/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","vs/base/common/stopwatch","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(ne){for(var e=[],c=0,t=ne.length;c<t;c++)e[c]=Se[ne[c]];return e};define(Se[79],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function c(A){return A?A.replace(/\$\((.*?)\)/g,(D,T)=>` ${T} `).trim():""}e.getCodiconAriaLabel=c;class t{constructor(D,T,S){this.id=D,this.definition=T,this.description=S,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function T(R){if(R instanceof t)return["codicon","codicon-"+R.id];const P=D.exec(R.id);if(!P)return T(t.error);const[,E,C]=P,v=["codicon","codicon-"+E];return C&&v.push("codicon-modifier-"+C.substring(1)),v}A.asClassNameArray=T;function S(R){return T(R).join(" ")}A.asClassName=S;function y(R){return"."+T(R).join(".")}A.asCSSSelector=y})(k=e.CSSIcon||(e.CSSIcon={}))}),define(Se[80],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(D,T){const S=Object.create(null);for(const y of D){const R=T(y);let P=S[R];P||(P=S[R]=[]),P.push(y)}return S}e.groupBy=c;function t(D,T){const S=[],y=[];for(const R of D)T.has(R)||S.push(R);for(const R of T)D.has(R)||y.push(R);return{removed:S,added:y}}e.diffSets=t;function k(D,T){const S=[],y=[];for(const[R,P]of D)T.has(R)||S.push(P);for(const[R,P]of T)D.has(R)||y.push(P);return{removed:S,added:y}}e.diffMaps=k;class A{constructor(){this.a=new Map}add(T,S){let y=this.a.get(T);y||(y=new Set,this.a.set(T,y)),y.add(S)}delete(T,S){const y=this.a.get(T);!y||(y.delete(S),y.size===0&&this.a.delete(T))}forEach(T,S){const y=this.a.get(T);!y||y.forEach(S)}}e.SetMap=A}),define(Se[60],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(D){return(T,S,y)=>{let R=null,P=null;if(typeof y.value=="function"?(R="value",P=y.value):typeof y.get=="function"&&(R="get",P=y.get),!P)throw new Error("not supported");y[R]=D(P,S)}}function t(D,T,S){let y=null,R=null;if(typeof S.value=="function"?(y="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(y="get",R=S.get),!R)throw new Error("not supported");const P=`$memoize$${T}`;S[y]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,E)}),this[P]}}e.memoize=t;function k(D,T,S){return c((y,R)=>{const P=`$debounce$${R}`,E=`$debounce$result$${R}`;return function(...C){this[E]||(this[E]=S?S():void 0),clearTimeout(this[P]),T&&(this[E]=T(this[E],...C),C=[this[E]]),this[P]=setTimeout(()=>{y.apply(this,C),this[E]=S?S():void 0},D)}})}e.debounce=k;function A(D,T,S){return c((y,R)=>{const P=`$throttle$timer$${R}`,E=`$throttle$result$${R}`,C=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...d){if(this[E]||(this[E]=S?S():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),T&&(this[E]=T(this[E],...d)),this[v])return;const g=this[C]+D;g<=Date.now()?(this[C]=Date.now(),y.apply(this,[this[E]]),this[E]=S?S():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[C]=Date.now(),y.apply(this,[this[E]]),this[E]=S?S():void 0},g-Date.now()))}})}e.throttle=A}),define(Se[10],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?f.isErrorNoTelemetry(s)?new f(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(i=>{i(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.ErrorHandler=c,e.errorHandler=new c;function t(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=t;function k(b){S(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=k;function A(b){S(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=A;function D(b){if(b instanceof Error){const{name:s,message:i}=b,l=b.stacktrace||b.stack;return{$isError:!0,name:s,message:i,stack:l,noTelemetry:f.isErrorNoTelemetry(b)}}return b}e.transformErrorForSerialization=D;const T="Canceled";function S(b){return b instanceof y?!0:b instanceof Error&&b.name===T&&b.message===T}e.isCancellationError=S;class y extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=y;function R(){const b=new Error(T);return b.name=b.message,b}e.canceled=R;function P(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=P;function E(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=E;function C(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function v(b){const s=new Error(`${b} has been disposed`);return s.name="DISPOSED",s}e.disposed=v;function d(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=d;class g extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=g;class m extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class f extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof f)return s;const i=new f;return i.message=s.message,i.stack=s.stack,i}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class h extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(Se[17],ye([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(se,ue=0){return se[se.length-(1+ue)]}e.tail=t;function k(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=k;function A(se,ue,he=(ee,ae)=>ee===ae){if(se===ue)return!0;if(!se||!ue||se.length!==ue.length)return!1;for(let ee=0,ae=se.length;ee<ae;ee++)if(!he(se[ee],ue[ee]))return!1;return!0}e.equals=A;function D(se,ue){const he=se.length-1;ue<he&&(se[ue]=se[he]),se.pop()}e.removeFastWithoutKeepingOrder=D;function T(se,ue,he){return S(se.length,ee=>he(se[ee],ue))}e.binarySearch=T;function S(se,ue){let he=0,ee=se-1;for(;he<=ee;){const ae=(he+ee)/2|0,re=ue(ae);if(re<0)he=ae+1;else if(re>0)ee=ae-1;else return ae}return-(he+1)}e.binarySearch2=S;function y(se,ue){let he=0,ee=se.length;if(ee===0)return 0;for(;he<ee;){const ae=Math.floor((he+ee)/2);ue(se[ae])?ee=ae:he=ae+1}return he}e.findFirstInSorted=y;function R(se,ue,he){if(se=se|0,se>=ue.length)throw new TypeError("invalid index");const ee=ue[Math.floor(ue.length*Math.random())],ae=[],re=[],O=[];for(const $ of ue){const G=he($,ee);G<0?ae.push($):G>0?re.push($):O.push($)}return se<ae.length?R(se,ae,he):se<ae.length+O.length?O[0]:R(se-(ae.length+O.length),re,he)}e.quickSelect=R;function P(se,ue){const he=[];let ee;for(const ae of se.slice(0).sort(ue))!ee||ue(ee[0],ae)!==0?(ee=[ae],he.push(ee)):ee.push(ae);return he}e.groupBy=P;function E(se,ue,he){const ee=[];function ae($,G,Q){if(G===0&&Q.length===0)return;const de=ee[ee.length-1];de&&de.start+de.deleteCount===$?(de.deleteCount+=G,de.toInsert.push(...Q)):ee.push({start:$,deleteCount:G,toInsert:Q})}let re=0,O=0;for(;;){if(re===se.length){ae(re,0,ue.slice(O));break}if(O===ue.length){ae(re,se.length-re,[]);break}const $=se[re],G=ue[O],Q=he($,G);Q===0?(re+=1,O+=1):Q<0?(ae(re,1,[]),re+=1):Q>0&&(ae(re,0,[G]),O+=1)}return ee}e.sortedDiff=E;function C(se,ue,he){const ee=E(se,ue,he),ae=[],re=[];for(const O of ee)ae.push(...se.slice(O.start,O.start+O.deleteCount)),re.push(...O.toInsert);return{removed:ae,added:re}}e.delta=C;function v(se,ue,he){if(he===0)return[];const ee=se.slice(0,he).sort(ue);return g(se,ue,ee,he,se.length),ee}e.top=v;function d(se,ue,he,ee,ae){return he===0?Promise.resolve([]):new Promise((re,O)=>{(async()=>{const $=se.length,G=se.slice(0,he).sort(ue);for(let Q=he,de=Math.min(he+ee,$);Q<$;Q=de,de=Math.min(de+ee,$)){if(Q>he&&await new Promise(be=>setTimeout(be)),ae&&ae.isCancellationRequested)throw new c.CancellationError;g(se,ue,G,Q,de)}return G})().then(re,O)})}e.topAsync=d;function g(se,ue,he,ee,ae){for(const re=he.length;ee<ae;ee++){const O=se[ee];if(ue(O,he[re-1])<0){he.pop();const $=y(he,G=>ue(O,G)<0);he.splice($,0,O)}}}function m(se){return se.filter(ue=>!!ue)}e.coalesce=m;function w(se){let ue=0;for(let he=0;he<se.length;he++)se[he]&&(se[ue]=se[he],ue+=1);se.length=ue}e.coalesceInPlace=w;function f(se,ue,he){se.splice(he,0,se.splice(ue,1)[0])}e.move=f;function h(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=h;function b(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=b;function s(se,ue=he=>he){const he=new Set;return se.filter(ee=>{const ae=ue(ee);return he.has(ae)?!1:(he.add(ae),!0)})}e.distinct=s;function i(se){const ue=new Set;return he=>{const ee=se(he);return ue.has(ee)?!1:(ue.add(ee),!0)}}e.uniqueFilter=i;function l(se,ue){const he=u(se,ue);if(he!==-1)return se[he]}e.findLast=l;function u(se,ue){for(let he=se.length-1;he>=0;he--){const ee=se[he];if(ue(ee))return he}return-1}e.lastIndex=u;function r(se,ue){return se.length>0?se[0]:ue}e.firstOrDefault=r;function a(se,ue){return se.length>0?se[se.length-1]:ue}e.lastOrDefault=a;function n(se,ue,he=(ee,ae)=>ee===ae){let ee=0;for(let ae=0,re=Math.min(se.length,ue.length);ae<re&&he(se[ae],ue[ae]);ae++)ee++;return ee}e.commonPrefixLength=n;function o(se){return[].concat(...se)}e.flatten=o;function p(se,ue){let he=typeof ue=="number"?se:0;typeof ue=="number"?he=se:(he=0,ue=se);const ee=[];if(he<=ue)for(let ae=he;ae<ue;ae++)ee.push(ae);else for(let ae=he;ae>ue;ae--)ee.push(ae);return ee}e.range=p;function I(se,ue,he){return se.reduce((ee,ae)=>(ee[ue(ae)]=he?he(ae):ae,ee),Object.create(null))}e.index=I;function L(se,ue){return se.push(ue),()=>z(se,ue)}e.insert=L;function z(se,ue){const he=se.indexOf(ue);if(he>-1)return se.splice(he,1),ue}e.remove=z;function _(se,ue,he){const ee=se.slice(0,ue),ae=se.slice(ue);return ee.concat(he,ae)}e.arrayInsert=_;function q(se,ue){let he;if(typeof ue=="number"){let ee=ue;he=()=>{const ae=Math.sin(ee++)*179426549;return ae-Math.floor(ae)}}else he=Math.random;for(let ee=se.length-1;ee>0;ee-=1){const ae=Math.floor(he()*(ee+1)),re=se[ee];se[ee]=se[ae],se[ae]=re}}e.shuffle=q;function N(se,ue){const he=se.indexOf(ue);he>-1&&(se.splice(he,1),se.unshift(ue))}e.pushToStart=N;function M(se,ue){const he=se.indexOf(ue);he>-1&&(se.splice(he,1),se.push(ue))}e.pushToEnd=M;function F(se,ue){for(const he of ue)se.push(he)}e.pushMany=F;function B(se,ue){return Array.isArray(se)?se.map(ue):ue(se)}e.mapArrayOrNot=B;function U(se){return Array.isArray(se)?se:[se]}e.asArray=U;function H(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=H;function X(se,ue){for(const he of se){const ee=ue(he);if(ee!==void 0)return ee}}e.mapFind=X;function V(se,ue,he){const ee=Y(se,ue),ae=se.length,re=he.length;se.length=ae+re;for(let O=ae-1;O>=ee;O--)se[O+re]=se[O];for(let O=0;O<re;O++)se[O+ee]=he[O]}e.insertInto=V;function x(se,ue,he,ee){const ae=Y(se,ue),re=se.splice(ae,he);return V(se,ae,ee),re}e.splice=x;function Y(se,ue){return ue<0?Math.max(ue+se.length,0):Math.min(ue,se.length)}var J;(function(se){function ue(ae){return ae<0}se.isLessThan=ue;function he(ae){return ae>0}se.isGreaterThan=he;function ee(ae){return ae===0}se.isNeitherLessOrGreaterThan=ee,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function te(se,ue){return(he,ee)=>ue(se(he),se(ee))}e.compareBy=te;function le(...se){return(ue,he)=>{for(const ee of se){const ae=ee(ue,he);if(!J.isNeitherLessOrGreaterThan(ae))return ae}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=le;const Z=(se,ue)=>se-ue;e.numberComparator=Z;function ge(se,ue){if(se.length===0)return;let he=se[0];for(let ee=1;ee<se.length;ee++){const ae=se[ee];ue(ae,he)>0&&(he=ae)}return he}e.findMaxBy=ge;function ve(se,ue){if(se.length===0)return;let he=se[0];for(let ee=1;ee<se.length;ee++){const ae=se[ee];ue(ae,he)>=0&&(he=ae)}return he}e.findLastMaxBy=ve;function De(se,ue){return ge(se,(he,ee)=>-ue(he,ee))}e.findMinBy=De;class Re{constructor(ue){this.f=ue,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ue){let he=this.c;for(;he<this.f.length&&ue(this.f[he]);)he++;const ee=he===this.c?null:this.f.slice(this.c,he);return this.c=he,ee}takeFromEndWhile(ue){let he=this.d;for(;he>=0&&ue(this.f[he]);)he--;const ee=he===this.d?null:this.f.slice(he+1,this.d+1);return this.d=he,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ue=this.f[this.c];return this.c++,ue}removeLast(){const ue=this.f[this.d];return this.d--,ue}takeCount(ue){const he=this.f.slice(this.c,this.c+ue);return this.c+=ue,he}}e.ArrayQueue=Re;class ze{constructor(ue){this.iterate=ue}forEach(ue){this.iterate(he=>(ue(he),!0))}toArray(){const ue=[];return this.iterate(he=>(ue.push(he),!0)),ue}filter(ue){return new ze(he=>this.iterate(ee=>ue(ee)?he(ee):!0))}map(ue){return new ze(he=>this.iterate(ee=>he(ue(ee))))}some(ue){let he=!1;return this.iterate(ee=>(he=ue(ee),!he)),he}findFirst(ue){let he;return this.iterate(ee=>ue(ee)?(he=ee,!1):!0),he}findLast(ue){let he;return this.iterate(ee=>(ue(ee)&&(he=ee),!0)),he}findLastMaxBy(ue){let he,ee=!0;return this.iterate(ae=>((ee||J.isGreaterThan(ue(ae,he)))&&(ee=!1,he=ae),!0)),he}}e.CallbackIterable=ze,ze.empty=new ze(se=>{})}),define(Se[49],ye([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,y){if(!S)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=t;function k(S,y="Unreachable"){throw new Error(y)}e.assertNever=k;function A(S){if(!S)throw new c.BugIndicatingError("Assertion Failed")}e.assert=A;function D(S){if(!S()){debugger;S(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function T(S,y){let R=0;for(;R<S.length-1;){const P=S[R],E=S[R+1];if(!y(P,E))return!1;R++}return!0}e.checkAdjacentItems=T}),define(Se[61],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(t){const k=this;let A=!1,D;return function(){return A||(A=!0,D=t.apply(k,arguments)),D}}e.once=c}),define(Se[99],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(Se[62],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function k(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}t.is=k;const A=Object.freeze([]);function D(){return A}t.empty=D;function*T(h){yield h}t.single=T;function S(h){return k(h)?h:T(h)}t.wrap=S;function y(h){return h||A}t.from=y;function R(h){return!h||h[Symbol.iterator]().next().done===!0}t.isEmpty=R;function P(h){return h[Symbol.iterator]().next().value}t.first=P;function E(h,b){for(const s of h)if(b(s))return!0;return!1}t.some=E;function C(h,b){for(const s of h)if(b(s))return s}t.find=C;function*v(h,b){for(const s of h)b(s)&&(yield s)}t.filter=v;function*d(h,b){let s=0;for(const i of h)yield b(i,s++)}t.map=d;function*g(...h){for(const b of h)for(const s of b)yield s}t.concat=g;function m(h,b,s){let i=s;for(const l of h)i=b(i,l);return i}t.reduce=m;function*w(h,b,s=h.length){for(b<0&&(b+=h.length),s<0?s+=h.length:s>h.length&&(s=h.length);b<s;b++)yield h[b]}t.slice=w;function f(h,b=Number.POSITIVE_INFINITY){const s=[];if(b===0)return[s,h];const i=h[Symbol.iterator]();for(let l=0;l<b;l++){const u=i.next();if(u.done)return[s,t.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return i}}]}t.consume=f})(c=e.Iterable||(e.Iterable={}))}),define(Se[145],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function D(s,i=!1){let l=0;const u=s.length;let r="",a=0,n=16,o=0;function p(M){let F=0,B=0;for(;F<M;){const U=s.charCodeAt(l);if(U>=48&&U<=57)B=B*16+U-48;else if(U>=65&&U<=70)B=B*16+U-65+10;else if(U>=97&&U<=102)B=B*16+U-97+10;else break;l++,F++}return F<M&&(B=-1),B}function I(M){l=M,r="",a=0,n=16,o=0}function L(){const M=l;if(s.charCodeAt(l)===48)l++;else for(l++;l<s.length&&y(s.charCodeAt(l));)l++;if(l<s.length&&s.charCodeAt(l)===46)if(l++,l<s.length&&y(s.charCodeAt(l)))for(l++;l<s.length&&y(s.charCodeAt(l));)l++;else return o=3,s.substring(M,l);let F=l;if(l<s.length&&(s.charCodeAt(l)===69||s.charCodeAt(l)===101))if(l++,(l<s.length&&s.charCodeAt(l)===43||s.charCodeAt(l)===45)&&l++,l<s.length&&y(s.charCodeAt(l))){for(l++;l<s.length&&y(s.charCodeAt(l));)l++;F=l}else o=3;return s.substring(M,F)}function z(){let M="",F=l;for(;;){if(l>=u){M+=s.substring(F,l),o=2;break}const B=s.charCodeAt(l);if(B===34){M+=s.substring(F,l),l++;break}if(B===92){if(M+=s.substring(F,l),l++,l>=u){o=2;break}switch(s.charCodeAt(l++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const H=p(4);H>=0?M+=String.fromCharCode(H):o=4;break}default:o=5}F=l;continue}if(B>=0&&B<=31)if(S(B)){M+=s.substring(F,l),o=2;break}else o=6;l++}return M}function _(){if(r="",o=0,a=l,l>=u)return a=u,n=17;let M=s.charCodeAt(l);if(T(M)){do l++,r+=String.fromCharCode(M),M=s.charCodeAt(l);while(T(M));return n=15}if(S(M))return l++,r+=String.fromCharCode(M),M===13&&s.charCodeAt(l)===10&&(l++,r+=`
`),n=14;switch(M){case 123:return l++,n=1;case 125:return l++,n=2;case 91:return l++,n=3;case 93:return l++,n=4;case 58:return l++,n=6;case 44:return l++,n=5;case 34:return l++,r=z(),n=10;case 47:{const F=l-1;if(s.charCodeAt(l+1)===47){for(l+=2;l<u&&!S(s.charCodeAt(l));)l++;return r=s.substring(F,l),n=12}if(s.charCodeAt(l+1)===42){l+=2;const B=u-1;let U=!1;for(;l<B;){if(s.charCodeAt(l)===42&&s.charCodeAt(l+1)===47){l+=2,U=!0;break}l++}return U||(l++,o=1),r=s.substring(F,l),n=13}return r+=String.fromCharCode(M),l++,n=16}case 45:if(r+=String.fromCharCode(M),l++,l===u||!y(s.charCodeAt(l)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=L(),n=11;default:for(;l<u&&q(M);)l++,M=s.charCodeAt(l);if(a!==l){switch(r=s.substring(a,l),r){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return r+=String.fromCharCode(M),l++,n=16}}function q(M){if(T(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let M;do M=_();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>l,scan:i?N:_,getToken:()=>n,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>l-a,getTokenError:()=>o}}e.createScanner=D;function T(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function y(s){return s>=48&&s<=57}var R;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(R||(R={}));function P(s,i){const l=[],u=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function o(p,I,L,z){a.value=p,a.offset=I,a.length=L,a.type=z,a.colonOffset=void 0,r=a}try{f(s,{onObjectBegin:(p,I)=>{if(i<=p)throw u;r=void 0,n=i>p,l.push("")},onObjectProperty:(p,I,L)=>{if(i<I||(o(p,I,L,"property"),l[l.length-1]=p,i<=I+L))throw u},onObjectEnd:(p,I)=>{if(i<=p)throw u;r=void 0,l.pop()},onArrayBegin:(p,I)=>{if(i<=p)throw u;r=void 0,l.push(0)},onArrayEnd:(p,I)=>{if(i<=p)throw u;r=void 0,l.pop()},onLiteralValue:(p,I,L)=>{if(i<I||(o(p,I,L,b(p)),i<=I+L))throw u},onSeparator:(p,I,L)=>{if(i<=I)throw u;if(p===":"&&r&&r.type==="property")r.colonOffset=I,n=!1,r=void 0;else if(p===","){const z=l[l.length-1];typeof z=="number"?l[l.length-1]=z+1:(n=!0,l[l.length-1]=""),r=void 0}}})}catch(p){if(p!==u)throw p}return{path:l,previousNode:r,isAtPropertyKey:n,matches:p=>{let I=0;for(let L=0;I<p.length&&L<l.length;L++)if(p[I]===l[L]||p[I]==="*")I++;else if(p[I]!=="**")return!1;return I===p.length}}}e.getLocation=P;function E(s,i=[],l=A.DEFAULT){let u=null,r=[];const a=[];function n(p){Array.isArray(r)?r.push(p):u!==null&&(r[u]=p)}return f(s,{onObjectBegin:()=>{const p={};n(p),a.push(r),r=p,u=null},onObjectProperty:p=>{u=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const p=[];n(p),a.push(r),r=p,u=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:n,onError:(p,I,L)=>{i.push({error:p,offset:I,length:L})}},l),r[0]}e.parse=E;function C(s,i=[],l=A.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(p){u.type==="property"&&(u.length=p-u.offset,u=u.parent)}function a(p){return u.children.push(p),p}f(s,{onObjectBegin:p=>{u=a({type:"object",offset:p,length:-1,parent:u,children:[]})},onObjectProperty:(p,I,L)=>{u=a({type:"property",offset:I,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:p,offset:I,length:L,parent:u})},onObjectEnd:(p,I)=>{u.length=p+I-u.offset,u=u.parent,r(p+I)},onArrayBegin:(p,I)=>{u=a({type:"array",offset:p,length:-1,parent:u,children:[]})},onArrayEnd:(p,I)=>{u.length=p+I-u.offset,u=u.parent,r(p+I)},onLiteralValue:(p,I,L)=>{a({type:b(p),offset:I,length:L,parent:u,value:p}),r(I+L)},onSeparator:(p,I,L)=>{u.type==="property"&&(p===":"?u.colonOffset=I:p===","&&r(I))},onError:(p,I,L)=>{i.push({error:p,offset:I,length:L})}},l);const o=u.children[0];return o&&delete o.parent,o}e.parseTree=C;function v(s,i){if(!s)return;let l=s;for(const u of i)if(typeof u=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let r=!1;for(const a of l.children)if(Array.isArray(a.children)&&a.children[0].value===u){l=a.children[1],r=!0;break}if(!r)return}else{const r=u;if(l.type!=="array"||r<0||!Array.isArray(l.children)||r>=l.children.length)return;l=l.children[r]}return l}e.findNodeAtLocation=v;function d(s){if(!s.parent||!s.parent.children)return[];const i=d(s.parent);if(s.parent.type==="property"){const l=s.parent.children[0].value;i.push(l)}else if(s.parent.type==="array"){const l=s.parent.children.indexOf(s);l!==-1&&i.push(l)}return i}e.getNodePath=d;function g(s){switch(s.type){case"array":return s.children.map(g);case"object":{const i=Object.create(null);for(const l of s.children){const u=l.children[1];u&&(i[l.children[0].value]=g(u))}return i}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=g;function m(s,i,l=!1){return i>=s.offset&&i<s.offset+s.length||l&&i===s.offset+s.length}e.contains=m;function w(s,i,l=!1){if(m(s,i,l)){const u=s.children;if(Array.isArray(u))for(let r=0;r<u.length&&u[r].offset<=i;r++){const a=w(u[r],i,l);if(a)return a}return s}}e.findNodeAtOffset=w;function f(s,i,l=A.DEFAULT){const u=D(s,!1);function r(te){return te?()=>te(u.getTokenOffset(),u.getTokenLength()):()=>!0}function a(te){return te?le=>te(le,u.getTokenOffset(),u.getTokenLength()):()=>!0}const n=r(i.onObjectBegin),o=a(i.onObjectProperty),p=r(i.onObjectEnd),I=r(i.onArrayBegin),L=r(i.onArrayEnd),z=a(i.onLiteralValue),_=a(i.onSeparator),q=r(i.onComment),N=a(i.onError),M=l&&l.disallowComments,F=l&&l.allowTrailingComma;function B(){for(;;){const te=u.scan();switch(u.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:M||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(te){case 12:case 13:M?U(10):q();break;case 16:U(1);break;case 15:case 14:break;default:return te}}}function U(te,le=[],Z=[]){if(N(te),le.length+Z.length>0){let ge=u.getToken();for(;ge!==17;){if(le.indexOf(ge)!==-1){B();break}else if(Z.indexOf(ge)!==-1)break;ge=B()}}}function H(te){const le=u.getTokenValue();return te?z(le):o(le),B(),!0}function X(){switch(u.getToken()){case 11:{let te=0;try{te=JSON.parse(u.getTokenValue()),typeof te!="number"&&(U(2),te=0)}catch{U(2)}z(te);break}case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return B(),!0}function V(){return u.getToken()!==10?(U(3,[],[2,5]),!1):(H(!1),u.getToken()===6?(_(":"),B(),J()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function x(){n(),B();let te=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(te||U(4,[],[]),_(","),B(),u.getToken()===2&&F)break}else te&&U(6,[],[]);V()||U(4,[],[2,5]),te=!0}return p(),u.getToken()!==2?U(7,[2],[]):B(),!0}function Y(){I(),B();let te=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(te||U(4,[],[]),_(","),B(),u.getToken()===4&&F)break}else te&&U(6,[],[]);J()||U(4,[],[4,5]),te=!0}return L(),u.getToken()!==4?U(8,[4],[]):B(),!0}function J(){switch(u.getToken()){case 3:return Y();case 1:return x();case 10:return H(!0);default:return X()}}return B(),u.getToken()===17?l.allowEmptyContent?!0:(U(4,[],[]),!1):J()?(u.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=f;function h(s,i){const l=D(s),u=[];let r,a=0,n;do switch(n=l.getPosition(),r=l.scan(),r){case 12:case 13:case 17:a!==n&&u.push(s.substring(a,n)),i!==void 0&&u.push(l.getTokenValue().replace(/[^\r\n]/g,i)),a=l.getPosition();break}while(r!==17);return u.join("")}e.stripComments=h;function b(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(Se[81],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(k){this.d=k,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(k){return new c(()=>k(this.getValue()))}}e.Lazy=c}),define(Se[6],ye([1,0,61,62]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let A=null;function D(a){A=a}if(e.setDisposableTracker=D,k){const a="__is_disposable_tracked__";D(new class{trackDisposable(n){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[a]||console.log(o)},3e3)}setParent(n,o){if(n&&n!==w.None)try{n[a]=!0}catch{}}markAsDisposed(n){if(n&&n!==w.None)try{n[a]=!0}catch{}}markAsSingleton(n){}})}function T(a){return A?.trackDisposable(a),a}function S(a){A?.markAsDisposed(a)}function y(a,n){A?.setParent(a,n)}function R(a,n){if(!!A)for(const o of a)A.setParent(o,n)}function P(a){return A?.markAsSingleton(a),a}e.markAsSingleton=P;function E(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=E;function C(a){if(t.Iterable.is(a)){const n=[];for(const o of a)if(o)try{o.dispose()}catch(p){n.push(p)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=C;function v(a){for(const n of a)E(n)&&n.dispose();return[]}e.disposeIfDisposable=v;function d(...a){const n=g(()=>C(a));return R(a,n),n}e.combinedDisposable=d;function g(a){const n=T({dispose:(0,c.once)(()=>{S(n),a()})});return n}e.toDisposable=g;class m{constructor(){this.c=new Set,this.f=!1,T(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{C(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return y(n,this),this.f?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this.q=new m,T(this),y(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class f{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&y(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&y(n,null),n}}e.MutableDisposable=f;class h{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=h;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(n){let o=n;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,S(this))},this}}e.SafeDisposable=b;class s{constructor(){this.a=new Map}acquire(n,...o){let p=this.a.get(n);p||(p={counter:0,object:this.b(n,...o)},this.a.set(n,p));const{object:I}=p,L=(0,c.once)(()=>{--p.counter===0&&(this.c(n,p.object),this.a.delete(n))});return p.counter++,{object:I,dispose:L}}}e.ReferenceCollection=s;class i{constructor(n){this.a=n}async acquire(n,...o){const p=this.a.acquire(n,...o);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(I){throw p.dispose(),I}}}e.AsyncReferenceCollection=i;class l{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=l;function u(a){const n=new m;try{a(n)}finally{n.dispose()}}e.disposeOnReturn=u;class r{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{C(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,o,p=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||this.a.get(n)?.dispose(),this.a.set(n,o)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(Se[63],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(A){this.element=A,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class t{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let A=this.a;for(;A!==c.Undefined;){const D=A.next;A.prev=c.Undefined,A.next=c.Undefined,A=D}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,D){const T=new c(A);if(this.a===c.Undefined)this.a=T,this.b=T;else if(D){const y=this.b;this.b=T,T.prev=y,y.next=T}else{const y=this.a;this.a=T,T.next=y,y.prev=T}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(T))}}shift(){if(this.a!==c.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==c.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==c.Undefined&&A.next!==c.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===c.Undefined&&A.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):A.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):A.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==c.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),define(Se[28],ye([1,0]),function(ne,e){"use strict";var c,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(v,d,g){let m=v.get(d);return m===void 0&&(m=g,v.set(d,m)),m}e.getOrSet=A;function D(v){const d=[];return v.forEach((g,m)=>{d.push(`${m} => ${g}`)}),`Map(${v.size}) {${d.join(", ")}}`}e.mapToString=D;function T(v){const d=[];return v.forEach(g=>{d.push(g)}),`Set(${v.size}) {${d.join(", ")}}`}e.setToString=T;class S{constructor(d,g){this.uri=d,this.value=g}}class y{constructor(d,g){this[c]="ResourceMap",d instanceof y?(this.b=new Map(d.b),this.c=g??y.a):(this.b=new Map,this.c=d??y.a)}set(d,g){return this.b.set(this.c(d),new S(d,g)),this}get(d){return this.b.get(this.c(d))?.value}has(d){return this.b.has(this.c(d))}get size(){return this.b.size}clear(){this.b.clear()}delete(d){return this.b.delete(this.c(d))}forEach(d,g){typeof g<"u"&&(d=d.bind(g));for(const[m,w]of this.b)d(w.value,w.uri,this)}*values(){for(const d of this.b.values())yield d.value}*keys(){for(const d of this.b.values())yield d.uri}*entries(){for(const d of this.b.values())yield[d.uri,d.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.b)yield[d.uri,d.value]}}e.ResourceMap=y,y.a=v=>v.toString();class R{constructor(d,g){this[t]="ResourceSet",!d||typeof d=="function"?this.a=new y(d):(this.a=new y(g),d.forEach(this.add,this))}get size(){return this.a.size}add(d){return this.a.set(d,d),this}clear(){this.a.clear()}delete(d){return this.a.delete(d)}forEach(d,g){this.a.forEach((m,w)=>d.call(g,w,w,this))}has(d){return this.a.has(d)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var P;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class E{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(d){return this.a.has(d)}get(d,g=0){const m=this.a.get(d);if(!!m)return g!==0&&this.j(m,g),m.value}set(d,g,m=0){let w=this.a.get(d);if(w)w.value=g,m!==0&&this.j(w,m);else{switch(w={key:d,value:g,next:void 0,previous:void 0},m){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(d,w),this.d++}return this}delete(d){return!!this.remove(d)}remove(d){const g=this.a.get(d);if(!!g)return this.a.delete(d),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const d=this.b;return this.a.delete(d.key),this.i(d),this.d--,d.value}forEach(d,g){const m=this.e;let w=this.b;for(;w;){if(g?d.bind(g)(w.value,w.key,this):d(w.value,w.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const d=this,g=this.e;let m=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(m){const f={value:m.key,done:!1};return m=m.next,f}else return{value:void 0,done:!0}}};return w}values(){const d=this,g=this.e;let m=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(m){const f={value:m.value,done:!1};return m=m.next,f}else return{value:void 0,done:!0}}};return w}entries(){const d=this,g=this.e;let m=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(m){const f={value:[m.key,m.value],done:!1};return m=m.next,f}else return{value:void 0,done:!0}}};return w}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(d){if(d>=this.size)return;if(d===0){this.clear();return}let g=this.b,m=this.size;for(;g&&m>d;)this.a.delete(g.key),g=g.next,m--;this.b=g,this.d=m,g&&(g.previous=void 0),this.e++}g(d){if(!this.b&&!this.c)this.c=d;else if(this.b)d.next=this.b,this.b.previous=d;else throw new Error("Invalid list");this.b=d,this.e++}h(d){if(!this.b&&!this.c)this.b=d;else if(this.c)d.previous=this.c,this.c.next=d;else throw new Error("Invalid list");this.c=d,this.e++}i(d){if(d===this.b&&d===this.c)this.b=void 0,this.c=void 0;else if(d===this.b){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.b=d.next}else if(d===this.c){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.c=d.previous}else{const g=d.next,m=d.previous;if(!g||!m)throw new Error("Invalid list");g.previous=m,m.next=g}d.next=void 0,d.previous=void 0,this.e++}j(d,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(d===this.b)return;const m=d.next,w=d.previous;d===this.c?(w.next=void 0,this.c=w):(m.previous=w,w.next=m),d.previous=void 0,d.next=this.b,this.b.previous=d,this.b=d,this.e++}else if(g===2){if(d===this.c)return;const m=d.next,w=d.previous;d===this.b?(m.previous=void 0,this.b=m):(m.previous=w,w.next=m),d.next=void 0,d.previous=this.c,this.c.next=d,this.c=d,this.e++}}}toJSON(){const d=[];return this.forEach((g,m)=>{d.push([m,g])}),d}fromJSON(d){this.clear();for(const[g,m]of d)this.set(g,m)}}e.LinkedMap=E;class C extends E{constructor(d,g=1){super(),this.k=d,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(d){this.k=d,this.m()}get ratio(){return this.l}set ratio(d){this.l=Math.min(Math.max(0,d),1),this.m()}get(d,g=2){return super.get(d,g)}peek(d){return super.get(d,0)}set(d,g){return super.set(d,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=C}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Se[146],ye([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(se,ue){for(var he=0;he<ue.length;he++){var ee=ue[he];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(se,ee.key,ee)}}function c(se,ue,he){return ue&&e(se.prototype,ue),he&&e(se,he),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,ue){if(!!se){if(typeof se=="string")return k(se,ue);var he=Object.prototype.toString.call(se).slice(8,-1);if(he==="Object"&&se.constructor&&(he=se.constructor.name),he==="Map"||he==="Set")return Array.from(se);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return k(se,ue)}}function k(se,ue){(ue==null||ue>se.length)&&(ue=se.length);for(var he=0,ee=new Array(ue);he<ue;he++)ee[he]=se[he];return ee}function A(se,ue){var he=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(he)return(he=he.call(se)).next.bind(he);if(Array.isArray(se)||(he=t(se))||ue&&se&&typeof se.length=="number"){he&&(se=he);var ee=0;return function(){return ee>=se.length?{done:!0}:{done:!1,value:se[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=D();function T(se){ne.defaults=se}var S=/[&<>"']/,y=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ue){return E[ue]};function v(se,ue){if(ue){if(S.test(se))return se.replace(y,C)}else if(R.test(se))return se.replace(P,C);return se}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(se){return se.replace(d,function(ue,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var m=/(^|[^\[])\^/g;function w(se,ue){se=typeof se=="string"?se:se.source,ue=ue||"";var he={replace:function(ae,re){return re=re.source||re,re=re.replace(m,"$1"),se=se.replace(ae,re),he},getRegex:function(){return new RegExp(se,ue)}};return he}var f=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(se,ue,he){if(se){var ee;try{ee=decodeURIComponent(g(he)).replace(f,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ue&&!h.test(he)&&(he=r(ue,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var s={},i=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(se,ue){s[" "+se]||(i.test(se)?s[" "+se]=se+"/":s[" "+se]=p(se,"/",!0)),se=s[" "+se];var he=se.indexOf(":")===-1;return ue.substring(0,2)==="//"?he?ue:se.replace(l,"$1")+ue:ue.charAt(0)==="/"?he?ue:se.replace(u,"$1")+ue:se+ue}var a={exec:function(){}};function n(se){for(var ue=1,he,ee;ue<arguments.length;ue++){he=arguments[ue];for(ee in he)Object.prototype.hasOwnProperty.call(he,ee)&&(se[ee]=he[ee])}return se}function o(se,ue){var he=se.replace(/\|/g,function(re,O,$){for(var G=!1,Q=O;--Q>=0&&$[Q]==="\\";)G=!G;return G?"|":" |"}),ee=he.split(/ \|/),ae=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ue)ee.splice(ue);else for(;ee.length<ue;)ee.push("");for(;ae<ee.length;ae++)ee[ae]=ee[ae].trim().replace(/\\\|/g,"|");return ee}function p(se,ue,he){var ee=se.length;if(ee===0)return"";for(var ae=0;ae<ee;){var re=se.charAt(ee-ae-1);if(re===ue&&!he)ae++;else if(re!==ue&&he)ae++;else break}return se.slice(0,ee-ae)}function I(se,ue){if(se.indexOf(ue[1])===-1)return-1;for(var he=se.length,ee=0,ae=0;ae<he;ae++)if(se[ae]==="\\")ae++;else if(se[ae]===ue[0])ee++;else if(se[ae]===ue[1]&&(ee--,ee<0))return ae;return-1}function L(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function z(se,ue){if(ue<1)return"";for(var he="";ue>1;)ue&1&&(he+=se),ue>>=1,se+=se;return he+se}function _(se,ue,he,ee){var ae=ue.href,re=ue.title?v(ue.title):null,O=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){ee.state.inLink=!0;var $={type:"link",raw:he,href:ae,title:re,text:O,tokens:ee.inlineTokens(O)};return ee.state.inLink=!1,$}return{type:"image",raw:he,href:ae,title:re,text:v(O)}}function q(se,ue){var he=se.match(/^(\s+)(?:```)/);if(he===null)return ue;var ee=he[1];return ue.split(`
`).map(function(ae){var re=ae.match(/^\s+/);if(re===null)return ae;var O=re[0];return O.length>=ee.length?ae.slice(ee.length):ae}).join(`
`)}var N=function(){function se(he){this.options=he||ne.defaults}var ue=se.prototype;return ue.space=function(ee){var ae=this.rules.block.newline.exec(ee);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},ue.code=function(ee){var ae=this.rules.block.code.exec(ee);if(ae){var re=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?re:p(re,`
`)}}},ue.fences=function(ee){var ae=this.rules.block.fences.exec(ee);if(ae){var re=ae[0],O=q(re,ae[3]||"");return{type:"code",raw:re,lang:ae[2]?ae[2].trim():ae[2],text:O}}},ue.heading=function(ee){var ae=this.rules.block.heading.exec(ee);if(ae){var re=ae[2].trim();if(/#$/.test(re)){var O=p(re,"#");(this.options.pedantic||!O||/ $/.test(O))&&(re=O.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:re,tokens:this.lexer.inline(re)}}},ue.hr=function(ee){var ae=this.rules.block.hr.exec(ee);if(ae)return{type:"hr",raw:ae[0]}},ue.blockquote=function(ee){var ae=this.rules.block.blockquote.exec(ee);if(ae){var re=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},ue.list=function(ee){var ae=this.rules.block.list.exec(ee);if(ae){var re,O,$,G,Q,de,be,Pe,pe,Ce,ke,je,Ge=ae[1].trim(),et=Ge.length>1,_e={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(je=!1,!(!(ae=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(re=ae[0],ee=ee.substring(re.length),Pe=ae[2].split(`
`,1)[0],pe=ee.split(`
`,1)[0],this.options.pedantic?(G=2,ke=Pe.trimLeft()):(G=ae[2].search(/[^ ]/),G=G>4?1:G,ke=Pe.slice(G),G+=ae[1].length),de=!1,!Pe&&/^ *$/.test(pe)&&(re+=pe+`
`,ee=ee.substring(pe.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");ee&&(Ce=ee.split(`
`,1)[0],Pe=Ce,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(Pe)||it.test(Pe)||st.test(Pe)||ht.test(ee)));){if(Pe.search(/[^ ]/)>=G||!Pe.trim())ke+=`
`+Pe.slice(G);else if(!de)ke+=`
`+Pe;else break;!de&&!Pe.trim()&&(de=!0),re+=Ce+`
`,ee=ee.substring(Ce.length+1)}_e.loose||(be?_e.loose=!0:/\n *\n *$/.test(re)&&(be=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(ke),O&&($=O[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),_e.items.push({type:"list_item",raw:re,task:!!O,checked:$,loose:!1,text:ke}),_e.raw+=re}_e.items[_e.items.length-1].raw=re.trimRight(),_e.items[_e.items.length-1].text=ke.trimRight(),_e.raw=_e.raw.trimRight();var oe=_e.items.length;for(Q=0;Q<oe;Q++){this.lexer.state.top=!1,_e.items[Q].tokens=this.lexer.blockTokens(_e.items[Q].text,[]);var W=_e.items[Q].tokens.filter(function(Ie){return Ie.type==="space"}),ce=W.every(function(Ie){for(var Le=Ie.raw.split(""),Be=0,Xe=A(Le),Ze;!(Ze=Xe()).done;){var mt=Ze.value;if(mt===`
`&&(Be+=1),Be>1)return!0}return!1});!_e.loose&&W.length&&ce&&(_e.loose=!0,_e.items[Q].loose=!0)}return _e}},ue.html=function(ee){var ae=this.rules.block.html.exec(ee);if(ae){var re={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(ae[0]):v(ae[0]);re.type="paragraph",re.text=O,re.tokens=this.lexer.inline(O)}return re}},ue.def=function(ee){var ae=this.rules.block.def.exec(ee);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var re=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:ae[0],href:ae[2],title:ae[3]}}},ue.table=function(ee){var ae=this.rules.block.table.exec(ee);if(ae){var re={type:"table",header:o(ae[1]).map(function(be){return{text:be}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=ae[0];var O=re.align.length,$,G,Q,de;for($=0;$<O;$++)/^ *-+: *$/.test(re.align[$])?re.align[$]="right":/^ *:-+: *$/.test(re.align[$])?re.align[$]="center":/^ *:-+ *$/.test(re.align[$])?re.align[$]="left":re.align[$]=null;for(O=re.rows.length,$=0;$<O;$++)re.rows[$]=o(re.rows[$],re.header.length).map(function(be){return{text:be}});for(O=re.header.length,G=0;G<O;G++)re.header[G].tokens=this.lexer.inline(re.header[G].text);for(O=re.rows.length,G=0;G<O;G++)for(de=re.rows[G],Q=0;Q<de.length;Q++)de[Q].tokens=this.lexer.inline(de[Q].text);return re}}},ue.lheading=function(ee){var ae=this.rules.block.lheading.exec(ee);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},ue.paragraph=function(ee){var ae=this.rules.block.paragraph.exec(ee);if(ae){var re=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:re,tokens:this.lexer.inline(re)}}},ue.text=function(ee){var ae=this.rules.block.text.exec(ee);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},ue.escape=function(ee){var ae=this.rules.inline.escape.exec(ee);if(ae)return{type:"escape",raw:ae[0],text:v(ae[1])}},ue.tag=function(ee){var ae=this.rules.inline.tag.exec(ee);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):v(ae[0]):ae[0]}},ue.link=function(ee){var ae=this.rules.inline.link.exec(ee);if(ae){var re=ae[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var O=p(re.slice(0,-1),"\\");if((re.length-O.length)%2===0)return}else{var $=I(ae[2],"()");if($>-1){var G=ae[0].indexOf("!")===0?5:4,Q=G+ae[1].length+$;ae[2]=ae[2].substring(0,$),ae[0]=ae[0].substring(0,Q).trim(),ae[3]=""}}var de=ae[2],be="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Pe&&(de=Pe[1],be=Pe[3])}else be=ae[3]?ae[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(re)?de=de.slice(1):de=de.slice(1,-1)),_(ae,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},ue.reflink=function(ee,ae){var re;if((re=this.rules.inline.reflink.exec(ee))||(re=this.rules.inline.nolink.exec(ee))){var O=(re[2]||re[1]).replace(/\s+/g," ");if(O=ae[O.toLowerCase()],!O||!O.href){var $=re[0].charAt(0);return{type:"text",raw:$,text:$}}return _(re,O,re[0],this.lexer)}},ue.emStrong=function(ee,ae,re){re===void 0&&(re="");var O=this.rules.inline.emStrong.lDelim.exec(ee);if(!!O&&!(O[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=O[1]||O[2]||"";if(!$||$&&(re===""||this.rules.inline.punctuation.exec(re))){var G=O[0].length-1,Q,de,be=G,Pe=0,pe=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ae=ae.slice(-1*ee.length+G);(O=pe.exec(ae))!=null;)if(Q=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!Q){if(de=Q.length,O[3]||O[4]){be+=de;continue}else if((O[5]||O[6])&&G%3&&!((G+de)%3)){Pe+=de;continue}if(be-=de,!(be>0)){if(de=Math.min(de,de+be+Pe),Math.min(G,de)%2){var Ce=ee.slice(1,G+O.index+de);return{type:"em",raw:ee.slice(0,G+O.index+de+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ke=ee.slice(2,G+O.index+de-1);return{type:"strong",raw:ee.slice(0,G+O.index+de+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},ue.codespan=function(ee){var ae=this.rules.inline.code.exec(ee);if(ae){var re=ae[2].replace(/\n/g," "),O=/[^ ]/.test(re),$=/^ /.test(re)&&/ $/.test(re);return O&&$&&(re=re.substring(1,re.length-1)),re=v(re,!0),{type:"codespan",raw:ae[0],text:re}}},ue.br=function(ee){var ae=this.rules.inline.br.exec(ee);if(ae)return{type:"br",raw:ae[0]}},ue.del=function(ee){var ae=this.rules.inline.del.exec(ee);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},ue.autolink=function(ee,ae){var re=this.rules.inline.autolink.exec(ee);if(re){var O,$;return re[2]==="@"?(O=v(this.options.mangle?ae(re[1]):re[1]),$="mailto:"+O):(O=v(re[1]),$=O),{type:"link",raw:re[0],text:O,href:$,tokens:[{type:"text",raw:O,text:O}]}}},ue.url=function(ee,ae){var re;if(re=this.rules.inline.url.exec(ee)){var O,$;if(re[2]==="@")O=v(this.options.mangle?ae(re[0]):re[0]),$="mailto:"+O;else{var G;do G=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(G!==re[0]);O=v(re[0]),re[1]==="www."?$="http://"+O:$=O}return{type:"link",raw:re[0],text:O,href:$,tokens:[{type:"text",raw:O,text:O}]}}},ue.inlineText=function(ee,ae){var re=this.rules.inline.text.exec(ee);if(re){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):v(re[0]):re[0]:O=v(this.options.smartypants?ae(re[0]):re[0]),{type:"text",raw:re[0],text:O}}},se}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=w(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=w(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=w(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=w(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=w(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=w(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=n({},M),M.gfm=n({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=w(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=w(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=n({},M.normal,{html:w(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:w(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=w(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=w(M._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=w(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=w(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=w(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=w(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=w(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=w(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=w(F.reflink).replace("label",F._label).replace("ref",M._label).getRegex(),F.nolink=w(F.nolink).replace("ref",M._label).getRegex(),F.reflinkSearch=w(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:w(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:w(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:w(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=w(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:w(F.br).replace("{2,}","*").getRegex(),text:w(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(se){var ue="",he,ee,ae=se.length;for(he=0;he<ae;he++)ee=se.charCodeAt(he),Math.random()>.5&&(ee="x"+ee.toString(16)),ue+="&#"+ee+";";return ue}var H=function(){function se(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ne.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:M.normal,inline:F.normal};this.options.pedantic?(ee.block=M.pedantic,ee.inline=F.pedantic):this.options.gfm&&(ee.block=M.gfm,this.options.breaks?ee.inline=F.breaks:ee.inline=F.gfm),this.tokenizer.rules=ee}se.lex=function(ee,ae){var re=new se(ae);return re.lex(ee)},se.lexInline=function(ee,ae){var re=new se(ae);return re.inlineTokens(ee)};var ue=se.prototype;return ue.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},ue.blockTokens=function(ee,ae){var re=this;ae===void 0&&(ae=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(be,Pe,pe){return Pe+"    ".repeat(pe.length)});for(var O,$,G,Q;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(O=be.call({lexer:re},ee,ae))?(ee=ee.substring(O.raw.length),ae.push(O),!0):!1}))){if(O=this.tokenizer.space(ee)){ee=ee.substring(O.raw.length),O.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(O);continue}if(O=this.tokenizer.code(ee)){ee=ee.substring(O.raw.length),$=ae[ae.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+O.raw,$.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ae.push(O);continue}if(O=this.tokenizer.fences(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.heading(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.hr(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.blockquote(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.list(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.html(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.def(ee)){ee=ee.substring(O.raw.length),$=ae[ae.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+O.raw,$.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.lheading(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(G=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,Pe=ee.slice(1),pe=void 0;re.options.extensions.startBlock.forEach(function(Ce){pe=Ce.call({lexer:this},Pe),typeof pe=="number"&&pe>=0&&(be=Math.min(be,pe))}),be<1/0&&be>=0&&(G=ee.substring(0,be+1))}(),this.state.top&&(O=this.tokenizer.paragraph(G))){$=ae[ae.length-1],Q&&$.type==="paragraph"?($.raw+=`
`+O.raw,$.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ae.push(O),Q=G.length!==ee.length,ee=ee.substring(O.raw.length);continue}if(O=this.tokenizer.text(ee)){ee=ee.substring(O.raw.length),$=ae[ae.length-1],$&&$.type==="text"?($.raw+=`
`+O.raw,$.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ae.push(O);continue}if(ee){var de="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,ae},ue.inline=function(ee,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:ee,tokens:ae}),ae},ue.inlineTokens=function(ee,ae){var re=this;ae===void 0&&(ae=[]);var O,$,G,Q=ee,de,be,Pe;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(Q))!=null;)pe.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(Q=Q.slice(0,de.index)+"["+z("a",de[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(Q))!=null;)Q=Q.slice(0,de.index)+"["+z("a",de[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(Q))!=null;)Q=Q.slice(0,de.index)+"++"+Q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(be||(Pe=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(O=ke.call({lexer:re},ee,ae))?(ee=ee.substring(O.raw.length),ae.push(O),!0):!1}))){if(O=this.tokenizer.escape(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.tag(ee)){ee=ee.substring(O.raw.length),$=ae[ae.length-1],$&&O.type==="text"&&$.type==="text"?($.raw+=O.raw,$.text+=O.text):ae.push(O);continue}if(O=this.tokenizer.link(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(O.raw.length),$=ae[ae.length-1],$&&O.type==="text"&&$.type==="text"?($.raw+=O.raw,$.text+=O.text):ae.push(O);continue}if(O=this.tokenizer.emStrong(ee,Q,Pe)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.codespan(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.br(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.del(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.autolink(ee,U)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(ee,U))){ee=ee.substring(O.raw.length),ae.push(O);continue}if(G=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=ee.slice(1),Ge=void 0;re.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},je),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(G=ee.substring(0,ke+1))}(),O=this.tokenizer.inlineText(G,B)){ee=ee.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Pe=O.raw.slice(-1)),be=!0,$=ae[ae.length-1],$&&$.type==="text"?($.raw+=O.raw,$.text+=O.text):ae.push(O);continue}if(ee){var Ce="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ae},c(se,null,[{key:"rules",get:function(){return{block:M,inline:F}}}]),se}(),X=function(){function se(he){this.options=he||ne.defaults}var ue=se.prototype;return ue.code=function(ee,ae,re){var O=(ae||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(ee,O);$!=null&&$!==ee&&(re=!0,ee=$)}return ee=ee.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+v(O,!0)+'">'+(re?ee:v(ee,!0))+`</code></pre>
`:"<pre><code>"+(re?ee:v(ee,!0))+`</code></pre>
`},ue.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ue.html=function(ee){return ee},ue.heading=function(ee,ae,re,O){if(this.options.headerIds){var $=this.options.headerPrefix+O.slug(re);return"<h"+ae+' id="'+$+'">'+ee+"</h"+ae+`>
`}return"<h"+ae+">"+ee+"</h"+ae+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(ee,ae,re){var O=ae?"ol":"ul",$=ae&&re!==1?' start="'+re+'"':"";return"<"+O+$+`>
`+ee+"</"+O+`>
`},ue.listitem=function(ee){return"<li>"+ee+`</li>
`},ue.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(ee){return"<p>"+ee+`</p>
`},ue.table=function(ee,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ae+`</table>
`},ue.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ue.tablecell=function(ee,ae){var re=ae.header?"th":"td",O=ae.align?"<"+re+' align="'+ae.align+'">':"<"+re+">";return O+ee+("</"+re+`>
`)},ue.strong=function(ee){return"<strong>"+ee+"</strong>"},ue.em=function(ee){return"<em>"+ee+"</em>"},ue.codespan=function(ee){return"<code>"+ee+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(ee){return"<del>"+ee+"</del>"},ue.link=function(ee,ae,re){if(ee=b(this.options.sanitize,this.options.baseUrl,ee),ee===null)return re;var O='<a href="'+v(ee)+'"';return ae&&(O+=' title="'+ae+'"'),O+=">"+re+"</a>",O},ue.image=function(ee,ae,re){if(ee=b(this.options.sanitize,this.options.baseUrl,ee),ee===null)return re;var O='<img src="'+ee+'" alt="'+re+'"';return ae&&(O+=' title="'+ae+'"'),O+=this.options.xhtml?"/>":">",O},ue.text=function(ee){return ee},se}(),V=function(){function se(){}var ue=se.prototype;return ue.strong=function(ee){return ee},ue.em=function(ee){return ee},ue.codespan=function(ee){return ee},ue.del=function(ee){return ee},ue.html=function(ee){return ee},ue.text=function(ee){return ee},ue.link=function(ee,ae,re){return""+re},ue.image=function(ee,ae,re){return""+re},ue.br=function(){return""},se}(),x=function(){function se(){this.seen={}}var ue=se.prototype;return ue.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(ee,ae){var re=ee,O=0;if(this.seen.hasOwnProperty(re)){O=this.seen[ee];do O++,re=ee+"-"+O;while(this.seen.hasOwnProperty(re))}return ae||(this.seen[ee]=O,this.seen[re]=0),re},ue.slug=function(ee,ae){ae===void 0&&(ae={});var re=this.serialize(ee);return this.getNextSafeSlug(re,ae.dryrun)},se}(),Y=function(){function se(he){this.options=he||ne.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new x}se.parse=function(ee,ae){var re=new se(ae);return re.parse(ee)},se.parseInline=function(ee,ae){var re=new se(ae);return re.parseInline(ee)};var ue=se.prototype;return ue.parse=function(ee,ae){ae===void 0&&(ae=!0);var re="",O,$,G,Q,de,be,Pe,pe,Ce,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe=ee.length;for(O=0;O<oe;O++){if(ke=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(it=this.options.extensions.renderers[ke.type].call({parser:this},ke),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){re+=it||"";continue}switch(ke.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,g(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Pe="",Q=ke.header.length,$=0;$<Q;$++)Pe+=this.renderer.tablecell(this.parseInline(ke.header[$].tokens),{header:!0,align:ke.align[$]});for(pe+=this.renderer.tablerow(Pe),Ce="",Q=ke.rows.length,$=0;$<Q;$++){for(be=ke.rows[$],Pe="",de=be.length,G=0;G<de;G++)Pe+=this.renderer.tablecell(this.parseInline(be[G].tokens),{header:!1,align:ke.align[G]});Ce+=this.renderer.tablerow(Pe)}re+=this.renderer.table(pe,Ce);continue}case"blockquote":{Ce=this.parse(ke.tokens),re+=this.renderer.blockquote(Ce);continue}case"list":{for(je=ke.ordered,Ge=ke.start,et=ke.loose,Q=ke.items.length,Ce="",$=0;$<Q;$++)nt=ke.items[$],st=nt.checked,ht=nt.task,_e="",nt.task&&(Me=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Me+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Me+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Me}):_e+=Me),_e+=this.parse(nt.tokens,et),Ce+=this.renderer.listitem(_e,ht,st);re+=this.renderer.list(Ce,je,Ge);continue}case"html":{re+=this.renderer.html(ke.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Ce=ke.tokens?this.parseInline(ke.tokens):ke.text;O+1<oe&&ee[O+1].type==="text";)ke=ee[++O],Ce+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);re+=ae?this.renderer.paragraph(Ce):Ce;continue}default:{var W='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return re},ue.parseInline=function(ee,ae){ae=ae||this.renderer;var re="",O,$,G,Q=ee.length;for(O=0;O<Q;O++){if($=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(G=this.options.extensions.renderers[$.type].call({parser:this},$),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){re+=G||"";continue}switch($.type){case"escape":{re+=ae.text($.text);break}case"html":{re+=ae.html($.text);break}case"link":{re+=ae.link($.href,$.title,this.parseInline($.tokens,ae));break}case"image":{re+=ae.image($.href,$.title,$.text);break}case"strong":{re+=ae.strong(this.parseInline($.tokens,ae));break}case"em":{re+=ae.em(this.parseInline($.tokens,ae));break}case"codespan":{re+=ae.codespan($.text);break}case"br":{re+=ae.br();break}case"del":{re+=ae.del(this.parseInline($.tokens,ae));break}case"text":{re+=ae.text($.text);break}default:{var de='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return re},se}();function J(se,ue,he){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof ue=="function"&&(he=ue,ue=null),ue=n({},J.defaults,ue||{}),L(ue),he){var ee=ue.highlight,ae;try{ae=H.lex(se,ue)}catch(Q){return he(Q)}var re=function(de){var be;if(!de)try{ue.walkTokens&&J.walkTokens(ae,ue.walkTokens),be=Y.parse(ae,ue)}catch(Pe){de=Pe}return ue.highlight=ee,de?he(de):he(null,be)};if(!ee||ee.length<3||(delete ue.highlight,!ae.length))return re();var O=0;J.walkTokens(ae,function(Q){Q.type==="code"&&(O++,setTimeout(function(){ee(Q.text,Q.lang,function(de,be){if(de)return re(de);be!=null&&be!==Q.text&&(Q.text=be,Q.escaped=!0),O--,O===0&&re()})},0))}),O===0&&re();return}function $(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(Q.message+"",!0)+"</pre>";throw Q}try{var G=H.lex(se,ue);if(ue.walkTokens){if(ue.async)return Promise.all(J.walkTokens(G,ue.walkTokens)).then(function(){return Y.parse(G,ue)}).catch($);J.walkTokens(G,ue.walkTokens)}return Y.parse(G,ue)}catch(Q){$(Q)}}J.options=J.setOptions=function(se){return n(J.defaults,se),T(J.defaults),J},J.getDefaults=D,J.defaults=ne.defaults,J.use=function(){for(var se=arguments.length,ue=new Array(se),he=0;he<se;he++)ue[he]=arguments[he];var ee=n.apply(void 0,[{}].concat(ue)),ae=J.defaults.extensions||{renderers:{},childTokens:{}},re;ue.forEach(function(O){if(O.extensions&&(re=!0,O.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var Q=ae.renderers?ae.renderers[G.name]:null;Q?ae.renderers[G.name]=function(){for(var de=arguments.length,be=new Array(de),Pe=0;Pe<de;Pe++)be[Pe]=arguments[Pe];var pe=G.renderer.apply(this,be);return pe===!1&&(pe=Q.apply(this,be)),pe}:ae.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[G.level]?ae[G.level].unshift(G.tokenizer):ae[G.level]=[G.tokenizer],G.start&&(G.level==="block"?ae.startBlock?ae.startBlock.push(G.start):ae.startBlock=[G.start]:G.level==="inline"&&(ae.startInline?ae.startInline.push(G.start):ae.startInline=[G.start]))}G.childTokens&&(ae.childTokens[G.name]=G.childTokens)})),O.renderer&&function(){var G=J.defaults.renderer||new X,Q=function(Pe){var pe=G[Pe];G[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),je=0;je<Ce;je++)ke[je]=arguments[je];var Ge=O.renderer[Pe].apply(G,ke);return Ge===!1&&(Ge=pe.apply(G,ke)),Ge}};for(var de in O.renderer)Q(de);ee.renderer=G}(),O.tokenizer&&function(){var G=J.defaults.tokenizer||new N,Q=function(Pe){var pe=G[Pe];G[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),je=0;je<Ce;je++)ke[je]=arguments[je];var Ge=O.tokenizer[Pe].apply(G,ke);return Ge===!1&&(Ge=pe.apply(G,ke)),Ge}};for(var de in O.tokenizer)Q(de);ee.tokenizer=G}(),O.walkTokens){var $=J.defaults.walkTokens;ee.walkTokens=function(G){var Q=[];return Q.push(O.walkTokens.call(this,G)),$&&(Q=Q.concat($.call(this,G))),Q}}re&&(ee.extensions=ae),J.setOptions(ee)})},J.walkTokens=function(se,ue){for(var he=[],ee=function(){var $=re.value;switch(he=he.concat(ue.call(J,$)),$.type){case"table":{for(var G=A($.header),Q;!(Q=G()).done;){var de=Q.value;he=he.concat(J.walkTokens(de.tokens,ue))}for(var be=A($.rows),Pe;!(Pe=be()).done;)for(var pe=Pe.value,Ce=A(pe),ke;!(ke=Ce()).done;){var je=ke.value;he=he.concat(J.walkTokens(je.tokens,ue))}break}case"list":{he=he.concat(J.walkTokens($.items,ue));break}default:J.defaults.extensions&&J.defaults.extensions.childTokens&&J.defaults.extensions.childTokens[$.type]?J.defaults.extensions.childTokens[$.type].forEach(function(Ge){he=he.concat(J.walkTokens($[Ge],ue))}):$.tokens&&(he=he.concat(J.walkTokens($.tokens,ue)))}},ae=A(se),re;!(re=ae()).done;)ee();return he},J.parseInline=function(se,ue){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");ue=n({},J.defaults,ue||{}),L(ue);try{var he=H.lexInline(se,ue);return ue.walkTokens&&J.walkTokens(he,ue.walkTokens),Y.parseInline(he,ue)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(ee.message+"",!0)+"</pre>";throw ee}},J.Parser=Y,J.parser=Y.parse,J.Renderer=X,J.TextRenderer=V,J.Lexer=H,J.lexer=H.lex,J.Tokenizer=N,J.Slugger=x,J.parse=J;var te=J.options,le=J.setOptions,Z=J.use,ge=J.walkTokens,ve=J.parseInline,De=J,Re=Y.parse,ze=H.lex;ne.Lexer=H,ne.Parser=Y,ne.Renderer=X,ne.Slugger=x,ne.TextRenderer=V,ne.Tokenizer=N,ne.getDefaults=D,ne.lexer=ze,ne.marked=J,ne.options=te,ne.parse=De,ne.parseInline=ve,ne.parser=Re,ne.setOptions=le,ne.use=Z,ne.walkTokens=ge,Object.defineProperty(ne,"__esModule",{value:!0})}),define(Se[82],ye([1,0,28]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new c.LRUCache(1e4);function k(y){return S(y,"NFC",t)}e.normalizeNFC=k;const A=new c.LRUCache(1e4);function D(y){return S(y,"NFD",A)}e.normalizeNFD=D;const T=/[^\u0000-\u0080]/;function S(y,R,P){if(!y)return y;const E=P.get(y);if(E)return E;let C;return T.test(y)?C=y.normalize(R):C=y,P.set(y,C),C}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(R){return D(R).replace(y,"")}}()}),define(Se[100],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(T,S,y){return Math.min(Math.max(T,S),y)}e.clamp=c;function t(T,S){return(S+T%S)%S}e.rot=t;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class A{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class D{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const y=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function ne(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function D(S){A.push(S,Date.now())}function T(){const S=[];for(let y=0;y<A.length;y+=2)S.push({name:A[y],startTime:A[y+1]});return S}return{mark:D,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(k+D.startTime)});return A}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function c(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=c(t))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var t in c)(typeof exports=="object"?exports:ne)[t]=c[t]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function c(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return ne[t].call(k.exports,k,k.exports,c),k.l=!0,k.exports}return c.m=ne,c.c=e,c.d=function(t,k,A){c.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:A})},c.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},c.t=function(t,k){if(1&k&&(t=c(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var A=Object.create(null);if(c.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)c.d(A,D,function(T){return t[T]}.bind(null,D));return A},c.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return c.d(k,"a",k),k},c.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},c.p="",c(c.s=0)}([function(ne,e,c){(function(t){var k;e=ne.exports=Z,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],y=0,R=y++;S[R]="0|[1-9]\\d*";var P=y++;S[P]="[0-9]+";var E=y++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=y++;S[C]="("+S[R]+")\\.("+S[R]+")\\.("+S[R]+")";var v=y++;S[v]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var d=y++;S[d]="(?:"+S[R]+"|"+S[E]+")";var g=y++;S[g]="(?:"+S[P]+"|"+S[E]+")";var m=y++;S[m]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var w=y++;S[w]="(?:-?("+S[g]+"(?:\\."+S[g]+")*))";var f=y++;S[f]="[0-9A-Za-z-]+";var h=y++;S[h]="(?:\\+("+S[f]+"(?:\\."+S[f]+")*))";var b=y++,s="v?"+S[C]+S[m]+"?"+S[h]+"?";S[b]="^"+s+"$";var i="[v=\\s]*"+S[v]+S[w]+"?"+S[h]+"?",l=y++;S[l]="^"+i+"$";var u=y++;S[u]="((?:<|>)?=?)";var r=y++;S[r]=S[P]+"|x|X|\\*";var a=y++;S[a]=S[R]+"|x|X|\\*";var n=y++;S[n]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[m]+")?"+S[h]+"?)?)?";var o=y++;S[o]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[w]+")?"+S[h]+"?)?)?";var p=y++;S[p]="^"+S[u]+"\\s*"+S[n]+"$";var I=y++;S[I]="^"+S[u]+"\\s*"+S[o]+"$";var L=y++;S[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var z=y++;S[z]="(?:~>?)";var _=y++;S[_]="(\\s*)"+S[z]+"\\s+",T[_]=new RegExp(S[_],"g");var q=y++;S[q]="^"+S[z]+S[n]+"$";var N=y++;S[N]="^"+S[z]+S[o]+"$";var M=y++;S[M]="(?:\\^)";var F=y++;S[F]="(\\s*)"+S[M]+"\\s+",T[F]=new RegExp(S[F],"g");var B=y++;S[B]="^"+S[M]+S[n]+"$";var U=y++;S[U]="^"+S[M]+S[o]+"$";var H=y++;S[H]="^"+S[u]+"\\s*("+i+")$|^$";var X=y++;S[X]="^"+S[u]+"\\s*("+s+")$|^$";var V=y++;S[V]="(\\s*)"+S[u]+"\\s*("+i+"|"+S[n]+")",T[V]=new RegExp(S[V],"g");var x=y++;S[x]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var Y=y++;S[Y]="^\\s*("+S[o]+")\\s+-\\s+("+S[o]+")\\s*$";var J=y++;S[J]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)k(te,S[te]),T[te]||(T[te]=new RegExp(S[te]));function le(pe,Ce){if(pe instanceof Z)return pe;if(typeof pe!="string"||pe.length>A||!(Ce?T[l]:T[b]).test(pe))return null;try{return new Z(pe,Ce)}catch{return null}}function Z(pe,Ce){if(pe instanceof Z){if(pe.loose===Ce)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Z))return new Z(pe,Ce);k("SemVer",pe,Ce),this.loose=Ce;var ke=pe.trim().match(Ce?T[l]:T[b]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ge=+je;if(Ge>=0&&Ge<D)return Ge}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=le,e.valid=function(pe,Ce){var ke=le(pe,Ce);return ke?ke.version:null},e.clean=function(pe,Ce){var ke=le(pe.trim().replace(/^[=v]+/,""),Ce);return ke?ke.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(pe){return k("SemVer.compare",this.version,this.loose,pe),pe instanceof Z||(pe=new Z(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},Z.prototype.compareMain=function(pe){return pe instanceof Z||(pe=new Z(pe,this.loose)),ve(this.major,pe.major)||ve(this.minor,pe.minor)||ve(this.patch,pe.patch)},Z.prototype.comparePre=function(pe){if(pe instanceof Z||(pe=new Z(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var Ce=0;do{var ke=this.prerelease[Ce],je=pe.prerelease[Ce];if(k("prerelease compare",Ce,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return ve(ke,je)}while(++Ce)},Z.prototype.inc=function(pe,Ce){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,Ce,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new Z(pe,ke).inc(Ce,je).version}catch{return null}},e.diff=function(pe,Ce){if(se(pe,Ce))return null;var ke=le(pe),je=le(Ce);if(ke.prerelease.length||je.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return Ge},e.compareIdentifiers=ve;var ge=/^[0-9]+$/;function ve(pe,Ce){var ke=ge.test(pe),je=ge.test(Ce);return ke&&je&&(pe=+pe,Ce=+Ce),ke&&!je?-1:je&&!ke?1:pe<Ce?-1:pe>Ce?1:0}function De(pe,Ce,ke){return new Z(pe,ke).compare(new Z(Ce,ke))}function Re(pe,Ce,ke){return De(pe,Ce,ke)>0}function ze(pe,Ce,ke){return De(pe,Ce,ke)<0}function se(pe,Ce,ke){return De(pe,Ce,ke)===0}function ue(pe,Ce,ke){return De(pe,Ce,ke)!==0}function he(pe,Ce,ke){return De(pe,Ce,ke)>=0}function ee(pe,Ce,ke){return De(pe,Ce,ke)<=0}function ae(pe,Ce,ke,je){var Ge;switch(Ce){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe!==ke;break;case"":case"=":case"==":Ge=se(pe,ke,je);break;case"!=":Ge=ue(pe,ke,je);break;case">":Ge=Re(pe,ke,je);break;case">=":Ge=he(pe,ke,je);break;case"<":Ge=ze(pe,ke,je);break;case"<=":Ge=ee(pe,ke,je);break;default:throw new TypeError("Invalid operator: "+Ce)}return Ge}function re(pe,Ce){if(pe instanceof re){if(pe.loose===Ce)return pe;pe=pe.value}if(!(this instanceof re))return new re(pe,Ce);k("comparator",pe,Ce),this.loose=Ce,this.parse(pe),this.semver===O?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(pe,Ce){return ve(Ce,pe)},e.major=function(pe,Ce){return new Z(pe,Ce).major},e.minor=function(pe,Ce){return new Z(pe,Ce).minor},e.patch=function(pe,Ce){return new Z(pe,Ce).patch},e.compare=De,e.compareLoose=function(pe,Ce){return De(pe,Ce,!0)},e.rcompare=function(pe,Ce,ke){return De(Ce,pe,ke)},e.sort=function(pe,Ce){return pe.sort(function(ke,je){return e.compare(ke,je,Ce)})},e.rsort=function(pe,Ce){return pe.sort(function(ke,je){return e.rcompare(ke,je,Ce)})},e.gt=Re,e.lt=ze,e.eq=se,e.neq=ue,e.gte=he,e.lte=ee,e.cmp=ae,e.Comparator=re;var O={};function $(pe,Ce){if(pe instanceof $)return pe.loose===Ce?pe:new $(pe.raw,Ce);if(pe instanceof re)return new $(pe.value,Ce);if(!(this instanceof $))return new $(pe,Ce);if(this.loose=Ce,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function G(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function Q(pe,Ce,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe){return((Ce=G(ke)?"":G(je)?">="+ke+".0.0":G(Ge)?">="+ke+"."+je+".0":">="+Ce)+" "+(nt=G(st)?"":G(ht)?"<"+(+st+1)+".0.0":G(Me)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Me+"-"+it:"<="+nt)).trim()}function de(pe,Ce){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(Ce))return!1;if(Ce.prerelease.length){for(ke=0;ke<pe.length;ke++)if(k(pe[ke].semver),pe[ke].semver!==O&&pe[ke].semver.prerelease.length>0){var je=pe[ke].semver;if(je.major===Ce.major&&je.minor===Ce.minor&&je.patch===Ce.patch)return!0}return!1}return!0}function be(pe,Ce,ke){try{Ce=new $(Ce,ke)}catch{return!1}return Ce.test(pe)}function Pe(pe,Ce,ke,je){var Ge,et,_e,nt,st;switch(pe=new Z(pe,je),Ce=new $(Ce,je),ke){case">":Ge=Re,et=ee,_e=ze,nt=">",st=">=";break;case"<":Ge=ze,et=he,_e=Re,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(pe,Ce,je))return!1;for(var ht=0;ht<Ce.set.length;++ht){var Me=Ce.set[ht],it=null,oe=null;if(Me.forEach(function(W){W.semver===O&&(W=new re(">=0.0.0")),it=it||W,oe=oe||W,Ge(W.semver,it.semver,je)?it=W:_e(W.semver,oe.semver,je)&&(oe=W)}),it.operator===nt||it.operator===st||(!oe.operator||oe.operator===nt)&&et(pe,oe.semver)||oe.operator===st&&_e(pe,oe.semver))return!1}return!0}re.prototype.parse=function(pe){var Ce=this.loose?T[H]:T[X],ke=pe.match(Ce);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new Z(ke[2],this.loose):this.semver=O},re.prototype.toString=function(){return this.value},re.prototype.test=function(pe){return k("Comparator.test",pe,this.loose),this.semver===O||(typeof pe=="string"&&(pe=new Z(pe,this.loose)),ae(pe,this.operator,this.semver,this.loose))},re.prototype.intersects=function(pe,Ce){if(!(pe instanceof re))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new $(pe.value,Ce),be(this.value,ke,Ce);if(pe.operator==="")return ke=new $(this.value,Ce),be(pe.semver,ke,Ce);var je=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=ae(this.semver,"<",pe.semver,Ce)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=ae(this.semver,">",pe.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return je||Ge||et&&_e||nt||st},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(pe){var Ce=this.loose;pe=pe.trim(),k("range",pe,Ce);var ke=Ce?T[Y]:T[x];pe=pe.replace(ke,Q),k("hyphen replace",pe),pe=pe.replace(T[V],"$1$2$3"),k("comparator trim",pe,T[V]),pe=(pe=(pe=pe.replace(T[_],"$1~")).replace(T[F],"$1^")).split(/\s+/).join(" ");var je=Ce?T[H]:T[X],Ge=pe.split(" ").map(function(et){return function(_e,nt){return k("comp",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,oe){k("caret",it,oe);var W=oe?T[U]:T[B];return it.replace(W,function(ce,Ie,Le,Be,Xe){var Ze;return k("caret",it,ce,Ie,Le,Be,Xe),G(Ie)?Ze="":G(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":G(Be)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":Xe?(k("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+Xe+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+Xe+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+Xe+" <"+(+Ie+1)+".0.0"):(k("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+" <"+(+Ie+1)+".0.0"),k("caret return",Ze),Ze})}(Me,ht)}).join(" ")}(_e,nt),k("caret",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,oe){var W=oe?T[N]:T[q];return it.replace(W,function(ce,Ie,Le,Be,Xe){var Ze;return k("tilde",it,ce,Ie,Le,Be,Xe),G(Ie)?Ze="":G(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":G(Be)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":Xe?(k("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),Ze=">="+Ie+"."+Le+"."+Be+Xe+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0",k("tilde return",Ze),Ze})}(Me,ht)}).join(" ")}(_e,nt),k("tildes",_e),_e=function(st,ht){return k("replaceXRanges",st,ht),st.split(/\s+/).map(function(Me){return function(it,oe){it=it.trim();var W=oe?T[I]:T[p];return it.replace(W,function(ce,Ie,Le,Be,Xe,Ze){k("xRange",it,ce,Ie,Le,Be,Xe,Ze);var mt=G(Le),ft=mt||G(Be),lt=ft||G(Xe);return Ie==="="&&lt&&(Ie=""),mt?ce=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&lt?(ft&&(Be=0),lt&&(Xe=0),Ie===">"?(Ie=">=",ft?(Le=+Le+1,Be=0,Xe=0):lt&&(Be=+Be+1,Xe=0)):Ie==="<="&&(Ie="<",ft?Le=+Le+1:Be=+Be+1),ce=Ie+Le+"."+Be+"."+Xe):ft?ce=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(ce=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),k("xRange return",ce),ce})}(Me,ht)}).join(" ")}(_e,nt),k("xrange",_e),_e=function(st,ht){return k("replaceStars",st,ht),st.trim().replace(T[J],"")}(_e,nt),k("stars",_e),_e}(et,Ce)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(je)})),Ge=Ge.map(function(et){return new re(et,Ce)})},$.prototype.intersects=function(pe,Ce){if(!(pe instanceof $))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return pe.set.some(function(Ge){return Ge.every(function(et){return je.intersects(et,Ce)})})})})},e.toComparators=function(pe,Ce){return new $(pe,Ce).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},$.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new Z(pe,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(de(this.set[Ce],pe))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(pe,Ce,ke){var je=null,Ge=null;try{var et=new $(Ce,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==-1||(Ge=new Z(je=_e,ke)))}),je},e.minSatisfying=function(pe,Ce,ke){var je=null,Ge=null;try{var et=new $(Ce,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==1||(Ge=new Z(je=_e,ke)))}),je},e.validRange=function(pe,Ce){try{return new $(pe,Ce).range||"*"}catch{return null}},e.ltr=function(pe,Ce,ke){return Pe(pe,Ce,"<",ke)},e.gtr=function(pe,Ce,ke){return Pe(pe,Ce,">",ke)},e.outside=Pe,e.prerelease=function(pe,Ce){var ke=le(pe,Ce);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,Ce,ke){return pe=new $(pe,ke),Ce=new $(Ce,ke),pe.intersects(Ce)},e.coerce=function(pe){if(pe instanceof Z)return pe;if(typeof pe!="string")return null;var Ce=pe.match(T[L]);return Ce==null?null:le((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,c(1))},function(ne,e){var c,t,k=ne.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function T(g){if(c===setTimeout)return setTimeout(g,0);if((c===A||!c)&&setTimeout)return c=setTimeout,setTimeout(g,0);try{return c(g,0)}catch{try{return c.call(null,g,0)}catch{return c.call(this,g,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:A}catch{c=A}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var S,y=[],R=!1,P=-1;function E(){R&&S&&(R=!1,S.length?y=S.concat(y):P=-1,y.length&&C())}function C(){if(!R){var g=T(E);R=!0;for(var m=y.length;m;){for(S=y,y=[];++P<m;)S&&S[P].run();P=-1,m=y.length}S=null,R=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(g)}}function v(g,m){this.fun=g,this.array=m}function d(){}k.nextTick=function(g){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];y.push(new v(g,m)),y.length!==1||R||T(C)},v.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=d,k.addListener=d,k.once=d,k.off=d,k.removeListener=d,k.removeAllListeners=d,k.emit=d,k.prependListener=d,k.prependOnceListener=d,k.listeners=function(g){return[]},k.binding=function(g){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(g){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Se[101],ye([1,0,10,6]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(h){const b=h;return b?typeof b.read=="function":!1}e.isReadable=k;function A(h){const b=h;return b?[b.on,b.pause,b.resume,b.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=A;function D(h){const b=h;return b?A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=D;function T(h,b){return new S(h,b)}e.newWriteableStream=T;class S{constructor(b,s){this.e=b,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(s=>s(b))}h(b){this.c.error.length===0?(0,c.onUnexpectedError)(b):this.c.error.slice(0).forEach(s=>s(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,s){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(b,s){if(this.a.destroyed)return;let i;switch(b){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const l=i.indexOf(s);l>=0&&i.splice(l,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(h,b){const s=[];let i;for(;(i=h.read())!==null;)s.push(i);return b(s)}e.consumeReadable=y;function R(h,b,s){const i=[];let l;for(;(l=h.read())!==null&&i.length<s;)i.push(l);return l===null&&i.length>0?b(i):{read:()=>{if(i.length>0)return i.shift();if(typeof l<"u"){const u=l;return l=void 0,u}return h.read()}}}e.peekReadable=R;function P(h,b){return new Promise((s,i)=>{const l=[];E(h,{onData:u=>{b&&l.push(u)},onError:u=>{b?i(u):s(void 0)},onEnd:()=>{s(b?b(l):void 0)}})})}e.consumeStream=P;function E(h,b){let s=!1;return h.on("error",i=>{s||b.onError(i)}),h.on("end",()=>{s||b.onEnd()}),h.on("data",i=>{s||b.onData(i)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=E;function C(h,b){return new Promise((s,i)=>{const l=new t.DisposableStore,u=[],r=o=>{if(u.push(o),u.length>b)return l.dispose(),h.pause(),s({stream:h,buffer:u,ended:!1})},a=o=>i(o),n=()=>s({stream:h,buffer:u,ended:!0});l.add((0,t.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),l.add((0,t.toDisposable)(()=>h.removeListener("end",n))),h.on("end",n),l.add((0,t.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}e.peekStream=C;function v(h,b){const s=T(b);return s.end(h),s}e.toStream=v;function d(){const h=T(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function g(h){let b=!1;return{read:()=>b?null:(b=!0,h)}}e.toReadable=g;function m(h,b,s){const i=T(s);return E(h,{onData:l=>i.write(b.data(l)),onError:l=>i.error(b.error?b.error(l):l),onEnd:()=>i.end()}),i}e.transform=m;function w(h,b,s){let i=!1;return{read:()=>{const l=b.read();return i?l:(i=!0,l!==null?s([h,l]):h)}}}e.prefixedReadable=w;function f(h,b,s){let i=!1;const l=T(s);return E(b,{onData:u=>i?l.write(u):(i=!0,l.write(s([h,u]))),onError:u=>l.error(u),onEnd:()=>{i||(i=!0,l.write(h)),l.end()}}),l}e.prefixedStream=f}),define(Se[22],ye([1,0,101]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,A;class D{static alloc(o){return t?new D(Buffer.allocUnsafe(o)):new D(new Uint8Array(o))}static wrap(o){return t&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new D(o)}static fromString(o,p){return!(p?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(o)):(k||(k=new TextEncoder),new D(k.encode(o)))}static fromByteArray(o){const p=D.alloc(o.length);for(let I=0,L=o.length;I<L;I++)p.buffer[I]=o[I];return p}static concat(o,p){if(typeof p>"u"){p=0;for(let z=0,_=o.length;z<_;z++)p+=o[z].byteLength}const I=D.alloc(p);let L=0;for(let z=0,_=o.length;z<_;z++){const q=o[z];I.set(q,L),L+=q.byteLength}return I}constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}clone(){const o=D.alloc(this.byteLength);return o.set(this),o}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(o,p){return new D(this.buffer.subarray(o,p))}set(o,p){if(o instanceof D)this.buffer.set(o.buffer,p);else if(o instanceof Uint8Array)this.buffer.set(o,p);else if(o instanceof ArrayBuffer)this.buffer.set(new Uint8Array(o),p);else if(ArrayBuffer.isView(o))this.buffer.set(new Uint8Array(o.buffer,o.byteOffset,o.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(o){return y(this.buffer,o)}writeUInt32BE(o,p){R(this.buffer,o,p)}readUInt32LE(o){return P(this.buffer,o)}writeUInt32LE(o,p){E(this.buffer,o,p)}readUInt8(o){return C(this.buffer,o)}writeUInt8(o,p){v(this.buffer,o,p)}}e.VSBuffer=D;function T(n,o){return n[o+0]<<0>>>0|n[o+1]<<8>>>0}e.readUInt16LE=T;function S(n,o,p){n[p+0]=o&255,o=o>>>8,n[p+1]=o&255}e.writeUInt16LE=S;function y(n,o){return n[o]*2**24+n[o+1]*2**16+n[o+2]*2**8+n[o+3]}e.readUInt32BE=y;function R(n,o,p){n[p+3]=o,o=o>>>8,n[p+2]=o,o=o>>>8,n[p+1]=o,o=o>>>8,n[p]=o}e.writeUInt32BE=R;function P(n,o){return n[o+0]<<0>>>0|n[o+1]<<8>>>0|n[o+2]<<16>>>0|n[o+3]<<24>>>0}e.readUInt32LE=P;function E(n,o,p){n[p+0]=o&255,o=o>>>8,n[p+1]=o&255,o=o>>>8,n[p+2]=o&255,o=o>>>8,n[p+3]=o&255}e.writeUInt32LE=E;function C(n,o){return n[o]}e.readUInt8=C;function v(n,o,p){n[p]=o}e.writeUInt8=v;function d(n){return c.consumeReadable(n,o=>D.concat(o))}e.readableToBuffer=d;function g(n){return c.toReadable(n)}e.bufferToReadable=g;function m(n){return c.consumeStream(n,o=>D.concat(o))}e.streamToBuffer=m;async function w(n){return n.ended?D.concat(n.buffer):D.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=w;function f(n){return c.toStream(n,o=>D.concat(o))}e.bufferToStream=f;function h(n){return c.transform(n,{data:o=>typeof o=="string"?D.fromString(o):D.wrap(o)},o=>D.concat(o))}e.streamToBufferReadableStream=h;function b(n){return c.newWriteableStream(o=>D.concat(o),n)}e.newWriteableBufferStream=b;function s(n,o){return c.prefixedReadable(n,o,p=>D.concat(p))}e.prefixedBufferReadable=s;function i(n,o){return c.prefixedStream(n,o,p=>D.concat(p))}e.prefixedBufferStream=i;function l(n){let o=0,p=0,I=0;const L=new Uint8Array(Math.floor(n.length/4*3)),z=q=>{switch(p){case 3:L[I++]=o|q,p=0;break;case 2:L[I++]=o|q>>>2,o=q<<6,p=3;break;case 1:L[I++]=o|q>>>4,o=q<<4,p=2;break;default:o=q<<2,p=1}};for(let q=0;q<n.length;q++){const N=n.charCodeAt(q);if(N>=65&&N<=90)z(N-65);else if(N>=97&&N<=122)z(N-97+26);else if(N>=48&&N<=57)z(N-48+52);else if(N===43||N===45)z(62);else if(N===47||N===95)z(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${n[q]}`)}}const _=I;for(;p>0;)z(0);return D.wrap(L).slice(0,_)}e.decodeBase64=l;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:n},o=!0,p=!1){const I=p?r:u;let L="";const z=n.byteLength%3;let _=0;for(;_<n.byteLength-z;_+=3){const q=n[_+0],N=n[_+1],M=n[_+2];L+=I[q>>>2],L+=I[(q<<4|N>>>4)&63],L+=I[(N<<2|M>>>6)&63],L+=I[M&63]}if(z===1){const q=n[_+0];L+=I[q>>>2],L+=I[q<<4&63],o&&(L+="==")}else if(z===2){const q=n[_+0],N=n[_+1];L+=I[q>>>2],L+=I[(q<<4|N>>>4)&63],L+=I[N<<2&63],o&&(L+="=")}return L}e.encodeBase64=a}),define(Se[11],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(i){return typeof i=="string"}e.isString=c;function t(i){return Array.isArray(i)&&i.every(l=>c(l))}e.isStringArray=t;function k(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.isObject=k;function A(i){const l=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof l}e.isTypedArray=A;function D(i){return typeof i=="number"&&!isNaN(i)}e.isNumber=D;function T(i){return!!i&&typeof i[Symbol.iterator]=="function"}e.isIterable=T;function S(i){return i===!0||i===!1}e.isBoolean=S;function y(i){return typeof i>"u"}e.isUndefined=y;function R(i){return!P(i)}e.isDefined=R;function P(i){return y(i)||i===null}e.isUndefinedOrNull=P;function E(i,l){if(!i)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=E;function C(i){if(P(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.assertIsDefined=C;function v(...i){const l=[];for(let u=0;u<i.length;u++){const r=i[u];if(P(r))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);l.push(r)}return l}e.assertAllDefined=v;const d=Object.prototype.hasOwnProperty;function g(i){if(!k(i))return!1;for(const l in i)if(d.call(i,l))return!1;return!0}e.isEmptyObject=g;function m(i){return typeof i=="function"}e.isFunction=m;function w(...i){return i.length>0&&i.every(m)}e.areFunctions=w;function f(i,l){const u=Math.min(i.length,l.length);for(let r=0;r<u;r++)h(i[r],l[r])}e.validateConstraints=f;function h(i,l){if(c(l)){if(typeof i!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(m(l)){try{if(i instanceof l)return}catch{}if(!P(i)&&i.constructor===l||l.length===1&&l.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function b(i){return i===null?void 0:i}e.withNullAsUndefined=b;function s(i){return typeof i>"u"?null:i}e.withUndefinedAsNull=s}),define(Se[23],ye([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const w=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([f,h])=>{w[f]=h&&typeof h=="object"?t(h):h}),w}e.deepClone=t;function k(m){if(!m||typeof m!="object")return m;const w=[m];for(;w.length>0;){const f=w.shift();Object.freeze(f);for(const h in f)if(A.call(f,h)){const b=f[h];typeof b=="object"&&!Object.isFrozen(b)&&!(0,c.isTypedArray)(b)&&w.push(b)}}return m}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function D(m,w){return T(m,w,new Set)}e.cloneAndChange=D;function T(m,w,f){if((0,c.isUndefinedOrNull)(m))return m;const h=w(m);if(typeof h<"u")return h;if(Array.isArray(m)){const b=[];for(const s of m)b.push(T(s,w,f));return b}if((0,c.isObject)(m)){if(f.has(m))throw new Error("Cannot clone recursive data-structure");f.add(m);const b={};for(const s in m)A.call(m,s)&&(b[s]=T(m[s],w,f));return f.delete(m),b}return m}function S(m,w,f=!0){return(0,c.isObject)(m)?((0,c.isObject)(w)&&Object.keys(w).forEach(h=>{h in m?f&&((0,c.isObject)(m[h])&&(0,c.isObject)(w[h])?S(m[h],w[h],f):m[h]=w[h]):m[h]=w[h]}),m):w}e.mixin=S;function y(m,w){if(m===w)return!0;if(m==null||w===null||w===void 0||typeof m!=typeof w||typeof m!="object"||Array.isArray(m)!==Array.isArray(w))return!1;let f,h;if(Array.isArray(m)){if(m.length!==w.length)return!1;for(f=0;f<m.length;f++)if(!y(m[f],w[f]))return!1}else{const b=[];for(h in m)b.push(h);b.sort();const s=[];for(h in w)s.push(h);if(s.sort(),!y(b,s))return!1;for(f=0;f<b.length;f++)if(!y(m[b[f]],w[b[f]]))return!1}return!0}e.equals=y;function R(m){const w=new Set;return JSON.stringify(m,(f,h)=>{if((0,c.isObject)(h)||Array.isArray(h)){if(w.has(h))return"[Circular]";w.add(h)}return h})}e.safeStringify=R;function P(m,w){const f=Object.create(null);return!m||!w||Object.keys(w).forEach(b=>{const s=m[b],i=w[b];y(s,i)||(f[b]=i)}),f}e.distinct=P;function E(m,w){const f=w.toLowerCase(),h=Object.keys(m).find(b=>b.toLowerCase()===f);return h?m[h]:m[w]}e.getCaseInsensitive=E;function C(m,w){const f=Object.create(null);for(const[h,b]of Object.entries(m))w(h,b)&&(f[h]=b);return f}e.filter=C;function v(m){let w=[],f=Object.getPrototypeOf(m);for(;Object.prototype!==f;)w=w.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return w}e.getAllPropertyNames=v;function d(m){const w=[];for(const f of v(m))typeof m[f]=="function"&&w.push(f);return w}e.getAllMethodNames=d;function g(m,w){const f=b=>function(){const s=Array.prototype.slice.call(arguments,0);return w(b,s)},h={};for(const b of m)h[b]=f(b);return h}e.createProxyObject=g}),define(Se[102],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function t(A){return A<0?0:A>255?255:A|0}e.toUint8=t;function k(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=k}),define(Se[30],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return c.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const A=new Uint8Array(16),D=[];for(let T=0;T<256;T++)D.push(T.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,y="";return y+=D[A[S++]],y+=D[A[S++]],y+=D[A[S++]],y+=D[A[S++]],y+="-",y+=D[A[S++]],y+=D[A[S++]],y+="-",y+=D[A[S++]],y+=D[A[S++]],y+="-",y+=D[A[S++]],y+=D[A[S++]],y+="-",y+=D[A[S++]],y+=D[A[S++]],y+=D[A[S++]],y+=D[A[S++]],y+=D[A[S++]],y+=D[A[S++]],y}}()}),define(Se[147],ye([1,0,17,30]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function k(T){return{id:(0,t.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=k;function A(T,S,y){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:S,data:y}),value:void 0}}e.createFileDataTransferItem=A;class D{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,y){const R=this.a.get(S);R?R.push(y):this.a.set(this.b(S),[y])}replace(S,y){this.a.set(this.b(S),[y])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,y]of this.a.entries())for(const R of y)yield[S,R]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[y,R]of this.entries())S(R,y)}b(S){return S.toLowerCase()}}e.VSDataTransfer=D,e.UriList=Object.freeze({create:T=>(0,c.distinct)(T.map(S=>S.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(S=>!S.startsWith("#"))})}),define(Se[103],ye([1,0,102]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(T){const S=(0,c.toUint8)(T);this.c=S,this.a=t.d(S),this.b=new Map}static d(T){const S=new Uint8Array(256);return S.fill(T),S}set(T,S){const y=(0,c.toUint8)(S);T>=0&&T<256?this.a[T]=y:this.b.set(T,y)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var k;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(k||(k={}));class A{constructor(){this.a=new t(0)}add(T){this.a.set(T,1)}has(T){return this.a.get(T)===1}clear(){return this.a.clear()}}e.CharacterSet=A}),define(Se[50],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(k,A){this.lineNumber=k,this.column=A}with(k=this.lineNumber,A=this.column){return k===this.lineNumber&&A===this.column?this:new c(k,A)}delta(k=0,A=0){return this.with(this.lineNumber+k,this.column+A)}equals(k){return c.equals(this,k)}static equals(k,A){return!k&&!A?!0:!!k&&!!A&&k.lineNumber===A.lineNumber&&k.column===A.column}isBefore(k){return c.isBefore(this,k)}static isBefore(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<A.column}isBeforeOrEqual(k){return c.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<=A.column}static compare(k,A){const D=k.lineNumber|0,T=A.lineNumber|0;if(D===T){const S=k.column|0,y=A.column|0;return S-y}return D-T}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new c(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=c}),define(Se[35],ye([1,0,50]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(A,D,T,S){A>T||A===T&&D>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=A,this.endColumn=D):(this.startLineNumber=A,this.startColumn=D,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return t.containsPosition(this,A)}static containsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<A.startColumn||D.lineNumber===A.endLineNumber&&D.column>A.endColumn)}static strictContainsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<=A.startColumn||D.lineNumber===A.endLineNumber&&D.column>=A.endColumn)}containsRange(A){return t.containsRange(this,A)}static containsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>A.endColumn)}strictContainsRange(A){return t.strictContainsRange(this,A)}static strictContainsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<=A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>=A.endColumn)}plusRange(A){return t.plusRange(this,A)}static plusRange(A,D){let T,S,y,R;return D.startLineNumber<A.startLineNumber?(T=D.startLineNumber,S=D.startColumn):D.startLineNumber===A.startLineNumber?(T=D.startLineNumber,S=Math.min(D.startColumn,A.startColumn)):(T=A.startLineNumber,S=A.startColumn),D.endLineNumber>A.endLineNumber?(y=D.endLineNumber,R=D.endColumn):D.endLineNumber===A.endLineNumber?(y=D.endLineNumber,R=Math.max(D.endColumn,A.endColumn)):(y=A.endLineNumber,R=A.endColumn),new t(T,S,y,R)}intersectRanges(A){return t.intersectRanges(this,A)}static intersectRanges(A,D){let T=A.startLineNumber,S=A.startColumn,y=A.endLineNumber,R=A.endColumn;const P=D.startLineNumber,E=D.startColumn,C=D.endLineNumber,v=D.endColumn;return T<P?(T=P,S=E):T===P&&(S=Math.max(S,E)),y>C?(y=C,R=v):y===C&&(R=Math.min(R,v)),T>y||T===y&&S>R?null:new t(T,S,y,R)}equalsRange(A){return t.equalsRange(this,A)}static equalsRange(A,D){return!A&&!D?!0:!!A&&!!D&&A.startLineNumber===D.startLineNumber&&A.startColumn===D.startColumn&&A.endLineNumber===D.endLineNumber&&A.endColumn===D.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(A){return new c.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(A){return new c.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,D){return new t(this.startLineNumber,this.startColumn,A,D)}setStartPosition(A,D){return new t(A,D,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(A){return new t(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static collapseToStart(A){return new t(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,D=A){return new t(A.lineNumber,A.column,D.lineNumber,D.column)}static lift(A){return A?new t(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn)}static areIntersecting(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,D){if(A&&D){const y=A.startLineNumber|0,R=D.startLineNumber|0;if(y===R){const P=A.startColumn|0,E=D.startColumn|0;if(P===E){const C=A.endLineNumber|0,v=D.endLineNumber|0;if(C===v){const d=A.endColumn|0,g=D.endColumn|0;return d-g}return C-v}return P-E}return y-R}return(A?1:0)-(D?1:0)}static compareRangesUsingEnds(A,D){return A.endLineNumber===D.endLineNumber?A.endColumn===D.endColumn?A.startLineNumber===D.startLineNumber?A.startColumn-D.startColumn:A.startLineNumber-D.startLineNumber:A.endColumn-D.endColumn:A.endLineNumber-D.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=t}),define(Se[148],ye([1,0,50,35]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class A extends t.Range{constructor(T,S,y,R){super(T,S,y,R),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=y,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return A.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,T,S):new A(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new A(T,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new A(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new A(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new A(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new A(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let y=0,R=T.length;y<R;y++)if(!this.selectionsEqual(T[y],S[y]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,y,R,P){return P===0?new A(T,S,y,R):new A(y,R,T,S)}}e.Selection=A}),define(Se[149],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[150],ye([1,0,103]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends c.CharacterClassifier{constructor(T){super(0);for(let S=0,y=T.length;S<y;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function A(D){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=D(S)),T[S])}e.getMapForWordSeparators=A(D=>new k(D))}),define(Se[104],ye([1,0,62,6,63]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)P.indexOf(C)>=0||(E+="\\"+C);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=A();function D(P){let E=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)E=P;else{let C="g";P.ignoreCase&&(C+="i"),P.multiline&&(C+="m"),P.unicode&&(C+="u"),E=new RegExp(P.source,C)}return E.lastIndex=0,E}e.ensureValidWordDefinition=D;const T=new k.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(P){const E=T.unshift(P);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function y(P,E,C,v,d){if(d||(d=c.Iterable.first(T)),C.length>d.maxLen){let h=P-d.maxLen/2;return h<0?h=0:v+=h,C=C.substring(h,P+d.maxLen/2),y(P,E,C,v,d)}const g=Date.now(),m=P-1-v;let w=-1,f=null;for(let h=1;!(Date.now()-g>=d.timeBudget);h++){const b=m-d.windowSize*h;E.lastIndex=Math.max(0,b);const s=R(E,C,m,w);if(!s&&f||(f=s,b<=0))break;w=b}if(f){const h={word:f[0],startColumn:v+1+f.index,endColumn:v+1+f.index+f[0].length};return E.lastIndex=0,h}return null}e.getWordAtText=y;function R(P,E,C,v){let d;for(;d=P.exec(E);){const g=d.index||0;if(g<=C&&P.lastIndex>=C)return d;if(v>0&&g>v)return null}return null}}),define(Se[151],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class t{constructor(T){if(this.e=null,this.f=!1,this.open=T.open,this.close=T.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(T.notIn))for(let S=0,y=T.notIn.length;S<y;S++)switch(T.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const y=T.findTokenIndexAtOffset(S-2),R=T.getStandardTokenType(y);return this.isOK(R)}g(T,S){for(let y=T;y<=S;y++){const R=String.fromCharCode(y);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class k{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=k;function A(D,T,S){D.has(T)?D.get(T).push(S):D.set(T,[S])}}),define(Se[152],ye([1,0,103]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class k{constructor(v,d,g){const m=new Uint8Array(v*d);for(let w=0,f=v*d;w<f;w++)m[w]=g;this.a=m,this.rows=v,this.cols=d}get(v,d){return this.a[v*this.cols+d]}set(v,d,g){this.a[v*this.cols+d]=g}}class A{constructor(v){let d=0,g=0;for(let w=0,f=v.length;w<f;w++){const[h,b,s]=v[w];b>d&&(d=b),h>g&&(g=h),s>g&&(g=s)}d++,g++;const m=new k(g,d,0);for(let w=0,f=v.length;w<f;w++){const[h,b,s]=v[w];m.set(h,b,s)}this.a=m,this.b=d}nextState(v,d){return d<0||d>=this.b?0:this.a.get(v,d)}}e.StateMachine=A;let D=null;function T(){return D===null&&(D=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var S;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let y=null;function R(){if(y===null){y=new c.CharacterClassifier(0);const C=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<C.length;d++)y.set(C.charCodeAt(d),1);const v=".,;:";for(let d=0;d<v.length;d++)y.set(v.charCodeAt(d),2)}return y}class P{static a(v,d,g,m,w){let f=w-1;do{const h=d.charCodeAt(f);if(v.get(h)!==2)break;f--}while(f>m);if(m>0){const h=d.charCodeAt(m-1),b=d.charCodeAt(f);(h===40&&b===41||h===91&&b===93||h===123&&b===125)&&f--}return{range:{startLineNumber:g,startColumn:m+1,endLineNumber:g,endColumn:f+2},url:d.substring(m,f+1)}}static computeLinks(v,d=T()){const g=R(),m=[];for(let w=1,f=v.getLineCount();w<=f;w++){const h=v.getLineContent(w),b=h.length;let s=0,i=0,l=0,u=1,r=!1,a=!1,n=!1,o=!1;for(;s<b;){let p=!1;const I=h.charCodeAt(s);if(u===13){let L;switch(I){case 40:r=!0,L=0;break;case 41:L=r?0:1;break;case 91:n=!0,a=!0,L=0;break;case 93:n=!1,L=a?0:1;break;case 123:o=!0,L=0;break;case 125:L=o?0:1;break;case 39:case 34:case 96:l===I?L=1:l===39||l===34||l===96?L=0:L=1;break;case 42:L=l===42?1:0;break;case 124:L=l===124?1:0;break;case 32:L=n?0:1;break;default:L=g.get(I)}L===1&&(m.push(P.a(g,h,w,i,s)),p=!0)}else if(u===12){let L;I===91?(a=!0,L=0):L=g.get(I),L===1?p=!0:u=13}else u=d.nextState(u,I),u===0&&(p=!0);p&&(u=1,r=!1,a=!1,o=!1,i=s+1,l=I),s++}u===13&&m.push(P.a(g,h,w,i,b))}return m}}e.LinkComputer=P;function E(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:P.computeLinks(C)}e.computeLinks=E}),define(Se[105],ye([1,0,23]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=Math.max(1,h.indentSize|0),this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace),this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class R{constructor(h,b){this._findMatchBrand=void 0,this.range=h,this.matches=b}}e.FindMatch=R;var P;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(f){return f&&typeof f.read=="function"}e.isITextSnapshot=E;var C;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(C=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class d{constructor(h,b,s,i,l,u){this.identifier=h,this.range=b,this.text=s,this.forceMoveMarkers=i,this.isAutoWhitespaceEdit=l,this._isTracked=u}}e.ValidAnnotatedEditOperation=d;class g{constructor(h,b,s){this.regex=h,this.wordSeparators=b,this.simpleSearch=s}}e.SearchData=g;class m{constructor(h,b,s){this.reverseEdits=h,this.changes=b,this.trimAutoWhitespaceLineNumbers=s}}e.ApplyEditsResult=m;function w(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}e.shouldSynchronizeModel=w}),define(Se[153],ye([1,0,17,102]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,y){S=(0,t.toUint32)(S);const R=this.a,P=this.b,E=y.length;return E===0?!1:(this.a=new Uint32Array(R.length+E),this.a.set(R.subarray(0,S),0),this.a.set(R.subarray(S),S+E),this.a.set(y,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(S,y){return S=(0,t.toUint32)(S),y=(0,t.toUint32)(y),this.a[S]===y?!1:(this.a[S]=y,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,y){S=(0,t.toUint32)(S),y=(0,t.toUint32)(y);const R=this.a,P=this.b;if(S>=R.length)return!1;const E=R.length-S;return y>=E&&(y=E),y===0?!1:(this.a=new Uint32Array(R.length-y),this.a.set(R.subarray(0,S),0),this.a.set(R.subarray(S+y),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),S>=this.a.length&&(S=this.a.length-1);for(let R=y;R<=S;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let y=0,R=this.a.length-1,P=0,E=0,C=0;for(;y<=R;)if(P=y+(R-y)/2|0,E=this.b[P],C=E-this.a[P],S<C)R=P-1;else if(S>=E)y=P+1;else break;return new D(P,S-C)}}e.PrefixSumComputer=k;class A{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const y=this.e[S],R=y>0?this.d[y-1]:0;return new D(y,S-R)}removeValues(S,y){this.a.splice(S,y),this.f(S)}insertValues(S,y){this.a=(0,c.arrayInsert)(this.a,S,y),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,y=this.a.length;S<y;S++){const R=this.a[S],P=S>0?this.d[S-1]:0;this.d[S]=P+R;for(let E=0;E<R;E++)this.e[P+E]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,y){this.a[S]!==y&&(this.a[S]=y,this.f(S))}}e.ConstantTimePrefixSumComputer=A;class D{constructor(S,y){this.index=S,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=y}}e.PrefixSumIndexOfResult=D}),define(Se[154],ye([19,20]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Se[155],ye([1,0,154]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,A=k*24,D=A*7,T=A*30,S=A*365;function y(P,E,C){typeof P!="number"&&(P=P.getTime());const v=Math.round((new Date().getTime()-P)/1e3);if(v<-30)return(0,c.localize)(0,null,y(new Date().getTime()+v*1e3,!1));if(v<30)return(0,c.localize)(1,null);let d;return v<t?(d=v,E?d===1?C?(0,c.localize)(2,null,d):(0,c.localize)(3,null,d):C?(0,c.localize)(4,null,d):(0,c.localize)(5,null,d):d===1?C?(0,c.localize)(6,null,d):(0,c.localize)(7,null,d):C?(0,c.localize)(8,null,d):(0,c.localize)(9,null,d)):v<k?(d=Math.floor(v/t),E?d===1?C?(0,c.localize)(10,null,d):(0,c.localize)(11,null,d):C?(0,c.localize)(12,null,d):(0,c.localize)(13,null,d):d===1?C?(0,c.localize)(14,null,d):(0,c.localize)(15,null,d):C?(0,c.localize)(16,null,d):(0,c.localize)(17,null,d)):v<A?(d=Math.floor(v/k),E?d===1?C?(0,c.localize)(18,null,d):(0,c.localize)(19,null,d):C?(0,c.localize)(20,null,d):(0,c.localize)(21,null,d):d===1?C?(0,c.localize)(22,null,d):(0,c.localize)(23,null,d):C?(0,c.localize)(24,null,d):(0,c.localize)(25,null,d)):v<D?(d=Math.floor(v/A),E?d===1?(0,c.localize)(26,null,d):(0,c.localize)(27,null,d):d===1?(0,c.localize)(28,null,d):(0,c.localize)(29,null,d)):v<T?(d=Math.floor(v/D),E?d===1?C?(0,c.localize)(30,null,d):(0,c.localize)(31,null,d):C?(0,c.localize)(32,null,d):(0,c.localize)(33,null,d):d===1?C?(0,c.localize)(34,null,d):(0,c.localize)(35,null,d):C?(0,c.localize)(36,null,d):(0,c.localize)(37,null,d)):v<S?(d=Math.floor(v/T),E?d===1?C?(0,c.localize)(38,null,d):(0,c.localize)(39,null,d):C?(0,c.localize)(40,null,d):(0,c.localize)(41,null,d):d===1?C?(0,c.localize)(42,null,d):(0,c.localize)(43,null,d):C?(0,c.localize)(44,null,d):(0,c.localize)(45,null,d)):(d=Math.floor(v/S),E?d===1?C?(0,c.localize)(46,null,d):(0,c.localize)(47,null,d):C?(0,c.localize)(48,null,d):(0,c.localize)(49,null,d):d===1?C?(0,c.localize)(50,null,d):(0,c.localize)(51,null,d):C?(0,c.localize)(52,null,d):(0,c.localize)(53,null,d))}e.fromNow=y;function R(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Se[156],ye([19,20]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Se[51],ye([1,0,17,11,156]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(P,E){return E&&(P.stack||P.stacktrace)?k.localize(0,null,T(P),D(P.stack)||D(P.stacktrace)):T(P)}function D(P){return Array.isArray(P)?P.join(`
`):P}function T(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function S(P=null,E=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const C=c.coalesce(P),v=S(C[0],E);return C.length>1?k.localize(4,null,v,C.length):v}if(t.isString(P))return P;if(P.detail){const C=P.detail;if(C.error)return A(C.error,E);if(C.exception)return A(C.exception,E)}return P.stack?A(P,E):P.message?P.message:k.localize(5,null)}e.toErrorMessage=S;function y(P){const E=P;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=y;function R(P,E){let C;return typeof P=="string"?C=new Error(P):C=P,C.actions=E,C}e.createErrorWithActions=R}),define(Se[157],ye([19,20]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(Se[12],ye([1,0,157]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,A=!1,D=!1,T=!1,S=!1,y=!1,R=!1,P=!1,E=!1,C,v=e.LANGUAGE_DEFAULT,d,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?m=e.globals.vscode.process:typeof process<"u"&&(m=process);const w=typeof m?.versions?.electron=="string",f=w&&m?.type==="renderer";if(typeof navigator=="object"&&!f)g=navigator.userAgent,t=g.indexOf("Windows")>=0,k=g.indexOf("Macintosh")>=0,R=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,E=g?.indexOf("Mobi")>=0,S=!0,C=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,v=C;else if(typeof m=="object"){t=m.platform==="win32",k=m.platform==="darwin",A=m.platform==="linux",D=A&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,y=w,P=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT;const n=m.env.VSCODE_NLS_CONFIG;if(n)try{const o=JSON.parse(n),p=o.availableLanguages["*"];C=o.locale,v=p||e.LANGUAGE_DEFAULT,d=o._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var h;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let s=0;k?s=1:t?s=3:A&&(s=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=A,e.isLinuxSnap=D,e.isNative=T,e.isElectron=y,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isMobile=E,e.isCI=P,e.platform=s,e.userAgent=g,e.language=v;var i;(function(n){function o(){return e.language}n.value=o;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=p;function I(){return e.language==="en"}n.isDefault=I})(i=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let I=0,L=n.length;I<L;I++){const z=n[I];if(z.id===p.data.vscodeScheduleAsyncWork){n.splice(I,1),z.callback();return}}});let o=0;return p=>{const I=++o;n.push({id:I,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return n=>setTimeout(n)})();var l;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||R?2:t?1:3;let u=!0,r=!1;function a(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,u=new Uint16Array(n.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Se[36],ye([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const k=c.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Se[9],ye([1,0,36]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,A=90,D=122,T=46,S=47,y=92,R=58,P=63;class E extends Error{constructor(h,b,s){let i;typeof b=="string"&&b.indexOf("not ")===0?(i="must not be",b=b.replace(/^not /,"")):i="must be";const l=h.indexOf(".")!==-1?"property":"argument";let u=`The "${h}" ${l} ${i} of type ${b}`;u+=`. Received type ${typeof s}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function C(f,h){if(typeof f!="string")throw new E(h,"string",f)}function v(f){return f===S||f===y}function d(f){return f===S}function g(f){return f>=t&&f<=A||f>=k&&f<=D}function m(f,h,b,s){let i="",l=0,u=-1,r=0,a=0;for(let n=0;n<=f.length;++n){if(n<f.length)a=f.charCodeAt(n);else{if(s(a))break;a=S}if(s(a)){if(!(u===n-1||r===1))if(r===2){if(i.length<2||l!==2||i.charCodeAt(i.length-1)!==T||i.charCodeAt(i.length-2)!==T){if(i.length>2){const o=i.lastIndexOf(b);o===-1?(i="",l=0):(i=i.slice(0,o),l=i.length-1-i.lastIndexOf(b)),u=n,r=0;continue}else if(i.length!==0){i="",l=0,u=n,r=0;continue}}h&&(i+=i.length>0?`${b}..`:"..",l=2)}else i.length>0?i+=`${b}${f.slice(u+1,n)}`:i=f.slice(u+1,n),l=n-u-1;u=n,r=0}else a===T&&r!==-1?++r:r=-1}return i}function w(f,h){if(h===null||typeof h!="object")throw new E("pathObject","Object",h);const b=h.dir||h.root,s=h.base||`${h.name||""}${h.ext||""}`;return b?b===h.root?`${b}${s}`:`${b}${f}${s}`:s}e.win32={resolve(...f){let h="",b="",s=!1;for(let i=f.length-1;i>=-1;i--){let l;if(i>=0){if(l=f[i],C(l,"path"),l.length===0)continue}else h.length===0?l=c.cwd():(l=c.env[`=${h}`]||c.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==h.toLowerCase()&&l.charCodeAt(2)===y)&&(l=`${h}\\`));const u=l.length;let r=0,a="",n=!1;const o=l.charCodeAt(0);if(u===1)v(o)&&(r=1,n=!0);else if(v(o))if(n=!0,v(l.charCodeAt(1))){let p=2,I=p;for(;p<u&&!v(l.charCodeAt(p));)p++;if(p<u&&p!==I){const L=l.slice(I,p);for(I=p;p<u&&v(l.charCodeAt(p));)p++;if(p<u&&p!==I){for(I=p;p<u&&!v(l.charCodeAt(p));)p++;(p===u||p!==I)&&(a=`\\\\${L}\\${l.slice(I,p)}`,r=p)}}}else r=1;else g(o)&&l.charCodeAt(1)===R&&(a=l.slice(0,2),r=2,u>2&&v(l.charCodeAt(2))&&(n=!0,r=3));if(a.length>0)if(h.length>0){if(a.toLowerCase()!==h.toLowerCase())continue}else h=a;if(s){if(h.length>0)break}else if(b=`${l.slice(r)}\\${b}`,s=n,n&&h.length>0)break}return b=m(b,!s,"\\",v),s?`${h}\\${b}`:`${h}${b}`||"."},normalize(f){C(f,"path");const h=f.length;if(h===0)return".";let b=0,s,i=!1;const l=f.charCodeAt(0);if(h===1)return d(l)?"\\":f;if(v(l))if(i=!0,v(f.charCodeAt(1))){let r=2,a=r;for(;r<h&&!v(f.charCodeAt(r));)r++;if(r<h&&r!==a){const n=f.slice(a,r);for(a=r;r<h&&v(f.charCodeAt(r));)r++;if(r<h&&r!==a){for(a=r;r<h&&!v(f.charCodeAt(r));)r++;if(r===h)return`\\\\${n}\\${f.slice(a)}\\`;r!==a&&(s=`\\\\${n}\\${f.slice(a,r)}`,b=r)}}}else b=1;else g(l)&&f.charCodeAt(1)===R&&(s=f.slice(0,2),b=2,h>2&&v(f.charCodeAt(2))&&(i=!0,b=3));let u=b<h?m(f.slice(b),!i,"\\",v):"";return u.length===0&&!i&&(u="."),u.length>0&&v(f.charCodeAt(h-1))&&(u+="\\"),s===void 0?i?`\\${u}`:u:i?`${s}\\${u}`:`${s}${u}`},isAbsolute(f){C(f,"path");const h=f.length;if(h===0)return!1;const b=f.charCodeAt(0);return v(b)||h>2&&g(b)&&f.charCodeAt(1)===R&&v(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let h,b;for(let l=0;l<f.length;++l){const u=f[l];C(u,"path"),u.length>0&&(h===void 0?h=b=u:h+=`\\${u}`)}if(h===void 0)return".";let s=!0,i=0;if(typeof b=="string"&&v(b.charCodeAt(0))){++i;const l=b.length;l>1&&v(b.charCodeAt(1))&&(++i,l>2&&(v(b.charCodeAt(2))?++i:s=!1))}if(s){for(;i<h.length&&v(h.charCodeAt(i));)i++;i>=2&&(h=`\\${h.slice(i)}`)}return e.win32.normalize(h)},relative(f,h){if(C(f,"from"),C(h,"to"),f===h)return"";const b=e.win32.resolve(f),s=e.win32.resolve(h);if(b===s||(f=b.toLowerCase(),h=s.toLowerCase(),f===h))return"";let i=0;for(;i<f.length&&f.charCodeAt(i)===y;)i++;let l=f.length;for(;l-1>i&&f.charCodeAt(l-1)===y;)l--;const u=l-i;let r=0;for(;r<h.length&&h.charCodeAt(r)===y;)r++;let a=h.length;for(;a-1>r&&h.charCodeAt(a-1)===y;)a--;const n=a-r,o=u<n?u:n;let p=-1,I=0;for(;I<o;I++){const z=f.charCodeAt(i+I);if(z!==h.charCodeAt(r+I))break;z===y&&(p=I)}if(I!==o){if(p===-1)return s}else{if(n>o){if(h.charCodeAt(r+I)===y)return s.slice(r+I+1);if(I===2)return s.slice(r+I)}u>o&&(f.charCodeAt(i+I)===y?p=I:I===2&&(p=3)),p===-1&&(p=0)}let L="";for(I=i+p+1;I<=l;++I)(I===l||f.charCodeAt(I)===y)&&(L+=L.length===0?"..":"\\..");return r+=p,L.length>0?`${L}${s.slice(r,a)}`:(s.charCodeAt(r)===y&&++r,s.slice(r,a))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const h=e.win32.resolve(f);if(h.length<=2)return f;if(h.charCodeAt(0)===y){if(h.charCodeAt(1)===y){const b=h.charCodeAt(2);if(b!==P&&b!==T)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(g(h.charCodeAt(0))&&h.charCodeAt(1)===R&&h.charCodeAt(2)===y)return`\\\\?\\${h}`;return f},dirname(f){C(f,"path");const h=f.length;if(h===0)return".";let b=-1,s=0;const i=f.charCodeAt(0);if(h===1)return v(i)?f:".";if(v(i)){if(b=s=1,v(f.charCodeAt(1))){let r=2,a=r;for(;r<h&&!v(f.charCodeAt(r));)r++;if(r<h&&r!==a){for(a=r;r<h&&v(f.charCodeAt(r));)r++;if(r<h&&r!==a){for(a=r;r<h&&!v(f.charCodeAt(r));)r++;if(r===h)return f;r!==a&&(b=s=r+1)}}}}else g(i)&&f.charCodeAt(1)===R&&(b=h>2&&v(f.charCodeAt(2))?3:2,s=b);let l=-1,u=!0;for(let r=h-1;r>=s;--r)if(v(f.charCodeAt(r))){if(!u){l=r;break}}else u=!1;if(l===-1){if(b===-1)return".";l=b}return f.slice(0,l)},basename(f,h){h!==void 0&&C(h,"ext"),C(f,"path");let b=0,s=-1,i=!0,l;if(f.length>=2&&g(f.charCodeAt(0))&&f.charCodeAt(1)===R&&(b=2),h!==void 0&&h.length>0&&h.length<=f.length){if(h===f)return"";let u=h.length-1,r=-1;for(l=f.length-1;l>=b;--l){const a=f.charCodeAt(l);if(v(a)){if(!i){b=l+1;break}}else r===-1&&(i=!1,r=l+1),u>=0&&(a===h.charCodeAt(u)?--u===-1&&(s=l):(u=-1,s=r))}return b===s?s=r:s===-1&&(s=f.length),f.slice(b,s)}for(l=f.length-1;l>=b;--l)if(v(f.charCodeAt(l))){if(!i){b=l+1;break}}else s===-1&&(i=!1,s=l+1);return s===-1?"":f.slice(b,s)},extname(f){C(f,"path");let h=0,b=-1,s=0,i=-1,l=!0,u=0;f.length>=2&&f.charCodeAt(1)===R&&g(f.charCodeAt(0))&&(h=s=2);for(let r=f.length-1;r>=h;--r){const a=f.charCodeAt(r);if(v(a)){if(!l){s=r+1;break}continue}i===-1&&(l=!1,i=r+1),a===T?b===-1?b=r:u!==1&&(u=1):b!==-1&&(u=-1)}return b===-1||i===-1||u===0||u===1&&b===i-1&&b===s+1?"":f.slice(b,i)},format:w.bind(null,"\\"),parse(f){C(f,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return h;const b=f.length;let s=0,i=f.charCodeAt(0);if(b===1)return v(i)?(h.root=h.dir=f,h):(h.base=h.name=f,h);if(v(i)){if(s=1,v(f.charCodeAt(1))){let p=2,I=p;for(;p<b&&!v(f.charCodeAt(p));)p++;if(p<b&&p!==I){for(I=p;p<b&&v(f.charCodeAt(p));)p++;if(p<b&&p!==I){for(I=p;p<b&&!v(f.charCodeAt(p));)p++;p===b?s=p:p!==I&&(s=p+1)}}}}else if(g(i)&&f.charCodeAt(1)===R){if(b<=2)return h.root=h.dir=f,h;if(s=2,v(f.charCodeAt(2))){if(b===3)return h.root=h.dir=f,h;s=3}}s>0&&(h.root=f.slice(0,s));let l=-1,u=s,r=-1,a=!0,n=f.length-1,o=0;for(;n>=s;--n){if(i=f.charCodeAt(n),v(i)){if(!a){u=n+1;break}continue}r===-1&&(a=!1,r=n+1),i===T?l===-1?l=n:o!==1&&(o=1):l!==-1&&(o=-1)}return r!==-1&&(l===-1||o===0||o===1&&l===r-1&&l===u+1?h.base=h.name=f.slice(u,r):(h.name=f.slice(u,l),h.base=f.slice(u,r),h.ext=f.slice(l,r))),u>0&&u!==s?h.dir=f.slice(0,u-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let h="",b=!1;for(let s=f.length-1;s>=-1&&!b;s--){const i=s>=0?f[s]:c.cwd();C(i,"path"),i.length!==0&&(h=`${i}/${h}`,b=i.charCodeAt(0)===S)}return h=m(h,!b,"/",d),b?`/${h}`:h.length>0?h:"."},normalize(f){if(C(f,"path"),f.length===0)return".";const h=f.charCodeAt(0)===S,b=f.charCodeAt(f.length-1)===S;return f=m(f,!h,"/",d),f.length===0?h?"/":b?"./":".":(b&&(f+="/"),h?`/${f}`:f)},isAbsolute(f){return C(f,"path"),f.length>0&&f.charCodeAt(0)===S},join(...f){if(f.length===0)return".";let h;for(let b=0;b<f.length;++b){const s=f[b];C(s,"path"),s.length>0&&(h===void 0?h=s:h+=`/${s}`)}return h===void 0?".":e.posix.normalize(h)},relative(f,h){if(C(f,"from"),C(h,"to"),f===h||(f=e.posix.resolve(f),h=e.posix.resolve(h),f===h))return"";const b=1,s=f.length,i=s-b,l=1,u=h.length-l,r=i<u?i:u;let a=-1,n=0;for(;n<r;n++){const p=f.charCodeAt(b+n);if(p!==h.charCodeAt(l+n))break;p===S&&(a=n)}if(n===r)if(u>r){if(h.charCodeAt(l+n)===S)return h.slice(l+n+1);if(n===0)return h.slice(l+n)}else i>r&&(f.charCodeAt(b+n)===S?a=n:n===0&&(a=0));let o="";for(n=b+a+1;n<=s;++n)(n===s||f.charCodeAt(n)===S)&&(o+=o.length===0?"..":"/..");return`${o}${h.slice(l+a)}`},toNamespacedPath(f){return f},dirname(f){if(C(f,"path"),f.length===0)return".";const h=f.charCodeAt(0)===S;let b=-1,s=!0;for(let i=f.length-1;i>=1;--i)if(f.charCodeAt(i)===S){if(!s){b=i;break}}else s=!1;return b===-1?h?"/":".":h&&b===1?"//":f.slice(0,b)},basename(f,h){h!==void 0&&C(h,"ext"),C(f,"path");let b=0,s=-1,i=!0,l;if(h!==void 0&&h.length>0&&h.length<=f.length){if(h===f)return"";let u=h.length-1,r=-1;for(l=f.length-1;l>=0;--l){const a=f.charCodeAt(l);if(a===S){if(!i){b=l+1;break}}else r===-1&&(i=!1,r=l+1),u>=0&&(a===h.charCodeAt(u)?--u===-1&&(s=l):(u=-1,s=r))}return b===s?s=r:s===-1&&(s=f.length),f.slice(b,s)}for(l=f.length-1;l>=0;--l)if(f.charCodeAt(l)===S){if(!i){b=l+1;break}}else s===-1&&(i=!1,s=l+1);return s===-1?"":f.slice(b,s)},extname(f){C(f,"path");let h=-1,b=0,s=-1,i=!0,l=0;for(let u=f.length-1;u>=0;--u){const r=f.charCodeAt(u);if(r===S){if(!i){b=u+1;break}continue}s===-1&&(i=!1,s=u+1),r===T?h===-1?h=u:l!==1&&(l=1):h!==-1&&(l=-1)}return h===-1||s===-1||l===0||l===1&&h===s-1&&h===b+1?"":f.slice(h,s)},format:w.bind(null,"/"),parse(f){C(f,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return h;const b=f.charCodeAt(0)===S;let s;b?(h.root="/",s=1):s=0;let i=-1,l=0,u=-1,r=!0,a=f.length-1,n=0;for(;a>=s;--a){const o=f.charCodeAt(a);if(o===S){if(!r){l=a+1;break}continue}u===-1&&(r=!1,u=a+1),o===T?i===-1?i=a:n!==1&&(n=1):i!==-1&&(n=-1)}if(u!==-1){const o=l===0&&b?1:l;i===-1||n===0||n===1&&i===u-1&&i===l+1?h.base=h.name=f.slice(o,u):(h.name=f.slice(o,i),h.base=f.slice(o,u),h.ext=f.slice(i,u))}return l>0?h.dir=f.slice(0,l-1):b&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=c.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=c.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=c.platform==="win32"?e.win32.join:e.posix.join,e.resolve=c.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=c.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=c.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=c.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=c.platform==="win32"?e.win32.extname:e.posix.extname,e.format=c.platform==="win32"?e.win32.format:e.posix.format,e.parse=c.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=c.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=c.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=c.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Se[83],ye([1,0,9]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const P=(0,c.extname)(R),E=t[P.toLowerCase()];return E!==void 0?E:D(R)}e.getMediaOrTextMime=A;function D(R){const P=(0,c.extname)(R);return k[P.toLowerCase()]}e.getMediaMime=D;function T(R){for(const P in k)if(k[P]===R)return P}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function y(R,P){const E=S.exec(R);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:P?void 0:R}e.normalizeMimeType=y}),define(Se[106],ye([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(T,...S){const y=S.reduce((E,C)=>(E[C]=!0,E),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(E=>!y[E]).forEach(E=>{for(let C=0;C<R.length;C++)if(E.search(R[C])!==-1){delete T[E];break}})}e.sanitizeProcessEnvironment=A;function D(T){!T||(delete T.DEBUG,c.isMacintosh&&delete T.DYLD_LIBRARY_PATH,c.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Se[44],ye([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=c.globals.performance&&typeof c.globals.performance.now=="function";class k{static create(D=!0){return new k(D)}constructor(D){this.a=t&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?c.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Se[4],ye([1,0,10,61,6,63,44]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var y;(function(a){a.None=()=>k.Disposable.None;function n(De){if(S){const{onDidAddListener:Re}=De,ze=v.create();let se=0;De.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ze.print()),Re?.()}}}function o(De,Re){return F(De,()=>{},0,void 0,void 0,Re)}a.defer=o;function p(De){return(Re,ze=null,se)=>{let ue=!1,he;return he=De(ee=>{if(!ue)return he?he.dispose():ue=!0,Re.call(ze,ee)},null,se),ue&&he.dispose(),he}}a.once=p;function I(De,Re,ze){return M((se,ue=null,he)=>De(ee=>se.call(ue,Re(ee)),null,he),ze)}a.map=I;function L(De,Re,ze){return M((se,ue=null,he)=>De(ee=>{Re(ee),se.call(ue,ee)},null,he),ze)}a.forEach=L;function z(De,Re,ze){return M((se,ue=null,he)=>De(ee=>Re(ee)&&se.call(ue,ee),null,he),ze)}a.filter=z;function _(De){return De}a.signal=_;function q(...De){return(Re,ze=null,se)=>(0,k.combinedDisposable)(...De.map(ue=>ue(he=>Re.call(ze,he),null,se)))}a.any=q;function N(De,Re,ze,se){let ue=ze;return I(De,he=>(ue=Re(ue,he),ue),se)}a.reduce=N;function M(De,Re){let ze;const se={onWillAddFirstListener(){ze=De(ue.fire,ue)},onDidRemoveLastListener(){ze?.dispose()}};Re||n(se);const ue=new g(se);return Re?.add(ue),ue.event}function F(De,Re,ze=100,se=!1,ue,he){let ee,ae,re,O=0;const $={leakWarningThreshold:ue,onWillAddFirstListener(){ee=De(Q=>{O++,ae=Re(ae,Q),se&&!re&&(G.fire(ae),ae=void 0),clearTimeout(re),re=setTimeout(()=>{const de=ae;ae=void 0,re=void 0,(!se||O>1)&&G.fire(de),O=0},ze)})},onDidRemoveLastListener(){ee.dispose()}};he||n($);const G=new g($);return he?.add(G),G.event}a.debounce=F;function B(De,Re=0,ze){return a.debounce(De,(se,ue)=>se?(se.push(ue),se):[ue],Re,void 0,void 0,ze)}a.accumulate=B;function U(De,Re=(se,ue)=>se===ue,ze){let se=!0,ue;return z(De,he=>{const ee=se||!Re(he,ue);return se=!1,ue=he,ee},ze)}a.latch=U;function H(De,Re,ze){return[a.filter(De,Re,ze),a.filter(De,se=>!Re(se),ze)]}a.split=H;function X(De,Re=!1,ze=[]){let se=ze.slice(),ue=De(ae=>{se?se.push(ae):ee.fire(ae)});const he=()=>{se?.forEach(ae=>ee.fire(ae)),se=null},ee=new g({onWillAddFirstListener(){ue||(ue=De(ae=>ee.fire(ae)))},onDidAddFirstListener(){se&&(Re?setTimeout(he):he())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return ee.event}a.buffer=X;class V{constructor(Re){this.event=Re,this.c=new k.DisposableStore}map(Re){return new V(I(this.event,Re,this.c))}forEach(Re){return new V(L(this.event,Re,this.c))}filter(Re){return new V(z(this.event,Re,this.c))}reduce(Re,ze){return new V(N(this.event,Re,ze,this.c))}latch(){return new V(U(this.event,void 0,this.c))}debounce(Re,ze=100,se=!1,ue){return new V(F(this.event,Re,ze,se,ue,this.c))}on(Re,ze,se){return this.event(Re,ze,se)}once(Re,ze,se){return p(this.event)(Re,ze,se)}dispose(){this.c.dispose()}}function x(De){return new V(De)}a.chain=x;function Y(De,Re,ze=se=>se){const se=(...ae)=>ee.fire(ze(...ae)),ue=()=>De.on(Re,se),he=()=>De.removeListener(Re,se),ee=new g({onWillAddFirstListener:ue,onDidRemoveLastListener:he});return ee.event}a.fromNodeEventEmitter=Y;function J(De,Re,ze=se=>se){const se=(...ae)=>ee.fire(ze(...ae)),ue=()=>De.addEventListener(Re,se),he=()=>De.removeEventListener(Re,se),ee=new g({onWillAddFirstListener:ue,onDidRemoveLastListener:he});return ee.event}a.fromDOMEventEmitter=J;function te(De){return new Promise(Re=>p(De)(Re))}a.toPromise=te;function le(De,Re){return Re(void 0),De(ze=>Re(ze))}a.runAndSubscribe=le;function Z(De,Re){let ze=null;function se(he){ze?.dispose(),ze=new k.DisposableStore,Re(he,ze)}se(void 0);const ue=De(he=>se(he));return(0,k.toDisposable)(()=>{ue.dispose(),ze?.dispose()})}a.runAndSubscribeWithStore=Z;class ge{constructor(Re,ze){this.obs=Re,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Re.addObserver(this)},onDidRemoveLastListener:()=>{Re.removeObserver(this)}};ze||n(se),this.emitter=new g(se),ze&&ze.add(this.emitter)}beginUpdate(Re){this.c++}handleChange(Re,ze){this.d=!0}endUpdate(Re){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function ve(De,Re){return new ge(De,Re).emitter.event}a.fromObservable=ve})(y=e.Event||(e.Event={}));class R{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${R.c++}`,R.all.add(this)}start(n){this.d=new D.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=R,R.all=new Set,R.c=0;let P=-1;function E(a){const n=P;return P=a,{dispose(){P=n}}}e.setGlobalLeakWarningThreshold=E;class C{constructor(n,o=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=o,this.d=0}dispose(){this.c?.clear()}check(n,o){const p=this.threshold;if(p<=0||o<p)return;this.c||(this.c=new Map);const I=this.c.get(n.value)||0;if(this.c.set(n.value,I+1),this.d-=1,this.d<=0){this.d=p*.5;let L,z=0;for(const[_,q]of this.c)(!L||z<q)&&(L=_,z=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${z}):`),console.warn(L)}return()=>{const L=this.c.get(n.value)||0;this.c.set(n.value,L-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(n,o,p){this.callback=n,this.callbackThis=o,this.stack=p,this.subscription=new k.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class g{constructor(n){this.j=!1,this.d=n,this.f=P>0||this.d?.leakWarningThreshold?new C(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new R(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const n=Array.from(this.q);queueMicrotask(()=>{for(const o of n)o.subscription.isset()&&(o.subscription.unset(),o.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,o,p)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const I=this.q.isEmpty();I&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let L,z;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(z=v.create(),L=this.f.check(z,this.q.size+1)),T&&(z=z??v.create());const _=new d(n,o,z),q=this.q.push(_);I&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,o);const N=_.subscription.set(()=>{L?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return p instanceof k.DisposableStore?p.add(N):Array.isArray(p)&&p.push(N),N}),this.l}fire(n){if(this.q){this.m||(this.m=new w);for(const o of this.q)this.m.push(this,o,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=g;class m{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(n,o,p){this.c.push(new f(n,o,p))}clear(n){const o=new A.LinkedList;for(const p of this.c)p.emitter!==n&&o.push(p);this.c=o}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(o){(0,c.onUnexpectedError)(o)}}}}e.EventDeliveryQueue=m;class w extends m{clear(n){this.c.clear()}}class f{constructor(n,o,p){this.emitter=n,this.listener=o,this.event=p}}class h extends g{async fireAsync(n,o,p){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const I of this.q)this.c.push([I,n]);for(;this.c.size>0&&!o.isCancellationRequested;){const[I,L]=this.c.shift(),z=[],_={...L,token:o,waitUntil:q=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");p&&(q=p(q,I.callback)),z.push(q)}};try{I.invoke(_)}catch(q){(0,c.onUnexpectedError)(q);continue}Object.freeze(z),await Promise.allSettled(z).then(q=>{for(const N of q)N.status==="rejected"&&(0,c.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=h;class b extends g{constructor(n){super(n),this.h=0,this.s=new A.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=b;class s extends b{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=s;class i extends g{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(o=>super.fire(o)),this.c=[]}))}}e.MicrotaskEmitter=i;class l{constructor(){this.d=!1,this.f=[],this.c=new g({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const o={event:n,listener:null};this.f.push(o),this.d&&this.j(o);const p=()=>{this.d&&this.k(o);const I=this.f.indexOf(o);this.f.splice(I,1)};return(0,k.toDisposable)((0,t.once)(p))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(o=>this.c.fire(o))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=l;class u{constructor(){this.c=[]}wrapEvent(n){return(o,p,I)=>n(L=>{const z=this.c[this.c.length-1];z?z.push(()=>o.call(p,L)):o.call(p,L)},void 0,I)}bufferEvents(n){const o=[];this.c.push(o);const p=n();return this.c.pop(),o.forEach(I=>I()),p}}e.EventBufferer=u;class r{constructor(){this.c=!1,this.d=y.None,this.f=k.Disposable.None,this.g=new g({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(Se[21],ye([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(T,S){const y=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(y)}}});var k;(function(T){function S(y){return y===T.None||y===T.Cancelled||y instanceof A?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new c.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=k.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=D}),define(Se[158],ye([1,0,21]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new c.CancellationTokenSource,S=this.b(T.token);return this.a={promise:S,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=t;class k{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const S=JSON.stringify(T);return this.b!==S&&(this.b=S,this.a=this.c(T)),this.a}}e.LRUCachedFunction=k;class A{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const S=this.b(T);return this.a.set(T,S),S}}e.CachedFunction=A}),define(Se[8],ye([1,0,158,81]),function(ne,e,c,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=A;const D=/{(\d+)}/g;function T(W,...ce){return ce.length===0?W:W.replace(D,function(Ie,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=ce.length?Ie:ce[Be]})}e.format=T;const S=/{([^}]+)}/g;function y(W,ce){return W.replace(S,(Ie,Le)=>ce[Le]??Ie)}e.format2=y;function R(W){return W.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=R;function P(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function E(W,ce){let Ie=0;const Le=ce.charCodeAt(0);for(let Be=W.length-1;Be>=0;Be--)W.charCodeAt(Be)===Le&&Ie++;return Ie}e.count=E;function C(W,ce,Ie="\u2026"){return W.length<=ce?W:`${W.substr(0,ce)}${Ie}`}e.truncate=C;function v(W,ce=" "){const Ie=d(W,ce);return g(Ie,ce)}e.trim=v;function d(W,ce){if(!W||!ce)return W;const Ie=ce.length;if(Ie===0||W.length===0)return W;let Le=0;for(;W.indexOf(ce,Le)===Le;)Le=Le+Ie;return W.substring(Le)}e.ltrim=d;function g(W,ce){if(!W||!ce)return W;const Ie=ce.length,Le=W.length;if(Ie===0||Le===0)return W;let Be=Le,Xe=-1;for(;Xe=W.lastIndexOf(ce,Be-1),!(Xe===-1||Xe+Ie!==Be);){if(Xe===0)return"";Be=Xe}return W.substring(0,Be)}e.rtrim=g;function m(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function w(W){return W.replace(/\*/g,"")}e.stripWildcards=w;function f(W,ce,Ie={}){if(!W)throw new Error("Cannot create regex from empty string");ce||(W=P(W)),Ie.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp(W,Le)}e.createRegExp=f;function h(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function b(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function s(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=s;function i(W){return W.split(/\r\n|\r|\n/)}e.splitLines=i;function l(W){for(let ce=0,Ie=W.length;ce<Ie;ce++){const Le=W.charCodeAt(ce);if(Le!==32&&Le!==9)return ce}return-1}e.firstNonWhitespaceIndex=l;function u(W,ce=0,Ie=W.length){for(let Le=ce;Le<Ie;Le++){const Be=W.charCodeAt(Le);if(Be!==32&&Be!==9)return W.substring(ce,Le)}return W.substring(ce,Ie)}e.getLeadingWhitespace=u;function r(W,ce=W.length-1){for(let Ie=ce;Ie>=0;Ie--){const Le=W.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=r;function a(W,ce,Ie){const Le=[];let Be=0;for(const Xe of W.matchAll(ce)){if(Le.push(W.slice(Be,Xe.index)),Xe.index===void 0)throw new Error("match.index should be defined");Be=Xe.index+Xe[0].length,Le.push(Ie(Xe[0],...Xe.slice(1),Xe.index,W,Xe.groups))}return Le.push(W.slice(Be)),Promise.all(Le).then(Xe=>Xe.join(""))}e.replaceAsync=a;function n(W,ce){return W<ce?-1:W>ce?1:0}e.compare=n;function o(W,ce,Ie=0,Le=W.length,Be=0,Xe=ce.length){for(;Ie<Le&&Be<Xe;Ie++,Be++){const ft=W.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(ft<lt)return-1;if(ft>lt)return 1}const Ze=Le-Ie,mt=Xe-Be;return Ze<mt?-1:Ze>mt?1:0}e.compareSubstring=o;function p(W,ce){return I(W,ce,0,W.length,0,ce.length)}e.compareIgnoreCase=p;function I(W,ce,Ie=0,Le=W.length,Be=0,Xe=ce.length){for(;Ie<Le&&Be<Xe;Ie++,Be++){let ft=W.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(ft===lt)continue;if(ft>=128||lt>=128)return o(W.toLowerCase(),ce.toLowerCase(),Ie,Le,Be,Xe);z(ft)&&(ft-=32),z(lt)&&(lt-=32);const ot=ft-lt;if(ot!==0)return ot}const Ze=Le-Ie,mt=Xe-Be;return Ze<mt?-1:Ze>mt?1:0}e.compareSubstringIgnoreCase=I;function L(W){return W>=48&&W<=57}e.isAsciiDigit=L;function z(W){return W>=97&&W<=122}e.isLowerAsciiLetter=z;function _(W){return W>=65&&W<=90}e.isUpperAsciiLetter=_;function q(W,ce){return W.length===ce.length&&I(W,ce)===0}e.equalsIgnoreCase=q;function N(W,ce){const Ie=ce.length;return ce.length>W.length?!1:I(W,ce,0,Ie)===0}e.startsWithIgnoreCase=N;function M(W,ce){const Ie=Math.min(W.length,ce.length);let Le;for(Le=0;Le<Ie;Le++)if(W.charCodeAt(Le)!==ce.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=M;function F(W,ce){const Ie=Math.min(W.length,ce.length);let Le;const Be=W.length-1,Xe=ce.length-1;for(Le=0;Le<Ie;Le++)if(W.charCodeAt(Be-Le)!==ce.charCodeAt(Xe-Le))return Le;return Ie}e.commonSuffixLength=F;function B(W){return 55296<=W&&W<=56319}e.isHighSurrogate=B;function U(W){return 56320<=W&&W<=57343}e.isLowSurrogate=U;function H(W,ce){return(W-55296<<10)+(ce-56320)+65536}e.computeCodePoint=H;function X(W,ce,Ie){const Le=W.charCodeAt(Ie);if(B(Le)&&Ie+1<ce){const Be=W.charCodeAt(Ie+1);if(U(Be))return H(Le,Be)}return Le}e.getNextCodePoint=X;function V(W,ce){const Ie=W.charCodeAt(ce-1);if(U(Ie)&&ce>1){const Le=W.charCodeAt(ce-2);if(B(Le))return H(Le,Ie)}return Ie}class x{get offset(){return this.e}constructor(ce,Ie=0){this.c=ce,this.d=ce.length,this.e=Ie}setOffset(ce){this.e=ce}prevCodePoint(){const ce=V(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=X(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=x;class Y{get offset(){return this.c.offset}constructor(ce,Ie=0){this.c=new x(ce,Ie)}nextGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const Xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.nextCodePoint());if(je(Be,Ze)){Ie.setOffset(Xe);break}Be=Ze}return Ie.offset-Le}prevGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const Xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.prevCodePoint());if(je(Ze,Be)){Ie.setOffset(Xe);break}Be=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Y;function J(W,ce){return new Y(W,ce).nextGraphemeLength()}e.nextCharLength=J;function te(W,ce){return new Y(W,ce).prevGraphemeLength()}e.prevCharLength=te;function le(W,ce){ce>0&&U(W.charCodeAt(ce))&&ce--;const Ie=ce+J(W,ce);return[Ie-te(W,Ie),Ie]}e.getCharContainingOffset=le;function Z(W){const ce=new Y(W);let Ie=0;for(;!ce.eol();)Ie++,ce.nextGraphemeLength();return Ie}e.charCount=Z;let ge;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De(W){return ge||(ge=ve()),ge.test(W)}e.containsRTL=De;const Re=/^[\t\n\r\x20-\x7E]*$/;function ze(W){return Re.test(W)}e.isBasicASCII=ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=se;function ue(W){return W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=ue;function he(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129008||W>=129280&&W<=129535||W>=129648&&W<=129782}e.isEmojiImprecise=he;function ee(W,ce){if(W.length<ce)return W;const Ie=/\b/g;let Le=0;for(;Ie.test(W)&&!(W.length-Ie.lastIndex<ce);)Le=Ie.lastIndex,Ie.lastIndex+=1;return W.substring(Le).replace(/^\s/,"")}e.lcut=ee;const ae=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function $(W){return W&&(W=W.replace(ae,""),W=W.replace(re,""),W=W.replace(O,"")),W}e.removeAnsiEscapeCodes=$,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=G;function Q(W){return G(W)?W.substr(1):W}e.stripUTF8BOM=Q;function de(W,ce){if(!W||!ce||W.length<ce.length)return!1;const Ie=ce.length,Le=W.toLowerCase();let Be=0,Xe=-1;for(;Be<Ie;){const Ze=Le.indexOf(ce[Be],Xe+1);if(Ze<0)return!1;Xe=Ze,Be++}return!0}e.fuzzyContains=de;function be(W,ce=!1){return W?(ce&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=be;function Pe(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=Pe;function pe(W,ce=1){if(ce===0)return"";let Ie=-1;do Ie=W.indexOf(`
`,Ie+1),ce--;while(ce>0&&Ie>=0);return Ie===-1?W:(W[Ie-1]==="\r"&&Ie--,W.substr(0,Ie))}e.getNLines=pe;function Ce(W){return W=W%(2*26),W<26?String.fromCharCode(97+W):String.fromCharCode(65+W-26)}e.singleLetterHash=Ce;function ke(W){return et.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ke;function je(W,ce){return W===0?ce!==5&&ce!==7:W===2&&ce===3?!1:W===4||W===2||W===3||ce===4||ce===2||ce===3?!0:!(W===8&&(ce===8||ce===9||ce===11||ce===12)||(W===11||W===9)&&(ce===9||ce===10)||(W===12||W===10)&&ce===10||ce===5||ce===13||ce===7||W===1||W===13&&ce===14||W===6&&ce===6)}var Ge;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=_e()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const Ie=this.d,Le=Ie.length/3;let Be=1;for(;Be<=Le;)if(ce<Ie[3*Be])Be=2*Be;else if(ce>Ie[3*Be+1])Be=2*Be+1;else return Ie[3*Be+2];return 0}}et.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(W,ce){if(W===0)return 0;const Ie=st(W,ce);if(Ie!==void 0)return Ie;const Le=new x(ce,W);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st(W,ce){const Ie=new x(ce,W);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!he(Le))return;let Be=Ie.offset;return Be>0&&Ie.prevCodePoint()===8205&&(Be=Ie.offset),Be}function ht(W){return 127995<=W&&W<=127999}var Me;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class it{static getInstance(ce){return it.d.get(Array.from(ce))}static getLocales(){return it.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,k=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new c.LRUCachedFunction(W=>{function ce(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function Ie(lt,ot){const rt=new Map(lt);for(const[At,Rt]of ot)rt.set(At,Rt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[At,Rt]of lt)ot.has(At)&&rt.set(At,Rt);return rt}const Be=k.c.getValue();let Xe=W.filter(lt=>!lt.startsWith("_")&&lt in Be);Xe.length===0&&(Xe=["_default"]);let Ze;for(const lt of Xe){const ot=ce(Be[lt]);Ze=Le(Ze,ot)}const mt=ce(Be._common),ft=Ie(mt,Ze);return new it(ft)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter(W=>!W.startsWith("_")));class oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(oe.c())),this.d}static isInvisibleCharacter(ce){return oe.e().has(ce)}static get codePoints(){return oe.e()}}e.InvisibleCharacters=oe,oe.d=void 0}),define(Se[32],ye([1,0,9,12,8,11]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function T(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=T;function S(r){return r.indexOf("/")===-1&&(r=T(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function y(r,a=c.posix.sep){if(!r)return"";const n=r.length,o=r.charCodeAt(0);if(D(o)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let I=3;const L=I;for(;I<n&&!D(r.charCodeAt(I));I++);if(L!==I&&!D(r.charCodeAt(I+1))){for(I+=1;I<n;I++)if(D(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,a)}}return a}else if(m(o)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<n;p++)if(D(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=y;function R(r){if(!t.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let n=2;const o=n;for(;n<r.length&&(a=r.charCodeAt(n),a!==92);n++);return!(o===n||(a=r.charCodeAt(n+1),isNaN(a)||a===92))}e.isUNC=R;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(r,a=t.isWindows){const n=a?P:E;return!(!r||r.length===0||/^\s+$/.test(r)||(n.lastIndex=0,n.test(r))||a&&C.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=v;function d(r,a,n){const o=r===a;return!n||o?o:!r||!a?!1:(0,k.equalsIgnoreCase)(r,a)}e.isEqual=d;function g(r,a,n,o=c.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(n){if(!(0,k.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let I=a.length;return a.charAt(a.length-1)===o&&I--,r.charAt(I)===o}return a.charAt(a.length-1)!==o&&(a+=o),r.indexOf(a)===0}e.isEqualOrParent=g;function m(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=m;function w(r,a){return t.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(a,r)),r=(0,c.normalize)(r),t.isWindows?(r=(0,k.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,k.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=w;function f(r){const a=(0,c.normalize)(r);return t.isWindows?r.length>3?!1:h(a)&&(r.length===2||a.charCodeAt(2)===92):a===c.posix.sep}e.isRootOrDriveLetter=f;function h(r,a=t.isWindows){return a?m(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function b(r){return h(r)?r[0]:void 0}e.getDriveLetter=b;function s(r,a,n){return a.length>r.length?-1:r===a?0:(n&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=s;function i(r){const a=r.split(":");let n,o,p;for(const I of a){const L=Number(I);(0,A.isNumber)(L)?o===void 0?o=L:p===void 0&&(p=L):n=n?[n,I].join(":"):I}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:o!==void 0?o:void 0,column:p!==void 0?p:o!==void 0?1:void 0}}e.parseLineAndColumnAware=i;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(r,a,n=8){let o="";for(let I=0;I<n;I++)o+=l.charAt(Math.floor(Math.random()*l.length));let p;return a?p=`${a}-${o}`:p=o,r?(0,c.join)(r,p):p}e.randomPath=u}),define(Se[107],ye([1,0,28,8]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...re){return function(O,$){for(let G=0,Q=re.length;G<Q;G++){const de=re[G](O,$);if(de)return de}return null}}e.or=k,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(re,O,$){if(!$||$.length<O.length)return null;let G;return re?G=t.startsWithIgnoreCase($,O):G=$.indexOf(O)===0,G?O.length>0?[{start:0,end:O.length}]:[]:null}function D(re,O){const $=O.toLowerCase().indexOf(re.toLowerCase());return $===-1?null:[{start:$,end:$+re.length}]}e.matchesContiguousSubString=D;function T(re,O){return S(re.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=T;function S(re,O,$,G){if($===re.length)return[];if(G===O.length)return null;if(re[$]===O[G]){let Q=null;return(Q=S(re,O,$+1,G+1))?m({start:G,end:G+1},Q):null}return S(re,O,$,G+1)}function y(re){return 97<=re&&re<=122}function R(re){return 65<=re&&re<=90}e.isUpper=R;function P(re){return 48<=re&&re<=57}function E(re){return re===32||re===9||re===10||re===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>C.add(re.charCodeAt(0)));function v(re){return E(re)||C.has(re)}function d(re,O){return re===O||v(re)&&v(O)}function g(re){return y(re)||R(re)||P(re)}function m(re,O){return O.length===0?O=[re]:re.end===O[0].start?O[0].start=re.start:O.unshift(re),O}function w(re,O){for(let $=O;$<re.length;$++){const G=re.charCodeAt($);if(R(G)||P(G)||$>0&&!g(re.charCodeAt($-1)))return $}return re.length}function f(re,O,$,G){if($===re.length)return[];if(G===O.length)return null;if(re[$]!==O[G].toLowerCase())return null;{let Q=null,de=G+1;for(Q=f(re,O,$+1,G+1);!Q&&(de=w(O,de))<O.length;)Q=f(re,O,$+1,de),de++;return Q===null?null:m({start:G,end:G+1},Q)}}function h(re){let O=0,$=0,G=0,Q=0,de=0;for(let ke=0;ke<re.length;ke++)de=re.charCodeAt(ke),R(de)&&O++,y(de)&&$++,g(de)&&G++,P(de)&&Q++;const be=O/re.length,Pe=$/re.length,pe=G/re.length,Ce=Q/re.length;return{upperPercent:be,lowerPercent:Pe,alphaPercent:pe,numericPercent:Ce}}function b(re){const{upperPercent:O,lowerPercent:$}=re;return $===0&&O>.6}function s(re){const{upperPercent:O,lowerPercent:$,alphaPercent:G,numericPercent:Q}=re;return $>.2&&O<.8&&G>.6&&Q<.2}function i(re){let O=0,$=0,G=0,Q=0;for(let de=0;de<re.length;de++)G=re.charCodeAt(de),R(G)&&O++,y(G)&&$++,E(G)&&Q++;return(O===0||$===0)&&Q===0?re.length<=30:O<=5}function l(re,O){if(!O||(O=O.trim(),O.length===0)||!i(re)||O.length>60)return null;const $=h(O);if(!s($)){if(!b($))return null;O=O.toLowerCase()}let G=null,Q=0;for(re=re.toLowerCase();Q<O.length&&(G=f(re,O,0,Q))===null;)Q=w(O,Q+1);return G}e.matchesCamelCase=l;function u(re,O,$=!1){if(!O||O.length===0)return null;let G=null,Q=0;for(re=re.toLowerCase(),O=O.toLowerCase();Q<O.length&&(G=r(re,O,0,Q,$))===null;)Q=a(O,Q+1);return G}e.matchesWords=u;function r(re,O,$,G,Q){if($===re.length)return[];if(G===O.length)return null;if(d(re.charCodeAt($),O.charCodeAt(G))){let de=null,be=G+1;if(de=r(re,O,$+1,G+1,Q),!Q)for(;!de&&(be=a(O,be))<O.length;)de=r(re,O,$+1,be,Q),be++;return de?re.charCodeAt($)!==O.charCodeAt(G)?de:m({start:G,end:G+1},de):null}else return null}function a(re,O){for(let $=O;$<re.length;$++)if(v(re.charCodeAt($))||$>0&&v(re.charCodeAt($-1)))return $;return re.length}const n=k(e.matchesPrefix,l,D),o=k(e.matchesPrefix,l,T),p=new c.LRUCache(1e4);function I(re,O,$=!1){if(typeof re!="string"||typeof O!="string")return null;let G=p.get(re);G||(G=new RegExp(t.convertSimple2RegExpPattern(re),"i"),p.set(re,G));const Q=G.exec(O);return Q?[{start:Q.index,end:Q.index+Q[0].length}]:$?o(re,O):n(re,O)}e.matchesFuzzy=I;function L(re,O){const $=Re(re,re.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?_($):null}e.matchesFuzzy2=L;function z(re,O,$,G,Q,de){const be=Math.min(13,re.length);for(;$<be;$++){const Pe=Re(re,O,$,G,Q,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Pe)return Pe}return[0,de]}e.anyScore=z;function _(re){if(typeof re>"u")return[];const O=[],$=re[1];for(let G=re.length-1;G>1;G--){const Q=re[G]+$,de=O[O.length-1];de&&de.end===Q?de.end=Q+1:O.push({start:Q,end:Q+1})}return O}e.createMatches=_;const q=128;function N(){const re=[],O=[];for(let $=0;$<=q;$++)O[$]=0;for(let $=0;$<=q;$++)re.push(O.slice(0));return re}function M(re){const O=[];for(let $=0;$<=re;$++)O[$]=0;return O}const F=M(2*q),B=M(2*q),U=N(),H=N(),X=N(),V=!1;function x(re,O,$,G,Q){function de(Pe,pe,Ce=" "){for(;Pe.length<pe;)Pe=Ce+Pe;return Pe}let be=` |   |${G.split("").map(Pe=>de(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=$;Pe++)Pe===0?be+=" |":be+=`${O[Pe-1]}|`,be+=re[Pe].slice(0,Q+1).map(pe=>de(pe.toString(),3)).join("|")+`
`;return be}function Y(re,O,$,G){re=re.substr(O),$=$.substr(G),console.log(x(H,re,re.length,$,$.length)),console.log(x(X,re,re.length,$,$.length)),console.log(x(U,re,re.length,$,$.length))}function J(re,O){if(O<0||O>=re.length)return!1;const $=re.codePointAt(O);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise($)}}function te(re,O){if(O<0||O>=re.length)return!1;switch(re.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function le(re,O,$){return O[re]!==$[re]}function Z(re,O,$,G,Q,de,be=!1){for(;O<$&&Q<de;)re[O]===G[Q]&&(be&&(F[O]=Q),O+=1),Q+=1;return O===$}e.isPatternInWord=Z;var ge;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var ve;(function(re){re.Default=[-100,0];function O($){return!$||$.length===2&&$[0]===-100&&$[1]===0}re.isDefault=O})(ve=e.FuzzyScore||(e.FuzzyScore={}));class De{constructor(O,$){this.firstMatchCanBeWeak=O,this.boostFullMatch=$}}e.FuzzyScoreOptions=De,De.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(re,O,$,G,Q,de,be=De.default){const Pe=re.length>q?q:re.length,pe=G.length>q?q:G.length;if($>=Pe||de>=pe||Pe-$>pe-de||!Z(O,$,Pe,Q,de,pe,!0))return;ze(Pe,pe,$,de,O,Q);let Ce=1,ke=1,je=$,Ge=de;const et=[!1];for(Ce=1,je=$;je<Pe;Ce++,je++){const Me=F[je],it=B[je],oe=je+1<Pe?B[je+1]:pe;for(ke=Me-de+1,Ge=Me;Ge<oe;ke++,Ge++){let W=Number.MIN_SAFE_INTEGER,ce=!1;Ge<=it&&(W=se(re,O,je,$,G,Q,Ge,pe,de,U[Ce-1][ke-1]===0,et));let Ie=0;W!==Number.MAX_SAFE_INTEGER&&(ce=!0,Ie=W+H[Ce-1][ke-1]);const Le=Ge>Me,Be=Le?H[Ce][ke-1]+(U[Ce][ke-1]>0?-5:0):0,Xe=Ge>Me+1&&U[Ce][ke-1]>0,Ze=Xe?H[Ce][ke-2]+(U[Ce][ke-2]>0?-5:0):0;if(Xe&&(!Le||Ze>=Be)&&(!ce||Ze>=Ie))H[Ce][ke]=Ze,X[Ce][ke]=3,U[Ce][ke]=0;else if(Le&&(!ce||Be>=Ie))H[Ce][ke]=Be,X[Ce][ke]=2,U[Ce][ke]=0;else if(ce)H[Ce][ke]=Ie,X[Ce][ke]=1,U[Ce][ke]=U[Ce-1][ke-1]+1;else throw new Error("not possible")}}if(V&&Y(re,$,G,de),!et[0]&&!be.firstMatchCanBeWeak)return;Ce--,ke--;const _e=[H[Ce][ke],de];let nt=0,st=0;for(;Ce>=1;){let Me=ke;do{const it=X[Ce][Me];if(it===3)Me=Me-2;else if(it===2)Me=Me-1;else break}while(Me>=1);nt>1&&O[$+Ce-1]===Q[de+ke-1]&&!le(Me+de-1,G,Q)&&nt+1>U[Ce][Me]&&(Me=ke),Me===ke?nt++:nt=1,st||(st=Me),Ce--,ke=Me-1,_e.push(ke)}pe===Pe&&be.boostFullMatch&&(_e[0]+=2);const ht=st-Pe;return _e[0]-=ht,_e}e.fuzzyScore=Re;function ze(re,O,$,G,Q,de){let be=re-1,Pe=O-1;for(;be>=$&&Pe>=G;)Q[be]===de[Pe]&&(B[be]=Pe,be--),Pe--}function se(re,O,$,G,Q,de,be,Pe,pe,Ce,ke){if(O[$]!==de[be])return Number.MIN_SAFE_INTEGER;let je=1,Ge=!1;return be===$-G?je=re[$]===Q[be]?7:5:le(be,Q,de)&&(be===0||!le(be-1,Q,de))?(je=re[$]===Q[be]?7:5,Ge=!0):J(de,be)&&(be===0||!J(de,be-1))?je=5:(J(de,be-1)||te(de,be-1))&&(je=5,Ge=!0),je>1&&$===G&&(ke[0]=!0),Ge||(Ge=le(be,Q,de)||J(de,be-1)||te(de,be-1)),$===G?be>pe&&(je-=Ge?3:5):Ce?je+=Ge?2:0:je+=Ge?0:1,be+1===Pe&&(je-=Ge?3:5),je}function ue(re,O,$,G,Q,de,be){return ee(re,O,$,G,Q,de,!0,be)}e.fuzzyScoreGracefulAggressive=ue;function he(re,O,$,G,Q,de,be){return ee(re,O,$,G,Q,de,!1,be)}e.fuzzyScoreGraceful=he;function ee(re,O,$,G,Q,de,be,Pe){let pe=Re(re,O,$,G,Q,de,Pe);if(pe&&!be)return pe;if(re.length>=3){const Ce=Math.min(7,re.length-1);for(let ke=$+1;ke<Ce;ke++){const je=ae(re,ke);if(je){const Ge=Re(je,je.toLowerCase(),$,G,Q,de,Pe);Ge&&(Ge[0]-=3,(!pe||Ge[0]>pe[0])&&(pe=Ge))}}}return pe}function ae(re,O){if(O+1>=re.length)return;const $=re[O],G=re[O+1];if($!==G)return re.slice(0,O)+G+$+re.slice(O+2)}}),define(Se[84],ye([1,0,8]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return k(m,0)}e.hash=t;function k(m,w){switch(typeof m){case"object":return m===null?A(349,w):Array.isArray(m)?S(m,w):y(m,w);case"string":return T(m,w);case"boolean":return D(m,w);case"number":return A(m,w);case"undefined":return A(937,w);default:return A(617,w)}}e.doHash=k;function A(m,w){return(w<<5)-w+m|0}e.numberHash=A;function D(m,w){return A(m?433:863,w)}function T(m,w){w=A(149417,w);for(let f=0,h=m.length;f<h;f++)w=A(m.charCodeAt(f),w);return w}e.stringHash=T;function S(m,w){return w=A(104579,w),m.reduce((f,h)=>k(h,f),w)}function y(m,w){return w=A(181387,w),Object.keys(m).sort().reduce((f,h)=>(f=T(h,f),k(m[h],f)),w)}class R{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=k(w,this.g),this.g}}e.Hasher=R;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(m,w,f=32){const h=f-w,b=~((1<<h)-1);return(m<<w|(b&m)>>>h)>>>0}function C(m,w=0,f=m.byteLength,h=0){for(let b=0;b<f;b++)m[w+b]=h}function v(m,w,f="0"){for(;m.length<w;)m=f+m;return m}function d(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):v((m>>>0).toString(16),w/4)}e.toHexString=d;class g{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const f=w.length;if(f===0)return;const h=this.p;let b=this.r,s=this.u,i,l;for(s!==0?(i=s,l=-1,s=0):(i=w.charCodeAt(0),l=0);;){let u=i;if(c.isHighSurrogate(i))if(l+1<f){const r=w.charCodeAt(l+1);c.isLowSurrogate(r)?(l++,u=c.computeCodePoint(i,r)):u=65533}else{s=i;break}else c.isLowSurrogate(i)&&(u=65533);if(b=this.w(h,b,u),l++,l<f)i=w.charCodeAt(l);else break}this.r=b,this.u=s}w(w,f,h){return h<128?w[f++]=h:h<2048?(w[f++]=192|(h&1984)>>>6,w[f++]=128|(h&63)>>>0):h<65536?(w[f++]=224|(h&61440)>>>12,w[f++]=128|(h&4032)>>>6,w[f++]=128|(h&63)>>>0):(w[f++]=240|(h&1835008)>>>18,w[f++]=128|(h&258048)>>>12,w[f++]=128|(h&4032)>>>6,w[f++]=128|(h&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,C(this.p,this.r),this.r>56&&(this.y(),C(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=g.g,f=this.q;for(let n=0;n<64;n+=4)w.setUint32(n,f.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)w.setUint32(n,E(w.getUint32(n-12,!1)^w.getUint32(n-32,!1)^w.getUint32(n-56,!1)^w.getUint32(n-64,!1),1),!1);let h=this.h,b=this.l,s=this.m,i=this.n,l=this.o,u,r,a;for(let n=0;n<80;n++)n<20?(u=b&s|~b&i,r=1518500249):n<40?(u=b^s^i,r=1859775393):n<60?(u=b&s|b&i|s&i,r=2400959708):(u=b^s^i,r=3395469782),a=E(h,5)+u+l+r+w.getUint32(n*4,!1)&4294967295,l=i,i=s,s=E(b,30),b=h,h=a;this.h=this.h+h&4294967295,this.l=this.l+b&4294967295,this.m=this.m+s&4294967295,this.n=this.n+i&4294967295,this.o=this.o+l&4294967295}}e.StringSHA1=g,g.g=new DataView(new ArrayBuffer(320))}),define(Se[159],ye([1,0,79,107,8]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",D=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(c.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${D.source}`,"g");function y(m){return m.replace(S,(w,f)=>f?w:`\\${w}`)}e.escapeIcons=y;const R=new RegExp(`\\\\${D.source}`,"g");function P(m){return m.replace(R,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=P;const E=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function C(m){return m.indexOf(A)===-1?m:m.replace(E,(w,f,h,b)=>h?w:f||b||"")}e.stripIcons=C;function v(m){const w=m.indexOf(A);return w===-1?{text:m}:d(m,w)}e.parseLabelWithIcons=v;function d(m,w){const f=[];let h="";function b(o){if(o){h+=o;for(const p of o)f.push(l)}}let s=-1,i="",l=0,u,r,a=w;const n=m.length;for(b(m.substr(0,w));a<n;)u=m[a],r=m[a+1],u===A[0]&&r===A[1]?(s=a,b(i),i=A,a++):u===")"&&s!==-1?(l+=a-s+1,s=-1,i=""):s!==-1?T.test(u)?i+=u:(b(i),s=-1,i=""):b(u),a++;return b(i),{text:h,iconOffsets:f}}function g(m,w,f=!1){const{text:h,iconOffsets:b}=w;if(!b||b.length===0)return(0,t.matchesFuzzy)(m,h,f);const s=(0,k.ltrim)(h," "),i=h.length-s.length,l=(0,t.matchesFuzzy)(m,s,f);if(l)for(const u of l){const r=b[u.start+i]+i;u.start+=r,u.end+=r}return l}e.matchesFuzzyIconAware=g}),define(Se[42],ye([1,0,8]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const A="error",D="warning",T="warn",S="info",y="ignore";function R(E){return E?c.equalsIgnoreCase(A,E)?k.Error:c.equalsIgnoreCase(D,E)||c.equalsIgnoreCase(T,E)?k.Warning:c.equalsIgnoreCase(S,E)?k.Info:k.Ignore:k.Ignore}k.fromValue=R;function P(E){switch(E){case k.Error:return A;case k.Warning:return D;case k.Info:return S;default:return y}}k.toString=P}(t||(t={})),e.default=t}),define(Se[64],ye([1,0,17,8]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(C){return this.b=C,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(C){const v=C.charCodeAt(0),d=this.b.charCodeAt(this.c);return v-d}value(){return this.b[this.c]}}e.StringIterator=k;class A{constructor(C=!0){this.e=C}reset(C){return this.b=C,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let C=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(C)this.c++;else break;else C=!1;return this}cmp(C){return this.e?(0,t.compareSubstring)(C,this.b,0,C.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class D{constructor(C=!0,v=!0){this.f=C,this.g=v}reset(C){this.d=0,this.e=0,this.b=C,this.c=C.length;for(let v=C.length-1;v>=0;v--,this.c--){const d=this.b.charCodeAt(v);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let C=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(C)this.d++;else break;else C=!1}return this}cmp(C){return this.g?(0,t.compareSubstring)(C,this.b,0,C.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var T;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(C,v){this.f=C,this.g=v,this.d=[],this.e=0}reset(C){return this.c=C,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(C)),this.b.reset(C.path),this.b.value()&&this.d.push(3)),this.g(C)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(C){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(C,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(C,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(C);if(this.d[this.e]===4)return(0,t.compare)(C,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(C,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(R||(R={}));class P{static forUris(C=()=>!1,v=()=>!1){return new P(new S(C,v))}static forPaths(C=!1){return new P(new D(void 0,!C))}static forStrings(){return new P(new k)}static forConfigKeys(){return new P(new A)}constructor(C){this.b=C}clear(){this.c=void 0}fill(C,v){if(v){const d=v.slice(0);(0,c.shuffle)(d);for(const g of d)this.set(g,C)}else{const d=C.slice(0);(0,c.shuffle)(d);for(const g of d)this.set(g[0],g[1])}}set(C,v){const d=this.b.reset(C);let g;this.c||(this.c=new y,this.c.segment=d.value());const m=[];for(g=this.c;;){const f=d.cmp(g.segment);if(f>0)g.left||(g.left=new y,g.left.segment=d.value()),m.push([-1,g]),g=g.left;else if(f<0)g.right||(g.right=new y,g.right.segment=d.value()),m.push([1,g]),g=g.right;else if(d.hasNext())d.next(),g.mid||(g.mid=new y,g.mid.segment=d.value()),m.push([0,g]),g=g.mid;else break}const w=g.value;g.value=v,g.key=C;for(let f=m.length-1;f>=0;f--){const h=m[f][1];h.updateHeight();const b=h.balanceFactor();if(b<-1||b>1){const s=m[f][0],i=m[f+1][0];if(s===1&&i===1)m[f][1]=h.rotateLeft();else if(s===-1&&i===-1)m[f][1]=h.rotateRight();else if(s===1&&i===-1)h.right=m[f+1][1]=m[f+1][1].rotateRight(),m[f][1]=h.rotateLeft();else if(s===-1&&i===1)h.left=m[f+1][1]=m[f+1][1].rotateLeft(),m[f][1]=h.rotateRight();else throw new Error;if(f>0)switch(m[f-1][0]){case-1:m[f-1][1].left=m[f][1];break;case 1:m[f-1][1].right=m[f][1];break;case 0:m[f-1][1].mid=m[f][1];break}else this.c=m[0][1]}}return w}get(C){return this.d(C)?.value}d(C){const v=this.b.reset(C);let d=this.c;for(;d;){const g=v.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else break}return d}has(C){const v=this.d(C);return!(v?.value===void 0&&v?.mid===void 0)}delete(C){return this.e(C,!1)}deleteSuperstr(C){return this.e(C,!0)}e(C,v){const d=this.b.reset(C),g=[];let m=this.c;for(;m;){const w=d.cmp(m.segment);if(w>0)g.push([-1,m]),m=m.left;else if(w<0)g.push([1,m]),m=m.right;else if(d.hasNext())d.next(),g.push([0,m]),m=m.mid;else break}if(!!m){if(v?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const w=this.f(m.right);if(w.key){const{key:f,value:h,segment:b}=w;this.e(w.key,!1),m.key=f,m.value=h,m.segment=b}}else{const w=m.left??m.right;if(g.length>0){const[f,h]=g[g.length-1];switch(f){case-1:h.left=w;break;case 0:h.mid=w;break;case 1:h.right=w;break}}else this.c=w}for(let w=g.length-1;w>=0;w--){const f=g[w][1];f.updateHeight();const h=f.balanceFactor();if(h>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),g[w][1]=f.rotateLeft()):h<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),g[w][1]=f.rotateRight()),w>0)switch(g[w-1][0]){case-1:g[w-1][1].left=g[w][1];break;case 1:g[w-1][1].right=g[w][1];break;case 0:g[w-1][1].mid=g[w][1];break}else this.c=g[0][1]}}}f(C){for(;C.left;)C=C.left;return C}findSubstr(C){const v=this.b.reset(C);let d=this.c,g;for(;d;){const m=v.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(v.hasNext())v.next(),g=d.value||g,d=d.mid;else break}return d&&d.value||g}findSuperstr(C){const v=this.b.reset(C);let d=this.c;for(;d;){const g=v.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else return d.mid?this.g(d.mid):void 0}}forEach(C){for(const[v,d]of this)C(d,v)}*[Symbol.iterator](){yield*this.g(this.c)}g(C){const v=[];return this.h(C,v),v[Symbol.iterator]()}h(C,v){!C||(C.left&&this.h(C.left,v),C.value&&v.push([C.key,C.value]),C.mid&&this.h(C.mid,v),C.right&&this.h(C.right,v))}_isBalanced(){const C=v=>{if(!v)return!0;const d=v.balanceFactor();return d<-1||d>1?!1:C(v.left)&&C(v.right)};return C(this.c)}}e.TernarySearchTree=P}),define(Se[2],ye([1,0,9,12]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function T(l,u){if(!l.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!k.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!A.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(l,u){return!l&&!u?"file":l}function y(l,u){switch(l){case"https":case"http":case"file":u?u[0]!==P&&(u=P+u):u=P;break}return u}const R="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(u){return u instanceof C?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,r,a,n,o,p=!1){typeof u=="object"?(this.scheme=u.scheme||R,this.authority=u.authority||R,this.path=u.path||R,this.query=u.query||R,this.fragment=u.fragment||R):(this.scheme=S(u,p),this.authority=r||R,this.path=y(this.scheme,a||R),this.query=n||R,this.fragment=o||R,T(this,p))}get fsPath(){return f(this,!1)}with(u){if(!u)return this;let{scheme:r,authority:a,path:n,query:o,fragment:p}=u;return r===void 0?r=this.scheme:r===null&&(r=R),a===void 0?a=this.authority:a===null&&(a=R),n===void 0?n=this.path:n===null&&(n=R),o===void 0?o=this.query:o===null&&(o=R),p===void 0?p=this.fragment:p===null&&(p=R),r===this.scheme&&a===this.authority&&n===this.path&&o===this.query&&p===this.fragment?this:new d(r,a,n,o,p)}static parse(u,r=!1){const a=E.exec(u);return a?new d(a[2]||R,i(a[4]||R),i(a[5]||R),i(a[7]||R),i(a[9]||R),r):new d(R,R,R,R,R)}static file(u){let r=R;if(t.isWindows&&(u=u.replace(/\\/g,P)),u[0]===P&&u[1]===P){const a=u.indexOf(P,2);a===-1?(r=u.substring(2),u=P):(r=u.substring(2,a),u=u.substring(a)||P)}return new d("file",r,u,R,R)}static from(u){const r=new d(u.scheme,u.authority,u.path,u.query,u.fragment);return T(r,!0),r}static joinPath(u,...r){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&u.scheme==="file"?a=C.file(c.win32.join(f(u,!0),...r)).path:a=c.posix.join(u.path,...r),u.with({path:a})}toString(u=!1){return h(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof C)return u;{const r=new d(u);return r._formatted=u.external,r._fsPath=u._sep===v?u.fsPath:null,r}}else return u}}e.URI=C;const v=t.isWindows?1:void 0;class d extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(u=!1){return u?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=v),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(l,u){let r,a=-1;for(let n=0;n<l.length;n++){const o=l.charCodeAt(n);if(o>=97&&o<=122||o>=65&&o<=90||o>=48&&o<=57||o===45||o===46||o===95||o===126||u&&o===47)a!==-1&&(r+=encodeURIComponent(l.substring(a,n)),a=-1),r!==void 0&&(r+=l.charAt(n));else{r===void 0&&(r=l.substr(0,n));const p=g[o];p!==void 0?(a!==-1&&(r+=encodeURIComponent(l.substring(a,n)),a=-1),r+=p):a===-1&&(a=n)}}return a!==-1&&(r+=encodeURIComponent(l.substring(a))),r!==void 0?r:l}function w(l){let u;for(let r=0;r<l.length;r++){const a=l.charCodeAt(r);a===35||a===63?(u===void 0&&(u=l.substr(0,r)),u+=g[a]):u!==void 0&&(u+=l[r])}return u!==void 0?u:l}function f(l,u){let r;return l.authority&&l.path.length>1&&l.scheme==="file"?r=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?u?r=l.path.substr(1):r=l.path[1].toLowerCase()+l.path.substr(2):r=l.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=f;function h(l,u){const r=u?w:m;let a="",{scheme:n,authority:o,path:p,query:I,fragment:L}=l;if(n&&(a+=n,a+=":"),(o||n==="file")&&(a+=P,a+=P),o){let z=o.indexOf("@");if(z!==-1){const _=o.substr(0,z);o=o.substr(z+1),z=_.indexOf(":"),z===-1?a+=r(_,!1):(a+=r(_.substr(0,z),!1),a+=":",a+=r(_.substr(z+1),!1)),a+="@"}o=o.toLowerCase(),z=o.indexOf(":"),z===-1?a+=r(o,!1):(a+=r(o.substr(0,z),!1),a+=o.substr(z))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const z=p.charCodeAt(1);z>=65&&z<=90&&(p=`/${String.fromCharCode(z+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const z=p.charCodeAt(0);z>=65&&z<=90&&(p=`${String.fromCharCode(z+32)}:${p.substr(2)}`)}a+=r(p,!0)}return I&&(a+="?",a+=r(I,!1)),L&&(a+="#",a+=u?L:m(L,!1)),a}function b(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+b(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(l){return l.match(s)?l.replace(s,u=>b(u)):l}}),define(Se[85],ye([1,0,22,8,2]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(y){return JSON.stringify(y,T)}e.stringify=A;function D(y){let R=JSON.parse(y);return R=S(R),R}e.parse=D;function T(y,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function S(y,R=0){if(!y||R>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return k.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 16:return new Date(y.source)}if(y instanceof c.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let P=0;P<y.length;++P)y[P]=S(y[P],R+1);else for(const P in y)Object.hasOwnProperty.call(y,P)&&(y[P]=S(y[P],R+1))}return y}e.revive=S}),define(Se[15],ye([1,0,12,2]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y){this.f=`${y}/${k.vscodeRemoteResource}`}set(y,R,P){this.a[y]=R,this.b[y]=P}setConnectionToken(y,R){this.c[y]=R}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)return this.e(y);const R=y.authority;let P=this.a[R];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const E=this.b[R],C=this.c[R];let v=`path=${encodeURIComponent(y.path)}`;return typeof C=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),t.URI.from({scheme:c.isWeb?this.d:k.vscodeRemoteResource,authority:`${P}:${E}`,path:this.f,query:v})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(y){const R=this.b(y,ne);return this.uriToBrowserUri(R)}uriToBrowserUri(y){return y.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===k.file&&(c.isNative||c.isWebWorker&&c.globals.origin===`${k.vscodeFileResource}://${D.a}`)?y.with({scheme:k.vscodeFileResource,authority:y.authority||D.a,query:null,fragment:null}):y}asFileUri(y){const R=this.b(y,ne);return this.uriToFileUri(R)}uriToFileUri(y){return y.scheme===k.vscodeFileResource?y.with({scheme:k.file,authority:y.authority!==D.a?y.authority:null,query:null,fragment:null}):y}b(y,R){return t.URI.isUri(y)?y:t.URI.parse(R.toUrl(y))}}D.a="vscode-app",e.FileAccess=new D;var T;(function(S){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(y.get("3"));const R="vscode-coi";function P(C){let v;typeof C=="string"?v=new URL(C).searchParams:C instanceof URL?v=C.searchParams:t.URI.isUri(C)&&(v=new URL(C.toString(!0)).searchParams);const d=v?.get(R);if(!!d)return y.get(d)}S.getHeadersFromQuery=P;function E(C,v,d){if(!globalThis.crossOriginIsolated)return;const g=v&&d?"3":d?"2":"1";C instanceof URLSearchParams?C.set(R,g):C[R]=g}S.addSearchParam=E})(T=e.COI||(e.COI={}))}),define(Se[24],ye([1,0,32,15,9,12,8,2]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(C){return(0,T.uriToFsPath)(C,!0)}e.originalFSPath=S;class y{constructor(v){this.a=v}compare(v,d,g=!1){return v===d?0:(0,D.compare)(this.getComparisonKey(v,g),this.getComparisonKey(d,g))}isEqual(v,d,g=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,g)===this.getComparisonKey(d,g)}getComparisonKey(v,d=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,d,g=!1){if(v.scheme===d.scheme){if(v.scheme===t.Schemas.file)return c.isEqualOrParent(S(v),S(d),this.a(v))&&v.query===d.query&&(g||v.fragment===d.fragment);if((0,e.isEqualAuthority)(v.authority,d.authority))return c.isEqualOrParent(v.path,d.path,this.a(v),"/")&&v.query===d.query&&(g||v.fragment===d.fragment)}return!1}joinPath(v,...d){return T.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return k.posix.basename(v.path)}extname(v){return k.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===t.Schemas.file?d=T.URI.file(k.dirname(S(v))).path:(d=k.posix.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===t.Schemas.file?d=T.URI.file(k.normalize(S(v))).path:d=k.posix.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.isEqualAuthority)(v.authority,d.authority))return;if(v.scheme===t.Schemas.file){const w=k.relative(S(v),S(d));return A.isWindows?c.toSlashes(w):w}let g=v.path||"/";const m=d.path||"/";if(this.a(v)){let w=0;for(const f=Math.min(g.length,m.length);w<f&&!(g.charCodeAt(w)!==m.charCodeAt(w)&&g.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);g=m.substr(0,w)+g.substr(w)}return k.posix.relative(g,m)}resolvePath(v,d){if(v.scheme===t.Schemas.file){const g=T.URI.file(k.resolve(S(v),d));return v.with({authority:g.authority,path:g.path})}return d=c.toPosixPath(d),v.with({path:k.posix.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,D.equalsIgnoreCase)(v,d)}hasTrailingPathSeparator(v,d=k.sep){if(v.scheme===t.Schemas.file){const g=S(v);return g.length>c.getRoot(g).length&&g[g.length-1]===d}else{const g=v.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=k.sep){return(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=k.sep){let g=!1;if(v.scheme===t.Schemas.file){const m=S(v);g=m!==void 0&&m.length===c.getRoot(m).length&&m[m.length-1]===d}else{d="/";const m=v.path;g=m.length===1&&m.charCodeAt(m.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path+"/"}):v}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(C=>C.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new y(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(C,v){const d=[];for(let g=0;g<C.length;g++){const m=v(C[g]);C.some((w,f)=>f===g?!1:(0,e.isEqualOrParent)(m,v(w)))||d.push(C[g])}return d}e.distinctParents=R;var P;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function v(d){const g=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(f=>{const[h,b]=f.split(":");h&&b&&g.set(h,b)});const w=d.path.substring(0,d.path.indexOf(";"));return w&&g.set(C.META_DATA_MIME,w),g}C.parseMetaData=v})(P=e.DataUri||(e.DataUri={}));function E(C,v,d){if(v){let g=C.path;return g&&g[0]!==k.posix.sep&&(g=k.posix.sep+g),C.with({scheme:d,authority:v,path:g})}return C.with({scheme:d})}e.toLocalResource=E}),define(Se[18],ye([1,0,21,10,4,6,24,12]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(le){return!!le&&typeof le.then=="function"}e.isThenable=S;function y(le){const Z=new c.CancellationTokenSource,ge=le(Z.token),ve=new Promise((De,Re)=>{const ze=Z.token.onCancellationRequested(()=>{ze.dispose(),Z.dispose(),Re(new t.CancellationError)});Promise.resolve(ge).then(se=>{ze.dispose(),Z.dispose(),De(se)},se=>{ze.dispose(),Z.dispose(),Re(se)})});return new class{cancel(){Z.cancel()}then(De,Re){return ve.then(De,Re)}catch(De){return this.then(void 0,De)}finally(De){return ve.finally(De)}}}e.createCancelablePromise=y;function R(le,Z,ge){return new Promise((ve,De)=>{const Re=Z.onCancellationRequested(()=>{Re.dispose(),ve(ge)});le.then(ve,De).finally(()=>Re.dispose())})}e.raceCancellation=R;function P(le,Z){return new Promise((ge,ve)=>{const De=Z.onCancellationRequested(()=>{De.dispose(),ve(new t.CancellationError)});le.then(ge,ve).finally(()=>De.dispose())})}e.raceCancellationError=P;async function E(le){let Z=-1;const ge=le.map((De,Re)=>De.then(ze=>(Z=Re,ze))),ve=await Promise.race(ge);return le.forEach((De,Re)=>{Re!==Z&&De.cancel()}),ve}e.raceCancellablePromises=E;function C(le,Z,ge){let ve;const De=setTimeout(()=>{ve?.(void 0),ge?.()},Z);return Promise.race([le.finally(()=>clearTimeout(De)),new Promise(Re=>ve=Re)])}e.raceTimeout=C;function v(le){return new Promise((Z,ge)=>{const ve=le();S(ve)?ve.then(Z,ge):Z(ve)})}e.asPromise=v;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(Z){if(this.a){if(this.d=Z,!this.b){const ge=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(ge,ge).then(ve)})}return new Promise((ge,ve)=>{this.b.then(ge,ve)})}return this.a=Z(),new Promise((ge,ve)=>{this.a.then(De=>{this.a=null,ge(De)},De=>{this.a=null,ve(De)})})}}e.Throttler=d;class g{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.Sequencer=g;class m{constructor(){this.a=new Map}queue(Z,ge){const De=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.a.get(Z)===De&&this.a.delete(Z)});return this.a.set(Z,De),De}}e.SequencerByKey=m;const w=(le,Z)=>{let ge=!0;const ve=setTimeout(()=>{ge=!1,Z()},le);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(ve),ge=!1}}},f=le=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,le())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ge=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((De,Re)=>{this.d=De,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const De=this.g;return this.g=null,De()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=ge===e.MicrotaskDelay?f(ve):w(ge,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=h;class b{constructor(Z){this.a=new h(Z),this.b=new d}trigger(Z,ge){return this.a.trigger(()=>this.b.queue(Z),ge)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=b;class s{constructor(){this.a=!1,this.b=new Promise((Z,ge)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class i extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function l(le,Z){return Z?new Promise((ge,ve)=>{const De=setTimeout(()=>{Re.dispose(),ge()},le),Re=Z.onCancellationRequested(()=>{clearTimeout(De),Re.dispose(),ve(new t.CancellationError)})}):y(ge=>l(le,ge))}e.timeout=l;function u(le,Z=0){const ge=setTimeout(le,Z);return(0,A.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=u;function r(le){const Z=[];let ge=0;const ve=le.length;function De(){return ge<ve?le[ge++]():null}function Re(ze){ze!=null&&Z.push(ze);const se=De();return se?se.then(Re):Promise.resolve(Z)}return Promise.resolve(null).then(Re)}e.sequence=r;function a(le,Z=ve=>!!ve,ge=null){let ve=0;const De=le.length,Re=()=>{if(ve>=De)return Promise.resolve(ge);const ze=le[ve++];return Promise.resolve(ze()).then(ue=>Z(ue)?Promise.resolve(ue):Re())};return Re()}e.first=a;function n(le,Z=ve=>!!ve,ge=null){if(le.length===0)return Promise.resolve(ge);let ve=le.length;const De=()=>{ve=-1;for(const Re of le)Re.cancel?.()};return new Promise((Re,ze)=>{for(const se of le)se.then(ue=>{--ve>=0&&Z(ue)?(De(),Re(ue)):ve===0&&Re(ge)}).catch(ue=>{--ve>=0&&(De(),ze(ue))})})}e.firstParallel=n;class o{constructor(Z){this.a=0,this.d=Z,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Z){return this.a++,new Promise((ge,ve)=>{this.f.push({factory:Z,c:ge,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Z=this.f.shift();this.b++;const ge=Z.factory();ge.then(Z.c,Z.e),ge.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=o;class p extends o{constructor(){super(1)}}e.Queue=p;class I{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Z=new X;return this.b.add(Z),Z.p}d(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueFor(Z,ge=D.extUri){const ve=ge.getComparisonKey(Z);let De=this.a.get(ve);return De||(De=new p,k.Event.once(De.onDrained)(()=>{De?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,De)),De}f(){!this.d()||this.g()}g(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.g()}}e.ResourceQueue=I;class L{constructor(Z,ge){this.a=-1,typeof Z=="function"&&typeof ge=="number"&&this.setIfNotSet(Z,ge)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ge){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ge)}setIfNotSet(Z,ge){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ge))}}e.TimeoutTimer=L;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Z,ge){this.cancel(),this.a=setInterval(()=>{Z()},ge)}}e.IntervalTimer=z;class _{constructor(Z,ge){this.b=-1,this.a=Z,this.d=ge,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=_;class q{constructor(Z,ge){ge%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ge,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=q;class N extends _{constructor(Z,ge){super(Z,ge),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=N;class M extends A.Disposable{constructor(Z,ge){super(),this.g=Z,this.h=ge,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...Z),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,T.setTimeout0)(()=>{if(Z)return;const ge=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(le,Z)=>{const ge=requestIdleCallback(le,typeof Z=="number"?{timeout:Z}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(ge))}}}}();class F{constructor(Z){this.d=!1,this.a=()=>{try{this.f=Z()}catch(ge){this.g=ge}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function B(le,Z,ge){let ve;for(let De=0;De<ge;De++)try{return await le()}catch(Re){ve=Re,await l(Z)}throw ve}e.retry=B;class U{hasPending(Z){return this.a?typeof Z=="number"?this.a.taskId===Z:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Z,ge,ve){return this.a={taskId:Z,cancel:()=>ve?.(),promise:ge},ge.then(()=>this.d(Z),()=>this.d(Z)),ge}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this.b)this.b.run=Z;else{let ge,ve;const De=new Promise((Re,ze)=>{ge=Re,ve=ze});this.b={run:Z,promise:De,promiseResolve:ge,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=U;class H{constructor(Z,ge=()=>Date.now()){this.d=Z,this.f=ge,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.IntervalCounter=H;class X{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Z,ge)=>{this.a=Z,this.b=ge})}complete(Z){return new Promise(ge=>{this.a(Z),this.f=!0,ge()})}error(Z){return new Promise(ge=>{this.b(Z),this.d=!0,ge()})}cancel(){new Promise(Z=>{this.b(new t.CancellationError),this.d=!0,Z()})}}e.DeferredPromise=X;var V;(function(le){async function Z(ve){let De;const Re=await Promise.all(ve.map(ze=>ze.then(se=>se,se=>{De||(De=se)})));if(typeof De<"u")throw De;return Re}le.settled=Z;function ge(ve){return new Promise(async(De,Re)=>{try{await ve(De,Re)}catch(ze){Re(ze)}})}le.withAsyncBody=ge})(V=e.Promises||(e.Promises={}));var x;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(x||(x={}));class Y{static fromArray(Z){return new Y(ge=>{ge.emitMany(Z)})}static fromPromise(Z){return new Y(async ge=>{ge.emitMany(await Z)})}static fromPromises(Z){return new Y(async ge=>{await Promise.all(Z.map(async ve=>ge.emitOne(await ve)))})}static merge(Z){return new Y(async ge=>{await Promise.all(Z.map(async ve=>{for await(const De of ve)ge.emitOne(De)}))})}constructor(Z){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const ge={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(Z(ge)),this.j()}catch(ve){this.k(ve)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(Z,ge){return new Y(async ve=>{for await(const De of Z)ve.emitOne(ge(De))})}map(Z){return Y.map(this,Z)}static filter(Z,ge){return new Y(async ve=>{for await(const De of Z)ge(De)&&ve.emitOne(De)})}filter(Z){return Y.filter(this,Z)}static coalesce(Z){return Y.filter(Z,ge=>!!ge)}coalesce(){return Y.coalesce(this)}static async toPromise(Z){const ge=[];for await(const ve of Z)ge.push(ve);return ge}toPromise(){return Y.toPromise(this)}g(Z){this.a===0&&(this.b.push(Z),this.f.fire())}h(Z){this.a===0&&(this.b=this.b.concat(Z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Z){this.a===0&&(this.a=2,this.d=Z,this.f.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class J extends Y{constructor(Z,ge){super(ge),this.l=Z}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=J;function te(le){const Z=new c.CancellationTokenSource,ge=le(Z.token);return new J(Z,async ve=>{const De=Z.token.onCancellationRequested(()=>{De.dispose(),Z.dispose(),ve.reject(new t.CancellationError)});try{for await(const Re of ge){if(Z.token.isCancellationRequested)return;ve.emitOne(Re)}De.dispose(),Z.dispose()}catch(Re){De.dispose(),Z.dispose(),ve.reject(Re)}})}e.createCancelableAsyncIterable=te}),define(Se[108],ye([1,0,18,9]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new c.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),A=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(p,I,L=!1){const z=p||"",_=I||"",q=k.value.collator.compare(z,_);return k.value.collatorIsNumeric&&q===0&&z!==_?z<_?-1:1:q}e.compareFileNames=T;function S(p,I){const L=A.value.collator;return p=p||"",I=I||"",b(L,p,I)}e.compareFileNamesDefault=S;function y(p,I){const L=A.value.collator;return p=p||"",I=I||"",u(p,I)||b(L,p,I)}e.compareFileNamesUpper=y;function R(p,I){const L=A.value.collator;return p=p||"",I=I||"",l(p,I)||b(L,p,I)}e.compareFileNamesLower=R;function P(p,I){return p=p||"",I=I||"",p===I?0:p<I?-1:1}e.compareFileNamesUnicode=P;function E(p,I,L=!1){L||(p=p&&p.toLowerCase(),I=I&&I.toLowerCase());const[z,_]=f(p),[q,N]=f(I);return z!==q?z<q?-1:1:_===N?0:_<N?-1:1}e.noIntlCompareFileNames=E;function C(p,I){const[L,z]=f(p),[_,q]=f(I);let N=k.value.collator.compare(z,q);if(N===0){if(k.value.collatorIsNumeric&&z!==q)return z<q?-1:1;if(N=k.value.collator.compare(L,_),k.value.collatorIsNumeric&&N===0&&L!==_)return L<_?-1:1}return N}e.compareFileExtensions=C;function v(p,I){p=p||"",I=I||"";const L=h(p),z=h(I),_=A.value.collator,q=D.value.collator;return b(q,L,z)||b(_,p,I)}e.compareFileExtensionsDefault=v;function d(p,I){p=p||"",I=I||"";const L=h(p),z=h(I),_=A.value.collator,q=D.value.collator;return b(q,L,z)||u(p,I)||b(_,p,I)}e.compareFileExtensionsUpper=d;function g(p,I){p=p||"",I=I||"";const L=h(p),z=h(I),_=A.value.collator,q=D.value.collator;return b(q,L,z)||l(p,I)||b(_,p,I)}e.compareFileExtensionsLower=g;function m(p,I){p=p||"",I=I||"";const L=h(p).toLowerCase(),z=h(I).toLowerCase();return L!==z?L<z?-1:1:p!==I?p<I?-1:1:0}e.compareFileExtensionsUnicode=m;const w=/^(.*?)(\.([^.]*))?$/;function f(p,I=!1){const L=p?w.exec(p):[];let z=[L&&L[1]||"",L&&L[3]||""];return I&&(!z[0]&&z[1]||z[0]&&z[0].charAt(0)===".")&&(z=[z[0]+"."+z[1],""]),z}function h(p){const I=p?w.exec(p):[];return I&&I[1]&&I[1].charAt(0)!=="."&&I[3]||""}function b(p,I,L){const z=p.compare(I,L);return z!==0?z:I.length!==L.length?I.length<L.length?-1:1:0}function s(p){const I=p.charAt(0);return I.toLocaleUpperCase()!==I}function i(p){const I=p.charAt(0);return I.toLocaleLowerCase()!==I}function l(p,I){return s(p)&&i(I)?-1:i(p)&&s(I)?1:0}function u(p,I){return i(p)&&s(I)?-1:s(p)&&i(I)?1:0}function r(p,I,L=!1){return L||(p=p&&p.toLowerCase(),I=I&&I.toLowerCase()),p===I?0:p<I?-1:1}function a(p,I,L=!1){const z=p.split(t.sep),_=I.split(t.sep),q=z.length-1,N=_.length-1;let M,F;for(let B=0;;B++){if(M=q===B,F=N===B,M&&F)return T(z[B],_[B],L);if(M)return-1;if(F)return 1;const U=r(z[B],_[B],L);if(U!==0)return U}}e.comparePaths=a;function n(p,I,L){const z=p.toLowerCase(),_=I.toLowerCase(),q=o(p,I,L);if(q)return q;const N=z.endsWith(L),M=_.endsWith(L);if(N!==M)return N?-1:1;const F=T(z,_);return F!==0?F:z.localeCompare(_)}e.compareAnything=n;function o(p,I,L){const z=p.toLowerCase(),_=I.toLowerCase(),q=z.startsWith(L),N=_.startsWith(L);if(q!==N)return q?-1:1;if(q&&N){if(z.length<_.length)return-1;if(z.length>_.length)return 1}return 0}e.compareByPrefix=o}),define(Se[109],ye([1,0,108,107,84,9,12,8]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,y=[S,[]];function R(U,H,X,V){if(!U||!H)return y;const x=U.length,Y=H.length;if(x<Y)return y;const J=U.toLowerCase();return P(H,X,Y,U,J,x,V)}e.scoreFuzzy=R;function P(U,H,X,V,x,Y,J){const te=[],le=[];for(let De=0;De<X;De++){const Re=De*Y,ze=Re-Y,se=De>0,ue=U[De],he=H[De];for(let ee=0;ee<Y;ee++){const ae=ee>0,re=Re+ee,O=re-1,$=ze+ee-1,G=ae?te[O]:0,Q=se&&ae?te[$]:0,de=se&&ae?le[$]:0;let be;!Q&&se?be=0:be=E(ue,he,V,x,ee,de),be&&Q+be>=G&&(J||se||x.startsWith(H,ee))?(le[re]=de+1,te[re]=Q+be):(le[re]=S,te[re]=G)}}const Z=[];let ge=X-1,ve=Y-1;for(;ge>=0&&ve>=0;){const De=ge*Y+ve;le[De]===S||(Z.push(ve),ge--),ve--}return[te[X*Y-1],Z.reverse()]}function E(U,H,X,V,x,Y){let J=0;if(!C(H,V[x]))return J;if(J+=1,Y>0&&(J+=Y*5),U===X[x]&&(J+=1),x===0)J+=8;else{const te=v(X.charCodeAt(x-1));te?J+=te:(0,t.isUpper)(X.charCodeAt(x))&&Y===0&&(J+=2)}return J}function C(U,H){return U===H?!0:U==="/"||U==="\\"?H==="/"||H==="\\":!1}function v(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function g(U,H,X=0,V=0){const x=H;return x.values&&x.values.length>1?m(U,x.values,X,V):w(U,H,X,V)}e.scoreFuzzy2=g;function m(U,H,X,V){let x=0;const Y=[];for(const J of H){const[te,le]=w(U,J,X,V);if(typeof te!="number")return d;x+=te,Y.push(...le)}return[x,o(Y)]}function w(U,H,X,V){const x=(0,t.fuzzyScore)(H.original,H.originalLowercase,X,U,U.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return x?[x[0],(0,t.createMatches)(x)]:d}const f=Object.freeze({score:0}),h=1<<18,b=1<<17,s=1<<16;function i(U,H,X,V){const x=V.values?V.values:[V];return(0,k.hash)({[V.normalized]:{values:x.map(J=>({value:J.normalized,expectContiguousMatch:J.expectContiguousMatch})),label:U,description:H,allowNonContiguousMatches:X}})}function l(U,H,X,V,x){if(!U||!H.normalized)return f;const Y=V.getItemLabel(U);if(!Y)return f;const J=V.getItemDescription(U),te=i(Y,J,X,H),le=x[te];if(le)return le;const Z=u(Y,J,V.getItemPath(U),H,X);return x[te]=Z,Z}e.scoreItemFuzzy=l;function u(U,H,X,V,x){const Y=!X||!V.containsPathSeparator;return X&&(D.isLinux?V.pathNormalized===X:(0,T.equalsIgnoreCase)(V.pathNormalized,X))?{score:h,labelMatch:[{start:0,end:U.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:V.values&&V.values.length>1?r(U,H,X,V.values,Y,x):a(U,H,X,V,Y,x)}function r(U,H,X,V,x,Y){let J=0;const te=[],le=[];for(const Z of V){const{score:ge,labelMatch:ve,descriptionMatch:De}=a(U,H,X,Z,x,Y);if(ge===S)return f;J+=ge,ve&&te.push(...ve),De&&le.push(...De)}return{score:J,labelMatch:o(te),descriptionMatch:o(le)}}function a(U,H,X,V,x,Y){if(x||!H){const[J,te]=R(U,V.normalized,V.normalizedLowercase,Y&&!V.expectContiguousMatch);if(J){const le=(0,t.matchesPrefix)(V.normalized,U);let Z;return le?(Z=b,Z+=Math.round(V.normalized.length/U.length*100)):Z=s,{score:Z+J,labelMatch:le||n(te)}}}if(H){let J=H;X&&(J=`${H}${A.sep}`);const te=J.length,le=`${J}${U}`,[Z,ge]=R(le,V.normalized,V.normalizedLowercase,Y&&!V.expectContiguousMatch);if(Z){const ve=n(ge),De=[],Re=[];return ve.forEach(ze=>{ze.start<te&&ze.end>te?(De.push({start:0,end:ze.end-te}),Re.push({start:ze.start,end:te})):ze.start>=te?De.push({start:ze.start-te,end:ze.end-te}):Re.push(ze)}),{score:Z,labelMatch:De,descriptionMatch:Re}}}return f}function n(U){const H=[];if(!U)return H;let X;for(const V of U)X&&X.end===V?X.end+=1:(X={start:V,end:V+1},H.push(X));return H}function o(U){const H=U.sort((x,Y)=>x.start-Y.start),X=[];let V;for(const x of H)!V||!p(V,x)?(V=x,X.push(x)):(V.start=Math.min(V.start,x.start),V.end=Math.max(V.end,x.end));return X}function p(U,H){return!(U.end<H.start||H.end<U.start)}function I(U,H,X,V,x,Y){const J=l(U,X,V,x,Y),te=l(H,X,V,x,Y),le=J.score,Z=te.score;if((le===h||Z===h)&&le!==Z)return le===h?-1:1;if(le>s||Z>s){if(le!==Z)return le>Z?-1:1;if(le<b&&Z<b){const ue=z(J.labelMatch,te.labelMatch);if(ue!==0)return ue}const ze=x.getItemLabel(U)||"",se=x.getItemLabel(H)||"";if(ze.length!==se.length)return ze.length-se.length}if(le!==Z)return le>Z?-1:1;const ge=Array.isArray(J.labelMatch)&&J.labelMatch.length>0,ve=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(ge&&!ve)return-1;if(ve&&!ge)return 1;const De=L(U,J,x),Re=L(H,te,x);return De&&Re&&De!==Re?Re>De?-1:1:_(U,H,X,x)}e.compareItemsByFuzzyScore=I;function L(U,H,X){let V=-1,x=-1;if(H.descriptionMatch&&H.descriptionMatch.length?V=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(V=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(x=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const Y=X.getItemDescription(U);Y&&(x+=Y.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(x=H.descriptionMatch[H.descriptionMatch.length-1].end);return x-V}function z(U,H){if(!U&&!H||(!U||!U.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!U||!U.length)return 1;const X=U[0].start,x=U[U.length-1].end-X,Y=H[0].start,te=H[H.length-1].end-Y;return x===te?0:te<x?1:-1}function _(U,H,X,V){const x=V.getItemLabel(U)||"",Y=V.getItemLabel(H)||"",J=V.getItemDescription(U),te=V.getItemDescription(H),le=x.length+(J?J.length:0),Z=Y.length+(te?te.length:0);if(le!==Z)return le-Z;const ge=V.getItemPath(U),ve=V.getItemPath(H);return ge&&ve&&ge.length!==ve.length?ge.length-ve.length:x!==Y?(0,c.compareAnything)(x,Y,X.normalized):J&&te&&J!==te?(0,c.compareAnything)(J,te,X.normalized):ge&&ve&&ge!==ve?(0,c.compareAnything)(ge,ve,X.normalized):0}function q(U){return U.startsWith('"')&&U.endsWith('"')}const N=" ";function M(U){typeof U!="string"&&(U="");const H=U.toLowerCase(),{pathNormalized:X,normalized:V,normalizedLowercase:x}=F(U),Y=X.indexOf(A.sep)>=0,J=q(U);let te;const le=U.split(N);if(le.length>1)for(const Z of le){const ge=q(Z),{pathNormalized:ve,normalized:De,normalizedLowercase:Re}=F(Z);De&&(te||(te=[]),te.push({original:Z,originalLowercase:Z.toLowerCase(),pathNormalized:ve,normalized:De,normalizedLowercase:Re,expectContiguousMatch:ge}))}return{original:U,originalLowercase:H,pathNormalized:X,normalized:V,normalizedLowercase:x,values:te,containsPathSeparator:Y,expectContiguousMatch:J}}e.prepareQuery=M;function F(U){let H;D.isWindows?H=U.replace(/\//g,A.sep):H=U.replace(/\\/g,A.sep);const X=(0,T.stripWildcards)(H).replace(/\s|"/g,"");return{pathNormalized:H,normalized:X,normalizedLowercase:X.toLowerCase()}}function B(U){return Array.isArray(U)?M(U.map(H=>H.original).join(N)):M(U.original)}e.pieceToQuery=B}),define(Se[37],ye([1,0,17,18,32,28,9,12,8]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",P="[^/\\\\]",E=/\//g;function C(X,V){switch(X){case 0:return"";case 1:return`${P}*?`;default:return`(?:${R}|${P}+${R}${V?`|${R}${P}+`:""})*?`}}function v(X,V){if(!X)return[];const x=[];let Y=!1,J=!1,te="";for(const le of X){switch(le){case V:if(!Y&&!J){x.push(te),te="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":J=!0;break;case"]":J=!1;break}te+=le}return te&&x.push(te),x}e.splitGlobAware=v;function d(X){if(!X)return"";let V="";const x=v(X,e.GLOB_SPLIT);if(x.every(Y=>Y===e.GLOBSTAR))V=".*";else{let Y=!1;x.forEach((J,te)=>{if(J===e.GLOBSTAR){if(Y)return;V+=C(2,te===x.length-1)}else{let le=!1,Z="",ge=!1,ve="";for(const De of J){if(De!=="}"&&le){Z+=De;continue}if(ge&&(De!=="]"||!ve)){let Re;De==="-"?Re=De:(De==="^"||De==="!")&&!ve?Re="^":De===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(De),ve+=Re;continue}switch(De){case"{":le=!0;continue;case"[":ge=!0;continue;case"}":{V+=`(?:${v(Z,",").map(se=>d(se)).join("|")})`,le=!1,Z="";break}case"]":{V+="["+ve+"]",ge=!1,ve="";break}case"?":V+=P;continue;case"*":V+=C(1);continue;default:V+=(0,S.escapeRegExpCharacters)(De)}}te<x.length-1&&(x[te+1]!==e.GLOBSTAR||te+2<x.length)&&(V+=R)}Y=J===e.GLOBSTAR})}return V}const g=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new A.LRUCache(1e4),i=function(){return!1},l=function(){return null};function u(X,V){if(!X)return l;let x;typeof X!="string"?x=X.pattern:x=X,x=x.trim();const Y=`${x}_${!!V.trimForExclusions}`;let J=s.get(Y);if(J)return r(J,X);let te;return g.test(x)?J=n(x.substr(4),x):(te=m.exec(a(x,V)))?J=o(te[1],x):(V.trimForExclusions?f:w).test(x)?J=p(x,V):(te=h.exec(a(x,V)))?J=I(te[1].substr(1),x,!0):(te=b.exec(a(x,V)))?J=I(te[1],x,!1):J=L(x),s.set(Y,J),r(J,X)}function r(X,V){if(typeof V=="string")return X;const x=function(Y,J){return(0,k.isEqualOrParent)(Y,V.base,!T.isLinux)?X((0,S.ltrim)(Y.substr(V.base.length),D.sep),J):null};return x.allBasenames=X.allBasenames,x.allPaths=X.allPaths,x.basenames=X.basenames,x.patterns=X.patterns,x}function a(X,V){return V.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function n(X,V){return function(x,Y){return typeof x=="string"&&x.endsWith(X)?V:null}}function o(X,V){const x=`/${X}`,Y=`\\${X}`,J=function(le,Z){return typeof le!="string"?null:Z?Z===X?V:null:le===X||le.endsWith(x)||le.endsWith(Y)?V:null},te=[X];return J.basenames=te,J.patterns=[V],J.allBasenames=te,J}function p(X,V){const x=U(X.slice(1,-1).split(",").map(Z=>u(Z,V)).filter(Z=>Z!==l),X),Y=x.length;if(!Y)return l;if(Y===1)return x[0];const J=function(Z,ge){for(let ve=0,De=x.length;ve<De;ve++)if(x[ve](Z,ge))return X;return null},te=x.find(Z=>!!Z.allBasenames);te&&(J.allBasenames=te.allBasenames);const le=x.reduce((Z,ge)=>ge.allPaths?Z.concat(ge.allPaths):Z,[]);return le.length&&(J.allPaths=le),J}function I(X,V,x){const Y=D.sep===D.posix.sep,J=Y?X:X.replace(E,D.sep),te=D.sep+J,le=D.posix.sep+X;let Z;return x?Z=function(ge,ve){return typeof ge=="string"&&(ge===J||ge.endsWith(te)||!Y&&(ge===X||ge.endsWith(le)))?V:null}:Z=function(ge,ve){return typeof ge=="string"&&(ge===J||!Y&&ge===X)?V:null},Z.allPaths=[(x?"*/":"./")+X],Z}function L(X){try{const V=new RegExp(`^${d(X)}$`);return function(x){return V.lastIndex=0,typeof x=="string"&&V.test(x)?X:null}}catch{return l}}function z(X,V,x){return!X||typeof V!="string"?!1:_(X)(V,void 0,x)}e.match=z;function _(X,V={}){if(!X)return i;if(typeof X=="string"||q(X)){const x=u(X,V);if(x===l)return i;const Y=function(J,te){return!!x(J,te)};return x.allBasenames&&(Y.allBasenames=x.allBasenames),x.allPaths&&(Y.allPaths=x.allPaths),Y}return F(X,V)}e.parse=_;function q(X){const V=X;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=q;function N(X){return X.allBasenames||[]}e.getBasenameTerms=N;function M(X){return X.allPaths||[]}e.getPathTerms=M;function F(X,V){const x=U(Object.getOwnPropertyNames(X).map(Z=>B(Z,X[Z],V)).filter(Z=>Z!==l)),Y=x.length;if(!Y)return l;if(!x.some(Z=>!!Z.requiresSiblings)){if(Y===1)return x[0];const Z=function(De,Re){let ze;for(let se=0,ue=x.length;se<ue;se++){const he=x[se](De,Re);if(typeof he=="string")return he;(0,t.isThenable)(he)&&(ze||(ze=[]),ze.push(he))}return ze?(async()=>{for(const se of ze){const ue=await se;if(typeof ue=="string")return ue}return null})():null},ge=x.find(De=>!!De.allBasenames);ge&&(Z.allBasenames=ge.allBasenames);const ve=x.reduce((De,Re)=>Re.allPaths?De.concat(Re.allPaths):De,[]);return ve.length&&(Z.allPaths=ve),Z}const J=function(Z,ge,ve){let De,Re;for(let ze=0,se=x.length;ze<se;ze++){const ue=x[ze];ue.requiresSiblings&&ve&&(ge||(ge=(0,D.basename)(Z)),De||(De=ge.substr(0,ge.length-(0,D.extname)(Z).length)));const he=ue(Z,ge,De,ve);if(typeof he=="string")return he;(0,t.isThenable)(he)&&(Re||(Re=[]),Re.push(he))}return Re?(async()=>{for(const ze of Re){const se=await ze;if(typeof se=="string")return se}return null})():null},te=x.find(Z=>!!Z.allBasenames);te&&(J.allBasenames=te.allBasenames);const le=x.reduce((Z,ge)=>ge.allPaths?Z.concat(ge.allPaths):Z,[]);return le.length&&(J.allPaths=le),J}function B(X,V,x){if(V===!1)return l;const Y=u(X,x);if(Y===l)return l;if(typeof V=="boolean")return Y;if(V){const J=V.when;if(typeof J=="string"){const te=(le,Z,ge,ve)=>{if(!ve||!Y(le,Z))return null;const De=J.replace("$(basename)",ge),Re=ve(De);return(0,t.isThenable)(Re)?Re.then(ze=>ze?X:null):Re?X:null};return te.requiresSiblings=!0,te}}return Y}function U(X,V){const x=X.filter(Z=>!!Z.basenames);if(x.length<2)return X;const Y=x.reduce((Z,ge)=>{const ve=ge.basenames;return ve?Z.concat(ve):Z},[]);let J;if(V){J=[];for(let Z=0,ge=Y.length;Z<ge;Z++)J.push(V)}else J=x.reduce((Z,ge)=>{const ve=ge.patterns;return ve?Z.concat(ve):Z},[]);const te=function(Z,ge){if(typeof Z!="string")return null;if(!ge){let De;for(De=Z.length;De>0;De--){const Re=Z.charCodeAt(De-1);if(Re===47||Re===92)break}ge=Z.substr(De)}const ve=Y.indexOf(ge);return ve!==-1?J[ve]:null};te.basenames=Y,te.patterns=J,te.allBasenames=Y;const le=X.filter(Z=>!Z.basenames);return le.push(te),le}function H(X,V){return(0,c.equals)(X,V,(x,Y)=>typeof x=="string"&&typeof Y=="string"?x===Y:typeof x!="string"&&typeof Y!="string"?x.base===Y.base&&x.pattern===Y.pattern:!1)}e.patternsEquals=H}),define(Se[110],ye([1,0,10,159,24,8,2]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(m="",w=!1){if(this.value=m,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(m,w=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(f,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,w){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}appendLink(m,w,f){return this.value+="[",this.value+=this.c(w,"]"),this.value+="](",this.value+=this.c(String(m),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(m,w){const f=new RegExp((0,A.escapeRegExpCharacters)(w),"g");return m.replace(f,(h,b)=>m.charAt(b-1)!=="\\"?`\\${h}`:h)}}e.MarkdownString=S;function y(g){return R(g)?!g.value:Array.isArray(g)?g.every(y):!0}e.isEmptyMarkdownString=y;function R(g){return g instanceof S?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function P(g,m){return g===m?!0:!g||!m?!1:g.value===m.value&&g.isTrusted===m.isTrusted&&g.supportThemeIcons===m.supportThemeIcons&&g.supportHtml===m.supportHtml&&(g.baseUri===m.baseUri||!!g.baseUri&&!!m.baseUri&&(0,k.isEqual)(D.URI.from(g.baseUri),D.URI.from(m.baseUri)))}e.markdownStringEqual=P;function E(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function C(g){return g.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=C;function v(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=v;function d(g){const m=[],w=g.split("|").map(h=>h.trim());g=w[0];const f=w[1];if(f){const h=/height=(\d+)/.exec(f),b=/width=(\d+)/.exec(f),s=h?h[1]:"",i=b?b[1]:"",l=isFinite(parseInt(i)),u=isFinite(parseInt(s));l&&m.push(`width="${i}"`),u&&m.push(`height="${s}"`)}return{href:g,dimensions:m}}e.parseHrefAndDimensions=d}),define(Se[111],ye([1,0,17,32,9,12,24,8]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(l,u){const{os:r,tildify:a,relative:n}=u;if(n){const I=y(l,n,r);if(typeof I=="string")return I}let o=l.fsPath;if(r===1&&!A.isWindows?o=o.replace(/\//g,"\\"):r!==1&&A.isWindows&&(o=o.replace(/\\/g,"/")),r!==1&&a?.userHome){const I=a.userHome.fsPath;let L;l.scheme!==a.userHome.scheme&&l.path.startsWith(k.posix.sep)?L=a.userHome.with({path:l.path}).fsPath:L=l.fsPath,o=E(L,I,r)}return(r===1?k.win32:k.posix).normalize(R(o,r===1))}e.getPathLabel=S;function y(l,u,r){const a=r===1?k.win32:k.posix,n=r===3?D.extUri:D.extUriIgnorePathCase,o=u.getWorkspace(),p=(0,c.firstOrDefault)(o.folders);if(!p)return;l.scheme!==p.uri.scheme&&l.path.startsWith(k.posix.sep)&&(l=p.uri.with({path:l.path}));const I=u.getWorkspaceFolder(l);if(!I)return;let L;if(n.isEqual(I.uri,l)?L="":L=n.relativePath(I.uri,l)??"",L&&(L=a.normalize(L)),o.folders.length>1&&!u.noPrefix){const z=I.name?I.name:n.basenameOrAuthority(I.uri);L=L?`${z} \u2022 ${L}`:z}return L}function R(l,u=A.isWindows){return(0,t.hasDriveLetter)(l,u)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=R;let P=Object.create(null);function E(l,u,r=A.OS){if(r===1||!l||!u)return l;let a=P.original===u?P.normalized:void 0;a||(a=u,A.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,T.rtrim)(a,k.posix.sep)}${k.posix.sep}`,P={original:u,normalized:a});let n=l;return A.isWindows&&(n=(0,t.toSlashes)(n)),(r===3?n.startsWith(a):(0,T.startsWithIgnoreCase)(n,a))?`~/${n.substr(a.length)}`:l}e.tildify=E;function C(l,u){return l.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=C;const v="\u2026",d="\\\\",g="~";function m(l,u=k.sep){const r=new Array(l.length);let a=!1;for(let n=0;n<l.length;n++){const o=l[n];if(o===""){r[n]=`.${u}`;continue}if(!o){r[n]=o;continue}a=!0;let p="",I=o;I.indexOf(d)===0?(p=I.substr(0,I.indexOf(d)+d.length),I=I.substr(I.indexOf(d)+d.length)):I.indexOf(u)===0?(p=I.substr(0,I.indexOf(u)+u.length),I=I.substr(I.indexOf(u)+u.length)):I.indexOf(g)===0&&(p=I.substr(0,I.indexOf(g)+g.length),I=I.substr(I.indexOf(g)+g.length));const L=I.split(u);for(let z=1;a&&z<=L.length;z++)for(let _=L.length-z;a&&_>=0;_--){a=!1;let q=L.slice(_,_+z).join(u);for(let N=0;!a&&N<l.length;N++)if(N!==n&&l[N]&&l[N].indexOf(q)>-1){const M=_+z===L.length,F=_>0&&l[N].indexOf(u)>-1?u+q:q,B=l[N].endsWith(F);a=!M||B}if(!a){let N="";(L[0].endsWith(":")||p!=="")&&(_===1&&(_=0,z++,q=L[0]+u+q),_>0&&(N=L[0]+u),N=p+N),_>0&&(N=N+v+u),N=N+q,_+z<L.length&&(N=N+u+v),r[n]=N}}a&&(r[n]=o)}return r}e.shorten=m;var w;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function f(l,u=Object.create(null)){const r=[];let a=!1,n="";for(const o of l)if(o==="$"||a&&o==="{")n&&r.push({value:n,type:w.TEXT}),n="",a=!0;else if(o==="}"&&a){const p=u[n];if(typeof p=="string")p.length&&r.push({value:p,type:w.VARIABLE});else if(p){const I=r[r.length-1];(!I||I.type!==w.SEPARATOR)&&r.push({value:p.label,type:w.SEPARATOR})}n="",a=!1}else n+=o;return n&&!a&&r.push({value:n,type:w.TEXT}),r.filter((o,p)=>{if(o.type===w.SEPARATOR){const I=r[p-1],L=r[p+1];return[I,L].every(z=>z&&(z.type===w.VARIABLE||z.type===w.TEXT)&&z.value.length>0)}return!0}).map(o=>o.value).join("")}e.template=f;function h(l,u){return A.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):l.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function b(l,u){return A.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,""):A.isWindows?l.replace(/&&|&/g,r=>r==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function s(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=s;function i(l){const u=l.indexOf("/")!==-1?k.posix:k.win32,r=u.basename(l),a=u.dirname(l);return r.length?{name:r,parentPath:a}:{name:a,parentPath:""}}e.splitName=i}),define(Se[112],ye([1,0,2]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class k{constructor(P){this.a=P}transformIncoming(P){const E=this.a.transformIncoming(P);return E===P?P:t(c.URI.from(E))}transformOutgoing(P){const E=this.a.transformOutgoing(P);return E===P?P:t(c.URI.from(E))}transformOutgoingURI(P){const E=this.a.transformOutgoing(P);return E===P?P:c.URI.from(E)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function A(R,P,E){if(!R||E>200)return null;if(typeof R=="object"){if(R instanceof c.URI)return P.transformOutgoing(R);for(const C in R)if(Object.hasOwnProperty.call(R,C)){const v=A(R[C],P,E+1);v!==null&&(R[C]=v)}}return null}function D(R,P){const E=A(R,P,0);return E===null?R:E}e.transformOutgoingURIs=D;function T(R,P,E,C){if(!R||C>200)return null;if(typeof R=="object"){if(R.$mid===1)return E?c.URI.revive(P.transformIncoming(R)):P.transformIncoming(R);for(const v in R)if(Object.hasOwnProperty.call(R,v)){const d=T(R[v],P,E,C+1);d!==null&&(R[v]=d)}}return null}function S(R,P){const E=T(R,P,!1,0);return E===null?R:E}e.transformIncomingURIs=S;function y(R,P){const E=T(R,P,!0,0);return E===null?R:E}e.transformAndReviveIncomingURIs=y}),define(Se[29],ye([1,0,65,86,309,18,32,82,9,12,24,2]),function(ne,e,c,t,k,A,D,T,S,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function C(F,B=E.UNLINK){if((0,D.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return B===E.UNLINK?d(F):v(F)}async function v(F){try{const B=(0,D.randomPath)((0,t.tmpdir)());try{await c.promises.rename(F,B)}catch(U){return U.code==="ENOENT"?void 0:d(F)}d(B).catch(U=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function d(F){return(0,k.promisify)(c.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function g(F){if((0,D.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function m(F,B){return h(await(B?w(F):(0,k.promisify)(c.readdir)(F)))}async function w(F){try{return await(0,k.promisify)(c.readdir)(F,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const B=[],U=await m(F);for(const H of U){let X=!1,V=!1,x=!1;try{const Y=await e.Promises.lstat((0,S.join)(F,H));X=Y.isFile(),V=Y.isDirectory(),x=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}B.push({name:H,isFile:()=>X,isDirectory:()=>V,isSymbolicLink:()=>x})}return B}function f(F){return h(c.readdirSync(F))}e.readdirSync=f;function h(F){return F.map(B=>typeof B=="string"?y.isMacintosh?(0,T.normalizeNFC)(B):B:(B.name=y.isMacintosh?(0,T.normalizeNFC)(B.name):B.name,B))}async function b(F){const B=await m(F),U=[];for(const H of B)await i.existsDirectory((0,S.join)(F,H))&&U.push(H);return U}function s(F,B=1e3){return new Promise(U=>{let H=!1;const X=setInterval(()=>{H||(H=!0,c.access(F,V=>{H=!1,V&&(clearInterval(X),U(void 0))}))},B)})}e.whenDeleted=s;var i;(function(F){async function B(X){let V;try{if(V=await e.Promises.lstat(X),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(y.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw Y}throw x}}F.stat=B;async function U(X){try{const{stat:V,symbolicLink:x}=await F.stat(X);return V.isFile()&&x?.dangling!==!0}catch{}return!1}F.existsFile=U;async function H(X){try{const{stat:V,symbolicLink:x}=await F.stat(X);return V.isDirectory()&&x?.dangling!==!0}catch{}return!1}F.existsDirectory=H})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const l=new A.ResourceQueue;function u(F,B,U){return l.queueFor(P.URI.file(F),R.extUriBiasedIgnorePathCase).queue(()=>{const H=p(U);return new Promise((X,V)=>n(F,B,H,x=>x?V(x):X()))})}let r=!0;function a(F){r=F}e.configureFlushOnWrite=a;function n(F,B,U,H){if(!r)return c.writeFile(F,B,{mode:U.mode,flag:U.flag},H);c.open(F,U.flag,U.mode,(X,V)=>{if(X)return H(X);c.writeFile(V,B,x=>{if(x)return c.close(V,()=>H(x));c.fdatasync(V,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),a(!1)),c.close(V,J=>H(J))))})})}function o(F,B,U){const H=p(U);if(!r)return c.writeFileSync(F,B,{mode:H.mode,flag:H.flag});const X=c.openSync(F,H.flag,H.mode);try{c.writeFileSync(X,B);try{c.fdatasyncSync(X)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),a(!1)}}finally{c.closeSync(X)}}e.writeFileSync=o;function p(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function I(F,B){if(F!==B)try{await e.Promises.rename(F,B)}catch(U){if(F.toLowerCase()!==B.toLowerCase()&&U.code==="EXDEV"||F.endsWith("."))await L(F,B,{preserveSymlinks:!1}),await C(F,E.MOVE);else throw U}}async function L(F,B,U){return _(F,B,{root:{source:F,target:B},options:U,handledSourcePaths:new Set})}const z=511;async function _(F,B,U){if(U.handledSourcePaths.has(F))return;U.handledSourcePaths.add(F);const{stat:H,symbolicLink:X}=await i.stat(F);if(X){if(U.options.preserveSymlinks)try{return await M(F,B,U)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(X.dangling)return}return H.isDirectory()?q(F,B,H.mode&z,U):N(F,B,H.mode&z)}async function q(F,B,U,H){await e.Promises.mkdir(B,{recursive:!0,mode:U});const X=await m(F);for(const V of X)await _((0,S.join)(F,V),(0,S.join)(B,V),H)}async function N(F,B,U){await e.Promises.copyFile(F,B),await e.Promises.chmod(B,U)}async function M(F,B,U){let H=await e.Promises.readlink(F);(0,D.isEqualOrParent)(H,U.root.source,!y.isLinux)&&(H=(0,S.join)(U.root.target,H.substr(U.root.source.length+1))),await e.Promises.symlink(H,B)}e.Promises=new class{get access(){return(0,k.promisify)(c.access)}get stat(){return(0,k.promisify)(c.stat)}get lstat(){return(0,k.promisify)(c.lstat)}get utimes(){return(0,k.promisify)(c.utimes)}get read(){return(F,B,U,H,X)=>new Promise((V,x)=>{c.read(F,B,U,H,X,(Y,J,te)=>Y?x(Y):V({bytesRead:J,buffer:te}))})}get readFile(){return(0,k.promisify)(c.readFile)}get write(){return(F,B,U,H,X)=>new Promise((V,x)=>{c.write(F,B,U,H,X,(Y,J,te)=>Y?x(Y):V({bytesWritten:J,buffer:te}))})}get appendFile(){return(0,k.promisify)(c.appendFile)}get fdatasync(){return(0,k.promisify)(c.fdatasync)}get truncate(){return(0,k.promisify)(c.truncate)}get rename(){return(0,k.promisify)(c.rename)}get copyFile(){return(0,k.promisify)(c.copyFile)}get open(){return(0,k.promisify)(c.open)}get close(){return(0,k.promisify)(c.close)}get symlink(){return(0,k.promisify)(c.symlink)}get readlink(){return(0,k.promisify)(c.readlink)}get chmod(){return(0,k.promisify)(c.chmod)}get mkdir(){return(0,k.promisify)(c.mkdir)}get unlink(){return(0,k.promisify)(c.unlink)}get rmdir(){return(0,k.promisify)(c.rmdir)}get realpath(){return(0,k.promisify)(c.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return b}get writeFile(){return u}get rm(){return C}get move(){return I}get copy(){return L}}}),define(Se[113],ye([1,0,65,9,12,8,29]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(E){if(k.isLinux)return E;const C=(0,t.dirname)(E);if(E===C)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const g=(0,D.readdirSync)(C).filter(m=>m.toLowerCase()===v);if(g.length===1){const m=T(C);if(m)return(0,t.join)(m,g[0])}else if(g.length>1){const m=g.indexOf(v);if(m>=0){const w=T(C);if(w)return(0,t.join)(w,g[m])}}}catch{}return null}e.realcaseSync=T;async function S(E){if(k.isLinux)return E;const C=(0,t.dirname)(E);if(E===C)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const g=(await D.Promises.readdir(C)).filter(m=>m.toLowerCase()===v);if(g.length===1){const m=await S(C);if(m)return(0,t.join)(m,g[0])}else if(g.length>1){const m=g.indexOf(v);if(m>=0){const w=await S(C);if(w)return(0,t.join)(w,g[m])}}}catch{}return null}e.realcase=S;async function y(E){try{return await D.Promises.realpath(E)}catch{const v=P(E);return await D.Promises.access(v,c.constants.R_OK),v}}e.realpath=y;function R(E){try{return c.realpathSync(E)}catch{const v=P(E);return c.accessSync(v,c.constants.R_OK),v}}e.realpathSync=R;function P(E){return(0,A.rtrim)((0,t.normalize)(E),t.sep)}}),define(Se[114],ye([1,0,9,12,36,106,11,29]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(P=k.env){return P.comspec||"cmd.exe"}e.getWindowsShell=S;function y(P){let E=[],C=!1;const v=function(d){if(C){E.push(d);return}(!P.send(d,m=>{if(m&&console.error(m),C=!1,E.length>0){const w=E.slice(0);E=[],w.forEach(f=>v(f))}})||t.isWindows)&&(C=!0)};return{send:v}}e.createQueuedSender=y;var R;(function(P){async function E(C,v,d){if(c.isAbsolute(C))return C;if(v===void 0&&(v=k.cwd()),c.dirname(C)!=="."||(d===void 0&&D.isString(k.env.PATH)&&(d=k.env.PATH.split(c.delimiter)),d===void 0||d.length===0))return c.join(v,C);async function m(w){if(await T.Promises.exists(w)){let f;try{f=await T.Promises.stat(w)}catch(h){h.message.startsWith("EACCES")&&(f=await T.Promises.lstat(w))}return f?!f.isDirectory():!1}return!1}for(const w of d){let f;if(c.isAbsolute(w)?f=c.join(w,C):f=c.join(v,w,C),await m(f))return f;let h=f+".com";if(await m(h)||(h=f+".exe",await m(h)))return h}return c.join(v,C)}P.findExecutable=E})(R=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(ne,e,c,t){var k=arguments.length,A=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,c):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ne,e,c,t);else for(var T=ne.length-1;T>=0;T--)(D=ne[T])&&(A=(k<3?D(A):k>3?D(e,c,A):D(e,c))||A);return k>3&&A&&Object.defineProperty(e,c,A),A};define(Se[115],ye([1,0,17,18,22,21,60,10,4,6,85,8,11]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var C;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(C||(C={}));function v(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(d||(d={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(m||(m={}));function w(V){let x=0;for(let Y=0;;Y+=7){const J=V.read(1);if(x|=(J.buffer[0]&127)<<Y,!(J.buffer[0]&128))return x}}const f=l(0);function h(V,x){if(x===0){V.write(f);return}let Y=0;for(let te=x;te!==0;te=te>>>7)Y++;const J=k.VSBuffer.alloc(Y);for(let te=0;x!==0;te++)J.buffer[te]=x&127,x=x>>>7,x>0&&(J.buffer[te]|=128);V.write(J)}class b{constructor(x){this.b=x,this.a=0}read(x){const Y=this.b.slice(this.a,this.a+x);return this.a+=Y.byteLength,Y}}e.BufferReader=b;class s{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(x){this.a.push(x)}}e.BufferWriter=s;var i;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(i||(i={}));function l(V){const x=k.VSBuffer.alloc(1);return x.writeUInt8(V,0),x}const u={Undefined:l(i.Undefined),String:l(i.String),Buffer:l(i.Buffer),VSBuffer:l(i.VSBuffer),Array:l(i.Array),Object:l(i.Object),Uint:l(i.Int)},r=typeof Buffer<"u";function a(V,x){if(typeof x>"u")V.write(u.Undefined);else if(typeof x=="string"){const Y=k.VSBuffer.fromString(x);V.write(u.String),h(V,Y.byteLength),V.write(Y)}else if(r&&Buffer.isBuffer(x)){const Y=k.VSBuffer.wrap(x);V.write(u.Buffer),h(V,Y.byteLength),V.write(Y)}else if(x instanceof k.VSBuffer)V.write(u.VSBuffer),h(V,x.byteLength),V.write(x);else if(Array.isArray(x)){V.write(u.Array),h(V,x.length);for(const Y of x)a(V,Y)}else if(typeof x=="number"&&(x|0)===x)V.write(u.Uint),h(V,x);else{const Y=k.VSBuffer.fromString(JSON.stringify(x));V.write(u.Object),h(V,Y.byteLength),V.write(Y)}}e.serialize=a;function n(V){switch(V.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return V.read(w(V)).toString();case i.Buffer:return V.read(w(V)).buffer;case i.VSBuffer:return V.read(w(V));case i.Array:{const Y=w(V),J=[];for(let te=0;te<Y;te++)J.push(n(V));return J}case i.Object:return JSON.parse(V.read(w(V)).toString());case i.Int:return w(V)}}e.deserialize=n;class o{constructor(x,Y,J=null,te=1e3){this.h=x,this.j=Y,this.k=J,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(le=>this.q(le)),this.m({type:200})}registerChannel(x,Y){this.b.set(x,Y),setTimeout(()=>this.w(x),0)}m(x){switch(x.type){case 200:{const Y=this.o([x.type]);this.k?.logOutgoing(Y,0,1,g(x.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([x.type,x.id],x.data);this.k?.logOutgoing(Y,x.id,1,g(x.type),x.data);return}}}o(x,Y=void 0){const J=new s;return a(J,x),a(J,Y),this.p(J.buffer)}p(x){try{return this.h.send(x),x.byteLength}catch{return 0}}q(x){const Y=new b(x),J=n(Y),te=n(Y),le=J[0];switch(le){case 100:return this.k?.logIncoming(x.byteLength,J[1],1,`${v(le)}: ${J[2]}.${J[3]}`,te),this.s({type:le,id:J[1],channelName:J[2],name:J[3],arg:te});case 102:return this.k?.logIncoming(x.byteLength,J[1],1,`${v(le)}: ${J[2]}.${J[3]}`,te),this.t({type:le,id:J[1],channelName:J[2],name:J[3],arg:te});case 101:return this.k?.logIncoming(x.byteLength,J[1],1,`${v(le)}`),this.u({type:le,id:J[1]});case 103:return this.k?.logIncoming(x.byteLength,J[1],1,`${v(le)}`),this.u({type:le,id:J[1]})}}s(x){const Y=this.b.get(x.channelName);if(!Y){this.v(x);return}const J=new A.CancellationTokenSource;let te;try{te=Y.call(this.j,x.name,x.arg,J.token)}catch(ge){te=Promise.reject(ge)}const le=x.id;te.then(ge=>{this.m({id:le,data:ge,type:201}),this.d.delete(x.id)},ge=>{ge instanceof Error?this.m({id:le,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.m({id:le,data:ge,type:203}),this.d.delete(x.id)});const Z=(0,y.toDisposable)(()=>J.cancel());this.d.set(x.id,Z)}t(x){const Y=this.b.get(x.channelName);if(!Y){this.v(x);return}const J=x.id,le=Y.listen(this.j,x.name,x.arg)(Z=>this.m({id:J,data:Z,type:204}));this.d.set(x.id,le)}u(x){const Y=this.d.get(x.id);Y&&(Y.dispose(),this.d.delete(x.id))}v(x){let Y=this.g.get(x.channelName);Y||(Y=[],this.g.set(x.channelName,Y));const J=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.m({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:x,timeoutTimer:J})}w(x){const Y=this.g.get(x);if(Y){for(const J of Y)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(x)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=o;var p;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class I{constructor(x,Y=null){this.l=x,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=Y}getChannel(x){const Y=this;return{call(J,te,le){return Y.a?Promise.reject(new T.CancellationError):Y.m(x,J,te,le)},listen(J,te){return Y.a?S.Event.None:Y.o(x,J,te)}}}m(x,Y,J,te=A.CancellationToken.None){const le=this.g++,ge={id:le,type:100,channelName:x,name:Y,arg:J};if(te.isCancellationRequested)return Promise.reject(new T.CancellationError);let ve;return new Promise((Re,ze)=>{if(te.isCancellationRequested)return ze(new T.CancellationError);const se=()=>{const ae=re=>{switch(re.type){case 201:this.f.delete(le),Re(re.data);break;case 202:{this.f.delete(le);const O=new Error(re.data.message);O.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,O.name=re.data.name,ze(O);break}case 203:this.f.delete(le),ze(re.data);break}};this.f.set(le,ae),this.p(ge)};let ue=null;this.b===m.Idle?se():(ue=(0,t.createCancelablePromise)(ae=>this.u()),ue.then(()=>{ue=null,se()}));const he=()=>{ue?(ue.cancel(),ue=null):this.p({id:le,type:101}),ze(new T.CancellationError)},ee=te.onCancellationRequested(he);ve=(0,y.combinedDisposable)((0,y.toDisposable)(he),ee),this.d.add(ve)}).finally(()=>{this.d.delete(ve)})}o(x,Y,J){const te=this.g++,Z={id:te,type:102,channelName:x,name:Y,arg:J};let ge=null;const ve=new S.Emitter({onWillAddFirstListener:()=>{ge=(0,t.createCancelablePromise)(Re=>this.u()),ge.then(()=>{ge=null,this.d.add(ve),this.p(Z)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(ve),this.p({id:te,type:103}))}}),De=Re=>ve.fire(Re.data);return this.f.set(te,De),ve.event}p(x){switch(x.type){case 100:case 102:{const Y=this.q([x.type,x.id,x.channelName,x.name],x.arg);this.j?.logOutgoing(Y,x.id,0,`${v(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const Y=this.q([x.type,x.id]);this.j?.logOutgoing(Y,x.id,0,v(x.type));return}}}q(x,Y=void 0){const J=new s;return a(J,x),a(J,Y),this.r(J.buffer)}r(x){try{return this.l.send(x),x.byteLength}catch{return 0}}s(x){const Y=new b(x),J=n(Y),te=n(Y),le=J[0];switch(le){case 200:return this.j?.logIncoming(x.byteLength,0,0,g(le)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(x.byteLength,J[1],0,g(le),te),this.t({type:J[0],id:J[1],data:te})}}t(x){if(x.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(x.id)?.(x)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.dispose)(this.d.values()),this.d.clear()}}qe([D.memoize],I.prototype,"onDidInitializePromise",null),e.ChannelClient=I;class L{get connections(){const x=[];return this.f.forEach(Y=>x.push(Y)),x}constructor(x){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,x(({protocol:Y,onDidClientDisconnect:J})=>{S.Event.once(Y.onMessage)(le=>{const Z=new b(le),ge=n(Z),ve=new o(Y,ge),De=new I(Y);this.a.forEach((ze,se)=>ve.registerChannel(se,ze));const Re={channelServer:ve,channelClient:De,ctx:ge};this.f.add(Re),this.g.fire(Re),J(()=>{ve.dispose(),De.dispose(),this.f.delete(Re),this.h.fire(Re)})})})}getChannel(x,Y){const J=this;return{call(te,le,Z){let ge;if((0,E.isFunction)(Y)){const De=(0,c.getRandomElement)(J.connections.filter(Y));ge=De?Promise.resolve(De):S.Event.toPromise(S.Event.filter(J.onDidAddConnection,Y))}else ge=Y.routeCall(J,te,le);const ve=ge.then(De=>De.channelClient.getChannel(x));return _(ve).call(te,le,Z)},listen(te,le){if((0,E.isFunction)(Y))return J.j(x,Y,te,le);const Z=Y.routeEvent(J,te,le).then(ge=>ge.channelClient.getChannel(x));return _(Z).listen(te,le)}}}j(x,Y,J,te){const le=this;let Z=new y.DisposableStore;const ge=new S.Emitter({onWillAddFirstListener:()=>{Z=new y.DisposableStore;const ve=new S.EventMultiplexer,De=new Map,Re=se=>{const he=se.channelClient.getChannel(x).listen(J,te),ee=ve.add(he);De.set(se,ee)},ze=se=>{const ue=De.get(se);!ue||(ue.dispose(),De.delete(se))};le.connections.filter(Y).forEach(Re),S.Event.filter(le.onDidAddConnection,Y)(Re,void 0,Z),le.onDidRemoveConnection(ze,void 0,Z),ve.event(ge.fire,ge,Z),Z.add(ve)},onDidRemoveLastListener:()=>{Z.dispose()}});return ge.event}registerChannel(x,Y){this.a.set(x,Y),this.f.forEach(J=>{J.channelServer.registerChannel(x,Y)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=L;class z{constructor(x,Y,J=null){const te=new s;a(te,Y),x.send(te.buffer),this.a=new I(x,J),this.d=new o(x,Y,J)}getChannel(x){return this.a.getChannel(x)}registerChannel(x,Y){this.d.registerChannel(x,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=z;function _(V){return{call(x,Y,J){return V.then(te=>te.call(x,Y,J))},listen(x,Y){const J=new S.Relay;return V.then(te=>J.input=te.listen(x,Y)),J.event}}}e.getDelayedChannel=_;function q(V){let x=!1;return{call(Y,J,te){return x?V.call(Y,J,te):(0,t.timeout)(0).then(()=>x=!0).then(()=>V.call(Y,J,te))},listen(Y,J){if(x)return V.listen(Y,J);const te=new S.Relay;return(0,t.timeout)(0).then(()=>x=!0).then(()=>te.input=V.listen(Y,J)),te.event}}}e.getNextTickChannel=q;class N{constructor(x){this.a=x}routeCall(x){return this.b(x)}routeEvent(x){return this.b(x)}async b(x){for(const Y of x.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await S.Event.toPromise(x.onDidAddConnection),await this.b(x)}}e.StaticRouter=N;var M;(function(V){function x(le,Z){const ge=le,ve=Z&&Z.disableMarshalling,De=new Map;for(const Re in ge)J(Re)&&De.set(Re,S.Event.buffer(ge[Re],!0));return new class{listen(Re,ze,se){const ue=De.get(ze);if(ue)return ue;if(te(ze)){const he=ge[ze];if(typeof he=="function")return he.call(ge,se)}throw new Error(`Event not found: ${ze}`)}call(Re,ze,se){const ue=ge[ze];if(typeof ue=="function"){if(!ve&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,R.revive)(se[he]);return ue.apply(ge,se)}throw new Error(`Method not found: ${ze}`)}}}V.fromService=x;function Y(le,Z){const ge=Z&&Z.disableMarshalling;return new Proxy({},{get(ve,De){if(typeof De=="string")return Z?.properties?.has(De)?Z.properties.get(De):te(De)?function(Re){return le.listen(De,Re)}:J(De)?le.listen(De):async function(...Re){let ze;Z&&!(0,E.isUndefinedOrNull)(Z.context)?ze=[Z.context,...Re]:ze=Re;const se=await le.call(De,ze);return ge?se:(0,R.revive)(se)};throw new Error(`Property not found: ${String(De)}`)}})}V.toService=Y;function J(le){return le[0]==="o"&&le[1]==="n"&&P.isUpperAsciiLetter(le.charCodeAt(2))}function te(le){return/^onDynamic/.test(le)&&P.isUpperAsciiLetter(le.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const x=V.toString();if(x!=="[object Object]")return x}return V}function U(V){return Array.isArray(V)?V.map(B):B(V)}function H(V,x,Y,J,te,le,Z){Z=U(Z);const ge=F[te],ve=ge[J%ge.length];let De=[`%c[${V}]%c[${String(x).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(le)?(De=De.concat(Z),De.push(")")):De.push(Z),console.log.apply(console,De)}class X{constructor(x,Y){this.d=x,this.f=Y,this.a=0,this.b=0}logOutgoing(x,Y,J,te,le){this.b+=x,H(this.d,this.b,x,Y,J,te,le)}logIncoming(x,Y,J,te,le){this.a+=x,H(this.f,this.a,x,Y,J,te,le)}}e.IPCLogger=X}),define(Se[116],ye([1,0,22,4,6,115]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var T;(function(u){u.enableDiagnostics=!1,u.records=[];const r=new WeakMap;let a=0;function n(p,I){if(!r.has(p)){const L=String(++a);r.set(p,L)}return r.get(p)}function o(p,I,L,z){if(!u.enableDiagnostics)return;const _=n(p,I);if(z instanceof c.VSBuffer||z instanceof Uint8Array||z instanceof ArrayBuffer||ArrayBuffer.isView(z)){const q=c.VSBuffer.alloc(z.byteLength);q.set(z),u.records.push({timestamp:Date.now(),id:_,label:I,type:L,buff:q})}else u.records.push({timestamp:Date.now(),id:_,label:I,type:L,data:z})}u.traceSocketEvent=o})(T=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function R(){return y||(y=c.VSBuffer.alloc(0)),y}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,a){if(r===0)return R();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const I=this.a[0];return a&&(this.a.shift(),this.b-=r),I}if(this.a[0].byteLength>r){const I=this.a[0].slice(0,r);return a&&(this.a[0]=this.a[0].slice(r),this.b-=r),I}const n=c.VSBuffer.alloc(r);let o=0,p=0;for(;r>0;){const I=this.a[p];if(I.byteLength>r){const L=I.slice(0,r);n.set(L,o),o+=r,a&&(this.a[p]=I.slice(r),this.b-=r),r-=r}else n.set(I,o),o+=I.byteLength,a?(this.a.shift(),this.b-=I.byteLength):p++,r-=I.byteLength}return n}}e.ChunkStream=P;var E;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(E||(E={}));function C(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,a,n,o){this.type=r,this.id=a,this.ack=n,this.data=o,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(r){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new P,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:C(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const n=this.g.messageType,o=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new d(n,o,p,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=c.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:C(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(a,r.data)}g(r,a){const n=this.f===0;return this.d.push(r,a),this.f+=r.byteLength+a.byteLength,n}h(){const r=c.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,a){this.g(r,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class w extends k.Disposable{constructor(r){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new m(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new d(1,0,0,r))}}e.Protocol=w;class f extends A.IPCClient{static fromSocket(r,a){return new f(new w(r),a)}get onDidDispose(){return this.b.onDidDispose}constructor(r,a,n=null){super(r,a,n),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.Client=f;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.BufferedEmitter=h;class b{constructor(r){this.data=r,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let r=0,a=this.a;for(;a;)a=a.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let a=0,n=this.a;for(;n;)r[a++]=n.data,n=n.next;return r}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const a=new b(r);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const r=Date.now();for(let a=0;a<i.a;a++)this.c[a]=r-1e3*a;setInterval(()=>{for(let a=i.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),a=(1+i.a)*1e3;let n=0;for(let o=0;o<i.a;o++)r-this.c[o]<=a&&n++;return 1-n/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;class l{get unacknowledgedCount(){return this.c-this.d}constructor(r,a=null,n=i.getInstance()){this.t=new h,this.onControlMessage=this.t.event,this.u=new h,this.onMessage=this.u.event,this.v=new h,this.onDidDispose=this.v.event,this.w=new h,this.onSocketClose=this.w.event,this.x=new h,this.onSocketTimeout=this.x.event,this.s=n,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=r,this.p=new m(this.o),this.r.push(this.p),this.q=new g(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(o=>this.y(o))),this.r.push(this.o.onClose(o=>this.w.fire(o))),a&&this.q.acceptChunk(a),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,k.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const r=new d(5,0,0,R());this.p.write(r),this.p.flush()}sendPause(){const r=new d(7,0,0,R());this.p.write(r)}sendResume(){const r=new d(8,0,0,R());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,a){this.a=!0,this.r=(0,k.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=new m(this.o),this.r.push(this.p),this.q=new g(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(n=>this.y(n))),this.r.push(this.o.onClose(n=>this.w.fire(n))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new d(3,0,this.h,R());this.p.write(r);const a=this.b.toArray();for(let n=0,o=a.length;n<o;n++)this.p.write(a[n]);this.A()}acceptDisconnect(){this.v.fire()}y(r){if(r.ack>this.d){this.d=r.ack;do{const a=this.b.peek();if(a&&a.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new d(6,0,0,R())))}else this.g=r.id,this.j=Date.now(),this.z(),this.u.fire(r.data);break}case 2:{this.t.fire(r.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const a=this.b.toArray();for(let n=0,o=a.length;n<o;n++)this.p.write(a[n]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const a=++this.c;this.h=this.g;const n=new d(1,a,this.h,r);this.b.push(n),this.a||(this.p.write(n),this.A())}sendControl(r){const a=new d(2,0,0,r);this.p.write(a)}z(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-r+5)}A(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),a=Date.now()-r.writtenTime,n=Date.now()-this.q.lastReadTime,o=Date.now()-this.n;if(a>=2e4&&n>=2e4&&o>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:n});return}const p=Math.max(2e4-a,2e4-n,2e4-o,500);this.f=setTimeout(()=>{this.f=null,this.A()},p)}B(){if(this.g<=this.h)return;this.h=this.g;const r=new d(3,0,this.h,R());this.p.write(r)}C(){const r=new d(9,0,0,R());this.p.write(r)}}e.PersistentProtocol=l}),define(Se[117],ye([1,0,22,10,4,6,9,12,30,115,116]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class E{traceSocketEvent(n,o){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,o)}constructor(n,o=""){this.f=!0,this.debugLabel=o,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,t.onUnexpectedError)(p)}},this.socket.on("error",this.a),this.b=p=>{this.traceSocketEvent("close",{hadError:p}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const o=p=>{this.traceSocketEvent("read",p),n(c.VSBuffer.wrap(p))};return this.socket.on("data",o),{dispose:()=>this.socket.off("data",o)}}onClose(n){const o=p=>{n({type:0,hadError:p,error:void 0})};return this.socket.on("close",o),{dispose:()=>this.socket.off("close",o)}}onEnd(n){const o=()=>{n()};return this.socket.on("end",o),{dispose:()=>this.socket.off("end",o)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,o=>{if(o){if(o.code==="EPIPE")return;(0,t.onUnexpectedError)(o)}})}catch(o){if(o.code==="EPIPE")return;(0,t.onUnexpectedError)(o)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,o)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=E;var C;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(C||(C={}));var v;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(v||(v={}));class d extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,o){this.socket.traceSocketEvent(n,o)}constructor(n,o,p,I){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:o,inflateBytesLength:p?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new g(this,o,p,I,this.f,(L,z)=>this.k(L,z))),this.B(this.a.onError(L=>{console.error(L),(0,t.onUnexpectedError)(L),this.g.fire({type:0,hadError:!0,error:L})})),this.b=new R.ChunkStream,this.B(this.socket.onData(L=>this.l(L))),this.B(this.socket.onClose(L=>this.g.fire(L)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,o){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let p=2;n.byteLength<126?p+=0:n.byteLength<2**16?p+=2:p+=8;const I=c.VSBuffer.alloc(p);if(o?I.writeUInt8(194,0):I.writeUInt8(130,0),n.byteLength<126)I.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){I.writeUInt8(126,1);let L=1;I.writeUInt8(n.byteLength>>>8&255,++L),I.writeUInt8(n.byteLength>>>0&255,++L)}else{I.writeUInt8(127,1);let L=1;I.writeUInt8(0,++L),I.writeUInt8(0,++L),I.writeUInt8(0,++L),I.writeUInt8(0,++L),I.writeUInt8(n.byteLength>>>24&255,++L),I.writeUInt8(n.byteLength>>>16&255,++L),I.writeUInt8(n.byteLength>>>8&255,++L),I.writeUInt8(n.byteLength>>>0&255,++L)}this.socket.write(c.VSBuffer.concat([I,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const o=this.b.peek(this.j.readLen),p=o.readUInt8(0),I=(p&128)>>>7,L=(p&64)>>>6,z=o.readUInt8(1),_=(z&128)>>>7,q=z&127;this.j.state=2,this.j.readLen=2+(_?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(L)),this.j.firstFrameOfMessage=Boolean(I),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const o=this.b.read(this.j.readLen),p=o.readUInt8(1),I=(p&128)>>>7;let L=p&127,z=1;L===126?L=o.readUInt8(++z)*2**8+o.readUInt8(++z):L===127&&(L=o.readUInt8(++z)*0+o.readUInt8(++z)*0+o.readUInt8(++z)*0+o.readUInt8(++z)*0+o.readUInt8(++z)*2**24+o.readUInt8(++z)*2**16+o.readUInt8(++z)*2**8+o.readUInt8(++z));let _=0;I&&(_=o.readUInt8(++z)*2**24+o.readUInt8(++z)*2**16+o.readUInt8(++z)*2**8+o.readUInt8(++z)),this.j.state=3,this.j.readLen=L,this.j.mask=_,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const o=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",o),f(o,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",o),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(o,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class g extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(n,o,p,I,L,z){super(),this.k=n,this.l=L,this.m=z,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,o?(this.b=this.B(new m(this.k,I,p,{windowBits:15})),this.f=this.B(new w(this.k,{windowBits:15})),this.B(this.b.onError(_=>this.a.fire(_))),this.B(this.f.onError(_=>this.a.fire(_)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const o=await this.r(this.f,n);this.m(o,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,o){return new Promise((p,I)=>{n.write(o),n.flush(L=>p(L))})}acceptFrame(n,o,p){this.h.push({data:n,isCompressed:o,isLastFrameOfMessage:p}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const o=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(o)}else this.l.fire(n.data)}this.s=!1}}u(n,o,p){return new Promise((I,L)=>{n.write(o),p&&n.write(c.VSBuffer.fromByteArray([0,0,255,255])),n.flush(z=>I(z))})}}class m extends A.Disposable{get recordedInflateBytes(){return this.j?c.VSBuffer.concat(this.f):c.VSBuffer.alloc(0)}constructor(n,o,p,I){super(),this.h=n,this.j=o,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(I),this.b.on("error",L=>{this.h.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent("zlibInflateData",L),this.g.push(c.VSBuffer.wrap(L))}),p&&(this.h.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this.b.write(p.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const o=c.VSBuffer.concat(this.g);this.g.length=0,n(o)})}}class w extends A.Disposable{constructor(n,o){super(),this.g=n,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",p=>{this.g.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this.a.fire(p)}),this.b.on("data",p=>{this.g.traceSocketEvent("zlibDeflateData",p),this.f.push(c.VSBuffer.wrap(p))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let o=c.VSBuffer.concat(this.f);this.f.length=0,o=o.slice(0,o.byteLength-4),n(o)})}}function f(a,n){if(n===0)return;const o=a.byteLength>>>2;for(let q=0;q<o;q++){const N=a.readUInt32BE(q*4);a.writeUInt32BE(N^n,q*4)}const p=o*4,I=a.byteLength-p,L=n>>>24&255,z=n>>>16&255,_=n>>>8&255;I>=1&&a.writeUInt8(a.readUInt8(p)^L,p),I>=2&&a.writeUInt8(a.readUInt8(p+1)^z,p+1),I>=3&&a.writeUInt8(a.readUInt8(p+2)^_,p+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function b(){const a=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):n=(0,D.join)(P().os.tmpdir(),`vscode-ipc-${a}.sock`),i(n),n}e.createRandomIPCHandle=b;function s(a,n,o){const p=P().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${o}-${n}-sock`;let I;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?I=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${o}-${n}.sock`):I=(0,D.join)(a,`${o}-${n}.sock`),i(I),I}e.createStaticIPCHandle=s;function i(a){const n=h[T.platform];typeof n=="number"&&a.length>=n&&console.warn(`WARNING: IPC handle "${a}" is longer than ${n} chars, try a shorter --user-data-dir`)}class l extends y.IPCServer{static b(n){const o=k.Event.fromNodeEventEmitter(n,"connection");return k.Event.map(o,p=>({protocol:new R.Protocol(new E(p,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(p,"close"))}))}constructor(n){super(l.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=l;function u(a){return new Promise((n,o)=>{const p=P().net.createServer();p.on("error",o),p.listen(a,()=>{p.removeListener("error",o),n(new l(p))})})}e.serve=u;function r(a,n){return new Promise((o,p)=>{const I=P().net.createConnection(a,()=>{I.removeListener("error",p),o(R.Client.fromSocket(new E(I,`ipc-client${n}`),n))});I.once("error",p)})}e.connect=r}),define(Se[160],ye([1,0,37,9]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(A,D,T,S,y,R){if(Array.isArray(A)){let P=0;for(const E of A){const C=k(E,D,T,S,y,R);if(C===10)return C;C>P&&(P=C)}return P}else{if(typeof A=="string")return S?A==="*"?5:A===T?10:0:0;if(A){const{language:P,pattern:E,scheme:C,hasAccessToAllModels:v,notebookType:d}=A;if(!S&&!v)return 0;d&&y&&(D=y);let g=0;if(C)if(C===D.scheme)g=10;else if(C==="*")g=5;else return 0;if(P)if(P===T)g=10;else if(P==="*")g=Math.max(g,5);else return 0;if(d)if(d===R)g=10;else if(d==="*"&&R!==void 0)g=Math.max(g,5);else return 0;if(E){let m;if(typeof E=="string"?m=E:m={...E,base:(0,t.normalize)(E.base)},m===D.fsPath||(0,c.match)(m,D.fsPath))g=10;else return 0}return g}else return 0}}e.score=k}),define(Se[161],ye([1,0,8,50,153]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(T,S,y,R){this.c=T,this.d=S,this.f=y,this.g=R,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(T){T.eol&&T.eol!==this.f&&(this.f=T.eol,this.h=null);const S=T.changes;for(const y of S)this.n(y.range),this.o(new t.Position(y.range.startLineNumber,y.range.startColumn),y.text);this.g=T.versionId,this.j=null}k(){if(!this.h){const T=this.f.length,S=this.d.length,y=new Uint32Array(S);for(let R=0;R<S;R++)y[R]=this.d[R].length+T;this.h=new k.PrefixSumComputer(y)}}l(T,S){this.d[T]=S,this.h&&this.h.setValue(T,this.d[T].length+this.f.length)}n(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.startLineNumber-1].substring(T.endColumn-1));return}this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.endLineNumber-1].substring(T.endColumn-1)),this.d.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.h&&this.h.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}o(T,S){if(S.length===0)return;const y=(0,c.splitLines)(S);if(y.length===1){this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+y[0]+this.d[T.lineNumber-1].substring(T.column-1));return}y[y.length-1]+=this.d[T.lineNumber-1].substring(T.column-1),this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+y[0]);const R=new Uint32Array(y.length-1);for(let P=1;P<y.length;P++)this.d.splice(T.lineNumber+P-1,0,y[P]),R[P-1]=y[P].length+this.f.length;this.h&&this.h.insertValues(T.lineNumber,R)}}e.MirrorTextModel=A}),define(Se[162],ye([1,0,8,150,50,35,105]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(w,f,h,b){this.searchString=w,this.isRegex=f,this.matchCase=h,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=y(this.searchString):w=this.searchString.indexOf(`
`)>=0;let f=null;try{f=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!f)return null;let h=!this.isRegex&&!w;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new D.SearchData(f,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,h?this.searchString:null)}}e.SearchParams=S;function y(m){if(!m||m.length===0)return!1;for(let w=0,f=m.length;w<f;w++){const h=m.charCodeAt(w);if(h===10)return!0;if(h===92){if(w++,w>=f)break;const b=m.charCodeAt(w);if(b===110||b===114||b===87)return!0}}return!1}e.isMultilineRegexSource=y;function R(m,w,f){if(!f)return new D.FindMatch(m,null);const h=[];for(let b=0,s=w.length;b<s;b++)h[b]=w[b];return new D.FindMatch(m,h)}e.createFindMatch=R;class P{constructor(w){const f=[];let h=0;for(let b=0,s=w.length;b<s;b++)w.charCodeAt(b)===10&&(f[h++]=b);this.a=f}findLineFeedCountBeforeOffset(w){const f=this.a;let h=0,b=f.length-1;if(b===-1||w<=f[0])return 0;for(;h<b;){const s=h+((b-h)/2>>0);f[s]>=w?b=s-1:f[s+1]>=w?(h=s,b=s):h=s+1}return h+1}}class E{static findMatches(w,f,h,b,s){const i=f.parseSearchRequest();return i?i.regex.multiline?this.b(w,h,new g(i.wordSeparators,i.regex),b,s):this.c(w,h,i,b,s):[]}static a(w,f,h,b,s,i){let l,u=0;b?(u=b.findLineFeedCountBeforeOffset(s),l=f+s+u):l=f+s;let r;if(b){const p=b.findLineFeedCountBeforeOffset(s+i.length)-u;r=l+i.length+p}else r=l+i.length;const a=w.getPositionAt(l),n=w.getPositionAt(r);return new A.Range(a.lineNumber,a.column,n.lineNumber,n.column)}static b(w,f,h,b,s){const i=w.getOffsetAt(f.getStartPosition()),l=w.getValueInRange(f,1),u=w.getEOL()===`\r
`?new P(l):null,r=[];let a=0,n;for(h.reset(0);n=h.next(l);)if(r[a++]=R(this.a(w,i,l,u,n.index,n[0]),n,b),a>=s)return r;return r}static c(w,f,h,b,s){const i=[];let l=0;if(f.startLineNumber===f.endLineNumber){const r=w.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return l=this.d(h,r,f.startLineNumber,f.startColumn-1,l,i,b,s),i}const u=w.getLineContent(f.startLineNumber).substring(f.startColumn-1);l=this.d(h,u,f.startLineNumber,f.startColumn-1,l,i,b,s);for(let r=f.startLineNumber+1;r<f.endLineNumber&&l<s;r++)l=this.d(h,w.getLineContent(r),r,0,l,i,b,s);if(l<s){const r=w.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);l=this.d(h,r,f.endLineNumber,0,l,i,b,s)}return i}static d(w,f,h,b,s,i,l,u){const r=w.wordSeparators;if(!l&&w.simpleSearch){const o=w.simpleSearch,p=o.length,I=f.length;let L=-p;for(;(L=f.indexOf(o,L+p))!==-1;)if((!r||d(r,f,I,L,p))&&(i[s++]=new D.FindMatch(new A.Range(h,L+1+b,h,L+1+p+b),null),s>=u))return s;return s}const a=new g(w.wordSeparators,w.regex);let n;a.reset(0);do if(n=a.next(f),n&&(i[s++]=R(new A.Range(h,n.index+1+b,h,n.index+1+n[0].length+b),n,l),s>=u))return s;while(n);return s}static findNextMatch(w,f,h,b){const s=f.parseSearchRequest();if(!s)return null;const i=new g(s.wordSeparators,s.regex);return s.regex.multiline?this.e(w,h,i,b):this.f(w,h,i,b)}static e(w,f,h,b){const s=new k.Position(f.lineNumber,1),i=w.getOffsetAt(s),l=w.getLineCount(),u=w.getValueInRange(new A.Range(s.lineNumber,s.column,l,w.getLineMaxColumn(l)),1),r=w.getEOL()===`\r
`?new P(u):null;h.reset(f.column-1);const a=h.next(u);return a?R(this.a(w,i,u,r,a.index,a[0]),a,b):f.lineNumber!==1||f.column!==1?this.e(w,new k.Position(1,1),h,b):null}static f(w,f,h,b){const s=w.getLineCount(),i=f.lineNumber,l=w.getLineContent(i),u=this.g(h,l,i,f.column,b);if(u)return u;for(let r=1;r<=s;r++){const a=(i+r-1)%s,n=w.getLineContent(a+1),o=this.g(h,n,a+1,1,b);if(o)return o}return null}static g(w,f,h,b,s){w.reset(b-1);const i=w.next(f);return i?R(new A.Range(h,i.index+1,h,i.index+1+i[0].length),i,s):null}static findPreviousMatch(w,f,h,b){const s=f.parseSearchRequest();if(!s)return null;const i=new g(s.wordSeparators,s.regex);return s.regex.multiline?this.h(w,h,i,b):this.j(w,h,i,b)}static h(w,f,h,b){const s=this.b(w,new A.Range(1,1,f.lineNumber,f.column),h,b,10*T);if(s.length>0)return s[s.length-1];const i=w.getLineCount();return f.lineNumber!==i||f.column!==w.getLineMaxColumn(i)?this.h(w,new k.Position(i,w.getLineMaxColumn(i)),h,b):null}static j(w,f,h,b){const s=w.getLineCount(),i=f.lineNumber,l=w.getLineContent(i).substring(0,f.column-1),u=this.k(h,l,i,b);if(u)return u;for(let r=1;r<=s;r++){const a=(s+i-r-1)%s,n=w.getLineContent(a+1),o=this.k(h,n,a+1,b);if(o)return o}return null}static k(w,f,h,b){let s=null,i;for(w.reset(0);i=w.next(f);)s=R(new A.Range(h,i.index+1,h,i.index+1+i[0].length),i,b);return s}}e.TextModelSearch=E;function C(m,w,f,h,b){if(h===0)return!0;const s=w.charCodeAt(h-1);if(m.get(s)!==0||s===13||s===10)return!0;if(b>0){const i=w.charCodeAt(h);if(m.get(i)!==0)return!0}return!1}function v(m,w,f,h,b){if(h+b===f)return!0;const s=w.charCodeAt(h+b);if(m.get(s)!==0||s===13||s===10)return!0;if(b>0){const i=w.charCodeAt(h+b-1);if(m.get(i)!==0)return!0}return!1}function d(m,w,f,h,b){return C(m,w,f,h,b)&&v(m,w,f,h,b)}e.isValidMatch=d;class g{constructor(w,f){this._wordSeparators=w,this.a=f,this.b=-1,this.c=0}reset(w){this.a.lastIndex=w,this.b=-1,this.c=0}next(w){const f=w.length;let h;do{if(this.b+this.c===f||(h=this.a.exec(w),!h))return null;const b=h.index,s=h[0].length;if(b===this.b&&s===this.c){if(s===0){c.getNextCodePoint(w,f,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=b,this.c=s,!this._wordSeparators||d(this._wordSeparators,w,f,b,s))return h}while(h);return null}}e.Searcher=g}),define(Se[118],ye([1,0,22,12]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(k||(k={}));function A(P){for(let E=0,C=P.length;E<C;E+=4){const v=P[E+0],d=P[E+1],g=P[E+2],m=P[E+3];P[E+0]=m,P[E+1]=g,P[E+2]=d,P[E+3]=v}}function D(P){const E=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||A(E),c.VSBuffer.wrap(E)}function T(P){const E=P.buffer;if(t.isLittleEndian()||A(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const C=new Uint8Array(E.byteLength);return C.set(E),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function S(P){const E=new Uint32Array(y(P));let C=0;if(E[C++]=P.id,P.type==="full")E[C++]=1,E[C++]=P.data.length,E.set(P.data,C),C+=P.data.length;else{E[C++]=2,E[C++]=P.deltas.length;for(const v of P.deltas)E[C++]=v.start,E[C++]=v.deleteCount,v.data?(E[C++]=v.data.length,E.set(v.data,C),C+=v.data.length):E[C++]=0}return D(E)}e.encodeSemanticTokensDto=S;function y(P){let E=0;if(E+=1+1,P.type==="full")E+=1+P.data.length;else{E+=1,E+=(1+1+1)*P.deltas.length;for(const C of P.deltas)C.data&&(E+=C.data.length)}return E}function R(P){const E=T(P);let C=0;const v=E[C++];if(E[C++]===1){const w=E[C++],f=E.subarray(C,C+w);return C+=w,{id:v,type:"full",data:f}}const g=E[C++],m=[];for(let w=0;w<g;w++){const f=E[C++],h=E[C++],b=E[C++];let s;b>0&&(s=E.subarray(C,C+b),C+=b),m[w]={start:f,deleteCount:h,data:s}}return{id:v,type:"delta",deltas:m}}e.decodeSemanticTokensDto=R}),define(Se[163],ye([1,0,4,6]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this.a=new Map,this.b=new Map,this.c=new c.Emitter,this.onDidChange=this.c.event,this.d=null}fire(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this.a.set(T,S),this.fire([T]),(0,t.toDisposable)(()=>{this.a.get(T)===S&&(this.a.delete(T),this.fire([T]))})}registerFactory(T,S){this.b.get(T)?.dispose();const y=new A(this,T,S);return this.b.set(T,y),(0,t.toDisposable)(()=>{const R=this.b.get(T);!R||R!==y||(this.b.delete(T),R.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const y=this.b.get(T);return!y||y.isResolved?null:(await y.resolve(),this.get(T))}get(T){return this.a.get(T)||null}isResolved(T){if(this.get(T))return!0;const y=this.b.get(T);return!!(!y||y.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=k;class A extends t.Disposable{get isResolved(){return this.c}constructor(T,S,y){super(),this.f=T,this.g=S,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,T&&!this.a&&this.B(this.f.register(this.g,T))}}}),define(Se[66],ye([1,0,79,2,35,163]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class D{constructor(p,I,L){this._tokenBrand=void 0,this.offset=p,this.type=I,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class T{constructor(p,I){this._tokenizationResultBrand=void 0,this.tokens=p,this.endState=I}}e.TokenizationResult=T;class S{constructor(p,I){this._encodedTokenizationResultBrand=void 0,this.tokens=p,this.endState=I}}e.EncodedTokenizationResult=S;var y;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(y=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(o){const p=new Map;p.set(0,c.Codicon.symbolMethod),p.set(1,c.Codicon.symbolFunction),p.set(2,c.Codicon.symbolConstructor),p.set(3,c.Codicon.symbolField),p.set(4,c.Codicon.symbolVariable),p.set(5,c.Codicon.symbolClass),p.set(6,c.Codicon.symbolStruct),p.set(7,c.Codicon.symbolInterface),p.set(8,c.Codicon.symbolModule),p.set(9,c.Codicon.symbolProperty),p.set(10,c.Codicon.symbolEvent),p.set(11,c.Codicon.symbolOperator),p.set(12,c.Codicon.symbolUnit),p.set(13,c.Codicon.symbolValue),p.set(15,c.Codicon.symbolEnum),p.set(14,c.Codicon.symbolConstant),p.set(15,c.Codicon.symbolEnum),p.set(16,c.Codicon.symbolEnumMember),p.set(17,c.Codicon.symbolKeyword),p.set(27,c.Codicon.symbolSnippet),p.set(18,c.Codicon.symbolText),p.set(19,c.Codicon.symbolColor),p.set(20,c.Codicon.symbolFile),p.set(21,c.Codicon.symbolReference),p.set(22,c.Codicon.symbolCustomColor),p.set(23,c.Codicon.symbolFolder),p.set(24,c.Codicon.symbolTypeParameter),p.set(25,c.Codicon.account),p.set(26,c.Codicon.issues);function I(_){let q=p.get(_);return q||(console.info("No codicon found for CompletionItemKind "+_),q=c.Codicon.symbolProperty),q}o.toIcon=I;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function z(_,q){let N=L.get(_);return typeof N>"u"&&!q&&(N=9),N}o.fromString=z})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(o){o[o.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(o){o[o.None=0]="None",o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var C;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function w(o){return o&&t.URI.isUri(o.uri)&&k.Range.isIRange(o.range)&&(k.Range.isIRange(o.originSelectionRange)||k.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=w;var f;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var h;(function(o){o[o.Deprecated=1]="Deprecated"})(h=e.SymbolTag||(e.SymbolTag={}));var b;(function(o){const p=new Map;p.set(0,c.Codicon.symbolFile),p.set(1,c.Codicon.symbolModule),p.set(2,c.Codicon.symbolNamespace),p.set(3,c.Codicon.symbolPackage),p.set(4,c.Codicon.symbolClass),p.set(5,c.Codicon.symbolMethod),p.set(6,c.Codicon.symbolProperty),p.set(7,c.Codicon.symbolField),p.set(8,c.Codicon.symbolConstructor),p.set(9,c.Codicon.symbolEnum),p.set(10,c.Codicon.symbolInterface),p.set(11,c.Codicon.symbolFunction),p.set(12,c.Codicon.symbolVariable),p.set(13,c.Codicon.symbolConstant),p.set(14,c.Codicon.symbolString),p.set(15,c.Codicon.symbolNumber),p.set(16,c.Codicon.symbolBoolean),p.set(17,c.Codicon.symbolArray),p.set(18,c.Codicon.symbolObject),p.set(19,c.Codicon.symbolKey),p.set(20,c.Codicon.symbolNull),p.set(21,c.Codicon.symbolEnumMember),p.set(22,c.Codicon.symbolStruct),p.set(23,c.Codicon.symbolEvent),p.set(24,c.Codicon.symbolOperator),p.set(25,c.Codicon.symbolTypeParameter);function I(L){let z=p.get(L);return z||(console.info("No codicon found for SymbolKind "+L),z=c.Codicon.symbolProperty),z}o.toIcon=I})(b=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(p){this.value=p}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var i;(function(o){function p(I){return!I||typeof I!="object"?!1:typeof I.id=="string"&&typeof I.title=="string"}o.is=p})(i=e.Command||(e.Command={}));var l;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(o){o[o.Unresolved=0]="Unresolved",o[o.Resolved=1]="Resolved"})(u=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var a;(function(o){o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(a=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var n;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Se[164],ye([19,20]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Se[119],ye([1,0,164,12,104,17,23,149]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(W){this.c=W}hasChanged(W){return this.c[W]}}e.ConfigurationChangedEvent=y;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class P{constructor(W,ce,Ie,Le){this.id=W,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate(W,ce){return C(W,ce)}compute(W,ce,Ie){return Ie}}class E{constructor(W,ce){this.newValue=W,this.didChange=ce}}e.ApplyUpdateResult=E;function C(oe,W){if(typeof oe!="object"||typeof W!="object"||!oe||!W)return new E(W,oe!==W);if(Array.isArray(oe)||Array.isArray(W)){const Ie=Array.isArray(oe)&&Array.isArray(W)&&A.equals(oe,W);return new E(W,!Ie)}let ce=!1;for(const Ie in W)if(W.hasOwnProperty(Ie)){const Le=C(oe[Ie],W[Ie]);Le.didChange&&(oe[Ie]=Le.newValue,ce=!0)}return new E(oe,ce)}class v{constructor(W){this.schema=void 0,this.id=W,this.name="_never_",this.defaultValue=void 0}applyUpdate(W,ce){return C(W,ce)}validate(W){return this.defaultValue}}class d{constructor(W,ce,Ie,Le){this.id=W,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate(W,ce){return C(W,ce)}validate(W){return typeof W>"u"?this.defaultValue:W}compute(W,ce,Ie){return Ie}}function g(oe,W){return typeof oe>"u"?W:oe==="false"?!1:Boolean(oe)}e.boolean=g;class m extends d{constructor(W,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super(W,ce,Ie,Le)}validate(W){return g(W,this.defaultValue)}}function w(oe,W,ce,Ie){if(typeof oe>"u")return W;let Le=parseInt(oe,10);return isNaN(Le)?W:(Le=Math.max(ce,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=w;class f extends d{static clampedInt(W,ce,Ie,Le){return w(W,ce,Ie,Le)}constructor(W,ce,Ie,Le,Be,Xe=void 0){typeof Xe<"u"&&(Xe.type="integer",Xe.default=Ie,Xe.minimum=Le,Xe.maximum=Be),super(W,ce,Ie,Xe),this.minimum=Le,this.maximum=Be}validate(W){return f.clampedInt(W,this.defaultValue,this.minimum,this.maximum)}}class h extends d{static clamp(W,ce,Ie){return W<ce?ce:W>Ie?Ie:W}static float(W,ce){if(typeof W=="number")return W;if(typeof W>"u")return ce;const Ie=parseFloat(W);return isNaN(Ie)?ce:Ie}constructor(W,ce,Ie,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=Ie),super(W,ce,Ie,Be),this.validationFn=Le}validate(W){return this.validationFn(h.float(W,this.defaultValue))}}class b extends d{static string(W,ce){return typeof W!="string"?ce:W}constructor(W,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super(W,ce,Ie,Le)}validate(W){return b.string(W,this.defaultValue)}}function s(oe,W,ce){return typeof oe!="string"||ce.indexOf(oe)===-1?W:oe}e.stringSet=s;class i extends d{constructor(W,ce,Ie,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=Ie),super(W,ce,Ie,Be),this.c=Le}validate(W){return s(W,this.defaultValue,this.c)}}class l extends P{constructor(W,ce,Ie,Le,Be,Xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super(W,ce,Ie,Ze),this.c=Be,this.d=Xe}validate(W){return typeof W!="string"?this.defaultValue:this.c.indexOf(W)===-1?this.defaultValue:this.d(W)}}function u(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(W){switch(W){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(W,ce,Ie){return Ie===0?W.accessibilitySupport:Ie}}class a extends P{constructor(){const W={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",W,{"editor.comments.insertSpace":{type:"boolean",default:W.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:W.ignoreEmptyLines,description:c.localize(5,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{insertSpace:g(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function I(oe){switch(oe){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=I;function L(oe){switch(oe){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class z extends v{constructor(){super(133)}compute(W,ce,Ie){const Le=["monaco-editor"];return ce.get(34)&&Le.push(ce.get(34)),W.extraEditorClassName&&Le.push(W.extraEditorClassName),ce.get(68)==="default"?Le.push("mouse-default"):ce.get(68)==="copy"&&Le.push("mouse-copy"),ce.get(103)&&Le.push("showUnused"),ce.get(131)&&Le.push("showDeprecated"),Le.join(" ")}}class _ extends m{constructor(){super(33,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(W,ce,Ie){return Ie&&W.emptySelectionClipboard}}class q extends P{constructor(){const W={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",W,{"editor.find.cursorMoveOnType":{type:"boolean",default:W.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:W.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:W.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:W.globalFindClipboard,description:c.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:W.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:W.loop,description:c.localize(18,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{cursorMoveOnType:g(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof W.seedSearchStringFromSelection=="boolean"?W.seedSearchStringFromSelection?"always":"never":s(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof W.autoFindInSelection=="boolean"?W.autoFindInSelection?"always":"never":s(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(ce.loop,this.defaultValue.loop)}}}class N extends P{constructor(){super(46,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"?N.OFF:W==="true"?N.ON:W:Boolean(W)?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class M extends P{constructor(){super(49,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"?M.OFF:W==="true"?M.TRANSLATE:W:Boolean(W)?M.TRANSLATE:M.OFF}compute(W,ce,Ie){return W.fontInfo.fontVariationSettings}}e.EditorFontVariations=M,M.OFF="normal",M.TRANSLATE="translate";class F extends v{constructor(){super(45)}compute(W,ce,Ie){return W.fontInfo}}class B extends d{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(W){const ce=h.float(W,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ce,6,100)}compute(W,ce,Ie){return W.fontInfo.fontSize}}class U extends P{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(W){return W==="normal"||W==="bold"?W:String(f.clampedInt(W,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}U.c=["normal","bold","100","200","300","400","500","600","700","800","900"],U.d=1,U.e=1e3;class H extends P{constructor(){const W={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:W.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",W,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...ce},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...ce},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:W.alternativeDefinitionCommand,enum:Ie,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:W.alternativeTypeDefinitionCommand,enum:Ie,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:W.alternativeDeclarationCommand,enum:Ie,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:W.alternativeImplementationCommand,enum:Ie,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:W.alternativeReferenceCommand,enum:Ie,description:c.localize(41,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{multiple:s(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??s(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??s(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??s(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??s(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??s(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends P{constructor(){const W={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",W,{"editor.hover.enabled":{type:"boolean",default:W.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:W.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:W.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:W.above,description:c.localize(45,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{enabled:g(ce.enabled,this.defaultValue.enabled),delay:f.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:g(ce.sticky,this.defaultValue.sticky),above:g(ce.above,this.defaultValue.above)}}}var V;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class x extends v{constructor(){super(136)}compute(W,ce,Ie){return x.computeLayout(ce,{memory:W.memory,outerWidth:W.outerWidth,outerHeight:W.outerHeight,isDominatedByLongLines:W.isDominatedByLongLines,lineHeight:W.fontInfo.lineHeight,viewLineCount:W.viewLineCount,lineNumbersDigitCount:W.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:W.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:W.fontInfo.maxDigitWidth,pixelRatio:W.pixelRatio})}static computeContainedMinimapLineCount(W){const ce=W.height/W.lineHeight,Ie=W.scrollBeyondLastLine?ce-1:0,Le=(W.viewLineCount+Ie)/(W.pixelRatio*W.height),Be=Math.floor(W.viewLineCount/Le);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Ie,desiredRatio:Le,minimapLineCount:Be}}static c(W,ce){const Ie=W.outerWidth,Le=W.outerHeight,Be=W.pixelRatio;if(!W.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Xe=ce.stableMinimapLayoutInput,Ze=Xe&&W.outerHeight===Xe.outerHeight&&W.lineHeight===Xe.lineHeight&&W.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&W.pixelRatio===Xe.pixelRatio&&W.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&W.minimap.enabled===Xe.minimap.enabled&&W.minimap.side===Xe.minimap.side&&W.minimap.size===Xe.minimap.size&&W.minimap.showSlider===Xe.minimap.showSlider&&W.minimap.renderCharacters===Xe.minimap.renderCharacters&&W.minimap.maxColumn===Xe.minimap.maxColumn&&W.minimap.scale===Xe.minimap.scale&&W.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&W.isViewportWrapping===Xe.isViewportWrapping,mt=W.lineHeight,ft=W.typicalHalfwidthCharacterWidth,lt=W.scrollBeyondLastLine,ot=W.minimap.renderCharacters;let rt=Be>=2?Math.round(W.minimap.scale*2):W.minimap.scale;const At=W.minimap.maxColumn,Rt=W.minimap.size,Ft=W.minimap.side,pt=W.verticalScrollbarWidth,kt=W.viewLineCount,Bt=W.remainingWidth,Mt=W.isViewportWrapping,xe=ot?2:3;let Ot=Math.floor(Be*Le);const Ut=Ot/Be;let Ht=!1,bt=!1,Lt=xe*rt,Ae=rt/Be,Oe=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:It,desiredRatio:Et,minimapLineCount:Tt}=x.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:lt,height:Le,lineHeight:mt,pixelRatio:Be});if(kt/Tt>1)Ht=!0,bt=!0,rt=1,Lt=1,Ae=rt/Be;else{let vt=!1,yt=rt+1;if(Rt==="fit"){const zt=Math.ceil((kt+It)*Lt);Mt&&Ze&&Bt<=ce.stableFitRemainingWidth?(vt=!0,yt=ce.stableFitMaxMinimapScale):vt=zt>Ot}if(Rt==="fill"||vt){Ht=!0;const zt=rt;Lt=Math.min(mt*Be,Math.max(1,Math.floor(1/Et))),Mt&&Ze&&Bt<=ce.stableFitRemainingWidth&&(yt=ce.stableFitMaxMinimapScale),rt=Math.min(yt,Math.max(1,Math.floor(Lt/xe))),rt>zt&&(Oe=Math.min(2,rt/zt)),Ae=rt/Be/Oe,Ot=Math.ceil(Math.max(tt,kt+It)*Lt),Mt?(ce.stableMinimapLayoutInput=W,ce.stableFitRemainingWidth=Bt,ce.stableFitMaxMinimapScale=rt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const Ee=Math.floor(At*Ae),ie=Math.min(Ee,Math.max(0,Math.floor((Bt-pt-2)*Ae/(ft+Ae)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Be*ie);const $e=Ne/Be;Ne=Math.floor(Ne*Oe);const Qe=ot?1:2,Ve=Ft==="left"?0:Ie-ie-pt;return{renderMinimap:Qe,minimapLeft:Ve,minimapWidth:ie,minimapHeightIsEditorHeight:Ht,minimapIsSampling:bt,minimapScale:rt,minimapLineHeight:Lt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Ut}}static computeLayout(W,ce){const Ie=ce.outerWidth|0,Le=ce.outerHeight|0,Be=ce.lineHeight|0,Xe=ce.lineNumbersDigitCount|0,Ze=ce.typicalHalfwidthCharacterWidth,mt=ce.maxDigitWidth,ft=ce.pixelRatio,lt=ce.viewLineCount,ot=W.get(128),rt=ot==="inherit"?W.get(127):ot,At=rt==="inherit"?W.get(123):rt,Rt=W.get(126),Ft=ce.isDominatedByLongLines,pt=W.get(52),kt=W.get(62).renderType!==0,Bt=W.get(63),Mt=W.get(97),xe=W.get(67),Ot=W.get(95),Ut=Ot.verticalScrollbarSize,Ht=Ot.verticalHasArrows,bt=Ot.arrowSize,Lt=Ot.horizontalScrollbarSize,Ae=W.get(38),Oe=W.get(102)!=="never";let Ee=W.get(60);Ae&&Oe&&(Ee+=16);let ie=0;if(kt){const St=Math.max(Xe,Bt);ie=Math.round(St*mt)}let Ne=0;pt&&(Ne=Be);let $e=0,Qe=$e+Ne,Ve=Qe+ie,tt=Ve+Ee;const It=Ie-Ne-ie-Ee;let Et=!1,Tt=!1,wt=-1;rt==="inherit"&&Ft?(Et=!0,Tt=!0):At==="on"||At==="bounded"?Tt=!0:At==="wordWrapColumn"&&(wt=Rt);const vt=x.c({outerWidth:Ie,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:ft,scrollBeyondLastLine:Mt,minimap:xe,verticalScrollbarWidth:Ut,viewLineCount:lt,remainingWidth:It,isViewportWrapping:Tt},ce.memory||new R);vt.renderMinimap!==0&&vt.minimapLeft===0&&($e+=vt.minimapWidth,Qe+=vt.minimapWidth,Ve+=vt.minimapWidth,tt+=vt.minimapWidth);const yt=It-vt.minimapWidth,zt=Math.max(1,Math.floor((yt-Ut-2)/Ze)),xt=Ht?bt:0;return Tt&&(wt=Math.max(1,zt),At==="bounded"&&(wt=Math.min(wt,Rt))),{width:Ie,height:Le,glyphMarginLeft:$e,glyphMarginWidth:Ne,lineNumbersLeft:Qe,lineNumbersWidth:ie,decorationsLeft:Ve,decorationsWidth:Ee,contentLeft:tt,contentWidth:yt,minimap:vt,viewportColumn:zt,isWordWrapMinified:Et,isViewportWrapping:Tt,wrappingColumn:wt,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:Lt,overviewRuler:{top:xt,width:Ut,height:Le-2*xt,right:0}}}}e.EditorLayoutInfoComputer=x;class Y extends P{constructor(){super(130,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate(W){return s(W,"simple",["simple","advanced"])}compute(W,ce,Ie){return ce.get(2)===2?"advanced":Ie}}class J extends P{constructor(){const W={enabled:!0};super(59,"lightbulb",W,{"editor.lightbulb.enabled":{type:"boolean",default:W.enabled,description:c.localize(49,null)}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{enabled:g(W.enabled,this.defaultValue.enabled)}}}class te extends P{constructor(){const W={enabled:!1,maxLineCount:5};super(107,"stickyScroll",W,{"editor.stickyScroll.enabled":{type:"boolean",default:W.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:W.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{enabled:g(ce.enabled,this.defaultValue.enabled),maxLineCount:f.clampedInt(ce.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends P{constructor(){const W={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(132,"inlayHints",W,{"editor.inlayHints.enabled":{type:"string",default:W.enabled,description:c.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(53,null),c.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:W.fontSize,markdownDescription:c.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:W.fontFamily,markdownDescription:c.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:W.padding,description:c.localize(59,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return typeof ce.enabled=="boolean"&&(ce.enabled=ce.enabled?"on":"off"),{enabled:s(ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ce.fontFamily,this.defaultValue.fontFamily),padding:g(ce.padding,this.defaultValue.padding)}}}class Z extends P{constructor(){super(60,"lineDecorationsWidth",10)}validate(W){return typeof W=="string"&&/^\d+(\.\d+)?ch$/.test(W)?-parseFloat(W.substring(0,W.length-2)):f.clampedInt(W,this.defaultValue,0,1e3)}compute(W,ce,Ie){return Ie<0?f.clampedInt(-Ie*W.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class ge extends h{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,W=>h.clamp(W,0,150),{markdownDescription:c.localize(60,null)})}compute(W,ce,Ie){return W.fontInfo.lineHeight}}class ve extends P{constructor(){const W={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",W,{"editor.minimap.enabled":{type:"boolean",default:W.enabled,description:c.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:W.autohide,description:c.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)],default:W.size,description:c.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:W.side,description:c.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:W.showSlider,description:c.localize(68,null)},"editor.minimap.scale":{type:"number",default:W.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:W.renderCharacters,description:c.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:W.maxColumn,description:c.localize(71,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{enabled:g(ce.enabled,this.defaultValue.enabled),autohide:g(ce.autohide,this.defaultValue.autohide),size:s(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ce.side,this.defaultValue.side,["right","left"]),showSlider:s(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(ce.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(ce.scale,1,1,3),maxColumn:f.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function De(oe){return oe==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Re extends P{constructor(){super(78,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{top:f.clampedInt(ce.top,0,0,1e3),bottom:f.clampedInt(ce.bottom,0,0,1e3)}}}class ze extends P{constructor(){const W={enabled:!0,cycle:!1};super(79,"parameterHints",W,{"editor.parameterHints.enabled":{type:"boolean",default:W.enabled,description:c.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:W.cycle,description:c.localize(75,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{enabled:g(ce.enabled,this.defaultValue.enabled),cycle:g(ce.cycle,this.defaultValue.cycle)}}}class se extends v{constructor(){super(134)}compute(W,ce,Ie){return W.pixelRatio}}class ue extends P{constructor(){const W={other:"on",comments:"off",strings:"off"},ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(76,null),c.localize(77,null),c.localize(78,null)]}];super(82,"quickSuggestions",W,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ce,default:W.strings,description:c.localize(79,null)},comments:{anyOf:ce,default:W.comments,description:c.localize(80,null)},other:{anyOf:ce,default:W.other,description:c.localize(81,null)}},default:W,markdownDescription:c.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=W}validate(W){if(typeof W=="boolean"){const ft=W?"on":"off";return{comments:ft,strings:ft,other:ft}}if(!W||typeof W!="object")return this.defaultValue;const{other:ce,comments:Ie,strings:Le}=W,Be=["on","inline","off"];let Xe,Ze,mt;return typeof ce=="boolean"?Xe=ce?"on":"off":Xe=s(ce,this.defaultValue.other,Be),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=s(Ie,this.defaultValue.comments,Be),typeof Le=="boolean"?mt=Le?"on":"off":mt=s(Le,this.defaultValue.strings,Be),{other:Xe,comments:Ze,strings:mt}}}var he;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(he=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends P{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(83,null),c.localize(84,null),c.localize(85,null),c.localize(86,null)],default:"on",description:c.localize(87,null)})}validate(W){let ce=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof W<"u"&&(typeof W=="function"?(ce=4,Ie=W):W==="interval"?ce=3:W==="relative"?ce=2:W==="on"?ce=1:ce=0),{renderType:ce,renderFn:Ie}}}function ae(oe){const W=oe.get(90);return W==="editable"?oe.get(84):W!=="on"}e.filterValidationDecorations=ae;class re extends P{constructor(){const W=[],ce={type:"number",description:c.localize(88,null)};super(94,"rulers",W,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:c.localize(89,null),format:"color-hex"}}}]},default:W,description:c.localize(90,null)})}validate(W){if(Array.isArray(W)){const ce=[];for(const Ie of W)if(typeof Ie=="number")ce.push({column:f.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;ce.push({column:f.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ce.sort((Ie,Le)=>Ie.column-Le.column),ce}return this.defaultValue}}function O(oe,W){if(typeof oe!="string")return W;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends P{constructor(){const W={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(95,"scrollbar",W,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(91,null),c.localize(92,null),c.localize(93,null)],default:"auto",description:c.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(95,null),c.localize(96,null),c.localize(97,null)],default:"auto",description:c.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:W.verticalScrollbarSize,description:c.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:W.horizontalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:W.scrollByPage,description:c.localize(101,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W,Ie=f.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=f.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(ce.vertical,this.defaultValue.vertical),horizontal:O(ce.horizontal,this.defaultValue.horizontal),useShadows:g(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:f.clampedInt(ce.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:f.clampedInt(ce.verticalSliderSize,Le,0,1e3),scrollByPage:g(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends P{constructor(){const W={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(117,"unicodeHighlight",W,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.nonBasicASCII,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:W.invisibleCharacters,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:W.ambiguousCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeComments,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeStrings,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:W.allowedCharacters,description:c.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:W.allowedLocales,description:c.localize(108,null)}})}applyUpdate(W,ce){let Ie=!1;ce.allowedCharacters&&W&&(D.equals(W.allowedCharacters,ce.allowedCharacters)||(W={...W,allowedCharacters:ce.allowedCharacters},Ie=!0)),ce.allowedLocales&&W&&(D.equals(W.allowedLocales,ce.allowedLocales)||(W={...W,allowedLocales:ce.allowedLocales},Ie=!0));const Le=super.applyUpdate(W,ce);return Ie?new E(Le.newValue,!0):Le}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{nonBasicASCII:Pe(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(W.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(W.allowedLocales,this.defaultValue.allowedLocales)}}c(W,ce){if(typeof W!="object"||!W)return ce;const Ie={};for(const[Le,Be]of Object.entries(W))Be===!0&&(Ie[Le]=!0);return Ie}}class Q extends P{constructor(){const W={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",W,{"editor.inlineSuggest.enabled":{type:"boolean",default:W.enabled,description:c.localize(109,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{enabled:g(ce.enabled,this.defaultValue.enabled),mode:s(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class de extends P{constructor(){const W={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",W,{"editor.bracketPairColorization.enabled":{type:"boolean",default:W.enabled,markdownDescription:c.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:W.independentColorPoolPerBracketType,description:c.localize(111,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{enabled:g(ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class be extends P{constructor(){const W={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",W,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(112,null),c.localize(113,null),c.localize(114,null)],default:W.bracketPairs,description:c.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(116,null),c.localize(117,null),c.localize(118,null)],default:W.bracketPairsHorizontal,description:c.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:W.highlightActiveBracketPair,description:c.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:W.indentation,description:c.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(122,null),c.localize(123,null),c.localize(124,null)],default:W.highlightActiveIndentation,description:c.localize(125,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{bracketPairs:Pe(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe(oe,W,ce){const Ie=ce.indexOf(oe);return Ie===-1?W:ce[Ie]}class pe extends P{constructor(){const W={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(110,"suggest",W,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(126,null),c.localize(127,null)],default:W.insertMode,description:c.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:W.filterGraceful,description:c.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:W.localityBonus,description:c.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:W.shareSuggestSelections,markdownDescription:c.localize(131,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:W.snippetsPreventQuickSuggestions,description:c.localize(132,null)},"editor.suggest.showIcons":{type:"boolean",default:W.showIcons,description:c.localize(133,null)},"editor.suggest.showStatusBar":{type:"boolean",default:W.showStatusBar,description:c.localize(134,null)},"editor.suggest.preview":{type:"boolean",default:W.preview,description:c.localize(135,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:W.showInlineDetails,description:c.localize(136,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(137,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(138,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(139,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(140,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(141,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(142,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(143,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(145,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(146,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ce=W;return{insertMode:s(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:g(ce.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:g(ce.showIcons,this.defaultValue.showIcons),showStatusBar:g(ce.showStatusBar,this.defaultValue.showStatusBar),preview:g(ce.preview,this.defaultValue.preview),previewMode:s(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(ce.showMethods,this.defaultValue.showMethods),showFunctions:g(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:g(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(ce.showFields,this.defaultValue.showFields),showVariables:g(ce.showVariables,this.defaultValue.showVariables),showClasses:g(ce.showClasses,this.defaultValue.showClasses),showStructs:g(ce.showStructs,this.defaultValue.showStructs),showInterfaces:g(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:g(ce.showModules,this.defaultValue.showModules),showProperties:g(ce.showProperties,this.defaultValue.showProperties),showEvents:g(ce.showEvents,this.defaultValue.showEvents),showOperators:g(ce.showOperators,this.defaultValue.showOperators),showUnits:g(ce.showUnits,this.defaultValue.showUnits),showValues:g(ce.showValues,this.defaultValue.showValues),showConstants:g(ce.showConstants,this.defaultValue.showConstants),showEnums:g(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:g(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(ce.showKeywords,this.defaultValue.showKeywords),showWords:g(ce.showWords,this.defaultValue.showWords),showColors:g(ce.showColors,this.defaultValue.showColors),showFiles:g(ce.showFiles,this.defaultValue.showFiles),showReferences:g(ce.showReferences,this.defaultValue.showReferences),showFolders:g(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:g(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(ce.showSnippets,this.defaultValue.showSnippets),showUsers:g(ce.showUsers,this.defaultValue.showUsers),showIssues:g(ce.showIssues,this.defaultValue.showIssues)}}}class Ce extends P{constructor(){super(105,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(169,null),default:!0,type:"boolean"}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(W.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends v{constructor(){super(135)}compute(W,ce,Ie){return ce.get(84)?!0:W.tabFocusMode}}var je;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends P{constructor(){super(129,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(170,null),c.localize(171,null),c.localize(172,null),c.localize(173,null)],description:c.localize(174,null),default:"same"}})}validate(W){switch(W){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(W,ce,Ie){return ce.get(2)===2?0:Ie}}class et extends v{constructor(){super(137)}compute(W,ce,Ie){const Le=ce.get(136);return{isDominatedByLongLines:W.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class _e extends P{constructor(){const W={enabled:!0};super(32,"dropIntoEditor",W,{"editor.dropIntoEditor.enabled":{type:"boolean",default:W.enabled,markdownDescription:c.localize(175,null)}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{enabled:g(W.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var it;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.autoClosingBrackets=5]="autoClosingBrackets",oe[oe.autoClosingDelete=6]="autoClosingDelete",oe[oe.autoClosingOvertype=7]="autoClosingOvertype",oe[oe.autoClosingQuotes=8]="autoClosingQuotes",oe[oe.autoIndent=9]="autoIndent",oe[oe.automaticLayout=10]="automaticLayout",oe[oe.autoSurround=11]="autoSurround",oe[oe.bracketPairColorization=12]="bracketPairColorization",oe[oe.guides=13]="guides",oe[oe.codeLens=14]="codeLens",oe[oe.codeLensFontFamily=15]="codeLensFontFamily",oe[oe.codeLensFontSize=16]="codeLensFontSize",oe[oe.colorDecorators=17]="colorDecorators",oe[oe.columnSelection=18]="columnSelection",oe[oe.comments=19]="comments",oe[oe.contextmenu=20]="contextmenu",oe[oe.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=22]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=24]="cursorStyle",oe[oe.cursorSurroundingLines=25]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=27]="cursorWidth",oe[oe.disableLayerHinting=28]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",oe[oe.domReadOnly=30]="domReadOnly",oe[oe.dragAndDrop=31]="dragAndDrop",oe[oe.dropIntoEditor=32]="dropIntoEditor",oe[oe.emptySelectionClipboard=33]="emptySelectionClipboard",oe[oe.extraEditorClassName=34]="extraEditorClassName",oe[oe.fastScrollSensitivity=35]="fastScrollSensitivity",oe[oe.find=36]="find",oe[oe.fixedOverflowWidgets=37]="fixedOverflowWidgets",oe[oe.folding=38]="folding",oe[oe.foldingStrategy=39]="foldingStrategy",oe[oe.foldingHighlight=40]="foldingHighlight",oe[oe.foldingImportsByDefault=41]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=42]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=44]="fontFamily",oe[oe.fontInfo=45]="fontInfo",oe[oe.fontLigatures=46]="fontLigatures",oe[oe.fontSize=47]="fontSize",oe[oe.fontWeight=48]="fontWeight",oe[oe.fontVariations=49]="fontVariations",oe[oe.formatOnPaste=50]="formatOnPaste",oe[oe.formatOnType=51]="formatOnType",oe[oe.glyphMargin=52]="glyphMargin",oe[oe.gotoLocation=53]="gotoLocation",oe[oe.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",oe[oe.hover=55]="hover",oe[oe.inDiffEditor=56]="inDiffEditor",oe[oe.inlineSuggest=57]="inlineSuggest",oe[oe.letterSpacing=58]="letterSpacing",oe[oe.lightbulb=59]="lightbulb",oe[oe.lineDecorationsWidth=60]="lineDecorationsWidth",oe[oe.lineHeight=61]="lineHeight",oe[oe.lineNumbers=62]="lineNumbers",oe[oe.lineNumbersMinChars=63]="lineNumbersMinChars",oe[oe.linkedEditing=64]="linkedEditing",oe[oe.links=65]="links",oe[oe.matchBrackets=66]="matchBrackets",oe[oe.minimap=67]="minimap",oe[oe.mouseStyle=68]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=70]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=72]="multiCursorModifier",oe[oe.multiCursorPaste=73]="multiCursorPaste",oe[oe.multiCursorLimit=74]="multiCursorLimit",oe[oe.occurrencesHighlight=75]="occurrencesHighlight",oe[oe.overviewRulerBorder=76]="overviewRulerBorder",oe[oe.overviewRulerLanes=77]="overviewRulerLanes",oe[oe.padding=78]="padding",oe[oe.parameterHints=79]="parameterHints",oe[oe.peekWidgetDefaultFocus=80]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=81]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=82]="quickSuggestions",oe[oe.quickSuggestionsDelay=83]="quickSuggestionsDelay",oe[oe.readOnly=84]="readOnly",oe[oe.renameOnType=85]="renameOnType",oe[oe.renderControlCharacters=86]="renderControlCharacters",oe[oe.renderFinalNewline=87]="renderFinalNewline",oe[oe.renderLineHighlight=88]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=89]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=90]="renderValidationDecorations",oe[oe.renderWhitespace=91]="renderWhitespace",oe[oe.revealHorizontalRightPadding=92]="revealHorizontalRightPadding",oe[oe.roundedSelection=93]="roundedSelection",oe[oe.rulers=94]="rulers",oe[oe.scrollbar=95]="scrollbar",oe[oe.scrollBeyondLastColumn=96]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=97]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=98]="scrollPredominantAxis",oe[oe.selectionClipboard=99]="selectionClipboard",oe[oe.selectionHighlight=100]="selectionHighlight",oe[oe.selectOnLineNumbers=101]="selectOnLineNumbers",oe[oe.showFoldingControls=102]="showFoldingControls",oe[oe.showUnused=103]="showUnused",oe[oe.snippetSuggestions=104]="snippetSuggestions",oe[oe.smartSelect=105]="smartSelect",oe[oe.smoothScrolling=106]="smoothScrolling",oe[oe.stickyScroll=107]="stickyScroll",oe[oe.stickyTabStops=108]="stickyTabStops",oe[oe.stopRenderingLineAfter=109]="stopRenderingLineAfter",oe[oe.suggest=110]="suggest",oe[oe.suggestFontSize=111]="suggestFontSize",oe[oe.suggestLineHeight=112]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=113]="suggestOnTriggerCharacters",oe[oe.suggestSelection=114]="suggestSelection",oe[oe.tabCompletion=115]="tabCompletion",oe[oe.tabIndex=116]="tabIndex",oe[oe.unicodeHighlighting=117]="unicodeHighlighting",oe[oe.unusualLineTerminators=118]="unusualLineTerminators",oe[oe.useShadowDOM=119]="useShadowDOM",oe[oe.useTabStops=120]="useTabStops",oe[oe.wordBreak=121]="wordBreak",oe[oe.wordSeparators=122]="wordSeparators",oe[oe.wordWrap=123]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=124]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=125]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=126]="wordWrapColumn",oe[oe.wordWrapOverride1=127]="wordWrapOverride1",oe[oe.wordWrapOverride2=128]="wordWrapOverride2",oe[oe.wrappingIndent=129]="wrappingIndent",oe[oe.wrappingStrategy=130]="wrappingStrategy",oe[oe.showDeprecated=131]="showDeprecated",oe[oe.inlayHints=132]="inlayHints",oe[oe.editorClassName=133]="editorClassName",oe[oe.pixelRatio=134]="pixelRatio",oe[oe.tabFocusMode=135]="tabFocusMode",oe[oe.layoutInfo=136]="layoutInfo",oe[oe.wrappingInfo=137]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(176,null)})),acceptSuggestionOnEnter:Me(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(177,null),""],markdownDescription:c.localize(178,null)})),accessibilitySupport:Me(new r),accessibilityPageSize:Me(new f(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(179,null),tags:["accessibility"]})),ariaLabel:Me(new b(4,"ariaLabel",c.localize(180,null))),autoClosingBrackets:Me(new i(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(181,null),c.localize(182,null),""],description:c.localize(183,null)})),autoClosingDelete:Me(new i(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(184,null),""],description:c.localize(185,null)})),autoClosingOvertype:Me(new i(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(186,null),""],description:c.localize(187,null)})),autoClosingQuotes:Me(new i(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(188,null),c.localize(189,null),""],description:c.localize(190,null)})),autoIndent:Me(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[c.localize(191,null),c.localize(192,null),c.localize(193,null),c.localize(194,null),c.localize(195,null)],description:c.localize(196,null)})),automaticLayout:Me(new m(10,"automaticLayout",!1)),autoSurround:Me(new i(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(197,null),c.localize(198,null),c.localize(199,null),""],description:c.localize(200,null)})),bracketPairColorization:Me(new de),bracketPairGuides:Me(new be),stickyTabStops:Me(new m(108,"stickyTabStops",!1,{description:c.localize(201,null)})),codeLens:Me(new m(14,"codeLens",!0,{description:c.localize(202,null)})),codeLensFontFamily:Me(new b(15,"codeLensFontFamily","",{description:c.localize(203,null)})),codeLensFontSize:Me(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(204,null)})),colorDecorators:Me(new m(17,"colorDecorators",!0,{description:c.localize(205,null)})),columnSelection:Me(new m(18,"columnSelection",!1,{description:c.localize(206,null)})),comments:Me(new a),contextmenu:Me(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new m(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(207,null)})),cursorBlinking:Me(new l(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:c.localize(208,null)})),cursorSmoothCaretAnimation:Me(new m(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(209,null)})),cursorStyle:Me(new l(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:c.localize(210,null)})),cursorSurroundingLines:Me(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(211,null)})),cursorSurroundingLinesStyle:Me(new i(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(212,null),c.localize(213,null)],description:c.localize(214,null)})),cursorWidth:Me(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(215,null)})),disableLayerHinting:Me(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new m(30,"domReadOnly",!1)),dragAndDrop:Me(new m(31,"dragAndDrop",!0,{description:c.localize(216,null)})),emptySelectionClipboard:Me(new _),dropIntoEditor:Me(new _e),stickyScroll:Me(new te),extraEditorClassName:Me(new b(34,"extraEditorClassName","")),fastScrollSensitivity:Me(new h(35,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:c.localize(217,null)})),find:Me(new q),fixedOverflowWidgets:Me(new m(37,"fixedOverflowWidgets",!1)),folding:Me(new m(38,"folding",!0,{description:c.localize(218,null)})),foldingStrategy:Me(new i(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(219,null),c.localize(220,null)],description:c.localize(221,null)})),foldingHighlight:Me(new m(40,"foldingHighlight",!0,{description:c.localize(222,null)})),foldingImportsByDefault:Me(new m(41,"foldingImportsByDefault",!1,{description:c.localize(223,null)})),foldingMaximumRegions:Me(new f(42,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(224,null)})),unfoldOnClickAfterEndOfLine:Me(new m(43,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(225,null)})),fontFamily:Me(new b(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(226,null)})),fontInfo:Me(new F),fontLigatures2:Me(new N),fontSize:Me(new B),fontWeight:Me(new U),fontVariations:Me(new M),formatOnPaste:Me(new m(50,"formatOnPaste",!1,{description:c.localize(227,null)})),formatOnType:Me(new m(51,"formatOnType",!1,{description:c.localize(228,null)})),glyphMargin:Me(new m(52,"glyphMargin",!0,{description:c.localize(229,null)})),gotoLocation:Me(new H),hideCursorInOverviewRuler:Me(new m(54,"hideCursorInOverviewRuler",!1,{description:c.localize(230,null)})),hover:Me(new X),inDiffEditor:Me(new m(56,"inDiffEditor",!1)),letterSpacing:Me(new h(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>h.clamp(oe,-5,20),{description:c.localize(231,null)})),lightbulb:Me(new J),lineDecorationsWidth:Me(new Z),lineHeight:Me(new ge),lineNumbers:Me(new ee),lineNumbersMinChars:Me(new f(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new m(64,"linkedEditing",!1,{description:c.localize(232,null)})),links:Me(new m(65,"links",!0,{description:c.localize(233,null)})),matchBrackets:Me(new i(66,"matchBrackets","always",["always","near","never"],{description:c.localize(234,null)})),minimap:Me(new ve),mouseStyle:Me(new i(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new h(69,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:c.localize(235,null)})),mouseWheelZoom:Me(new m(70,"mouseWheelZoom",!1,{markdownDescription:c.localize(236,null)})),multiCursorMergeOverlapping:Me(new m(71,"multiCursorMergeOverlapping",!0,{description:c.localize(237,null)})),multiCursorModifier:Me(new l(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],De,{markdownEnumDescriptions:[c.localize(238,null),c.localize(239,null)],markdownDescription:c.localize(240,null)})),multiCursorPaste:Me(new i(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(241,null),c.localize(242,null)],markdownDescription:c.localize(243,null)})),multiCursorLimit:Me(new f(74,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(244,null)})),occurrencesHighlight:Me(new m(75,"occurrencesHighlight",!0,{description:c.localize(245,null)})),overviewRulerBorder:Me(new m(76,"overviewRulerBorder",!0,{description:c.localize(246,null)})),overviewRulerLanes:Me(new f(77,"overviewRulerLanes",3,0,3)),padding:Me(new Re),parameterHints:Me(new ze),peekWidgetDefaultFocus:Me(new i(80,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(247,null),c.localize(248,null)],description:c.localize(249,null)})),definitionLinkOpensInPeek:Me(new m(81,"definitionLinkOpensInPeek",!1,{description:c.localize(250,null)})),quickSuggestions:Me(new ue),quickSuggestionsDelay:Me(new f(83,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(251,null)})),readOnly:Me(new m(84,"readOnly",!1)),renameOnType:Me(new m(85,"renameOnType",!1,{description:c.localize(252,null),markdownDeprecationMessage:c.localize(253,null)})),renderControlCharacters:Me(new m(86,"renderControlCharacters",!0,{description:c.localize(254,null),restricted:!0})),renderFinalNewline:Me(new i(87,"renderFinalNewline",t.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(255,null)})),renderLineHighlight:Me(new i(88,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(256,null)],description:c.localize(257,null)})),renderLineHighlightOnlyWhenFocus:Me(new m(89,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(258,null)})),renderValidationDecorations:Me(new i(90,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new i(91,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(259,null),c.localize(260,null),c.localize(261,null),""],description:c.localize(262,null)})),revealHorizontalRightPadding:Me(new f(92,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new m(93,"roundedSelection",!0,{description:c.localize(263,null)})),rulers:Me(new re),scrollbar:Me(new $),scrollBeyondLastColumn:Me(new f(96,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(264,null)})),scrollBeyondLastLine:Me(new m(97,"scrollBeyondLastLine",!0,{description:c.localize(265,null)})),scrollPredominantAxis:Me(new m(98,"scrollPredominantAxis",!0,{description:c.localize(266,null)})),selectionClipboard:Me(new m(99,"selectionClipboard",!0,{description:c.localize(267,null),included:t.isLinux})),selectionHighlight:Me(new m(100,"selectionHighlight",!0,{description:c.localize(268,null)})),selectOnLineNumbers:Me(new m(101,"selectOnLineNumbers",!0)),showFoldingControls:Me(new i(102,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(269,null),c.localize(270,null),c.localize(271,null)],description:c.localize(272,null)})),showUnused:Me(new m(103,"showUnused",!0,{description:c.localize(273,null)})),showDeprecated:Me(new m(131,"showDeprecated",!0,{description:c.localize(274,null)})),inlayHints:Me(new le),snippetSuggestions:Me(new i(104,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(275,null),c.localize(276,null),c.localize(277,null),c.localize(278,null)],description:c.localize(279,null)})),smartSelect:Me(new Ce),smoothScrolling:Me(new m(106,"smoothScrolling",!1,{description:c.localize(280,null)})),stopRenderingLineAfter:Me(new f(109,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new pe),inlineSuggest:Me(new Q),suggestFontSize:Me(new f(111,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(281,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new f(112,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(282,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new m(113,"suggestOnTriggerCharacters",!0,{description:c.localize(283,null)})),suggestSelection:Me(new i(114,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(284,null),c.localize(285,null),c.localize(286,null)],description:c.localize(287,null)})),tabCompletion:Me(new i(115,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(288,null),c.localize(289,null),c.localize(290,null)],description:c.localize(291,null)})),tabIndex:Me(new f(116,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new G),unusualLineTerminators:Me(new i(118,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(292,null),c.localize(293,null),c.localize(294,null)],description:c.localize(295,null)})),useShadowDOM:Me(new m(119,"useShadowDOM",!0)),useTabStops:Me(new m(120,"useTabStops",!0,{description:c.localize(296,null)})),wordBreak:Me(new i(121,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null)],description:c.localize(299,null)})),wordSeparators:Me(new b(122,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:c.localize(300,null)})),wordWrap:Me(new i(123,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null),c.localize(304,null)],description:c.localize(305,null)})),wordWrapBreakAfterCharacters:Me(new b(124,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new b(125,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new f(126,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(306,null)})),wordWrapOverride1:Me(new i(127,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new i(128,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new z),pixelRatio:Me(new se),tabFocusMode:Me(new ke),layoutInfo:Me(new x),wrappingInfo:Me(new et),wrappingIndent:Me(new Ge),wrappingStrategy:Me(new Y)}}),define(Se[165],ye([19,20]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[166],ye([19,20]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[167],ye([19,20]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[168],ye([19,20]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[169],ye([19,20]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Se[170],ye([19,20]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Se[171],ye([19,20]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(Se[172],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[173],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[174],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[175],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[176],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[177],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[178],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[179],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[180],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Se[181],ye([19,20]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Se[182],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[183],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[184],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[185],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[186],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[187],ye([19,20]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[188],ye([19,20]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[189],ye([19,20]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[190],ye([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(A,D){this.a.set(A,D)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const D in A.contributes){const T=this.a.get(D);if(!T)continue;const S=A.contributes[D],y=Array.isArray(S)?S:[S];try{T(y,A.activationEvents)}catch(R){(0,c.onUnexpectedError)(R)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(Se[191],ye([1,0,24,42,167,310]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(m){return m=m.trim(),m==="*"||D.test(m)}e.isValidVersionStr=S;function y(m){if(!S(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=m.match(D);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=y;function R(m){if(!m)return null;const w=m.majorBase,f=m.majorMustEqual,h=m.minorBase;let b=m.minorMustEqual;const s=m.patchBase;let i=m.patchMustEqual;m.hasCaret&&(w===0||(b=!1),i=!1);let l=0;if(m.preRelease){const u=T.exec(m.preRelease);if(u){const[,r,a,n]=u;l=Date.UTC(Number(r),Number(a)-1,Number(n))}}return{majorBase:w,majorMustEqual:f,minorBase:h,minorMustEqual:b,patchBase:s,patchMustEqual:i,isMinimum:m.hasGreaterEquals,notBefore:l}}e.normalizeVersion=R;function P(m,w,f){let h;typeof m=="string"?h=R(y(m)):h=m;let b;w instanceof Date?b=w.getTime():typeof w=="string"&&(b=new Date(w).getTime());let s;if(typeof f=="string"?s=R(y(f)):s=f,!h||!s)return!1;const i=h.majorBase,l=h.minorBase,u=h.patchBase;let r=s.majorBase,a=s.minorBase,n=s.patchBase;const o=s.notBefore;let p=s.majorMustEqual,I=s.minorMustEqual,L=s.patchMustEqual;return s.isMinimum?i>r?!0:i<r?!1:l>a?!0:l<a||b&&b<o?!1:u>=n:(i===1&&r===0&&(!p||!I||!L)&&(r=1,a=0,n=0,p=!0,I=!1,L=!1),i<r?!1:i>r?!p:l<a?!1:l>a?!I:u<n?!1:u>n?!L:!(b&&b<o))}e.isValidVersion=P;function E(m,w,f,h,b){const s=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return s.push([t.default.Error,k.localize(0,null)]),s;if(typeof h.name!="string")return s.push([t.default.Error,k.localize(1,null,"name")]),s;if(typeof h.version!="string")return s.push([t.default.Error,k.localize(2,null,"version")]),s;if(!h.engines)return s.push([t.default.Error,k.localize(3,null,"engines")]),s;if(typeof h.engines.vscode!="string")return s.push([t.default.Error,k.localize(4,null,"engines.vscode")]),s;if(typeof h.extensionDependencies<"u"&&!g(h.extensionDependencies))return s.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),s;if(typeof h.activationEvents<"u"){if(!g(h.activationEvents))return s.push([t.default.Error,k.localize(6,null,"activationEvents")]),s;if(typeof h.main>"u"&&typeof h.browser>"u")return s.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),s}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&s.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return s.push([t.default.Error,k.localize(9,null,"main")]),s;{const u=(0,c.joinPath)(f,h.main);(0,c.isEqualOrParent)(u,f)||s.push([t.default.Warning,k.localize(10,null,u.path,f.path)])}if(typeof h.activationEvents>"u")return s.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),s}if(typeof h.browser<"u"){if(typeof h.browser!="string")return s.push([t.default.Error,k.localize(12,null,"browser")]),s;{const u=(0,c.joinPath)(f,h.browser);(0,c.isEqualOrParent)(u,f)||s.push([t.default.Warning,k.localize(13,null,u.path,f.path)])}if(typeof h.activationEvents>"u")return s.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),s}if(!A.valid(h.version))return s.push([t.default.Error,k.localize(15,null)]),s;const i=[];if(!C(m,w,h,b,i))for(const u of i)s.push([t.default.Error,u]);return s}e.validateExtensionManifest=E;function C(m,w,f,h,b){return h||typeof f.main>"u"&&typeof f.browser>"u"?!0:d(m,w,f.engines.vscode,b)}e.isValidExtensionVersion=C;function v(m,w,f){return m==="*"||d(w,f,m)}e.isEngineValid=v;function d(m,w,f,h=[]){const b=R(y(f));if(!b)return h.push(k.localize(16,null,f)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return h.push(k.localize(17,null,f)),!1}else if(!b.majorMustEqual)return h.push(k.localize(18,null,f)),!1;return P(m,w,b)?!0:(h.push(k.localize(19,null,m,f)),!1)}function g(m){if(!Array.isArray(m))return!1;for(let w=0,f=m.length;w<f;w++)if(typeof m[w]!="string")return!1;return!0}}),define(Se[120],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(k,A=[],D=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=c}),define(Se[87],ye([1,0,120]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function A(T,S,y){S instanceof c.SyncDescriptor||(S=new c.SyncDescriptor(S,[],Boolean(y))),t.push([T,S])}e.registerSingleton=A;function D(){return t}e.getSingletonServiceDescriptors=D}),define(Se[192],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(A,D){this.key=A,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class t{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const D of this.a.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const T=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(D);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(A){const D=this.b(A);this.a.delete(D);for(const T of this.a.values())T.outgoing.delete(D),T.incoming.delete(D)}lookupOrInsertNode(A){const D=this.b(A);let T=this.a.get(D);return T||(T=new c(D,A),this.a.set(D,T)),T}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[D,T]of this.a)A.push(`${D}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this.a){const T=new Set([A]),S=this.c(D,T);if(S)return S}}c(A,D){for(const[T,S]of A.outgoing){if(D.has(T))return[...D,T].join(" -> ");D.add(T);const y=this.c(S,D);if(y)return y;D.delete(T)}}}e.Graph=t}),define(Se[3],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=T})(c=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,T,S){T[c.DI_TARGET]===T?T[c.DI_DEPENDENCIES].push({id:D,index:S}):(T[c.DI_DEPENDENCIES]=[{id:D,index:S}],T[c.DI_TARGET]=T)}function k(D){if(c.serviceIds.has(D))return c.serviceIds.get(D);const T=function(S,y,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(T,S,R)};return T.toString=()=>D,c.serviceIds.set(D,T),T}e.createDecorator=k;function A(D){return D}e.refineServiceDecorator=A}),define(Se[52],ye([1,0,11,2,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=A;function D(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var T;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function y(m,w){const f=Object.create(null);for(const h in m)R(f,h,m[h],w);return f}e.toValuesTree=y;function R(m,w,f,h){const b=w.split("."),s=b.pop();let i=m;for(let l=0;l<b.length;l++){const u=b[l];let r=i[u];switch(typeof r){case"undefined":r=i[u]=Object.create(null);break;case"object":break;default:h(`Ignoring ${w} as ${b.slice(0,l+1).join(".")} is ${JSON.stringify(r)}`);return}i=r}if(typeof i=="object"&&i!==null)try{i[s]=f}catch{h(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(i)}`)}else h(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=R;function P(m,w){const f=w.split(".");E(m,f)}e.removeFromValueTree=P;function E(m,w){const f=w.shift();if(w.length===0){delete m[f];return}if(Object.keys(m).indexOf(f)!==-1){const h=m[f];typeof h=="object"&&!Array.isArray(h)&&(E(h,w),Object.keys(h).length===0&&delete m[f])}}function C(m,w,f){function h(i,l){let u=i;for(const r of l){if(typeof u!="object"||u===null)return;u=u[r]}return u}const b=w.split("."),s=h(m,b);return typeof s>"u"?f:s}e.getConfigurationValue=C;function v(m,w,f){Object.keys(w).forEach(h=>{h!=="__proto__"&&(h in m?c.isObject(m[h])&&c.isObject(w[h])?v(m[h],w[h],f):f&&(m[h]=w[h]):m[h]=w[h])})}e.merge=v;function d(m,w,f){const h=m.inspect(w),b=m.inspect(f);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:h.defaultValue}e.getMigratedSettingValue=d;function g(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(Se[53],ye([1,0,12,8,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",c.isMacintosh),A.set("isLinux",c.isLinux),A.set("isWindows",c.isWindows),A.set("isWeb",c.isWeb),A.set("isMacNative",c.isMacintosh&&!c.isWeb),A.set("isEdge",c.isEdge),A.set("isFirefox",c.isFirefox),A.set("isChrome",c.isChrome),A.set("isSafari",c.isSafari);const D=Object.prototype.hasOwnProperty;var T;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return P.INSTANCE}static true(){return E.INSTANCE}static has(N){return C.create(N)}static equals(N,M){return v.create(N,M)}static notEquals(N,M){return m.create(N,M)}static regex(N,M){return l.create(N,M)}static in(N,M){return d.create(N,M)}static notIn(N,M){return g.create(N,M)}static not(N){return w.create(N)}static and(...N){return a.create(N,null,!0)}static or(...N){return n.create(N,null,!0)}static greater(N,M){return h.create(N,M)}static greaterEquals(N,M){return b.create(N,M)}static smaller(N,M){return s.create(N,M)}static smallerEquals(N,M){return i.create(N,M)}static deserialize(N,M=!1){if(!!N)return this.c(N,M)}static c(N,M){const F=N.split("||");return n.create(F.map(B=>this.d(B,M)),null,!0)}static d(N,M){const F=N.split("&&");return a.create(F.map(B=>this.f(B,M)),null,!0)}static f(N,M){if(N=N.trim(),N.indexOf("!=")>=0){const F=N.split("!=");return m.create(F[0].trim(),this.g(F[1],M))}if(N.indexOf("==")>=0){const F=N.split("==");return v.create(F[0].trim(),this.g(F[1],M))}if(N.indexOf("=~")>=0){const F=N.split("=~");return l.create(F[0].trim(),this.h(F[1],M))}if(N.indexOf(" not in ")>=0){const F=N.split(" not in ");return g.create(F[0].trim(),this.g(F[1],M))}if(N.indexOf(" in ")>=0){const F=N.split(" in ");return d.create(F[0].trim(),this.g(F[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const F=N.split(">=");return b.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const F=N.split(">");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const F=N.split("<=");return i.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const F=N.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(N)?w.create(N.substr(1).trim()):C.create(N)}static g(N,M){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const F=/^'([^']*)'$/.exec(N);return F?F[1].trim():N}static h(N,M){if((0,t.isFalsyOrWhitespace)(N)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=N.indexOf("/"),B=N.lastIndexOf("/");if(F===B||F<0){if(M)throw new Error(`bad regexp-value '${N}', missing /-enclosure`);return console.warn(`bad regexp-value '${N}', missing /-enclosure`),null}const U=N.slice(F+1,B),H=N[B+1]==="i"?"i":"";try{return new RegExp(U,H)}catch(X){if(M)throw new Error(`bad regexp-value '${N}', parse error: ${X}`);return console.warn(`bad regexp-value '${N}', parse error: ${X}`),null}}}e.ContextKeyExpr=S;function y(q,N){const M=q?q.substituteConstants():void 0,F=N?N.substituteConstants():void 0;return!M&&!F?!0:!M||!F?!1:M.equals(F)}e.expressionsAreEqualWithConstantSubstitution=y;function R(q,N){return q.cmp(N)}class P{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class E{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class C{static create(N,M=null){const F=A.get(N);return typeof F=="boolean"?F?E.INSTANCE:P.INSTANCE:new C(N,M)}constructor(N,M){this.key=N,this.c=M,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:p(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=A.get(this.key);return typeof N=="boolean"?N?E.INSTANCE:P.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=w.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=C;class v{static create(N,M,F=null){if(typeof M=="boolean")return M?C.create(N,F):w.create(N,F);const B=A.get(N);return typeof B=="boolean"?M===(B?"true":"false")?E.INSTANCE:P.INSTANCE:new v(N,M,F)}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=A.get(this.c);if(typeof N=="boolean"){const M=N?"true":"false";return this.d===M?E.INSTANCE:P.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=v;class d{static create(N,M){return new d(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:I(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const M=N.getValue(this.f),F=N.getValue(this.d);return Array.isArray(M)?M.includes(F):typeof F=="string"&&typeof M=="object"&&M!==null?D.call(M,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=d;class g{static create(N,M){return new g(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=11,this.c=d.create(N,M)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=g;class m{static create(N,M,F=null){if(typeof M=="boolean")return M?w.create(N,F):C.create(N,F);const B=A.get(N);return typeof B=="boolean"?M===(B?"true":"false")?P.INSTANCE:E.INSTANCE:new m(N,M,F)}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=A.get(this.c);if(typeof N=="boolean"){const M=N?"true":"false";return this.d===M?P.INSTANCE:E.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=m;class w{static create(N,M=null){const F=A.get(N);return typeof F=="boolean"?F?P.INSTANCE:E.INSTANCE:new w(N,M)}constructor(N,M){this.c=N,this.d=M,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:p(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=A.get(this.c);return typeof N=="boolean"?N?P.INSTANCE:E.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=C.create(this.c,this)),this.d}}e.ContextKeyNotExpr=w;function f(q,N){if(typeof q=="string"){const M=parseFloat(q);isNaN(M)||(q=M)}return typeof q=="string"||typeof q=="number"?N(q):P.INSTANCE}class h{static create(N,M,F=null){return f(M,B=>new h(N,B,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=h;class b{static create(N,M,F=null){return f(M,B=>new b(N,B,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=b;class s{static create(N,M,F=null){return f(M,B=>new s(N,B,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class i{static create(N,M,F=null){return f(M,B=>new i(N,B,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=i;class l{static create(N,M){return new l(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const M=this.f?this.f.source:"",F=N.f?N.f.source:"";return M<F?-1:M>F?1:0}equals(N){if(N.type===this.type){const M=this.f?this.f.source:"",F=N.f?N.f.source:"";return this.d===N.d&&M===F}return!1}substituteConstants(){return this}evaluate(N){const M=N.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=l;class u{static create(N){return new u(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(N){return new u(this.c.map(N))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function r(q){let N=null;for(let M=0,F=q.length;M<F;M++){const B=q[M].substituteConstants();if(q[M]!==B&&N===null){N=[];for(let U=0;U<M;U++)N[U]=q[U]}N!==null&&(N[M]=B)}return N===null?q:N}class a{static create(N,M,F){return a.d(N,M,F)}constructor(N,M){this.expr=N,this.c=M,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const B=R(this.expr[M],N.expr[M]);if(B!==0)return B}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(N.expr[M]))return!1;return!0}return!1}substituteConstants(){const N=r(this.expr);return N===this.expr?this:a.create(N,this.c,!1)}evaluate(N){for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].evaluate(N))return!1;return!0}static d(N,M,F){const B=[];let U=!1;for(const H of N)if(!!H){if(H.type===1){U=!0;continue}if(H.type===0)return P.INSTANCE;if(H.type===6){B.push(...H.expr);continue}B.push(H)}if(B.length===0&&U)return E.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(R);for(let H=1;H<B.length;H++)B[H-1].equals(B[H])&&(B.splice(H,1),H--);if(B.length===1)return B[0];for(;B.length>1;){const H=B[B.length-1];if(H.type!==9)break;B.pop();const X=B.pop(),V=B.length===0,x=n.create(H.expr.map(Y=>a.create([Y,X],null,F)),null,V);x&&(B.push(x),B.sort(R))}if(B.length===1)return B[0];if(F){for(let H=0;H<B.length;H++)for(let X=H+1;X<B.length;X++)if(B[H].negate().equals(B[X]))return P.INSTANCE;if(B.length===1)return B[0]}return new a(B,M)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const M of this.expr)N.push(...M.keys());return N}map(N){return new a(this.expr.map(M=>M.map(N)),null)}negate(){if(!this.c){const N=[];for(const M of this.expr)N.push(M.negate());this.c=n.create(N,this,!0)}return this.c}}class n{static create(N,M,F){return n.d(N,M,F)}constructor(N,M){this.expr=N,this.c=M,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const B=R(this.expr[M],N.expr[M]);if(B!==0)return B}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(N.expr[M]))return!1;return!0}return!1}substituteConstants(){const N=r(this.expr);return N===this.expr?this:n.create(N,this.c,!1)}evaluate(N){for(let M=0,F=this.expr.length;M<F;M++)if(this.expr[M].evaluate(N))return!0;return!1}static d(N,M,F){let B=[],U=!1;if(N){for(let H=0,X=N.length;H<X;H++){const V=N[H];if(!!V){if(V.type===0){U=!0;continue}if(V.type===1)return E.INSTANCE;if(V.type===9){B=B.concat(V.expr);continue}B.push(V)}}if(B.length===0&&U)return P.INSTANCE;B.sort(R)}if(B.length!==0){if(B.length===1)return B[0];for(let H=1;H<B.length;H++)B[H-1].equals(B[H])&&(B.splice(H,1),H--);if(B.length===1)return B[0];if(F){for(let H=0;H<B.length;H++)for(let X=H+1;X<B.length;X++)if(B[H].negate().equals(B[X]))return E.INSTANCE;if(B.length===1)return B[0]}return new n(B,M)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const M of this.expr)N.push(...M.keys());return N}map(N){return new n(this.expr.map(M=>M.map(N)),null)}negate(){if(!this.c){const N=[];for(const M of this.expr)N.push(M.negate());for(;N.length>1;){const M=N.shift(),F=N.shift(),B=[];for(const U of _(M))for(const H of _(F))B.push(a.create([U,H],null,!1));N.unshift(n.create(B,null,!1))}this.c=n.create(N,this,!0)}return this.c}}class o extends C{static all(){return o.d.values()}constructor(N,M,F){super(N,null),this.f=M,typeof F=="object"?o.d.push({...F,key:N}):F!==!0&&o.d.push({key:N,description:F,type:M!=null?typeof M:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return v.create(this.key,N)}notEqualsTo(N){return m.create(this.key,N)}}e.RawContextKey=o,o.d=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function p(q,N){return q<N?-1:q>N?1:0}function I(q,N,M,F){return q<M?-1:q>M?1:N<F?-1:N>F?1:0}function L(q,N){if(q.type===0||N.type===1)return!0;if(q.type===9)return N.type===9?z(q.expr,N.expr):!1;if(N.type===9){for(const M of N.expr)if(L(q,M))return!0;return!1}if(q.type===6){if(N.type===6)return z(N.expr,q.expr);for(const M of q.expr)if(L(M,N))return!0;return!1}return q.equals(N)}e.implies=L;function z(q,N){let M=0,F=0;for(;M<q.length&&F<N.length;){const B=q[M].cmp(N[F]);if(B<0)return!1;B===0&&M++,F++}return M===q.length}function _(q){return q.type===9?q.expr:[q]}}),define(Se[193],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(Se[121],ye([1,0,166,3]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function A(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function D(m,w){switch(m){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function T(m,w){return w==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(m,w,f){return T(w,f)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===f?!0:y(f).includes(m)}e.isTargetPlatformCompatible=S;function y(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function R(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=R;var P;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var E;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var C;(function(m){m.Install="install",m.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var v;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var d;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal",m.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(w,f){super(w),this.code=f,this.name=f}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Se[194],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(Se[195],ye([1,0,45,15,9,12,106,29,114,168,194]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=y.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:C.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class C extends E{openTerminal(h,b){return this.spawnTerminal(c,h,S.getWindowsShell(),b)}spawnTerminal(h,b,s,i){const l=b.windowsExec||C.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const u=k.basename(l).toLowerCase();if(u==="cmder"||u==="cmder.exe")return h.spawn(l,i?[i]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return l.indexOf(" ")>=0&&r.push('""'),r.push(l),(u==="wt"||u==="wt.exe")&&r.push("-d ."),new Promise((a,n)=>{const o=g(process),p=h.spawn(s,r,{cwd:i,env:o});p.on("error",n),p.on("exit",()=>a())})}runInTerminal(h,b,s,i,l){const u="windowsExec"in l&&l.windowsExec?l.windowsExec:C.getDefaultTerminalWindows();return new Promise((r,a)=>{const n=`"${b} - ${P}"`,o=`""${s.join('" "')}" & pause"`,p=["/c","start",n,"/wait",u,"/c",o],I=Object.assign({},g(process),i);Object.keys(I).filter(_=>I[_]===null).forEach(_=>delete I[_]);const L={cwd:b,env:I,windowsVerbatimArguments:!0};c.spawn(C.b,p,L).on("error",_=>{a(m(_))}),r(void 0)})}static getDefaultTerminalWindows(){if(!C.d){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");C.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return C.d}}e.WindowsExternalTerminalService=C,C.b="cmd.exe";class v extends E{openTerminal(h,b){return this.spawnTerminal(c,h,b)}runInTerminal(h,b,s,i,l){const u=l.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{if(u===R.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const n=u===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",h||P,"-w",b];for(const z of s)p.push("-a"),p.push(z);if(i){const z=Object.assign({},g(process),i);for(const _ in z){const q=z[_];q===null?(p.push("-u"),p.push(_)):(p.push("-e"),p.push(`${_}=${q}`))}}let I="";const L=c.spawn(v.b,p);L.on("error",z=>{a(m(z))}),L.stderr.on("data",z=>{I+=z.toString()}),L.on("exit",z=>{if(z===0)r(void 0);else if(I){const _=I.split(`
`,1);a(new Error(_[0]))}else a(new Error(y.localize(1,null,n,z)))})}else a(new Error(y.localize(2,null,u)))})}spawnTerminal(h,b,s){const i=b.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((l,u)=>{const r=["-a",i];s&&r.push(s);const a=g(process),n=h.spawn("/usr/bin/open",r,{cwd:s,env:a});n.on("error",u),n.on("exit",()=>l())})}}e.MacExternalTerminalService=v,v.b="/usr/bin/osascript";class d extends E{openTerminal(h,b){return this.spawnTerminal(c,h,b)}runInTerminal(h,b,s,i,l){const u=l.linuxExec?Promise.resolve(l.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{const n=[];u.then(o=>{o.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const p=`${w(s)}; echo; read -p "${d.b}" -n1;`;n.push(`''${p}''`);const I=Object.assign({},g(process),i);Object.keys(I).filter(q=>I[q]===null).forEach(q=>delete I[q]);const L={cwd:b,env:I};let z="";const _=c.spawn(o,n,L);_.on("error",q=>{a(m(q))}),_.stderr.on("data",q=>{z+=q.toString()}),_.on("exit",q=>{if(q===0)r(void 0);else if(z){const N=z.split(`
`,1);a(new Error(N[0]))}else a(new Error(y.localize(4,null,o,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!A.isLinux)d.d=Promise.resolve("xterm");else{const h=await T.Promises.exists("/etc/debian_version");d.d=new Promise(b=>{h?b("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?b("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?b("konsole"):process.env.COLORTERM?b(process.env.COLORTERM):process.env.TERM?b(process.env.TERM):b("xterm")})}return d.d}spawnTerminal(h,b,s){const i=b.linuxExec?Promise.resolve(b.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((l,u)=>{i.then(r=>{const a=g(process),n=h.spawn(r,[],{cwd:s,env:a});n.on("error",u),n.on("exit",()=>l())})})}}e.LinuxExternalTerminalService=d,d.b=y.localize(3,null);function g(f){const h={...f.env};return(0,D.sanitizeProcessEnvironment)(h),h}function m(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(y.localize(5,null,f.path)):f}function w(f){let h="";for(const b of f)b.indexOf(" ")>=0?h+='"'+b+'"':h+=b,h+=" ";return h}}),define(Se[38],ye([1,0,64,9,8,11,2,169,3]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function y(U){return U.create===!0}e.isFileOpenForWriteOptions=y;var R;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var P;(function(U){U[U.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var E;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=C;function v(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=d;function g(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function m(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=m;function w(U){return C(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var f;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(H,X){super(H),this.code=X}}e.FileSystemProviderError=h;function b(U,H){const X=new h(U.toString(),H);return i(X,H),X}e.createFileSystemProviderError=b;function s(U){return U||b((0,T.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=s;function i(U,H){return U.name=H?`${H} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=i;function l(U){if(!U)return f.Unknown;if(U instanceof h)return U.code;const H=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!H)return f.Unknown;switch(H[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=l;function u(U){if(U instanceof I)return U.fileOperationResult;switch(l(U)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class a{constructor(H,X,V){this.resource=H,this.operation=X,this.target=V}isOperation(H){return this.operation===H}}e.FileOperationEvent=a;var n;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class o{constructor(H,X){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const V=new Map;for(const x of H){const Y=V.get(x.type);switch(Y?Y.push([x.resource,x]):V.set(x.type,[[x.resource,x]]),x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}}for(const[x,Y]of V)switch(x){case 1:this.a=c.TernarySearchTree.forUris(()=>X),this.a.fill(Y);break;case 0:this.b=c.TernarySearchTree.forUris(()=>X),this.b.fill(Y);break;case 2:this.c=c.TernarySearchTree.forUris(()=>X),this.c.fill(Y);break}}contains(H,...X){return this.d(H,{includeChildren:!1},...X)}affects(H,...X){return this.d(H,{includeChildren:!0},...X)}d(H,X,...V){if(!H)return!1;const x=V.length>0;return!!((!x||V.includes(1))&&(this.a?.get(H)||X.includeChildren&&this.a?.findSuperstr(H))||(!x||V.includes(0))&&(this.b?.get(H)||X.includeChildren&&this.b?.findSuperstr(H))||(!x||V.includes(2))&&(this.c?.findSubstr(H)||X.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=o;function p(U,H,X){return!U||!H||U===H||H.length>U.length?!1:(H.charAt(H.length-1)!==t.sep&&(H+=t.sep),X?(0,k.startsWithIgnoreCase)(U,H):U.indexOf(H)===0)}e.isParent=p;class I extends Error{constructor(H,X,V){super(H),this.fileOperationResult=X,this.options=V}}e.FileOperationError=I;class L extends I{constructor(H,X,V){super(H,2,V),this.stat=X}}e.NotModifiedSinceFileOperationError=L;var z;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(z=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function q(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=q;async function N(U,H){if(!H.hasProvider(D.URI.from({scheme:U.scheme})))return new Promise(X=>{const V=H.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===U.scheme&&x.added&&(V.dispose(),X())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(H){return(0,A.isNumber)(H)||(H=0),H<M.KB?(0,T.localize)(1,null,H.toFixed(0)):H<M.MB?(0,T.localize)(2,null,(H/M.KB).toFixed(2)):H<M.GB?(0,T.localize)(3,null,(H/M.MB).toFixed(2)):H<M.TB?(0,T.localize)(4,null,(H/M.GB).toFixed(2)):(0,T.localize)(5,null,(H/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var F;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function B(U){return{maxFileSize:U===0?300*M.MB:16*M.GB,maxHeapSize:U===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=B}),define(Se[88],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...k){this.a=new Map;for(const[A,D]of k)this.set(A,D)}set(k,A){const D=this.a.get(k);return this.a.set(k,A),D}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=c}),define(Se[196],ye([1,0,18,10,6,120,192,3,88,63]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class P extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class E{constructor(g=new S.ServiceCollection,m=!1,w,f=R){this.f=g,this.g=m,this.h=w,this.i=f,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=f?w?._globalGraph??new D.Graph(h=>h):void 0}createChild(g){return new E(g,this.g,this,this.i)}invokeFunction(g,...m){const w=v.traceInvocation(this.i,g);let f=!1;try{return g({get:b=>{if(f)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(b,w);if(!s)throw new Error(`[invokeFunction] unknown service '${b}'`);return s}},...m)}finally{f=!0,w.stop()}}createInstance(g,...m){let w,f;return g instanceof A.SyncDescriptor?(w=v.traceCreation(this.i,g.ctor),f=this.j(g.ctor,g.staticArguments.concat(m),w)):(w=v.traceCreation(this.i,g),f=this.j(g,m,w)),w.stop(),f}j(g,m=[],w){const f=T._util.getServiceDependencies(g).sort((s,i)=>s.index-i.index),h=[];for(const s of f){const i=this.m(s.id,w);i||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${s.id}.`,!1),h.push(i)}const b=f.length>0?f[0].index:m.length;if(m.length!==b){console.trace(`[createInstance] First service dependency of ${g.name} at position ${b+1} conflicts with ${m.length} static arguments`);const s=b-m.length;s>0?m=m.concat(new Array(s)):m=m.slice(0,b)}return Reflect.construct(g,m.concat(h))}k(g,m){if(this.f.get(g)instanceof A.SyncDescriptor)this.f.set(g,m);else if(this.h)this.h.k(g,m);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const m=this.f.get(g);return!m&&this.h?this.h.l(g):m}m(g,m){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const w=this.l(g);return w instanceof A.SyncDescriptor?this.q(g,w,m.branch(g,!0)):(m.branch(g,!1),w)}q(g,m,w){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,m,w)}finally{this.o.delete(g)}}r(g,m,w){const f=new D.Graph(s=>s.id.toString());let h=0;const b=[{id:g,desc:m,_trace:w}];for(;b.length;){const s=b.pop();if(f.lookupOrInsertNode(s),h++>1e3)throw new P(f);for(const i of T._util.getServiceDependencies(s.desc.ctor)){const l=this.l(i.id);if(l||this.u(`[createInstance] ${g} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(i.id)),l instanceof A.SyncDescriptor){const u={id:i.id,desc:l,_trace:s._trace.branch(i.id,!0)};f.insertEdge(s,u),b.push(u)}}}for(;;){const s=f.roots();if(s.length===0){if(!f.isEmpty())throw new P(f);break}for(const{data:i}of s){if(this.l(i.id)instanceof A.SyncDescriptor){const u=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,u)}f.removeNode(i)}}return this.l(g)}s(g,m,w=[],f,h){if(this.f.get(g)instanceof A.SyncDescriptor)return this.t(g,m,w,f,h);if(this.h)return this.h.s(g,m,w,f,h);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}t(g,m,w=[],f,h){if(f){const b=new E(void 0,this.g,this,this.i);b.c=String(g);const s=new Map,i=new c.IdleValue(()=>{const l=b.j(m,w,h);for(const[u,r]of s){const a=l[u];if(typeof a=="function")for(const n of r)a.apply(l,n)}return s.clear(),l});return new Proxy(Object.create(null),{get(l,u){if(!i.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let n=s.get(u);return n||(n=new y.LinkedList,s.set(u,n)),(p,I,L)=>{const z=n.push([p,I,L]);return(0,k.toDisposable)(z)}}if(u in l)return l[u];const r=i.value;let a=r[u];return typeof a!="function"||(a=a.bind(r),l[u]=a),a},set(l,u,r){return i.value[u]=r,!0},getPrototypeOf(l){return m.prototype}})}else return this.j(m,w,h)}u(g,m){if(m&&console.warn(g),this.g)throw new Error(g)}}e.InstantiationService=E;var C;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(C||(C={}));class v{static traceInvocation(g,m){return g?new v(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(g,m){return g?new v(1,m.name):v.c}constructor(g,m){this.type=g,this.name=m,this.g=Date.now(),this.h=[]}branch(g,m){const w=new v(3,g.toString());return this.h.push([g,m,w]),w}stop(){const g=Date.now()-this.g;v.f+=g;let m=!1;function w(h,b){const s=[],i=new Array(h+1).join("	");for(const[l,u,r]of b.h)if(u&&r){m=!0,s.push(`${i}CREATES -> ${l}`);const a=w(h+1,r);a&&s.push(a)}else s.push(`${i}uses -> ${l}`);return s.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(g>2||m)&&v.all.add(f.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0}),define(Se[13],ye([1,0,51,4,6,28,12,2,3]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function y(){return new Date().toISOString()}var R;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(R=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=R.Info;function P(a,n,o){switch(n){case R.Trace:a.trace(o);break;case R.Debug:a.debug(o);break;case R.Info:a.info(o);break;case R.Warning:a.warn(o);break;case R.Error:a.error(o);break;case R.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=P;function E(a){let n="";for(let o=0;o<a.length;o++){let p=a[o];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}n+=(o>0?" ":"")+p}return n}e.format=E;class C extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==R.Off&&this.b<=n}}e.AbstractLogger=C;class v extends C{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...o){this.f(R.Trace)&&this.g(R.Trace,E([n,...o]))}debug(n,...o){this.f(R.Debug)&&this.g(R.Debug,E([n,...o]))}info(n,...o){this.f(R.Info)&&this.g(R.Info,E([n,...o]))}warn(n,...o){this.f(R.Warning)&&this.g(R.Warning,E([n,...o]))}error(n,...o){if(this.f(R.Error))if(n instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=n.stack,this.g(R.Error,E(p))}else this.g(R.Error,E([n,...o]))}flush(){}}e.AbstractMessageLogger=v;class d extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!D.isWindows}trace(n,...o){this.f(R.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...o):console.log(`[main ${y()}]`,n,...o))}debug(n,...o){this.f(R.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...o):console.log(`[main ${y()}]`,n,...o))}info(n,...o){this.f(R.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...o):console.log(`[main ${y()}]`,n,...o))}warn(n,...o){this.f(R.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,n,...o):console.warn(`[main ${y()}]`,n,...o))}error(n,...o){this.f(R.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,n,...o):console.error(`[main ${y()}]`,n,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class g extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...o){this.f(R.Trace)&&console.log("%cTRACE","color: #888",n,...o)}debug(n,...o){this.f(R.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...o)}info(n,...o){this.f(R.Info)&&console.log("%c INFO","color: #33f",n,...o)}warn(n,...o){this.f(R.Warning)&&console.log("%c WARN","color: #993",n,...o)}error(n,...o){this.f(R.Error)&&console.log("%c  ERR","color: #f33",n,...o)}dispose(){}flush(){}}e.ConsoleLogger=g;class m extends C{constructor(n,o=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(o)}trace(n,...o){this.f(R.Trace)&&this.g.log(R.Trace,[this.h(n),...o])}debug(n,...o){this.f(R.Debug)&&this.g.log(R.Debug,[this.h(n),...o])}info(n,...o){this.f(R.Info)&&this.g.log(R.Info,[this.h(n),...o])}warn(n,...o){this.f(R.Warning)&&this.g.log(R.Warning,[this.h(n),...o])}error(n,...o){this.f(R.Error)&&this.g.log(R.Error,[this.h(n),...o])}h(n){return typeof n=="string"?n:(0,c.toErrorMessage)(n,this.f(R.Trace))}dispose(){}flush(){}}e.AdapterLogger=m;class w extends C{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const o of this.g)o.setLevel(n);super.setLevel(n)}trace(n,...o){for(const p of this.g)p.trace(n,...o)}debug(n,...o){for(const p of this.g)p.debug(n,...o)}info(n,...o){for(const p of this.g)p.info(n,...o)}warn(n,...o){for(const p of this.g)p.warn(n,...o)}error(n,...o){for(const p of this.g)p.error(n,...o)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=w;class f extends k.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...o){this.b.trace(n,...o)}debug(n,...o){this.b.debug(n,...o)}info(n,...o){this.b.info(n,...o)}warn(n,...o){this.b.warn(n,...o)}error(n,...o){this.b.error(n,...o)}flush(){this.b.flush()}}e.LogService=f;class h extends k.Disposable{constructor(n,o){super(),this.c=n,this.b=new A.ResourceMap,this.B(o(p=>this.setLevel(p)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,o,p){let I=this.b.get(n)?.logger;return I||(p=o?.always?R.Trace:p,I=this.f(n,p??this.c,o),this.b.set(n,{logger:I,logLevel:p})),I}setLevel(n,o){const p=T.URI.isUri(n)?n:void 0,I=p?o:n;if(p){const L=this.b.get(p);L&&L.logLevel!==I&&(L.logLevel=I,L.logger.setLevel(I))}else this.c=I,this.b.forEach(({logLevel:L,logger:z})=>{L===void 0&&z.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=h;class b{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return R.Info}trace(n,...o){}debug(n,...o){}info(n,...o){}warn(n,...o){}error(n,...o){}critical(n,...o){}dispose(){}flush(){}}e.NullLogger=b;class s extends b{}e.NullLogService=s;class i extends h{constructor(){super(R.Info,t.Event.None)}f(n,o,p){return new b}}e.NullLoggerService=i;function l(a){if(a.verbose)return R.Trace;if(typeof a.logLevel=="string"){const n=r(a.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function u(a){switch(a){case R.Trace:return"trace";case R.Debug:return"debug";case R.Info:return"info";case R.Warning:return"warn";case R.Error:return"error";case R.Off:return"off"}}e.LogLevelToString=u;function r(a){switch(a){case"trace":return R.Trace;case"debug":return R.Debug;case"info":return R.Info;case"warn":return R.Warning;case"error":return R.Error;case"critical":return R.Error;case"off":return R.Off}}e.parseLogLevel=r}),define(Se[197],ye([1,0,38,13]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(k||(k={}));async function A(y,R,P,E,C){try{const v=await new Promise((g,m)=>{ne(["spdlog"],g,m)});v.setFlushOn(k.Trace);const d=await v.createAsyncRotatingLogger(y,R,P,E);return C?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(v){console.error(v)}return null}function D(y,R,P){switch(R){case t.LogLevel.Trace:y.trace(P);break;case t.LogLevel.Debug:y.debug(P);break;case t.LogLevel.Info:y.info(P);break;case t.LogLevel.Warning:y.warn(P);break;case t.LogLevel.Error:y.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function T(y,R){switch(R){case t.LogLevel.Trace:y.setLevel(k.Trace);break;case t.LogLevel.Debug:y.setLevel(k.Debug);break;case t.LogLevel.Info:y.setLevel(k.Info);break;case t.LogLevel.Warning:y.setLevel(k.Warning);break;case t.LogLevel.Error:y.setLevel(k.Error);break;case t.LogLevel.Off:y.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class S extends t.AbstractMessageLogger{constructor(R,P,E,C,v){super(),this.k=[],this.setLevel(v),this.l=this.n(R,P,E,C),this.B(this.onDidChangeLogLevel(d=>{this.m&&T(this.m,d)}))}async n(R,P,E,C){const v=E?6:1,d=30/v*c.ByteSize.MB,g=await A(R,P,d,v,C);if(g){this.m=g,T(this.m,this.getLevel());for(const{level:m,message:w}of this.k)D(this.m,m,w);this.k=[]}}g(R,P){this.m?D(this.m,R,P):this.getLevel()<=R&&this.k.push({level:R,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(Se[122],ye([1,0,42,170,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var D;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function y(v,d){return d-v}S.compare=y;const R=Object.create(null);R[S.Error]=(0,t.localize)(0,null),R[S.Warning]=(0,t.localize)(1,null),R[S.Info]=(0,t.localize)(2,null);function P(v){return R[v]||""}S.toString=P;function E(v){switch(v){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=E;function C(v){switch(v){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=C}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const y="";function R(E){return P(E,!0)}S.makeKey=R;function P(E,C){const v=[y];return E.source?v.push(E.source.replace("\xA6","\\\xA6")):v.push(y),E.code?typeof E.code=="string"?v.push(E.code.replace("\xA6","\\\xA6")):v.push(E.code.value.replace("\xA6","\\\xA6")):v.push(y),E.severity!==void 0&&E.severity!==null?v.push(D.toString(E.severity)):v.push(y),E.message&&C?v.push(E.message.replace("\xA6","\\\xA6")):v.push(y),E.startLineNumber!==void 0&&E.startLineNumber!==null?v.push(E.startLineNumber.toString()):v.push(y),E.startColumn!==void 0&&E.startColumn!==null?v.push(E.startColumn.toString()):v.push(y),E.endLineNumber!==void 0&&E.endLineNumber!==null?v.push(E.endLineNumber.toString()):v.push(y),E.endColumn!==void 0&&E.endColumn!==null?v.push(E.endColumn.toString()):v.push(y),v.push(y),v.join("\xA6")}S.makeKeyOptionalMessage=P})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(Se[198],ye([1,0,4,42,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,k.createDecorator)("notificationService");var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(y){y[y.OFF=0]="OFF",y[y.SILENT=1]="SILENT",y[y.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=S}),define(Se[123],ye([1,0,8,2,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService");function A(y,R){return t.URI.isUri(y)?(0,c.equalsIgnoreCase)(y.scheme,R):(0,c.startsWithIgnoreCase)(y,R+":")}e.matchesScheme=A;function D(y,...R){return R.some(P=>A(y,P))}e.matchesSomeScheme=D;function T(y,R){return y.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=T;function S(y){let R;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(y.fragment);return P&&(R={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},y=y.with({fragment:""})),{selection:R,uri:y}}e.extractSelection=S}),define(Se[199],ye([1,0,12,36]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const A=c.globals.vscode.context.configuration();if(A)k=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:A.version})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(Se[200],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ne,e){return function(c,t){e(c,t,ne)}};define(Se[124],ye([1,0,18,21,6,3]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends k.Disposable{constructor(P,E){super(),this.a=new c.DeferredPromise,E.withProgress(P,C=>(this.b=C,this.c&&C.report(this.c),this.a.p)),this.B((0,k.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};S=qe([We(1,e.IProgressService)],S),e.UnmanagedProgress=S;class y extends k.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new k.DisposableStore)}start(P){this.stop();const E=++this.a,C=new t.CancellationTokenSource;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,k.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,k.toDisposable)(()=>C.cancel())),this.b.add((0,k.toDisposable)(()=>this.c?this.c.done():void 0)),{id:E,token:C.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=y,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Se[43],ye([1,0,49,11]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(D,T){c.ok(t.isString(D)),c.ok(t.isObject(T)),c.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,T)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new k}),define(Se[125],ye([1,0,4,43]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class A{constructor(){this.b=new c.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,y){this.a[k(S)]=y,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const D=new A;t.Registry.add(e.Extensions.JSONContribution,D)}),define(Se[126],ye([1,0,17,4,11,165,52,125,43]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=S.Registry.as(T.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(s,i=!0){this.registerConfigurations([s],i)}registerConfigurations(s,i=!0){const l=this.k(s,i);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}deregisterConfigurations(s){const i=this.l(s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:s,remove:i}){const l=[];l.push(...this.l(i)),l.push(...this.k(s,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,c.distinct)(l)})}registerDefaultConfigurations(s){const i=[],l=[];for(const{overrides:u,source:r}of s)for(const a in u)if(i.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const n=this.a.get(a),o=n?.valuesSources??new Map;if(r)for(const z of Object.keys(u[a]))o.set(z,r);const p={...n?.value||{},...u[a]};this.a.set(a,{source:r,value:p,valuesSources:o});const I=(0,D.getLanguageTagSettingPlainKey)(a),L={type:"object",default:p,description:A.localize(1,null,I),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:k.isString(r)?void 0:r,defaultValueSource:r};l.push(...d(a)),this.d[a]=L,this.b.properties[a]=L}else{this.a.set(a,{value:u[a],source:r});const n=this.d[a];n&&(this.s(a,n),this.o(a,n))}this.registerOverrideIdentifiers(l),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const i=[];for(const{overrides:l,source:u}of s)for(const r in l){const a=this.a.get(r),n=k.isString(u)?u:u?.id,o=k.isString(a?.source)?a?.source:a?.source?.id;if(n===o)if(i.push(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const p=this.d[r];p&&(this.s(r,p),this.o(r,p))}}this.q(),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){for(const i of s)this.h.add(i);this.q()}k(s,i){const l=[];return s.forEach(u=>{l.push(...this.m(u,i,u.extensionInfo,u.restrictedProperties)),this.c.push(u),this.n(u)}),l}l(s){const i=[],l=u=>{if(u.properties)for(const r in u.properties){i.push(r);const a=this.d[r];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[r],this.p(r,u.properties[r])}u.allOf?.forEach(r=>l(r))};for(const u of s){l(u);const r=this.c.indexOf(u);r!==-1&&this.c.splice(r,1)}return i}m(s,i=!0,l,u,r=3){r=k.isUndefinedOrNull(s.scope)?r:s.scope;const a=[],n=s.properties;if(n)for(const p in n){const I=n[p];if(i&&f(p,I)){delete n[p];continue}if(I.source=l,I.defaultDefaultValue=n[p].default,this.s(p,I),e.OVERRIDE_PROPERTY_REGEX.test(p)?I.scope=void 0:(I.scope=k.isUndefinedOrNull(I.scope)?r:I.scope,I.restricted=k.isUndefinedOrNull(I.restricted)?!!u?.includes(p):I.restricted),n[p].hasOwnProperty("included")&&!n[p].included){this.f[p]=n[p],delete n[p];continue}else this.d[p]=n[p],n[p].policy?.name&&this.e.set(n[p].policy.name,p);!n[p].deprecationMessage&&n[p].markdownDeprecationMessage&&(n[p].deprecationMessage=n[p].markdownDeprecationMessage),a.push(p)}const o=s.allOf;if(o)for(const p of o)a.push(...this.m(p,i,l,u,r));return a}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(s){const i=l=>{const u=l.properties;if(u)for(const a in u)this.o(a,u[a]);l.allOf?.forEach(i)};i(s)}o(s,i){switch(e.allSettings.properties[s]=i,i.scope){case 1:e.applicationSettings.properties[s]=i;break;case 2:e.machineSettings.properties[s]=i;break;case 6:e.machineOverridableSettings.properties[s]=i;break;case 3:e.windowSettings.properties[s]=i;break;case 4:e.resourceSettings.properties[s]=i;break;case 5:e.resourceSettings.properties[s]=i,this.g.properties[s]=i;break}}p(s,i){switch(delete e.allSettings.properties[s],i.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}q(){for(const s of this.h.values()){const i=`[${s}]`,l={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(i,l),e.allSettings.properties[i]=l,e.applicationSettings.properties[i]=l,e.machineSettings.properties[i]=l,e.machineOverridableSettings.properties[i]=l,e.windowSettings.properties[i]=l,e.resourceSettings.properties[i]=l}this.i.fire()}r(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}s(s,i){const l=this.a.get(s);let u=l?.value,r=l?.source;k.isUndefined(u)&&(u=i.defaultDefaultValue,r=void 0),k.isUndefined(u)&&(u=m(i.type)),i.default=u,i.defaultValueSource=r}}const C="\\[([^\\]]+)\\]",v=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(b){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let i=v.exec(b);for(;i?.length;){const l=i[1].trim();l&&s.push(l),i=v.exec(b)}}return(0,c.distinct)(s)}e.overrideIdentifiersFromKey=d;function g(b){return b.reduce((s,i)=>`${s}[${i}]`,"")}e.keyFromOverrideIdentifiers=g;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const w=new E;S.Registry.add(e.Extensions.Configuration,w);function f(b,s){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?A.localize(7,null,b):w.getConfigurationProperties()[b]!==void 0?A.localize(8,null,b):s.policy?.name&&w.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,b,s.policy?.name,w.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.validateProperty=f;function h(){const b=[],s=w.getConfigurationProperties();for(const i of Object.keys(s))b.push([i,s[i].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=h}),define(Se[201],ye([1,0,17,4,145,6,28,23,11,2,52,126,43]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class C{constructor(i={},l=[],u=[],r){this.c=i,this.d=l,this.f=u,this.raw=r,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(l=>{if(l instanceof C)return l;const u=new v("");return u.parseRaw(l),u.configurationModel});this.g=i.reduce((l,u)=>u===l?u:l.merge(u),i[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(i){return i?(0,R.getConfigurationValue)(this.contents,i):this.contents}inspect(i,l){const u=this.rawConfiguration.getValue(i),r=l?this.rawConfiguration.getOverrideValue(i,l):void 0,a=l?this.rawConfiguration.override(l).getValue(i):u;return{value:u,override:r,merged:a}}getOverrideValue(i,l){const u=this.l(l);return u?i?(0,R.getConfigurationValue)(u,i):u:void 0}getKeysForOverrideIdentifier(i){const l=[];for(const u of this.overrides)u.identifiers.includes(i)&&l.push(...u.keys);return c.distinct(l)}getAllOverrideIdentifiers(){const i=[];for(const l of this.overrides)i.push(...l.identifiers);return c.distinct(i)}override(i){let l=this.b.get(i);return l||(l=this.h(i),this.b.set(i,l)),l}merge(...i){const l=T.deepClone(this.contents),u=T.deepClone(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const n of i)if(a.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(l,n.contents);for(const o of n.overrides){const[p]=u.filter(I=>c.equals(I.identifiers,o.identifiers));p?(this.j(p.contents,o.contents),p.keys.push(...o.keys),p.keys=c.distinct(p.keys)):u.push(T.deepClone(o))}for(const o of n.keys)r.indexOf(o)===-1&&r.push(o)}return new C(l,r,u,a.every(n=>n instanceof C)?void 0:a)}freeze(){return this.a=!0,this}clone(){return new C(T.deepClone(this.contents),[...this.keys],T.deepClone(this.overrides))}h(i){const l=this.l(i);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const u={};for(const r of c.distinct([...Object.keys(this.contents),...Object.keys(l)])){let a=this.contents[r];const n=l[r];n&&(typeof a=="object"&&typeof n=="object"?(a=T.deepClone(a),this.j(a,n)):a=n),u[r]=a}return new C(u,this.keys,this.overrides)}j(i,l){for(const u of Object.keys(l)){if(u in i&&S.isObject(i[u])&&S.isObject(l[u])){this.j(i[u],l[u]);continue}i[u]=T.deepClone(l[u])}}k(i){return this.a&&!Object.isFrozen(i)?T.deepFreeze(i):i}l(i){let l=null,u=null;const r=a=>{a&&(u?this.j(u,a):u=T.deepClone(a))};for(const a of this.overrides)c.equals(a.identifiers,[i])?l=a.contents:a.identifiers.includes(i)&&r(a.contents);return r(l),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,l){this.m(i),(0,R.addToValueTree)(this.contents,i,l,u=>{throw new Error(u)})}removeValue(i){this.n(i)&&(0,R.removeFromValueTree)(this.contents,i)}m(i){let l=this.keys.length;for(let u=0;u<l;u++)i.indexOf(this.keys[u])===0&&(l=u);this.keys.splice(l,1,i)}n(i){const l=this.keys.indexOf(i);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=C;class v{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,l){if(!S.isUndefinedOrNull(i)){const u=this.g(i);this.parseRaw(u,l)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,l){this.a=i;const{contents:u,keys:r,overrides:a,restricted:n,hasExcludedProperties:o}=this.h(i,l);this.b=new C(u,r,a,o?[i]:void 0),this.c=n||[]}g(i){let l={},u=null,r=[];const a=[],n=[];function o(I){Array.isArray(r)?r.push(I):u!==null&&(r[u]=I)}const p={onObjectBegin:()=>{const I={};o(I),a.push(r),r=I,u=null},onObjectProperty:I=>{u=I},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const I=[];o(I),a.push(r),r=I,u=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:o,onError:(I,L,z)=>{n.push({error:I,offset:L,length:z})}};if(i)try{k.visit(i,p),l=r[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return l}h(i,l){const u=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.j(i,u,!0,l);i=r.raw;const a=(0,R.toValuesTree)(i,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),n=Object.keys(i),o=this.l(i,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:a,keys:n,overrides:o,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}j(i,l,u,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const n={},o=[];for(const p in i)if(P.OVERRIDE_PROPERTY_REGEX.test(p)&&u){const I=this.j(i[p],l,!1,r);n[p]=I.raw,a=a||I.hasExcludedProperties,o.push(...I.restricted)}else{const I=l[p],L=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&o.push(p),(L===void 0||r.scopes===void 0||r.scopes.includes(L))&&!(r.skipRestricted&&I?.restricted)?n[p]=i[p]:a=!0}return{raw:n,restricted:o,hasExcludedProperties:a}}l(i,l){const u=[];for(const r of Object.keys(i))if(P.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const n in i[r])a[n]=i[r][n];u.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,R.toValuesTree)(a,l)})}return u}}e.ConfigurationModelParser=v;class d extends A.Disposable{constructor(i,l,u,r){super(),this.f=i,this.g=l,this.h=r,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(u.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&u.isEqual(a.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new C}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class g{constructor(i,l,u,r,a,n,o,p,I,L,z,_,q){this.a=i,this.b=l,this.value=u,this.overrideIdentifiers=r,this.c=a,this.d=n,this.f=o,this.g=p,this.h=I,this.j=L,this.k=z,this.l=_,this.m=q}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class m{constructor(i,l,u,r,a=new C,n=new C,o=new D.ResourceMap,p=new C,I=new D.ResourceMap,L=!0){this.c=i,this.d=l,this.f=u,this.g=r,this.h=a,this.j=n,this.l=o,this.m=p,this.n=I,this.p=L,this.a=null,this.b=new D.ResourceMap,this.q=null}getValue(i,l,u){return this.s(i,l,u).getValue(i)}updateValue(i,l,u={}){let r;u.resource?(r=this.n.get(u.resource),r||(r=new C,this.n.set(u.resource,r))):r=this.m,l===void 0?r.removeValue(i):r.setValue(i,l),u.resource||(this.a=null)}inspect(i,l,u){const r=this.s(i,l,u),a=c.distinct(r.overrides.map(p=>p.identifiers).flat()).filter(p=>r.getOverrideValue(i,p)!==void 0),n=this.w(l.resource,u),o=l.resource?this.n.get(l.resource)||this.m:this.m;return new g(i,l,r.getValue(i),a.length?a:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),u?this.j.freeze():void 0,n?n.freeze():void 0,o.inspect(i,l.overrideIdentifier))}keys(i){const l=this.w(void 0,i);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.j=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,l){this.l.set(i,l),this.b.delete(i)}deleteFolderConfiguration(i){this.r.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,l){const u=[];if(!l){const{added:r,updated:a,removed:n}=h(this.c,i);l=[...r,...a,...n]}for(const r of l)for(const a of(0,P.overrideIdentifiersFromKey)(r)){const n=this.c.getKeysForOverrideIdentifier(a),o=i.getKeysForOverrideIdentifier(a),p=[...o.filter(I=>n.indexOf(I)===-1),...n.filter(I=>o.indexOf(I)===-1),...n.filter(I=>!T.equals(this.c.override(a).getValue(I),i.override(a).getValue(I)))];u.push([a,p])}return this.updateDefaultConfiguration(i),{keys:l,overrides:u}}compareAndUpdatePolicyConfiguration(i){const{added:l,updated:u,removed:r}=h(this.d,i),a=[...l,...u,...r];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:l,updated:u,removed:r,overrides:a}=h(this.applicationConfiguration,i),n=[...l,...u,...r];return n.length&&this.updateApplicationConfiguration(i),{keys:n,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:l,updated:u,removed:r,overrides:a}=h(this.localUserConfiguration,i),n=[...l,...u,...r];return n.length&&this.updateLocalUserConfiguration(i),{keys:n,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:l,updated:u,removed:r,overrides:a}=h(this.remoteUserConfiguration,i),n=[...l,...u,...r];return n.length&&this.updateRemoteUserConfiguration(i),{keys:n,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:l,updated:u,removed:r,overrides:a}=h(this.workspaceConfiguration,i),n=[...l,...u,...r];return n.length&&this.updateWorkspaceConfiguration(i),{keys:n,overrides:a}}compareAndUpdateFolderConfiguration(i,l){const u=this.r.get(i),{added:r,updated:a,removed:n,overrides:o}=h(u,l),p=[...r,...a,...n];return(p.length||!u)&&this.updateFolderConfiguration(i,l),{keys:p,overrides:o}}compareAndDeleteFolderConfiguration(i){const l=this.r.get(i);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:u,updated:r,removed:a,overrides:n}=h(l,void 0);return{keys:[...u,...r,...a],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(i,l,u){let r=this.t(l,u);return l.overrideIdentifier&&(r=r.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(r=r.merge(this.d)),r}t({resource:i},l){let u=this.u();if(l&&i){const r=l.getFolder(i);r&&(u=this.v(r.uri)||u);const a=this.n.get(i);a&&(u=u.merge(a))}return u}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(i){let l=this.b.get(i);if(!l){const u=this.u(),r=this.l.get(i);r?(l=u.merge(r),this.p&&(l=l.freeze()),this.b.set(i,l)):l=u}return l}w(i,l){if(l&&i){const u=l.getFolder(i);if(u)return this.l.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((i,l)=>{const{contents:u,overrides:r,keys:a}=this.l.get(l);return i.push([l,{contents:u,overrides:r,keys:a}]),i},[])}}allKeys(){const i=new Set;return this.c.freeze().keys.forEach(l=>i.add(l)),this.userConfiguration.freeze().keys.forEach(l=>i.add(l)),this.j.freeze().keys.forEach(l=>i.add(l)),this.l.forEach(l=>l.freeze().keys.forEach(u=>i.add(u))),[...i.values()]}x(){const i=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(l=>i.add(l)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(l=>i.add(l)),this.j.freeze().getAllOverrideIdentifiers().forEach(l=>i.add(l)),this.l.forEach(l=>l.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u))),[...i.values()]}y(i){const l=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(u=>l.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>l.add(u)),this.j.getKeysForOverrideIdentifier(i).forEach(u=>l.add(u)),this.l.forEach(u=>u.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r))),[...l.values()]}static parse(i){const l=this.z(i.defaults),u=this.z(i.policy),r=this.z(i.application),a=this.z(i.user),n=this.z(i.workspace),o=i.folders.reduce((p,I)=>(p.set(y.URI.revive(I[0]),this.z(I[1])),p),new D.ResourceMap);return new m(l,u,r,a,new C,n,o,new C,new D.ResourceMap,!1)}static z(i){return new C(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=m;function w(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,l=new Map;for(const r of s)r.keys.forEach(a=>i.add(a)),r.overrides.forEach(([a,n])=>{const o=(0,D.getOrSet)(l,a,new Set);n.forEach(p=>o.add(p))});const u=[];return l.forEach((r,a)=>u.push([a,[...r.values()]])),{keys:[...i.values()],overrides:u}}e.mergeChanges=w;class f{constructor(i,l,u,r){this.change=i,this.b=l,this.c=u,this.d=r,this.f=void 0;const a=new Set;i.keys.forEach(o=>a.add(o)),i.overrides.forEach(([,o])=>o.forEach(p=>a.add(p))),this.affectedKeys=[...a.values()];const n=new C;this.affectedKeys.forEach(o=>n.setValue(o,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=m.parse(this.b.data)),this.f}affectsConfiguration(i,l){if(this.g(this.a,i)){if(l){const u=this.previousConfiguration?this.previousConfiguration.getValue(i,l,this.b?.workspace):void 0,r=this.c.getValue(i,l,this.d);return!T.equals(u,r)}return!0}return!1}g(i,l){let u=(0,R.toValuesTree)({[l]:!0},()=>{}),r;for(;typeof u=="object"&&(r=Object.keys(u)[0]);){if(i=i[r],!i)return!1;u=u[r]}return!0}}e.ConfigurationChangeEvent=f;function h(s,i){const{added:l,removed:u,updated:r}=b(i?.rawConfiguration,s?.rawConfiguration),a=[],n=s?.getAllOverrideIdentifiers()||[],o=i?.getAllOverrideIdentifiers()||[];if(i){const p=o.filter(I=>!n.includes(I));for(const I of p)a.push([I,i.getKeysForOverrideIdentifier(I)])}if(s){const p=n.filter(I=>!o.includes(I));for(const I of p)a.push([I,s.getKeysForOverrideIdentifier(I)])}if(i&&s){for(const p of n)if(o.includes(p)){const I=b({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:i.getOverrideValue(void 0,p)||{},keys:i.getKeysForOverrideIdentifier(p)});a.push([p,[...I.added,...I.removed,...I.updated]])}}return{added:l,removed:u,updated:r,overrides:a}}function b(s,i){const l=s?i?s.keys.filter(a=>i.keys.indexOf(a)===-1):[...s.keys]:[],u=i?s?i.keys.filter(a=>s.keys.indexOf(a)===-1):[...i.keys]:[],r=[];if(s&&i){for(const a of i.keys)if(s.keys.indexOf(a)!==-1){const n=(0,R.getConfigurationValue)(i.contents,a),o=(0,R.getConfigurationValue)(s.contents,a);T.equals(n,o)||r.push(a)}}return{added:l,removed:u,updated:r}}}),define(Se[127],ye([1,0,10,3]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends c.ErrorNoTelemetry{static isNotAvailable(T){return T instanceof A&&T._code===k.NotAvailable}static isTemporarilyNotAvailable(T){return T instanceof A&&T._code===k.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof A&&T._code===k.NoResolverFound}static isHandled(T){return T instanceof A&&T.isHandled}constructor(T,S=k.Unknown,y){super(T),this._message=T,this._code=S,this._detail=y,this.isHandled=S===k.NotAvailable&&y===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(Se[67],ye([1,0,15]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(y){return y.scheme===c.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=t;function k(y){if(!y)return;const R=y.indexOf("+");return R<0?y:y.substr(0,R)}e.getRemoteName=k;function A(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=A;function D(y){const{host:R,port:P}=S(y);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:P}}e.parseAuthorityWithPort=D;function T(y,R){let{host:P,port:E}=S(y);return typeof E>"u"&&(E=R),{host:P,port:E}}e.parseAuthorityWithOptionalPort=T;function S(y){const R=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const P=y.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const E=y.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:y,port:void 0}}}),define(Se[27],ye([1,0,8,3,67]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=A;function D(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var S;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,g){if(typeof d>"u"||d===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof d=="string"||typeof g=="string"){const m=typeof d=="string"?d:d.value,w=typeof g=="string"?g:g.value;return c.equalsIgnoreCase(m,w)}return d.c===g.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=y;function R(v){return P(v)}e.isApplicationScopedExtension=R;function P(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function E(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function C(v,d){if(d){const g=`onResolveRemoteAuthority:${(0,k.getRemoteName)(d)}`;return v.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Se[202],ye([1,0,8,121,27,12,2,10,36]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function y(i,l){return i.uuid&&l.uuid?i.uuid===l.uuid:i.id===l.id?!0:(0,c.compareIgnoreCase)(i.id,l.id)===0}e.areSameExtensions=y;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(l){const u=l.manifest?l.manifest.version:l.version,r=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new P(l.identifier,u,r)}static parse(l){const u=R.exec(l);return u&&u[1]&&u[2]?new P({id:u[1]},u[2],u[4]||void 0):null}constructor(l,u,r="undefined"){this.version=u,this.targetPlatform=r,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof P?y(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=P;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(i){const l=E.exec(i);return l&&l[1]?[d(l[1]),l[2]]:[d(i),void 0]}e.getIdAndVersion=C;function v(i,l){return`${i}.${l}`}e.getExtensionId=v;function d(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function g(i,l){return d(v(i,l))}e.getGalleryExtensionId=g;function m(i,l){const u=[],r=a=>{for(const n of u)if(n.some(o=>y(l(o),l(a))))return n;return null};for(const a of i){const n=r(a);n?n.push(a):u.push([a])}return u}e.groupByExtension=m;function w(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function f(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function h(i,l){const u=[],r=l.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&u.every(n=>!y(n.identifier,{id:a}))){const n=i.filter(o=>y(o.identifier,{id:a}));n.length===1&&(u.push(n[0]),r.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=h;async function b(i,l){if(!A.isLinux)return!1;let u;try{u=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){l.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(a))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=b;async function s(i,l){const u=await b(i,l),r=(0,t.getTargetPlatform)(u?"alpine":A.platform,S.arch);return l.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=s}),define(Se[203],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.b=new Map}c(){return new Promise((k,A)=>ne(["vsda"],k,A))}async createNewMessage(k){try{const A=await this.c(),D=new A.validator;if(D){const T=String(c.a++);return this.b.set(T,D),{id:T,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,A){if(!k.id)return!0;const D=this.b.get(k.id);if(!D)return!1;this.b.delete(k.id);try{return D.validate(A)==="ok"}catch{return!1}}async sign(k){try{const A=await this.c(),D=new A.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=c,c.a=1}),define(Se[204],ye([1,0,12,36,2,30]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(y){if(c.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function T(y,R,P,E,C,v,d,g,m,w){const f=Object.create(null);f["common.machineId"]=d,f.sessionID=(0,A.generateUuid)()+Date.now(),f.commitHash=C,f.version=v,f["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,c.PlatformToString)(c.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=E,f["common.product"]=w||"desktop",g&&(f["common.msftInternal"]=g);let h=0;const b=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),c.isLinuxSnap&&(f["common.snap"]="true");const s=D(P);s&&(f["common.platformDetail"]=s);try{const i=await y.readFile(k.URI.file(m));f["common.source"]=i.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=T;function S(y){const R=t.env.USERDNSDOMAIN;if(!R)return!1;const P=R.toLowerCase();return y.some(E=>P===E)}e.verifyMicrosoftInternalDomain=S}),define(Se[205],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Se[128],ye([1,0,23,11,52,67,204,205]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(a){this.value=a}}e.TrustedTelemetryValue=S;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,n){return Promise.resolve(void 0)}publicLog2(a,n){return this.publicLog(a,n)}publicLogError(a,n){return Promise.resolve(void 0)}publicLogError2(a,n){return this.publicLogError(a,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class R{async publicLog(a,n,o){}async publicLogError(a,n,o){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(r,a){return a.onDidChangeConfiguration(n=>{n.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(n.source),configurationKeys:f(n.sourceConfig)})})}e.configurationTelemetry=P;function E(r,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!r.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=E;function C(r,a){return!(a.isBuilt||a.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.isLoggingOnly=C;function v(r){const a=r.getValue(T.TELEMETRY_SETTING_ID),n=r.getValue("telemetry.enableCrashReporter");if(r.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function d(r){const a={},n={},o={};w(r,o);for(let p in o){p=p.length>150?p.substr(p.length-149):p;const I=o[p];typeof I=="number"?n[p]=I:typeof I=="boolean"?n[p]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${I.length}`),a[p]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(a[p]=I)}return{properties:a,measurements:n}}e.validateTelemetryData=d;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function m(r){if(!r)return"none";const a=(0,A.getRemoteName)(r);return g.has(a)?a:"other"}e.cleanRemoteAuthority=m;function w(r,a,n=0,o){if(!!r)for(const p of Object.getOwnPropertyNames(r)){const I=r[p],L=o?o+p:p;Array.isArray(I)?a[L]=(0,c.safeStringify)(I):I instanceof Date?a[L]=I.toISOString():(0,t.isObject)(I)?n<2?w(I,a,n+1,L+"."):a[L]=(0,c.safeStringify)(I):a[L]=I}}function f(r){if(!r)return[];const a=[];return h(a,"",r),a}function h(r,a,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(o=>h(r,a?`${a}.${o}`:o,n[o])):r.push(a)}function b(r,a){const n=r.msftInternalDomains||[],o=a.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(n)||o}e.isInternalTelemetry=b;function s(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(r,a){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let n=r;const o=[];for(const z of a)for(;;){const _=z.exec(r);if(!_)break;o.push([_.index,z.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let L=0;for(n="";;){const z=I.exec(r);if(!z)break;const _=o.some(([q,N])=>z.index<N&&q<I.lastIndex);!p.test(z[0])&&!_&&(n+=r.substring(L,z.index)+"<REDACTED: user-file-path>",L=I.lastIndex)}return L<r.length&&(n+=r.substr(L)),n}function l(r){if(!r)return r;const a=r.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(a))return`<REDACTED: ${o.label}>`;return r}function u(r,a){return(0,c.cloneAndChange)(r,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let o=n.replaceAll("%20"," ");o=i(o,a);for(const p of a)o=o.replace(p,"");return o=l(o),o}})}e.cleanData=u}),define(Se[206],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,A,D=5){const T=A(S=>{const y=typeof S=="string"?S:S.data;let R=this.a.get(k);if(R){R.data.push(y);return}const P=setTimeout(()=>this.flushBuffer(k),D);R={data:[y],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(k),T.dispose()}},this.a.set(k,R)});return T}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const A=this.a.get(k);A&&(this.a.delete(k),this.b(k,A.data.join("")))}}e.TerminalDataBufferer=c}),define(Se[207],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var c;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(c=e.ColorScheme||(e.ColorScheme={}));function t(A){return A===c.HIGH_CONTRAST_DARK||A===c.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(A){return A===c.DARK||A===c.HIGH_CONTRAST_DARK}e.isDark=k}),define(Se[89],ye([1,0,79,4,6,3,43,207]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(g){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}g.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function y(g){return{id:g}}e.themeColorFromId=y;var R;(function(g){function m(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||S.isThemeColor(u.color))}g.isThemeIcon=m;const w=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function f(u){const r=w.exec(u);if(!r)return;const[,a]=r;return{id:a}}g.fromString=f;function h(u){return{id:u}}g.fromId=h;function b(u,r){let a=u.id;const n=a.lastIndexOf("~");return n!==-1&&(a=a.substring(0,n)),r&&(a=`${a}~${r}`),{id:a}}g.modify=b;function s(u){const r=u.id.lastIndexOf("~");if(r!==-1)return u.id.substring(r+1)}g.getModifier=s;function i(u,r){return u.id===r.id&&u.color?.id===r.color?.id}g.isEqual=i;function l(u,r){return{id:u.id,color:r?y(r):void 0}}g.asThemeIcon=l,g.asClassNameArray=c.CSSIcon.asClassNameArray,g.asClassName=c.CSSIcon.asClassName,g.asCSSSelector=c.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function P(g){switch(g){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case T.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(m){return this.a.push(m),this.b.fire(m),(0,k.toDisposable)(()=>{const w=this.a.indexOf(m);this.a.splice(w,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const C=new E;D.Registry.add(e.Extensions.ThemingContribution,C);function v(g){return C.onColorThemeChange(g)}e.registerThemingParticipant=v;class d extends k.Disposable{constructor(m){super(),this.k=m,this.h=m.getColorTheme(),this.B(this.k.onDidColorThemeChange(w=>this.n(w)))}n(m){this.h=m,this.updateStyles()}updateStyles(){}w(m,w){let f=this.h.getColor(m);return f&&w&&(f=w(f,this.h)),f?f.toString():null}}e.Themable=d}),define(Se[129],ye([1,0,4,52,3,13]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(d){d.Http="http",d.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function E(d,g,m,w){if(m===1)return!1;if(m===2&&P(g)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(f?.length===4&&parseInt(f[1])>=18)return!1}return d<1024}e.isPortPrivileged=E;class C{constructor(g,m,w){this.remoteAddress=g,this.localAddress=m,this.b=w,this.a=new c.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=C;let v=class{constructor(g,m){this.i=g,this.j=m,this.a=new c.Emitter,this.onTunnelOpened=this.a.event,this.b=new c.Emitter,this.onTunnelClosed=this.b.event,this.c=new c.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const g=this.j.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.e=g,g?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.f=g.elevation,this.g=g.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const g=[],m=Array.from(this.d.values());for(const w of m){const f=Array.from(w.values());for(const h of f){const b=await h.value;b&&g.push(b)}}return g}async dispose(){for(const g of this.d.values()){for(const{value:m}of g.values())await m.then(w=>w?.dispose());g.clear()}this.d.clear()}setEnvironmentTunnel(g,m,w,f,h){this.o(g,m,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:m,localAddress:w,privacy:f,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,m){(P(g)||R(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const w=this.q(g,m);if(w)return++w.refcount,w.value}openTunnel(g,m,w,f,h=!1,b,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${w} on local port ${f}.`),!g)return;if(m||(m="localhost"),this.e&&this.h.has(w)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(g,m,w,f,h,b,s);return i?i.then(l=>{if(!l){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(m,w);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(l);return(l.tunnelRemoteHost!==m||l.tunnelRemotePort!==w)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const m=this.d.get(g.tunnelRemoteHost);if(m){const w=m.get(g.tunnelRemotePort);w&&(w.refcount--,await this.n(g.tunnelRemoteHost,g.tunnelRemotePort,w))}}}}async n(g,m,w){if(w.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${m}.`);const f=w.value.then(async h=>{h&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.d.has(g)&&this.d.get(g).delete(m),f}}async closeTunnel(g,m){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${m} `);const w=this.d.get(g);if(w&&w.has(m)){const f=w.get(m);f.refcount=0,await this.n(g,m,f)}}o(g,m,w){this.d.has(g)||this.d.set(g,new Map),this.d.get(g).set(m,{refcount:1,value:w})}async p(g,m){const w=this.d.get(g);w&&(await w.get(m)||w.delete(m),w.size===0&&this.d.delete(g))}q(g,m){const w=[g];R(g)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):P(g)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const f=w.map(h=>this.d.get(h));for(const h of f){const b=h?.get(m);if(b)return b}}canTunnel(g){return!!y(g)}s(g,m,w,f,h,b,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${w} on local port ${f}.`);const i=w;this.h.add(i);const l=f===void 0?w:f,u={elevationRequired:h?this.isPortPrivileged(l):!1},r={remoteAddress:{host:m,port:w},localAddressPort:f,privacy:b,public:b?b!==T.Private:void 0,protocol:s},a=g.forwardPort(r,u);return a?(this.o(m,w,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(i)})):this.h.delete(i),a}};v=qe([We(0,A.ILogService),We(1,t.IConfigurationService)],v),e.AbstractTunnelService=v}),define(Se[208],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var t;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Se[209],ye([1,0,15]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==c.Schemas.file&&S.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=t;function k(S){if(S.folders.length)return S.folders.every(y=>t(y.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=k;function A(S){return k(S)?.scheme}e.getVirtualWorkspaceScheme=A;function D(S){return k(S)?.authority}e.getVirtualWorkspaceAuthority=D;function T(S){return k(S)!==void 0}e.isVirtualWorkspace=T}),define(Se[46],ye([1,0,171,9,64,24,2,3,15]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function y(i){const l=i;return typeof l?.id=="string"&&D.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=y,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(i,l){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,t.basename)(i)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const u=i;if(u.configuration)return{id:u.id,configPath:u.configuration};if(u.folders.length===1)return{id:u.id,uri:u.folders[0].uri}}e.toWorkspaceIdentifier=R;function P(i){const l=i;return typeof l?.id=="string"&&D.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=P;function E(i){const l=i;if(l?.uri)return{id:l.id,uri:D.URI.revive(l.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:D.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=E;var C;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function v(i){const l=i;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=v;function d(i){const l=i;return!!(l&&typeof l=="object"&&D.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=d;class g{constructor(l,u,r,a,n){this.h=l,this.j=r,this.k=a,this.l=n,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=u}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class m{constructor(l,u){this.raw=u,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,A.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function w(i){return new m({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(i,l){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,l.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function h(i){let l;return D.URI.isUri(i)?l=i:l=i.configuration,l?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=h;function b(i,l){return!f(i,l)&&!h(i)}e.isSavedWorkspace=b;function s(i){return(typeof i=="string"?(0,t.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Se[68],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const A=this.c++;return this.b.set(A,k),this.e(),A}get(k,A){return this.b.has(k)?this.b.get(k)[A]:void 0}delete(k){this.b.delete(k),this.e()}e(){!c.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=c,c.a=!1}),define(Se[47],ye([1,0,15,24,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this.a=new Set(Object.keys(c.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(T=>{const S=this.b.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this.b.delete(T.scheme):this.b.set(T.scheme,S)}isFreeScheme(T){return!this.b.has(T)&&!this.a.has(T)}getCapabilities(T){return this.b.get(T)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(Se[25],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(Se[210],ye([1,0,18]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(D,T,S){this.h=new Map,this.a=D,this.b=T,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new c.RunOnceScheduler(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of y.values())R.complete()}catch(R){for(const P of y.values())P.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this.d}get(D,T){let S=this.f[D];return typeof S>"u"&&(S=T),S}update(D,T){this.f[D]=T;const S=this.h.get(D);if(S!==void 0)return S.p;const y=new c.DeferredPromise;return this.h.set(D,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class k extends t{setKeysForSync(D){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},D)}constructor(D,T){super(D.identifier.value,!0,T),this.j=D}}e.ExtensionGlobalMemento=k}),define(Se[211],ye([1,0,4,2]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class k{constructor(D){this.c=D,this.a=new c.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new c.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(D,T,S,y){const P=this.c.getNotebookDocument(t.URI.revive(D)).acceptModelChanged(T.value,S,y);this.b.fire(P)}$acceptDirtyStateChanged(D,T){this.c.getNotebookDocument(t.URI.revive(D)).acceptDirty(T)}$acceptModelSaved(D){const T=this.c.getNotebookDocument(t.URI.revive(D));this.a.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=k}),define(Se[16],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[212],ye([1,0,27,4]),function(ne,e,c,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(T,S){k.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=c.ExtensionIdentifier.toKey(T.identifier),Je(this,k,S,"f"),Fe(this,k,"f").onDidChangePassword(y=>{y.extensionId===this.a&&this.b.fire({key:y.key})})}get(T){return Fe(this,k,"f").get(this.a,T)}store(T,S){return Fe(this,k,"f").store(this.a,T,S)}delete(T){return Fe(this,k,"f").delete(this.a,T)}}e.ExtensionSecrets=A,k=new WeakMap}),define(Se[54],ye([1,0,3,129,4,16]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(S){function y(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}S.fromApiTunnel=y;function R(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}S.fromServiceTunnel=R})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let T=class{constructor(y){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,R){}async getTunnels(){return[]}async setTunnelFactory(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,R){return{dispose:()=>{}}}async $providePortAttributes(y,R,P,E,C){return[]}async $forwardPort(y,R){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=qe([We(0,A.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(Se[55],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=t}),define(Se[213],ye([1,0,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let y=this.buffers.indexOf(S);return y<0&&(y=this.buffers.length,this.buffers.push(S)),y}}function k(T,S){if(S.serializeBuffersForPostMessage){const y=new t,R=(C,v)=>{if(v instanceof ArrayBuffer){const d=y.add(v);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(v)){const d=A(v);if(d){const g=y.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},P=JSON.stringify(T,R),E=y.buffers.map(C=>{const v=new Uint8Array(C);return c.VSBuffer.wrap(v)});return{message:P,buffers:E}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=k;function A(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(T,S){const y=S.map(E=>{const C=new ArrayBuffer(E.byteLength);return new Uint8Array(C).set(E.buffer),C}),R=S.length?(E,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const v=C,{index:d}=v,g=y[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(g,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return C}:void 0;return{message:JSON.parse(T,R),arrayBuffers:y}}e.deserializeWebviewMessage=D}),define(Se[214],ye([1,0,112]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(A){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:A,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function k(A){return new c.URITransformer(t(A))}e.createURITransformer=k}),define(Se[130],ye([1,0,181,11,2,6,3,43,38,15]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var P;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(P=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(X){const V=X;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.isEditorPaneWithSelection=E;function C(X,V,x){for(const Y of x.visibleEditorPanes)if(Y.group.id===V&&X.matches(Y.input))return Y.getViewState()}e.findViewStateForEditor=C;function v(X){if(r(X))return!1;const V=X;return k.URI.isUri(V?.resource)}e.isResourceEditorInput=v;function d(X){if(r(X))return!1;const V=X;return V?.original!==void 0&&V.modified!==void 0}e.isResourceDiffEditorInput=d;function g(X){if(r(X)||d(X))return!1;const V=X;return V?.primary!==void 0&&V.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function m(X){if(r(X))return!1;const V=X;return V?V.resource===void 0||V.resource.scheme===y.Schemas.untitled||V.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=m;const w=/Untitled-\d+/;function f(X){return X.scheme===y.Schemas.untitled&&X.path.length>1&&!w.test(X.path)}e.isUntitledWithAssociatedResource=f;function h(X){if(r(X))return!1;const V=X;return k.URI.isUri(V?.base?.resource)&&k.URI.isUri(V?.input1?.resource)&&k.URI.isUri(V?.input2?.resource)&&k.URI.isUri(V?.result?.resource)}e.isResourceMergeEditorInput=h;var b;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(b=e.Verbosity||(e.Verbosity={}));var s;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class i{constructor(){this.a=new Map}registerSource(V,x){let Y=this.a.get(V);return Y||(Y={source:V,label:x},this.a.set(V,Y)),Y.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.SaveSourceRegistry=new i;var l;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(l=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends A.Disposable{}e.AbstractEditorInput=u;function r(X){return X instanceof u}e.isEditorInput=r;function a(X){const V=X;return k.URI.isUri(V?.preferredResource)}function n(X){const V=X;return r(V?.primary)&&r(V?.secondary)}e.isSideBySideEditorInput=n;function o(X){const V=X;return r(V?.modified)&&r(V?.original)}e.isDiffEditorInput=o;function p(X){return r(X?.editor)}e.isEditorInputWithOptions=p;function I(X){const V=X;return p(X)&&V?.group!==void 0}e.isEditorInputWithOptionsAndGroup=I;function L(X){const V=X;return typeof V?.groupId=="number"&&r(V.editor)}e.isEditorIdentifier=L;var z;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(z=e.EditorCloseContext||(e.EditorCloseContext={}));var _;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(_=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var q;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(q=e.SideBySideEditor||(e.SideBySideEditor={}));class N{getOriginalUri(V,x){if(!V)return;if(h(V))return e.EditorResourceAccessor.getOriginalUri(V.result,x);if(x?.supportSideBySide){const{primary:J,secondary:te}=this.a(V);if(J&&te){if(x?.supportSideBySide===q.BOTH)return{primary:this.getOriginalUri(J,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===q.ANY)return this.getOriginalUri(J,{filterByScheme:x.filterByScheme})??this.getOriginalUri(te,{filterByScheme:x.filterByScheme});V=x.supportSideBySide===q.PRIMARY?J:te}}if(d(V)||g(V)||h(V))return;const Y=a(V)?V.preferredResource:V.resource;return!Y||!x||!x.filterByScheme?Y:this.b(Y,x.filterByScheme)}a(V){return n(V)||g(V)?{primary:V.primary,secondary:V.secondary}:o(V)||d(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,x){if(!V)return;if(h(V))return e.EditorResourceAccessor.getCanonicalUri(V.result,x);if(x?.supportSideBySide){const{primary:J,secondary:te}=this.a(V);if(J&&te){if(x?.supportSideBySide===q.BOTH)return{primary:this.getCanonicalUri(J,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===q.ANY)return this.getCanonicalUri(J,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:x.filterByScheme});V=x.supportSideBySide===q.PRIMARY?J:te}}if(d(V)||g(V)||h(V))return;const Y=V.resource;return!Y||!x||!x.filterByScheme?Y:this.b(Y,x.filterByScheme)}b(V,x){if(Array.isArray(x)){if(x.some(Y=>V.scheme===Y))return V}else if(x===V.scheme)return V}}e.EditorResourceAccessor=new N;var M;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(V){const x=this.a=V.get(D.IInstantiationService);for(const[Y,J]of this.c)this.e(Y,J,x);this.c.clear()}e(V,x,Y){const J=Y.createInstance(x);this.d.set(V,J)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(V,x){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,x,this.a):this.c.set(V,x),(0,A.toDisposable)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new F);async function B(X,V,x){return!X||!X.length?[]:await Promise.all(X.map(async Y=>{const J=k.URI.revive(Y.fileUri);if(!J){x.info("Cannot resolve the path because it is not valid.",Y);return}if(!await V.canHandleResource(J)){x.info("Cannot resolve the path because it cannot be handled",Y);return}let le=Y.exists,Z=Y.type;if(typeof le!="boolean"||typeof Z!="number")try{Z=(await V.stat(J)).isDirectory?S.FileType.Directory:S.FileType.Unknown,le=!0}catch(ve){x.error(ve),le=!1}if(!le&&Y.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",Y);return}if(Z===S.FileType.Directory){x.info("Cannot resolve the path because it is a directory",Y);return}const ge={...Y.options,pinned:!0};return le?{resource:J,options:ge}:{resource:J,options:ge,forceUntitled:!0}}))}e.pathsToEditors=B;var U;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function H(X){const V=X;if(!V)return!1;const x=V;if(x.modified)return H(x.modified);const Y=V;return!!(Y.contributionsState&&Y.viewState&&Array.isArray(Y.cursorState))}e.isTextEditorViewState=H}),define(Se[131],ye([1,0,4,18,182]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new c.Emitter,this.n=new c.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(T){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=T}onEvent(T){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=T}onRequest(T){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.s("response",T)}sendRequest(T,S,y,R){const P={command:T};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.s("request",P),typeof R=="number"){const E=setTimeout(()=>{clearTimeout(E);const C=this.f.get(P.seq);if(C){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:T,message:(0,k.localize)(0,null,R,T)};C(v)}},R)}return y&&this.f.set(P.seq,y),P.seq}acceptMessage(T){this.j?this.j(T):(this.k.push(T),this.k.length===1&&this.q())}o(T,S){return T.type!=="event"||S.type!=="event"}async q(){let T;for(;this.k.length;){if((!T||this.o(this.k[0],T))&&await(0,t.timeout)(0),T=this.k.shift(),!T)return;switch(T.type){case"event":this.i?.(T);break;case"request":this.g?.(T);break;case"response":{const S=T,y=this.f.get(S.request_seq);y&&(this.f.delete(S.request_seq),y(S));break}}}}s(T,S){S.type=T,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((S,y)=>T.set(y,S)),await(0,t.timeout)(500),T.forEach((S,y)=>{S({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=A}),define(Se[215],ye([1,0,183,53,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(49,null)});const A=E=>c.localize(50,null,E);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(51,null)};var D;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(D=e.State||(e.State={}));function T(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var y;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(y=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,k.createDecorator)("debugService");var P;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Se[216],ye([1,0,8,2,9,23,15]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(l,u,r){return l.replace(T,function(a,n){return u&&n.length>0&&n[0]!=="_"?a:r&&r.hasOwnProperty(n)?r[n]:a})}e.formatPII=S;function y(l){const u={};for(const r of Object.keys(l))r.startsWith("!")||(u[r]=l[r]);return u}e.filterExceptionsFromTelemetry=y;function R(l){return l.configuration.request==="attach"&&!P(l)&&(!l.parentSession||R(l.parentSession))}e.isSessionAttach=R;function P(l){let u=l.configuration.type;if(!!u)return u==="vslsShare"&&(u=l.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(u,"extensionhost")||(0,c.equalsIgnoreCase)(u,"pwa-extensionhost")?l:l.parentSession?P(l.parentSession):void 0}e.getExtensionHostDebugSession=P;function E(l){return l.type&&(l.label||l.program||l.runtime)}e.isDebuggerMainContribution=E;function C(l,u,r){let a,n=0;const o=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=o.exec(l);){const I=p.index+1,L=I+p[0].length;if(I<=u&&L>=r){a=p[0],n=I;break}}if(a){const I=/\w+/g;let L=null;for(;(L=I.exec(a))&&!(L.index+1+n+L[0].length>=r););L&&(a=a.substring(0,I.lastIndex))}return a?{start:n,end:n+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=C;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(l){return!!(l&&l.match(v))}e.isUri=d;function g(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(d(l.path))return t.URI.parse(l.path);if((0,k.isAbsolute)(l.path))return t.URI.file(l.path)}return l.path}function m(l){if(typeof l.path=="object"){const u=t.URI.revive(l.path);if(u)return u.scheme===D.Schemas.file?u.fsPath:u.toString()}return l.path}function w(l,u){const r=u?g:m,a=(0,A.deepClone)(l);return h(a,(n,o)=>{n&&o&&(o.path=r(o))}),a}e.convertToDAPaths=w;function f(l,u){const r=u?g:m,a=(0,A.deepClone)(l);return h(a,(n,o)=>{!n&&o&&(o.path=r(o))}),a}e.convertToVSCPaths=f;function h(l,u){switch(l.type){case"event":{const r=l;switch(r.event){case"output":u(!1,r.body.source);break;case"loadedSource":u(!1,r.body.source);break;case"breakpoint":u(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=l;switch(r.command){case"setBreakpoints":u(!0,r.arguments.source);break;case"breakpointLocations":u(!0,r.arguments.source);break;case"source":u(!0,r.arguments.source);break;case"gotoTargets":u(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(a=>u(!1,a));break;default:break}break}case"response":{const r=l;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(a=>u(!1,a.source));break;case"loadedSources":r.body.sources.forEach(a=>u(!1,a));break;case"scopes":r.body.scopes.forEach(a=>u(!1,a.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(a=>u(!1,a.source));break;case"setBreakpoints":r.body.breakpoints.forEach(a=>u(!1,a.source));break;case"disassemble":r.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function b(l){return l.filter(u=>!u.presentation?.hidden).sort((u,r)=>u.presentation?r.presentation?u.presentation.group?r.presentation.group?u.presentation.group!==r.presentation.group?u.presentation.group.localeCompare(r.presentation.group):s(u.presentation.order,r.presentation.order):-1:r.presentation.group?1:s(u.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=b;function s(l,u){return typeof l!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:l-u}async function i(l,u){const r=l.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(r!=="none"&&(await u.saveAll(),r==="allEditorsInActiveGroup")){const a=u.activeEditorPane;a&&a.input.resource?.scheme===D.Schemas.untitled&&await u.save({editor:a.input,groupId:a.group.id})}await l.reloadConfiguration()}e.saveAllBeforeDebugStart=i}),define(Se[217],ye([1,0,45,218,23,9,12,8,29,184,131]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends R.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(m,w){this.p=w,this.r=Buffer.allocUnsafe(0),this.t=-1,m.on("data",f=>this.w(f))}sendMessage(m){if(this.p){const w=JSON.stringify(m);this.p.write(`Content-Length: ${Buffer.byteLength(w,"utf8")}${P.a}${w}`,"utf8")}}w(m){for(this.r=Buffer.concat([this.r,m]);;){if(this.t>=0){if(this.r.length>=this.t){const w=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,w.length>0)try{this.acceptMessage(JSON.parse(w))}catch(f){this.m.fire(new Error((f.message||f)+`
`+w))}continue}}else{const w=this.r.indexOf(P.a);if(w!==-1){const h=this.r.toString("utf8",0,w).split(P.b);for(const b of h){const s=b.split(P.l);s[0]==="Content-Length"&&(this.t=Number(s[1]))}this.r=this.r.slice(w+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class E extends P{startSession(){return new Promise((m,w)=>{let f=!1;this.x=this.y(()=>{this.v(this.x,this.x),m(),f=!0}),this.x.on("close",()=>{f?this.m.fire(new Error("connection closed")):w(new Error("connection closed"))}),this.x.on("error",h=>{f?this.m.fire(h):w(h)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=E;class C extends E{constructor(m){super(),this.z=m}y(m){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",m)}}e.SocketDebugAdapter=C;class v extends E{constructor(m){super(),this.z=m}y(m){return t.createConnection(this.z.path,m)}}e.NamedPipeDebugAdapter=v;class d extends P{constructor(m,w){super(),this.y=m,this.z=w}async startSession(){const m=this.y.command,w=this.y.args,f=this.y.options||{};try{if(m)if(A.isAbsolute(m)){if(!await S.Promises.exists(m))throw new Error(y.localize(0,null,m))}else m.indexOf("/")<0&&m.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let h=process.env;if(f.env&&Object.keys(f.env).length>0&&(h=k.mixin(k.deepClone(process.env),f.env)),m==="node")if(Array.isArray(w)&&w.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:h,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(s.cwd=f.cwd);const i=c.fork(w[0],w.slice(1),s);if(!i.pid)throw new Error(y.localize(2,null,w[0]));this.x=i}else throw new Error(y.localize(3,null));else{const b={env:h};f.cwd&&(b.cwd=f.cwd),this.x=c.spawn(m,w,b)}this.x.on("error",b=>{this.m.fire(b)}),this.x.on("exit",(b,s)=>{this.n.fire(b)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",b=>{this.m.fire(b)}),this.x.stdin.on("error",b=>{this.m.fire(b)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(h){this.m.fire(h)}}async stopSession(){return this.x?(await this.u(),D.isWindows?new Promise((m,w)=>{const f=c.exec(`taskkill /F /T /PID ${this.x.pid}`,function(h,b,s){if(h)return w(h)});f.on("exit",m),f.on("error",w)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(m,w){if(!m)return;const f=Object.create(null);m.runtime&&(m.runtime.indexOf("./")===0?f.runtime=A.join(w,m.runtime):f.runtime=m.runtime),m.runtimeArgs&&(f.runtimeArgs=m.runtimeArgs),m.program&&(A.isAbsolute(m.program)?f.program=m.program:f.program=A.join(w,m.program)),m.args&&(f.args=m.args);const h=m;return h.win&&(f.win=d.A(h.win,w)),h.winx86&&(f.winx86=d.A(h.winx86,w)),h.windows&&(f.windows=d.A(h.windows,w)),h.osx&&(f.osx=d.A(h.osx,w)),h.linux&&(f.linux=d.A(h.linux,w)),f}static platformAdapterExecutable(m,w){let f=Object.create(null);w=w.toLowerCase();for(const u of m)if(u.contributes){const r=u.contributes.debuggers;r&&r.length>0&&r.filter(a=>typeof a.type=="string"&&T.equalsIgnoreCase(a.type,w)).forEach(a=>{const n=d.A(a,u.extensionLocation.fsPath);f=k.mixin(f,n,u.isBuiltin)})}let h;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?h=f.winx86||f.win||f.windows:D.isWindows?h=f.win||f.windows:D.isMacintosh?h=f.osx:D.isLinux&&(h=f.linux),h=h||f;const b=h.program||f.program,s=h.args||f.args,i=h.runtime||f.runtime,l=h.runtimeArgs||f.runtimeArgs;if(i)return{type:"executable",command:i,args:(l||[]).concat(typeof b=="string"?[b]:[]).concat(s||[])};if(b)return{type:"executable",command:b,args:s||[]}}}e.ExecutableDebugAdapter=d}),define(Se[219],ye([1,0,45,32,12]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(y,R){return new Promise((P,E)=>{let C="";const v=c.spawn(y,R);v.pid&&v.stdout.on("data",d=>{C+=d.toString()}),v.on("error",d=>{E(d)}),v.on("close",d=>{P(C)})})}async function D(y){if(y)if(k.isWindows){const R=await new Promise((P,E)=>{ne(["windows-process-tree"],P,E)});return new Promise(P=>{R.getProcessTree(y,E=>{P(!!E&&E.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(y)]).then(R=>{const P=R.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var T;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(T||(T={}));function S(y,R,P,E,C){y=y.trim().toLowerCase();let v;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?v=1:y.indexOf("cmd.exe")>=0?v=0:y.indexOf("bash")>=0?v=2:k.isWindows?v=0:v=2;let d,g=" ";switch(v){case 1:if(d=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),E){const m=(0,t.getDriveLetter)(E);m&&(g+=`${m}:; `),g+=`cd ${d(E)}; `}if(C)for(const m in C){const w=C[m];w===null?g+=`Remove-Item env:${m}; `:g+=`\${env:${m}}='${w}'; `}if(R.length>0){const m=R.shift(),w=P?m:d(m);g+=w[0]==="'"?`& ${w} `:`${w} `;for(const f of R)g+=f==="<"||f===">"||P?f:d(f),g+=" "}break;case 0:if(d=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(w=>m.includes(w))||m.length===0?`"${m}"`:m),E){const m=(0,t.getDriveLetter)(E);m&&(g+=`${m}: && `),g+=`cd ${d(E)} && `}if(C){g+='cmd /C "';for(const m in C){let w=C[m];w===null?g+=`set "${m}=" && `:(w=w.replace(/[&^|<>]/g,f=>`^${f}`),g+=`set "${m}=${w}" && `)}}for(const m of R)g+=m==="<"||m===">"||P?m:d(m),g+=" ";C&&(g+='"');break;case 2:{d=w=>(w=w.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),w.length===0?'""':w);const m=w=>/[^\w@%\/+=,.:^-]/.test(w)?`'${w.replace(/'/g,"'\\''")}'`:w;if(E&&(g+=`cd ${d(E)} ; `),C){g+="/usr/bin/env";for(const w in C){const f=C[w];f===null?g+=` -u ${m(w)}`:g+=` ${m(`${w}=${f}`)}`}g+=" "}for(const w of R)g+=w==="<"||w===">"||P?w:d(w),g+=" ";break}}return g}e.prepareCommand=S}),define(Se[90],ye([1,0,22,37,62,83,15,9,12,53]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json",A.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var w;(function(B){B.scheme=D.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],H=new RegExp(`^[${U.join("")}]+`),X=7;function V(Z,ge){const ve=ge.toString(X),Re=`${ve.length<U.length?U[ve.length-1]:"z"}${ve}s${(0,c.encodeBase64)(c.VSBuffer.fromString(Z.scheme),!0,!0)}`;return Z.with({scheme:B.scheme,fragment:Re})}B.generate=V;function x(Z){if(Z.scheme!==B.scheme)return;const ge=Z.fragment.indexOf("s");if(ge<0)return;const ve=parseInt(Z.fragment.substring(0,ge).replace(H,""),X),De=(0,c.decodeBase64)(Z.fragment.substring(ge+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:Z.with({scheme:De,fragment:null})}}B.parse=x;function Y(Z,ge){return Z.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${Z.scheme!==D.Schemas.file?Z.scheme:""}`})}B.generateCellOutputUri=Y;function J(Z){if(Z.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Z.fragment);if(!ge)return;const ve=ge[1]&&ge[1]!==""?ge[1]:void 0,De=ge[2];return{outputId:ve,notebook:Z.with({scheme:De||D.Schemas.file,fragment:null})}}B.parseCellOutputUri=J;function te(Z,ge,ve){return B.generate(Z,ge).with({scheme:ve})}B.generateCellPropertyUri=te;function le(Z,ge){if(Z.scheme===ge)return B.parse(Z.with({scheme:B.scheme}))}B.parseCellPropertyUri=le})(w=e.CellUri||(e.CellUri={}));const f=B=>S.isWindows?B.replace(/\//g,"\\"):B;class h{constructor(U=[],H=e.NOTEBOOK_DISPLAY_ORDER){this.e=H,this.d=[...new Set(U)].map(X=>({pattern:X,matches:t.parse(f(X))}))}sort(U){const H=new Map(k.Iterable.map(U,V=>[V,f(V)]));let X=[];for(const{matches:V}of this.d)for(const[x,Y]of H)if(V(Y)){X.push(x),H.delete(x);break}return H.size&&(X=X.concat([...H.keys()].sort((V,x)=>this.e.indexOf(V)-this.e.indexOf(x)))),X}prioritize(U,H){const X=this.f(U);if(X===-1){this.d.unshift({pattern:U,matches:t.parse(f(U))});return}const V=new Set(H.map(Y=>this.f(Y,X)));V.delete(-1);const x=Array.from(V).sort();this.d.splice(X+1,0,...x.map(Y=>this.d[Y]));for(let Y=x.length-1;Y>=0;Y--)this.d.splice(x[Y],1)}toArray(){return this.d.map(U=>U.pattern)}f(U,H=this.d.length){const X=f(U);for(let V=0;V<H;V++)if(this.d[V].matches(X))return V;return-1}}e.MimeTypeDisplayOrder=h;function b(B,U,H,X=(V,x)=>V===x){const V=[];function x(te,le,Z){if(le===0&&Z.length===0)return;const ge=V[V.length-1];ge&&ge.start+ge.deleteCount===te?(ge.deleteCount+=le,ge.toInsert.push(...Z)):V.push({start:te,deleteCount:le,toInsert:Z})}let Y=0,J=0;for(;;){if(Y===B.length){x(Y,0,U.slice(J));break}if(J===U.length){x(Y,B.length-Y,[]);break}const te=B[Y],le=U[J];if(X(te,le)){Y+=1,J+=1;continue}H(le)?(x(Y,1,[]),Y+=1):(x(Y,0,[le]),J+=1)}return V}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(B){B.default="default",B.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(B){const U=B;return!!((typeof U.include=="string"||t.isRelativePattern(U.include))&&(typeof U.exclude=="string"||t.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=i;function l(B,U,H){if(Array.isArray(B.viewType)&&B.viewType.indexOf(U)>=0||B.viewType===U)return!0;if(B.filenamePattern){const X=i(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,V=i(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(t.match(X,(0,T.basename)(H.fsPath).toLowerCase()))return!(V&&t.match(V,(0,T.basename)(H.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var u;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(U){return`${r.d}${U}`}static parse(U){if(U.startsWith(r.d))return U.substring(r.d.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r.d="notebook/";function a(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=a;const n=new TextDecoder;function o(B){const U=[];let H=!1;for(const X of B)(U.length===0||H)&&(U.push(X),H=!0);return z(U),F(c.VSBuffer.concat(U.map(X=>c.VSBuffer.wrap(X))))}e.compressOutputItemStreams=o;const p=`${String.fromCharCode(27)}[A`,I=p.split("").map(B=>B.charCodeAt(0)),L=10;function z(B){B.forEach((U,H)=>{if(H===0||U.length<p.length)return;const X=B[H-1],V=U.subarray(0,p.length);if(V[0]===I[0]&&V[1]===I[1]&&V[2]===I[2]){const x=X.lastIndexOf(L);if(x===-1)return;B[H-1]=X.subarray(0,x),B[H]=U.subarray(p.length)}})}function _(B){let U=B;do B=U,U=B.replace(/[^\n]\x08/gm,"");while(U.length<B.length);return B}function q(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const U=B.match(/^(.*)\r+/m)[1];let H=B.match(/\r+(.*)$/m)[1];H=H+U.slice(H.length,U.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return B}const N="\b".charCodeAt(0),M="\r".charCodeAt(0);function F(B){return!B.buffer.includes(N)&&!B.buffer.includes(M)?B:c.VSBuffer.fromString(q(_(n.decode(B.buffer))))}}),define(Se[220],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(Se[221],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=c;function t(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=t;function k(D){return Array.from(D.entries()).map(T=>[T[0],c(T[1].map)])}e.serializeEnvironmentVariableCollections=k;function A(D){return new Map(D.map(T=>[T[0],{map:t(T[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Se[56],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(A){A.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class k{static fromExtHostTestItem(D,T,S=D.parent){if(D._isRoot)return new k([T]);const y=[D.id];for(let R=S;R&&R.id!==T;R=R.parent)y.push(R.id);return y.push(T),new k(y.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const T=D.indexOf("\0");return T===-1?D:D.slice(0,T)}static fromString(D){return new k(D.split("\0"))}static join(D,T){return new k([...D.path,T])}static joinToString(D,T){return D.toString()+"\0"+T}static parentId(D){const T=D.lastIndexOf("\0");return T===-1?void 0:D.slice(0,T)}static compare(D,T){return D===T?0:T.startsWith(D+"\0")?2:D.startsWith(T+"\0")?3:1}constructor(D,T=D.length){if(this.path=D,this.d=T,D.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new k(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new k(this.path,D)}compare(D){if(typeof D=="string")return k.compare(this.toString(),D);for(let T=0;T<D.d&&T<this.d;T++)if(D.path[T]!==this.path[T])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.TestId=k}),define(Se[69],ye([1,0,2,35,56]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var A;(function(a){a[a.Unset=0]="Unset",a[a.Queued=1]="Queued",a[a.Running=2]="Running",a[a.Passed=3]="Passed",a[a.Failed=4]="Failed",a[a.Skipped=5]="Skipped",a[a.Errored=6]="Errored"})(A=e.TestResultState||(e.TestResultState={}));var D;(function(a){a[a.Run=2]="Run",a[a.Debug=4]="Debug",a[a.Coverage=8]="Coverage",a[a.HasNonDefaultProfile=16]="HasNonDefaultProfile",a[a.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(a){a.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),a.deserialize=n=>({range:t.Range.lift(n.range),uri:c.URI.revive(n.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var S;(function(a){a[a.Error=0]="Error",a[a.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var y;(function(a){a.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&T.serialize(n.location)}),a.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&T.deserialize(n.location)})})(y=e.ITestErrorMessage||(e.ITestErrorMessage={}));const R=(a,n)=>`${n?"s":"e"}${a}`;e.getMarkId=R;var P;(function(a){a.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&T.serialize(n.location)}),a.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&T.deserialize(n.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(a){a.serialize=n=>n.type===0?y.serialize(n):P.serialize(n),a.deserialize=n=>n.type===0?y.deserialize(n):P.deserialize(n)})(E=e.ITestMessage||(e.ITestMessage={}));var C;(function(a){a.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),a.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(E.serialize)}),a.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(E.deserialize)})})(C=e.ITestTaskState||(e.ITestTaskState={}));const v="\0",d=(a,n)=>a+v+n;e.namespaceTestTag=d;const g=a=>{const n=a.indexOf(v);return{ctrlId:a.slice(0,n),tagId:a.slice(n+1)}};e.denamespaceTestTag=g;var m;(function(a){a.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),a.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?c.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(m=e.ITestItem||(e.ITestItem={}));var w;(function(a){a[a.NotExpandable=0]="NotExpandable",a[a.Expandable=1]="Expandable",a[a.BusyExpanding=2]="BusyExpanding",a[a.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var f;(function(a){a.serialize=n=>({expand:n.expand,item:m.serialize(n.item)}),a.deserialize=n=>({controllerId:k.TestId.root(n.item.extId),expand:n.expand,item:m.deserialize(n.item)})})(f=e.InternalTestItem||(e.InternalTestItem={}));var h;(function(a){a.serialize=n=>{let o;return n.item&&(o={},n.item.label!==void 0&&(o.label=n.item.label),n.item.tags!==void 0&&(o.tags=n.item.tags),n.item.busy!==void 0&&(o.busy=n.item.busy),n.item.uri!==void 0&&(o.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(o.range=n.item.range?.toJSON()),n.item.description!==void 0&&(o.description=n.item.description),n.item.error!==void 0&&(o.error=n.item.error),n.item.sortText!==void 0&&(o.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:o}},a.deserialize=n=>{let o;return n.item&&(o={},n.item.label!==void 0&&(o.label=n.item.label),n.item.tags!==void 0&&(o.tags=n.item.tags),n.item.busy!==void 0&&(o.busy=n.item.busy),n.item.range!==void 0&&(o.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(o.description=n.item.description),n.item.error!==void 0&&(o.error=n.item.error),n.item.sortText!==void 0&&(o.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:o}}})(h=e.ITestItemUpdate||(e.ITestItemUpdate={}));const b=(a,n)=>{n.expand!==void 0&&(a.expand=n.expand),n.item!==void 0&&(a.item=a.item?Object.assign(a.item,n.item):n.item)};e.applyTestItemUpdate=b;var s;(function(a){a.serializeWithoutMessages=n=>({...f.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serializeWithoutMessages),retired:n.retired}),a.serialize=n=>({...f.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serialize),retired:n.retired}),a.deserialize=n=>({...f.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var i;(function(a){a[a.Function=0]="Function",a[a.Statement=1]="Statement"})(i=e.DetailType||(e.DetailType={}));var l;(function(a){a[a.Add=0]="Add",a[a.Update=1]="Update",a[a.DocumentSynced=2]="DocumentSynced",a[a.Remove=3]="Remove",a[a.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",a[a.Retire=5]="Retire",a[a.AddTag=6]="AddTag",a[a.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(a){a.deserialize=n=>n.op===0?{op:n.op,item:f.deserialize(n.item)}:n.op===1?{op:n.op,item:h.deserialize(n.item)}:n.op===2?{op:n.op,uri:c.URI.revive(n.uri),docv:n.docv}:n,a.serialize=n=>n.op===0?{op:n.op,item:f.serialize(n.item)}:n.op===1?{op:n.op,item:h.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class r{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const o=this.o();for(const p of n)switch(p.op){case 0:this.j(f.deserialize(p.item),o);break;case 1:this.k(h.deserialize(p.item),o);break;case 3:this.l(p.itemId,o);break;case 5:this.m(p.itemId);break;case 4:this.updatePendingRoots(p.amount);break;case 6:this.c.set(p.tag.id,p.tag);break;case 7:this.c.delete(p.id);break}o.complete?.()}j(n,o){const p=k.TestId.parentId(n.item.extId)?.toString();let I;if(!p)I=this.p(n),this.f.add(I),this.d.set(n.item.extId,I);else if(this.d.has(p)){const L=this.d.get(p);L.children.add(n.item.extId),I=this.p(n,L),this.d.set(n.item.extId,I)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return o.add?.(I),n.expand===2&&this.g++,I}k(n,o){const p=this.d.get(n.extId);if(!!p)return n.expand!==void 0&&(p.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(p,n),o.update?.(p),p}l(n,o){const p=this.d.get(n);if(!p)return;const I=k.TestId.parentId(p.item.extId)?.toString();I?this.d.get(I).children.delete(p.item.extId):this.f.delete(p);const L=[[n]];for(;L.length;)for(const z of L.pop()){const _=this.d.get(z);_&&(L.push(_.children),this.d.delete(z),o.remove?.(_,_!==p),_.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=r}),define(Se[91],ye([1,0,18,4,6,49,69,56]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(w){w[w.Upsert=0]="Upsert",w[w.SetTags=1]="SetTags",w[w.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",w[w.RemoveChild=3]="RemoveChild",w[w.SetProp=4]="SetProp",w[w.Bulk=5]="Bulk",w[w.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const y=(w,f)=>w===f,P=Object.entries({range:(w,f)=>w===f?!0:!w||!f?!1:w.equalsRange(f),busy:y,label:y,description:y,error:y,sortText:y,tags:(w,f)=>!(w.length!==f.length||w.some(h=>!f.includes(h)))}),E=(w,f)=>{let h;for(const[b,s]of P)s(w[b],f[b])||(h?h[b]=f[b]:h={[b]:f[b]});return h};class C extends k.Disposable{get root(){return this.m.root}constructor(f){super(),this.m=f,this.f=this.B(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(f){this.h=f;for(const h of this.tree.values())this.G(h)}collectDiff(){const f=this.k;return this.k=[],f}pushDiff(f){switch(f.op){case 2:{for(const h of this.k)if(h.op===2&&h.uri===f.uri){h.docv=f.docv;return}break}case 1:{const h=this.k[this.k.length-1];if(h){if(h.op===1&&h.item.extId===f.item.extId){(0,D.applyTestItemUpdate)(h.item,f.item);return}if(h.op===0&&h.item.item.extId===f.item.extId){(0,D.applyTestItemUpdate)(h.item,f.item);return}}break}}this.k.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,h){const b=this.tree.get(f);if(!!b){if((b.expandLevels===void 0||h>b.expandLevels)&&(b.expandLevels=h),b.expand===1){const s=this.I(b);return s.isOpen()?this.H(b,h-1):s.wait().then(()=>this.H(b,h-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.H(b,h-1)):this.H(b,h-1)}}dispose(){for(const f of this.tree.values())this.m.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(f,h){switch(h.op){case 3:this.L(T.TestId.joinToString(f.fullId,h.id));break;case 0:this.u(h.item,f);break;case 5:for(const b of h.ops)this.p(f,b);break;case 1:this.w(h.new,h.old,f.fullId.toString());break;case 2:this.G(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:h.update}});break;case 6:this.s(f.actual.uri);break;default:(0,A.assertNever)(h)}}s(f){f&&this.pushDiff({op:2,uri:f,docv:this.m.getDocumentVersion(f)})}u(f,h){const b=T.TestId.fromExtHostTestItem(f,this.root.id,h?.actual),s=this.m.getApiFor(f);s.parent&&s.parent!==h?.actual&&this.m.getChildren(s.parent).delete(f.id);let i=this.tree.get(b.toString());if(!i){i={fullId:b,actual:f,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},f.tags.forEach(this.y,this),this.tree.set(i.fullId.toString(),i),this.C(f,h),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:i.expand,item:this.m.toITestItem(f)}}),this.F(f,i,h);return}if(i.actual===f){this.D(f,i,h);return}if(i.actual.uri?.toString()!==f.uri?.toString())return this.L(b.toString()),this.u(f,h);const l=this.m.getChildren(i.actual),u=i.actual,r=E(this.m.toITestItem(u),this.m.toITestItem(f));this.m.getApiFor(u).listener=void 0,i.actual=f,i.expand=0,r&&(r.hasOwnProperty("tags")&&(this.w(f.tags,u.tags,b.toString()),delete r.tags),this.p(i,{op:4,update:r})),this.F(f,i,h);for(const[a,n]of l)this.m.getChildren(f).get(n.id)||this.L(T.TestId.joinToString(b,n.id));this.s(i.actual.uri)}w(f,h,b){const s=new Set(h.map(i=>i.id));for(const i of f)s.delete(i.id)||this.y(i);this.pushDiff({op:1,item:{extId:b,item:{tags:f.map(i=>(0,D.namespaceTestTag)(this.m.controllerId,i.id))}}}),s.forEach(this.z,this)}y(f){const h=this.j.get(f.id);h?h.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.m.controllerId,f.id)}}))}z(f){const h=this.j.get(f);h&&!--h.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.m.controllerId,f)}))}C(f,h){this.m.getApiFor(f).parent=h&&h.actual!==this.root?h.actual:void 0}D(f,h,b){this.C(f,b);const s=this.m.getApiFor(f);s.parent=b?.actual,s.listener=i=>this.p(h,i),this.G(h)}F(f,h,b){this.D(f,h,b);for(const[s,i]of this.m.getChildren(f))this.u(i,h)}G(f){let h;this.h?f.resolveBarrier?h=f.resolveBarrier.isOpen()?3:2:h=f.actual.canResolveChildren?1:0:h=0,h!==f.expand&&(f.expand=h,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:h}}),h===1&&f.expandLevels!==void 0&&this.I(f))}H(f,h){if(h<0)return;const b=[];for(const[s,i]of this.m.getChildren(f.actual)){const l=this.expand(T.TestId.joinToString(f.fullId,i.id),h);(0,c.isThenable)(l)&&b.push(l)}if(b.length)return Promise.all(b).then(()=>{})}I(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const i=new c.Barrier;return i.open(),i}f.expand=2,this.J(f);const h=f.resolveBarrier=new c.Barrier,b=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,i)};let s;try{s=this.h(f.actual===this.root?void 0:f.actual)}catch(i){b(i)}return(0,c.isThenable)(s)?s.catch(b).then(()=>{h.open(),this.G(f)}):(h.open(),this.G(f)),f.resolveBarrier}J(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}L(f){const h=this.tree.get(f);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const b=[h];for(;b.length;){const s=b.pop();if(!!s){this.m.getApiFor(s.actual).listener=void 0;for(const i of s.actual.tags)this.z(i.id);this.tree.delete(s.fullId.toString());for(const[i,l]of this.m.getChildren(s.actual))b.push(this.tree.get(T.TestId.joinToString(s.fullId,l.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.TestItemCollection=C;class v extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=v;class d extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class g extends Error{constructor(f,h,b){super(`TestItem with ID "${f}" is from controller "${h}" and cannot be added as a child of an item from controller "${b}".`)}}e.MixedTestItemController=g;const m=(w,f,h)=>{let b=new Map;return{get size(){return b.size},forEach(s,i){for(const l of b.values())s.call(i,l,this)},[Symbol.iterator](){return b.entries()},replace(s){const i=new Map,l=new Set(b.keys()),u={op:5,ops:[]};for(const r of s){if(!(r instanceof h))throw new d(r.id);const a=f(r).controllerId;if(a!==w.controllerId)throw new g(r.id,a,w.controllerId);if(i.has(r.id))throw new v(r.id);i.set(r.id,r),l.delete(r.id),u.ops.push({op:0,item:r})}for(const r of l.keys())u.ops.push({op:3,id:r});w.listener?.(u),b=i},add(s){if(!(s instanceof h))throw new d(s.id);b.set(s.id,s),w.listener?.({op:0,item:s})},delete(s){b.delete(s)&&w.listener?.({op:3,id:s})},get(s){return b.get(s)},toJSON(){return Array.from(b.values())}}};e.createTestItemChildren=m}),define(Se[132],ye([1,0,91]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,k=(D,T)=>{const S={controllerId:T};return t.set(D,S),S};e.createPrivateApiFor=k;const A=D=>{const T=t.get(D);if(!T)throw new c.InvalidTestItemError(D?.id||"<unknown>");return T};e.getPrivateApiFor=A}),define(Se[92],ye([1,0,15,2]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function k(T,S){return T.scheme===c.Schemas.http||T.scheme===c.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===c.Schemas.file&&(T=t.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:T.path})),t.URI.from({scheme:c.Schemas.https,authority:`${T.scheme}+${A(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=k;function A(T){return T.replace(/./g,S=>{const y=S.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?S:"-"+y.toString(16).padStart(4,"0")})}function D(T){return T.replace(/-([0-9a-f]{4})/g,(S,y)=>String.fromCharCode(parseInt(y,16)))}e.decodeAuthority=D}),define(Se[222],ye([1,0,4,6,92]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(T,S,y){this.d=T,this.e=S,this.f=y,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const P of this.c.values())R.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,S,y,R,P){let E;for(const f of this.e.getVisibleTextEditors(!0))if(f.value===T){E=f;break}if(!E)throw new Error("not a visible editor");const C=this,v=this.a++,d=new c.Emitter,g=new c.Emitter,m=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(f){return(0,k.asWebviewUri)(f,C.f)}get cspSource(){return k.webviewGenericCspSource}set options(f){this.b=f,C.d.$setOptions(v,f)}get options(){return this.b}set html(f){this.a=f,C.d.$setHtml(v,f)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(f){return C.d.$postMessage(v,f)}},w=new class{constructor(){this.editor=T,this.line=S,this.height=y,this.webview=m,this.onDidDispose=g.event}dispose(){C.c.has(v)&&(C.c.delete(v),C.d.$disposeEditorInset(v),g.fire(),g.dispose(),d.dispose())}};return this.d.$createEditorInset(v,E.id,E.value.document.uri,S+1,y,R||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:T,inset:w,onDidReceiveMessage:d}),w}$onDidDispose(T){const S=this.c.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this.c.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(Se[223],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var t;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class k extends Error{constructor(D,T){super(T),this.variable=D}}e.VariableError=k}),define(Se[224],ye([1,0,9,36,11,23,12,111,187,223,8]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(C,v,d,g){this.g=new Map,this.a=C,this.b=v,this.d=d,g&&(this.c=g.then(m=>this.h(m)))}h(C){if(D.isWindows){const v=Object.create(null);return Object.keys(C).forEach(d=>{v[d.toLowerCase()]=C[d]}),v}return C}resolveWithEnvironment(C,v,d){return this.j({env:this.h(C),userHome:void 0},v?v.uri:void 0,d)}async resolveAsync(C,v){const d={env:await this.c,userHome:await this.d};return this.j(d,C?C.uri:void 0,v)}async i(C,v,d,g){const m=A.deepClone(v);D.isWindows&&m.windows?Object.keys(m.windows).forEach(f=>m[f]=m.windows[f]):D.isMacintosh&&m.osx?Object.keys(m.osx).forEach(f=>m[f]=m.osx[f]):D.isLinux&&m.linux&&Object.keys(m.linux).forEach(f=>m[f]=m.linux[f]),delete m.windows,delete m.osx,delete m.linux;const w={env:await this.c,userHome:await this.d};return this.j(w,C?C.uri:void 0,m,d,g)}async resolveAnyAsync(C,v,d){return this.i(C,v,d)}async resolveAnyMap(C,v,d){const g=new Map;return{newConfig:await this.i(C,v,d,g),resolvedVariables:g}}resolveWithInteractionReplace(C,v,d,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,v,d,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,v){if(this.g.has(C))throw new Error("Variable "+C+" is contributed twice.");this.g.set(C,v)}async j(C,v,d,g,m){if(k.isString(d))return this.l(C,v,d,g,m);if(Array.isArray(d))return Promise.all(d.map(w=>this.j(C,v,w,g,m)));if(k.isObject(d)){const w=Object.create(null),f=await Promise.all(Object.keys(d).map(async h=>[await this.l(C,v,h,g,m),await this.j(C,v,d[h],g,m)]));for(const[h,b]of f)w[h]=b;return w}return d}l(C,v,d,g,m){return(0,R.replaceAsync)(d,P.VARIABLE_REGEXP,async(w,f)=>{if(f.includes(P.VARIABLE_LHS))return w;let h=await this.n(C,w,f,v,g);return m?.set(f,h),h!==w&&k.isString(h)&&h.match(P.VARIABLE_REGEXP)&&(h=await this.l(C,v,h,g,m)),h})}m(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async n(C,v,d,g,m){let w;const f=d.split(":");f.length>1&&(d=f[0],w=f[1]);const h=i=>{const l=this.a.getFilePath();if(l)return(0,T.normalizeDriveLetter)(l);throw new y.VariableError(i,(0,S.localize)(0,null,v))},b=i=>{const l=h(i);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,T.normalizeDriveLetter)(u)}throw new y.VariableError(i,(0,S.localize)(1,null,v,c.basename(l)))},s=i=>{if(w){const l=this.a.getFolderUri(w);if(l)return l;throw new y.VariableError(i,(0,S.localize)(2,null,v,w))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new y.VariableError(i,(0,S.localize)(3,null,v)):new y.VariableError(i,(0,S.localize)(4,null,v))};switch(d){case"env":if(w){if(C.env){const i=C.env[D.isWindows?w.toLowerCase():w];if(k.isString(i))return i}return""}throw new y.VariableError(y.VariableKind.Env,(0,S.localize)(5,null,v));case"config":if(w){const i=this.a.getConfigurationValue(g,w);if(k.isUndefinedOrNull(i))throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(6,null,v,w));if(k.isObject(i))throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(7,null,v,w));return i}throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(8,null,v));case"command":return this.o(y.VariableKind.Command,v,w,m,"command");case"input":return this.o(y.VariableKind.Input,v,w,m,"input");case"extensionInstallFolder":if(w){const i=await this.a.getExtension(w);if(!i)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,v,w));return this.m(i.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,v));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.m(s(y.VariableKind.WorkspaceFolder)));case"cwd":return g||w?(0,T.normalizeDriveLetter)(this.m(s(y.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.normalizeDriveLetter)(c.basename(this.m(s(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,S.localize)(11,null,v))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new y.VariableError(y.VariableKind.LineNumber,(0,S.localize)(12,null,v))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new y.VariableError(y.VariableKind.SelectedText,(0,S.localize)(13,null,v))}case"file":return h(y.VariableKind.File);case"fileWorkspaceFolder":return b(y.VariableKind.FileWorkspaceFolder);case"relativeFile":return g||w?c.relative(this.m(s(y.VariableKind.RelativeFile)),h(y.VariableKind.RelativeFile)):h(y.VariableKind.RelativeFile);case"relativeFileDirname":{const i=c.dirname(h(y.VariableKind.RelativeFileDirname));if(g||w){const l=c.relative(this.m(s(y.VariableKind.RelativeFileDirname)),i);return l.length===0?".":l}return i}case"fileDirname":return c.dirname(h(y.VariableKind.FileDirname));case"fileExtname":return c.extname(h(y.VariableKind.FileExtname));case"fileBasename":return c.basename(h(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=c.basename(h(y.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-c.extname(i).length)}case"fileDirnameBasename":return c.basename(c.dirname(h(y.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||v}case"execInstallFolder":{const i=this.a.getAppRoot();return i||v}case"pathSeparator":return c.sep;default:try{const i=w?`${d}:${w}`:d;return this.o(y.VariableKind.Unknown,v,i,m,void 0)}catch{return v}}}}o(C,v,d,g,m){if(d&&g){const w=m===void 0?g[d]:g[m+":"+d];if(typeof w=="string")return w;throw new y.VariableError(C,(0,S.localize)(14,null,v))}return v}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[133],ye([1,0,3,130]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var T;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function y(v){const d=v;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=y;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function E(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=E;function C(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(Se[225],ye([1,0,3,133]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(A){const D=A;return typeof A=="number"||(0,t.isEditorGroup)(D)}e.isPreferredGroup=k}),define(Se[226],ye([1,0,3,193]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(t.IEnvironmentService)}),define(Se[227],ye([1,0,27,4,9]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=A;class D{constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(c.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(c.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let E of P.activationEvents)E==="onUri"&&(E=`onUri:${c.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(E)||this.g.set(E,[]),this.g.get(E).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,E){this.d=y(this.d,E),this.d=this.d.concat(P);const C=D.j(this.d);return this.d=y(this.d,C.map(v=>v.identifier)),this.h(),this.c.fire(void 0),new A(C)}static j(P){const E=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,w){this.addNode(m),this.addNode(w),this.c.has(m)?this.c.get(m).push(w):this.c.set(m,[w])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,w){const f=E.getArcs(m);for(let h=0;h<f.length;h++)if(!w.has(f[h]))return!1;return!0}getNodes(){return this.e}},C=new Map;for(const m of P){const w=c.ExtensionIdentifier.toKey(m.identifier);if(C.set(w,m),m.extensionDependencies)for(const f of m.extensionDependencies){const h=c.ExtensionIdentifier.toKey(f);E.addArc(w,h)}}const v=new Set;E.getNodes().filter(m=>E.getArcs(m).length===0).forEach(m=>v.add(m));const d=E.getNodes().filter(m=>!v.has(m));let g;do{g=!1;for(let m=0;m<d.length;m++){const w=d[m];E.hasOnlyGoodArcs(w,v)&&(d.splice(m,1),m--,v.add(w),g=!0)}}while(g);return d.map(m=>C.get(m))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(c.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const E=this.g.get(P);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const E=this.e.get(c.ExtensionIdentifier.toKey(P));return E||void 0}getExtensionDescriptionByUUID(P){for(const E of this.f)if(E.uuid===P)return E}getExtensionDescriptionByIdOrUUID(P,E){return this.getExtensionDescription(P)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=D;var T;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(T||(T={}));function S(R,P){const E=R.isBuiltin?0:R.isUnderDevelopment?2:1,C=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(E!==C)return E-C;const v=k.posix.basename(R.extensionLocation.path),d=k.posix.basename(P.extensionLocation.path);return v<d?-1:v>d?1:0}function y(R,P){const E=new Set;return P.forEach(C=>E.add(c.ExtensionIdentifier.toKey(C))),R.filter(C=>!E.has(c.ExtensionIdentifier.toKey(C.identifier)))}}),define(Se[228],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class k{constructor(){this.type=2}serialize(P){P[k.ENV_KEY]="1"}}e.SocketExtHostConnection=k,k.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(P){P[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function D(R){delete R[t.ENV_KEY],delete R[k.ENV_KEY],delete R[A.ENV_KEY]}function T(R,P){D(P),R.serialize(P)}e.writeExtHostConnection=T;function S(R){if(R[t.ENV_KEY])return y(R,new t(R[t.ENV_KEY]));if(R[k.ENV_KEY])return y(R,new k);if(R[A.ENV_KEY])return y(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function y(R,P){return D(R),P}}),define(Se[93],ye([1,0,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var k;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function D(y){const R=c.VSBuffer.alloc(1);switch(y){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=D;function T(y,R){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=T;var S;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Se[94],ye([1,0,3,4,13,25,93,67,128,23,2]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(d,g){this.i=d,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=g.createLogger(R.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(d,g){const m=this.getTelemetryDetails(),w=new E(g,d,this.g,this.f,this.getBuiltInCommonProperties(d),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled});return this.h.set(d.identifier.value,w),w.apiTelemetryLogger}$initializeTelemetryLevel(d,g,m){this.d=d,this.f=g,this.c=m??{usage:!0,error:!0}}getBuiltInCommonProperties(d){const g={};switch(g["common.extname"]=d.name,g["common.extversion"]=d.version,g["common.vscodemachineid"]=this.i.telemetryInfo.machineId,g["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,g["common.vscodeversion"]=this.i.version,g["common.isnewappinstall"]=C(this.i.telemetryInfo.firstSessionDate),g["common.product"]=this.i.environment.appHost,this.i.uiKind){case D.UIKind.Web:g["common.uikind"]="web";break;case D.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),g}$onDidChangeTelemetryLevel(d){this.e=this.getTelemetryConfiguration(),this.d=d;const g=this.getTelemetryDetails();this.h.forEach(m=>{m.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(d,g){const m=this.h.get(d.value);return m?(m.logError(g),!0):!1}};P=qe([We(0,A.IExtHostInitDataService),We(1,k.ILoggerService)],P),e.ExtHostTelemetry=P;class E{constructor(d,g,m,w,f,h){this.e=g,this.f=m,this.g=w,this.h=f,this.b=new t.Emitter,this.a=d,this.c={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(d,g){this.d&&(this.c={isUsageEnabled:d,isErrorsEnabled:g},this.b.fire(this.d))}mixInCommonPropsAndCleanData(d){let g=d.properties??d;return g=(0,S.cleanData)(g,[]),this.a.additionalCommonProperties&&(g=(0,y.mixin)(g,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(g=(0,y.mixin)(g,this.h)),d.properties?d.properties=g:d=g,d}i(d,g){this.e.publisher==="vscode"?d=this.e.name+"/"+d:d=this.e.identifier.value+"/"+d,g=this.mixInCommonPropsAndCleanData(g||{}),this.g||this.a.logEvent(d,g),this.f.trace(d,g)}logUsage(d,g){!this.c.isUsageEnabled||this.i(d,g)}logError(d,g){!this.c.isErrorsEnabled||(typeof d=="string"?this.i(d,g):this.a.logException(d,g))}get apiTelemetryLogger(){if(!this.d){const d=this,g={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.c.isUsageEnabled},get isErrorsEnabled(){return d.c.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.b.event.bind(d)};this.d=Object.freeze(g)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=E;function C(v){const d=Date.now()-new Date(v).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=C,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(Se[26],ye([1,0,4,2,3,27,202]),function(ne,e,c,t,k,A,D){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class S{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class y{constructor(a){this.affinity=a,this.kind=2}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=y;class R{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class P{constructor(a){this.dependency=a}}e.MissingExtensionDependency=P;var E;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=C;class v{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(a,n){const o=[],p=[],I=[],L=[],z=m(this.c),_=m(a),q=(B,U)=>B.extensionLocation.toString()===U.extensionLocation.toString()||B.isBuiltin===U.isBuiltin||B.isUserBuiltin===U.isUserBuiltin||B.isUnderDevelopment===U.isUnderDevelopment;for(const B of this.c){const U=_.get(A.ExtensionIdentifier.toKey(B.identifier));if(!U){o.push(B.identifier),z.delete(A.ExtensionIdentifier.toKey(B.identifier));continue}if(!q(B,U)){o.push(B.identifier),z.delete(A.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of a){const U=z.get(A.ExtensionIdentifier.toKey(B.identifier));if(!U){p.push(B);continue}if(!q(U,B)){o.push(U.identifier),z.delete(A.ExtensionIdentifier.toKey(U.identifier));continue}}const N=g(this.d),M=g(n);for(const B of this.d)M.has(A.ExtensionIdentifier.toKey(B))||I.push(B);for(const B of n)N.has(A.ExtensionIdentifier.toKey(B))||L.push(B);const F={toRemove:o,toAdd:p,myToRemove:I,myToAdd:L};return this.delta(F),F}delta(a){const{toRemove:n,toAdd:o,myToRemove:p,myToAdd:I}=a,L=g(n),z=g(p);for(let _=0;_<this.c.length;_++)L.has(A.ExtensionIdentifier.toKey(this.c[_].identifier))&&(this.c.splice(_,1),_--);for(let _=0;_<this.d.length;_++)z.has(A.ExtensionIdentifier.toKey(this.d[_]))&&(this.d.splice(_,1),_--);for(const _ of o)this.c.push(_);for(const _ of I)this.d.push(_)}containsExtension(a){for(const n of this.d)if(A.ExtensionIdentifier.equals(n,a))return!0;return!1}}e.ExtensionHostExtensions=v;class d{constructor(a){if(this[T]="ExtensionIdentifierSet",this.c=new Map,this.d=A.ExtensionIdentifier.toKey,a)for(const n of a)this.add(n)}get size(){return this.c.size}add(a){return this.c.set(this.d(a),a),this}clear(){this.c.clear()}delete(a){return this.c.delete(this.d(a))}has(a){return this.c.has(this.d(a))}forEach(a,n){this.c.forEach(o=>a.call(n,o,o,this))}*entries(){for(const[a,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=d;function g(r){const a=new Set;for(const n of r)a.add(A.ExtensionIdentifier.toKey(n));return a}e.extensionIdentifiersArrayToSet=g;function m(r){const a=new Map;for(const n of r)a.set(A.ExtensionIdentifier.toKey(n.identifier),n);return a}function w(r,a){return r.enabledApiProposals?r.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=w;function f(r,a){if(!w(r,a))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=f;class h{constructor(a,n,o,p){this.codeLoadingTime=a,this.activateCallTime=n,this.activateResolvedTime=o,this.activationReason=p}}e.ActivationTimes=h;class b{constructor(a,n){this.description=a,this.value=n}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function i(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=i;function l(r,a){return{identifier:new A.ExtensionIdentifier((0,D.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!a,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=l;class u{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,n){return Promise.resolve(0)}getInspectPorts(a,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(Se[229],ye([1,0,10,27,26,13,18]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class T{constructor(g,m,w,f){this.startup=g,this.codeLoadingTime=m,this.activateCallTime=w,this.activateResolvedTime=f}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class S{constructor(g){this.a=g,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(g,m){return g===-1||m===-1?-1:m-g}build(){return new T(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=S;class y{constructor(g,m,w,f,h,b){this.activationFailed=g,this.activationFailedError=m,this.activationTimes=w,this.module=f,this.exports=h,this.subscriptions=b}}e.ActivatedExtension=y;class R extends y{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class P extends y{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class E extends y{constructor(g){super(!0,g,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(g,m,w,f,h){this.h=h,this.a=g,this.b=new Set,m.forEach(b=>this.b.add(t.ExtensionIdentifier.toKey(b))),this.c=new Map,w.forEach(b=>this.c.set(t.ExtensionIdentifier.toKey(b),b)),this.d=f,this.f=new Map,this.g=Object.create(null)}dispose(){for(const[g,m]of this.f)m.dispose()}isActivated(g){const m=this.f.get(t.ExtensionIdentifier.toKey(g));return Boolean(m&&m.value)}getActivatedExtension(g){const m=this.f.get(t.ExtensionIdentifier.toKey(g));if(!m||!m.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return m.value}async activateByEvent(g,m){if(this.g[g])return;const w=this.a.getExtensionDescriptionsForActivationEvent(g);await this.j(w.map(f=>({id:f.identifier,reason:{startup:m,extensionId:f.identifier,activationEvent:g}}))),this.g[g]=!0}activateById(g,m){const w=this.a.getExtensionDescription(g);if(!w)throw new Error(`Extension '${g}' is not known`);return this.j([{id:w.identifier,reason:m}])}async j(g){const m=g.filter(w=>!this.isActivated(w.id)).map(w=>this.k(w));await Promise.all(m.map(w=>w.wait()))}k(g){if(this.f.has(t.ExtensionIdentifier.toKey(g.id)))return this.f.get(t.ExtensionIdentifier.toKey(g.id));if(this.c.has(t.ExtensionIdentifier.toKey(g.id)))return this.l(g,null,[],null);const m=this.a.getExtensionDescription(g.id);if(!m){const h=new Error(`Cannot activate unknown extension '${g.id.value}'`),b=this.l(g,null,[],new E(h));return this.d.onExtensionActivationError(g.id,h,new k.MissingExtensionDependency(g.id.value)),b}const w=[],f=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const h of f){if(this.b.has(t.ExtensionIdentifier.toKey(h)))continue;const b=this.f.get(t.ExtensionIdentifier.toKey(h));if(b){w.push(b);continue}if(this.c.has(t.ExtensionIdentifier.toKey(h))){w.push(this.k({id:this.c.get(t.ExtensionIdentifier.toKey(h)),reason:g.reason}));continue}const s=this.a.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;w.push(this.k({id:s.identifier,reason:g.reason}));continue}const i=m.displayName||m.identifier.value,l=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${h}'`),u=this.l(g,m.displayName,[],new E(l));return this.d.onExtensionActivationError(m.identifier,l,new k.MissingExtensionDependency(h)),u}return this.l(g,m.displayName,w,null)}l(g,m,w,f){const h=new v(g.id,m,g.reason,w,f,this.d,this.h);return this.f.set(t.ExtensionIdentifier.toKey(g.id),h),h}};C=qe([We(4,A.ILogService)],C),e.ExtensionsActivator=C;let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(g,m,w,f,h,b,s){this.c=g,this.d=m,this.f=w,this.g=f,this.h=h,this.j=b,this.k=s,this.a=new D.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let g=0;g<this.g.length;g++){const m=this.g[g];if(m.value&&!m.value.activationFailed){this.g.splice(g,1),g--;continue}if(m.value&&m.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);w.detail=m.value.activationFailedError,this.h=new E(w),this.j.onExtensionActivationError(this.c,w,null);return}}this.g.length>0&&await Promise.race(this.g.map(g=>g.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(g){const m=new Error;if(g&&g.name&&(m.name=g.name),g&&g.message?m.message=`Activating extension '${this.c.value}' failed: ${g.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${g}.`,g&&g.stack&&(m.stack=g.stack),this.h=new E(m),this.b&&c.isCancellationError(g))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(g)}}};v=qe([We(6,A.ILogService)],v)}),define(Se[230],ye([1,0,13,25,26]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends c.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:k.ExtensionHostLogFileName}))}};A=qe([We(0,c.ILoggerService),We(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[7],ye([1,0,17,10,110,28,83,8,11,2,30,38,127,90,26]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v){"use strict";var d,g,m,w,f,h,b,s,i,l,u,r,a,n,o,p,I,L,z,_,q,N,M;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(K){return Object.assign(K,{apply:function(){const fe=arguments.length===1?[]:arguments[1];return Reflect.construct(K,fe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(K,[]);{const[fe,...Te]=arguments;return Reflect.construct(K,Te,fe.constructor)}}})}var B;(function(K){K.top="top",K.bottom="bottom"})(B=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var U;(function(K){K.command="command",K.opener="opener"})(U=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let H=h=class{static from(...j){let fe=j;return new h(function(){if(fe){for(const Te of fe)Te&&typeof Te.dispose=="function"&&Te.dispose();fe=void 0}})}constructor(j){d.set(this,void 0),Je(this,d,j,"f")}dispose(){typeof Fe(this,d,"f")=="function"&&(Fe(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,H=h=qe([F],H),e.Disposable=H;let X=b=class{static Min(...j){if(j.length===0)throw new TypeError;let fe=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isBefore(fe)&&(fe=Ke)}return fe}static Max(...j){if(j.length===0)throw new TypeError;let fe=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isAfter(fe)&&(fe=Ke)}return fe}static isPosition(j){if(!j)return!1;if(j instanceof b)return!0;const{line:fe,character:Te}=j;return typeof fe=="number"&&typeof Te=="number"}static of(j){if(j instanceof b)return j;if(this.isPosition(j))return new b(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,fe){if(j<0)throw(0,t.illegalArgument)("line must be non-negative");if(fe<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=j,this.e=fe}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,fe=0){if(j===null||fe===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=0:typeof j=="number"?Te=j:(Te=typeof j.lineDelta=="number"?j.lineDelta:0,fe=typeof j.characterDelta=="number"?j.characterDelta:0),Te===0&&fe===0?this:new b(this.line+Te,this.character+fe)}with(j,fe=this.character){if(j===null||fe===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=this.line:typeof j=="number"?Te=j:(Te=typeof j.line=="number"?j.line:this.line,fe=typeof j.character=="number"?j.character:this.character),Te===this.line&&fe===this.character?this:new b(Te,fe)}toJSON(){return{line:this.line,character:this.character}}};X=b=qe([F],X),e.Position=X;let V=s=class{static isRange(j){return j instanceof s?!0:j?X.isPosition(j.start)&&X.isPosition(j.end):!1}static of(j){if(j instanceof s)return j;if(this.isRange(j))return new s(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,fe,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new X(j,fe),ct=new X(Te,Ke)):X.isPosition(j)&&X.isPosition(fe)&&(Ye=X.of(j),ct=X.of(fe)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(j){return s.isRange(j)?this.contains(j.start)&&this.contains(j.end):X.isPosition(j)?!(X.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const fe=X.Max(j.start,this.c),Te=X.Min(j.end,this.e);if(!fe.isAfter(Te))return new s(fe,Te)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const fe=X.Min(j.start,this.c),Te=X.Max(j.end,this.end);return new s(fe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,fe=this.end){if(j===null||fe===null)throw(0,t.illegalArgument)();let Te;return j?X.isPosition(j)?Te=j:(Te=j.start||this.start,fe=j.end||this.end):Te=this.start,Te.isEqual(this.c)&&fe.isEqual(this.end)?this:new s(Te,fe)}toJSON(){return[this.start,this.end]}};V=s=qe([F],V),e.Range=V;let x=i=class extends V{static isSelection(j){return j instanceof i?!0:j?V.isRange(j)&&X.isPosition(j.anchor)&&X.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,fe,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new X(j,fe),ct=new X(Te,Ke)):X.isPosition(j)&&X.isPosition(fe)&&(Ye=X.of(j),ct=X.of(fe)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=i=qe([F],x),e.Selection=x;class Y{constructor(j,fe,Te){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=j,this.port=Math.round(fe),this.connectionToken=Te}}e.ResolvedAuthority=Y;class J extends Error{static NotAvailable(j,fe){return new J(j,E.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(j){return new J(j,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,fe=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(j),this._message=j,this._code=fe,this._detail=Te,Object.setPrototypeOf(this,J.prototype)}}e.RemoteAuthorityResolverError=J;var te;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(te=e.EndOfLine||(e.EndOfLine={}));var le;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(le=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Z=l=class{static isTextEdit(j){return j instanceof l?!0:j?V.isRange(j)&&typeof j.newText=="string":!1}static replace(j,fe){return new l(j,fe)}static insert(j,fe){return l.replace(new V(j,j),fe)}static delete(j){return l.replace(j,"")}static setEndOfLine(j){const fe=new l(new V(new X(0,0),new X(0,0)),"");return fe.newEol=j,fe}get range(){return this.c}set range(j){if(j&&!V.isRange(j))throw(0,t.illegalArgument)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,t.illegalArgument)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,t.illegalArgument)("newEol");this.f=j}constructor(j,fe){this.c=j,this.e=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};Z=l=qe([F],Z),e.TextEdit=Z;let ge=u=class{static isNotebookCellEdit(j){return j instanceof u?!0:j?Kt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,fe){return new u(j,fe)}static insertCells(j,fe){return new u(new Kt(j,j),fe)}static deleteCells(j){return new u(j,[])}static updateCellMetadata(j,fe){const Te=new u(new Kt(j,j),[]);return Te.newCellMetadata=fe,Te}static updateNotebookMetadata(j){const fe=new u(new Kt(0,0),[]);return fe.newNotebookMetadata=j,fe}constructor(j,fe){this.range=j,this.newCells=fe}};ge=u=qe([F],ge),e.NotebookEdit=ge;class ve{static isSnippetTextEdit(j){return j instanceof ve?!0:j?V.isRange(j.range)&&ze.isSnippetString(j.snippet):!1}static replace(j,fe){return new ve(j,fe)}static insert(j,fe){return ve.replace(new V(j,j),fe)}constructor(j,fe){this.range=j,this.snippet=fe}}e.SnippetTextEdit=ve;var De;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(De=e.FileEditType||(e.FileEditType={}));let Re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,fe,Te,Ke){this.c.push({_type:1,from:j,to:fe,options:Te,metadata:Ke})}createFile(j,fe,Te){this.c.push({_type:1,from:void 0,to:j,options:fe,metadata:Te})}deleteFile(j,fe,Te){this.c.push({_type:1,from:j,to:void 0,options:fe,metadata:Te})}e(j,fe,Te){this.c.push({_type:3,metadata:Te,uri:j,edit:{editType:5,metadata:fe},notebookMetadata:fe})}f(j,fe,Te,Ke){const Ye=fe.start,ct=fe.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:j,index:Ye,count:ct-Ye,cells:Te,metadata:Ke})}g(j,fe,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:j,edit:{editType:8,index:fe,metadata:Te}})}replace(j,fe,Te,Ke){this.c.push({_type:2,uri:j,edit:new Z(fe,Te),metadata:Ke})}insert(j,fe,Te,Ke){this.replace(j,new V(fe,fe),Te,Ke)}delete(j,fe,Te){this.replace(j,fe,"",Te)}has(j){return this.c.some(fe=>fe._type===2&&fe.uri.toString()===j.toString())}set(j,fe){if(fe)for(const Te of fe){if(!Te)continue;let Ke,Ye;Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,ge.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(j,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(j,Ke.newNotebookMetadata,Ye):this.f(j,Ke.range,Ke.newCells,Ye):ve.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:j,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:j,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===j.toString()&&(this.c[Te]=void 0);break}}(0,c.coalesceInPlace)(this.c)}}get(j){const fe=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===j.toString()&&fe.push(Te.edit);return fe}entries(){const j=new A.ResourceMap;for(const fe of this.c)if(fe._type===2){let Te=j.get(fe.uri);Te||(Te=[fe.uri,[]],j.set(fe.uri,Te)),Te[1].push(fe.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Re=qe([F],Re),e.WorkspaceEdit=Re;let ze=r=class{static isSnippetString(j){return j instanceof r?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=r.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,fe=this.e++){if(typeof j=="function"){const Te=new r;Te.e=this.e,j(Te),this.e=Te.e,j=Te.value}else j=r.c(j);return this.value+="${",this.value+=fe,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,fe=this.e++){const Te=j.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(j,fe){if(typeof fe=="function"){const Te=new r;Te.e=this.e,fe(Te),this.e=Te.e,fe=Te.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};ze=r=qe([F],ze),e.SnippetString=ze;var se;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let he=a=class{static isLocation(j){return j instanceof a?!0:j?V.isRange(j.range)&&y.URI.isUri(j.uri):!1}constructor(j,fe){if(this.uri=j,fe)if(V.isRange(fe))this.range=V.of(fe);else if(X.isPosition(fe))this.range=new V(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};he=a=qe([F],he),e.Location=he;let ee=class{static is(j){return j?typeof j.message=="string"&&j.location&&V.isRange(j.location.range)&&y.URI.isUri(j.location.uri):!1}constructor(j,fe){this.location=j,this.message=fe}static isEqual(j,fe){return j===fe?!0:!j||!fe?!1:j.message===fe.message&&j.location.range.isEqual(fe.location.range)&&j.location.uri.toString()===fe.location.uri.toString()}};ee=qe([F],ee),e.DiagnosticRelatedInformation=ee;let ae=class{constructor(j,fe,Te=ue.Error){if(!V.isRange(j))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=j,this.message=fe,this.severity=Te}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,fe){return j===fe?!0:!j||!fe?!1:j.message===fe.message&&j.severity===fe.severity&&j.code===fe.code&&j.severity===fe.severity&&j.source===fe.source&&j.range.isEqual(fe.range)&&(0,c.equals)(j.tags,fe.tags)&&(0,c.equals)(j.relatedInformation,fe.relatedInformation,ee.isEqual)}};ae=qe([F],ae),e.Diagnostic=ae;let re=class{constructor(j,fe){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=fe}};re=qe([F],re),e.Hover=re;var O;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(O=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(j,fe=O.Text){this.range=j,this.kind=fe}toJSON(){return{range:this.range,kind:O[this.kind]}}};$=qe([F],$),e.DocumentHighlight=$;var G;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(G=e.SymbolKind||(e.SymbolKind={}));var Q;(function(K){K[K.Deprecated=1]="Deprecated"})(Q=e.SymbolTag||(e.SymbolTag={}));let de=n=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,fe,Te,Ke,Ye){this.name=j,this.kind=fe,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof he?this.location=Ke:Te instanceof V&&(this.location=new he(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:G[this.kind],location:this.location,containerName:this.containerName}}};de=n=qe([F],de),e.SymbolInformation=de;let be=o=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(o.validate)}constructor(j,fe,Te,Ke,Ye){this.name=j,this.detail=fe,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],o.validate(this)}};be=o=qe([F],be),e.DocumentSymbol=be;var Pe;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(j,fe){this.title=j,this.kind=fe}};pe=qe([F],pe),e.CodeAction=pe;let Ce=p=class{constructor(j){this.value=j}append(j){return new p(this.value?this.value+p.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+p.c)}};Ce.c=".",Ce=p=qe([F],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let ke=class{constructor(j,fe){if(this.range=j,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([F],ke),e.SelectionRange=ke;class je{constructor(j,fe,Te,Ke,Ye,ct){this.kind=j,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=je;class Ge{constructor(j,fe){this.fromRanges=fe,this.from=j}}e.CallHierarchyIncomingCall=Ge;class et{constructor(j,fe){this.fromRanges=fe,this.to=j}}e.CallHierarchyOutgoingCall=et;var _e;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(_e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(j,fe){this.range=j,this.command=fe}get isResolved(){return!!this.command}};nt=qe([F],nt),e.CodeLens=nt;let st=I=class{static isMarkdownString(j){return j instanceof I?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,fe=!1){g.set(this,void 0),Je(this,g,new k.MarkdownString(j,{supportThemeIcons:fe}),"f")}get value(){return Fe(this,g,"f").value}set value(j){Fe(this,g,"f").value=j}get isTrusted(){return Fe(this,g,"f").isTrusted}set isTrusted(j){Fe(this,g,"f").isTrusted=j}get supportThemeIcons(){return Fe(this,g,"f").supportThemeIcons}set supportThemeIcons(j){Fe(this,g,"f").supportThemeIcons=j}get supportHtml(){return Fe(this,g,"f").supportHtml}set supportHtml(j){Fe(this,g,"f").supportHtml=j}get baseUri(){return Fe(this,g,"f").baseUri}set baseUri(j){Fe(this,g,"f").baseUri=j}appendText(j){return Fe(this,g,"f").appendText(j),this}appendMarkdown(j){return Fe(this,g,"f").appendMarkdown(j),this}appendCodeblock(j,fe){return Fe(this,g,"f").appendCodeblock(fe??"",j),this}};g=new WeakMap,st=I=qe([F],st),e.MarkdownString=st;let ht=class{constructor(j,fe){this.label=j,this.documentation=fe}};ht=qe([F],ht),e.ParameterInformation=ht;let Me=class{constructor(j,fe){this.label=j,this.documentation=fe,this.parameters=[]}};Me=qe([F],Me),e.SignatureInformation=Me;let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};it=qe([F],it),e.SignatureHelp=it;var oe;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var W;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(W=e.InlayHintKind||(e.InlayHintKind={}));let ce=class{constructor(j){this.value=j}};ce=qe([F],ce),e.InlayHintLabelPart=ce;let Ie=class{constructor(j,fe,Te){this.position=j,this.label=fe,this.kind=Te}};Ie=qe([F],Ie),e.InlayHint=Ie;var Le;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(K){K[K.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(j,fe){this.label=j,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([F],Ze),e.CompletionItem=Ze;let mt=class{constructor(j=[],fe=!1){this.items=j,this.isIncomplete=fe}};mt=qe([F],mt),e.CompletionList=mt;let ft=class{constructor(j,fe,Te){this.insertText=j,this.range=fe,this.command=Te}};ft=qe([F],ft),e.InlineSuggestion=ft;let lt=class{constructor(j){this.commands=void 0,this.items=j}};lt=qe([F],lt),e.InlineSuggestionList=lt;var ot;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var At;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(At=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Rt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var kt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(kt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(K){function j(fe){switch(fe){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=j}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Mt=class{constructor(j,fe){if(fe&&!y.URI.isUri(fe))throw(0,t.illegalArgument)("target");if(!V.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.target=fe}};Mt=qe([F],Mt),e.DocumentLink=Mt;let xe=class{constructor(j,fe,Te,Ke){this.red=j,this.green=fe,this.blue=Te,this.alpha=Ke}};xe=qe([F],xe),e.Color=xe;let Ot=class{constructor(j,fe){if(fe&&!(fe instanceof xe))throw(0,t.illegalArgument)("color");if(!V.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.color=fe}};Ot=qe([F],Ot),e.ColorInformation=Ot;let Ut=class{constructor(j){if(!j||typeof j!="string")throw(0,t.illegalArgument)("label");this.label=j}};Ut=qe([F],Ut),e.ColorPresentation=Ut;var Ht;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Ht=e.ColorFormat||(e.ColorFormat={}));var bt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Lt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(Lt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ae{constructor(j,fe,Te){if(this.startIndex=j,this.length=fe,this.tooltip=Te,typeof j!="number"||j<0)throw(0,t.illegalArgument)("startIndex");if(typeof fe!="number"||fe<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ae;var Oe;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Oe=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(j){if(this.options=j,typeof j!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ee;var ie;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(ie=e.TaskRevealKind||(e.TaskRevealKind={}));var Ne;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Ne=e.TaskPanelKind||(e.TaskPanelKind={}));let $e=L=class{static from(j){switch(j){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(j,fe){if(this.label=fe,typeof j!="string"||typeof fe!="string")throw(0,t.illegalArgument)("name");this.c=j}get id(){return this.c}};$e.Clean=new L("clean","Clean"),$e.Build=new L("build","Build"),$e.Rebuild=new L("rebuild","Rebuild"),$e.Test=new L("test","Test"),$e=L=qe([F],$e),e.TaskGroup=$e;function Qe(K){let j="";for(let fe=0;fe<K.length;fe++)j+=K[fe].replace(/,/g,",,")+",";return j}let Ve=class{constructor(j,fe,Te){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=j,fe!==void 0&&(Array.isArray(fe)?(this.e=fe,this.f=Te):this.f=fe)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const fe of this.e)j.push(fe);return Qe(j)}};Ve=qe([F],Ve),e.ProcessExecution=Ve;let tt=class{constructor(j,fe,Te){if(this.f=[],Array.isArray(fe)){if(!j)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j,this.f=fe,this.g=Te}else{if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j,this.g=fe}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const fe of this.f)j.push(typeof fe=="string"?fe:fe.value);return Qe(j)}};tt=qe([F],tt),e.ShellExecution=tt;var It;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class Tt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(j){this.c=j}get callback(){return this.c}}e.CustomExecution=Tt;let wt=z=class{constructor(j,fe,Te,Ke,Ye,ct){this.j=!1,this.k=this.definition=j;let dt;typeof fe=="string"?(this.m=this.name=fe,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):fe===Et.Global||fe===Et.Workspace?(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct):(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Ve?this.k={type:z.e,id:this.n.computeId()}:this.n instanceof tt?this.k={type:z.f,id:this.n.computeId()}:this.n instanceof Tt?this.k={type:z.c,id:this.n.computeId()}:this.k={type:z.g,id:(0,R.generateUuid)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=j}get scope(){return this.l}set target(j){this.y(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.y(),this.n=j;const fe=this.k.type;(z.g===fe||z.e===fe||z.f===fe||z.c===fe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.y(),this.o=j,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.y(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.y(),this.u=j}get detail(){return this.x}set detail(j){j===null&&(j=void 0),this.x=j}get presentationOptions(){return this.v}set presentationOptions(j){j==null&&(j=Object.create(null)),this.y(),this.v=j}get runOptions(){return this.w}set runOptions(j){j==null&&(j=Object.create(null)),this.y(),this.w=j}};wt.c="customExecution",wt.e="process",wt.f="shell",wt.g="$empty",wt=z=qe([F],wt),e.Task=wt;var vt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));var yt;(function(K){function j(fe){const Te=fe;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}K.isViewBadge=j})(yt=e.ViewBadge||(e.ViewBadge={}));let zt=_=class{static isTreeItem(j,fe){if(j instanceof _)return!0;const Te=j;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!y.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!y.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!y.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!y.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<xt.None&&Te.collapsibleState>xt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,v.checkProposedApiEnabled)(fe,"treeItemCheckbox");const Ke=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==St.Checked&&Ke!==St.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(j,fe=xt.None){this.collapsibleState=fe,y.URI.isUri(j)?this.resourceUri=j:this.label=j}};zt=_=qe([F],zt),e.TreeItem=zt;var xt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(xt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var St;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(St=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let on=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j,fe){this.value=j,this.id=fe??(0,R.generateUuid)()}};on=qe([F],on),e.DataTransferItem=on;let an=class{constructor(j){m.set(this,new Map);for(const[fe,Te]of j??[]){const Ke=Fe(this,m,"f").get(fe);Ke?Ke.push(Te):Fe(this,m,"f").set(fe,[Te])}}get(j){return Fe(this,m,"f").get(j)?.[0]}set(j,fe){Fe(this,m,"f").set(j,[fe])}forEach(j,fe){for(const[Te,Ke]of Fe(this,m,"f"))for(const Ye of Ke)j.call(fe,Ye,Te,this)}*[(m=new WeakMap,Symbol.iterator)](){for(const[j,fe]of Fe(this,m,"f"))for(const Te of fe)yield[j,Te]}};an=qe([F],an),e.DataTransfer=an;let Zt=class{constructor(j){this.insertText=j}};Zt=qe([F],Zt),e.DocumentDropEdit=Zt;let bn=class{constructor(j){this.insertText=j}};bn=qe([F],bn),e.DocumentPasteEdit=bn;let Ct=class{constructor(j,fe){this.id=j,this.color=fe}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};Ct=qe([F],Ct),e.ThemeIcon=Ct,Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let cn=class{constructor(j){this.id=j}};cn=qe([F],cn),e.ThemeColor=cn;var On;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(On=e.ConfigurationTarget||(e.ConfigurationTarget={}));let en=class{get base(){return this.c}set base(j){this.c=j,this.e=y.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,fe){if(typeof j!="string"&&(!j||!y.URI.isUri(j)&&!y.URI.isUri(j.uri)))throw(0,t.illegalArgument)("base");if(typeof fe!="string")throw(0,t.illegalArgument)("pattern");typeof j=="string"?this.baseUri=y.URI.file(j):y.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};en=qe([F],en),e.RelativePattern=en;let jt=class{constructor(j,fe,Te,Ke){this.enabled=typeof j=="boolean"?j:!0,typeof fe=="string"&&(this.condition=fe),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,R.generateUuid)()),this.c}};jt=qe([F],jt),e.Breakpoint=jt;let ut=class extends jt{constructor(j,fe,Te,Ke,Ye){if(super(fe,Te,Ke,Ye),j===null)throw(0,t.illegalArgument)("location");this.location=j}};ut=qe([F],ut),e.SourceBreakpoint=ut;let wn=class extends jt{constructor(j,fe,Te,Ke,Ye){super(fe,Te,Ke,Ye),this.functionName=j}};wn=qe([F],wn),e.FunctionBreakpoint=wn;let Vt=class extends jt{constructor(j,fe,Te,Ke,Ye,ct,dt){if(super(Ke,Ye,ct,dt),!fe)throw(0,t.illegalArgument)("dataId");this.label=j,this.dataId=fe,this.canPersist=Te}};Vt=qe([F],Vt),e.DataBreakpoint=Vt;let _t=class{constructor(j,fe,Te){this.command=j,this.args=fe||[],this.options=Te}};_t=qe([F],_t),e.DebugAdapterExecutable=_t;let ln=class{constructor(j,fe){this.port=j,this.host=fe}};ln=qe([F],ln),e.DebugAdapterServer=ln;let vn=class{constructor(j){this.path=j}};vn=qe([F],vn),e.DebugAdapterNamedPipeServer=vn;let un=class{constructor(j){this.implementation=j}};un=qe([F],un),e.DebugAdapterInlineImplementation=un;let En=class{constructor(j,fe){this.range=j,this.expression=fe}};En=qe([F],En),e.EvaluatableExpression=En;var kn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let tn=class{constructor(j,fe){this.range=j,this.text=fe}};tn=qe([F],tn),e.InlineValueText=tn;let Sn=class{constructor(j,fe,Te=!0){this.range=j,this.variableName=fe,this.caseSensitiveLookup=Te}};Sn=qe([F],Sn),e.InlineValueVariableLookup=Sn;let rn=class{constructor(j,fe){this.range=j,this.expression=fe}};rn=qe([F],rn),e.InlineValueEvaluatableExpression=rn;let sn=class{constructor(j,fe){this.frameId=j,this.stoppedLocation=fe}};sn=qe([F],sn),e.InlineValueContext=sn;var Nn;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Nn=e.FileChangeType||(e.FileChangeType={}));let yn=q=class extends Error{static FileExists(j){return new q(j,P.FileSystemProviderErrorCode.FileExists,q.FileExists)}static FileNotFound(j){return new q(j,P.FileSystemProviderErrorCode.FileNotFound,q.FileNotFound)}static FileNotADirectory(j){return new q(j,P.FileSystemProviderErrorCode.FileNotADirectory,q.FileNotADirectory)}static FileIsADirectory(j){return new q(j,P.FileSystemProviderErrorCode.FileIsADirectory,q.FileIsADirectory)}static NoPermissions(j){return new q(j,P.FileSystemProviderErrorCode.NoPermissions,q.NoPermissions)}static Unavailable(j){return new q(j,P.FileSystemProviderErrorCode.Unavailable,q.Unavailable)}constructor(j,fe=P.FileSystemProviderErrorCode.Unknown,Te){super(y.URI.isUri(j)?j.toString(!0):j),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,fe),Object.setPrototypeOf(this,q.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};yn=q=qe([F],yn),e.FileSystemError=yn;let Qt=class{constructor(j,fe,Te){this.start=j,this.end=fe,this.kind=Te}};Qt=qe([F],Qt),e.FoldingRange=Qt;var Fn;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Fn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mn;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Mn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Un;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Un=e.CommentMode||(e.CommentMode={}));var Bn;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Bn=e.CommentThreadState||(e.CommentThreadState={}));class zn{constructor(j,fe=[]){this.tokenTypes=j,this.tokenModifiers=fe}}e.SemanticTokensLegend=zn;function Cn(K){return typeof K>"u"||(0,S.isStringArray)(K)}class dn{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let fe=0,Te=j.tokenTypes.length;fe<Te;fe++)this.j.set(j.tokenTypes[fe],fe);for(let fe=0,Te=j.tokenModifiers.length;fe<Te;fe++)this.k.set(j.tokenModifiers[fe],fe)}}push(j,fe,Te,Ke,Ye){if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(j,fe,Te,Ke,Ye);if(V.isRange(j)&&typeof fe=="string"&&Cn(Te))return this.m(j,fe,Te);throw(0,t.illegalArgument)()}m(j,fe,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(fe))throw new Error("`tokenType` is not in the provided legend");const Ke=j.start.line,Ye=j.start.character,ct=j.end.character-j.start.character,dt=this.j.get(fe);let Nt=0;if(Te)for(const Wt of Te){if(!this.k.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Wt);Nt|=1<<qt>>>0}this.n(Ke,Ye,ct,dt,Nt)}n(j,fe,Te,Ke,Ye){if(this.f&&(j<this.c||j===this.c&&fe<this.e)){this.f=!1;const Nt=this.g.length/5|0;let Wt=0,qt=0;for(let Xt=0;Xt<Nt;Xt++){let Yt=this.g[5*Xt],Dn=this.g[5*Xt+1];Yt===0?(Yt=Wt,Dn+=qt):Yt+=Wt,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Dn,Wt=Yt,qt=Dn}}let ct=j,dt=fe;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=j,this.e=fe}static o(j){const fe=[],Te=j.length/5|0;for(let dt=0;dt<Te;dt++)fe[dt]=dt;fe.sort((dt,Nt)=>{const Wt=j[5*dt],qt=j[5*Nt];if(Wt===qt){const Xt=j[5*dt+1],Yt=j[5*Nt+1];return Xt-Yt}return Wt-qt});const Ke=new Uint32Array(j.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Nt=5*fe[dt],Wt=j[Nt+0],qt=j[Nt+1],Xt=j[Nt+2],Yt=j[Nt+3],Dn=j[Nt+4],ti=Wt-Ye,Ii=ti===0?qt-ct:qt,In=5*dt;Ke[In+0]=ti,Ke[In+1]=Ii,Ke[In+2]=Xt,Ke[In+3]=Yt,Ke[In+4]=Dn,Ye=Wt,ct=qt}return Ke}build(j){return this.f?new hn(new Uint32Array(this.g),j):new hn(dn.o(this.g),j)}}e.SemanticTokensBuilder=dn;class hn{constructor(j,fe){this.resultId=fe,this.data=j}}e.SemanticTokens=hn;class He{constructor(j,fe,Te){this.start=j,this.deleteCount=fe,this.data=Te}}e.SemanticTokensEdit=He;class Gt{constructor(j,fe){this.resultId=fe,this.edits=j}}e.SemanticTokensEdits=Gt;var Tn;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Tn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let gt=class{constructor(){}};gt.Back={iconPath:new Ct("arrow-left")},gt=qe([F],gt),e.QuickInputButtons=gt;var $n;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})($n=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Wn;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Wn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Pn;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Pn=e.ExtensionKind||(e.ExtensionKind={}));class Hn{static validate(j){if(typeof j.badge=="string"){let fe=(0,T.nextCharLength)(j.badge,0);if(fe<j.badge.length&&(fe+=(0,T.nextCharLength)(j.badge,fe)),j.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Ct.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,fe,Te){this.badge=j,this.tooltip=fe,this.color=Te}}e.FileDecoration=Hn;let nn=class{constructor(j){this.kind=j}};nn=qe([F],nn),e.ColorTheme=nn;var jn;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(jn=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(j){return j instanceof Kt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,fe){if(j<0)throw(0,t.illegalArgument)("start must be positive");if(fe<0)throw(0,t.illegalArgument)("end must be positive");j<=fe?(this.c=j,this.e=fe):(this.c=fe,this.e=j)}with(j){let fe=this.c,Te=this.e;return j.start!==void 0&&(fe=j.start),j.end!==void 0&&(Te=j.end),fe===this.c&&Te===this.e?this:new Kt(fe,Te)}}e.NotebookRange=Kt;class fn{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(fe=>fn.isNotebookCellData(fe))}static isNotebookCellData(j){return!0}constructor(j,fe,Te,Ke,Ye,ct,dt){this.kind=j,this.value=fe,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,fn.validate(this)}}e.NotebookCellData=fn;class An{constructor(j){this.cells=j}}e.NotebookData=An;class $t{static isNotebookCellOutputItem(j){return j instanceof $t?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const fe={name:j.name,message:j.message,stack:j.stack};return $t.json(fe,"application/vnd.code.notebook.error")}static stdout(j){return $t.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return $t.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,fe="application/octet-stream"){return new $t(j,fe)}static text(j,fe=D.Mimes.text){const Te=Fe($t,w,"f",f).encode(String(j));return new $t(Te,fe)}static json(j,fe="text/x-json"){const Te=JSON.stringify(j,void 0,"	");return $t.text(Te,fe)}constructor(j,fe){this.data=j,this.mime=fe;const Te=(0,D.normalizeMimeType)(fe,!0);if(!Te)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=$t,w=$t,f={value:new TextEncoder};class mn{static isNotebookCellOutput(j){return j instanceof mn?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,fe=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<j.length;Ye++){const ct=j[Ye],dt=(0,D.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,C.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),fe&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?j:j.filter((Ye,ct)=>!Ke.has(ct))}constructor(j,fe,Te){this.items=mn.ensureUniqueMimeTypes(j,!0),typeof fe=="string"?(this.id=fe,this.metadata=Te):(this.id=(0,R.generateUuid)(),this.metadata=fe??Te)}}e.NotebookCellOutput=mn;var Vn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Vn=e.NotebookCellKind||(e.NotebookCellKind={}));var qn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(qn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Gn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Kn;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Kn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class me{constructor(j,fe){this.text=j,this.alignment=fe}}e.NotebookCellStatusBarItem=me;var we;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(we=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Ue;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(Ue=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class at{constructor(j,fe=[]){this.uri=j,this.provides=(0,c.asArray)(fe)}}e.NotebookRendererScript=at;class Dt{constructor(j){this.label=j}}e.NotebookKernelSourceAction=Dt;let Pt=class{constructor(j,fe){this.label=j,this.timestamp=fe}};Pt=qe([F],Pt),e.TimelineItem=Pt;var si;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class ci{constructor(j,fe){this.ranges=j,this.wordPattern=fe}}e.LinkedEditingRanges=ci;class li{constructor(j,fe){this.c=j,this.e=fe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=li;var ui;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var di;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(di=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Xn=class{constructor(j=void 0,fe=void 0,Te=void 0){this.include=j,this.exclude=fe,this.profile=Te}};Xn=qe([F],Xn),e.TestRunRequest=Xn;let xn=N=class{static diff(j,fe,Te){const Ke=new N(j);return Ke.expectedOutput=fe,Ke.actualOutput=Te,Ke}constructor(j){this.message=j}};xn=N=qe([F],xn),e.TestMessage=xn;let _n=class{constructor(j){this.id=j}};_n=qe([F],_n),e.TestTag=_n;let gn=class{constructor(j,fe){this.covered=j,this.total=fe}};gn=qe([F],gn),e.CoveredCount=gn;let Qn=M=class{static fromDetails(j,fe){const Te=new gn(0,0),Ke=new gn(0,0),Ye=new gn(0,0);for(const dt of fe)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Nt of dt.branches)Ke.total+=1,Ke.covered+=Nt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new M(j,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=fe,ct}constructor(j,fe,Te,Ke){this.uri=j,this.statementCoverage=fe,this.branchCoverage=Te,this.functionCoverage=Ke}};Qn=M=qe([F],Qn),e.FileCoverage=Qn;let Yn=class{constructor(j,fe,Te=[]){this.executionCount=j,this.location=fe,this.branches=Te}};Yn=qe([F],Yn),e.StatementCoverage=Yn;let Jn=class{constructor(j,fe){this.executionCount=j,this.location=fe}};Jn=qe([F],Jn),e.BranchCoverage=Jn;let Zn=class{constructor(j,fe){this.executionCount=j,this.location=fe}};Zn=qe([F],Zn),e.FunctionCoverage=Zn;var hi;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fi;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(fi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(j,fe,Te,Ke,Ye,ct){this.kind=j,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=gi;class pi{constructor(j){this.uri=j}}e.TextTabInput=pi;class bi{constructor(j,fe){this.original=j,this.modified=fe}}e.TextDiffTabInput=bi;class wi{constructor(j,fe,Te,Ke){this.base=j,this.input1=fe,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=wi;class vi{constructor(j,fe){this.uri=j,this.viewType=fe}}e.CustomEditorTabInput=vi;class Ei{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=Ei;class Si{constructor(j,fe){this.uri=j,this.notebookType=fe}}e.NotebookEditorTabInput=Si;class yi{constructor(j,fe,Te){this.original=j,this.modified=fe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=yi;class Ci{constructor(){}}e.TerminalEditorTabInput=Ci;class Di{constructor(j,fe){this.uri=j,this.inputBoxUri=fe}}e.InteractiveWindowInput=Di}),define(Se[134],ye([1,0,49,15,8,161,104,7,17]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const y=new Map;function R(v,d){d?y.set(v,d):y.delete(v)}e.setWordDefinitionFor=R;function P(v){return y.get(v)}class E extends A.MirrorTextModel{constructor(d,g,m,w,f,h,b,s){super(g,m,w,f),this.m=d,this.p=h,this.q=b,this.notebook=s,this.b=!1}dispose(){(0,c.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===t.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(g){return g?d.s(g):d.getText()},get eol(){return d.f===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(g){return d.t(g)},offsetAt(g){return d.u(g)},positionAt(g){return d.v(g)},validateRange(g){return d.w(g)},validatePosition(g){return d.x(g)},getWordRangeAtPosition(g,m){return d.y(g,m)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,c.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,c.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const g=this.w(d);if(g.isEmpty)return"";if(g.isSingleLine)return this.d[g.start.line].substring(g.start.character,g.end.character);const m=this.f,w=g.start.line,f=g.end.line,h=[];h.push(this.d[w].substring(g.start.character));for(let b=w+1;b<f;b++)h.push(this.d[b]);return h.push(this.d[f].substring(0,g.end.character)),h.join(m)}t(d){let g;if(d instanceof T.Position?g=d.line:typeof d=="number"&&(g=d),typeof g!="number"||g<0||g>=this.d.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new C(g,this.d[g],g===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const g=this.h.getIndexOf(d),m=this.d[g.index].length;return new T.Position(g.index,Math.min(g.remainder,m))}w(d){if(!(d instanceof T.Range))throw new Error("Invalid argument");const g=this.x(d.start),m=this.x(d.end);return g===d.start&&m===d.end?d:new T.Range(g.line,g.character,m.line,m.character)}x(d){if(!(d instanceof T.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:g,character:m}=d,w=!1;if(g<0)g=0,m=0,w=!0;else if(g>=this.d.length)g=this.d.length-1,m=this.d[g].length,w=!0;else{const f=this.d[g].length;m<0?(m=0,w=!0):m>f&&(m=f,w=!0)}return w?new T.Position(g,m):d}y(d,g){const m=this.x(d);if(!g)g=P(this.p);else if((0,k.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const w=(0,D.getWordAtText)(m.character+1,(0,D.ensureValidWordDefinition)(g),this.d[m.line],0);if(w)return new T.Range(m.line,w.startColumn-1,m.line,w.endColumn-1)}}e.ExtHostDocumentData=E;class C{constructor(d,g,m){this.a=d,this.b=g,this.c=m}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=C}),define(Se[231],ye([1,0,7,16,4]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(T){this.a=new c.ColorTheme(c.ColorThemeKind.Dark),this.b=new k.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(T){let S;switch(T){case"light":S=c.ColorThemeKind.Light;break;case"hcDark":S=c.ColorThemeKind.HighContrast;break;case"hcLight":S=c.ColorThemeKind.HighContrastLight;break;default:S=c.ColorThemeKind.Dark}this.a=new c.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};A=qe([We(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Se[14],ye([1,0,17,22,147,61,110,28,146,85,83,23,11,2,35,66,122,132,130,90,56,69,225,7]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h,b,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(Ae){function Oe(ie){const{selectionStartLineNumber:Ne,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Ve}=ie,tt=new i.Position(Ne-1,$e-1),It=new i.Position(Qe-1,Ve-1);return new i.Selection(tt,It)}Ae.to=Oe;function Ee(ie){const{anchor:Ne,active:$e}=ie;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Ae.from=Ee})(l=e.Selection||(e.Selection={}));var u;(function(Ae){function Oe(ie){if(!ie)return;const{start:Ne,end:$e}=ie;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Ae.from=Oe;function Ee(ie){if(!ie)return;const{startLineNumber:Ne,startColumn:$e,endLineNumber:Qe,endColumn:Ve}=ie;return new i.Range(Ne-1,$e-1,Qe-1,Ve-1)}Ae.to=Ee})(u=e.Range||(e.Range={}));var r;(function(Ae){function Oe(Ee){switch(Ee){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}Ae.to=Oe})(r=e.TokenType||(e.TokenType={}));var a;(function(Ae){function Oe(ie){return new i.Position(ie.lineNumber-1,ie.column-1)}Ae.to=Oe;function Ee(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Ae.from=Ee})(a=e.Position||(e.Position={}));var n;(function(Ae){function Oe(Ne,$e){return(0,c.coalesce)((0,c.asArray)(Ne).map(Qe=>Ee(Qe,$e)))}Ae.from=Oe;function Ee(Ne,$e){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:ie(Ne.scheme,$e),pattern:W.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function ie(Ne,$e){return $e&&typeof Ne=="string"?$e.transformOutgoingScheme(Ne):Ne}})(n=e.DocumentSelector||(e.DocumentSelector={}));var o;(function(Ae){function Oe(ie){switch(ie){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Ee(ie){switch(ie){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}Ae.to=Ee})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(Ae){function Oe(ie){let Ne;return ie.code&&((0,E.isString)(ie.code)||(0,E.isNumber)(ie.code)?Ne=String(ie.code):Ne={value:String(ie.code.value),target:ie.code.target}),{...u.from(ie.range),message:ie.message,source:ie.source,code:Ne,severity:L.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(I.from),tags:Array.isArray(ie.tags)?(0,c.coalesce)(ie.tags.map(o.from)):void 0}}Ae.from=Oe;function Ee(ie){const Ne=new i.Diagnostic(u.to(ie),ie.message,L.to(ie.severity));return Ne.source=ie.source,Ne.code=(0,E.isString)(ie.code)?ie.code:ie.code?.value,Ne.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(I.to),Ne.tags=ie.tags&&(0,c.coalesce)(ie.tags.map(o.to)),Ne}Ae.to=Ee})(p=e.Diagnostic||(e.Diagnostic={}));var I;(function(Ae){function Oe(ie){return{...u.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Ae.from=Oe;function Ee(ie){return new i.DiagnosticRelatedInformation(new i.Location(ie.resource,u.to(ie)),ie.message)}Ae.to=Ee})(I=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var L;(function(Ae){function Oe(ie){switch(ie){case i.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Ae.from=Oe;function Ee(ie){switch(ie){case g.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}Ae.to=Ee})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var z;(function(Ae){function Oe(ie){return typeof ie=="number"&&ie>=i.ViewColumn.One?ie-1:ie===i.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}Ae.from=Oe;function Ee(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Ee})(z=e.ViewColumn||(e.ViewColumn={}));function _(Ae){return typeof Ae.range<"u"}function q(Ae){return Ae.length===0?!0:!!_(Ae[0])}e.isDecorationOptionsArr=q;var N;(function(Ae){function Oe(Ve){return Ve.map(Ae.from)}Ae.fromMany=Oe;function Ee(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function ie(Ve){let tt;if(Ee(Ve)){const{language:wt,value:vt}=Ve;tt={value:"```"+wt+`
`+vt+"\n```\n"}}else i.MarkdownString.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const It=Object.create(null);tt.uris=It;const Et=wt=>{try{let vt=C.URI.parse(wt,!0);vt=vt.with({query:Ne(vt.query,It)}),It[wt]=vt}catch{}return""},Tt=new S.marked.Renderer;return Tt.link=Et,Tt.image=wt=>typeof wt=="string"?Et(D.parseHrefAndDimensions(wt).href):"",(0,S.marked)(tt.value,{renderer:Tt}),tt}Ae.from=ie;function Ne(Ve,tt){if(!Ve)return Ve;let It;try{It=(0,y.parse)(Ve)}catch{}if(!It)return Ve;let Et=!1;return It=(0,P.cloneAndChange)(It,Tt=>{if(C.URI.isUri(Tt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[wt]=Tt,Et=!0,wt}else return}),Et?JSON.stringify(It):Ve}function $e(Ve){const tt=new i.MarkdownString(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?C.URI.from(Ve.baseUri):void 0,tt}Ae.to=$e;function Qe(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Ae.from(Ve)}Ae.fromStrict=Qe})(N=e.MarkdownString||(e.MarkdownString={}));function M(Ae){return q(Ae)?Ae.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?N.fromMany(Oe.hoverMessage):Oe.hoverMessage?N.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=M;function F(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?C.URI.file(Ae):Ae}e.pathOrURIToURI=F;var B;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?F(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Ae.from=Oe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?B.from(Ee.before):void 0,after:Ee.after?B.from(Ee.after):void 0}}Ae.from=Oe})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(Ae){function Oe(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var X;(function(Ae){function Oe(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?H.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?U.from(Ee.light):void 0,dark:Ee.dark?U.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?B.from(Ee.before):void 0,after:Ee.after?B.from(Ee.after):void 0}}Ae.from=Oe})(X=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Ae){function Oe(ie){return{text:ie.newText,eol:ie.newEol&&st.from(ie.newEol),range:u.from(ie.range)}}Ae.from=Oe;function Ee(ie){const Ne=new i.TextEdit(u.to(ie.range),ie.text);return Ne.newEol=typeof ie.eol>"u"?void 0:st.to(ie.eol),Ne}Ae.to=Ee})(V=e.TextEdit||(e.TextEdit={}));var x;(function(Ae){function Oe(ie,Ne){const $e={edits:[]};if(ie instanceof i.WorkspaceEdit){const Qe=new T.ResourceSet;for(const Ve of ie._allEntries())Ve._type===1&&C.URI.isUri(Ve.to)&&Ve.from===void 0&&Qe.add(Ve.to);for(const Ve of ie._allEntries())Ve._type===1?$e.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?$e.edits.push({resource:Ve.uri,textEdit:V.from(Ve.edit),versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?$e.edits.push({resource:Ve.uri,textEdit:{range:u.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(mt.from)}})}return $e}Ae.from=Oe;function Ee(ie){const Ne=new i.WorkspaceEdit;for(const $e of ie.edits)$e.textEdit?Ne.replace(C.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Ne.renameFile(C.URI.revive($e.oldResource),C.URI.revive($e.newResource),$e.options);return Ne}Ae.to=Ee})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Y;(function(Ae){const Oe=Object.create(null);Oe[i.SymbolKind.File]=0,Oe[i.SymbolKind.Module]=1,Oe[i.SymbolKind.Namespace]=2,Oe[i.SymbolKind.Package]=3,Oe[i.SymbolKind.Class]=4,Oe[i.SymbolKind.Method]=5,Oe[i.SymbolKind.Property]=6,Oe[i.SymbolKind.Field]=7,Oe[i.SymbolKind.Constructor]=8,Oe[i.SymbolKind.Enum]=9,Oe[i.SymbolKind.Interface]=10,Oe[i.SymbolKind.Function]=11,Oe[i.SymbolKind.Variable]=12,Oe[i.SymbolKind.Constant]=13,Oe[i.SymbolKind.String]=14,Oe[i.SymbolKind.Number]=15,Oe[i.SymbolKind.Boolean]=16,Oe[i.SymbolKind.Array]=17,Oe[i.SymbolKind.Object]=18,Oe[i.SymbolKind.Key]=19,Oe[i.SymbolKind.Null]=20,Oe[i.SymbolKind.EnumMember]=21,Oe[i.SymbolKind.Struct]=22,Oe[i.SymbolKind.Event]=23,Oe[i.SymbolKind.Operator]=24,Oe[i.SymbolKind.TypeParameter]=25;function Ee(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Ae.from=Ee;function ie(Ne){for(const $e in Oe)if(Oe[$e]===Ne)return Number($e);return i.SymbolKind.Property}Ae.to=ie})(Y=e.SymbolKind||(e.SymbolKind={}));var J;(function(Ae){function Oe(ie){switch(ie){case i.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Ee(ie){switch(ie){case 1:return i.SymbolTag.Deprecated}}Ae.to=Ee})(J=e.SymbolTag||(e.SymbolTag={}));var te;(function(Ae){function Oe(ie){return{name:ie.name,kind:Y.from(ie.kind),tags:ie.tags&&ie.tags.map(J.from),containerName:ie.containerName,location:De.from(ie.location)}}Ae.from=Oe;function Ee(ie){const Ne=new i.SymbolInformation(ie.name,Y.to(ie.kind),ie.containerName,De.to(ie.location));return Ne.tags=ie.tags&&ie.tags.map(J.to),Ne}Ae.to=Ee})(te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(Ae){function Oe(ie){const Ne={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),kind:Y.from(ie.kind),tags:ie.tags?.map(J.from)??[]};return ie.children&&(Ne.children=ie.children.map(Oe)),Ne}Ae.from=Oe;function Ee(ie){const Ne=new i.DocumentSymbol(ie.name,ie.detail,Y.to(ie.kind),u.to(ie.range),u.to(ie.selectionRange));return(0,c.isNonEmptyArray)(ie.tags)&&(Ne.tags=ie.tags.map(J.to)),ie.children&&(Ne.children=ie.children.map(Ee)),Ne}Ae.to=Ee})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var Z;(function(Ae){function Oe(ie){const Ne=new i.CallHierarchyItem(Y.to(ie.kind),ie.name,ie.detail||"",C.URI.revive(ie.uri),u.to(ie.range),u.to(ie.selectionRange));return Ne._sessionId=ie._sessionId,Ne._itemId=ie._itemId,Ne}Ae.to=Oe;function Ee(ie,Ne,$e){if(Ne=Ne??ie._sessionId,$e=$e??ie._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,name:ie.name,detail:ie.detail,kind:Y.from(ie.kind),uri:ie.uri,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),tags:ie.tags?.map(J.from)}}Ae.from=Ee})(Z=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ge;(function(Ae){function Oe(Ee){return new i.CallHierarchyIncomingCall(Z.to(Ee.from),Ee.fromRanges.map(ie=>u.to(ie)))}Ae.to=Oe})(ge=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(Ae){function Oe(Ee){return new i.CallHierarchyOutgoingCall(Z.to(Ee.to),Ee.fromRanges.map(ie=>u.to(ie)))}Ae.to=Oe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var De;(function(Ae){function Oe(ie){return{range:ie.range&&u.from(ie.range),uri:ie.uri}}Ae.from=Oe;function Ee(ie){return new i.Location(C.URI.revive(ie.uri),u.to(ie.range))}Ae.to=Ee})(De=e.location||(e.location={}));var Re;(function(Ae){function Oe(ie){const Ne=ie,$e=ie;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:$e.uri,range:u.from(Ne.targetRange?Ne.targetRange:$e.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Ae.from=Oe;function Ee(ie){return{targetUri:C.URI.revive(ie.uri),targetRange:u.to(ie.range),targetSelectionRange:ie.targetSelectionRange?u.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?u.to(ie.originSelectionRange):void 0}}Ae.to=Ee})(Re=e.DefinitionLink||(e.DefinitionLink={}));var ze;(function(Ae){function Oe(ie){return{range:u.from(ie.range),contents:N.fromMany(ie.contents)}}Ae.from=Oe;function Ee(ie){return new i.Hover(ie.contents.map(N.to),u.to(ie.range))}Ae.to=Ee})(ze=e.Hover||(e.Hover={}));var se;(function(Ae){function Oe(ie){return{range:u.from(ie.range),expression:ie.expression}}Ae.from=Oe;function Ee(ie){return new i.EvaluatableExpression(u.to(ie.range),ie.expression)}Ae.to=Ee})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ue;(function(Ae){function Oe(ie){if(ie instanceof i.InlineValueText)return{type:"text",range:u.from(ie.range),text:ie.text};if(ie instanceof i.InlineValueVariableLookup)return{type:"variable",range:u.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof i.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Ee(ie){switch(ie.type){case"text":return{range:u.to(ie.range),text:ie.text};case"variable":return{range:u.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:u.to(ie.range),expression:ie.expression}}}Ae.to=Ee})(ue=e.InlineValue||(e.InlineValue={}));var he;(function(Ae){function Oe(ie){return{frameId:ie.frameId,stoppedLocation:u.from(ie.stoppedLocation)}}Ae.from=Oe;function Ee(ie){return new i.InlineValueContext(ie.frameId,u.to(ie.stoppedLocation))}Ae.to=Ee})(he=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Ae){function Oe(ie){return{range:u.from(ie.range),kind:ie.kind}}Ae.from=Oe;function Ee(ie){return new i.DocumentHighlight(u.to(ie.range),ie.kind)}Ae.to=Ee})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(Ae){function Oe(Ee){switch(Ee){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}Ae.to=Oe})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var re;(function(Ae){function Oe(Ee){return{triggerKind:ae.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Ae.to=Oe})(re=e.CompletionContext||(e.CompletionContext={}));var O;(function(Ae){function Oe(ie){switch(ie){case i.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Ee(ie){switch(ie){case 1:return i.CompletionItemTag.Deprecated}}Ae.to=Ee})(O=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(Ae){const Oe=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function Ee($e){return Oe.get($e)??9}Ae.from=Ee;const ie=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Ne($e){return ie.get($e)??i.CompletionItemKind.Property}Ae.to=Ne})($=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(Ae){function Oe(Ee,ie){const Ne=new i.CompletionItem(Ee.label);return Ne.insertText=Ee.insertText,Ne.kind=$.to(Ee.kind),Ne.tags=Ee.tags?.map(O.to),Ne.detail=Ee.detail,Ne.documentation=D.isMarkdownString(Ee.documentation)?N.to(Ee.documentation):Ee.documentation,Ne.sortText=Ee.sortText,Ne.filterText=Ee.filterText,Ne.preselect=Ee.preselect,Ne.commitCharacters=Ee.commitCharacters,v.Range.isIRange(Ee.range)?Ne.range=u.to(Ee.range):typeof Ee.range=="object"&&(Ne.range={inserting:u.to(Ee.range.insert),replacing:u.to(Ee.range.replace)}),Ne.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:Boolean(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Ne.insertText=new i.SnippetString(Ee.insertText):(Ne.insertText=Ee.insertText,Ne.textEdit=Ne.range instanceof i.Range?new i.TextEdit(Ne.range,Ne.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ee.additionalTextEdits.map($e=>V.to($e))),Ne.command=ie&&Ee.command?ie.fromInternal(Ee.command):void 0,Ne}Ae.to=Oe})(G=e.CompletionItem||(e.CompletionItem={}));var Q;(function(Ae){function Oe(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:N.fromStrict(ie.documentation)}}Ae.from=Oe;function Ee(ie){return{label:ie.label,documentation:D.isMarkdownString(ie.documentation)?N.to(ie.documentation):ie.documentation}}Ae.to=Ee})(Q=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Ae){function Oe(ie){return{label:ie.label,documentation:N.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(Q.from):[],activeParameter:ie.activeParameter}}Ae.from=Oe;function Ee(ie){return{label:ie.label,documentation:D.isMarkdownString(ie.documentation)?N.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(Q.to):[],activeParameter:ie.activeParameter}}Ae.to=Ee})(de=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(Ae){function Oe(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(de.from):[]}}Ae.from=Oe;function Ee(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(de.to):[]}}Ae.to=Ee})(be=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Ae){function Oe(Ee,ie){const Ne=new i.InlayHint(a.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(pe.to.bind(void 0,Ee)),ie.kind&&Ce.to(ie.kind));return Ne.textEdits=ie.textEdits&&ie.textEdits.map(V.to),Ne.tooltip=D.isMarkdownString(ie.tooltip)?N.to(ie.tooltip):ie.tooltip,Ne.paddingLeft=ie.paddingLeft,Ne.paddingRight=ie.paddingRight,Ne}Ae.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var pe;(function(Ae){function Oe(Ee,ie){const Ne=new i.InlayHintLabelPart(ie.label);return Ne.tooltip=D.isMarkdownString(ie.tooltip)?N.to(ie.tooltip):ie.tooltip,d.Command.is(ie.command)&&(Ne.command=Ee.fromInternal(ie.command)),ie.location&&(Ne.location=De.to(ie.location)),Ne}Ae.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Ae){function Oe(ie){return ie}Ae.from=Oe;function Ee(ie){return ie}Ae.to=Ee})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Ae){function Oe(ie){return{range:u.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Ae.from=Oe;function Ee(ie){let Ne;if(ie.url)try{Ne=typeof ie.url=="string"?C.URI.parse(ie.url,!0):C.URI.revive(ie.url)}catch{}return new i.DocumentLink(u.to(ie.range),Ne)}Ae.to=Ee})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Ae){function Oe(ie){const Ne=new i.ColorPresentation(ie.label);return ie.textEdit&&(Ne.textEdit=V.to(ie.textEdit)),ie.additionalTextEdits&&(Ne.additionalTextEdits=ie.additionalTextEdits.map($e=>V.to($e))),Ne}Ae.to=Oe;function Ee(ie){return{label:ie.label,textEdit:ie.textEdit?V.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Ne=>V.from(Ne)):void 0}}Ae.from=Ee})(je=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Ae){function Oe(ie){return new i.Color(ie[0],ie[1],ie[2],ie[3])}Ae.to=Oe;function Ee(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Ae.from=Ee})(Ge=e.Color||(e.Color={}));var et;(function(Ae){function Oe(ie){return{range:u.from(ie.range)}}Ae.from=Oe;function Ee(ie){return new i.SelectionRange(u.to(ie.range))}Ae.to=Ee})(et=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Ae){function Oe(Ee){switch(Ee){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Ae){function Oe(ie){switch(ie){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Ee(ie){switch(ie){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}Ae.to=Ee})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Ae){function Oe(ie){if(ie===i.EndOfLine.CRLF)return 1;if(ie===i.EndOfLine.LF)return 0}Ae.from=Oe;function Ee(ie){if(ie===1)return i.EndOfLine.CRLF;if(ie===0)return i.EndOfLine.LF}Ae.to=Ee})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Ae){function Oe(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(Ae){function Oe(Ee){const ie={start:Ee.start+1,end:Ee.end+1};return Ee.kind&&(ie.kind=it.from(Ee.kind)),ie}Ae.from=Oe})(Me=e.FoldingRange||(e.FoldingRange={}));var it;(function(Ae){function Oe(Ee){if(Ee)switch(Ee){case i.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case i.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case i.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Ae.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var oe;(function(Ae){function Oe(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?u.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?w.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var W;(function(Ae){function Oe($e){return $e instanceof i.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Ee($e)||ie($e)?new i.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Ae.from=Oe;function Ee($e){const Qe=$e;return Qe?C.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function ie($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ne($e){return typeof $e=="string"?$e:new i.RelativePattern(C.URI.revive($e.baseUri),$e.pattern)}Ae.to=Ne})(W=e.GlobPattern||(e.GlobPattern={}));var ce;(function(Ae){function Oe(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Oe);if(typeof Ee=="string")return Ee;{const ie=Ee;return{language:ie.language,scheme:ie.scheme,pattern:W.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Ae.from=Oe})(ce=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Ae){function Oe(ie){return{start:ie.start,end:ie.end}}Ae.from=Oe;function Ee(ie){return new i.NotebookRange(ie.start,ie.end)}Ae.to=Ee})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Ae){function Oe(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Ae.to=Oe;function Ee(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Ae.from=Ee})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Ae){function Oe(Ee){if(Ee===f.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(Ee===f.NotebookCellExecutionState.Pending)return;if(Ee===f.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Ae.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(Ae){function Oe(ie){switch(ie){case i.NotebookCellKind.Markup:return f.CellKind.Markup;case i.NotebookCellKind.Code:default:return f.CellKind.Code}}Ae.from=Oe;function Ee(ie){switch(ie){case f.CellKind.Markup:return i.NotebookCellKind.Markup;case f.CellKind.Code:default:return i.NotebookCellKind.Code}}Ae.to=Ee})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Ae){function Oe(ie){const Ne={metadata:ie.metadata??Object.create(null),cells:[]};for(const $e of ie.cells)i.NotebookCellData.validate($e),Ne.cells.push(mt.from($e));return Ne}Ae.from=Oe;function Ee(ie){const Ne=new i.NotebookData(ie.cells.map(mt.to));return(0,E.isEmptyObject)(ie.metadata)||(Ne.metadata=ie.metadata),Ne}Ae.to=Ee})(Ze=e.NotebookData||(e.NotebookData={}));var mt;(function(Ae){function Oe(ie){return{cellKind:Xe.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Le.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(lt.from):[]}}Ae.from=Oe;function Ee(ie){return new i.NotebookCellData(Xe.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(lt.to):void 0,ie.metadata,ie.internalMetadata?Le.to(ie.internalMetadata):void 0)}Ae.to=Ee})(mt=e.NotebookCellData||(e.NotebookCellData={}));var ft;(function(Ae){function Oe(ie){return{mime:ie.mime,valueBytes:t.VSBuffer.wrap(ie.data)}}Ae.from=Oe;function Ee(ie){return new i.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}Ae.to=Ee})(ft=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Ae){function Oe(ie){return{outputId:ie.id,items:ie.items.map(ft.from),metadata:ie.metadata}}Ae.from=Oe;function Ee(ie){const Ne=ie.items.map(ft.to);return new i.NotebookCellOutput(Ne,ie.outputId,ie.metadata)}Ae.to=Ee})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Ae){function Oe(Ne){return ie(Ne)?{include:(0,E.withNullAsUndefined)(W.from(Ne.include)),exclude:(0,E.withNullAsUndefined)(W.from(Ne.exclude))}:(0,E.withNullAsUndefined)(W.from(Ne))}Ae.from=Oe;function Ee(Ne){return ie(Ne)?{include:W.to(Ne.include),exclude:W.to(Ne.exclude)}:W.to(Ne)}Ae.to=Ee;function ie(Ne){const $e=Ne;return $e?!(0,E.isUndefinedOrNull)($e.include)&&!(0,E.isUndefinedOrNull)($e.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Ae){function Oe(Ee,ie,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal($e,Ne),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Ae.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var At;(function(Ae){function Oe(Ee,ie,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:ie.toInternal($e,Ne),label:Ee.label,description:Ee.description,detail:Ee.detail}}Ae.from=Oe})(At=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Rt;(function(Ae){function Oe(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Ae.from=Oe})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(Ae){function Oe(ie){return{uri:ie.uri,provides:ie.provides}}Ae.from=Oe;function Ee(ie){return new i.NotebookRendererScript(C.URI.revive(ie.uri),ie.provides)}Ae.to=Ee})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Ae){function Oe(ie){return{message:N.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,location:ie.location&&{range:u.from(ie.location.range),uri:ie.location.uri}}}Ae.from=Oe;function Ee(ie){const Ne=new i.TestMessage(typeof ie.message=="string"?ie.message:N.to(ie.message));return Ne.actualOutput=ie.actual,Ne.expectedOutput=ie.expected,Ne.location=ie.location?De.to(ie.location):void 0,Ne}Ae.to=Ee})(pt=e.TestMessage||(e.TestMessage={}));var kt;(function(Ae){Ae.namespace=b.namespaceTestTag,Ae.denamespace=b.denamespaceTestTag})(kt=e.TestTag||(e.TestTag={}));var Bt;(function(Ae){function Oe(ie){const Ne=(0,m.getPrivateApiFor)(ie).controllerId;return{extId:h.TestId.fromExtHostTestItem(ie,Ne).toString(),label:ie.label,uri:C.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map($e=>kt.namespace(Ne,$e.id)),range:v.Range.lift(u.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&N.fromStrict(ie.error)||null}}Ae.from=Oe;function Ee(ie){return{parent:void 0,error:void 0,id:h.TestId.fromString(ie.extId).localId,label:ie.label,uri:C.URI.revive(ie.uri),tags:(ie.tags||[]).map(Ne=>{const{tagId:$e}=kt.denamespace(Ne);return new i.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Ae.toPlain=Ee})(Bt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(ie){return{id:ie.id}}Ae.from=Oe;function Ee(ie){return new i.TestTag(ie.id)}Ae.to=Ee}(kt=e.TestTag||(e.TestTag={}));var Mt;(function(Ae){const Oe=(ie,Ne)=>{const $e=[];for(const[Ve,tt]of Ne)h.TestId.compare(tt.item.extId,Ve)===2&&(Ne.delete(Ve),$e.push(tt));const Qe={...Bt.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(pt.to)})),children:$e.map(Ve=>Oe(Ve,Ne))};for(const Ve of Qe.children)Ve.parent=Qe;return Qe};function Ee(ie){const Ne=[],$e=new Map;for(const Qe of ie.items){$e.set(Qe.item.extId,Qe);const Ve=h.TestId.root(Qe.item.extId);ie.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(Qe.item.extId))&&Ne.push(Qe)}return{completedAt:ie.completedAt,results:Ne.map(Qe=>Oe(Qe,$e))}}Ae.to=Ee})(Mt=e.TestResults||(e.TestResults={}));var xe;(function(Ae){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Ee($e){return"line"in $e?a.from($e):u.from($e)}function ie($e){return"branches"in $e?{count:$e.executionCount,location:Ee($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Ee(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:Ee($e.location)}}Ae.fromDetailed=ie;function Ne($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(ie)}}Ae.fromFile=Ne})(xe=e.TestCoverage||(e.TestCoverage={}));var Ot;(function(Ae){function Oe(Ee){switch(Ee){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ut;(function(Ae){function Oe(ie){const Ne=new i.TypeHierarchyItem(Y.to(ie.kind),ie.name,ie.detail||"",C.URI.revive(ie.uri),u.to(ie.range),u.to(ie.selectionRange));return Ne._sessionId=ie._sessionId,Ne._itemId=ie._itemId,Ne}Ae.to=Oe;function Ee(ie,Ne,$e){if(Ne=Ne??ie._sessionId,$e=$e??ie._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,kind:Y.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),tags:ie.tags?.map(J.from)}}Ae.from=Ee})(Ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ht;(function(Ae){function Oe(Ee){if(!!Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Ae.from=Oe})(Ht=e.ViewBadge||(e.ViewBadge={}));var bt;(function(Ae){function Oe($e,Qe,Ve){const tt=Qe.fileData;return tt?new class extends i.DataTransferItem{asFile(){return{name:tt.name,uri:C.URI.revive(tt.uri),data:(0,A.once)(()=>Ve())}}}("",Qe.id):$e===R.Mimes.uriList&&Qe.uriListData?new i.DataTransferItem(Ne(Qe.uriListData)):new i.DataTransferItem(Qe.asString)}Ae.to=Oe;async function Ee($e,Qe){const Ve=await Qe.asString();if($e===R.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:ie(Ve)};const tt=Qe.asFile();return{id:Qe.id,asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Ae.from=Ee;function ie($e){return k.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return C.URI.parse(Qe)}catch{}return Qe})}function Ne($e){return k.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:C.URI.revive(Qe)))}})(bt=e.DataTransferItem||(e.DataTransferItem={}));var Lt;(function(Ae){function Oe(ie,Ne){const $e=ie.items.map(([Qe,Ve])=>[Qe,bt.to(Qe,Ve,()=>Ne(Ve.id))]);return new i.DataTransfer($e)}Ae.toDataTransfer=Oe;async function Ee(ie){const Ne={items:[]},$e=[];return ie.forEach((Qe,Ve)=>{$e.push((async()=>{Ne.items.push([Ve,await bt.from(Ve,Qe)])})())}),await Promise.all($e),Ne}Ae.toDataTransferDTO=Ee})(Lt=e.DataTransfer||(e.DataTransfer={}))}),define(Se[232],ye([1,0,2,10,7,14,63]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(y,R,P,E={timeout:1500,errors:3}){this.c=y,this.d=R,this.f=P,this.g=E,this.a=new D.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(R,P,E)=>{const v={dispose:this.a.push([R,P,y])};return Array.isArray(E)&&E.push(v),v}}async $participateInSave(y,R){const P=c.URI.revive(y);let E=!1;const C=setTimeout(()=>E=!0,this.g.timeout),v=[];try{for(const d of[...this.a]){if(E)break;const g=this.d.getDocument(P),m=await this.h(d,{document:g,reason:A.TextDocumentSaveReason.to(R)});v.push(m)}}finally{clearTimeout(C)}return v}h([y,R,P],E){const C=this.b.get(y);return typeof C=="number"&&C>this.g.errors?Promise.resolve(!1):this.i(P,y,R,E).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const d=this.b.get(y);this.b.set(y,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,R,P,E){const C=[],v=Date.now(),{document:d,reason:g}=E,{version:m}=d,w=Object.freeze({document:d,reason:g,waitUntil(f){if(Object.isFrozen(C))throw(0,t.illegalState)("waitUntil can not be called async");C.push(Promise.resolve(f))}});try{R.apply(P,[w])}catch(f){return Promise.reject(f)}return Object.freeze(C),new Promise((f,h)=>{const b=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(C).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(b),f(s)}).catch(s=>{clearTimeout(b),h(s)})}).then(f=>{const h={edits:[]};for(const b of f)if(Array.isArray(b)&&b.every(s=>s instanceof k.TextEdit))for(const{newText:s,newEol:i,range:l}of b)h.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:l&&A.Range.from(l),text:s,eol:i&&A.EndOfLine.from(i)}});if(h.edits.length!==0)return m===d.version?this.f.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(Se[233],ye([1,0,15,2,14,7,90]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(P,E,C,v){this.start=P,this.deletedCount=E,this.deletedItems=C,this.items=v}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(P,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,E,C){this.notebook=P,this.h=E,this.j=C,this.handle=C.handle,this.uri=t.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(k.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,E=this.h.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:E.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(C)}return this.f}setOutputs(P){this.a=P.map(k.NotebookCellOutput.to)}setOutputItems(P,E,C){const v=C.map(k.NotebookCellOutputItem.to),d=this.a.find(g=>g.id===P);if(d&&(E||(d.items.length=0),d.items.push(...v),d.items.length>1&&d.items.every(g=>D.isTextStreamMime(g.mime)))){const g=new Map,m=[];d.items.forEach(w=>{let f;g.has(w.mime)?f=g.get(w.mime):(f=[],g.set(w.mime,f),m.push(w.mime)),f.push(w.data)}),d.items.length=0,m.forEach(w=>{const f=D.compressOutputItemStreams(g.get(w));d.items.push({mime:w,data:f.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=S;class y{constructor(P,E,C,v,d){this.k=P,this.l=E,this.m=C,this.uri=v,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,E={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===c.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(C){return C=P.n(C),P.b[C].apiCell},getCells(C){return(C?P.p(C):P.b).map(d=>d.apiCell)},save(){return P.q()}};this.e=Object.freeze(E)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,E,C){this.g=P.versionId,this.h=E,this.acceptDocumentPropertiesChanged({metadata:C});const v={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},d=[];for(const m of P.rawEvents)m.kind===D.NotebookCellsChangeType.ModelChange?this.r(m.changes,!1,v.contentChanges):m.kind===D.NotebookCellsChangeType.Move?this.s(m.index,m.length,m.newIdx,v.contentChanges):m.kind===D.NotebookCellsChangeType.Output?(this.t(m.index,m.outputs),d.push({cell:this.b[m.index].apiCell,outputs:this.b[m.index].apiCell.outputs})):m.kind===D.NotebookCellsChangeType.OutputItem?(this.u(m.index,m.outputId,m.append,m.outputItems),d.push({cell:this.b[m.index].apiCell,outputs:this.b[m.index].apiCell.outputs})):m.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this.v(m.index,m.language),d.push({cell:this.b[m.index].apiCell,document:this.b[m.index].apiCell.document})):m.kind===D.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[m.index].apiCell,document:this.b[m.index].apiCell.document}):m.kind===D.NotebookCellsChangeType.ChangeCellMime?this.w(m.index,m.mime):m.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this.x(m.index,m.metadata),d.push({cell:this.b[m.index].apiCell,metadata:this.b[m.index].apiCell.metadata})):m.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(m.index,m.internalMetadata),d.push({cell:this.b[m.index].apiCell,executionSummary:this.b[m.index].apiCell.executionSummary}));const g=new Map;for(let m=0;m<d.length;m++){const w=d[m],f=g.get(w.cell);if(f===void 0){const h=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...w});g.set(w.cell,h-1)}else v.cellChanges[f]={...v.cellChanges[f],...w}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let E=P.start|0,C=P.end|0;return E<0&&(E=0),C>this.b.length&&(C=this.b.length),P.with({start:E,end:C})}p(P){P=this.o(P);const E=[];for(let C=P.start;C<P.end;C++)E.push(this.b[C]);return E}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,E,C){if(this.j)return;const v=[],d=[],g=[];if(P.reverse().forEach(m=>{const f=m[2].map(s=>{const i=new S(this,this.l,s);return E||d.push(S.asModelAddData(this.apiNotebook,s)),i}),h=new T(m[0],m[1],[],f),b=this.b.splice(m[0],m[1],...f);for(const s of b)g.push(s.uri),h.deletedItems.push(s.apiCell);v.push(h)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:g}),C)for(const m of v)C.push(m.asApiEvent())}s(P,E,C,v){const d=this.b.splice(P,E);this.b.splice(C,0,...d);const g=[new T(P,E,d.map(m=>m.apiCell),[]),new T(C,0,[],d)];for(const m of g)v.push(m.asApiEvent())}t(P,E){this.b[P].setOutputs(E)}u(P,E,C,v){this.b[P].setOutputItems(E,C,v)}v(P,E){const C=this.b[P];C.apiCell.document.languageId!==E&&this.m.$acceptModelLanguageChanged(C.uri,E)}w(P,E){const C=this.b[P];C.apiCell.mime=E}x(P,E){this.b[P].setMetadata(E)}y(P,E){this.b[P].setInternalMetadata(E)}getCellFromApiCell(P){return this.b.find(E=>E.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(E=>E.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=y,y.a=0}),define(Se[135],ye([1,0,10,14,7]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(T,S,y,R,P,E){this.id=T,this.f=S,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=R,this.c=E}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(S){this.selections=[S]},get selections(){return T.a},set selections(S){if(!Array.isArray(S)||!S.every(k.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");T.a=S,T.g(S)},get visibleRanges(){return T.b},revealRange(S,y){T.f.$tryRevealRange(T.id,t.NotebookRange.from(S),y??k.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(t.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(Se[234],ye([1,0,4,13,14]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(T,S){this.c=T,this.d=S,this.a=new c.Emitter,this.b=new c.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const y=this.d.getEditorById(T);S.visibleRanges&&y._acceptVisibleRanges(S.visibleRanges.ranges.map(k.NotebookRange.to)),S.selections&&y._acceptSelections(S.selections.selections.map(k.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this.d.getEditorById(S)._acceptViewColumn(k.ViewColumn.to(T[S]))}};A=qe([We(0,t.ILogService)],A),e.ExtHostNotebookEditors=A}),define(Se[235],ye([1,0,14,124,174,21,60,10]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,C,v){const d=this.b++,{title:g,location:m,cancellable:w}=C,f={label:(0,k.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this.a.$startProgress(d,{location:c.ProgressLocation.from(m),title:g,source:f,cancellable:w},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.onUnexpectedExternalError),this.d(d,v,!!w)}d(E,C,v){let d;v&&(d=new A.CancellationTokenSource,this.c.set(E,d));const g=w=>{this.a.$progressEnd(w),this.c.delete(w),d?.dispose()};let m;try{m=C(new R(this.a,E),v&&d?d.token:A.CancellationToken.None)}catch(w){throw g(E),w}return m.then(w=>g(E),w=>g(E)),m}$acceptProgressCanceled(E){const C=this.c.get(E);C&&(C.cancel(),this.c.delete(E))}}e.ExtHostProgress=S;function y(P,E){return P.message=E.message,typeof E.increment=="number"&&(typeof P.increment=="number"?P.increment+=E.increment:P.increment=E.increment),P}class R extends t.Progress{constructor(E,C){super(v=>this.throttledReport(v)),this.c=E,this.d=C}throttledReport(E){this.c.$progressReport(this.d,E)}}qe([(0,D.throttle)(100,(P,E)=>y(P,E),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Se[136],ye([1,0,35,132,56,91,69,14,2]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(f,h,b,s)=>{let i=h;return{enumerable:!0,configurable:!1,get(){return i},set(l){if(!b(i,l)){const u=i;i=l,f.listener?.(s(l,u))}}}},R=(f,h)=>f===h,P={range:(f,h)=>f===h?!0:!f||!h?!1:f.isEqual(h),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(f,h)=>!(f.length!==h.length||f.some(b=>!h.find(s=>b.id===s.id)))},E=f=>h=>({op:4,update:f(h)}),C=(f,h)=>({range:(()=>{let b;const s=E(i=>({range:c.Range.lift(T.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return b},set(i){f.listener?.({op:6}),P.range(b,i)||(b=i,f.listener?.(s(i)))}}})(),label:y(f,h,P.label,E(b=>({label:b}))),description:y(f,void 0,P.description,E(b=>({description:b}))),sortText:y(f,void 0,P.sortText,E(b=>({sortText:b}))),canResolveChildren:y(f,!1,P.canResolveChildren,b=>({op:2,state:b})),busy:y(f,!1,P.busy,E(b=>({busy:b}))),error:y(f,void 0,P.error,E(b=>({error:T.MarkdownString.fromStrict(b)||null}))),tags:y(f,[],P.tags,(b,s)=>({op:1,new:b.map(T.TestTag.from),old:s.map(T.TestTag.from)}))}),v=f=>{const h=k.TestId.fromString(f.extId),b=new g(h.controllerId,h.localId,f.label,S.URI.revive(f.uri)||void 0);return b.range=T.Range.to(f.range||void 0),b.description=f.description||void 0,b.sortText=f.sortText||void 0,b.tags=f.tags.map(s=>T.TestTag.to({id:(0,D.denamespaceTestTag)(s).tagId})),b},d=f=>{let h;for(const b of f.tests){const s=v(b.item);(0,t.getPrivateApiFor)(s).parent=h,h=s}return h};e.toItemFromContext=d;class g{constructor(h,b,s,i){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const l=(0,t.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof m?void 0:l.parent}},children:{value:(0,A.createTestItemChildren)(l,t.getPrivateApiFor,g),enumerable:!0,writable:!1},...C(l,s)})}}e.TestItemImpl=g;class m extends g{constructor(h,b){super(h,h,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=m;class w extends A.TestItemCollection{constructor(h,b,s){super({controllerId:h,getDocumentVersion:i=>i&&s.getDocument(i)?.version,getApiFor:t.getPrivateApiFor,getChildren:i=>i.children,root:new m(h,b),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=w}),define(Se[137],ye([1,0,49,10,99,14,7]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class T{constructor(E,C,v){const d=T.c.nextId();E.$registerTextEditorDecorationType(C.identifier,d,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){E.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=T,T.c=new k.IdGenerator("TextEditorDecorationType");class S{constructor(E,C){this.g=[],this.h=void 0,this.j=!1,this.c=E,this.d=E.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(E,C){this.k();let v=null;if(E instanceof D.Position)v=new D.Range(E,E);else if(E instanceof D.Range)v=E;else throw new Error("Unrecognized location");this.l(v,C,!1)}insert(E,C){this.k(),this.l(new D.Range(E,E),C,!0)}delete(E){this.k();let C=null;if(E instanceof D.Range)C=E;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(E,C,v){const d=this.c.validateRange(E);this.g.push({range:d,text:C,forceMoveMarkers:v})}setEndOfLine(E){if(this.k(),E!==D.EndOfLine.LF&&E!==D.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=E}}class y{constructor(E,C,v,d){this.c=E,this.d=C,this._accept(v),this.e=d;const g=this;this.value={get tabSize(){return g.f},set tabSize(m){g.m(m)},get indentSize(){return g.g},set indentSize(m){g.o(m)},get insertSpaces(){return g.h},set insertSpaces(m){g.q(m)},get cursorStyle(){return g.j},set cursorStyle(m){g.s(m)},get lineNumbers(){return g.k},set lineNumbers(m){g.t(m)}}}_accept(E){this.f=E.tabSize,this.g=E.indentSize,this.h=E.insertSpaces,this.j=E.cursorStyle,this.k=A.TextEditorLineNumbersStyle.to(E.lineNumbers)}l(E){if(E==="auto")return"auto";if(typeof E=="number"){const C=Math.floor(E);return C>0?C:null}if(typeof E=="string"){const C=parseInt(E,10);return isNaN(C)?null:C>0?C:null}return null}m(E){const C=this.l(E);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}n(E){if(E==="tabSize")return"tabSize";if(typeof E=="number"){const C=Math.floor(E);return C>0?C:null}if(typeof E=="string"){const C=parseInt(E,10);return isNaN(C)?null:C>0?C:null}return null}o(E){const C=this.n(E);if(C!==null){if(typeof C=="number"){if(this.g===C)return;this.g=C}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}p(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}q(E){const C=this.p(E);if(typeof C=="boolean"){if(this.h===C)return;this.h=C}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}s(E){this.j!==E&&(this.j=E,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:E})))}t(E){this.k!==E&&(this.k=E,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(E)})))}assign(E){const C={};let v=!1;if(typeof E.tabSize<"u"){const d=this.l(E.tabSize);d==="auto"?(v=!0,C.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,v=!0,C.tabSize=d)}if(typeof E.indentSize<"u"){const d=this.n(E.indentSize);d==="tabSize"?(v=!0,C.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,v=!0,C.indentSize=d)}if(typeof E.insertSpaces<"u"){const d=this.p(E.insertSpaces);d==="auto"?(v=!0,C.insertSpaces=d):this.h!==d&&(this.h=d,v=!0,C.insertSpaces=d)}typeof E.cursorStyle<"u"&&this.j!==E.cursorStyle&&(this.j=E.cursorStyle,v=!0,C.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this.k!==E.lineNumbers&&(this.k=E.lineNumbers,v=!0,C.lineNumbers=A.TextEditorLineNumbersStyle.from(E.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,C))}u(E,C){C.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this.e.warn(v)})}}e.ExtHostTextEditorOptions=y;class R{constructor(E,C,v,d,g,m,w,f){this.id=E,this.j=C,this.k=v,this.g=!1,this.h=new Set,this.c=g,this.d=new y(this.j,this.id,m,v),this.e=w,this.f=f;const h=this;this.value=Object.freeze({get document(){return d.getValue()},set document(b){throw(0,t.readonly)("document")},get selection(){return h.c&&h.c[0]},set selection(b){if(!(b instanceof D.Selection))throw(0,t.illegalArgument)("selection");h.c=[b],h.l()},get selections(){return h.c},set selections(b){if(!Array.isArray(b)||b.some(s=>!(s instanceof D.Selection)))throw(0,t.illegalArgument)("selections");h.c=b,h.l()},get visibleRanges(){return h.e},set visibleRanges(b){throw(0,t.readonly)("visibleRanges")},get options(){return h.d.value},set options(b){h.g||h.d.assign(b)},get viewColumn(){return h.f},set viewColumn(b){throw(0,t.readonly)("viewColumn")},edit(b,s={undoStopBefore:!0,undoStopAfter:!0}){if(h.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new S(d.getValue(),s);return b(i),h.m(i)},insertSnippet(b,s,i={undoStopBefore:!0,undoStopAfter:!0}){if(h.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!s||Array.isArray(s)&&s.length===0)l=h.c.map(u=>A.Range.from(u));else if(s instanceof D.Position){const{lineNumber:u,column:r}=A.Position.from(s);l=[{startLineNumber:u,startColumn:r,endLineNumber:u,endColumn:r}]}else if(s instanceof D.Range)l=[A.Range.from(s)];else{l=[];for(const u of s)if(u instanceof D.Range)l.push(A.Range.from(u));else{const{lineNumber:r,column:a}=A.Position.from(u);l.push({startLineNumber:r,startColumn:a,endLineNumber:r,endColumn:a})}}return C.$tryInsertSnippet(E,d.getValue().version,b.value,l,i)},setDecorations(b,s){const i=s.length===0;i&&!h.h.has(b.key)||(i?h.h.delete(b.key):h.h.add(b.key),h.n(()=>{if(A.isDecorationOptionsArr(s))return C.$trySetDecorations(E,b.key,A.fromRangeOrRangeWithMessage(s));{const l=new Array(4*s.length);for(let u=0,r=s.length;u<r;u++){const a=s[u];l[4*u]=a.start.line+1,l[4*u+1]=a.start.character+1,l[4*u+2]=a.end.line+1,l[4*u+3]=a.end.character+1}return C.$trySetDecorationsFast(E,b.key,l)}}))},revealRange(b,s){h.n(()=>C.$tryRevealRange(E,A.Range.from(b),s||D.TextEditorRevealType.Default))},show(b){C.$tryShowEditor(E,A.ViewColumn.from(b))},hide(){C.$tryHideEditor(E)}})}dispose(){(0,c.ok)(!this.g),this.g=!0}_acceptOptions(E){(0,c.ok)(!this.g),this.d._accept(E)}_acceptVisibleRanges(E){(0,c.ok)(!this.g),this.e=E}_acceptViewColumn(E){(0,c.ok)(!this.g),this.f=E}_acceptSelections(E){(0,c.ok)(!this.g),this.c=E}async l(){const E=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,E)),this.value}m(E){const C=E.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const v=C.edits.map(g=>g.range);v.sort((g,m)=>g.end.line===m.end.line?g.end.character===m.end.character?g.start.line===m.start.line?g.start.character-m.start.character:g.start.line-m.start.line:g.end.character-m.end.character:g.end.line-m.end.line);for(let g=0,m=v.length-1;g<m;g++){const w=v[g].end;if(v[g+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=C.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,d,{setEndOfLine:typeof C.setEndOfLine=="number"?A.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(E){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.ExtHostTextEditor=R}),define(Se[236],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[237],ye([1,0,188,10,42,121,125,43,27,236,200,190]),function(ne,e,c,t,k,A,D,T,S,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=T.Registry.as(D.Extensions.JSONContribution);class C{constructor(b,s,i){this.a=b,this.b=s,this.c=i}d(b,s){this.a({type:b,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(k.default.Error,b)}warn(b){this.d(k.default.Warning,b)}info(b){this.d(k.default.Info,b)}}e.ExtensionMessageCollector=C;class v{static a(b){const s=new Set;for(let i=0,l=b.length;i<l;i++)s.add(S.ExtensionIdentifier.toKey(b[i].description.identifier));return s}static compute(b,s){if(!b||!b.length)return new v(s,[]);if(!s||!s.length)return new v([],b);const i=this.a(b),l=this.a(s),u=s.filter(a=>!i.has(S.ExtensionIdentifier.toKey(a.description.identifier))),r=b.filter(a=>!l.has(S.ExtensionIdentifier.toKey(a.description.identifier)));return new v(u,r)}constructor(b,s){this.added=b,this.removed=s}}e.ExtensionPointUserDelta=v;class d{constructor(b,s){this.name=b,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=v.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,t.onUnexpectedError)(b)}}}e.ExtensionPoint=d;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},m="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},activationEvents:{description:c.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(30,null)},{label:"onUri",body:"onUri",description:c.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(35,null)},{label:"onRenderer",description:c.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(37,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(39,null)},{label:"*",description:c.localize(40,null),body:"*"}]}},badges:{type:"array",description:c.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(42,null)},href:{type:"string",description:c.localize(43,null)},description:{type:"string",description:c.localize(44,null)}}}},markdown:{type:"string",description:c.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(49,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(50,null)},{body:["workspace"],description:c.localize(51,null)},{body:["ui","workspace"],description:c.localize(52,null)},{body:["workspace","ui"],description:c.localize(53,null)},{body:[],description:c.localize(54,null)}]},capabilities:{description:c.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(58,null),c.localize(59,null),c.localize(60,null)]},description:{type:"string",markdownDescription:c.localize(61,null)}}},untrustedWorkspaces:{description:c.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(64,null),c.localize(65,null),c.localize(66,null)]},restrictedConfigurations:{description:c.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(68,null)}}}}},sponsor:{description:c.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(71,null),type:"string"},"vscode:uninstall":{description:c.localize(72,null),type:"string"}}},icon:{type:"string",description:c.localize(73,null)},l10n:{type:"string",description:c.localize(74,null)}}};class w{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const s=new d(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,s),b.activationEventsGenerator&&P.ImplicitActivationEvents.register(b.extensionPoint,b.activationEventsGenerator),e.schema.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,E.registerSchema(m,e.schema),s}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=w;const f={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(f.ExtensionsRegistry,new w),e.ExtensionsRegistry=T.Registry.as(f.ExtensionsRegistry),E.registerSchema(m,e.schema),E.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Se[238],ye([1,0,185,11,23,237,53,4]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var y;(function(E){function C(v,d,g){if(!v)return;const m=t.isString(v.type)?v.type:void 0;if(!m||m.length===0){g.error(c.localize(3,null));return}const w=[];if(Array.isArray(v.required))for(const f of v.required)t.isString(f)&&w.push(f);return{extensionId:d.value,taskType:m,required:w,properties:v.properties?k.deepClone(v.properties):{},when:v.when?D.ContextKeyExpr.deserialize(v.when):void 0}}E.from=C})(y||(y={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:S}});class P{constructor(){this.d=new T.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,v)=>{R.setHandler((d,g)=>{this.c=void 0;try{for(const m of g.removed){const w=m.value;for(const f of w)this.a&&f.type&&this.a[f.type]&&delete this.a[f.type]}for(const m of g.added){const w=m.value;for(const f of w){const h=y.from(f,m.description.identifier,m.collector);h&&(this.a[h.taskType]=h)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const v of this.all()){const d={type:"object",additionalProperties:!1};v.required.length>0&&(d.required=v.required.slice(0)),v.properties!==void 0?d.properties=k.deepClone(v.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[v.taskType]},C.push(d)}this.c={oneOf:C}}return this.c}}e.TaskDefinitionRegistry=new P}),define(Se[239],ye([1,0,186,11,24,23,53,238]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function B(U){if(!U)return F.Strong;switch(U.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=B}(S=e.ShellQuoting||(e.ShellQuoting={}));var y;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(y=e.CommandOptions||(e.CommandOptions={}));var R;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(F){function B(U){switch(U.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=B}(R=e.RevealKind||(e.RevealKind={}));var P;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function B(U){switch(U.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=B}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(F){function B(U){switch(U.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=B}(E=e.PanelKind||(e.PanelKind={}));var C;(function(F){F.defaults={echo:!0,reveal:R.Always,revealProblems:P.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(C=e.PresentationOptions||(e.PresentationOptions={}));var v;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(v=e.RuntimeType||(e.RuntimeType={})),function(F){function B(H){switch(H.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=B;function U(H){switch(H){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=U}(v=e.RuntimeType||(e.RuntimeType={}));var d;(function(F){function B(U){return t.isString(U)?U:U.value}F.value=B})(d=e.CommandString||(e.CommandString={}));var g;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function B(H){return H===F.Clean._id||H===F.Build._id||H===F.Rebuild._id||H===F.Test._id}F.is=B;function U(H){if(H!==void 0)return t.isString(H)?B(H)?{_id:H,isDefault:!1}:void 0:H}F.from=U})(g=e.TaskGroup||(e.TaskGroup={}));var m;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(m=e.TaskScope||(e.TaskScope={}));var w;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function B(U){switch(U){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=B})(w=e.TaskSourceKind||(e.TaskSourceKind={}));var f;(function(F){F.parallel="parallel",F.sequence="sequence"})(f=e.DependsOrder||(e.DependsOrder={}));var h;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(h=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:h.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class s{constructor(B,U,H,X,V,x){this._label="",this._id=B,U&&(this._label=U),H&&(this.type=H),this.runOptions=X,this.configurationProperties=V,this._source=x}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,U=!1){if(B===void 0)return!1;if(t.isString(B))return B===this._label||B===this.configurationProperties.identifier||U&&B===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=s;class i extends s{constructor(B,U,H,X,V,x,Y,J){super(B,H,void 0,Y,J,U),this.command={},this._source=U,this.hasDefinedMatchers=x,V&&(this.command=V)}clone(){return new i(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case v.Shell:U="shell";break;case v.Process:U="process";break;case v.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(B){return B instanceof i}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let U=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(U+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:U};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new i(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=i;class l extends s{constructor(B,U,H,X,V,x,Y){super(B,H,X,x,Y,U),this._source=U,this.configures=V}static is(B){return B instanceof l}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let U=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(U+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:U};return JSON.stringify(H)}}e.ConfiguringTask=l;class u extends s{constructor(B,U,H,X,V,x,Y,J,te){super(B,H,X,J,te,U),this.defines=V,this.hasDefinedMatchers=Y,this.command=x,this.icon=te.icon,this.hide=te.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof u}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new u(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=u;class r extends s{constructor(B,U,H,X,V,x){super(B,H,X,V,x,U),this._source=U}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new r(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=r;var a;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(a=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(a=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class o{constructor(B){this.c=new Map;for(let U=0;U<B.length;U++)this.c.set(B[U].uri.toString(),U)}compare(B,U){const H=B.getWorkspaceFolder(),X=U.getWorkspaceFolder();if(H&&X){let V=this.c.get(H.uri.toString());V=V===void 0?0:V+1;let x=this.c.get(X.uri.toString());return x=x===void 0?0:x+1,V===x?B._label.localeCompare(U._label):V-x}else return!H&&X?-1:H&&!X?1:0}}e.TaskSorter=o;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var I;(function(F){F.SingleRun="singleRun",F.Background="background"})(I=e.TaskRunType||(e.TaskRunType={}));var L;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var z;(function(F){function B(U,H,X,V){if(H){const x={kind:U,taskId:H._id,taskName:H.configurationProperties.name,runType:H.configurationProperties.isBackground?"background":"singleRun",group:H.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:X,__task:H};return U==="start"?x.resolvedVariables=V:U==="processStarted"?x.processId=V:U==="processEnded"&&(x.exitCode=V),Object.freeze(x)}else return Object.freeze({kind:"changed"})}F.create=B})(z=e.TaskEvent||(e.TaskEvent={}));var _;(function(F){function B(H){const X=Object.keys(H).sort();let V="";for(const x of X){let Y=H[x];Y instanceof Object?Y=B(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),V+=x+","+Y+","}return V}function U(H){const V={_key:B(H),type:H.taskType};return Object.assign(V,H),V}F.create=U})(_=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var q;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(q=e.TaskSettingId||(e.TaskSettingId={}));var N;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(N=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var M;(function(F){function B(U,H){const X=T.TaskDefinitionRegistry.get(U.type);if(X===void 0){const J=A.deepClone(U);return delete J._key,_.create(J)}const V=Object.create(null);V.type=X.taskType;const x=new Set;X.required.forEach(J=>x.add(J));const Y=X.properties;for(const J of Object.keys(Y)){const te=U[J];if(te!=null)V[J]=te;else if(x.has(J)){const le=Y[J];if(le.default!==void 0)V[J]=A.deepClone(le.default);else switch(le.type){case"boolean":V[J]=!1;break;case"number":case"integer":V[J]=0;break;case"string":V[J]="";break;default:H.error(c.localize(2,null,JSON.stringify(U,void 0,0),J));return}}}return _.create(V)}F.createTaskIdentifier=B})(M=e.TaskDefinition||(e.TaskDefinition={}))}),define(Se[240],ye([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((D,T)=>{this.b=D,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(D){this.f||this.h||(this.f=!0,this.g=D,this.a&&this.b(D))}resolveErr(D){this.f||this.h||(this.h=!0,this.i=D,this.a?this.d(D):(0,c.onUnexpectedError)(D))}then(D,T){return this.j().then(D,T)}catch(D){return this.j().then(void 0,D)}finally(D){return this.j().finally(D)}}e.LazyPromise=t;class k extends t{constructor(){super(),this.h=!0,this.i=new c.CancellationError}}e.CanceledLazyPromise=k}),define(Se[57],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const t=[];function k(T){const S=new c(T);return t[S.nid]=S,S}e.createProxyIdentifier=k;function A(T){return t[T].sid}e.getStringIdentifierForProxy=A;class D{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=D}),define(Se[5],ye([1,0,57]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A=e.TabModelOperationKind||(e.TabModelOperationKind={}));var D;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var y;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(y=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(g){return g._id=P.a++,g}}e.IdObject=P,P.a=0;var E;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var C;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(C=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(Se[70],ye([1,0,3,13,5,16]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(S,y){this.c=y,this.a=new Set,this.b=S.getProxy(k.MainContext.MainThreadTelemetry)}report(S,y,R){const P=this.d(S,y);this.a.has(P)||(this.a.add(P),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:S}))}d(S,y){return`${S}-${y.identifier.value}`}};D=qe([We(0,A.IExtHostRpcService),We(1,t.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,y){}})}),define(Se[241],ye([1,0,4,5,7,27]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(S){this.b=new Map,this.c=[],this.d=new c.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,y,R,P={}){const E=A.ExtensionIdentifier.toKey(S.identifier),C=this.f.get(E)||[],v=[...R].sort().join(" ");let d=C.find(g=>g.providerId===y&&g.scopes===v);if(d)return d.result;{const g=this.g(S,E,y,R,P);d={providerId:y,scopes:v,result:g},C.push(d),this.f.set(E,C);try{await g}finally{const m=C.findIndex(w=>w.providerId===y&&w.scopes===v);m>-1&&(C.splice(m),this.f.set(E,C))}return g}}async g(S,y,R,P,E={}){await this.a.$ensureProvider(R);const C=S.displayName||S.name;return this.a.$getSession(R,P,y,C,E)}async removeSession(S,y){const R=this.b.get(S);return R?R.provider.removeSession(y):this.a.$removeSession(S,y)}registerAuthenticationProvider(S,y,R,P){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:y,provider:R,options:P??{supportsMultipleAccounts:!1}}),this.c.find(C=>C.id===S)||this.c.push({id:S,label:y});const E=R.onDidChangeSessions(C=>{this.a.$sendDidChangeSessions(S,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this.a.$registerAuthenticationProvider(S,y,P?.supportsMultipleAccounts??!1),new k.Disposable(()=>{E.dispose(),this.b.delete(S);const C=this.c.findIndex(v=>v.id===S);C>-1&&this.c.splice(C),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,y){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.createSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,y){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,y){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,y){return this.d.fire({provider:{id:S,label:y}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(Se[242],ye([1,0,5,16,14]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(T,S){this.a=T.getProxy(c.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>S.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,y){const R=k.WorkspaceEdit.from(T,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,y?.isRefactoring??!1)}};A=qe([We(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(Se[243],ye([1,0,5]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const D=A.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(T){return D.$writeText(T)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[39],ye([1,0,11,7,14,23,5,17,13,85,35,50,2,6,3,16,136,22,57,51,44]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h){"use strict";var b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(o,p){b.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),Je(this,b,o.getProxy(D.MainContext.MainThreadCommands),"f"),this.d=p,Je(this,s,o.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,I=>{const L=this.c.get(I);return L?.result===r.Void?L:void 0},p),this.f=[{processArgument(I){return(0,y.revive)(I)}},{processArgument(I){return(0,A.cloneAndChange)(I,function(L){if(R.Range.isIRange(L))return k.Range.to(L);if(P.Position.isIPosition(L))return k.Position.to(L);if(R.Range.isIRange(L.range)&&E.URI.isUri(L.uri))return k.location.to(L);if(L instanceof m.VSBuffer)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(o){this.f.push(o)}registerApiCommand(o){const p=this.registerCommand(!1,o.id,async(...I)=>{const L=o.args.map((_,q)=>{if(!_.validate(I[q]))throw new Error(`Invalid argument '${_.name}' when running '${o.id}', received: ${I[q]}`);return _.convert(I[q])}),z=await this.executeCommand(o.internalId,...L);return o.result.convert(z,I,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this.c.set(o.id,o),new t.Disposable(()=>{p.dispose(),this.c.delete(o.id)})}registerCommand(o,p,I,L,z,_){if(this.d.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this.b.has(p))throw new Error(`command '${p}' already exists`);return this.b.set(p,{callback:I,thisArg:L,description:z,extension:_}),o&&Fe(this,b,"f").$registerCommand(p),new t.Disposable(()=>{this.b.delete(p)&&o&&Fe(this,b,"f").$unregisterCommand(p)})}executeCommand(o,...p){return this.d.trace("ExtHostCommands#executeCommand",o),this.g(o,p,!0)}async g(o,p,I){if(this.b.has(o))return Fe(this,b,"f").$fireCommandActivationEvent(o),this.h(o,p,!1);{let L=!1;const z=(0,A.cloneAndChange)(p,function(_){if(_ instanceof t.Position)return k.Position.from(_);if(_ instanceof t.Range)return k.Range.from(_);if(_ instanceof t.Location)return k.location.from(_);if(t.NotebookRange.isNotebookRange(_))return k.NotebookRange.from(_);if(_ instanceof ArrayBuffer)return L=!0,m.VSBuffer.wrap(new Uint8Array(_));if(_ instanceof Uint8Array)return L=!0,m.VSBuffer.wrap(_);if(_ instanceof m.VSBuffer)return L=!0,_;if(!Array.isArray(_))return _});try{const _=await Fe(this,b,"f").$executeCommand(o,L?new w.SerializableObjectWithBuffers(z):z,I);return(0,y.revive)(_)}catch(_){if(_ instanceof Error&&_.message==="$executeCommand:retry")return this.g(o,p,!1);throw _}}}async h(o,p,I){const L=this.b.get(o);if(!L)throw new Error("Unknown command");const{callback:z,thisArg:_,description:q}=L;if(q)for(let M=0;M<q.args.length;M++)try{(0,c.validateConstraint)(p[M],q.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${q.args[M].name}' - ${q.args[M].description}`)}const N=h.StopWatch.create();try{return await z.apply(_,p)}catch(M){if(o===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...p);F&&(o=F.command)}throw this.d.error(M,o,L.extension?.identifier),I?new class extends Error{constructor(){super((0,f.toErrorMessage)(M)),this.id=o,this.source=L.extension?.displayName??L.extension?.name}}:M}finally{this.j(L,o,N.elapsed())}}j(o,p,I){!o.extension||o.extension.isBuiltin||Fe(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:p,duration:I})}$executeContributedCommand(o,...p){return this.d.trace("ExtHostCommands#$executeContributedCommand",o),this.b.has(o)?(p=p.map(I=>this.f.reduce((L,z)=>z.processArgument(L),I)),this.h(o,p,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this.d.trace("ExtHostCommands#getCommands",o),Fe(this,b,"f").$getCommands().then(p=>(o&&(p=p.filter(I=>I[0]!=="_")),p))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[p,I]of this.b){const{description:L}=I;L&&(o[p]=L)}return Promise.resolve(o)}};b=new WeakMap,s=new WeakMap,i=qe([We(0,d.IExtHostRpcService),We(1,S.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class l{constructor(o,p,I){this.d=o,this.f=p,this.g=I,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(o,p){if(!o)return;const I={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return I;const L=this.f(o.command);if(L)I.id=L.internalId,I.arguments=L.args.map((z,_)=>z.convert(o.arguments&&o.arguments[_]));else if((0,T.isNonEmptyArray)(o.arguments)){const z=`${o.command}/${++this.c}`;this.b.set(z,o),p.add((0,C.toDisposable)(()=>{this.b.delete(z),this.g.trace("CommandsConverter#DISPOSE",z)})),I.$ident=z,I.id=this.delegatingCommandId,I.arguments=[z],this.g.trace("CommandsConverter#CREATE",o.command,z)}return I}fromInternal(o){return typeof o.$ident=="string"?this.b.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this.b.get(o[0])}h(...o){const p=this.getActualCommand(...o);return this.g.trace("CommandsConverter#EXECUTE",o[0],p?p.command:"MISSING"),p?this.d.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${o[0]}`)}}e.CommandsConverter=l;class u{constructor(o,p,I,L){this.name=o,this.description=p,this.validate=I,this.convert=L}optional(){return new u(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,p){return new u(o??this.name,p??this.description,this.validate,this.convert)}}e.ApiCommandArgument=u,u.Uri=new u("uri","Uri of a text document",n=>E.URI.isUri(n),n=>n),u.Position=new u("position","A position in a text document",n=>t.Position.isPosition(n),k.Position.from),u.Range=new u("range","A range in a text document",n=>t.Range.isRange(n),k.Range.from),u.Selection=new u("selection","A selection in a text document",n=>t.Selection.isSelection(n),k.Selection.from),u.Number=new u("number","",n=>typeof n=="number",n=>n),u.String=new u("string","",n=>typeof n=="string",n=>n),u.CallHierarchyItem=new u("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,k.CallHierarchyItem.from),u.TypeHierarchyItem=new u("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,k.TypeHierarchyItem.from),u.TestItem=new u("testItem","A VS Code TestItem",n=>n instanceof g.TestItemImpl,k.TestItem.from);class r{constructor(o,p){this.description=o,this.convert=p}}e.ApiCommandResult=r,r.Void=new r("no result",n=>n);class a{constructor(o,p,I,L,z){this.id=o,this.internalId=p,this.description=I,this.args=L,this.result=z}}e.ApiCommand=a}),define(Se[244],ye([1,0,2,14,7,66,39,17,118,123,15]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(t.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,g)=>{if((0,T.isFalsyOrEmpty)(d))return;class m extends k.SymbolInformation{static to(f){const h=new m(f.name,t.SymbolKind.to(f.kind),f.containerName||"",new k.Location(g[0],t.Range.to(f.range)));return h.detail=f.detail,h.range=h.location.range,h.selectionRange=t.Range.to(f.selectionRange),h.children=f.children?f.children.map(m.to):[],h}}return d.map(m.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(t.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(t.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(g=>k.Position.isPosition(g)),d=>d.map(t.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(g=>{let m;for(const w of g.reverse())m=new k.SelectionRange(t.Range.to(w),m);return m}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(t.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(t.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(t.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(t.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:t.Range.to(d.range),placeholder:d.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return t.WorkspaceEdit.to(d)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(t.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new k.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const g=(0,S.decodeSemanticTokensDto)(d);if(g.type==="full")return new k.SemanticTokens(g.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new k.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const g=(0,S.decodeSemanticTokensDto)(d);if(g.type==="full")return new k.SemanticTokens(g.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,g,m)=>{if(!d)return new k.CompletionList([]);const w=d.suggestions.map(f=>t.CompletionItem.to(f,m));return new k.CompletionList(w,d.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return t.SignatureHelp.to(d)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,g,m)=>C(w=>new k.CodeLens(t.Range.to(w.range),w.command&&m.fromInternal(w.command)))(d))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>k.Range.isRange(d),d=>k.Selection.isSelection(d)?t.Selection.from(d):t.Range.from(d)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,g,m)=>C(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(w.command)}else{const f=new k.CodeAction(w.title,w.kind?new k.CodeActionKind(w.kind):void 0);return w.edit&&(f.edit=t.WorkspaceEdit.to(w.edit)),w.command&&(f.command=m.fromInternal(w.command)),f.isPreferred=w.isPreferred,f}})(d))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(g=>new k.ColorInformation(t.Range.to(g.range),t.Color.to(g.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",d=>d instanceof k.Color,t.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:t.Range.from(d.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(t.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,g,m)=>d.map(t.InlayHint.to.bind(void 0,m)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(g=>t.NotebookExclusiveDocumentPattern.to(g))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(t.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>c.URI.isUri(d)||typeof d=="string"&&(0,y.matchesSomeScheme)(d,R.Schemas.http,R.Schemas.https),d=>d),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void),new D.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[D.ApiCommandArgument.String.with("name","The context key name"),new D.ApiCommandArgument("value","The context key value",()=>!0,d=>d)],D.ApiCommandResult.Void)];class E{static register(g){P.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=E;function C(d){return g=>{if(Array.isArray(g))return g.map(d)}}function v(d){if(!Array.isArray(d))return;const g=[];for(const m of d)A.isLocationLink(m)?g.push(t.DefinitionLink.to(m)):g.push(t.location.to(m));return g}}),define(Se[245],ye([1,0,18,60,4,6,2,66,27,14,7,26,5]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function C(v,d,g){const m=v.getProxy(E.MainContext.MainThreadComments);class w{constructor(){this.b=new Map,this.c=new Map,d.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const n=this.b.get(a.handle);return n?n.value:a}else if(a&&a.$mid===7){const n=this.b.get(a.commentControlHandle);if(!n)return a;const o=n.getCommentThread(a.commentThreadHandle);return o?o.value:a}else if(a&&(a.$mid===9||a.$mid===8)){const n=this.b.get(a.thread.commentControlHandle);if(!n)return a;const o=n.getCommentThread(a.thread.commentThreadHandle);return o?a.$mid===8?o.value:{thread:o.value,text:a.text}:a}else if(a&&a.$mid===10){const n=this.b.get(a.thread.commentControlHandle);if(!n)return a;const o=n.getCommentThread(a.thread.commentThreadHandle);if(!o)return a;const p=a.commentUniqueId,I=o.getCommentByUniqueId(p);return I||a}else if(a&&a.$mid===11){const n=this.b.get(a.thread.commentControlHandle);if(!n)return a;const o=n.getCommentThread(a.thread.commentThreadHandle);if(!o)return a;const p=a.text,I=a.commentUniqueId,L=o.getCommentByUniqueId(I);return L?(typeof L.body=="string"?L.body=p:L.body.value=p,L):a}return a}})}createCommentController(a,n,o){const p=w.a++,I=new h(a,p,n,o);this.b.set(I.handle,I);const L=this.c.get(S.ExtensionIdentifier.toKey(a.identifier))||[];return L.push(I),this.c.set(S.ExtensionIdentifier.toKey(a.identifier),L),I.value}$createCommentThreadTemplate(a,n,o){const p=this.b.get(a);!p||p.$createCommentThreadTemplate(n,o)}async $updateCommentThreadTemplate(a,n,o){const p=this.b.get(a);!p||p.$updateCommentThreadTemplate(n,o)}$deleteCommentThread(a,n){this.b.get(a)?.$deleteCommentThread(n)}$provideCommentingRanges(a,n,o){const p=this.b.get(a);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const I=g.getDocument(D.URI.revive(n));return(0,c.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(I,o)).then(L=>L?L.map(z=>y.Range.from(z)):void 0)}$toggleReaction(a,n,o,p,I){const L=this.b.get(a);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const z=L.getCommentThread(n);if(z){const _=z.getCommentByUniqueId(p.uniqueIdInThread);if(L!==void 0&&_&&L.reactionHandler)return L.reactionHandler(_,i(I))}return Promise.resolve(void 0)})}dispose(){}}w.a=0;class f{set threadId(a){this.n=a}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(a){a.isEqual(this.p)||(this.p=a,this.b.range=a,this.c.fire())}get range(){return this.p}set canReply(a){this.d!==a&&(this.d=a,this.b.canReply=a,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(a){this.e=a,this.b.label=a,this.c.fire()}get contextValue(){return this.f}set contextValue(a){this.f=a,this.b.contextValue=a,this.c.fire()}get comments(){return this.q}set comments(a){this.q=a,this.b.comments=a,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(a){this.g=a,this.b.collapsibleState=a,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(a){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=a,this.b.state=a,this.c.fire()}get isDisposed(){return this.j}constructor(a,n,o,p,I,L,z,_){this.m=n,this.n=o,this.o=p,this.p=I,this.q=L,this.extensionDescription=z,this.r=_,this.handle=f.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.MutableDisposable,this.l.value=new A.DisposableStore,this.n===void 0&&(this.n=`${a}.${this.handle}`),m.$createCommentThread(n,this.handle,this.n,this.o,y.Range.from(this.p),z.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{m.$deleteCommentThread(n,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(N){q.range=N},get comments(){return q.comments},set comments(N){q.comments=N},get collapsibleState(){return q.collapsibleState},set collapsibleState(N){q.collapsibleState=N},get canReply(){return q.canReply},set canReply(N){q.canReply=N},get contextValue(){return q.contextValue},set contextValue(N){q.contextValue=N},get label(){return q.label},set label(N){q.label=N},get state(){return q.state},set state(N){q.state=N},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.DisposableStore);const a=o=>Object.prototype.hasOwnProperty.call(this.b,o),n={};a("range")&&(n.range=y.Range.from(this.p)),a("label")&&(n.label=this.label),a("contextValue")&&(n.contextValue=this.contextValue??null),a("comments")&&(n.comments=this.q.map(o=>b(this,o,this.k))),a("collapsibleState")&&(n.collapseState=l(this.g)),a("canReply")&&(n.canReply=this.canReply),a("state")&&(n.state=u(this.h)),a("isTemplate")&&(n.isTemplate=this.r),this.b={},m.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(a){for(const n of this.k){const o=n[0],p=n[1];if(a===p)return o}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(a=>a.dispose())}}f.a=0,qe([(0,t.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class h{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(a){this.b=a,m.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(a){this.c=a,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this.d}set options(a){this.d=a,m.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(a,n,o,p){this.f=a,this.g=n,this.h=o,this.i=p,this.a=new Map,m.$registerCommentController(this.handle,o,p);const I=this;this.value=Object.freeze({id:I.id,label:I.label,get options(){return I.options},set options(L){I.options=L},get commentingRangeProvider(){return I.commentingRangeProvider},set commentingRangeProvider(L){I.commentingRangeProvider=L},get reactionHandler(){return I.reactionHandler},set reactionHandler(L){I.reactionHandler=L},createCommentThread(L,z,_){return I.createCommentThread(L,z,_).value},dispose:()=>{I.dispose()}}),this.e=[],this.e.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(a,n,o,p){if(typeof a=="string"){const I=new f(this.id,this.handle,a,n,o,p,this.f,!1);return this.a.set(I.handle,I),I}else{const I=new f(this.id,this.handle,void 0,a,n,o,this.f,!1);return this.a.set(I.handle,I),I}}$createCommentThreadTemplate(a,n){const o=new f(this.id,this.handle,void 0,D.URI.revive(a),y.Range.to(n),[],this.f,!0);return o.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this.a.set(o.handle,o),o}$updateCommentThreadTemplate(a,n){const o=this.a.get(a);o&&(o.range=y.Range.to(n))}$deleteCommentThread(a){this.a.get(a)?.dispose(),this.a.delete(a)}getCommentThread(a){return this.a.get(a)}dispose(){this.a.forEach(a=>{a.dispose()}),this.e.forEach(a=>a.dispose())}}function b(r,a,n){let o=n.get(a);o||(o=++r.commentHandle,n.set(a,o));const p=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:o,body:typeof a.body=="string"?a.body:y.MarkdownString.from(a.body),userName:a.author.name,userIconPath:p,label:a.label,commentReactions:a.reactions?a.reactions.map(I=>s(I)):void 0,timestamp:a.timestamp?.toJSON()}}function s(r){return{label:r.label,iconPath:r.iconPath?y.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?D.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function l(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function u(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new w}e.createExtHostComments=C}),define(Se[246],ye([1,0,23,5,25,16]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(R,P){this.a=R.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,P){const E=this,C=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){E.e(R,P,C,arguments)}})}e(R,P,E,C){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:S(C,this.b)}),this.c&&this.f(R,E,C)}};D=qe([We(0,A.IExtHostRpcService),We(1,k.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const T=1e5;function S(y,R){const P=[];if(y.length)for(let E=0;E<y.length;E++){let C=y[E];if(typeof C>"u")C="undefined";else if(C instanceof Error){const v=C;v.stack?C=v.stack:C=v.toString()}P.push(C)}if(R){const E=new Error().stack;E&&P.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,c.safeStringify)(P);return E.length>T?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(Se[138],ye([1,0,2,5,7,3,16,13,17,8,9,26]),function(ne,e,c,t,k,A,D,T,S,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class Rn{constructor(v,d){this.h=d,this.f=new Map,this.g=v.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,d){const g=Rn.c++;this.f.set(g,{provider:v,extensionDescription:d}),this.g.$registerDecorationProvider(g,d.identifier.value);const m=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(w=>{if(!w){this.g.$onDidChange(g,null);return}const f=(0,S.asArray)(w);if(f.length<=Rn.d){this.g.$onDidChange(g,f);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,f.length);const h=f.map(i=>({uri:i,rank:(0,y.count)(i.path,"/")})),b=(0,S.groupBy)(h,(i,l)=>i.rank-l.rank||(0,y.compare)(i.uri.path,l.uri.path)),s=[];e:for(const i of b){let l;for(const u of i){const r=(0,R.dirname)(u.uri.path);if(l!==r&&(l=r,s.push(u.uri)>=Rn.d))break e}}this.g.$onDidChange(g,s)});return new k.Disposable(()=>{m?.dispose(),this.g.$unregisterDecorationProvider(g),this.f.delete(g)})}async $provideDecorations(v,d,g){if(!this.f.has(v))return Object.create(null);const m=Object.create(null),{provider:w,extensionDescription:f}=this.f.get(v);return await Promise.all(d.map(async h=>{try{const{uri:b,id:s}=h,i=await Promise.resolve(w.provideFileDecoration(c.URI.revive(b),g));if(!i)return;try{k.FileDecoration.validate(i),i.badge&&typeof i.badge!="string"&&(0,P.checkProposedApiEnabled)(f,"codiconDecoration"),m[s]=[i.propagate,i.tooltip,i.badge,i.color]}catch(l){this.h.warn(`INVALID decoration from extension '${f}': ${l}`)}}catch(b){this.h.error(b)}})),m}};E.c=0,E.d=250,E=qe([We(0,D.IExtHostRpcService),We(1,T.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[247],ye([1,0,172,122,2,5,7,14,4,13,28,47]),function(ne,e,c,t,k,A,D,T,S,y,R,P){"use strict";var E,C,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(w,f,h,b,s,i,l){this.d=w,this.e=f,this.f=h,this.g=b,E.set(this,void 0),C.set(this,void 0),v.set(this,void 0),this.c=!1,Je(this,v,new R.ResourceMap(u=>s.getComparisonKey(u)),"f"),Je(this,E,i,"f"),Je(this,C,l,"f")}dispose(){this.c||(Fe(this,C,"f").fire([...Fe(this,v,"f").keys()]),Fe(this,E,"f")?.$clear(this.e),Fe(this,v,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(w,f){if(!w){this.clear();return}this.h();let h=[];if(k.URI.isUri(w)){if(!f){this.delete(w);return}Fe(this,v,"f").set(w,f.slice()),h=[w]}else if(Array.isArray(w)){h=[];let s;w=[...w].sort(d.j);for(const i of w){const[l,u]=i;if((!s||l.toString()!==s.toString())&&(s&&Fe(this,v,"f").get(s).length===0&&Fe(this,v,"f").delete(s),s=l,h.push(l),Fe(this,v,"f").set(l,[])),u)Fe(this,v,"f").get(l)?.push(...u);else{const r=Fe(this,v,"f").get(l);r&&(r.length=0)}}}if(Fe(this,C,"f").fire(h),!Fe(this,E,"f"))return;const b=[];for(const s of h){let i=[];const l=Fe(this,v,"f").get(s);if(l)if(l.length>this.f){i=[];const u=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const a of l)if(a.severity===u[r]&&i.push({...T.Diagnostic.from(a),modelVersionId:this.g(s)})===this.f)break e;i.push({severity:t.MarkerSeverity.Info,message:(0,c.localize)(0,null,l.length-this.f),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=l.map(u=>({...T.Diagnostic.from(u),modelVersionId:this.g(s)}));b.push([s,i])}Fe(this,E,"f").$changeMany(this.e,b)}delete(w){this.h(),Fe(this,C,"f").fire([w]),Fe(this,v,"f").delete(w),Fe(this,E,"f")?.$changeMany(this.e,[[w,void 0]])}clear(){this.h(),Fe(this,C,"f").fire([...Fe(this,v,"f").keys()]),Fe(this,v,"f").clear(),Fe(this,E,"f")?.$clear(this.e)}forEach(w,f){this.h();for(const[h,b]of this)w.call(f,h,b,this)}*[(E=new WeakMap,C=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.h();for(const w of Fe(this,v,"f").keys())yield[w,this.get(w)]}get(w){this.h();const f=Fe(this,v,"f").get(w);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(w){return this.h(),Array.isArray(Fe(this,v,"f").get(w))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(w,f){return w[0].toString()<f[0].toString()?-1:w[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=d;let g=class pn{static _mapper(w){const f=new R.ResourceMap;for(const h of w)f.set(h,h);return{uris:Object.freeze(Array.from(f.values()))}}constructor(w,f,h,b){this.h=f,this.j=h,this.k=b,this.f=new Map,this.g=new S.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pn._mapper),this.e=w.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(w,f){const{f:h,e:b,g:s,h:i,j:l,k:u}=this,r=new class{$changeMany(o,p){b.$changeMany(o,p),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,o,p.length===0?"CLEARING":p)}$clear(o){b.$clear(o),i.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,o)}dispose(){b.dispose()}};let a;if(!f)f="_generated_diagnostic_collection_name_#"+pn.c++,a=f;else if(!h.has(f))a=f;else{this.h.warn(`DiagnosticCollection with name '${f}' does already exist.`);do a=f+pn.c++;while(h.has(a))}return new class extends d{constructor(){super(f,a,pn.d,o=>u.getDocument(o)?.version,l.extUri,r,s),h.set(a,this)}dispose(){super.dispose(),h.delete(a)}}}getDiagnostics(w){if(w)return this.l(w);{const f=new Map,h=[];for(const b of this.f.values())b.forEach((s,i)=>{let l=f.get(s.toString());typeof l>"u"&&(l=h.length,f.set(s.toString(),l),h.push([s,[]])),h[l][1]=h[l][1].concat(...i)});return h}}l(w){let f=[];for(const h of this.f.values())h.has(w)&&(f=f.concat(h.get(w)));return f}$acceptMarkersChange(w){if(!this.m){const f="_generated_mirror",h=new d(f,f,pn.d,b=>{},this.j.extUri,void 0,this.g);this.f.set(f,h),this.m=h}for(const[f,h]of w)this.m.set(k.URI.revive(f),h.map(T.Diagnostic.to))}};g.c=0,g.d=1e3,g=qe([We(1,y.ILogService),We(2,P.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(Se[248],ye([1,0,2,5]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(D){this.a=D.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(D){return this.a.$showOpenDialog(D).then(T=>T?T.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(D){return this.a.$showSaveDialog(D).then(T=>T?c.URI.revive(T):void 0)}}e.ExtHostDialogs=k}),define(Se[249],ye([1,0,10,2,7,5,15,21,8]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{constructor(P,E,C){this.d=E,this.e=C,this.b=new Map,this.c=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,E){if(Object.keys(D.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const C=y.a++;this.b.set(C,E),this.c.$registerTextContentProvider(C,P);let v;return typeof E.onDidChange=="function"&&(v=E.onDidChange(d=>{if(d.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(C,d).then(g=>{if(!g&&typeof g!="string")return;const m=this.d.getDocument(d);if(!m)return;const w=(0,S.splitLines)(g);if(!m.equalLines(w))return this.c.$onVirtualDocumentChange(d,g)},c.onUnexpectedError)})),new k.Disposable(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,E){const C=this.b.get(P);return C?Promise.resolve(C.provideTextDocumentContent(t.URI.revive(E),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=y,y.a=0}),define(Se[250],ye([1,0,4,6,2,5,134,14,11,23,7]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(C,v){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=C.getProxy(A.MainContext.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(d=>{for(const g of d)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const g of d)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const v=this.g.getDocument(C);if(v)return v}getDocument(C){const v=this.getDocumentData(C);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return v.document}ensureDocumentData(C){const v=this.g.getDocument(C);if(v)return Promise.resolve(v);let d=this.h.get(C.toString());return d||(d=this.f.$tryOpenDocument(C).then(g=>{this.h.delete(C.toString());const m=k.URI.revive(g);return(0,S.assertIsDefined)(this.g.getDocument(m))},g=>(this.h.delete(C.toString()),Promise.reject(g))),this.h.set(C.toString(),d)),d}createDocumentData(C){return this.f.$tryCreateDocument(C).then(v=>k.URI.revive(v))}$acceptModelLanguageChanged(C,v){const d=k.URI.revive(C),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(v),this.a.fire(g.document)}$acceptModelSaved(C){const v=k.URI.revive(C),d=this.g.getDocument(v);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(C,v){const d=k.URI.revive(C),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");g._acceptIsDirty(v),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,v,d){const g=k.URI.revive(C),m=this.g.getDocument(g);if(!m)throw new Error("unknown document");m._acceptIsDirty(d),m.onEvents(v);let w;v.isUndoing?w=R.TextDocumentChangeReason.Undo:v.isRedoing&&(w=R.TextDocumentChangeReason.Redo),this.c.fire((0,y.deepFreeze)({document:m.document,contentChanges:v.changes.map(f=>({range:T.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:w}))}setWordDefinitionFor(C,v){(0,D.setWordDefinitionFor)(C,v)}}e.ExtHostDocuments=P}),define(Se[58],ye([1,0,49,4,6,2,3,5,134,16,137,14,13,28,15,62,81]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(h){this.value=h,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let w=class{constructor(h,b){this.h=h,this.i=b,this.a=null,this.b=new Map,this.c=new C.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const b=[],s=[],i=[];if(h.removedDocuments)for(const l of h.removedDocuments){const u=A.URI.revive(l),r=this.c.get(u);r?.unref()&&(this.c.delete(u),b.push(r.value))}if(h.addedDocuments)for(const l of h.addedDocuments){const u=A.URI.revive(l.uri);let r=this.c.get(u);if(r&&u.scheme!==v.Schemas.vscodeNotebookCell&&u.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);r||(r=new m(new S.ExtHostDocumentData(this.h.getProxy(T.MainContext.MainThreadDocuments),u,l.lines,l.EOL,l.versionId,l.languageId,l.isDirty,l.notebook)),this.c.set(u,r),s.push(r.value)),r.ref()}if(h.removedEditors)for(const l of h.removedEditors){const u=this.b.get(l);this.b.delete(l),u&&i.push(u)}if(h.addedEditors)for(const l of h.addedEditors){const u=A.URI.revive(l.documentUri);c.ok(this.c.has(u),`document '${u}' does not exist`),c.ok(!this.b.has(l.id),`editor '${l.id}' already exists!`);const r=this.c.get(u).value,a=new R.ExtHostTextEditor(l.id,this.h.getProxy(T.MainContext.MainThreadTextEditors),this.i,new g.Lazy(()=>r.document),l.selections.map(P.Selection.to),l.options,l.visibleRanges.map(n=>P.Range.to(n)),typeof l.editorPosition=="number"?P.ViewColumn.to(l.editorPosition):void 0);this.b.set(l.id,a)}h.newActiveEditor!==void 0&&(c.ok(h.newActiveEditor===null||this.b.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this.a=h.newActiveEditor),(0,k.dispose)(b),(0,k.dispose)(i),h.removedDocuments&&this.e.fire(b),h.addedDocuments&&this.d.fire(s),(h.removedEditors||h.addedEditors)&&this.f.fire(this.allEditors().map(l=>l.value)),h.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(h){return this.c.get(h)?.value}allDocuments(){return d.Iterable.map(this.c.values(),h=>h.value)}getEditor(h){return this.b.get(h)}activeEditor(h){if(!this.a)return;const b=this.b.get(this.a);return h?b:b?.value}allEditors(){return[...this.b.values()]}};w=qe([We(0,y.IExtHostRpcService),We(1,E.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(Se[59],ye([1,0,14,5,2,4,3,7,16,11,80]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class P{constructor(g,m,w){this.e=w,this.d=m,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,m={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(m)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.TextTabInput(k.URI.revive(this.b.input.uri));case 2:return new T.TextDiffTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified));case 3:return new T.TextMergeTabInput(k.URI.revive(this.b.input.base),k.URI.revive(this.b.input.input1),k.URI.revive(this.b.input.input2),k.URI.revive(this.b.input.result));case 6:return new T.CustomEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.WebviewEditorTabInput(this.b.input.viewType);case 4:return new T.NotebookEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(k.URI.revive(this.b.input.uri),k.URI.revive(this.b.input.inputBoxUri));default:return}}}class E{constructor(g,m){this.c=[],this.d="",this.b=g,this.e=m;for(const w of g.tabs)w.isActive&&(this.d=w.id),this.c.push(new P(w,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,m={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return c.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(w=>w.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(w=>w.apiObject))}};this.a=Object.freeze(m)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const w=new P(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,w),g.tabDto.isActive&&(this.d=w.tabId),w}else if(g.kind===1){const w=this.c.splice(g.index,1)[0];if(!w)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return w.tabId===this.d&&(this.d=""),w}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const w=this.c.splice(g.oldIndex,1)[0];if(!w)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,w),w}const m=this.c.find(w=>w.tabId===g.tabDto.id);if(!m)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),m.acceptDtoUpdate(g.tabDto),m}activeTabId(){return this.d}}let C=class{constructor(g){this.b=new A.Emitter,this.c=new A.Emitter,this.e=[],this.a=g.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,m={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(w=>w.apiObject))},get activeTabGroup(){const w=g.d;return(0,y.assertIsDefined)(g.e.find(h=>h.groupId===w)?.apiObject)},close:async(w,f)=>{const h=Array.isArray(w)?w:[w];return h.length?v(h[0])?this.j(h,f):this.i(h,f):!0}};this.f=Object.freeze(m)}return this.f}$acceptEditorTabModel(g){const m=new Set(this.e.map(l=>l.groupId)),w=new Set(g.map(l=>l.groupId)),f=(0,R.diffSets)(m,w),h=this.e.filter(l=>f.removed.includes(l.groupId)).map(l=>l.apiObject),b=[],s=[];this.e=g.map(l=>{const u=new E(l,()=>this.d);return f.added.includes(u.groupId)?b.push(u.apiObject):s.push(u.apiObject),u});const i=(0,y.assertIsDefined)(g.find(l=>l.isActive===!0)?.groupId);i!==void 0&&this.d!==i&&(this.d=i),this.c.fire(Object.freeze({opened:b,closed:h,changed:s}))}$acceptTabGroupUpdate(g){const m=this.e.find(w=>w.groupId===g.groupId);if(!m)throw new Error("Update Group IPC call received before group creation.");m.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[m.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const m=this.e.find(f=>f.groupId===g.groupId);if(!m)throw new Error("Update Tabs IPC call received before group creation.");const w=m.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[w.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[w.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[w.apiObject]}));return}}g(g){for(const m of this.e)for(const w of m.tabs)if(w.apiObject===g)return w}h(g){return this.e.find(m=>m.apiObject===g)}async i(g,m){const w=[];for(const f of g){const h=this.g(f);if(!h)throw new Error("Tab close: Invalid tab not found!");w.push(h.tabId)}return this.a.$closeTab(w,m)}async j(g,m){const w=[];for(const f of g){const h=this.h(f);if(!h)throw new Error("Group close: Invalid group not found!");w.push(h.groupId)}return this.a.$closeGroup(w,m)}};C=qe([We(0,S.IExtHostRpcService)],C),e.ExtHostEditorTabs=C;function v(d){return d.tabs!==void 0}}),define(Se[251],ye([1,0,2,5,6,7,14,152,8,22,26]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const d=this.a.indexOf(v);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),d=[];let g,m,w=14,f=14;for(const h of v){let b=g?(0,S.commonPrefixLength)(g,h):0;for(b===0?m=1:m=f;b<h.length;b++)b+1===h.length?(w=f,f=9):f+=1,d.push([m,h.toUpperCase().charCodeAt(b),f]),d.push([m,h.toLowerCase().charCodeAt(b),f]),m=f;g=h,f=w}d.push([9,58,10]),d.push([10,47,12]),this.b=new T.StateMachine(d)}}provideDocumentLinks(v){this.c();const d=[],g=T.LinkComputer.computeLinks({getLineContent(m){return v.lineAt(m-1).text},getLineCount(){return v.lineCount}},this.b);for(const m of g){const w=D.DocumentLink.to(m);w.target&&d.push(w)}return d}}class E{constructor(v,d){this.i=d,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,d,g,m={}){if(this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const w=this.h++;this.b.add(d),this.d.add(d),this.c.set(w,g);let f=2;m.isCaseSensitive&&(f+=1024),m.isReadonly&&(f+=2048),typeof g.copy=="function"&&(f+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,R.checkProposedApiEnabled)(v,"fsChunks"),f+=4),this.a.$registerFileSystemProvider(w,d,f).catch(b=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${d}`),console.error(b)});const h=g.onDidChangeFile(b=>{const s=[];for(const i of b){const{uri:l,type:u}=i;if(l.scheme!==d)continue;let r;switch(u){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:l,type:r})}this.a.$onFileSystemChange(w,s)});return(0,k.toDisposable)(()=>{h.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(w),this.a.$unregisterProvider(w)})}static j(v){const{type:d,ctime:g,mtime:m,size:w,permissions:f}=v;return{type:d,ctime:g,mtime:m,size:w,permissions:f}}$stat(v,d){return Promise.resolve(this.k(v).stat(c.URI.revive(d))).then(g=>E.j(g))}$readdir(v,d){return Promise.resolve(this.k(v).readDirectory(c.URI.revive(d)))}$readFile(v,d){return Promise.resolve(this.k(v).readFile(c.URI.revive(d))).then(g=>y.VSBuffer.wrap(g))}$writeFile(v,d,g,m){return Promise.resolve(this.k(v).writeFile(c.URI.revive(d),g.buffer,m))}$delete(v,d,g){return Promise.resolve(this.k(v).delete(c.URI.revive(d),g))}$rename(v,d,g,m){return Promise.resolve(this.k(v).rename(c.URI.revive(d),c.URI.revive(g),m))}$copy(v,d,g,m){const w=this.k(v);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(c.URI.revive(d),c.URI.revive(g),m))}$mkdir(v,d){return Promise.resolve(this.k(v).createDirectory(c.URI.revive(d)))}$watch(v,d,g,m){const w=this.k(v).watch(c.URI.revive(g),m);this.f.set(d,w)}$unwatch(v,d){const g=this.f.get(d);g&&(g.dispose(),this.f.delete(d))}$open(v,d,g){const m=this.k(v);if(!m.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(m.open(c.URI.revive(d),g))}$close(v,d){const g=this.k(v);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(d))}$read(v,d,g,m){const w=this.k(v);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const f=y.VSBuffer.alloc(m);return Promise.resolve(w.read(d,g,f.buffer,0,m)).then(h=>f.slice(0,h))}$write(v,d,g,m){const w=this.k(v);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(d,g,m.buffer,0,m.byteLength))}k(v){const d=this.c.get(v);if(!d){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return d}}e.ExtHostFileSystem=E}),define(Se[71],ye([1,0,5,38,7,22,3,16,47,6]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Jt{constructor(E,C){this.b=new Map,this.a=E.getProxy(c.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(d){try{const g=v.b.get(d.scheme);if(!g)return await v.a.$stat(d);await v.a.$ensureActivation(d.scheme);const m=await g.stat(d);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions}}catch(g){Jt.c(g)}},async readDirectory(d){try{const g=v.b.get(d.scheme);return g?(await v.a.$ensureActivation(d.scheme),(await g.readDirectory(d)).slice()):await v.a.$readdir(d)}catch(g){return Jt.c(g)}},async createDirectory(d){try{return await v.a.$mkdir(d)}catch(g){return Jt.c(g)}},async readFile(d){try{const g=v.b.get(d.scheme);return g?(await v.a.$ensureActivation(d.scheme),(await g.readFile(d)).slice()):(await v.a.$readFile(d)).buffer}catch(g){return Jt.c(g)}},async writeFile(d,g){try{return await v.a.$writeFile(d,A.VSBuffer.wrap(g))}catch(m){return Jt.c(m)}},async delete(d,g){try{const m=v.b.get(d.scheme);return m?(await v.a.$ensureActivation(d.scheme),await m.delete(d,{recursive:!1,...g})):await v.a.$delete(d,{recursive:!1,useTrash:!1,...g})}catch(m){return Jt.c(m)}},async rename(d,g,m){try{return await v.a.$rename(d,g,{overwrite:!1,...m})}catch(w){return Jt.c(w)}},async copy(d,g,m){try{return await v.a.$copy(d,g,{overwrite:!1,...m})}catch(w){return Jt.c(w)}},isWritableFileSystem(d){const g=C.getCapabilities(d);if(typeof g=="number")return!(g&2048)}})}static c(E){if(E instanceof k.FileSystemError)throw E;if(!(E instanceof Error))throw new k.FileSystemError(String(E));if(E.name==="ENOPRO")throw k.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(E.message);default:throw new k.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,C){return this.b.set(E,C),(0,y.toDisposable)(()=>this.b.delete(E))}};R=qe([We(0,T.IExtHostRpcService),We(1,S.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(Se[252],ye([1,0,4,37,2,5,14,7]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,E,C,v,d,g,m,w){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter;const f=this.h(P,C,d);this.g=0,g&&(this.g+=1),m&&(this.g+=2),w&&(this.g+=4);const h=(0,t.parse)(d),b=typeof d=="string",s=v(i=>{if(!g)for(const l of i.created){const u=k.URI.revive(l);h(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.a.fire(u)}if(!m)for(const l of i.changed){const u=k.URI.revive(l);h(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.b.fire(u)}if(!w)for(const l of i.deleted){const u=k.URI.revive(l);h(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=T.Disposable.from(f,this.a,this.b,this.c,s)}h(P,E,C){const v=T.Disposable.from();if(typeof C=="string")return v;const d=P.getProxy(A.MainContext.MainThreadFileSystem);let g=!1;(C.pattern.includes(t.GLOBSTAR)||C.pattern.includes(t.GLOB_SPLIT))&&(g=!0);const m=Math.random();return d.$watch(E.identifier.value,m,C.baseUri,{recursive:g,excludes:[]}),T.Disposable.from({dispose:()=>d.$unwatch(m)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class y{constructor(P,E,C){this.j=P,this.k=E,this.l=C,this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.g=new c.AsyncEmitter,this.h=new c.AsyncEmitter,this.i=new c.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,E,C,v,d,g){return new S(this.j,P,E,this.a.event,D.GlobPattern.from(C),v,d,g)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,E){switch(P){case 2:this.b.fire(Object.freeze({files:E.map(C=>({oldUri:k.URI.revive(C.source),newUri:k.URI.revive(C.target)}))}));break;case 1:this.d.fire(Object.freeze({files:E.map(C=>k.URI.revive(C.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:E.map(C=>k.URI.revive(C.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,E){return(C,v,d)=>{const g=function(w){C.call(v,w)};return g.extension=P,E.event(g,void 0,d)}}async $onWillRunFileOperation(P,E,C,v){switch(P){case 2:return await this.n(this.g,{files:E.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))},C,v);case 1:return await this.n(this.i,{files:E.map(d=>k.URI.revive(d.target))},C,v);case 0:case 3:return await this.n(this.h,{files:E.map(d=>k.URI.revive(d.target))},C,v)}}async n(P,E,C,v){const d=new Set,g=[];if(await P.fireAsync(E,v,async(w,f)=>{const h=Date.now(),b=await Promise.resolve(w);b instanceof T.WorkspaceEdit&&(g.push([f.extension,b]),d.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-h>C&&this.k.warn("SLOW file-participant",f.extension.identifier)}),v.isCancellationRequested||g.length===0)return;const m={edits:[]};for(const[,w]of g){const{edits:f}=D.WorkspaceEdit.from(w,{getTextDocumentVersion:h=>this.l.getDocument(h)?.version,getNotebookDocumentVersion:()=>{}});m.edits=m.edits.concat(f)}return{edit:m,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=y}),define(Se[253],ye([1,0,2,39]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(D,T,S,y,R){this.a=T,this.b=S,this.c=y;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const C=this.a.getEditorById(E.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri),notebookEditor:C.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(D,T,S,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:D,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(c.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=k}),define(Se[254],ye([1,0,6,5]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(D){this.b=0,this.a=D.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,D),(0,c.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=k}),define(Se[255],ye([1,0,2,23,14,7,66,5,8,35,17,11,148,21,6,118,99,68,44,10,18,26]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(O,$){this.d=O,this.e=$}async provideDocumentSymbols(O,$){const G=this.d.getDocument(O),Q=await this.e.provideDocumentSymbols(G,$);if(!(0,R.isFalsyOrEmpty)(Q))return Q[0]instanceof A.DocumentSymbol?Q.map(k.DocumentSymbol.from):s.f(Q)}static f(O){O=O.slice(0).sort((Q,de)=>{let be=Q.location.range.start.compareTo(de.location.range.start);return be===0&&(be=de.location.range.end.compareTo(Q.location.range.end)),be});const $=[],G=[];for(const Q of O){const de={name:Q.name||"!!MISSING: name!!",kind:k.SymbolKind.from(Q.kind),tags:Q.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:k.Range.from(Q.location.range),selectionRange:k.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(de),$.push(de);break}const be=G[G.length-1];if(y.Range.containsRange(be.range,de.range)&&!y.Range.equalsRange(be.range,de.range)){be.children?.push(de),G.push(de);break}G.pop()}}return $}}class i{constructor(O,$,G){this.g=O,this.h=$,this.j=G,this.e=new m.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(O,$){const G=this.g.getDocument(O),Q=await this.j.provideCodeLenses(G,$);if(!Q||$.isCancellationRequested)return;const de=this.e.add(Q),be=new v.DisposableStore;this.f.set(de,be);const Pe={cacheId:de,lenses:[]};for(let pe=0;pe<Q.length;pe++)Pe.lenses.push({cacheId:[de,pe],range:k.Range.from(Q[pe].range),command:this.h.toInternal(Q[pe].command,be)});return Pe}async resolveCodeLens(O,$){const G=O.cacheId&&this.e.get(...O.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,$),Q||(Q=G),$.isCancellationRequested)return;const de=O.cacheId&&this.f.get(O.cacheId[0]);if(!!de)return O.command=this.h.toInternal(Q.command??i.d,de),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}i.d={command:"missing",title:"!!MISSING: command!!"};function l(re){return Array.isArray(re)?re.map(k.DefinitionLink.from):re?[k.DefinitionLink.from(re)]:[]}class u{constructor(O,$){this.d=O,this.e=$}async provideDefinition(O,$,G){const Q=this.d.getDocument(O),de=k.Position.to($),be=await this.e.provideDefinition(Q,de,G);return l(be)}}class r{constructor(O,$){this.d=O,this.e=$}async provideDeclaration(O,$,G){const Q=this.d.getDocument(O),de=k.Position.to($),be=await this.e.provideDeclaration(Q,de,G);return l(be)}}class a{constructor(O,$){this.d=O,this.e=$}async provideImplementation(O,$,G){const Q=this.d.getDocument(O),de=k.Position.to($),be=await this.e.provideImplementation(Q,de,G);return l(be)}}class n{constructor(O,$){this.d=O,this.e=$}async provideTypeDefinition(O,$,G){const Q=this.d.getDocument(O),de=k.Position.to($),be=await this.e.provideTypeDefinition(Q,de,G);return l(be)}}class o{constructor(O,$){this.d=O,this.e=$}async provideHover(O,$,G){const Q=this.d.getDocument(O),de=k.Position.to($),be=await this.e.provideHover(Q,de,G);if(!(!be||(0,R.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=Q.getWordRangeAtPosition(de)),be.range||(be.range=new A.Range(de,de)),k.Hover.from(be)}}class p{constructor(O,$){this.d=O,this.e=$}async provideEvaluatableExpression(O,$,G){const Q=this.d.getDocument(O),de=k.Position.to($),be=await this.e.provideEvaluatableExpression(Q,de,G);if(be)return k.EvaluatableExpression.from(be)}}class I{constructor(O,$){this.d=O,this.e=$}async provideInlineValues(O,$,G,Q){const de=this.d.getDocument(O),be=await this.e.provideInlineValues(de,k.Range.to($),k.InlineValueContext.to(G),Q);if(Array.isArray(be))return be.map(Pe=>k.InlineValue.from(Pe))}}class L{constructor(O,$){this.d=O,this.e=$}async provideDocumentHighlights(O,$,G){const Q=this.d.getDocument(O),de=k.Position.to($),be=await this.e.provideDocumentHighlights(Q,de,G);if(Array.isArray(be))return be.map(k.DocumentHighlight.from)}}class z{constructor(O,$){this.d=O,this.e=$}async provideLinkedEditingRanges(O,$,G){const Q=this.d.getDocument(O),de=k.Position.to($),be=await this.e.provideLinkedEditingRanges(Q,de,G);if(be&&Array.isArray(be.ranges))return{ranges:(0,R.coalesce)(be.ranges.map(k.Range.from)),wordPattern:be.wordPattern}}}class _{constructor(O,$){this.d=O,this.e=$}async provideReferences(O,$,G,Q){const de=this.d.getDocument(O),be=k.Position.to($),Pe=await this.e.provideReferences(de,be,G,Q);if(Array.isArray(Pe))return Pe.map(k.location.from)}}class q{constructor(O,$,G,Q,de,be,Pe){this.g=O,this.h=$,this.j=G,this.k=Q,this.l=de,this.m=be,this.n=Pe,this.e=new m.Cache("CodeAction"),this.f=new Map}async provideCodeActions(O,$,G,Q){const de=this.g.getDocument(O),be=E.Selection.isISelection($)?k.Selection.to($):k.Range.to($),Pe=[];for(const et of this.j.getDiagnostics(O))if(be.intersection(et.range)&&Pe.push(et)>q.d)break;const pe={diagnostics:Pe,only:G.only?new A.CodeActionKind(G.only):void 0,triggerKind:k.CodeActionTriggerKind.to(G.trigger)},Ce=await this.k.provideCodeActions(de,be,pe,Q);if(!(0,R.isNonEmptyArray)(Ce)||Q.isCancellationRequested)return;const ke=this.e.add(Ce),je=new v.DisposableStore;this.f.set(ke,je);const Ge=[];for(let et=0;et<Ce.length;et++){const _e=Ce[et];!_e||(q.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,je)})):(pe.only&&(_e.kind?pe.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(k.Diagnostic.from),edit:_e.edit&&k.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(O,$){const[G,Q]=O,de=this.e.get(G,Q);if(!de||q.o(de)||!this.k.resolveCodeAction)return;const be=await this.k.resolveCodeAction(de,$)??de;return be?.edit?k.WorkspaceEdit.from(be.edit,void 0):void 0}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}q.d=1e3;class N{constructor(O,$,G,Q){this.d=O,this.e=$,this.f=G,this.g=Q}async prepareDocumentPaste(O,$,G,Q){if(!this.f.prepareDocumentPaste)return;const de=this.e.getDocument(O),be=$.map(pe=>k.Range.to(pe)),Pe=k.DataTransfer.toDataTransfer(G,()=>{throw new f.NotImplementedError});return await this.f.prepareDocumentPaste(de,be,Pe,Q),k.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(O,$,G,Q,de){const be=this.e.getDocument($),Pe=G.map(ke=>k.Range.to(ke)),pe=k.DataTransfer.toDataTransfer(Q,async ke=>(await this.d.$resolvePasteFileData(this.g,O,ke)).buffer),Ce=await this.f.provideDocumentPasteEdits(be,Pe,pe,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?k.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class M{constructor(O,$){this.d=O,this.e=$}async provideDocumentFormattingEdits(O,$,G){const Q=this.d.getDocument(O),de=await this.e.provideDocumentFormattingEdits(Q,$,G);if(Array.isArray(de))return de.map(k.TextEdit.from)}}class F{constructor(O,$){this.d=O,this.e=$}async provideDocumentRangeFormattingEdits(O,$,G,Q){const de=this.d.getDocument(O),be=k.Range.to($),Pe=await this.e.provideDocumentRangeFormattingEdits(de,be,G,Q);if(Array.isArray(Pe))return Pe.map(k.TextEdit.from)}}class B{constructor(O,$){this.d=O,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,$,G,Q,de){const be=this.d.getDocument(O),Pe=k.Position.to($),pe=await this.e.provideOnTypeFormattingEdits(be,Pe,G,Q,de);if(Array.isArray(pe))return pe.map(k.TextEdit.from)}}class U{constructor(O,$){this.e=O,this.f=$,this.d=new m.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,$){const G=await this.e.provideWorkspaceSymbols(O,$);if(!(0,R.isNonEmptyArray)(G))return{symbols:[]};const Q=this.d.add(G),de={cacheId:Q,symbols:[]};for(let be=0;be<G.length;be++){const Pe=G[be];if(!Pe||!Pe.name){this.f.warn("INVALID SymbolInformation",Pe);continue}de.symbols.push({...k.WorkspaceSymbol.from(Pe),cacheId:[Q,be]})}return de}async resolveWorkspaceSymbol(O,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const G=this.d.get(...O.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,$);return Q&&(0,t.mixin)(O,k.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class H{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,$,G){this.d=O,this.e=$,this.f=G}async provideRenameEdits(O,$,G,Q){const de=this.d.getDocument(O),be=k.Position.to($);try{const Pe=await this.e.provideRenameEdits(de,be,G,Q);return Pe?k.WorkspaceEdit.from(Pe):void 0}catch(Pe){const pe=H.g(Pe);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(O,$,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(O),de=k.Position.to($);try{const be=await this.e.prepareRename(Q,de,G);let Pe,pe;if(A.Range.isRange(be)?(Pe=be,pe=Q.getText(be)):(0,P.isObject)(be)&&(Pe=be.range,pe=be.placeholder),!Pe||!pe)return;if(Pe.start.line>de.line||Pe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(Pe),text:pe}}catch(be){const Pe=H.g(be);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(be)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class X{constructor(O,$){this.resultId=O,this.tokens=$}}class V{constructor(O,$){this.f=O,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,$,G){const Q=this.f.getDocument(O),de=$!==0?this.d.get($):null;let be=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,de.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return de&&this.d.delete($),be?(be=V.h(be),this.o(V.n(de,be),be)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return V.j(O)?V.k(O)?O:new A.SemanticTokens(new Uint32Array(O.data),O.resultId):V.l(O)?V.m(O)?O:new A.SemanticTokensEdits(O.edits.map($=>new A.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const $ of O.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(O,$){if(!V.j($)||!O||!O.tokens)return $;const G=O.tokens,Q=G.length,de=$.data,be=de.length;let Pe=0;const pe=Math.min(Q,be);for(;Pe<pe&&G[Pe]===de[Pe];)Pe++;if(Pe===Q&&Pe===be)return new A.SemanticTokensEdits([],$.resultId);let Ce=0;const ke=pe-Pe;for(;Ce<ke&&G[Q-Ce-1]===de[be-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Pe,deleteCount:Q-Pe-Ce,data:de.subarray(Pe,be-Ce)}],$.resultId)}o(O,$){if(V.j(O)){const G=this.e++;return this.d.set(G,new X(O.resultId,O.data)),(0,d.encodeSemanticTokensDto)({id:G,type:"full",data:O.data})}if(V.l(O)){const G=this.e++;return V.j($)?this.d.set(G,new X($.resultId,$.data)):this.d.set(G,new X(O.resultId)),(0,d.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(O.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class x{constructor(O,$){this.d=O,this.e=$}async provideDocumentRangeSemanticTokens(O,$,G){const Q=this.d.getDocument(O),de=await this.e.provideDocumentRangeSemanticTokens(Q,k.Range.to($),G);return de?this.f(de):null}f(O){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class Y{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,$,G,Q,de){this.f=O,this.g=$,this.h=G,this.j=Q,this.k=de,this.d=new m.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(O,$,G,Q){const de=this.f.getDocument(O),be=k.Position.to($),Pe=de.getWordRangeAtPosition(be)||new A.Range(be,be),pe=Pe.with({end:be}),Ce=new w.StopWatch(!0),ke=await this.h.provideCompletionItems(de,be,Q,k.CompletionContext.to(G));if(!ke||Q.isCancellationRequested)return;const je=Array.isArray(ke)?new A.CompletionList(ke):ke,Ge=Y.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new v.DisposableStore;this.e.set(Ge,et);const _e=[],nt={x:Ge,b:_e,a:{replace:k.Range.from(Pe),insert:k.Range.from(pe)},c:je.isIncomplete||void 0,d:Ce.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Me=this.l(ht,[Ge,st],pe,Pe);_e.push(Me)}return nt}async resolveCompletionItem(O,$){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...O);if(!G)return;const Q=await this.h.resolveCompletionItem(G,$);if(!!Q)return this.l(Q,O)}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,$,G,Q){const de=this.e.get($[0]);if(!de)throw Error("DisposableStore is missing...");const be=this.g.toInternal(O.command,de),Pe={x:$,a:O.label,b:O.kind!==void 0?k.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(k.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:k.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(k.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=O.textEdit.newText):typeof O.insertText=="string"?Pe.h=O.insertText:O.insertText instanceof A.SnippetString&&(Pe.h=O.insertText.value,Pe.i|=4);let pe;return O.textEdit?pe=O.textEdit.range:O.range&&(pe=O.range),A.Range.isRange(pe)?Pe.j=k.Range.from(pe):pe&&(!G?.isEqual(pe.inserting)||!Q?.isEqual(pe.replacing))&&(Pe.j={insert:k.Range.from(pe.inserting),replace:k.Range.from(pe.replacing)}),Pe}}class J{async provideInlineCompletions(O,$,G,Q){}disposeCompletions(O){}handleDidShowCompletionItem(O,$){}}class te extends J{constructor(O,$,G,Q){super(),this.f=O,this.g=$,this.h=G,this.j=Q,this.d=new le,this.e=(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[D.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,$,G,Q){const de=this.g.getDocument(O),be=k.Position.to($),Pe=await this.h.provideInlineCompletionItems(de,be,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:k.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!Pe||Q.isCancellationRequested)return;const pe=Array.isArray(Pe)?Pe:Pe.items,Ce=this.e?Array.isArray(Pe)?[]:Pe.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((Ge,et)=>{let _e;Ge.command&&(ke||(ke=new v.DisposableStore),_e=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?k.Range.from(Ge.range):void 0,command:_e,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:Ce.map(Ge=>(ke||(ke=new v.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,$){const G=this.d.get(O)?.items[$];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G)}}class le{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const $=this.e++;return this.d.set($,O),$}disposeReferenceId(O){const $=this.d.get(O);return this.d.delete(O),$}get(O){return this.d.get(O)}}class Z{constructor(O,$){this.e=O,this.f=$,this.d=new m.Cache("SignatureHelp")}async provideSignatureHelp(O,$,G,Q){const de=this.e.getDocument(O),be=k.Position.to($),Pe=this.g(G),pe=await this.f.provideSignatureHelp(de,be,Q,Pe);if(pe){const Ce=this.d.add([pe]);return{...k.SignatureHelp.from(pe),id:Ce}}}g(O){let $;if(O.activeSignatureHelp){const G=k.SignatureHelp.to(O.activeSignatureHelp),Q=this.d.get(O.activeSignatureHelp.id,0);Q?($=Q,$.activeSignature=G.activeSignature,$.activeParameter=G.activeParameter):$=G}return{...O,activeSignatureHelp:$}}releaseSignatureHelp(O){this.d.delete(O)}}class ge{constructor(O,$,G,Q,de){this.f=O,this.g=$,this.h=G,this.j=Q,this.k=de,this.d=new m.Cache("InlayHints"),this.e=new Map}async provideInlayHints(O,$,G){const Q=this.f.getDocument(O),de=k.Range.to($),be=await this.h.provideInlayHints(Q,de,G);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(G.isCancellationRequested)return;const Pe=this.d.add(be);this.e.set(Pe,new v.DisposableStore);const pe={hints:[],cacheId:Pe};for(let Ce=0;Ce<be.length;Ce++)this.l(be[Ce],de)&&pe.hints.push(this.m(be[Ce],[Pe,Ce]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),pe}async resolveInlayHint(O,$){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...O);if(!G)return;const Q=await this.h.resolveInlayHint(G,$);if(!!Q&&!!this.l(Q))return this.m(Q,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,$){return O.label.length===0||Array.isArray(O.label)&&O.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!($&&!$.contains(O.position))}m(O,$){const G=this.e.get($[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:$,tooltip:k.MarkdownString.fromStrict(O.tooltip),position:k.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(k.TextEdit.from),kind:O.kind&&k.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Q.label=O.label:Q.label=O.label.map(de=>{const be={label:de.value};return be.tooltip=k.MarkdownString.fromStrict(de.tooltip),A.Location.isLocation(de.location)&&(be.location=k.location.from(de.location)),de.command&&(be.command=this.g.toInternal(de.command,G)),be}),Q}}class ve{constructor(O,$){this.e=O,this.f=$,this.d=new m.Cache("DocumentLink")}async provideLinks(O,$){const G=this.e.getDocument(O),Q=await this.f.provideDocumentLinks(G,$);if(!(!Array.isArray(Q)||Q.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ve.g).map(k.DocumentLink.from)};{const de=this.d.add(Q),be={links:[],cacheId:de};for(let Pe=0;Pe<Q.length;Pe++){if(!ve.g(Q[Pe]))continue;const pe=k.DocumentLink.from(Q[Pe]);pe.cacheId=[de,Pe],be.links.push(pe)}return be}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,$){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...O);if(!G)return;const Q=await this.f.resolveDocumentLink(G,$);if(!(!Q||!ve.g(Q)))return k.DocumentLink.from(Q)}releaseLinks(O){this.d.delete(O)}}class De{constructor(O,$){this.d=O,this.e=$}async provideColors(O,$){const G=this.d.getDocument(O),Q=await this.e.provideDocumentColors(G,$);return Array.isArray(Q)?Q.map(be=>({color:k.Color.from(be.color),range:k.Range.from(be.range)})):[]}async provideColorPresentations(O,$,G){const Q=this.d.getDocument(O),de=k.Range.to($.range),be=k.Color.to($.color),Pe=await this.e.provideColorPresentations(be,{document:Q,range:de},G);if(!!Array.isArray(Pe))return Pe.map(k.ColorPresentation.from)}}class Re{constructor(O,$){this.d=O,this.e=$}async provideFoldingRanges(O,$,G){const Q=this.d.getDocument(O),de=await this.e.provideFoldingRanges(Q,$,G);if(!!Array.isArray(de))return de.map(k.FoldingRange.from)}}class ze{constructor(O,$,G){this.d=O,this.e=$,this.f=G}async provideSelectionRanges(O,$,G){const Q=this.d.getDocument(O),de=$.map(k.Position.to),be=await this.e.provideSelectionRanges(Q,de,G);if(!(0,R.isNonEmptyArray)(be))return[];if(be.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let pe=0;pe<de.length;pe++){const Ce=[];Pe.push(Ce);let ke=de[pe],je=be[pe];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(k.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Pe}}class se{constructor(O,$){this.f=O,this.g=$,this.d=new g.IdGenerator(""),this.e=new Map}async prepareSession(O,$,G){const Q=this.f.getDocument(O),de=k.Position.to($),be=await this.g.prepareCallHierarchy(Q,de,G);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(pe=>this.h(Pe,pe)):[this.h(Pe,be)]}async provideCallsTo(O,$,G){const Q=this.j(O,$);if(!Q)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(!!de)return de.map(be=>({from:this.h(O,be.from),fromRanges:be.fromRanges.map(Pe=>k.Range.from(Pe))}))}async provideCallsFrom(O,$,G){const Q=this.j(O,$);if(!Q)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(!!de)return de.map(be=>({to:this.h(O,be.to),fromRanges:be.fromRanges.map(Pe=>k.Range.from(Pe))}))}releaseSession(O){this.e.delete(O)}h(O,$){const G=this.e.get(O),Q=k.CallHierarchyItem.from($,O,G.size.toString(36));return G.set(Q._itemId,$),Q}j(O,$){return this.e.get(O)?.get($)}}class ue{constructor(O,$){this.f=O,this.g=$,this.d=new g.IdGenerator(""),this.e=new Map}async prepareSession(O,$,G){const Q=this.f.getDocument(O),de=k.Position.to($),be=await this.g.prepareTypeHierarchy(Q,de,G);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(pe=>this.h(Pe,pe)):[this.h(Pe,be)]}async provideSupertypes(O,$,G){const Q=this.j(O,$);if(!Q)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Q,G);if(!!de)return de.map(be=>this.h(O,be))}async provideSubtypes(O,$,G){const Q=this.j(O,$);if(!Q)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Q,G);if(!!de)return de.map(be=>this.h(O,be))}releaseSession(O){this.e.delete(O)}h(O,$){const G=this.e.get(O),Q=k.TypeHierarchyItem.from($,O,G.size.toString(36));return G.set(Q._itemId,$),Q}j(O,$){return this.e.get(O)?.get($)}}class he{constructor(O,$,G,Q){this.d=O,this.e=$,this.f=G,this.g=Q}async provideDocumentOnDropEdits(O,$,G,Q,de){const be=this.e.getDocument($),Pe=k.Position.to(G),pe=k.DataTransfer.toDataTransfer(Q,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,ke)).buffer),Ce=await this.f.provideDocumentDropEdits(be,Pe,pe,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?k.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ee{constructor(O,$){this.adapter=O,this.extension=$}}class ae{constructor(O,$,G,Q,de,be,Pe,pe){this.g=$,this.h=G,this.j=Q,this.k=de,this.l=be,this.m=Pe,this.n=pe,this.f=new Map,this.e=O.getProxy(T.MainContext.MainThreadLanguageFeatures)}o(O){return k.DocumentSelector.from(O,this.g)}p(O){return new A.Disposable(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return ae.d++}async s(O,$,G,Q,de,be=!1){const Pe=this.f.get(O);if(!Pe||!(Pe.adapter instanceof $))return Q;const pe=Date.now();be||this.l.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ce=G(Pe.adapter,Pe.extension);return Promise.resolve(Ce).catch(ke=>{(0,f.isCancellationError)(ke)||(this.l.error(`[${Pe.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Pe.extension.identifier,ke))}).finally(()=>{be||this.l.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),C.CancellationToken.isCancellationToken(de)?(0,h.raceCancellationError)(Ce,de):Ce}t(O,$){const G=this.q();return this.f.set(G,new ee(O,$)),G}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,$,G,Q){const de=this.t(new s(this.h,G),O),be=Q&&Q.label||ae.u(O);return this.e.$registerDocumentSymbolProvider(de,this.o($),be),this.p(de)}$provideDocumentSymbols(O,$,G){return this.s(O,s,Q=>Q.provideDocumentSymbols(c.URI.revive($),G),void 0,G)}registerCodeLensProvider(O,$,G){const Q=this.q(),de=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new ee(new i(this.h,this.j.converter,G),O)),this.e.$registerCodeLensSupport(Q,this.o($),de);let be=this.p(Q);if(de!==void 0){const Pe=G.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(de));be=A.Disposable.from(be,Pe)}return be}$provideCodeLenses(O,$,G){return this.s(O,i,Q=>Q.provideCodeLenses(c.URI.revive($),G),void 0,G)}$resolveCodeLens(O,$,G){return this.s(O,i,Q=>Q.resolveCodeLens($,G),void 0,void 0)}$releaseCodeLenses(O,$){this.s(O,i,G=>Promise.resolve(G.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(O,$,G){const Q=this.t(new u(this.h,G),O);return this.e.$registerDefinitionSupport(Q,this.o($)),this.p(Q)}$provideDefinition(O,$,G,Q){return this.s(O,u,de=>de.provideDefinition(c.URI.revive($),G,Q),[],Q)}registerDeclarationProvider(O,$,G){const Q=this.t(new r(this.h,G),O);return this.e.$registerDeclarationSupport(Q,this.o($)),this.p(Q)}$provideDeclaration(O,$,G,Q){return this.s(O,r,de=>de.provideDeclaration(c.URI.revive($),G,Q),[],Q)}registerImplementationProvider(O,$,G){const Q=this.t(new a(this.h,G),O);return this.e.$registerImplementationSupport(Q,this.o($)),this.p(Q)}$provideImplementation(O,$,G,Q){return this.s(O,a,de=>de.provideImplementation(c.URI.revive($),G,Q),[],Q)}registerTypeDefinitionProvider(O,$,G){const Q=this.t(new n(this.h,G),O);return this.e.$registerTypeDefinitionSupport(Q,this.o($)),this.p(Q)}$provideTypeDefinition(O,$,G,Q){return this.s(O,n,de=>de.provideTypeDefinition(c.URI.revive($),G,Q),[],Q)}registerHoverProvider(O,$,G,Q){const de=this.t(new o(this.h,G),O);return this.e.$registerHoverProvider(de,this.o($)),this.p(de)}$provideHover(O,$,G,Q){return this.s(O,o,de=>de.provideHover(c.URI.revive($),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(O,$,G,Q){const de=this.t(new p(this.h,G),O);return this.e.$registerEvaluatableExpressionProvider(de,this.o($)),this.p(de)}$provideEvaluatableExpression(O,$,G,Q){return this.s(O,p,de=>de.provideEvaluatableExpression(c.URI.revive($),G,Q),void 0,Q)}registerInlineValuesProvider(O,$,G,Q){const de=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new I(this.h,G),O);this.e.$registerInlineValuesProvider(be,this.o($),de);let Pe=this.p(be);if(de!==void 0){const pe=G.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(de));Pe=A.Disposable.from(Pe,pe)}return Pe}$provideInlineValues(O,$,G,Q,de){return this.s(O,I,be=>be.provideInlineValues(c.URI.revive($),G,Q,de),void 0,de)}registerDocumentHighlightProvider(O,$,G){const Q=this.t(new L(this.h,G),O);return this.e.$registerDocumentHighlightProvider(Q,this.o($)),this.p(Q)}$provideDocumentHighlights(O,$,G,Q){return this.s(O,L,de=>de.provideDocumentHighlights(c.URI.revive($),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(O,$,G){const Q=this.t(new z(this.h,G),O);return this.e.$registerLinkedEditingRangeProvider(Q,this.o($)),this.p(Q)}$provideLinkedEditingRanges(O,$,G,Q){return this.s(O,z,async de=>{const be=await de.provideLinkedEditingRanges(c.URI.revive($),G,Q);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?ae.w(be.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(O,$,G){const Q=this.t(new _(this.h,G),O);return this.e.$registerReferenceSupport(Q,this.o($)),this.p(Q)}$provideReferences(O,$,G,Q,de){return this.s(O,_,be=>be.provideReferences(c.URI.revive($),G,Q,de),void 0,de)}registerCodeActionProvider(O,$,G,Q){const de=new v.DisposableStore,be=this.t(new q(this.h,this.j.converter,this.k,G,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(be,this.o($),{providedKinds:Q?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:Q?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this.j.converter.toInternal(Pe.command,de)}))},ae.u(O),Boolean(G.resolveCodeAction)),de.add(this.p(be)),de}$provideCodeActions(O,$,G,Q,de){return this.s(O,q,be=>be.provideCodeActions(c.URI.revive($),G,Q,de),void 0,de)}$resolveCodeAction(O,$,G){return this.s(O,q,Q=>Q.resolveCodeAction($,G),void 0,void 0)}$releaseCodeActions(O,$){this.s(O,q,G=>Promise.resolve(G.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(O,$,G){const Q=this.t(new M(this.h,G),O);return this.e.$registerDocumentFormattingSupport(Q,this.o($),O.identifier,O.displayName||O.name),this.p(Q)}$provideDocumentFormattingEdits(O,$,G,Q){return this.s(O,M,de=>de.provideDocumentFormattingEdits(c.URI.revive($),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(O,$,G){const Q=this.t(new F(this.h,G),O);return this.e.$registerRangeFormattingSupport(Q,this.o($),O.identifier,O.displayName||O.name),this.p(Q)}$provideDocumentRangeFormattingEdits(O,$,G,Q,de){return this.s(O,F,be=>be.provideDocumentRangeFormattingEdits(c.URI.revive($),G,Q,de),void 0,de)}registerOnTypeFormattingEditProvider(O,$,G,Q){const de=this.t(new B(this.h,G),O);return this.e.$registerOnTypeFormattingSupport(de,this.o($),Q,O.identifier),this.p(de)}$provideOnTypeFormattingEdits(O,$,G,Q,de,be){return this.s(O,B,Pe=>Pe.provideOnTypeFormattingEdits(c.URI.revive($),G,Q,de,be),void 0,be)}registerWorkspaceSymbolProvider(O,$){const G=this.t(new U($,this.l),O);return this.e.$registerNavigateTypeSupport(G,typeof $.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(O,$,G){return this.s(O,U,Q=>Q.provideWorkspaceSymbols($,G),{symbols:[]},G)}$resolveWorkspaceSymbol(O,$,G){return this.s(O,U,Q=>Q.resolveWorkspaceSymbol($,G),void 0,void 0)}$releaseWorkspaceSymbols(O,$){this.s(O,U,G=>G.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(O,$,G){const Q=this.t(new H(this.h,G,this.l),O);return this.e.$registerRenameSupport(Q,this.o($),H.supportsResolving(G)),this.p(Q)}$provideRenameEdits(O,$,G,Q,de){return this.s(O,H,be=>be.provideRenameEdits(c.URI.revive($),G,Q,de),void 0,de)}$resolveRenameLocation(O,$,G,Q){return this.s(O,H,de=>de.resolveRenameLocation(c.URI.revive($),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(O,$,G,Q){const de=this.t(new V(this.h,G),O),be=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o($),Q,be);let Pe=this.p(de);if(be){const pe=G.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(be));Pe=A.Disposable.from(Pe,pe)}return Pe}$provideDocumentSemanticTokens(O,$,G,Q){return this.s(O,V,de=>de.provideDocumentSemanticTokens(c.URI.revive($),G,Q),null,Q)}$releaseDocumentSemanticTokens(O,$){this.s(O,V,G=>G.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,$,G,Q){const de=this.t(new x(this.h,G),O);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o($),Q),this.p(de)}$provideDocumentRangeSemanticTokens(O,$,G,Q){return this.s(O,x,de=>de.provideDocumentRangeSemanticTokens(c.URI.revive($),G,Q),null,Q)}registerCompletionItemProvider(O,$,G,Q){const de=this.t(new Y(this.h,this.j.converter,G,this.m,O),O);return this.e.$registerCompletionsProvider(de,this.o($),Q,Y.supportsResolving(G),`${O.identifier.value}(${Q.join("")})`),this.p(de)}$provideCompletionItems(O,$,G,Q,de){return this.s(O,Y,be=>be.provideCompletionItems(c.URI.revive($),G,Q,de),void 0,de)}$resolveCompletionItem(O,$,G){return this.s(O,Y,Q=>Q.resolveCompletionItem($,G),void 0,G)}$releaseCompletionItems(O,$){this.s(O,Y,G=>G.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(O,$,G){const Q=new te(O,this.h,G,this.j.converter),de=this.t(Q,O);return this.e.$registerInlineCompletionsSupport(de,this.o($),Q.supportsHandleDidShowCompletionItem),this.p(de)}$provideInlineCompletions(O,$,G,Q,de){return this.s(O,J,be=>be.provideInlineCompletions(c.URI.revive($),G,Q,de),void 0,de)}$handleInlineCompletionDidShow(O,$,G){this.s(O,J,async Q=>{Q.handleDidShowCompletionItem($,G)},void 0,void 0)}$freeInlineCompletionsList(O,$){this.s(O,J,async G=>{G.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(O,$,G,Q){const de=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,be=this.t(new Z(this.h,G),O);return this.e.$registerSignatureHelpProvider(be,this.o($),de),this.p(be)}$provideSignatureHelp(O,$,G,Q,de){return this.s(O,Z,be=>be.provideSignatureHelp(c.URI.revive($),G,Q,de),void 0,de)}$releaseSignatureHelp(O,$){this.s(O,Z,G=>G.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(O,$,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ge(this.h,this.j.converter,G,this.l,O),O);this.e.$registerInlayHintsProvider(de,this.o($),typeof G.resolveInlayHint=="function",Q,ae.u(O));let be=this.p(de);if(Q!==void 0){const Pe=G.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(Q));be=A.Disposable.from(be,Pe)}return be}$provideInlayHints(O,$,G,Q){return this.s(O,ge,de=>de.provideInlayHints(c.URI.revive($),G,Q),void 0,Q)}$resolveInlayHint(O,$,G){return this.s(O,ge,Q=>Q.resolveInlayHint($,G),void 0,G)}$releaseInlayHints(O,$){this.s(O,ge,G=>G.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(O,$,G){const Q=this.t(new ve(this.h,G),O);return this.e.$registerDocumentLinkProvider(Q,this.o($),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(O,$,G){return this.s(O,ve,Q=>Q.provideLinks(c.URI.revive($),G),void 0,G,$.scheme==="output")}$resolveDocumentLink(O,$,G){return this.s(O,ve,Q=>Q.resolveLink($,G),void 0,void 0,!0)}$releaseDocumentLinks(O,$){this.s(O,ve,G=>G.releaseLinks($),void 0,void 0,!0)}registerColorProvider(O,$,G){const Q=this.t(new De(this.h,G),O);return this.e.$registerDocumentColorProvider(Q,this.o($)),this.p(Q)}$provideDocumentColors(O,$,G){return this.s(O,De,Q=>Q.provideColors(c.URI.revive($),G),[],G)}$provideColorPresentations(O,$,G,Q){return this.s(O,De,de=>de.provideColorPresentations(c.URI.revive($),G,Q),void 0,Q)}registerFoldingRangeProvider(O,$,G){const Q=this.q(),de=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new ee(new Re(this.h,G),O)),this.e.$registerFoldingRangeProvider(Q,this.o($),O.identifier,de);let be=this.p(Q);if(de!==void 0){const Pe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));be=A.Disposable.from(be,Pe)}return be}$provideFoldingRanges(O,$,G,Q){return this.s(O,Re,de=>de.provideFoldingRanges(c.URI.revive($),G,Q),void 0,Q)}registerSelectionRangeProvider(O,$,G){const Q=this.t(new ze(this.h,G,this.l),O);return this.e.$registerSelectionRangeProvider(Q,this.o($)),this.p(Q)}$provideSelectionRanges(O,$,G,Q){return this.s(O,ze,de=>de.provideSelectionRanges(c.URI.revive($),G,Q),[],Q)}registerCallHierarchyProvider(O,$,G){const Q=this.t(new se(this.h,G),O);return this.e.$registerCallHierarchyProvider(Q,this.o($)),this.p(Q)}$prepareCallHierarchy(O,$,G,Q){return this.s(O,se,de=>Promise.resolve(de.prepareSession(c.URI.revive($),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(O,$,G,Q){return this.s(O,se,de=>de.provideCallsTo($,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(O,$,G,Q){return this.s(O,se,de=>de.provideCallsFrom($,G,Q),void 0,Q)}$releaseCallHierarchy(O,$){this.s(O,se,G=>Promise.resolve(G.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(O,$,G){const Q=this.t(new ue(this.h,G),O);return this.e.$registerTypeHierarchyProvider(Q,this.o($)),this.p(Q)}$prepareTypeHierarchy(O,$,G,Q){return this.s(O,ue,de=>Promise.resolve(de.prepareSession(c.URI.revive($),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(O,$,G,Q){return this.s(O,ue,de=>de.provideSupertypes($,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(O,$,G,Q){return this.s(O,ue,de=>de.provideSubtypes($,G,Q),void 0,Q)}$releaseTypeHierarchy(O,$){this.s(O,ue,G=>Promise.resolve(G.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(O,$,G){const Q=this.q();return this.f.set(Q,new ee(new he(this.e,this.h,G,Q),O)),this.e.$registerDocumentOnDropEditProvider(Q,this.o($)),this.p(Q)}$provideDocumentOnDropEdits(O,$,G,Q,de,be){return this.s(O,he,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits($,c.URI.revive(G),Q,de,be)),void 0,void 0)}registerDocumentPasteEditProvider(O,$,G,Q){const de=this.q();return this.f.set(de,new ee(new N(this.e,this.h,G,de),O)),this.e.$registerPasteEditProvider(de,this.o($),!!G.prepareDocumentPaste,Q.pasteMimeTypes),this.p(de)}$prepareDocumentPaste(O,$,G,Q,de){return this.s(O,N,be=>be.prepareDocumentPaste(c.URI.revive($),G,Q,de),void 0,de)}$providePasteEdits(O,$,G,Q,de,be){return this.s(O,N,Pe=>Pe.providePasteEdits($,c.URI.revive(G),Q,de,be),void 0,be)}static w(O){return{pattern:O.source,flags:(0,S.regExpFlags)(O)}}static y(O){return{decreaseIndentPattern:ae.w(O.decreaseIndentPattern),increaseIndentPattern:ae.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ae.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ae.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:ae.w(O.beforeText),afterText:O.afterText?ae.w(O.afterText):void 0,previousLineText:O.previousLineText?ae.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(ae.z)}setLanguageConfiguration(O,$,G){const{wordPattern:Q}=G;if(Q&&(0,S.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor($,Q):this.h.setWordDefinitionFor($,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const de=this.q(),be={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ae.w(G.wordPattern):void 0,indentationRules:G.indentationRules?ae.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ae.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this.e.$setLanguageConfiguration(de,$,be),this.p(de)}$setWordDefinitions(O){for(const $ of O)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=ae,ae.d=0}),define(Se[256],ye([1,0,5,14,7,42,18,6]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,P,E,C){this.c=P,this.d=E,this.e=C,this.b=[],this.f=0,this.g=new Set,this.a=R.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this.b=R}async getLanguages(){return this.b.slice(0)}async changeLanguage(R,P){await this.a.$changeLanguage(R,P);const E=this.c.getDocumentData(R);if(!E)throw new Error(`document '${R.toString()}' NOT found`);return E.document}async tokenAtPosition(R,P){const E=R.version,C=t.Position.from(P),v=await this.a.$tokensAtPosition(R.uri,C),d={type:k.StandardTokenType.Other,range:R.getWordRangeAtPosition(P)??new k.Range(P.line,P.character,P.line,P.character)};if(!v)return d;const g={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!g.range.contains(P)||E!==R.version?d:g}createLanguageStatusItem(R,P,E){const C=this.f++,v=this.a,d=this.g,g=`${R.identifier.value}/${P}`;if(d.has(g))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);d.add(g);const m={selector:E,id:P,name:R.displayName??R.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let w;const f=new T.DisposableStore,h=()=>{w?.dispose(),w=(0,D.disposableTimeout)(()=>{f.clear(),this.a.$setLanguageStatus(C,{id:g,name:m.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(m.selector,this.e),label:m.text,detail:m.detail??"",severity:m.severity===k.LanguageStatusSeverity.Error?A.default.Error:m.severity===k.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:m.command&&this.d.toInternal(m.command,f),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},b={dispose(){f.dispose(),w?.dispose(),v.$removeLanguageStatus(C),d.delete(g)},get id(){return m.id},get name(){return m.name},set name(s){m.name=s,h()},get selector(){return m.selector},set selector(s){m.selector=s,h()},get text(){return m.text},set text(s){m.text=s,h()},get detail(){return m.detail},set detail(s){m.detail=s,h()},get severity(){return m.severity},set severity(s){m.severity=s,h()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(s){m.accessibilityInformation=s,h()},get command(){return m.command},set command(s){m.command=s,h()},get busy(){return m.busy},set busy(s){m.busy=s,h()}};return h(),b}}e.ExtHostLanguages=S}),define(Se[95],ye([1,0,12,8,2,3,13,5,25,16]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(E,C,v){this.f=v,this.d=new Map,this.a=C.getProxy(T.MainContext.MainThreadLocalization),this.b=E.environment.appLanguage,this.c=this.b===c.LANGUAGE_DEFAULT}getMessage(E,C){const{message:v,args:d,comment:g}=C;if(this.c)return(0,t.format2)(v,d??{});let m=v;g&&g.length>0&&(m+=`/${Array.isArray(g)?g.join():g}`);const w=this.d.get(E)?.contents[m];return w||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${m}`),(0,t.format2)(w??v,d??{})}getBundle(E){return this.d.get(E)?.contents}getBundleUri(E){return this.d.get(E)?.uri}async initializeLocalizedMessages(E){if(this.c||!E.l10n&&!E.isBuiltin||this.d.has(E.identifier.value))return;let C;const v=await this.g(E);if(!v){this.f.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(v),g=JSON.parse(d);C=E.isBuiltin?g.contents?.bundle:g}catch(d){this.f.error(`Failed to load translations for ${E.identifier.value} from ${v}: ${d.message}`);return}C&&this.d.set(E.identifier.value,{contents:C,uri:v})}async g(E){if(E.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(E.identifier.value);return k.URI.revive(C)}return E.l10n?k.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.b}.json`):void 0}};R=qe([We(0,S.IExtHostInitDataService),We(1,y.IExtHostRpcService),We(2,D.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Se[139],ye([1,0,13,5,25,16,2,4,11]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends c.AbstractLoggerService{constructor(E,C){super(C.logLevel,T.Event.None),this.g=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,C){C?this.setLevel(D.URI.revive(C),E):(0,S.isUndefined)(E)||this.setLevel(E)}f(E,C,v){return new R(this.g,E,C,v)}};y=qe([We(0,A.IExtHostRpcService),We(1,k.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class R extends c.AbstractMessageLogger{constructor(E,C,v,d){super(d?.always),this.m=E,this.n=C,this.k=!1,this.l=[],this.setLevel(v),this.m.$createLogger(C,d).then(()=>{this.r(this.l),this.k=!0})}g(E,C){const v=[[E,C]];this.k?this.r(v):this.l.push(...v)}r(E){this.m.$log(this.n,E)}}}),define(Se[257],ye([1,0,5,13,26]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(T){return T&&T.title}let D=class{constructor(S,y){this.b=y,this.a=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,y,R,P,E){const C={source:{identifier:S.identifier,label:S.displayName||S.name}};let v;typeof P=="string"||A(P)?v=[P,...E]:(C.modal=P?.modal,C.useCustom=P?.useCustom,C.detail=P?.detail,v=E),C.useCustom&&(0,k.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let g=0;g<v.length;g++){const m=v[g];if(typeof m=="string")d.push({title:m,handle:g,isCloseAffordance:!1});else if(typeof m=="object"){const{title:w,isCloseAffordance:f}=m;d.push({title:w,isCloseAffordance:!!f,handle:g})}else this.b.warn("Invalid message item:",m)}return this.a.$showMessage(y,R,C,d).then(g=>{if(typeof g=="number")return v[g]})}};D=qe([We(1,t.ILogService)],D),e.ExtHostMessageService=D}),define(Se[258],ye([1,0,22,4,6,28,8,11,2,68,5,39,14,7,57,233,135]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class m{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(f=>f.apiEditor)}constructor(f,h,b,s){this.q=b,this.r=s,this.f=new Map,this.g=new A.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=f.getProxy(R.MainContext.MainThreadNotebook),this.c=f.getProxy(R.MainContext.MainThreadNotebookDocuments),this.d=f.getProxy(R.MainContext.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===13){const l=i.notebookEditor?.notebookUri,u=i.cell.handle,a=this.g.get(l)?.getCell(u);if(a)return a.apiCell}if(i&&i.$mid===14){const l=i.uri,u=this.g.get(l);if(u)return u.apiNotebook}return i}}),m.x(h)}getEditorById(f){const h=this.h.get(f);if(!h)throw new Error(`unknown text editor: ${f}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(f){for(const[h,b]of this.h)if(b.apiEditor===f)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(f,h){const b=this.g.get(f);if(!b&&!h)throw new Error(`NO notebook document for '${f}'`);return b}static s(f,h){if(!h)return;const b=h.filenamePattern.map(s=>E.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(h.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:h.displayName,filenamePattern:b,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,h,b){const s=m.a++,i=typeof b.onDidChangeCellStatusBarItems=="function"?m.a++:void 0;this.f.set(s,b),this.b.$registerNotebookCellStatusBarItemProvider(s,i,h);let l;return i!==void 0&&(l=b.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(i))),new C.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,i),l?.dispose()})}async createNotebookDocument(f){const h=await this.c.$tryCreateNotebook({viewType:f.viewType,content:f.content&&E.NotebookData.from(f.content)});return S.URI.revive(h)}async openNotebookDocument(f){const h=this.g.get(f);if(h)return h.apiNotebook;const b=await this.c.$tryOpenNotebook(f),s=this.g.get(S.URI.revive(b));return(0,T.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(f,h){S.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let b;typeof h=="object"?b={position:E.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(E.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:b={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(f.uri,f.notebookType,b),i=s&&this.h.get(s)?.apiEditor;if(i)return i;throw s?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,h,b,s){const i=this.f.get(f),l=S.URI.revive(h),u=this.g.get(l);if(!u||!i)return;const r=u.getCellFromIndex(b);if(!r)return;const a=await i.provideCellStatusBarItems(r.apiCell,s);if(!a)return;const n=new k.DisposableStore,o=this.p.add([n]),I=(Array.isArray(a)?a:[a]).map(L=>E.NotebookStatusBarItem.from(L,this.i,n));return{cacheId:o,items:I}}$releaseNotebookCellStatusBarItems(f){this.p.delete(f)}registerNotebookSerializer(f,h,b,s,i){if((0,D.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const l=this.t++;return this.u.set(l,b),this.b.$registerNotebookSerializer(l,{id:f.identifier,location:f.extensionLocation},h,E.NotebookDocumentContentOptions.from(s),m.s(f,i)),(0,k.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(l)})}async $dataToNotebook(f,h,b){const s=this.u.get(f);if(!s)throw new Error("NO serializer found");const i=await s.deserializeNotebook(h.buffer,b);return new v.SerializableObjectWithBuffers(E.NotebookData.from(i))}async $notebookToData(f,h,b){const s=this.u.get(f);if(!s)throw new Error("NO serializer found");const i=await s.serializeNotebook(E.NotebookData.to(h.value),b);return c.VSBuffer.wrap(i)}w(f,h,b){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const s=new g.ExtHostNotebookEditor(h,this.d,f,b.visibleRanges.map(E.NotebookRange.to),b.selections.map(E.NotebookRange.to),typeof b.viewColumn=="number"?E.ViewColumn.to(b.viewColumn):void 0);this.h.set(h,s)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const b of f.value.removedDocuments){const s=S.URI.revive(b),i=this.g.get(s);i&&(i.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(l=>l.document.uri)}),this.n.fire(i.apiNotebook));for(const l of this.h.values())l.notebookData.uri.toString()===s.toString()&&this.h.delete(l.id)}if(f.value.addedDocuments){const b=[];for(const s of f.value.addedDocuments){const i=S.URI.revive(s.uri);if(this.g.has(i))throw new Error(`adding EXISTING notebook ${i} `);const l=new d.ExtHostNotebookDocument(this.c,this.q,this.r,i,s);b.push(...s.cells.map(u=>d.ExtHostCell.asModelAddData(l.apiNotebook,u))),this.g.get(i)?.dispose(),this.g.set(i,l),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(l.apiNotebook)}}if(f.value.addedEditors)for(const b of f.value.addedEditors){if(this.h.has(b.id))return;const s=S.URI.revive(b.documentUri),i=this.g.get(s);i&&this.w(i,b.id,b)}const h=[];if(f.value.removedEditors)for(const b of f.value.removedEditors){const s=this.h.get(b);s&&(this.h.delete(b),this.k?.id===s.id&&(this.k=void 0),h.push(s))}if(f.value.visibleEditors){this.l=f.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const b=new Set;this.l.forEach(s=>b.add(s.id));for(const s of this.h.values()){const i=b.has(s.id);s._acceptVisibility(i)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this.k=void 0:f.value.newActiveEditor&&(this.k=this.h.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(f){const h=P.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new P.ApiCommandArgument("data","Bytes to convert to data",i=>i instanceof Uint8Array,i=>c.VSBuffer.wrap(i))],new P.ApiCommandResult("Notebook Data",i=>E.NotebookData.to(i.value))),s=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",i=>!0,i=>new v.SerializableObjectWithBuffers(E.NotebookData.from(i)))],new P.ApiCommandResult("Bytes",i=>i.buffer));f.registerApiCommand(b),f.registerApiCommand(s)}}e.ExtHostNotebookController=m,m.a=0}),define(Se[259],ye([1,0,17,18,21,4,6,28,2,27,13,68,5,39,14,7,92,220,26,57]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let h=class{constructor(r,a,n,o,p){this.k=a,this.l=n,this.m=o,this.n=p,this.b=new T.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=r.getProxy(E.MainContext.MainThreadNotebookKernels);const I=new C.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new C.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const z=this.l.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:z}}else if(L&&"notebookEditor"in L){const z=this.l.getIdByEditor(L.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return L})],C.ApiCommandResult.Void);this.m.registerApiCommand(I)}createNotebookController(r,a,n,o,p,I){for(const J of this.h.values())if(J.controller.id===a&&y.ExtensionIdentifier.equals(r.identifier,J.extensionId))throw new Error(`notebook controller with id '${a}' ALREADY exist`);const L=this.i++,z=this;this.n.trace(`NotebookController[${L}], CREATED by ${r.identifier.value}, ${a}`);const _=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${r.identifier}'`);let q=!1;const N=new D.DisposableStore,M=new A.Emitter,F=new A.Emitter,B={id:l(r.identifier,a),notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:o||r.identifier.value,preloads:I?I.map(v.NotebookRendererScript.from):[]};let U=p??_,H;this.a.$addKernel(L,B).catch(J=>{console.log(J),q=!0});let X=0;const V=()=>{if(q)return;const J=++X;Promise.resolve().then(()=>{J===X&&this.a.$updateKernel(L,B)})},x=new T.ResourceMap,Y={get id(){return a},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return B.label},set label(J){B.label=J??r.displayName??r.name,V()},get detail(){return B.detail??""},set detail(J){B.detail=J,V()},get description(){return B.description??""},set description(J){B.description=J,V()},get kind(){return(0,w.checkProposedApiEnabled)(r,"notebookControllerKind"),B.kind??""},set kind(J){(0,w.checkProposedApiEnabled)(r,"notebookControllerKind"),B.kind=J,V()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(J){B.supportedLanguages=J,V()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(J){B.supportsExecutionOrder=J,V()},get rendererScripts(){return B.preloads?B.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(J){U=J??_},get interruptHandler(){return H},set interruptHandler(J){H=J,B.supportsInterrupt=Boolean(J),V()},createNotebookCellExecution(J){if(q)throw new Error("notebook controller is DISPOSED");if(!x.has(J.notebook.uri))throw z.n.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${J.notebook.uri.toString()}`);return z._createNotebookCellExecution(J,l(r.identifier,this.id))},dispose:()=>{q||(this.n.trace(`NotebookController[${L}], DISPOSED`),q=!0,this.h.delete(L),N.dispose(),M.dispose(),F.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(J,te){te===d.NotebookControllerAffinity2.Hidden&&(0,w.checkProposedApiEnabled)(r,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(L,J.uri,te)},onDidReceiveMessage:F.event,postMessage(J,te){return(0,w.checkProposedApiEnabled)(r,"notebookMessaging"),z.a.$postMessage(L,te&&z.l.getIdByEditor(te),J)},asWebviewUri(J){return(0,w.checkProposedApiEnabled)(r,"notebookMessaging"),(0,g.asWebviewUri)(J,z.k.remote)}};return this.h.set(L,{extensionId:r.identifier,controller:Y,onDidReceiveMessage:F,onDidChangeSelection:M,associatedNotebooks:x}),Y}getIdByController(r){for(const[a,n]of this.h)if(n.controller===r)return l(n.extensionId,r.id);return null}createNotebookControllerDetectionTask(r,a){const n=this.d++,o=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${r.identifier.value}`),this.a.$addKernelDetectionTask(n,a);const p={dispose:()=>{this.c.delete(n),o.a.$removeKernelDetectionTask(n)}};return this.c.set(n,p),p}registerKernelSourceActionProvider(r,a,n){const o=this.f++,p=this;return this.e.set(o,n),this.n.trace(`NotebookKernelSourceActionProvider[${o}], CREATED by ${r.identifier.value}`),this.a.$addKernelSourceActionProvider(o,a),{dispose:()=>{this.e.delete(o),p.a.$removeKernelSourceActionProvider(o)}}}async $provideKernelSourceActions(r,a){const n=this.e.get(r);if(n){const o=new D.DisposableStore;return this.g.add([o]),(await n.provideNotebookKernelSourceActions(a)??[]).map(I=>v.NotebookKernelSourceAction.from(I,this.m.converter,o))}return[]}$acceptNotebookAssociation(r,a,n){const o=this.h.get(r);if(o){const p=this.l.getNotebookDocument(S.URI.revive(a));n?o.associatedNotebooks.set(p.uri,!0):o.associatedNotebooks.delete(p.uri),this.n.trace(`NotebookController[${r}] ASSOCIATE notebook`,p.uri.toString(),n),o.onDidChangeSelection.fire({selected:n,notebook:p.apiNotebook})}}async $executeCells(r,a,n){const o=this.h.get(r);if(!o)return;const p=this.l.getNotebookDocument(S.URI.revive(a)),I=[];for(const L of n){const z=p.getCell(L);z&&I.push(z.apiCell)}try{this.n.trace(`NotebookController[${r}] EXECUTE cells`,p.uri.toString(),I.length),await o.controller.executeHandler.call(o.controller,I,p.apiNotebook,o.controller)}catch(L){this.n.error(`NotebookController[${r}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(r,a,n){const o=this.h.get(r);if(!o)return;const p=this.l.getNotebookDocument(S.URI.revive(a));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,p.apiNotebook);else for(const I of n){const L=p.getCell(I);L&&this.b.get(L.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,a,n){const o=this.h.get(r);if(!o)return;const p=this.l.getEditorById(a);o.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:n}))}$cellExecutionChanged(r,a,n){const p=this.l.getNotebookDocument(S.URI.revive(r)).getCell(a);if(p){const I=n?v.NotebookCellExecutionState.to(n):d.NotebookCellExecutionState.Idle;I!==void 0&&this.j.fire({cell:p.apiCell,state:I})}}_createNotebookCellExecution(r,a){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this.l.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!o)throw new Error("invalid cell");if(this.b.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const p=new s(a,o,this.a);this.b.set(o.uri,p);const I=p.onDidChangeState(()=>{p.state===b.Resolved&&(p.dispose(),I.dispose(),this.b.delete(o.uri))});return p.asApiObject()}};h=qe([We(4,R.ILogService)],h),e.ExtHostNotebookKernels=h;var b;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(b||(b={}));class s extends D.Disposable{get state(){return this.f}constructor(r,a,n){super(),this.j=a,this.k=n,this.b=s.a++,this.c=new A.Emitter,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new k.CancellationTokenSource),this.h=new i(10,o=>this.m(o)),this.i=a.internalMetadata.executionOrder,this.k.$createExecution(this.b,r,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(r){await this.h.addItem(r)}async m(r){const a=Array.isArray(r)?r:[r];return this.k.$updateExecution(this.b,new f.SerializableObjectWithBuffers(a))}n(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(r){let a=this.j;if(r&&(a=this.j.notebook.getCellFromApiCell(r)),!a)throw new Error("INVALID cell");return a.handle}s(r){return r.map(a=>{const n=d.NotebookCellOutput.ensureUniqueMimeTypes(a.items,!0);return n===a.items?v.NotebookCellOutput.from(a):v.NotebookCellOutput.from({items:n,id:a.id,metadata:a.metadata})})}async t(r,a,n){const o=this.r(a),p=this.s((0,c.asArray)(r));return this.l({editType:m.CellExecutionUpdateType.Output,cellHandle:o,append:n,outputs:p})}async w(r,a,n){return r=d.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(r),!0),this.l({editType:m.CellExecutionUpdateType.OutputItems,items:r.map(v.NotebookCellOutputItem.from),outputId:a.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r.g.token},get cell(){return r.j.apiCell},get executionOrder(){return r.i},set executionOrder(n){r.i=n,r.m([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:r.i}])},start(n){if(r.f===b.Resolved||r.f===b.Started)throw new Error("Cannot call start again");r.f=b.Started,r.c.fire(),r.m({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,o){if(r.f===b.Resolved)throw new Error("Cannot call resolve twice");r.f=b.Resolved,r.c.fire(),r.h.flush(),r.k.$completeExecution(r.b,new f.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:n}))},clearOutput(n){return r.n(),r.t([],n,!1)},appendOutput(n,o){return r.n(),r.t(n,o,!0)},replaceOutput(n,o){return r.n(),r.t(n,o,!1)},appendOutputItems(n,o){return r.n(),r.w(n,o,!0)},replaceOutputItems(n,o){return r.n(),r.w(n,o,!1)}})}}s.a=0;class i{constructor(r,a){this.d=r,this.e=a,this.a=[],this.b=Date.now()}addItem(r){return this.a.push(r),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const r=this.c;this.c=void 0;const a=this.a;return this.a=[],this.e(a).finally(()=>r.complete())}}function l(u,r){return`${u.value}/${r}`}e.createKernelId=l}),define(Se[260],ye([1,0,4,5,135]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(T,S){this.c=S,this.a=new Map,this.b=T.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,y){const R=this.c.getEditorById(T);this.a.get(S)?.fire({editor:R.apiEditor,message:y})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(R=>R.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(R,P,E)=>this.d(S).event(R,P,E),postMessage:(R,P)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,P]=[P,R]);const E=P&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(E?.id,S,R)}}}d(T){let S=this.a.get(T);return S||(S=new c.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(T)}}),this.a.set(T,S),S)}}e.ExtHostNotebookRenderers=A}),define(Se[261],ye([1,0,6,2,26,5]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class D{constructor(S){this.b=new Map,this.a=S.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,y,R){if((0,k.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(y))throw new Error(`Handler with id '${y}' already registered`);return this.b.set(y,R),this.a.$registerProfileContentHandler(y,R.name,S.identifier.value),(0,c.toDisposable)(()=>{this.b.delete(y),this.a.$unregisterProfileContentHandler(y)})}async $saveProfile(S,y,R,P){const E=this.b.get(S);if(!E)throw new Error(`Unknown handler with id: ${S}`);return E.saveProfile(y,R,P)}async $readProfile(S,y,R){const P=this.b.get(S);if(!P)throw new Error(`Unknown handler with id: ${S}`);return P.readProfile(t.URI.revive(y),R)}}e.ExtHostProfileContentHandlers=D}),define(Se[262],ye([1,0,21,4,6,5,2,7,10,17,42,89]),function(ne,e,c,t,k,A,D,T,S,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(C,v,d){const g=C.getProxy(A.MainContext.MainThreadQuickOpen);class m{constructor(r,a){this.e=new Map,this.f=0,this.a=r,this.b=a}showQuickPick(r,a,n=c.CancellationToken.None){this.c=void 0;const o=Promise.resolve(r),p=++this.f,I=g.$show(p,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},n),L={},z=I.then(()=>L);return Promise.race([z,o]).then(_=>{if(_!==L)return o.then(q=>{const N=[];for(let M=0;M<q.length;M++){const F=q[M];typeof F=="string"?N.push({label:F,handle:M}):F.kind===T.QuickPickItemKind.Separator?N.push({type:"separator",label:F.label}):N.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:M})}return a&&typeof a.onDidSelectItem=="function"&&(this.c=M=>{a.onDidSelectItem(q[M])}),g.$setItems(p,N),I.then(M=>{if(typeof M=="number")return q[M];if(Array.isArray(M))return M.map(F=>q[F])})})}).then(void 0,_=>{if(!(0,S.isCancellationError)(_))return g.$setError(p,_),Promise.reject(_)})}$onItemSelected(r){this.c?.(r)}showInput(r,a=c.CancellationToken.None){return this.d=r?.validateInput,g.$input(r,typeof this.d=="function",a).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(r){if(!this.d)return;const a=await this.d(r);if(!a||typeof a=="string")return a;let n;switch(a.severity){case T.InputBoxValidationSeverity.Info:n=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:n=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:n=R.default.Error;break;default:n=a.message?R.default.Error:R.default.Ignore;break}return{content:a.message,severity:n}}async showWorkspaceFolderPick(r,a=c.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!n)return;const o=await this.a.getWorkspaceFolders2();if(!!o)return o.find(p=>p.uri.toString()===n.uri.toString())}createQuickPick(r){const a=new i(r,()=>this.e.delete(a._id));return this.e.set(a._id,a),a}createInputBox(r){const a=new l(r,()=>this.e.delete(a._id));return this.e.set(a._id,a),a}$onDidChangeValue(r,a){this.e.get(r)?._fireDidChangeValue(a)}$onDidAccept(r){this.e.get(r)?._fireDidAccept()}$onDidChangeActive(r,a){const n=this.e.get(r);n instanceof i&&n._fireDidChangeActive(a)}$onDidChangeSelection(r,a){const n=this.e.get(r);n instanceof i&&n._fireDidChangeSelection(a)}$onDidTriggerButton(r,a){this.e.get(r)?._fireDidTriggerButton(a)}$onDidTriggerItemButton(r,a,n){const o=this.e.get(r);o instanceof i&&o._fireDidTriggerItemButton(a,n)}$onDidHide(r){this.e.get(r)?._fireDidHide()}}class w{constructor(r,a){this.x=r,this.y=a,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(r){this.b=r,this.z({title:r})}get step(){return this.c}set step(r){this.c=r,this.z({step:r})}get totalSteps(){return this.d}set totalSteps(r){this.d=r,this.z({totalSteps:r})}get enabled(){return this.g}set enabled(r){this.g=r,this.z({enabled:r})}get busy(){return this.j}set busy(r){this.j=r,this.z({busy:r})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(r){this.k=r,this.z({ignoreFocusOut:r})}get value(){return this.l}set value(r){this.l=r,this.z({value:r})}get placeholder(){return this.m}set placeholder(r){this.m=r,this.z({placeholder:r})}get buttons(){return this.n}set buttons(r){this.n=r.slice(),this.o.clear(),r.forEach((a,n)=>{const o=a===T.QuickInputButtons.Back?-1:n;this.o.set(o,a)}),this.z({buttons:r.map((a,n)=>({...s(a),tooltip:a.tooltip,handle:a===T.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(r){this.l=r,this.q.fire(r)}_fireDidTriggerButton(r){const a=this.o.get(r);a&&this.r.fire(a)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),g.$dispose(this._id))}z(r){if(!this.v){for(const a of Object.keys(r)){const n=r[a];this.u[a]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){g.$createOrUpdate(this.u),this.u={id:this._id}}}w.a=1;function f(u){if(u instanceof T.ThemeIcon)return{id:u.id};const r=b(u),a=h(u);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof a=="string"?D.URI.file(a):a}}function h(u){return typeof u=="object"&&"light"in u?u.light:u}function b(u){return typeof u=="object"&&"dark"in u?u.dark:u}function s(u){const r=f(u.iconPath);let a,n;return"id"in r?n=P.ThemeIcon.asClassName(r):a=r,{iconPath:a,iconClass:n}}class i extends w{constructor(r,a){super(r.identifier,a),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(r){this.B=r.slice(),this.C.clear(),this.D.clear(),r.forEach((n,o)=>{this.C.set(o,n),this.D.set(n,o)});const a=[];for(let n=0;n<r.length;n++){const o=r[n];o.kind===T.QuickPickItemKind.Separator?a.push({type:"separator",label:o.label}):a.push({handle:n,label:o.label,description:o.description,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow,buttons:o.buttons?.map((p,I)=>({...s(p),tooltip:p.tooltip,handle:I}))})}this.z({items:a})}get canSelectMany(){return this.E}set canSelectMany(r){this.E=r,this.z({canSelectMany:r})}get matchOnDescription(){return this.F}set matchOnDescription(r){this.F=r,this.z({matchOnDescription:r})}get matchOnDetail(){return this.G}set matchOnDetail(r){this.G=r,this.z({matchOnDetail:r})}get sortByLabel(){return this.H}set sortByLabel(r){this.H=r,this.z({sortByLabel:r})}get keepScrollPosition(){return this.I}set keepScrollPosition(r){this.I=r,this.z({keepScrollPosition:r})}get activeItems(){return this.J}set activeItems(r){this.J=r.filter(a=>this.D.has(a)),this.z({activeItems:this.J.map(a=>this.D.get(a))})}get selectedItems(){return this.L}set selectedItems(r){this.L=r.filter(a=>this.D.has(a)),this.z({selectedItems:this.L.map(a=>this.D.get(a))})}_fireDidChangeActive(r){const a=(0,y.coalesce)(r.map(n=>this.C.get(n)));this.J=a,this.K.fire(a)}_fireDidChangeSelection(r){const a=(0,y.coalesce)(r.map(n=>this.C.get(n)));this.L=a,this.M.fire(a)}_fireDidTriggerItemButton(r,a){const n=this.C.get(r);if(!n||!n.buttons||!n.buttons.length)return;const o=n.buttons[a];o&&this.N.fire({button:o,item:n})}}class l extends w{constructor(r,a){super(r.identifier,a),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(r){this.B=r,this.z({password:r})}get prompt(){return this.C}set prompt(r){this.C=r,this.z({prompt:r})}get valueSelection(){return this.D}set valueSelection(r){this.D=r,this.z({valueSelection:r})}get validationMessage(){return this.E}set validationMessage(r){this.E=r,r?typeof r=="string"?this.z({validationMessage:r,severity:R.default.Error}):this.z({validationMessage:r.message,severity:r.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new m(v,d)}e.createExtHostQuickOpen=E});var Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c};define(Se[263],ye([1,0,2,4,60,6,18,5,17,108,13,27,89,14,26]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v){"use strict";var d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(o){if(o)return typeof o.iconPath=="string"?c.URI.file(o.iconPath):c.URI.isUri(o.iconPath)||E.ThemeIcon.isThemeIcon(o.iconPath)?o.iconPath:void 0}function w(o,p){if(!o.iconPath&&!p.iconPath)return 0;if(o.iconPath){if(!p.iconPath)return 1}else return-1;const I=typeof o.iconPath=="string"?o.iconPath:c.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id,L=typeof p.iconPath=="string"?p.iconPath:c.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,y.comparePaths)(I,L)}function f(o,p){let I=0;if(o.strikeThrough!==p.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==p.faded)return o.faded?1:-1;if(o.tooltip!==p.tooltip)return(o.tooltip||"").localeCompare(p.tooltip||"");if(I=w(o,p),I!==0)return I;if(o.light&&p.light)I=w(o.light,p.light);else{if(o.light)return 1;if(p.light)return-1}if(I!==0)return I;if(o.dark&&p.dark)I=w(o.dark,p.dark);else{if(o.dark)return 1;if(p.dark)return-1}return I}function h(o,p){if(o.command!==p.command)return o.command<p.command?-1:1;if(o.title!==p.title)return o.title<p.title?-1:1;if(o.tooltip!==p.tooltip){if(o.tooltip!==void 0&&p.tooltip!==void 0)return o.tooltip<p.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(o.arguments===p.arguments)return 0;if(o.arguments)if(p.arguments){if(o.arguments.length!==p.arguments.length)return o.arguments.length-p.arguments.length}else return 1;else return-1;for(let I=0;I<o.arguments.length;I++){const L=o.arguments[I],z=p.arguments[I];if(L!==z)return L<z?-1:1}return 0}function b(o,p){let I=(0,y.comparePaths)(o.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(I!==0)return I;if(o.command&&p.command)I=h(o.command,p.command);else{if(o.command)return 1;if(p.command)return-1}if(I!==0)return I;if(o.decorations&&p.decorations)I=f(o.decorations,p.decorations);else{if(o.decorations)return 1;if(p.decorations)return-1}return I}function s(o,p){for(let I=0;I<o.length;I++)if(o[I]!==p[I])return!1;return!0}function i(o,p){return o.command===p.command&&o.title===p.title&&o.tooltip===p.tooltip&&(o.arguments&&p.arguments?s(o.arguments,p.arguments):o.arguments===p.arguments)}function l(o,p){return(0,S.equals)(o,p,i)}class u{get value(){return this.d}set value(p){p=p??"",Fe(this,d,"f").$setInputBoxValue(this.l,p),this.m(p)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(p){Fe(this,d,"f").$setInputBoxPlaceholder(this.l,p),this.f=p}get validateInput(){return(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(p){if((0,v.checkProposedApiEnabled)(this.k,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=p,Fe(this,d,"f").$setValidationProviderIsEnabled(this.l,!!p)}get enabled(){return this.h}set enabled(p){p=!!p,this.h!==p&&(this.h=p,Fe(this,d,"f").$setInputBoxEnablement(this.l,p))}get visible(){return this.j}set visible(p){p=!!p,this.j!==p&&(this.j=p,Fe(this,d,"f").$setInputBoxVisibility(this.l,p))}constructor(p,I,L){this.k=p,this.l=L,d.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,I,"f")}showValidationMessage(p,I){(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),Fe(this,d,"f").$showValidationMessage(this.l,p,I)}$onInputBoxValueChange(p){this.m(p)}m(p){this.d=p,this.e.fire(p)}}e.ExtHostSCMInputBox=u,d=new WeakMap;class r{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(p){this.v=p,this.q.$updateGroupLabel(this.t,this.handle,p)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(p){this.p=p,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(p){this.f=[...p],this.k.fire()}constructor(p,I,L,z,_){this.q=p,this.s=I,this.t=L,this.u=z,this.v=_,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=r.d++}getResourceState(p){return this.g.get(p)}$executeResourceCommand(p,I){const L=this.h.get(p);return L?(0,D.asPromise)(()=>this.s.executeCommand(L.command,...L.arguments||[],I)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this.f].sort(b),L=(0,S.sortedDiff)(this.o,p,b).map(q=>{const N=q.toInsert.map(M=>{const F=this.e++;this.g.set(F,M);const B=M.resourceUri;let U;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const ge=new A.DisposableStore;U=this.s.converter.toInternal(M.command,ge),this.j.set(F,ge)}else this.h.set(F,M.command);const H=m(M.decorations),X=M.decorations&&m(M.decorations.light)||H,V=M.decorations&&m(M.decorations.dark)||H,x=[X,V],Y=M.decorations&&M.decorations.tooltip||"",J=M.decorations&&!!M.decorations.strikeThrough,te=M.decorations&&!!M.decorations.faded,le=M.contextValue||"";return{rawResource:[F,B,x,Y,J,te,le,U],handle:F}});return{start:q.start,deleteCount:q.deleteCount,toInsert:N}}),z=L.map(({start:q,deleteCount:N,toInsert:M})=>[q,N,M.map(F=>F.rawResource)]),_=L.reverse();for(const{start:q,deleteCount:N,toInsert:M}of _){const F=M.map(U=>U.handle),B=this.n.splice(q,N,...F);for(const U of B)this.g.delete(U),this.h.delete(U),this.j.get(U)?.dispose(),this.j.delete(U)}return this.o=p,z}dispose(){this.l=!0,this.m.fire()}}r.d=0;class a{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(p){this.g!==p&&(this.g=p,Fe(this,g,"f").$updateSourceControl(this.t,{count:p}))}get quickDiffProvider(){return this.h}set quickDiffProvider(p){this.h=p,Fe(this,g,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this.j}set commitTemplate(p){p!==this.j&&(this.j=p,Fe(this,g,"f").$updateSourceControl(this.t,{commitTemplate:p}))}get acceptInputCommand(){return this.l}set acceptInputCommand(p){this.k.value=new A.DisposableStore,this.l=p;const I=this.v.converter.toInternal(p,this.k.value);Fe(this,g,"f").$updateSourceControl(this.t,{acceptInputCommand:I})}get actionButton(){return(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(p){(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new A.DisposableStore,this.n=p;const I=p!==void 0?{command:this.v.converter.toInternal(p.command,this.m.value),secondaryCommands:p.secondaryCommands?.map(L=>L.map(z=>this.v.converter.toInternal(z,this.m.value))),description:p.description,enabled:p.enabled}:void 0;Fe(this,g,"f").$updateSourceControl(this.t,{actionButton:I??null})}get statusBarCommands(){return this.p}set statusBarCommands(p){if(this.p&&p&&l(this.p,p))return;this.o.value=new A.DisposableStore,this.p=p;const I=(p||[]).map(L=>this.v.converter.toInternal(L,this.o.value));Fe(this,g,"f").$updateSourceControl(this.t,{statusBarCommands:I})}get selected(){return this.q}constructor(p,I,L,z,_,q){this.u=p,this.v=L,this.w=z,this.x=_,this.y=q,g.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new A.MutableDisposable,this.l=void 0,this.m=new A.MutableDisposable,this.o=new A.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=a.d++,this.z=new Map,this.A=new Set,Je(this,g,I,"f"),this.f=new u(p,Fe(this,g,"f"),this.t),Fe(this,g,"f").$registerSourceControl(this.t,z,_,q)}createResourceGroup(p,I){const L=new r(Fe(this,g,"f"),this.v,this.t,p,I),z=t.Event.once(L.onDidDispose)(()=>this.z.delete(L));return this.z.set(L,z),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const p=[],I=[];for(const[L,z]of this.z){z.dispose();const _=L.onDidUpdateResourceStates(()=>{this.A.add(L),this.eventuallyUpdateResourceStates()});t.Event.once(L.onDidDispose)(()=>{this.A.delete(L),_.dispose(),this.e.delete(L.handle),Fe(this,g,"f").$unregisterGroup(this.t,L.handle)}),p.push([L.handle,L.id,L.label,L.features]);const q=L._takeResourceStateSnapshot();q.length>0&&I.push([L.handle,q]),this.e.set(L.handle,L)}Fe(this,g,"f").$registerGroups(this.t,p,I),this.z.clear()}eventuallyUpdateResourceStates(){const p=[];this.A.forEach(I=>{const L=I._takeResourceStateSnapshot();L.length!==0&&p.push([I.handle,L])}),p.length>0&&Fe(this,g,"f").$spliceResourceStates(this.t,p),this.A.clear()}getResourceGroup(p){return this.e.get(p)}setSelectionState(p){this.q=p,this.s.fire(p)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(p=>p.dispose()),Fe(this,g,"f").$unregisterSourceControl(this.t)}}g=new WeakMap,a.d=0,qe([(0,k.debounce)(100)],a.prototype,"eventuallyAddResourceGroups",null),qe([(0,k.debounce)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let n=class ni{get onDidChangeActiveProvider(){return this.j.event}constructor(p,I,L){this.l=I,this.m=L,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=p.getProxy(T.MainContext.MainThreadSCM),this.f=p.getProxy(T.MainContext.MainThreadTelemetry),I.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const _=this.g.get(z.sourceControlHandle);if(!_)return z;const q=_.getResourceGroup(z.groupHandle);return q?q.getResourceState(z.handle):z}else if(z&&z.$mid===4){const _=this.g.get(z.sourceControlHandle);return _?_.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const _=this.g.get(z.handle);return _||z}return z}})}createSourceControl(p,I,L,z){this.m.trace("ExtHostSCM#createSourceControl",p.identifier.value,I,L,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const _=ni.d++,q=new a(p,this.e,this.l,I,L,z);this.g.set(_,q);const N=this.h.get(P.ExtensionIdentifier.toKey(p.identifier))||[];return N.push(q),this.h.set(P.ExtensionIdentifier.toKey(p.identifier),N),q}getLastInputBox(p){this.m.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const I=this.h.get(P.ExtensionIdentifier.toKey(p.identifier)),L=I&&I[I.length-1];return L&&L.inputBox}$provideOriginalResource(p,I,L){const z=c.URI.revive(I);this.m.trace("ExtHostSCM#$provideOriginalResource",p,z.toString());const _=this.g.get(p);return!_||!_.quickDiffProvider||!_.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>_.quickDiffProvider.provideOriginalResource(z,L)).then(q=>q||null)}$onInputBoxValueChange(p,I){this.m.trace("ExtHostSCM#$onInputBoxValueChange",p);const L=this.g.get(p);return L&&L.inputBox.$onInputBoxValueChange(I),Promise.resolve(void 0)}$executeResourceCommand(p,I,L,z){this.m.trace("ExtHostSCM#$executeResourceCommand",p,I,L);const _=this.g.get(p);if(!_)return Promise.resolve(void 0);const q=_.getResourceGroup(I);return q?q.$executeResourceCommand(L,z):Promise.resolve(void 0)}$validateInput(p,I,L){this.m.trace("ExtHostSCM#$validateInput",p);const z=this.g.get(p);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>z.inputBox.validateInput(I,L)).then(_=>{if(!_)return Promise.resolve(void 0);const q=C.MarkdownString.fromStrict(_.message);return q?Promise.resolve([q,_.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this.g.get(p)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=p,Promise.resolve(void 0)}};n.d=0,n=qe([We(2,R.ILogService)],n),e.ExtHostSCM=n}),define(Se[96],ye([1,0,5,4,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(T){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=T.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,S){return this.a.$getPassword(T,S)}store(T,S,y){return this.a.$setPassword(T,S,y)}delete(T,S){return this.a.$deletePassword(T,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[264],ye([1,0,7,5,175,6,14,11]),function(ne,e,c,t,k,A,D,T){"use strict";var S,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(v,d,g,m,w=c.StatusBarAlignment.Left,f){S.set(this,void 0),y.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new A.DisposableStore,Je(this,S,v,"f"),Je(this,y,d,"f"),this.c=R.a++,this.e=g,this.f=m,this.g=w,this.h=this.t(f)}t(v){if(!!(0,T.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(v){this.k=v,this.u()}set name(v){this.m=v,this.u()}set tooltip(v){this.l=v,this.u()}set color(v){this.n=v,this.u()}set backgroundColor(v){v&&!R.b.has(v.id)&&(v=void 0),this.o=v,this.u()}set command(v){this.q?.fromApi!==v&&(this.p.clear(),typeof v=="string"?this.q={fromApi:v,internal:Fe(this,y,"f").toInternal({title:"",command:v},this.p)}:v?this.q={fromApi:v,internal:Fe(this,y,"f").toInternal(v,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(v){this.s=v,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Fe(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let d;this.m?d=this.m:d=(0,k.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=R.b.get(this.o.id));const m=D.MarkdownString.fromStrict(this.l);Fe(this,S,"f").$setEntry(this.c,v,d,this.k,m,this.q?.internal,g,this.o,this.g===c.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=R,S=new WeakMap,y=new WeakMap,R.a=0,R.b=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const d={message:v};return this.b.unshift(d),this.c(),new c.Disposable(()=>{const g=this.b.indexOf(d);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class E{constructor(v,d){this.a=v.getProxy(t.MainContext.MainThreadStatusBar),this.b=d,this.c=new P(this)}createStatusBarEntry(v,d,g,m){return new R(this.a,this.b,v,d,g,m)}setStatusBarMessage(v,d){const g=this.c.setMessage(v);let m;return typeof d=="number"?m=setTimeout(()=>g.dispose(),d):typeof d<"u"&&d.then(()=>g.dispose(),()=>g.dispose()),new c.Disposable(()=>{g.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=E}),define(Se[97],ye([1,0,5,4,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(T,S){this.c=S,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this.a.$registerExtensionStorageKeysToSync(T,S)}async initializeExtensionStorage(T,S,y){const R=await this.a.$initializeExtensionStorage(T,S);let P;return R&&(P=this.d(T,S,R)),P||y}setValue(T,S,y){return this.a.$setValue(T,S,y)}$acceptValue(T,S,y){const R=this.d(T,S,y);R&&this.b.fire({shared:T,key:S,value:R})}d(T,S,y){try{return JSON.parse(y)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${T}): ${R}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(Se[72],ye([1,0,3,25,13,71,2]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let T=class{constructor(y,R,P){this.d=R,this.f=P,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(E=>this.c=E)}async g(y){return D.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,R=await this.g(y);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(D.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:D.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(y){if(this.c)return D.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return D.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=qe([We(0,t.IExtHostInitDataService),We(1,k.ILogService),We(2,A.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(Se[40],ye([1,0,4,5,3,2,16,6,7,176,10,221,21,30,206,89,11,18,14]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class f{constructor(n,o,p,I){this.k=n,this._id=o,this.l=p,this.m=I,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(z=>this.f=z);const L=this;this.value={get name(){return L.m||""},get processId(){return L.b},get creationOptions(){return L.l},get exitStatus(){return L.h},get state(){return L.j},sendText(z,_=!0){L.o(),L.k.$sendText(L._id,z,_)},show(z){L.o(),L.k.$show(L._id,z)},hide(){L.o(),L.k.$hide(L._id)},dispose(){L.a||(L.a=!0,L.k.$dispose(L._id))},get dimensions(){if(!(L.d===void 0||L.g===void 0))return{columns:L.d,rows:L.g}}}}async create(n,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,g.withNullAsUndefined)(n.shellPath),shellArgs:(0,g.withNullAsUndefined)(n.shellArgs),cwd:(0,g.withNullAsUndefined)(n.cwd),env:(0,g.withNullAsUndefined)(n.env),icon:(0,g.withNullAsUndefined)(u(n.iconPath)),color:d.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,g.withNullAsUndefined)(n.message),strictEnv:(0,g.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this.n(n.location,o?.resolvedExtHostIdentifier),isTransient:(0,g.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,o,p,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:p,color:d.ThemeColor.isThemeColor(I)?I.id:void 0,location:this.n(n,o),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,o){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in n?{viewColumn:w.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,o){this.h=Object.freeze({code:n,reason:o})}setDimensions(n,o){return n===this.d&&o===this.g||n===0||o===0?!1:(this.d=n,this.g=o,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(o=>{o!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=f;class h{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new c.Emitter,this.onProcessData=this.a.event,this.b=new c.Emitter,this.d=new c.Emitter,this.onDidChangeProperty=this.d.event,this.f=new c.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${o}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,o){this.g.setDimensions?.({columns:n,rows:o})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(o=>this.a.fire(o)),this.g.onDidClose?.((o=void 0)=>{this.f.fire(o===void 0?void 0:o)}),this.g.onDidOverrideDimensions?.(o=>{o&&this.d.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this.g.onDidChangeName?.(o=>{this.d.fire({type:"title",value:o})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let b=1,s=class extends T.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,o){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new c.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new c.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new c.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new c.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new c.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new c.Emitter,this.onDidChangeShell=this.J.event,this.a=o.getProxy(t.MainContext.MainThreadTerminalService),this.s=new v.TerminalDataBufferer(this.a.$sendProcessData),this.I=new c.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[p,I]of this.g)I.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,o){const p=new f(this.a,(0,C.generateUuid)(),n,n.name),I=new h(n.pty);return p.createExtensionTerminal(n.location,this.L(n,o).resolvedExtHostIdentifier,u(n.iconPath),r(n.color)).then(L=>{const z=this.M(L,I);this.h[L]=z}),this.f.push(p),p.value}L(n,o){if(o=o||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const p=n.location.parentTerminal;if(p){const I=this.f.find(L=>L.value===p);I&&(o.resolvedExtHostIdentifier=I._id)}}else n.location&&typeof n.location!="object"?o.location=n.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(n,o){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const I=new h(o),L=this.M(n,I);this.h[n]=L}async $acceptActiveTerminalChanged(n){const o=this.b;if(n===null){this.b=void 0,o!==this.b&&this.F.fire(this.b);return}const p=this.O(n);p&&(this.b=p,o!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,o){const p=this.O(n);p&&this.I.fire({terminal:p.value,data:o})}async $acceptTerminalDimensions(n,o,p){const I=this.O(n);I&&I.setDimensions(o,p)&&this.G.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptTerminalMaximumDimensions(n,o,p){this.g.get(n)?.resize(o,p)}async $acceptTerminalTitleChange(n,o){const p=this.O(n);p&&(p.name=o)}async $acceptTerminalClosed(n,o,p){const I=this.Q(this.f,n);if(I!==null){const L=this.f.splice(I,1)[0];L.setExitStatus(o,p),this.C.fire(L.value)}}$acceptTerminalOpened(n,o,p,I){if(o){const _=this.Q(this.f,o);if(_!==null){this.f[_]._id=n,this.D.fire(this.terminals[_]),this.f[_].isOpen=!0;return}}const L={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:A.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},z=new f(this.a,n,L,p);this.f.push(z),this.D.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(n,o){this.O(n)?._setProcessId(o)}async $startExtensionTerminal(n,o){const p=this.O(n);if(!p)return{message:(0,y.localize)(0,null,n)};p.isOpen||await new Promise(L=>{const z=this.onDidOpenTerminal(async _=>{_===p.value&&(z.dispose(),L())})});const I=this.g.get(n);I?I.startSendingEvents(o):this.j[n]={initialDimensions:o}}M(n,o){const p=new T.DisposableStore;p.add(o.onProcessReady(L=>this.a.$sendProcessReady(n,L.pid,L.cwd))),p.add(o.onDidChangeProperty(L=>this.a.$sendProcessProperty(n,L))),this.s.startBuffering(n,o.onProcessData),p.add(o.onProcessExit(L=>this.N(n,L))),this.g.set(n,o);const I=this.j[n];return I&&o instanceof h&&(o.startSendingEvents(I.initialDimensions),delete this.j[n]),p}$acceptProcessAckDataEvent(n,o){this.g.get(n)?.acknowledgeDataEvent(o)}$acceptProcessInput(n,o){this.g.get(n)?.input(o)}$acceptTerminalInteraction(n){const o=this.O(n);o?.setInteractedWith()&&this.H.fire(o.value)}$acceptProcessResize(n,o,p){try{this.g.get(n)?.resize(o,p)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(n,o){this.g.get(n)?.shutdown(o)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(o=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(o=>this.a.$sendProcessProperty(n,{type:"cwd",value:o}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,o,p){if(this.v.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this.v.set(o,p),this.a.$registerProfileProvider(o,n.identifier.value),new S.Disposable(()=>{this.v.delete(o),this.a.$unregisterProfileProvider(o)})}registerTerminalQuickFixProvider(n,o,p){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,p),this.a.$registerQuickFixProvider(n,o),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,o){const p=new E.CancellationTokenSource().token;if(p.isCancellationRequested)return;const I=this.w.get(n);if(!!I)return I.provideTerminalQuickFixes(o,p)}async $createContributedProfileTerminal(n,o){const p=new E.CancellationTokenSource().token;let I=await this.v.get(n)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,o);return}this.createTerminalFromOptions(I.options,o)}}async $provideLinks(n,o){const p=this.O(n);if(!p)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const L=new E.CancellationTokenSource;this.z.set(n,L);const z=[],_={terminal:p.value,line:o},q=[];for(const F of this.u)q.push(m.Promises.withAsyncBody(async B=>{L.token.onCancellationRequested(()=>B({provider:F,links:[]}));const U=await F.provideTerminalLinks(_,L.token)||[];L.token.isCancellationRequested||B({provider:F,links:U})}));const N=await Promise.all(q);if(L.token.isCancellationRequested)return[];const M=new Map;for(const F of N)F&&F.links.length>0&&z.push(...F.links.map(B=>{const U={id:b++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return M.set(U.id,{provider:F.provider,link:B}),U}));return this.y.set(n,M),z}$activateLink(n,o){const p=this.y.get(n)?.get(o);!p||p.provider.handleTerminalLink(p.link)}N(n,o){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const p=this.h[n];p&&(p.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,o)}O(n){return this.P(this.f,n)}P(n,o){const p=this.Q(n,o);return p!==null?n[p]:null}Q(n,o){let p=null;return n.some((I,L)=>I._id===o?(p=L,!0):!1),p}getEnvironmentVariableCollection(n){let o=this.l.get(n.identifier.value);return o||(o=new i,this.S(n.identifier.value,o)),o}R(n,o){const p=(0,P.serializeEnvironmentVariableCollection)(o.map);this.a.$setEnvironmentVariableCollection(n,o.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(n){n.forEach(o=>{const p=o[0],I=new i(o[1]);this.S(p,I)})}$acceptDefaultProfile(n,o){const p=this.m;this.m=n,this.n=o,p?.path!==n.path&&this.J.fire(n.path)}S(n,o){this.l.set(n,o),o.onDidChangeCollection(()=>{this.R(n,o)})}};s=qe([We(1,D.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class i{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new c.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,o){this.d(n,{value:o,type:S.EnvironmentVariableMutatorType.Replace})}append(n,o){this.d(n,{value:o,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,o){this.d(n,{value:o,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,o){const p=this.map.get(n);(!p||p.value!==o.value||p.type!==o.type)&&(this.map.set(n,o),this.b.fire())}get(n){return this.map.get(n)}forEach(n,o){this.map.forEach((p,I)=>n.call(o,I,p,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let l=class extends s{constructor(n){super(!1,n)}createTerminal(n,o,p){throw new R.NotSupportedError}createTerminalFromOptions(n,o){throw new R.NotSupportedError}};l=qe([We(0,D.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l;function u(a){if(!(!a||typeof a=="string"))return"id"in a?{id:a.id,color:a.color}:a}function r(a){return d.ThemeColor.isThemeColor(a)?a:void 0}});var Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c};define(Se[265],ye([1,0,17,18,22,21,4,61,84,6,23,11,30,5,16,136,14,7,56,91,69]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h){"use strict";var b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(M,F,B){this.j=B,this.c=new D.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=M.getProxy(C.MainContext.MainThreadTesting),this.h=new z(this.f),this.g=new a(this.f),F.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==15)return U;const H=U,X=H.tests[H.tests.length-1].item.extId;return this.d.get(w.TestId.root(X))?.collection.tree.get(X)?.actual??(0,d.toItemFromContext)(U)}})}createTestController(M,F,B){if(this.d.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const U=new y.DisposableStore,H=U.add(new d.ExtHostTestItemCollection(M,F,this.j));H.root.label=F;const X=new Map,V=this.f,x={items:H.root.children,get label(){return F},set label(J){F=J,H.root.label=J,V.$updateController(M,{label:F})},get refreshHandler(){return B},set refreshHandler(J){B=J,V.$updateController(M,{canRefresh:!!J})},get id(){return M},createRunProfile:(J,te,le,Z,ge)=>{let ve=(0,S.hash)(J);for(;X.has(ve);)ve++;return new _(this.f,X,M,ve,J,te,le,Z,ge)},createTestItem(J,te,le){return new d.TestItemImpl(M,J,te,le)},createTestRun:(J,te,le=!0)=>this.g.createTestRun(M,H,J,te,le),set resolveHandler(J){H.resolveHandler=J},get resolveHandler(){return H.resolveHandler},dispose:()=>{U.dispose()}};V.$registerTestController(M,F,!!B),U.add((0,y.toDisposable)(()=>V.$unregisterTestController(M)));const Y={controller:x,collection:H,profiles:X};return this.d.set(M,Y),U.add((0,y.toDisposable)(()=>this.d.delete(M))),U.add(H.onDidGenerateDiff(J=>V.$publishDiff(M,J.map(h.TestsDiffOp.serialize)))),x}createTestObserver(){return this.h.checkout()}async runTests(M,F=A.CancellationToken.None){const B=n(M);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.d.get(B.controllerId);if(!U)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(H=>w.TestId.fromExtHostTestItem(H,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:q[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:M.exclude?.map(H=>H.id)},F)}$syncTests(){for(const{collection:M}of this.d.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,F,B){return(0,c.mapFind)(this.g.trackers,H=>H.id===M?H.getCoverage(F):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(M,F,B,U){return(0,c.mapFind)(this.g.trackers,X=>X.id===M?X.getCoverage(F):void 0)?.resolveFileCoverage(B,U)??Promise.resolve([])}$configureRunProfile(M,F){this.d.get(M)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(M,F){await this.d.get(M)?.controller.refreshHandler?.(F)}$publishTestResults(M){this.results=Object.freeze(M.map(F=>(0,R.deepFreeze)(g.TestResults.to(F))).concat(this.results).sort((F,B)=>B.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(M,F){const B=this.d.get(w.TestId.fromString(M).controllerId)?.collection;B&&(await B.expand(M,F<0?1/0:F),B.flushDiff())}$acceptDiff(M){this.h.applyDiff(M.map(h.TestsDiffOp.deserialize))}async $runControllerTests(M,F){return Promise.all(M.map(B=>this.runControllerTestRequest(B,F)))}async runControllerTestRequest(M,F){const B=this.d.get(M.controllerId);if(!B)return{};const{collection:U,profiles:H}=B,X=H.get(M.profileId);if(!X)return{};const V=M.testIds.map(te=>U.tree.get(te)).filter(P.isDefined),x=M.excludeExtIds.map(te=>B.collection.tree.get(te)).filter(P.isDefined).filter(te=>V.some(le=>le.fullId.compare(te.fullId)===2));if(!V.length)return{};const Y=new m.TestRunRequest(V.some(te=>te.actual instanceof d.TestItemRootImpl)?void 0:V.map(te=>te.actual),x.map(te=>te.actual),X),J=this.g.prepareForMainThreadTestRun(Y,o.fromInternal(M,B.collection),F);try{return await X.runHandler(Y,F),{}}catch(te){return{error:String(te)}}finally{J.hasRunningTasks&&!F.isCancellationRequested&&await D.Event.toPromise(J.onEnd),J.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.g.cancelAllRuns():this.g.cancelRunById(M)}};i=qe([We(0,v.IExtHostRpcService)],i),e.ExtHostTesting=i;const l=1e4;var u;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(u||(u={}));class r extends y.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(M,F,B){super(),this.k=M,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new D.Emitter),this.onEnd=this.j.event,this.h=this.B(new A.CancellationTokenSource(B));const U=this.B(new t.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const F=this.k.id,B=this.k.controllerId,U=(0,E.generateUuid)(),H=new p(this.l,F,U),X=J=>(te,...le)=>{if(x){console.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(te)||(this.s(te),J(te,...le))},V=(J,te)=>{const le=te instanceof Array?te.map(g.TestMessage.from):[g.TestMessage.from(te)];if(J.uri&&J.range){const Z={range:g.Range.from(J.range),uri:J.uri};for(const ge of le)ge.location=ge.location||Z}this.l.$appendTestMessagesInRun(F,U,w.TestId.fromExtHostTestItem(J,B).toString(),le)};let x=!1;const Y={isPersisted:this.k.isPersisted,token:this.h.token,name:M,get coverageProvider(){return H.coverageProvider},set coverageProvider(J){H.coverageProvider=J},enqueued:X(J=>{this.l.$updateTestStateInRun(F,U,w.TestId.fromExtHostTestItem(J,B).toString(),1)}),skipped:X(J=>{this.l.$updateTestStateInRun(F,U,w.TestId.fromExtHostTestItem(J,B).toString(),5)}),started:X(J=>{this.l.$updateTestStateInRun(F,U,w.TestId.fromExtHostTestItem(J,B).toString(),2)}),errored:X((J,te,le)=>{V(J,te),this.l.$updateTestStateInRun(F,U,w.TestId.fromExtHostTestItem(J,B).toString(),6,le)}),failed:X((J,te,le)=>{V(J,te),this.l.$updateTestStateInRun(F,U,w.TestId.fromExtHostTestItem(J,B).toString(),4,le)}),passed:X((J,te)=>{this.l.$updateTestStateInRun(F,U,w.TestId.fromExtHostTestItem(J,this.k.controllerId).toString(),3,te)}),appendOutput:(J,te,le)=>{x||(le&&(this.k.isIncluded(le)?this.s(le):le=void 0),this.l.$appendOutputToRun(F,U,k.VSBuffer.fromString(J),te&&g.location.from(te),le&&w.TestId.fromExtHostTestItem(le,B).toString()))},end:()=>{x||(x=!0,this.l.$finishedTestRunTask(F,U),this.f.delete(U),this.f.size||this.p())}};return this.f.set(U,{run:Y,coverage:H}),this.l.$startedTestRunTask(F,{id:U,name:M,running:!0}),Y}m(){for(const{run:M}of this.f.values())M.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(M){if(!(M instanceof d.TestItemImpl))throw new f.InvalidTestItemError(M.id);if(this.g.has(w.TestId.fromExtHostTestItem(M,this.k.controllerId).toString()))return;const F=[],B=this.k.colllection.root;for(;;){const U=g.TestItem.from(M);if(F.unshift(U),this.g.has(U.extId)||(this.g.add(U.extId),M===B))break;M=M.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class a{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,F,B){return this.f(M,F,B)}cancelRunById(M){for(const F of this.c.values())if(F.id===M){F.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,F,B,U,H){const X=this.c.get(B);if(X)return X.createRun(U);const V=o.fromPublic(M,F,B,H),x=n(B);this.d.$startedExtensionTestRun({controllerId:M,profile:x&&{group:q[x.kind],id:x.profileId},exclude:B.exclude?.map(J=>w.TestId.fromExtHostTestItem(J,F.root.id).toString())??[],id:V.id,include:B.include?.map(J=>w.TestId.fromExtHostTestItem(J,F.root.id).toString())??[F.root.id],persist:H});const Y=this.f(B,V);return Y.onEnd(()=>{this.d.$finishedExtensionTestRun(V.id),Y.dispose()}),Y.createRun(U)}f(M,F,B){const U=new r(F,this.d,B);return this.c.set(M,U),U.onEnd(()=>this.c.delete(M)),U}}e.TestRunCoordinator=a;const n=N=>{if(!!N.profile){if(!(N.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class o{static fromPublic(M,F,B,U){return new o(M,(0,E.generateUuid)(),B.include?.map(H=>w.TestId.fromExtHostTestItem(H,M).toString())??[M],B.exclude?.map(H=>w.TestId.fromExtHostTestItem(H,M).toString())??[],U,F)}static fromInternal(M,F){return new o(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,F)}constructor(M,F,B,U,H,X){this.controllerId=M,this.id=F,this.isPersisted=H,this.colllection=X,this.c=B.map(V=>V+"\0"),this.d=U.map(V=>V+"\0")}isIncluded(M){const F=w.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const B of this.d)if(F===B||F.startsWith(B))return!1;for(const B of this.c)if(F===B||F.startsWith(B))return!0;return!1}}e.TestRunDto=o;class p{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,F,B){this.f=M,this.g=F,this.h=B}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(g.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(M,F){const B=await this.d;let U=B?.[M];return!this.c||!B||!U?[]:(U.detailedCoverage||(U=B[M]=await this.c.resolveFileCoverage?.(U,F)??U),U.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class I{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,g.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const F=w.TestId.parentId(M.item.extId);if(F&&this.g.has(F.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:F,f:B}=this;return{get added(){return[...M].map(U=>U.revived)},get updated(){return[...F].map(U=>U.revived)},get removed(){return[...B].map(U=>U.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class L extends h.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new D.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,F){return{...M,revived:g.TestItem.toPlain(M.item),depth:F?F.depth+1:0,children:new Set}}o(){return new I(this.q)}}e.MirroredTestCollection=L;class z{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(F=>F.revived)},dispose:(0,T.once)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new L;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class _{get label(){return this.d}set label(M){M!==this.d&&(this.d=M,Fe(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,Fe(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Fe(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?g.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,Fe(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,F,B,U,H,X,V,x=!1,Y=void 0){this.controllerId=B,this.profileId=U,this.d=H,this.kind=X,this.runHandler=V,this.f=x,this._tag=Y,b.set(this,void 0),s.set(this,void 0),Je(this,b,M,"f"),Je(this,s,F,"f"),F.set(U,this);const J=q[X];if(typeof J!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);Fe(this,b,"f").$publishTestRunProfile({profileId:U,controllerId:B,tag:Y?g.TestTag.namespace(this.controllerId,Y.id):null,label:H,group:J,isDefault:x,hasConfigurationHandler:!1})}dispose(){Fe(this,s,"f")?.delete(this.profileId)&&(Je(this,s,void 0,"f"),Fe(this,b,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=_,b=new WeakMap,s=new WeakMap;const q={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(Se[266],ye([1,0,17,4,5,137,14,7]),function(ne,e,c,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(R,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(k.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(E=>this.g.fire(E)),this.i.onDidChangeActiveTextEditor(E=>this.f.fire(E))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const P=this.i.allEditors();return R?P:P.map(E=>E.value)}async showTextDocument(R,P,E){let C;typeof P=="number"?C={position:D.ViewColumn.from(P),preserveFocus:E}:typeof P=="object"?C={position:D.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?D.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:C={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(R.uri,C),d=v&&this.i.getEditor(v);if(d)return d.value;throw v?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,P){return new A.TextEditorDecorationType(this.h,R,P).value}$acceptEditorPropertiesChanged(R,P){const E=this.i.getEditor(R);if(!E)throw new Error("unknown text editor");if(P.options&&E._acceptOptions(P.options),P.selections){const C=P.selections.selections.map(D.Selection.to);E._acceptSelections(C)}if(P.visibleRanges){const C=c.coalesce(P.visibleRanges.map(D.Range.to));E._acceptVisibleRanges(C)}if(P.options&&this.b.fire({textEditor:E.value,options:{...P.options,lineNumbers:D.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const C=T.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(D.Selection.to);this.a.fire({textEditor:E.value,selections:v,kind:C})}if(P.visibleRanges){const C=c.coalesce(P.visibleRanges.map(D.Range.to));this.c.fire({textEditor:E.value,visibleRanges:C})}}$acceptEditorPositionData(R){for(const P in R){const E=this.i.getEditor(P);if(!E)throw new Error("Unknown text editor");const C=D.ViewColumn.to(R[P]);E.value.viewColumn!==C&&(E._acceptViewColumn(C),this.d.fire({textEditor:E.value,viewColumn:C}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.ExtHostEditors=S}),define(Se[267],ye([1,0,2,3,5,6,7,14,11]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class y{constructor(E,C){this.b=new Map,this.c=new Map,this.a=E.getProxy(k.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===12){const d=v.uri===void 0?void 0:c.URI.revive(v.uri);return this.c.get(v.source)?.get(R(d))?.get(v.handle)}return v}})}async $getTimeline(E,C,v,d){return this.b.get(E)?.provideTimeline(c.URI.revive(C),v,d)}registerTimelineProvider(E,C,v,d){const g=new A.DisposableStore,m=this.d(C.id,d,g).bind(this);let w;C.onDidChange&&(w=C.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:C.id}),this));const f=this.c;return this.f({...C,scheme:E,onDidChange:void 0,async provideTimeline(h,b,s){b?.resetCache&&(g.clear(),f.get(C.id)?.clear());const i=await C.provideTimeline(h,b,s);if(i==null)return;const l=m(h,b);return{...i,source:C.id,items:i.items.map(l)}},dispose(){for(const h of f.values())h.get(C.id)?.clear();w?.dispose(),g.dispose()}})}d(E,C,v){return(d,g)=>{let m;if(g?.cacheResults){let w=this.c.get(E);w===void 0&&(w=new Map,this.c.set(E,w));const f=R(d);m=w.get(f),m===void 0&&(m=new Map,w.set(f,m))}return w=>{const{iconPath:f,...h}=w,b=`${E}|${w.id??w.timestamp}`;m?.set(b,w);let s,i,l;w.iconPath&&(f instanceof D.ThemeIcon?l={id:f.id,color:f.color}:c.URI.isUri(f)?(s=f,i=f):{light:s,dark:i}=f);let u;return D.MarkdownString.isMarkdownString(h.tooltip)?u=T.MarkdownString.from(h.tooltip):(0,S.isString)(h.tooltip)?u=h.tooltip:D.MarkdownString.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=T.MarkdownString.from(h.detail)):(0,S.isString)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=h.detail),{...h,id:h.id??void 0,handle:b,source:E,command:w.command?C.toInternal(w.command,v):void 0,icon:s,iconDark:i,themeIcon:l,tooltip:u,accessibilityInformation:w.accessibilityInformation}}}}f(E){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,E),(0,A.toDisposable)(()=>{for(const v of this.c.values())v.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=y;function R(P){return P?.toString()}}),define(Se[268],ye([1,0,6,15,2,5]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(S){this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,y,R,P){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const E=P.schemes.find(C=>!D.a.has(C));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this.c.set(y,R),this.b.$registerUriOpener(y,P.schemes,S,P.label),(0,c.toDisposable)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri(S,y,R){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const E=k.URI.revive(y);return P.canOpenExternalUri(E,R)}async $openUri(S,y,R){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(k.URI.revive(y.resolvedUri),{sourceUri:k.URI.revive(y.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.a=new Set([t.Schemas.http,t.Schemas.https])}),define(Se[269],ye([1,0,5,2,6,10,27]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(y){this.c=new Set,this.d=new Map,this.b=y.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(y,R){if(this.c.has(D.ExtensionIdentifier.toKey(y)))throw new Error(`Protocol handler already registered for extension ${y}`);const P=T.a++;return this.c.add(D.ExtensionIdentifier.toKey(y)),this.d.set(P,R),this.b.$registerUriHandler(P,y),(0,k.toDisposable)(()=>{this.c.delete(D.ExtensionIdentifier.toKey(y)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(y,R){const P=this.d.get(y);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(R))}catch(E){(0,A.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(y){return t.URI.revive(await this.b.$createAppUri(y))}}e.ExtHostUrls=T,T.a=0});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[73],ye([1,0,4,15,23,2,191,213,92,5]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";var R,P,E,C,v,d,g,m,w,f,h,b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class i{constructor(L,z,_,q,N,M,F){R.set(this,void 0),P.set(this,void 0),E.set(this,void 0),C.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,""),m.set(this,void 0),w.set(this,!1),f.set(this,!1),h.set(this,void 0),b.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new c.Emitter),this._onDidDispose=Fe(this,s,"f").event,Je(this,R,L,"f"),Je(this,P,z,"f"),Je(this,m,_,"f"),Je(this,C,q,"f"),Je(this,v,N,"f"),Je(this,d,M,"f"),Je(this,h,l(M),"f"),Je(this,b,u(M),"f"),Je(this,E,F,"f")}dispose(){Je(this,w,!0,"f"),Fe(this,s,"f").fire(),Fe(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return Je(this,f,!0,"f"),(0,S.asWebviewUri)(L,Fe(this,C,"f"))}get cspSource(){const L=Fe(this,d,"f").extensionLocation;if(L.scheme===t.Schemas.https||L.scheme===t.Schemas.http){let z=L.toString();return z.endsWith("/")||(z+="/"),z+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Fe(this,g,"f")}set html(L){this.a(),Fe(this,g,"f")!==L&&(Je(this,g,L,"f"),Fe(this,b,"f")&&!Fe(this,f,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(Je(this,f,!0,"f"),Fe(this,E,"f").report("Webview vscode-resource: uris",Fe(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,P,"f").$setHtml(Fe(this,R,"f"),this.b(L)))}get options(){return this.a(),Fe(this,m,"f")}set options(L){this.a(),k.equals(Fe(this,m,"f"),L)||Fe(this,P,"f").$setOptions(Fe(this,R,"f"),n(Fe(this,d,"f"),Fe(this,v,"f"),L)),Je(this,m,L,"f")}async postMessage(L){if(Fe(this,w,"f"))return!1;const z=(0,T.serializeWebviewMessage)(L,{serializeBuffersForPostMessage:Fe(this,h,"f")});return Fe(this,P,"f").$postMessage(Fe(this,R,"f"),z.message,...z.buffers)}a(){if(Fe(this,w,"f"))throw new Error("Webview is disposed")}b(L){if(!Fe(this,b,"f"))return L;const z=Fe(this,d,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,_=Fe(this,d,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Fe(this,d,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,N,M,F,B,U)=>{const H=A.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),X=(0,S.asWebviewUri)(H,{isRemote:z,authority:_}).toString();return`${N}${X}${U}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,N,M,F,B,U)=>{const H=A.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),X=(0,S.asWebviewUri)(H,{isRemote:z,authority:_}).toString();return`${N}${X}${U}`})}}e.ExtHostWebview=i,R=new WeakMap,P=new WeakMap,E=new WeakMap,C=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,m=new WeakMap,w=new WeakMap,f=new WeakMap,h=new WeakMap,b=new WeakMap,s=new WeakMap;function l(I){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(I.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;function u(I){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(I.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class r{constructor(L,z,_,q,N){this.c=z,this.d=_,this.e=q,this.f=N,this.b=new Map,this.a=L.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(L,z,_){const q=this.g(L);if(q){const{message:N}=(0,T.deserializeWebviewMessage)(z,_.value);q._onMessageEmitter.fire(N)}}$onMissingCsp(L,z){this.e.warn(`${z} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,z,_){const q=new i(L,this.a,o(z),this.c,this.d,_,this.f);return this.b.set(L,q),q._onDidDispose(()=>{this.b.delete(L)}),q}deleteWebview(L){this.b.delete(L)}g(L){return this.b.get(L)}}e.ExtHostWebviews=r;function a(I){return{id:I.identifier,location:I.extensionLocation}}e.toExtensionData=a;function n(I,L,z){return{enableCommandUris:z.enableCommandUris,enableScripts:z.enableScripts,enableForms:z.enableForms,portMapping:z.portMapping,localResourceRoots:z.localResourceRoots||p(I,L)}}e.serializeWebviewOptions=n;function o(I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,enableForms:I.enableForms,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots?.map(L=>A.URI.from(L))}}function p(I,L){return[...(L?.getWorkspaceFolders()||[]).map(z=>z.uri),I.extensionLocation]}}),define(Se[270],ye([1,0,21,84,6,15,24,2,14,73,68,5,7]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(i,l){this.document=i,this.b=l,this.a=1,this.c=new R.Cache("custom documents")}addEdit(i){return this.c.add([i])}async undo(i,l){await this.f(i).undo(),l||this.disposeBackup()}async redo(i,l){await this.f(i).redo(),l||this.disposeBackup()}disposeEdits(i){for(const l of i)this.c.delete(l)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const i=b(this.document.uri)+this.a++;return(0,D.joinPath)(this.b,i)}updateBackup(i){this.d?.delete(),this.d=i}disposeBackup(){this.d?.delete(),this.d=void 0}f(i){const l=this.c.get(i,0);if(!l)throw new Error("No edit found");return l}}class v{constructor(){this.a=new Map}get(i,l){return this.a.get(this.b(i,l))}add(i,l,u){const r=this.b(i,l.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${i} resource:${l.uri}`);const a=new C(l,u);return this.a.set(r,a),a}delete(i,l){const u=this.b(i,l.uri);this.a.delete(u)}b(i,l){return`${i}@@@${l}`}}var d;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(d||(d={}));class g{constructor(){this.a=new Map}addTextProvider(i,l,u){return this.b(0,i,l,u)}addCustomProvider(i,l,u){return this.b(1,i,l,u)}get(i){return this.a.get(i)}b(i,l,u,r){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,{type:i,extension:u,provider:r}),new E.Disposable(()=>this.a.delete(l))}}class m{constructor(i,l,u,r,a){this.d=l,this.f=u,this.g=r,this.h=a,this.b=new g,this.c=new v,this.a=i.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,l,u,r){const a=new k.DisposableStore;return f(u)?(a.add(this.b.addTextProvider(l,i,u)),this.a.$registerTextEditorProvider((0,y.toExtensionData)(i),l,r.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(i))):(a.add(this.b.addCustomProvider(l,i,u)),w(u)&&a.add(u.onDidChangeCustomDocument(n=>{const o=this.i(l,n.document.uri);if(h(n)){const p=o.addEdit(n);this.a.$onDidEdit(n.document.uri,l,p,n.label)}else this.a.$onContentChange(n.document.uri,l)})),this.a.$registerCustomEditorProvider((0,y.toExtensionData)(i),l,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(i))),E.Disposable.from(a,new E.Disposable(()=>{this.a.$unregisterEditorProvider(l)}))}async $createCustomDocument(i,l,u,r,a){const n=this.b.get(l);if(!n)throw new Error(`No provider found for '${l}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${l}'`);const o=T.URI.revive(i),p=await n.provider.openCustomDocument(o,{backupId:u,untitledDocumentData:r?.buffer},a);let I;return w(n.provider)&&this.f&&(I=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(l,p,I),{editable:w(n.provider)}}async $disposeCustomDocument(i,l){const u=this.b.get(l);if(!u)throw new Error(`No provider found for '${l}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${l}'`);const r=T.URI.revive(i),{document:a}=this.i(l,r);this.c.delete(l,a),a.dispose()}async $resolveWebviewEditor(i,l,u,r,a,n){const o=this.b.get(u);if(!o)throw new Error(`No provider found for '${u}'`);const p=S.ViewColumn.to(a),I=this.g.createNewWebview(l,r.contentOptions,o.extension),L=this.h.createNewWebviewPanel(l,u,r.title,p,r.options,I,!0),z=T.URI.revive(i);switch(o.type){case 1:{const{document:_}=this.i(u,z);return o.provider.resolveCustomEditor(_,L,n)}case 0:{const _=this.d.getDocument(z);return o.provider.resolveCustomTextEditor(_,L,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,l,u){this.i(l,i).disposeEdits(u)}async $onMoveCustomEditor(i,l,u){const r=this.b.get(u);if(!r)throw new Error(`No provider found for '${u}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const a=this.h.getWebviewPanel(i);if(!a)throw new Error("No webview found");const n=T.URI.revive(l),o=this.d.getDocument(n);await r.provider.moveCustomTextEditor(o,a,c.CancellationToken.None)}async $undo(i,l,u,r){return this.i(l,i).undo(u,r)}async $redo(i,l,u,r){return this.i(l,i).redo(u,r)}async $revert(i,l,u){const r=this.i(l,i);await this.j(l).revertCustomDocument(r.document,u),r.disposeBackup()}async $onSave(i,l,u){const r=this.i(l,i);await this.j(l).saveCustomDocument(r.document,u),r.disposeBackup()}async $onSaveAs(i,l,u,r){const a=this.i(l,i);return this.j(l).saveCustomDocumentAs(a.document,T.URI.revive(u),r)}async $backup(i,l,u){const r=this.i(l,i),n=await this.j(l).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},u);return r.updateBackup(n),n.id}i(i,l){const u=this.c.get(i,T.URI.revive(l));if(!u)throw new Error("No custom document found");return u}j(i){const u=this.b.get(i)?.provider;if(!u||!w(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=m;function w(s){return!!s.onDidChangeCustomDocument}function f(s){return typeof s.resolveCustomTextEditor=="function"}function h(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function b(s){const i=s.scheme===A.Schemas.file||s.scheme===A.Schemas.untitled?s.fsPath:s.toString();return(0,t.hash)(i)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[271],ye([1,0,4,6,2,30,14,73,5,7]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";var R,P,E,C,v,d,g,m,w,f,h,b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends t.Disposable{constructor(a,n,o,p){super(),R.set(this,void 0),P.set(this,void 0),E.set(this,void 0),C.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,void 0),m.set(this,void 0),w.set(this,!0),f.set(this,void 0),h.set(this,!1),b.set(this,this.B(new c.Emitter)),this.onDidDispose=Fe(this,b,"f").event,s.set(this,this.B(new c.Emitter)),this.onDidChangeViewState=Fe(this,s,"f").event,Je(this,R,a,"f"),Je(this,P,n,"f"),Je(this,C,o,"f"),Je(this,E,p.viewType,"f"),Je(this,v,p.panelOptions,"f"),Je(this,m,p.viewColumn,"f"),Je(this,d,p.title,"f"),Je(this,f,p.active,"f")}dispose(){Fe(this,h,"f")||(Je(this,h,!0,"f"),Fe(this,b,"f").fire(),Fe(this,P,"f").$disposeWebview(Fe(this,R,"f")),Fe(this,C,"f").dispose(),super.dispose())}get webview(){return this.c(),Fe(this,C,"f")}get viewType(){return this.c(),Fe(this,E,"f")}get title(){return this.c(),Fe(this,d,"f")}set title(a){this.c(),Fe(this,d,"f")!==a&&(Je(this,d,a,"f"),Fe(this,P,"f").$setTitle(Fe(this,R,"f"),a))}get iconPath(){return this.c(),Fe(this,g,"f")}set iconPath(a){this.c(),Fe(this,g,"f")!==a&&(Je(this,g,a,"f"),Fe(this,P,"f").$setIconPath(Fe(this,R,"f"),k.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Fe(this,v,"f")}get viewColumn(){if(this.c(),!(typeof Fe(this,m,"f")=="number"&&Fe(this,m,"f")<0))return Fe(this,m,"f")}get active(){return this.c(),Fe(this,f,"f")}get visible(){return this.c(),Fe(this,w,"f")}_updateViewState(a){Fe(this,h,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(Je(this,f,a.active,"f"),Je(this,w,a.visible,"f"),Je(this,m,a.viewColumn,"f"),Fe(this,s,"f").fire({webviewPanel:this}))}reveal(a,n){this.c(),Fe(this,P,"f").$reveal(Fe(this,R,"f"),{viewColumn:typeof a>"u"?void 0:D.ViewColumn.from(a),preserveFocus:!!n})}c(){if(Fe(this,h,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,P=new WeakMap,E=new WeakMap,C=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,m=new WeakMap,w=new WeakMap,f=new WeakMap,h=new WeakMap,b=new WeakMap,s=new WeakMap;class l{static c(){return(0,A.generateUuid)()}constructor(a,n,o){this.g=n,this.h=o,this.e=new Map,this.f=new Map,this.d=a.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(a,n,o,p,I={}){const L=typeof p=="object"?p.viewColumn:p,z={viewColumn:D.ViewColumn.from(L),preserveFocus:typeof p=="object"&&!!p.preserveFocus},_=(0,T.shouldSerializeBuffersForPostMessage)(a),q=l.c();this.d.$createWebviewPanel((0,T.toExtensionData)(a),q,n,{title:o,panelOptions:u(I),webviewOptions:(0,T.serializeWebviewOptions)(a,this.h,I),serializeBuffersForPostMessage:_},z);const N=this.g.createNewWebview(q,I,a);return this.createNewWebviewPanel(q,n,o,L,I,N,!0)}$onDidChangeWebviewPanelViewStates(a){const n=Object.keys(a);n.sort((o,p)=>{const I=a[o],L=a[p];return I.active?1:L.active?-1:+I.visible-+L.visible});for(const o of n){const p=this.getWebviewPanel(o);if(!p)continue;const I=a[o];p._updateViewState({active:I.active,visible:I.visible,viewColumn:D.ViewColumn.to(I.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this.e.delete(a),this.g.deleteWebview(a)}registerWebviewPanelSerializer(a,n,o){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:o,extension:a}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(a)}),new y.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(a,n,o,p){const I=this.f.get(n);if(!I)throw new Error(`No serializer found for '${n}'`);const{serializer:L,extension:z}=I,_=this.g.createNewWebview(a,o.webviewOptions,z),q=this.createNewWebviewPanel(a,n,o.title,p,o.panelOptions,_,o.active);await L.deserializeWebviewPanel(q,o.state)}createNewWebviewPanel(a,n,o,p,I,L,z){const _=new i(a,this.d,L,{viewType:n,title:o,viewColumn:p,panelOptions:I,active:z});return this.e.set(a,_),_}getWebviewPanel(a){return this.e.get(a)}}e.ExtHostWebviewPanels=l;function u(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[272],ye([1,0,4,6,73,14,5,7]),function(ne,e,c,t,k,A,D,T){"use strict";var S,y,R,P,E,C,v,d,g,m,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class f extends t.Disposable{constructor(s,i,l,u,r,a){super(),S.set(this,void 0),y.set(this,void 0),R.set(this,void 0),P.set(this,void 0),E.set(this,!1),C.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,void 0),m.set(this,this.B(new c.Emitter)),this.onDidChangeVisibility=Fe(this,m,"f").event,w.set(this,this.B(new c.Emitter)),this.onDidDispose=Fe(this,w,"f").event,Je(this,R,l,"f"),Je(this,v,u,"f"),Je(this,S,s,"f"),Je(this,y,i,"f"),Je(this,P,r,"f"),Je(this,C,a,"f")}dispose(){Fe(this,E,"f")||(Je(this,E,!0,"f"),Fe(this,w,"f").fire(),Fe(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Fe(this,v,"f")}set title(s){this.a(),Fe(this,v,"f")!==s&&(Je(this,v,s,"f"),Fe(this,y,"f").$setWebviewViewTitle(Fe(this,S,"f"),s))}get description(){return this.a(),Fe(this,d,"f")}set description(s){this.a(),Fe(this,d,"f")!==s&&(Je(this,d,s,"f"),Fe(this,y,"f").$setWebviewViewDescription(Fe(this,S,"f"),s))}get visible(){return Fe(this,C,"f")}get webview(){return Fe(this,P,"f")}get viewType(){return Fe(this,R,"f")}_setVisible(s){s===Fe(this,C,"f")||Fe(this,E,"f")||(Je(this,C,s,"f"),Fe(this,m,"f").fire())}get badge(){return this.a(),Fe(this,g,"f")}set badge(s){this.a(),!(s?.value===Fe(this,g,"f")?.value&&s?.tooltip===Fe(this,g,"f")?.tooltip)&&(Je(this,g,A.ViewBadge.from(s),"f"),Fe(this,y,"f").$setWebviewViewBadge(Fe(this,S,"f"),s))}show(s){this.a(),Fe(this,y,"f").$show(Fe(this,S,"f"),!!s)}a(){if(Fe(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,y=new WeakMap,R=new WeakMap,P=new WeakMap,E=new WeakMap,C=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,m=new WeakMap,w=new WeakMap;class h{constructor(s,i){this.d=i,this.b=new Map,this.c=new Map,this.a=s.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,i,l,u){if(this.b.has(i))throw new Error(`View provider for '${i}' already registered`);return this.b.set(i,{provider:l,extension:s}),this.a.$registerWebviewViewProvider((0,k.toExtensionData)(s),i,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(s)}),new T.Disposable(()=>{this.b.delete(i),this.a.$unregisterWebviewViewProvider(i)})}async $resolveWebviewView(s,i,l,u,r){const a=this.b.get(i);if(!a)throw new Error(`No view provider found for '${i}'`);const{provider:n,extension:o}=a,p=this.d.createNewWebview(s,{},o),I=new f(s,this.a,i,l,p,!0);this.c.set(s,I),await n.resolveWebviewView(I,{state:u},r)}async $onDidChangeWebviewViewVisibility(s,i){this.e(s)._setVisible(i)}async $disposeWebviewView(s){const i=this.e(s);this.c.delete(s),i.dispose(),this.d.deleteWebview(s)}e(s){const i=this.c.get(s);if(!i)throw new Error("No webview found");return i}}e.ExtHostWebviewViews=h}),define(Se[140],ye([1,0,4,5,2,15,8,3,16]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let y=class ii{get state(){return this.d}constructor(P){this.c=new c.Emitter,this.onDidChangeWindowState=this.c.event,this.d=ii.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,E){let C;if(typeof P=="string"){C=P;try{P=k.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,D.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,C,E)}async asExternalUri(P,E){if((0,D.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const C=await this.b.$asExternalUri(P,E);return k.URI.from(C)}};y.a={focused:!0},y=qe([We(0,S.IExtHostRpcService)],y),e.ExtHostWindow=y,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(Se[273],ye([1,0,117,274,65,39,2,13,46]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(E,C,v){this.b=E,this.c=C,this.f=v,this.a=t.createServer((d,g)=>this.h(d,g)),this.g().catch(d=>(C.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",E=>this.c.error(E))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(E,C){const v=(g,m)=>{C.writeHead(g,{"content-type":"application/json"}),C.end(JSON.stringify(m||null),w=>w&&this.c.error(w))},d=[];E.setEncoding("utf8"),E.on("data",g=>d.push(g)),E.on("end",async()=>{try{const g=JSON.parse(d.join(""));let m;switch(g.type){case"open":m=await this.i(g);break;case"openExternal":m=await this.j(g);break;case"status":m=await this.l(g);break;case"extensionManagement":m=await this.k(g);break;default:v(404,`Unknown message type: ${g.type}`);break}v(200,m)}catch(g){const m=g instanceof Error?g.message:JSON.stringify(g);v(500,m),this.c.error("Error while processing pipe request",g)}})}async i(E){const{fileURIs:C,folderURIs:v,forceNewWindow:d,diffMode:g,mergeMode:m,addMode:w,forceReuseWindow:f,gotoLineMode:h,waitMarkerFilePath:b,remoteAuthority:s}=E,i=[];if(Array.isArray(v))for(const a of v)try{i.push({folderUri:D.URI.parse(a)})}catch{}if(Array.isArray(C))for(const a of C)try{(0,S.hasWorkspaceFileExtension)(a)?i.push({workspaceUri:D.URI.parse(a)}):i.push({fileUri:D.URI.parse(a)})}catch{}const l=b?D.URI.file(b):void 0,r={forceNewWindow:d,diffMode:g,mergeMode:m,addMode:w,gotoLineMode:h,forceReuseWindow:f,preferNewWindow:!f&&!l&&!w,waitMarkerFileURI:l,remoteAuthority:s};return this.b.executeCommand("_remoteCLI.windowOpen",i,r),""}async j(E){for(const C of E.uris){const v=D.URI.parse(C),d=v.scheme==="file"?v:C;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(E){const C=d=>d?.map(g=>/\.vsix$/i.test(g)?D.URI.parse(g):g),v={list:E.list,install:C(E.install),uninstall:C(E.uninstall),force:E.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(E){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&k.existsSync(this.f)&&k.unlinkSync(this.f)}}e.CLIServerBase=y;let R=class extends y{constructor(E,C){super(E,C,(0,c.createRandomIPCHandle)())}};R=qe([We(0,A.IExtHostCommands),We(1,T.ILogService)],R),e.CLIServer=R}),define(Se[275],ye([1,0,246,25,16]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let D=class extends c.AbstractExtHostConsoleForwarder{constructor(S,y){super(S,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,y,R){const P=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),y.apply(console,R),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,y){const R=process[S],P=R.write;let E="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(C,v,d)=>{if(!this.g){E+=C.toString(v);const g=E.length>A?E.length:E.lastIndexOf(`
`);g!==-1&&(console[y](E.slice(0,g)),E=E.slice(g+1))}P.call(R,C,v,d)}})}};D=qe([We(0,k.IExtHostRpcService),We(1,t.IExtHostInitDataService)],D),e.ExtHostConsoleForwarder=D}),define(Se[276],ye([1,0,9,86,30,39,6,5,2,16]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends D.Disposable{constructor(E,C){super();const v=E.getProxy(T.MainContext.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async d=>{const g=S.URI.file((0,c.join)((0,t.tmpdir)(),(0,k.generateUuid)()));return await v.$download(d,g),g})}};R=qe([We(0,y.IExtHostRpcService),We(1,A.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(Se[277],ye([1,0,139,15,197,30]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class D extends c.ExtHostLoggerService{f(S,y,R){return S.scheme===t.Schemas.file?new k.SpdLogLogger(R?.name||(0,A.generateUuid)(),S.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,y):super.f(S,y,R)}}e.ExtHostLoggerService=D}),define(Se[278],ye([1,0,65,9,2,72,6,15,18,29]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends A.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(s){const i=await super.g(s);if(i.scheme!==T.Schemas.file)return i;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${i.fsPath}.`),i;const l=i.fsPath;let u=0;do{let r;u===0?r=l:r=/[/\\]$/.test(l)?`${l.substr(0,l.length-1)}-${u}`:`${l}-${u}`,await P(r);const a=t.join(r,"vscode.lock"),n=await d(this.d,a,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),k.URI.file(r);u++}while(u<10);return i}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function P(b){try{await y.Promises.stat(b);return}catch{}try{await y.Promises.mkdir(b,{recursive:!0})}catch{}}const E=1e3,C=10*60*1e3;class v extends D.Disposable{constructor(s,i){super(),this.b=s,this.c=i,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const l=await g(s,i);(!l||l.pid!==process.pid)&&(s.info(`Lock '${i}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(i,new Date,new Date)}catch(u){s.error(u),s.info(`Lock '${i}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{c.unlinkSync(this.c)}catch{}}async setWillRelease(s){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const i={pid:process.pid,willReleaseAt:Date.now()+s};await y.Promises.writeFile(this.c,JSON.stringify(i),{flag:"w"})}catch(i){this.b.error(i)}}}async function d(b,s,i){try{const u={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(s,JSON.stringify(u),{flag:"wx"})}catch(u){b.error(u)}const l=await g(b,s);return!l||l.pid!==process.pid?i?(b.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(b.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),f(b,s)):(b.info(`Lock '${s}': Lock acquired.`),new v(b,s))}async function g(b,s){let i;try{i=await y.Promises.readFile(s)}catch(l){return b.error(l),null}try{return JSON.parse(String(i))}catch(l){return b.error(l),null}}async function m(b,s){let i;try{i=await y.Promises.stat(s)}catch(l){return b.error(l),0}return i.mtime.getTime()}function w(b){try{return process.kill(b,0),!0}catch{return!1}}async function f(b,s){const i=await g(b,s);if(!i)return b.info(`Lock '${s}': Could not read pid of lock holder.`),h(b,s);if(i.willReleaseAt){let n=i.willReleaseAt-Date.now();if(n<5e3){for(n>0?b.info(`Lock '${s}': The lockfile is scheduled to be released in ${n} ms.`):b.info(`Lock '${s}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await m(b,s)===0)return h(b,s);n=i.willReleaseAt-Date.now()}return h(b,s)}}if(!w(i.pid))return b.info(`Lock '${s}': The pid ${i.pid} appears to be gone.`),h(b,s);const l=await m(b,s),u=Date.now()-l;if(u<=C)return b.info(`Lock '${s}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;b.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const r=await m(b,s),a=Date.now()-r;return a<=C?(b.info(`Lock '${s}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(b.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),h(b,s))}async function h(b,s){b.info(`Lock '${s}': Deleting a stale lock.`);try{await y.Promises.unlink(s)}catch{}return d(b,s,!0)}}),define(Se[279],ye([1,0,30,16,40]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends k.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,y){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:y})}createTerminalFromOptions(T,S){const y=new k.ExtHostTerminal(this.a,(0,c.generateUuid)(),T,T.name);return this.f.push(y),y.create(T,this.L(T,S)),y.value}};A=qe([We(0,t.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Se[280],ye([1,0,5,16,180,6,25,2,45,24,29,7,12,54,4,129,100,13]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class w extends d.DisposableTunnel{}function f(n){const o=n.trim().split(`
`),p=[];return o.forEach(L=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);z&&z.length>=3&&p.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),p.reduce((L,z)=>(L[z.socket]=z,L),{})}e.getSockets=f;function h(...n){const o=[].concat(...n.map(s));return[...new Map(o.filter(p=>p.st==="0A").map(p=>{const I=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:b(I[0]),port:parseInt(I[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=h;function b(n){let o="";if(n.length===8)for(let p=n.length-2;p>=0;p-=2)o+=parseInt(n.substr(p,2),16),p!==0&&(o+=".");else for(let p=n.length-4;p>=0;p-=4)o+=parseInt(n.substr(p,4),16).toString(16),p!==0&&(o+=":");return o}function s(n){const o=n.trim().split(`
`),p=o.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return o.map(L=>L.trim().split(/\s+/).reduce((z,_,q)=>(z[p[q]||q]=_,z),{}))}e.loadConnectionTable=s;function i(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function l(n){const o=n.trim().split(`
`),p=[];return o.forEach(I=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);L&&L.length>=4&&p.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),p}e.getRootProcesses=l;async function u(n,o,p){const I=p.reduce((z,_)=>(z[_.pid]=_,z),{}),L=[];return n.forEach(({socket:z,ip:_,port:q})=>{const N=o[z]?o[z].pid:void 0,M=N?I[N]?.cmd:void 0;N&&M&&!i(M)&&L.push({host:_,port:q,detail:M,pid:N})}),L}e.findPorts=u;function r(n,o,p){const I=new Map,L=l(o);for(const z of n){const _=p.get(z.port);if(_){I.set(z.port,_);continue}const q=L.find(N=>N.cmd.includes(`${z.port}`));if(q){let N=q,M;do M=L.find(F=>F.ppid===N.pid),M&&(N=M);while(M);I.set(z.port,{host:z.ip,port:z.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else I.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return I}e.tryFindRootPorts=r;let a=class extends A.Disposable{constructor(o,p,I){super(),this.n=I,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new v.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=o.getProxy(c.MainContext.MainThreadTunnelService),E.isLinux&&p.remote.isRemote&&p.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(o,p){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${p.remoteAddress.host}:${p.remoteAddress.port}.`);const I=await this.a.$openTunnel(p,o.displayName);if(I){const L=new w(I.remoteAddress,I.localAddress,()=>this.a.$closeTunnel(I.remoteAddress));return this.B(L),L}}async getTunnels(){return this.a.$getTunnels()}p(o){return Math.max(o*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(o,p){const I=this.r();return this.l.set(I,{selector:o,provider:p}),this.a.$registerPortsAttributesProvider(o,I),new P.Disposable(()=>{this.l.delete(I),this.a.$unregisterPortsAttributesProvider(I)})}async $providePortAttributes(o,p,I,L,z){const _=[];for(const N of o){const M=this.l.get(N);if(!M)return[];_.push(...await Promise.all(p.map(async F=>M.provider.providePortAttributes(F,I,L,z))))}const q=_.filter(N=>!!N);return q.length>0?q.map(N=>({autoForwardAction:N.autoForwardAction,port:N.port})):[]}async $registerCandidateFinder(o){if(o&&this.h)return;this.h=o;const p=new g.MovingAverage;let I;for(;this.h;){const L=new Date().getTime(),z=(await this.findCandidatePorts()).filter(q=>(0,d.isLocalhost)(q.host)||(0,d.isAllInterfaces)(q.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(q=>q.port).join(", ")}`);const _=new Date().getTime()-L;p.update(_),(!I||JSON.stringify(I)!==JSON.stringify(z))&&(I=z,await this.a.$onFoundNewCandidates(I)),await new Promise(q=>setTimeout(()=>q(),this.p(p.value)))}}async setTunnelFactory(o){if(o){if(o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.c=o.showCandidatePort,this.a.$setCandidateFilter()),o.tunnelFactory){this.b=o.tunnelFactory;let p=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&p.length===0&&(p=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]);const I=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:p}:void 0;this.a.$setTunnelProvider(I)}}else this.b=void 0;return(0,A.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(o,p){if(this.f.has(o.host)){const I=this.f.get(o.host);I.has(o.port)&&(p&&I.get(o.port).disposeListener.dispose(),await I.get(o.port).tunnel.dispose(),I.delete(o.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(o,p){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const I=this.b(o,p);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),I!==void 0){const L=await I;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(o.remoteAddress.host)||this.f.set(o.remoteAddress.host,new Map);const z=this.B(L.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(L.remoteAddress))));return this.f.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:L,disposeListener:z}),C.TunnelDtoConverter.fromApiTunnel(L)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(o){const p=await Promise.all(o.map(L=>this.c(L.host,L.port,L.detail??""))),I=o.filter((L,z)=>p[z]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(L=>L.port).join(", ")} to ${I.map(L=>L.port).join(", ")}`),I}async findCandidatePorts(){let o="",p="";try{o=await R.Promises.readFile("/proc/net/tcp","utf8"),p=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=h(o,p),L=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(H,X,V)=>{U(X)})}),z=f(L),_=await R.Promises.readdir("/proc"),q=[];for(const U of _)try{const H=Number(U),X=y.joinPath(T.URI.file("/proc"),U);if((await R.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(H)){const x=await R.Promises.readlink(y.joinPath(X,"cwd").fsPath),Y=await R.Promises.readFile(y.joinPath(X,"cmdline").fsPath,"utf8");q.push({pid:H,cwd:x,cmd:Y})}}catch{}const N=[],M=I.filter(U=>{const H=z[U.socket];return H||N.push(U),H}),F=u(M,z,q);let B;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const U=await new Promise(H=>{(0,S.exec)("ps -F -A -l | grep root",(X,V,x)=>{H(V)})});this.j=r(N,U,this.j),B=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.map(H=>H.port).join(", ")}`)}return F.then(U=>B?U.concat(B):U)}};a=qe([We(0,t.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,m.ILogService)],a),e.ExtHostTunnelService=a}),define(Se[281],ye([1,0,18,22,21,10,4,6,112,240,57]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(I,L){try{return JSON.stringify(I,L)}catch{return"null"}}const C="$$ref$$",v={[C]:-1};class d{constructor(L,z){this.jsonString=L,this.referencedBuffers=z}}function g(I,L=null,z=!1){const _=[];return{jsonString:(z?E:JSON.stringify)(I,(N,M)=>{if(typeof M>"u")return v;if(typeof M=="object"){if(M instanceof t.VSBuffer){const F=_.push(M)-1;return{[C]:F}}if(L)return L(N,M)}return M}),referencedBuffers:_}}e.stringifyJsonWithBufferRefs=g;function m(I,L,z){return JSON.parse(I,(_,q)=>{if(q){const N=q[C];if(typeof N=="number")return L[N];if(z&&q.$mid===1)return z.transformIncoming(q)}return q})}e.parseJsonAndRestoreBufferRefs=m;function w(I,L){return JSON.stringify(I,L)}function f(I){return I?(L,z)=>z&&z.$mid===1?I.transformOutgoing(z):z:null}var h;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(I){I[I.Responsive=0]="Responsive",I[I.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},i=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class u extends T.Disposable{constructor(L,z=null,_=null){super(),this[P]=!0,this.b=this.B(new D.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=z,this.g=_,this.h=f(this.g),this.j=!1,this.k=[],this.l=[];for(let q=0,N=R.ProxyIdentifier.count;q<N;q++)this.k[q]=null,this.l[q]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new c.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(q=>this.G(q))}dispose(){this.j=!0,Object.keys(this.s).forEach(L=>{this.s[L].resolveErr(A.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(L){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(L){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(L){this.t!==L&&(this.t=L,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(L){return this.g?(0,S.transformIncomingURIs)(L,this.g):L}getProxy(L){const{nid:z,sid:_}=L;return this.l[z]||(this.l[z]=this.F(z,_)),this.l[z]}F(L,z){const _={get:(q,N)=>(typeof N=="string"&&!q[N]&&N.charCodeAt(0)===36&&(q[N]=(...M)=>this.O(L,N,M)),N===l?z:q[N])};return new Proxy(Object.create(null),_)}set(L,z){return this.k[L.nid]=z,z}assertRegistered(L){for(let z=0,_=L.length;z<_;z++){const q=L[z];if(!this.k[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}G(L){if(this.j)return;const z=L.byteLength,_=r.read(L,0),q=_.readUInt8(),N=_.readUInt32();switch(q){case 1:case 2:{let{rpcId:M,method:F,args:B}=n.deserializeRequestJSONArgs(_);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(z,N,M,F,B,q===2);break}case 3:case 4:{let{rpcId:M,method:F,args:B}=n.deserializeRequestMixedArgs(_);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(z,N,M,F,B,q===4);break}case 5:{this.f?.logIncoming(z,N,0,"ack"),this.z(N);break}case 6:{this.I(z,N);break}case 7:{this.J(z,N,void 0);break}case 9:{let M=n.deserializeReplyOKJSON(_);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.J(z,N,M);break}case 10:{const M=n.deserializeReplyOKJSONWithBuffers(_,this.g);this.J(z,N,M);break}case 8:{const M=n.deserializeReplyOKVSBuffer(_);this.J(z,N,M);break}case 11:{let M=n.deserializeReplyErrError(_);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.L(z,N,M);break}case 12:{this.L(z,N,void 0);break}default:console.error("received unexpected message"),console.error(L)}}H(L,z,_,q,N,M){this.f?.logIncoming(L,z,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(_)}.${q}(`,N);const F=String(z);let B,U;if(M){const X=new k.CancellationTokenSource;N.push(X.token),B=this.M(_,q,N),U=()=>X.cancel()}else B=this.M(_,q,N),U=s;this.p[F]=U;const H=n.serializeAcknowledged(z);this.f?.logOutgoing(H.byteLength,z,1,"ack"),this.c.send(H),B.then(X=>{delete this.p[F];const V=n.serializeReplyOK(z,X,this.h);this.f?.logOutgoing(V.byteLength,z,1,"reply:",X),this.c.send(V)},X=>{delete this.p[F];const V=n.serializeReplyErr(z,X);this.f?.logOutgoing(V.byteLength,z,1,"replyErr:",X),this.c.send(V)})}I(L,z){this.f?.logIncoming(L,z,1,"receiveCancel");const _=String(z);this.p[_]?.()}J(L,z,_){this.f?.logIncoming(L,z,0,"receiveReply:",_);const q=String(z);if(!this.s.hasOwnProperty(q))return;const N=this.s[q];delete this.s[q],N.resolveOk(_)}L(L,z,_){this.f?.logIncoming(L,z,0,"receiveReplyErr:",_);const q=String(z);if(!this.s.hasOwnProperty(q))return;const N=this.s[q];delete this.s[q];let M;_&&(_.$isError?(M=new Error,M.name=_.name,M.message=_.message,M.stack=_.stack):M=_),N.resolveErr(M)}M(L,z,_){try{return Promise.resolve(this.N(L,z,_))}catch(q){return Promise.reject(q)}}N(L,z,_){const q=this.k[L];if(!q)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const N=q[z];if(typeof N!="function")throw new Error("Unknown method "+z+" on actor "+(0,R.getStringIdentifierForProxy)(L));return N.apply(q,_)}O(L,z,_){if(this.j)return new y.CanceledLazyPromise;let q=null;if(_.length>0&&k.CancellationToken.isCancellationToken(_[_.length-1])&&(q=_.pop()),q&&q.isCancellationRequested)return Promise.reject(A.canceled());const N=n.serializeRequestArguments(_,this.h),M=++this.m,F=String(M),B=new y.LazyPromise;q&&q.onCancellationRequested(()=>{const H=n.serializeCancel(M);this.f?.logOutgoing(H.byteLength,M,0,"cancel"),this.c.send(n.serializeCancel(M))}),this.s[F]=B,this.y(M);const U=n.serializeRequest(M,L,z,N,!!q);return this.f?.logOutgoing(U.byteLength,M,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${z}(`,_),this.c.send(U),B}}e.RPCProtocol=u,P=i,u.a=3*1e3;class r{static alloc(L,z,_){const q=new r(t.VSBuffer.alloc(_+1+4),0);return q.writeUInt8(L),q.writeUInt32(z),q}static read(L,z){return new r(L,z)}get buffer(){return this.a}constructor(L,z){this.a=L,this.b=z}static sizeUInt8(){return 1}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const _=this.a.slice(this.b,this.b+L).toString();return this.b+=L,_}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const _=this.a.slice(this.b,this.b+L).toString();return this.b+=L,_}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+L);return this.b+=L,z}static sizeMixedArray(L){let z=0;z+=1;for(let _=0,q=L.length;_<q;_++){const N=L[_];switch(z+=1,N.type){case 1:z+=this.sizeLongString(N.value);break;case 2:z+=this.sizeVSBuffer(N.value);break;case 3:z+=this.sizeUInt32,z+=this.sizeLongString(N.value);for(let M=0;M<N.buffers.length;++M)z+=this.sizeVSBuffer(N.buffers[M]);break;case 4:break}}return z}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let z=0,_=L.length;z<_;z++){const q=L[z];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let N=0;N<q.buffers.length;++N)this.writeBuffer(q.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const z=new Array(L);for(let _=0;_<L;_++)switch(this.readUInt8()){case 1:z[_]=this.readLongString();break;case 2:z[_]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),M=this.readLongString(),F=[];for(let B=0;B<N;++B)F.push(this.readVSBuffer());z[_]=new R.SerializableObjectWithBuffers(m(M,F,null));break}case 4:z[_]=void 0;break}return z}}r.sizeUInt32=4;var a;(function(I){I[I.Simple=0]="Simple",I[I.Mixed=1]="Mixed"})(a||(a={}));class n{static a(L){for(let z=0,_=L.length;z<_;z++)if(L[z]instanceof t.VSBuffer||L[z]instanceof R.SerializableObjectWithBuffers||typeof L[z]>"u")return!0;return!1}static serializeRequestArguments(L,z){if(this.a(L)){const _=[];for(let q=0,N=L.length;q<N;q++){const M=L[q];if(M instanceof t.VSBuffer)_[q]={type:2,value:M};else if(typeof M>"u")_[q]={type:4};else if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:B}=g(M.value,z);_[q]={type:3,value:t.VSBuffer.fromString(F),buffers:B}}else _[q]={type:1,value:t.VSBuffer.fromString(w(M,z))}}return{type:1,args:_}}return{type:0,args:w(L,z)}}static serializeRequest(L,z,_,q,N){switch(q.type){case 0:return this.b(L,z,_,q.args,N);case 1:return this.c(L,z,_,q.args,N)}}static b(L,z,_,q,N){const M=t.VSBuffer.fromString(_),F=t.VSBuffer.fromString(q);let B=0;B+=r.sizeUInt8(),B+=r.sizeShortString(M),B+=r.sizeLongString(F);const U=r.alloc(N?2:1,L,B);return U.writeUInt8(z),U.writeShortString(M),U.writeLongString(F),U.buffer}static deserializeRequestJSONArgs(L){const z=L.readUInt8(),_=L.readShortString(),q=L.readLongString();return{rpcId:z,method:_,args:JSON.parse(q)}}static c(L,z,_,q,N){const M=t.VSBuffer.fromString(_);let F=0;F+=r.sizeUInt8(),F+=r.sizeShortString(M),F+=r.sizeMixedArray(q);const B=r.alloc(N?4:3,L,F);return B.writeUInt8(z),B.writeShortString(M),B.writeMixedArray(q),B.buffer}static deserializeRequestMixedArgs(L){const z=L.readUInt8(),_=L.readShortString(),q=L.readMixedArray(),N=new Array(q.length);for(let M=0,F=q.length;M<F;M++){const B=q[M];typeof B=="string"?N[M]=JSON.parse(B):N[M]=B}return{rpcId:z,method:_,args:N}}static serializeAcknowledged(L){return r.alloc(5,L,0).buffer}static serializeCancel(L){return r.alloc(6,L,0).buffer}static serializeReplyOK(L,z,_){if(typeof z>"u")return this.d(L);if(z instanceof t.VSBuffer)return this.e(L,z);if(z instanceof R.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:N}=g(z.value,_,!0);return this.g(L,q,N)}else return this.f(L,E(z,_))}static d(L){return r.alloc(7,L,0).buffer}static e(L,z){let _=0;_+=r.sizeVSBuffer(z);const q=r.alloc(8,L,_);return q.writeVSBuffer(z),q.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,z){const _=t.VSBuffer.fromString(z);let q=0;q+=r.sizeLongString(_);const N=r.alloc(9,L,q);return N.writeLongString(_),N.buffer}static g(L,z,_){const q=t.VSBuffer.fromString(z);let N=0;N+=r.sizeUInt32,N+=r.sizeLongString(q);for(const F of _)N+=r.sizeVSBuffer(F);const M=r.alloc(10,L,N);M.writeUInt32(_.length),M.writeLongString(q);for(const F of _)M.writeBuffer(F);return M.buffer}static deserializeReplyOKJSON(L){const z=L.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(L,z){const _=L.readUInt32(),q=L.readLongString(),N=[];for(let M=0;M<_;++M)N.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(m(q,N,z))}static serializeReplyErr(L,z){const _=z?E(A.transformErrorForSerialization(z),null):void 0;if(typeof _!="string")return this.h(L);const q=t.VSBuffer.fromString(_);let N=0;N+=r.sizeLongString(q);const M=r.alloc(11,L,N);return M.writeLongString(q),M.buffer}static deserializeReplyErrError(L){const z=L.readLongString();return JSON.parse(z)}static h(L){return r.alloc(12,L,0).buffer}}var o;(function(I){I[I.RequestJSONArgs=1]="RequestJSONArgs",I[I.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",I[I.RequestMixedArgs=3]="RequestMixedArgs",I[I.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",I[I.Acknowledged=5]="Acknowledged",I[I.Cancel=6]="Cancel",I[I.ReplyOKEmpty=7]="ReplyOKEmpty",I[I.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",I[I.ReplyOKJSON=9]="ReplyOKJSON",I[I.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",I[I.ReplyErrError=11]="ReplyErrError",I[I.ReplyErrEmpty=12]="ReplyErrEmpty"})(o||(o={}));var p;(function(I){I[I.String=1]="String",I[I.VSBuffer=2]="VSBuffer",I[I.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",I[I.Undefined=4]="Undefined"})(p||(p={}))}),define(Se[282],ye([1,0,4,43,53,3,38,10,18]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new c.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new c.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(d=>v.push(d)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}t.Registry.add(e.Extensions.OutputChannels,new R);function P(C,v,d,g,m){return(0,S.createCancelablePromise)(async w=>{await(0,D.whenProviderRegistered)(d,g);const f=t.Registry.as(e.Extensions.OutputChannels);try{await E(d,1,g,m,w),f.registerChannel({id:C,label:v,file:d,log:!0})}catch(h){(0,T.isCancellationError)(h)||m.error("Error while registering log channel",d.toString(),(0,T.getErrorMessage)(h))}})}e.registerLogChannel=P;async function E(C,v,d,g,m){if(!await d.exists(C)){if(m.isCancellationRequested)throw new T.CancellationError;if(v>10)throw new Error("Timed out while waiting for file to be created");g.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",C.toString()),await(0,S.timeout)(1e3,m),await E(C,v+1,d,g,m)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new k.RawContextKey("activeOutputChannel","")}),define(Se[141],ye([1,0,5,3,16,27,13,282,71,25,47,155,22,11,38,4,6]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class m extends D.AbstractMessageLogger{get disposed(){return this.l}constructor(b,s,i,l,u){super(),this.id=b,this.name=s,this.m=i,this.n=l,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(i.getLevel()),this.B(i.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.k;this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Clear,b)}replace(b){const s=this.k;this.info(b),this.n.$update(this.id,T.OutputChannelUpdateMode.Replace,s),this.visible&&this.m.flush()}show(b,s){this.m.flush(),this.n.$reveal(this.id,!!(typeof b=="boolean"?b:s))}hide(){this.n.$close(this.id)}g(b,s){this.k+=E.VSBuffer.fromString(s).byteLength,(0,D.log)(this.m,b,s),this.visible&&(this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class w extends m{appendLine(b){this.append(b)}}let f=class{constructor(b,s,i,l,u,r){this.i=s,this.j=i,this.k=l,this.l=u,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(c.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[s,i]of this.g)i.visible=s===this.h}createOutputChannel(b,s,i){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const l=typeof s=="object"&&s.log,u=(0,C.isString)(s)?s:void 0;if((0,C.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const a=this.i.environment.extensionLogLevel?.find(([o])=>A.ExtensionIdentifier.equals(i.identifier,o))?.[1];a&&(r=(0,D.parseLogLevel)(a));const n=l?this.o(b,r,i):this.n(b,u,i);return n.then(o=>{this.g.set(o.id,o),o.visible=o.id===this.h}),l?this.r(b,r??this.m.getLevel(),n):this.q(b,n)}async n(b,s,i){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const l=await this.c,u=this.k.extUri.joinPath(l,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),a=await this.a.$register(b,u,!1,s,i.identifier.value);return new m(a,b,r,this.a,i)}async o(b,s,i){const l=await this.p(i),u=this.k.extUri.joinPath(l,`${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(u,{name:b},s),a=await this.a.$register(b,u,!0,void 0,i.identifier.value);return new w(a,b,r,this.a,i)}p(b){let s=this.d.get(b.identifier.value);if(!s){const i=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(i)}catch(l){if((0,v.toFileSystemProviderErrorCode)(l)!==v.FileSystemProviderErrorCode.FileExists)throw l}return i})())}return s}q(b,s){let i=!1;const l=()=>{if(i)throw new Error("Channel has been closed")};return{get name(){return b},append(u){l(),s.then(r=>r.append(u))},appendLine(u){l(),s.then(r=>r.appendLine(u))},clear(){l(),s.then(u=>u.clear())},replace(u){l(),s.then(r=>r.replace(u))},show(u,r){l(),s.then(a=>a.show(u,r))},hide(){l(),s.then(u=>u.hide())},dispose(){i=!0,s.then(u=>u.dispose())}}}r(b,s,i){const l=new g.DisposableStore,u=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},r=l.add(new d.Emitter);return i.then(a=>{l.add(a),l.add(a.onDidChangeLogLevel(n=>{s=n,r.fire(n)}))}),{...this.q(b,i),get logLevel(){return s},onDidChangeLogLevel:r.event,trace(a,...n){u(),i.then(o=>o.trace(a,...n))},debug(a,...n){u(),i.then(o=>o.debug(a,...n))},info(a,...n){u(),i.then(o=>o.info(a,...n))},warn(a,...n){u(),i.then(o=>o.warn(a,...n))},error(a,...n){u(),i.then(o=>o.error(a,...n))},dispose(){l.dispose()}}}};f=qe([We(0,k.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,S.IExtHostConsumerFileSystem),We(3,R.IExtHostFileSystemInfo),We(4,D.ILoggerService),We(5,D.ILogService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(Se[283],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(Se[284],ye([1,0,32,15,9,12,24,2,3,209,46,226,283]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let C=class ri{constructor(d,g,m,w){this.d=d,this.e=g,this.f=m,this.g=w,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const f=await this.e.getEnvironment();return this.c=f?.userHome??d})()}hasValidBasename(d,g,m){return typeof g=="string"||typeof g>"u"?this.a.then(w=>this.h(d,w,g)):this.h(d,g,m)}h(d,g,m){return d.scheme===t.Schemas.file||d.scheme===t.Schemas.vscodeRemote?(0,c.isValidBasename)(m??(0,D.basename)(d),g===1):!0}get defaultUriScheme(){return ri.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,g){if(d.remoteAuthority)return t.Schemas.vscodeRemote;const m=(0,y.getVirtualWorkspaceScheme)(g.getWorkspace());if(m)return m;const w=g.getWorkspace().folders[0];if(w)return w.uri.scheme;const f=g.getWorkspace().configuration;return f?f.scheme:t.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?k.win32:k.posix)}async fileURI(d){let g="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const w=d.indexOf("/",2);w===-1?(g=d.substring(2),d="/"):(g=d.substring(2,w),d=d.substring(w)||"/")}return T.URI.from({scheme:t.Schemas.file,authority:g,path:d,query:"",fragment:""})}};C=qe([We(1,E.IRemoteAgentService),We(2,P.IWorkbenchEnvironmentService),We(3,R.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(Se[74],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(D,T){this.line=D,this.character=T}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,T){return new c(0,0)}with(D){return new c(0,0)}}e.Position=c;class t{constructor(D,T,S,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(D,T),this.end=new c(S,y)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new t(0,0,0,0)}with(D){return new t(0,0,0,0)}}e.Range=t;var k;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Se[31],ye([1,0,17,37,23,32,8,3,9,10,74,18]),function(ne,e,c,t,k,A,D,T,S,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",C=" characters skipped \u27EB",v=(E.length+C.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var d;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function m(Y){return!!Y.preview}e.resultIsMatch=m;function w(Y){return!!Y.resource}e.isFileMatch=w;function f(Y){return!!Y.message}e.isProgressMessage=f;var h;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(J){this.resource=J,this.results=[]}}e.FileMatch=b;class s{constructor(J,te,le){this.ranges=te;const Z=Array.isArray(te)?te:[te];if(le&&le.matchLines===1&&i(Z)){J=(0,D.getNLines)(J,le.matchLines);let ge="",ve=0,De=0;const Re=Math.floor(le.charsPerLine/5),ze=[];for(const se of Z){const ue=Math.max(se.startColumn-Re,0),he=se.startColumn+le.charsPerLine;if(ue>De+Re+v){const ee=E+(ue-De)+C;ge+=ee+J.slice(ue,he),ve+=ue-(De+ee.length)}else ge+=J.slice(De,he);ze.push(new u(0,se.startColumn-ve,se.endColumn-ve)),De=he}this.preview={text:ge,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const ge=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:J,matches:(0,c.mapArrayOrNot)(te,ve=>new l(ve.startLineNumber-ge,ve.startColumn,ve.endLineNumber-ge,ve.endColumn))}}}}e.TextSearchMatch=s;function i(Y){const J=Y[0].startLineNumber;for(const te of Y)if(te.startLineNumber!==J||te.endLineNumber!==J)return!1;return!0}class l{constructor(J,te,le,Z){this.startLineNumber=J,this.startColumn=te,this.endLineNumber=le,this.endColumn=Z}}e.SearchRange=l;class u extends l{constructor(J,te,le){super(J,te,J,le)}}e.OneLineRange=u;var r;(function(Y){Y.List="list",Y.Tree="tree"})(r=e.ViewMode||(e.ViewMode={}));var a;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Y,J=!0){const te=Y&&Y.files&&Y.files.exclude,le=J&&Y&&Y.search&&Y.search.exclude;if(!te&&!le)return;if(!te||!le)return te||le;let Z=Object.create(null);return Z=k.mixin(Z,k.deepClone(te)),Z=k.mixin(Z,k.deepClone(le),!0),Z}e.getExcludes=n;function o(Y,J){return Y.excludePattern&&t.match(Y.excludePattern,J)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&t.match(Y.includePattern,J)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(te=>{const le=te.folder.fsPath;if(A.isEqualOrParent(J,le)){const Z=S.relative(le,J);return!te.includePattern||!!t.match(te.includePattern,Z)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var p;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class I extends Error{constructor(J,te){super(J),this.code=te}}e.SearchError=I;function L(Y){const J=Y.message;if((0,y.isCancellationError)(Y))return new I(J,p.canceled);try{const te=JSON.parse(J);return new I(te.message,te.code)}catch{return new I(J,p.other)}}e.deserializeSearchError=L;function z(Y){const J={message:Y.message,code:Y.code};return new Error(JSON.stringify(J))}e.serializeSearchError=z;function _(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=_;function q(Y){return Y.type==="success"}e.isSerializedSearchSuccess=q;function N(Y){return!!Y.path}e.isSerializedFileMatch=N;function M(Y,J){const te=Y.searchPath?Y.searchPath:Y.relativePath;return(0,D.fuzzyContains)(te,J)}e.isFilePatternMatch=M;class F{constructor(J){this.path=J,this.results=[]}addMatch(J){this.results.push(J)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function B(Y,J){const te={...Y||{},...J||{}};return Object.keys(te).filter(le=>{const Z=te[le];return typeof Z=="boolean"&&Z})}e.resolvePatternsForProvider=B;class U{constructor(J,te){this.c=null,this.a={...J.excludePattern||{},...te.excludePattern||{}},this.b=t.parse(this.a);let le=J.includePattern;te.includePattern&&(le?le={...le,...te.includePattern}:le=te.includePattern),le&&(this.c=t.parse(le))}matchesExcludesSync(J,te,le){return!!(this.b&&this.b(J,te,le))}includedInQuerySync(J,te,le){return!(this.b&&this.b(J,te,le)||this.c&&!this.c(J,te,le))}includedInQuery(J,te,le){const Z=this.b(J,te,le),ge=()=>this.c?!!this.c(J,te,le):!0;return(0,P.isThenable)(Z)?Z.then(ve=>ve?!1:ge()):ge()}hasSiblingExcludeClauses(){return H(this.a)}}e.QueryGlobTester=U;function H(Y){for(const J in Y)if(typeof Y[J]!="boolean")return!0;return!1}function X(Y){if(!Y)return;let J;return te=>(J||(J=(Y()||Promise.resolve([])).then(le=>le?x(le):{})),J.then(le=>!!le[te]))}e.hasSiblingPromiseFn=X;function V(Y){if(!Y)return;let J;return te=>{if(!J){const le=Y();J=le?x(le):{}}return!!J[te]}}e.hasSiblingFn=V;function x(Y){const J={};for(const te of Y)J[te]=!0;return J}}),define(Se[33],ye([1,0,17,18,21,4,6,64,15,100,24,8,11,2,178,3,13,198,46,47,25,16,14,7,55,31,5]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h,b,s,i,l,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(q,N,M){return new R.ExtUri(F=>I(F,M)).isEqual(q,N)}function n(q,N,M){return a(q.uri,N.uri,M)?0:(0,P.compare)(q.uri.toString(),N.uri.toString())}function o(q,N,M){return q.index!==N.index?q.index<N.index?-1:1:a(q.uri,N.uri,M)?(0,P.compare)(q.name,N.name):(0,P.compare)(q.uri.toString(),N.uri.toString())}function p(q,N,M,F){const B=q.slice(0).sort((H,X)=>M(H,X,F)),U=N.slice(0).sort((H,X)=>M(H,X,F));return(0,c.delta)(B,U,(H,X)=>M(H,X,F))}function I(q,N){const M=N.getCapabilities(q.scheme);return!(M&&M&1024)}class L extends w.Workspace{static toExtHostWorkspace(N,M,F,B){if(!N)return{workspace:null,added:[],removed:[]};const{id:U,name:H,folders:X,configuration:V,transient:x,isUntitled:Y}=N,J=[],te=M;M?X.forEach((ve,De)=>{const Re=C.URI.revive(ve.uri),ze=L.e(F||M,Re,B);ze?(ze.name=ve.name,ze.index=ve.index,J.push(ze)):J.push({uri:Re,name:ve.name,index:De})}):J.push(...X.map(({uri:ve,name:De,index:Re})=>({uri:C.URI.revive(ve),name:De,index:Re}))),J.sort((ve,De)=>ve.index<De.index?-1:1);const le=new L(U,H,J,!!x,V?C.URI.revive(V):null,!!Y,ve=>I(ve,B)),{added:Z,removed:ge}=p(te?te.workspaceFolders:[],le.workspaceFolders,n,B);return{workspace:le,added:Z,removed:ge}}static e(N,M,F){for(let B=0;B<N.folders.length;B++){const U=N.workspaceFolders[B];if(a(U.uri,M,F))return U}}constructor(N,M,F,B,U,H,X){super(N,F.map(V=>new w.WorkspaceFolder(V)),B,U,X),this.s=M,this.t=H,this.o=[],this.q=T.TernarySearchTree.forUris(X),F.forEach(V=>{this.o.push(V),this.q.set(V.uri,V)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(N,M){return M&&this.q.get(N)&&(N=(0,R.dirname)(N)),this.q.findSubstr(N)}resolveWorkspaceFolder(N){return this.q.get(N)}}let z=class{constructor(N,M,F,B,U){this.c=new A.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new A.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=B,this.q=F,this.s=U,this.h=new y.Counter,this.j=new t.Barrier,this.n=N.getProxy(r.MainContext.MainThreadWorkspace),this.o=N.getProxy(r.MainContext.MainThreadMessageService);const H=M.workspace;this.k=H?new L(H.id,H.name,[],!!H.transient,H.configuration?C.URI.revive(H.configuration):null,!!H.isUntitled,X=>I(X,F)):void 0}$initializeWorkspace(N,M){this.u=M,this.$acceptWorkspaceData(N),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?C.URI.from({scheme:S.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(N,M,F,...B){const U=[];if(Array.isArray(B)&&B.forEach(Y=>{C.URI.isUri(Y.uri)&&!U.some(J=>a(J.uri,Y.uri,this.q))&&U.push({uri:Y.uri,name:Y.name||(0,R.basenameOrAuthority)(Y.uri)})}),this.l||[M,F].some(Y=>typeof Y!="number"||Y<0)||F===0&&U.length===0)return!1;const H=this.w?this.w.workspaceFolders:[];if(M+F>H.length)return!1;const X=H.slice(0);X.splice(M,F,...U.map(Y=>({uri:Y.uri,name:Y.name||(0,R.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<X.length;Y++){const J=X[Y];if(X.some((te,le)=>le!==Y&&a(J.uri,te.uri,this.q)))return!1}X.forEach((Y,J)=>Y.index=J);const{added:V,removed:x}=p(H,X,o,this.q);if(V.length===0&&x.length===0)return!1;if(this.n){const Y=N.displayName||N.name;this.n.$updateWorkspaceFolders(Y,M,F,U).then(void 0,J=>{this.l=void 0;const te={source:{identifier:N.identifier,label:N.displayName||N.name}};this.o.$showMessage(m.Severity.Error,(0,v.localize)(0,null,Y,J.toString()),te,[])})}return this.x(X),!0}getWorkspaceFolder(N,M){if(!!this.w)return this.w.getWorkspaceFolder(N,M)}async getWorkspaceFolder2(N,M){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(N,M)}async resolveWorkspaceFolder(N){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(N)}getPath(){if(!this.w)return;const{folders:N}=this.w;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,M){let F,B="";if(typeof N=="string"?(F=C.URI.file(N),B=N):typeof N<"u"&&(F=N,B=N.fsPath),!F)return B;const U=this.getWorkspaceFolder(F,!0);if(!U)return B;typeof M>"u"&&this.w&&(M=this.w.folders.length>1);let H=(0,R.relativePath)(U.uri,F);return M&&U.name&&(H=`${U.name}/${H}`),H}x(N){this.w&&(this.l=L.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:N,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:M,added:F,removed:B}=L.toExtHostWorkspace(N,this.k,this.l,this.q);this.k=M||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:B}))}findFiles(N,M,F,B,U=k.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let H;if(M===null?H=!1:M&&(typeof M=="string"?H=M:H=M.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:V}=_(s.GlobPattern.from(N));return this.n.$startFileSearch((0,E.withUndefinedAsNull)(X),(0,E.withUndefinedAsNull)(V),(0,E.withUndefinedAsNull)(H),(0,E.withUndefinedAsNull)(F),U).then(x=>Array.isArray(x)?x.map(Y=>C.URI.revive(Y)):[])}async findTextInFiles(N,M,F,B,U=k.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const H=this.h.getNext(),X=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:V,folder:x}=_(s.GlobPattern.from(M.include)),Y=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,J={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:X,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:V,excludePattern:Y},te=!1;if(this.t[H]=le=>{if(te)return;const Z=C.URI.revive(le.resource);le.results.forEach(ge=>{(0,u.resultIsMatch)(ge)?F({uri:Z,preview:{text:ge.preview.text,matches:(0,c.mapArrayOrNot)(ge.preview.matches,ve=>new i.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,c.mapArrayOrNot)(ge.ranges,ve=>new i.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):F({uri:Z,text:ge.text,lineNumber:ge.lineNumber})})},U.isCancellationRequested)return{};try{const le=await this.n.$startTextSearch(N,(0,E.withUndefinedAsNull)(x),J,H,U);return delete this.t[H],le||{}}catch(le){throw delete this.t[H],le}}$handleTextSearchResult(N,M){this.t[M]?.(N)}saveAll(N){return this.n.$saveAll(N)}resolveProxy(N){return this.n.$resolveProxy(N)}get trusted(){return this.u}requestWorkspaceTrust(N){return this.n.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(N,M){if(this.v.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.v.set(N,M);const F=this.s.transformOutgoingScheme(N),B=this.y++;return this.n.$registerEditSessionIdentityProvider(B,F),(0,D.toDisposable)(()=>{this.v.delete(N),this.n.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(N,M){this.g.info("Getting edit session identifier for workspaceFolder",N);const F=await this.resolveWorkspaceFolder(C.URI.revive(N));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const U=await B.provideEditSessionIdentity(F,M);if(this.g.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(N,M,F,B){this.g.info("Getting edit session identifier for workspaceFolder",N);const U=await this.resolveWorkspaceFolder(C.URI.revive(N));if(!U){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const H=this.v.get(U.uri.scheme);if(this.g.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!H),!H)return;const X=await H.provideEditSessionIdentityMatch?.(M,F,B);if(this.g.info("Provider returned edit session identifier match result: ",X),!!X)return X}};z=qe([We(0,b.IExtHostRpcService),We(1,h.IExtHostInitDataService),We(2,f.IExtHostFileSystemInfo),We(3,g.ILogService),We(4,l.IURITransformerService)],z),e.ExtHostWorkspace=z,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function _(q){let N,M;return q&&(typeof q=="string"?N=q:(N=q.pattern,M=C.URI.revive(q.baseUri))),{includePattern:N,folder:M}}}),define(Se[34],ye([1,0,23,4,33,5,7,201,126,11,18,3,16,13,2]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(i,l){if(l){const u=l.split(".");let r=i;for(let a=0;r&&a<u.length;a++)r=r[u[a]];return r}}function g(i){return i instanceof v.URI}function m(i){return i&&i.uri instanceof v.URI&&i.languageId&&typeof i.languageId=="string"}function w(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function f(i){return i&&i.uri instanceof v.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function h(i){if(g(i))return{resource:i};if(m(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(w(i))return{overrideIdentifier:i.languageId};if(f(i))return{resource:i.uri};if(i===null)return{resource:null}}let b=class{constructor(l,u,r){this.a=l.getProxy(A.MainContext.MainThreadConfiguration),this.c=u,this.b=r,this.d=new R.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new s(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,u){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(l,u))}};b=qe([We(0,E.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,C.ILogService)],b),e.ExtHostConfiguration=b;class s{constructor(l,u,r,a){this.a=new t.Emitter,this.b=l,this.f=a,this.c=u,this.e=T.Configuration.parse(r),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,u){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=T.Configuration.parse(l),this.d=this.k(l.configurationScopes),this.a.fire(this.j(u,r))}getConfiguration(l,u,r){const a=h(u)||{},n=this.g(l?d(this.e.getValue(void 0,a,this.c.workspace),l):this.e.getValue(void 0,a,this.c.workspace));l&&this.h(l,a,r?.identifier);function o(I){if(I==null)return null;if(typeof I=="boolean")return I?2:5;switch(I){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(I){return typeof d(n,I)<"u"},get:(I,L)=>{this.h(l?`${l}.${I}`:I,a,r?.identifier);let z=d(n,I);if(typeof z>"u")z=L;else{let _;const q=(N,M)=>{let F;const B=()=>{_=_||(0,c.deepClone)(n),F=F||d(_,M)};return(0,y.isObject)(N)?new Proxy(N,{get:(U,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return B(),()=>F;if(_)return F=F||d(_,M),F[H];const X=U[H];return typeof H=="string"?q(X,`${M}.${H}`):X},set:(U,H,X)=>(B(),F&&(F[H]=X),!0),deleteProperty:(U,H)=>(B(),F&&delete F[H],!0),defineProperty:(U,H,X)=>(B(),F&&Object.defineProperty(F,H,X),!0)}):N};z=q(z,I)}return z},update:(I,L,z,_)=>{I=l?`${l}.${I}`:I;const q=o(z);return L!==void 0?this.b.$updateConfigurationOption(q,I,L,a,_):this.b.$removeConfigurationOption(q,I,a,_)},inspect:I=>{I=l?`${l}.${I}`:I;const L=this.e.inspect(I,a,this.c.workspace);if(L)return{key:I,defaultValue:(0,c.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,c.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,c.deepClone)(L.workspace?.value),workspaceFolderValue:(0,c.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(L.default?.override),globalLanguageValue:(0,c.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,c.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(L.workspaceFolder?.override),languageIds:(0,c.deepClone)(L.overrideIdentifiers)}}};return typeof n=="object"&&(0,c.mixin)(p,n,!1),Object.freeze(p)}g(l){const u=r=>(0,y.isObject)(r)?new Proxy(r,{get:(a,n)=>u(a[n]),set:(a,n,o)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(a,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(a,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return u(l)}h(l,u,r){const a=S.OVERRIDE_PROPERTY_REGEX.test(l)?4:this.d.get(l),n=r?`[${r.value}] `:"";if(a===4){typeof u?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){u?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,u){const r=new T.ConfigurationChangeEvent(l,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(a,n)=>r.affectsConfiguration(a,h(n))})}k(l){return l.reduce((u,r)=>(u.set(r[0],r[1]),u),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[75],ye([1,0,2,18,4,5,7,33,58,34,21,40,16,25,3,15,12,13,70,239,10]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(N){function M(B){if(B!=null)return B}N.from=M;function F(B){if(B!=null)return B}N.to=F})(s||(s={}));var i;(function(N){function M(B){if(B!=null)return B}N.from=M;function F(B){if(B!=null)return B}N.to=F})(i||(i={}));var l;(function(N){function M(B){if(B!=null)return B}N.from=M;function F(B){if(B!=null)return B}N.to=F})(l||(l={}));var u;(function(N){function M(U){if(U){const H=U;return H&&!!H.process}else return!1}N.is=M;function F(U){if(U==null)return;const H={process:U.process,args:U.args};return U.options&&(H.options=l.from(U.options)),H}N.from=F;function B(U){if(U!=null)return new D.ProcessExecution(U.process,U.args,U.options)}N.to=B})(u||(u={}));var r;(function(N){function M(B){if(B!=null)return B}N.from=M;function F(B){if(B!=null)return B}N.to=F})(r||(r={}));var a;(function(N){function M(U){if(U){const H=U;return H&&(!!H.commandLine||!!H.command)}else return!1}N.is=M;function F(U){if(U==null)return;const H={};return U.commandLine!==void 0?H.commandLine=U.commandLine:(H.command=U.command,H.args=U.args),U.options&&(H.options=r.from(U.options)),H}N.from=F;function B(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new D.ShellExecution(U.commandLine,U.options):new D.ShellExecution(U.command,U.args?U.args:[],U.options)}N.to=B})(a||(a={}));var n;(function(N){function M(U){if(U){const H=U;return H&&H.customExecution==="customExecution"}else return!1}N.is=M;function F(U){return{customExecution:"customExecution"}}N.from=F;function B(U,H){return H.get(U)}N.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var o;(function(N){function M(F,B){let U;return F.scope!==void 0&&typeof F.scope!="number"?U=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===D.TaskScope.Workspace&&B&&B.workspaceFile?U=B.workspaceFile:U=f.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:U}}N.from=M})(o=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(N){function M(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}N.from=M})(p||(p={}));var I;(function(N){function M(U,H){if(U==null)return[];const X=[];for(const V of U){const x=F(V,H);x&&X.push(x)}return X}N.fromMany=M;function F(U,H){if(U==null)return;let X;U.execution instanceof D.ProcessExecution?X=u.from(U.execution):U.execution instanceof D.ShellExecution?X=a.from(U.execution):U.execution&&U.execution instanceof D.CustomExecution&&(X=n.from(U.execution));const V=s.from(U.definition);let x;return U.scope?typeof U.scope=="number"?x=U.scope:x=U.scope.uri:x=D.TaskScope.Workspace,!V||!x?void 0:{_id:U._id,definition:V,name:U.name,source:{extensionId:H.identifier.value,label:U.source,scope:x},execution:X,isBackground:U.isBackground,group:p.from(U.group),presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}N.from=F;async function B(U,H,X){if(U==null)return;let V;u.is(U.execution)?V=u.to(U.execution):a.is(U.execution)?V=a.to(U.execution):n.is(U.execution)&&(V=n.to(U._id,X));const x=s.to(U.definition);let Y;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Y=U.source.scope:Y=await H.resolveWorkspaceFolder(c.URI.revive(U.source.scope)):Y=D.TaskScope.Workspace),!x||!Y)return;const J=new D.Task(x,Y,U.name,U.source.label,V,U.problemMatchers);return U.isBackground!==void 0&&(J.isBackground=U.isBackground),U.group!==void 0&&(J.group=D.TaskGroup.from(U.group._id),J.group&&U.group.isDefault&&(J.group=new D.TaskGroup(J.group.id,J.group.label),U.group.isDefault===!0&&(J.group.isDefault=U.group.isDefault))),U.presentationOptions&&(J.presentationOptions=i.to(U.presentationOptions)),U._id&&(J._id=U._id),U.detail&&(J.detail=U.detail),J}N.to=B})(I=e.TaskDTO||(e.TaskDTO={}));var L;(function(N){function M(B){return B}N.from=M;function F(B){if(!!B)return Object.assign(Object.create(null),B)}N.to=F})(L||(L={}));class z{constructor(M,F,B){this._id=F,this.a=B,b.set(this,void 0),Je(this,b,M,"f")}get task(){return this.a}terminate(){Fe(this,b,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}b=new WeakMap;let _=class{constructor(M,F,B,U,H,X,V,x){this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.t=new k.Emitter,this.a=M.getProxy(A.MainContext.MainThreadTask),this.b=B,this.c=U,this.d=H,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=V,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,F,B){if(!B)return new D.Disposable(()=>{});const U=this.w();return this.j.set(U,{type:F,provider:B,extension:M}),this.a.$registerTaskProvider(U,F),new D.Disposable(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(M,F){this.a.$registerTaskSystem(M,F)}fetchTasks(M){return this.a.$fetchTasks(L.from(M)).then(async F=>{const B=[];for(const U of F){const H=await I.to(U,this.b,this.m);H&&B.push(H)}return B})}get taskExecutions(){const M=[];return this.k.forEach(F=>M.push(F)),M}terminateTask(M){if(!(M instanceof z))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,F,B){const U=this.m.get(M.id);U&&(this.o.set(M.id,U),this.e.attachPtyToTerminal(F,await U.callback(B))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const F=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const F=await this.y(M.id);this.s.fire({execution:F,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const F=await this.y(M.id);this.t.fire({execution:F,exitCode:M.exitCode})}$provideTasks(M,F){const B=this.j.get(M);if(!B)return Promise.reject(new Error("no handler found"));const U=[],H=(0,t.asPromise)(()=>B.provider.provideTasks(R.CancellationToken.None)).then(X=>this.u(F,U,B,X));return new Promise(X=>{H.then(V=>{Promise.all(U).then(()=>{X(V)})})})}async $resolveTask(M,F){const B=this.j.get(M);if(!B)return Promise.reject(new Error("no handler found"));if(F.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${B.type}].`);const U=await I.to(F,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const H=await B.provider.resolveTask(U,R.CancellationToken.None);if(!H)return;this.z(H,B);const X=I.from(H,B.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(X.execution)&&await this.x(X,H,!0),await this.v(X)}w(){return this.h++}async x(M,F,B){const U=await this.a.$createTaskId(M);!B&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,F.execution)),this.m.set(U,F.execution)}async y(M,F){if(typeof M=="string"){const H=this.l.get(M);if(!H)throw new h.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return H}const B=this.l.get(M.id);if(B)return B;const U=new Promise((H,X)=>{function V(x,Y,J){J?H(new z(x,Y.id,J)):X("Unexpected: Task does not exist.")}F?V(this,M,F):I.to(M.task,this.b,this.m).then(x=>V(this,M,x))});return this.l.set(M.id,U),U.then(H=>(this.k.set(M.id,H),H),H=>Promise.reject(H))}z(M,F){M._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const B=this.n.values();let U=B.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=B.next()}};_=qe([We(0,E.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,y.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,m.ILogService),We(7,w.IExtHostApiDeprecationService)],_),e.ExtHostTaskBase=_;let q=class extends _{constructor(M,F,B,U,H,X,V,x){super(M,F,B,U,H,X,V,x),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(M,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const B=I.from(F,M);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.x(B,F,!1);else throw new h.NotSupportedError;const U=await this.y(await this.a.$getTaskExecution(B),F);return this.a.$executeTask(B).catch(H=>{throw new Error(H)}),U}u(M,F,B,U){const H=[];if(U)for(const X of U){this.z(X,B),(!X.definition||!M[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const V=I.from(X,B.extension);V&&n.is(V.execution)?(H.push(V),F.push(this.x(V,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:H,extension:B.extension}}async v(M){if(n.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,F,B){}};q=qe([We(0,E.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,y.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,m.ILogService),We(7,w.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(Se[285],ye([1,0,9,21,51,37,24,44,31]),function(ne,e,c,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(E,C,v){this.k=E,this.l=C,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=E.filePattern,this.b=E.includePattern&&A.parse(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.h=new Set,this.j=E.excludePattern&&A.parse(E.excludePattern)}cancel(){this.g=!0,this.h.forEach(E=>E.cancel()),this.h=new Set}search(E){const C=this.k.folderQueries||[];return new Promise((v,d)=>{const g=m=>{this.f++,E(m)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(m=>{const w=m.toString(),f=c.basename(w);this.j&&this.j(w,f)||this.v(g,{base:m,basename:f})}),Promise.all(C.map(m=>this.p(m,g))).then(m=>{v({limitHit:this.e,stats:m[0]||void 0})},m=>{d(new Error((0,k.toErrorMessage)(m)))})})}async p(E,C){const v=new t.CancellationTokenSource,d=this.q(E),g=this.r(),m=new S.QueryGlobTester(this.k,E),w=!m.hasSiblingExcludeClauses();let f;try{this.h.add(v),f=T.StopWatch.create();const h=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,v.token),b=f.elapsed(),s=T.StopWatch.create();return this.g&&!this.e||(h&&h.forEach(i=>{const l=c.posix.relative(E.folder.path,i.path);if(w){const u=c.basename(i.path);this.v(C,{base:E.folder,relativePath:l,basename:u});return}this.s(g,E.folder,l,C)}),this.g&&!this.e)?null:(this.u(g,m,C),{providerTime:b,postProcessTime:s.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(E){const C=(0,S.resolvePatternsForProvider)(this.k.includePattern,E.includePattern),v=(0,S.resolvePatternsForProvider)(this.k.excludePattern,E.excludePattern);return{folder:E.folder,excludes:v,includes:C,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}s({pathToEntries:E},C,v,d){if(v===this.a){const m=c.basename(this.a);this.v(d,{base:C,relativePath:this.a,basename:m})}function g(m){const w=c.basename(m),f=c.dirname(m);let h=E[f];h||(h=E[f]=[],g(f)),h.push({base:C,relativePath:m,basename:w})}g(v)}u({rootEntries:E,pathToEntries:C},v,d){const g=this,m=this.a;function w(f){const h=(0,S.hasSiblingFn)(()=>f.map(b=>b.basename));for(let b=0,s=f.length;b<s;b++){const i=f[b],{relativePath:l,basename:u}=i;if(v.matchesExcludesSync(l,u,m!==u?h:void 0))continue;const r=C[l];if(r)w(r);else{if(l===m)continue;g.v(d,i)}if(g.e)break}}w(E)}v(E,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||E(C))}}class R{constructor(){this.b=new Map}fileSearch(E,C,v,d){const g=this.c(E.cacheKey),m=new y(E,C,g&&g.token);let w=0;const f=h=>{w+=h.length,v(h.map(b=>this.d(b)))};return this.e(m,R.a,f,d).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:h.stats}}))}clearCache(E){this.c(E)?.cancel()}c(E){if(!!E)return this.b.has(E)||this.b.set(E,new t.CancellationTokenSource),this.b.get(E)}d(E){return E.relativePath?{resource:D.joinPath(E.base,E.relativePath)}:{resource:E.base}}e(E,C,v,d){d.onCancellationRequested(()=>{E.cancel()});const g=w=>{w&&(m.push(w),C>0&&m.length>=C&&(v(m),m=[]))};let m=[];return E.search(g).then(w=>(m.length&&v(m),w),w=>(m.length&&v(m),Promise.reject(w)))}}e.FileSearchManager=R,R.a=512}),define(Se[286],ye([1,0,17,80,37,111,28,15,9,24,8,11,2,162,189,52,13,46,133,284,31]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(p,I,L,z,_){this.a=p,this.b=I,this.c=L,this.d=z,this.e=_}text(p,I,L={}){p=this.f(p,L);const z=this.a.getValue(),_=I&&I.some(N=>!this.a.getValue({resource:N}).search.useRipgrep);return{...this.h(I?.map(m.toWorkspaceFolder),L),type:2,contentPattern:p,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:z.search.usePCRE2||_||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(p,I){const L=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const z={...p,wordSeparators:L.editor.wordSeparators};return this.j(p,I)&&(z.isCaseSensitive=!0),this.k(p)&&(z.isMultiline=!0),z}file(p,I={}){return{...this.h(p,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}g(p,I){return p?(p=Array.isArray(p)?p.map(r):r(p),I?this.parseSearchPaths(p):{pattern:i(...Array.isArray(p)?p:[p])}):{}}h(p=[],I={}){const L=this.g(I.includePattern,I.expandPatterns),z=this.g(I.excludePattern,I.expandPatterns),_=p.length>1,q=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(F=>this.q(F,I,z)):p.map(F=>this.r(F,I,z,_))).filter(F=>!!F),N={_reason:I._reason,folderQueries:q,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:z.pattern,includePattern:L.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const F=c.coalesce(c.flatten(this.c.groups.map(H=>H.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(H=>(0,h.pathIncludedInQuery)(N,H.fsPath)),U=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...N,...U}}const M=I.extraFileResources&&I.extraFileResources.filter(F=>(0,h.pathIncludedInQuery)(N,F.fsPath));return N.extraFileResources=M&&M.length?M:void 0,N}i(p){const I=[],L=new D.ResourceMap,z={};let _=!1;return p.forEach(q=>{if(q.scheme===T.Schemas.walkThrough)return;if((0,y.isAbsolutePath)(q)){const M=this.b.getWorkspaceFolder(q)?.uri??q.with({path:S.dirname(q.fsPath)});let F=L.get(M);F||(_=!0,F={folder:M,includePattern:{}},I.push(F),L.set(M,F));const B=S.relative(M.fsPath,q.fsPath);(0,P.assertIsDefined)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else q.fsPath&&(_=!0,z[q.fsPath]=!0)}),{folderQueries:I,includePattern:z,usingSearchPaths:!0,excludePattern:_?void 0:{"**/*":!0}}}j(p,I){if(I.isSmartCase){if(p.isRegExp){if(R.containsUppercaseCharacter(p.pattern,!0))return!0}else if(R.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,C.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const I=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),z=(Array.isArray(p)?p:l(p)).map(U=>{const H=this.e.resolvedUserHome;return H?(0,A.untildify)(U,H.scheme===T.Schemas.file?H.fsPath:H.path):U}),_=t.groupBy(z,U=>I(U)?"searchPaths":"exprSegments"),q=(_.exprSegments||[]).map(U=>R.rtrim(U,"/")).map(U=>R.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),u(U))),N={},M=this.m(_.searchPaths||[]);M&&M.length&&(N.searchPaths=M);const F=c.flatten(q),B=i(...F);return B&&(N.pattern=B),N}l(p,I){return I.disregardExcludeSettings?void 0:(0,h.getExcludes)(p,!I.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const I=c.flatten(p.map(z=>{let{pathPortion:_,globPortion:q}=s(z);q&&(q=a(q));const N=this.n(_);return c.flatten(N.map(M=>this.o(M,q)))})),L=new Map;return I.forEach(z=>{const _=z.searchPath.toString(),q=L.get(_);q?z.pattern&&(q.pattern=q.pattern||{},q.pattern[z.pattern]=!0):L.set(_,{searchPath:z.searchPath,pattern:z.pattern?i(z.pattern):void 0})}),Array.from(L.values())}n(p){if(S.isAbsolute(p)){const I=this.b.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==T.Schemas.file?[{searchPath:I[0].uri.with({path:p})}]:[{searchPath:E.URI.file(S.normalize(p))}]}if(this.b.getWorkbenchState()===2){const I=this.b.getWorkspace().folders[0].uri;if(p=r(p),p.startsWith("../")||p===".."){const z=S.posix.resolve(I.path,p);return[{searchPath:I.with({path:z})}]}const L=a(p);return[{searchPath:I,pattern:L}]}else{if(p==="./"||p===".\\")return[];{const I=p.replace(/^\.[\/\\]/,""),z=this.b.getWorkspace().folders.map(_=>{const q=I.match(new RegExp(`^${R.escapeRegExpCharacters(_.name)}(?:/(.*)|$)`));return q?{match:q,folder:_}:null}).filter(P.isDefined);if(z.length)return z.map(_=>{const q=_.match[1];return{searchPath:_.folder.uri,pattern:q&&a(q)}});{const _=p.match(/\.[\/\\](.+)[\/\\]?/),q=_?_[1]:p,N=v.localize(0,null,q);throw new Error(N)}}}}o(p,I){const L=p.pattern&&I?`${p.pattern}/${I}`:p.pattern||I,z=[{searchPath:p.searchPath,pattern:L}];return L&&!L.endsWith("**")&&z.push({searchPath:p.searchPath,pattern:L+"/**"}),z}q(p,I,L){const z=this.r((0,m.toWorkspaceFolder)(p.searchPath),I,L,!1);return z?{...z,includePattern:p.pattern}:null}r(p,I,L,z){let _;const q=E.URI.isUri(p)?p:p.uri;if(L.searchPaths){const U=L.searchPaths.filter(H=>(0,y.isEqual)(H.searchPath,q))[0];if(U&&!U.pattern)return null;U&&(_=U.pattern)}const N=this.a.getValue({resource:q}),F={...this.l(N,I)||{},..._||{}},B=E.URI.isUri(p)?(0,y.basename)(p):p.name;return{folder:q,folderName:z?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof I.disregardParentIgnoreFiles=="boolean"?I.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!N.search.followSymlinks}}};b=qe([We(0,d.IConfigurationService),We(1,m.IWorkspaceContextService),We(2,w.IEditorGroupsService),We(3,g.ILogService),We(4,f.IPathService)],b),e.QueryBuilder=b;function s(o){const p=o.match(/[\*\{\}\(\)\[\]\?]/);if(p){const I=p.index,L=o.substr(0,I).match(/[/|\\][^/\\]*$/);if(L){let z=o.substr(0,L.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:o.substr((L.index||0)+1)}}}return{pathPortion:o}}function i(...o){return o.length?o.reduce((p,I)=>(p[I]=!0,p),Object.create(null)):void 0}function l(o){return k.splitGlobAware(o,",").map(p=>p.trim()).filter(p=>!!p.length)}function u(o){return[`**/${o}/**`,`**/${o}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function r(o){return o.replace(/\\/g,"/")}function a(o){return r(o).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(o,p){o=c.distinct(o,z=>z.toString());const I=[],L=p.getWorkspace();return o&&o.forEach(z=>{let _;if(p.getWorkbenchState()===2)_=(0,y.relativePath)(L.folders[0].uri,z),_&&_!=="."&&(_="./"+_);else{const q=p.getWorkspaceFolder(z);if(q){const N=q.name;if(L.folders.filter(F=>F.name===N).length===1){const F=(0,y.relativePath)(q.uri,z);F===""?_=`./${q.name}`:_=`./${q.name}/${F}`}else _=z.fsPath}}_&&I.push(_)}),I}e.resolveResourcesForSearchIncludes=n}),define(Se[287],ye([1,0,24,2,21,10,3,286,31,46]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function P(d,g){const m=g.activationEvents;if(!m)return Promise.resolve(void 0);const w=[],f=[];for(const u of m)if(/^workspaceContains:/.test(u)){const r=u.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||d.forceUsingSearch?f.push(r):w.push(r)}if(w.length===0&&f.length===0)return Promise.resolve(void 0);let h;const b=new Promise((u,r)=>{h=u}),s=u=>h({activationEvent:u}),i=Promise.all(w.map(u=>E(d,u,s))).then(()=>{}),l=C(d,g.identifier,f,s);return Promise.all([i,l]).then(()=>{h(void 0)}),b}e.checkActivateWorkspaceContainsExtension=P;async function E(d,g,m){for(const w of d.folders)if(await d.exists(c.joinPath(t.URI.revive(w),g))){m(`workspaceContains:${g}`);return}}async function C(d,g,m,w){if(m.length===0)return Promise.resolve(void 0);const f=new k.CancellationTokenSource,h=d.checkExists(d.folders,m,f.token),b=setTimeout(async()=>{f.cancel(),d.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},R);let s=!1;try{s=await h}catch(i){A.isCancellationError(i)||A.onUnexpectedError(i)}f.dispose(),clearTimeout(b),s&&w(`workspaceContains:${m.join(",")}`)}function v(d,g,m,w){const f=d.get(D.IInstantiationService),h=d.get(S.ISearchService),s=f.createInstance(T.QueryBuilder).file(g.map(i=>(0,y.toWorkspaceFolder)(t.URI.revive(i))),{_reason:"checkExists",includePattern:m,exists:!0});return h.fileSearch(s,w).then(i=>!!i.limitHit,i=>A.isCancellationError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=v});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[41],ye([1,0,173,9,76,24,18,6,64,2,13,5,34,229,97,33,26,227,10,27,22,210,7,127,3,25,72,16,88,54,40,4,287,96,212,15,95]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h,b,s,i,l,u,r,a,n,o,p,I,L,z,_,q,N){"use strict";var M,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let U=class Ln extends T.Disposable{constructor(te,le,Z,ge,ve,De,Re,ze,se,ue,he){super(),this.a=this.B(new I.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=le,this.g=Z,this.f=Re,this.j=ge,this.k=ve,this.l=De,this.m=se,this.p=ue,this.s=he,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new D.Barrier,this.y=new D.Barrier,this.z=new D.Barrier,this.C=new D.Barrier,this.F=new m.ExtensionDescriptionRegistry(this.f.allExtensions);const ee=(0,g.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new m.ExtensionDescriptionRegistry(V(this.F,ee)),this.G=new v.ExtHostStorage(this.g,this.l),this.H=new z.ExtHostSecretState(this.g),this.I=ze,this.h=te.createChild(new n.ServiceCollection([v.IExtHostStorage,this.G],[z.IExtHostSecretState,this.H]));const ae=this.f.allExtensions.filter($=>!$.main&&!$.browser).map($=>$.identifier),re=this.f.allExtensions.filter($=>!ee.has(f.ExtensionIdentifier.toKey($.identifier.value))).filter($=>($.main||$.browser)&&$.api==="none").map($=>$.identifier),O=(0,g.extensionIdentifiersArrayToSet)(re);this.J=this.B(new C.ExtensionsActivator(this.D,ae,re,{onExtensionActivationError:($,G,Q)=>{this.v.$onExtensionActivationError($,w.transformErrorForSerialization(G),Q)},actualActivateExtension:async($,G)=>{if(O.has(f.ExtensionIdentifier.toKey($)))return await this.v.$activateExtension($,G),new C.HostExtension;const Q=this.D.getExtensionDescription($);return this.Y(Q,G)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(te){w.onUnexpectedError(te)}}async Q(){this.I.onWillDeactivateAll();let te=[];try{te=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(te)}terminate(te,le=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${te}`),this.l.flush(),this.p.dispose(),this.J.dispose(),w.setUnexpectedErrorHandler(ge=>{this.l.error(ge)}),this.g.dispose();const Z=this.Q();Promise.race([(0,D.timeout)(5e3),Z]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${le}`):this.l.info(`Extension host exiting with code ${le}`),this.l.flush(),this.l.dispose(),this.c.exit(le)})}isActivated(te){return this.z.isOpen()?this.J.isActivated(te):!1}async getExtension(te){const le=await this.v.$getExtension(te);let Z;if(le?.browserNlsBundleUris){Z={};for(const ge of Object.keys(le.browserNlsBundleUris))Z[ge]=y.URI.revive(le.browserNlsBundleUris[ge])}return le&&{...le,identifier:new f.ExtensionIdentifier(le.identifier.value),extensionLocation:y.URI.revive(le.extensionLocation),browserNlsBundleUris:Z}}R(te,le){return this.J.activateByEvent(te,le)}S(te,le){return this.J.activateById(te,le)}activateByIdWithErrors(te,le){return this.S(te,le).then(()=>{const Z=this.J.getActivatedExtension(te);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(te=>this.D)}getExtensionExports(te){return this.z.isOpen()?this.J.getActivatedExtension(te).exports:null}async U(te){if(te.scheme!==q.Schemas.file)return te;const le=await this.c.realpath(te.fsPath);return y.URI.file(le)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(te=>new Y(te))),this.L}async W(te){const le=S.TernarySearchTree.forUris(Z=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Z));return await Promise.all(te.map(async Z=>{if(this.ob(Z)){const ge=await this.U(Z.extensionLocation);le.set(ge,Z)}})),le}X(te){let le=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(te))return le;const Z=this.J.getActivatedExtension(te);if(!Z)return le;try{typeof Z.module.deactivate=="function"&&(le=Promise.resolve(Z.module.deactivate()).then(void 0,ge=>(this.l.error(ge),Promise.resolve(void 0))))}catch(ge){this.l.error(`An error occurred when deactivating the extension '${te.value}':`),this.l.error(ge)}try{(0,T.dispose)(Z.subscriptions)}catch(ge){this.l.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.l.error(ge)}return le}async Y(te,le){return this.f.remote.isRemote?this.v.$onWillActivateExtension(te.identifier):await this.v.$onWillActivateExtension(te.identifier),this.ab(te,le).then(Z=>{const ge=Z.activationTimes;return this.v.$onDidActivateExtension(te.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,le),this.Z(te,le,"success",ge),Z},Z=>{throw this.Z(te,le,"failure"),Z})}Z(te,le,Z,ge){const ve=H(te,le);this.u.$publicLog2("extensionActivationTimes",{...ve,...ge||{},outcome:Z})}ab(te,le){const Z=H(te,le);this.u.$publicLog2("activatePlugin",Z);const ge=this.ob(te);if(!ge)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${te.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this.l.flush();const ve=new C.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this.pb(te,(0,A.joinPath)(te.extensionLocation,ge),ve),this.bb(te)]).then(De=>(k.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ln.cb(this.l,te.identifier,De[0],De[1],ve))).then(De=>(k.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),De))}bb(te){const le=new b.ExtensionGlobalMemento(te,this.G),Z=new b.ExtensionMemento(te.identifier.value,!1,this.G),ge=new _.ExtensionSecrets(te,this.H),ve=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,De=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([le.whenReady,Z.whenReady,this.I.whenReady]).then(()=>{const Re=this;let ze,se;const ue=(0,g.isProposedApiEnabled)(te,"ipc")?this.f.messagePorts?.get(f.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:Z,secrets:ge,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(he){return t.join(te.extensionLocation.fsPath,he)},get storagePath(){return Re.I.workspaceValue(te)?.fsPath},get globalStoragePath(){return Re.I.globalValue(te).fsPath},get logPath(){return t.join(Re.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return y.URI.joinPath(Re.f.logsLocation,te.identifier.value)},get storageUri(){return Re.I.workspaceValue(te)},get globalStorageUri(){return Re.I.globalValue(te)},get extensionMode(){return ve},get extension(){return ze===void 0&&(ze=new X(Re,te.identifier,te,De,!1)),ze},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(te,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!se){if(!ue)return;const he=I.Event.buffer(I.Event.fromDOMEventEmitter(ue,"message",ee=>ee.data));ue.start(),se={onDidReceiveMessage:he,postMessage:ue.postMessage.bind(ue)}}return se}})})}static cb(te,le,Z,ge,ve){return Z=Z||{activate:void 0,deactivate:void 0},this.db(te,le,Z,ge,ve).then(De=>new C.ActivatedExtension(!1,null,ve.build(),Z,De,ge.subscriptions))}static db(te,le,Z,ge,ve){if(typeof Z.activate=="function")try{ve.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${le.value}`);const De=typeof global=="object"?global:self,Re=Z.activate.apply(De,[ge]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Re).then(ze=>(ve.activateResolveStop(),ze))}catch(De){return Promise.reject(De)}else return Promise.resolve(Z)}eb(te,le){this.S(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:le}).then(void 0,Z=>{this.l.error(Z)})}fb(){this.v.$setPerformanceMarks(k.getMarks());for(const te of this.D.getAllExtensionDescriptions())if(te.activationEvents)for(const le of te.activationEvents)le==="onStartupFinished"&&this.eb(te,le)}gb(){const te=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.hb(ve.added)));const le=this.j.workspace?this.j.workspace.folders:[],Z=this.hb(le),ge=Promise.all([te,Z]).then(()=>{});return Promise.race([ge,(0,D.timeout)(1e4)]).then(()=>{this.fb()}),ge}hb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(le=>this.ib(te,le))).then(()=>{})}async ib(te,le){if(this.isActivated(le.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,ge={logService:this.l,folders:te.map(De=>De.uri),forceUsingSearch:Z,exists:De=>this.c.exists(De.fsPath),checkExists:(De,Re,ze)=>this.t.$checkExists(De,Re,ze)},ve=await(0,L.checkActivateWorkspaceContainsExtension)(ge,le);if(!!ve)return this.S(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:ve.activationEvent}).then(void 0,De=>this.l.error(De))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(te){throw console.error(te),te}}async jb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:le}=this.f.environment;if(!te||!le)throw new Error(c.localize(0,null));const Z=await this.pb(null,le,new C.ExtensionActivationTimesBuilder(!1));if(!Z||typeof Z.run!="function")throw new Error(c.localize(1,null,le.toString()));return new Promise((ge,ve)=>{const De=(se,ue)=>{se?ve(se):ge(typeof ue=="number"&&ue>0?1:0)},Re=(0,A.originalFSPath)(le),ze=Z.run(Re,De);ze&&ze.then&&ze.then(()=>{ge(0)}).catch(se=>{ve(se instanceof Error&&se.stack?se.stack:String(se))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,le){return this.M[te]=le,(0,T.toDisposable)(()=>{delete this.M[te]})}async lb(te){const le=te.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const Z=te.substr(0,le);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.M[Z]}}async $resolveAuthority(te,le){this.l.info(`$resolveAuthority invoked for authority (${x(te)})`);const{authorityPrefix:Z,resolver:ge}=await this.lb(te);if(!ge)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Z}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(ge)),k.mark(`code/extHost/willResolveAuthority/${Z}`);const ve=await ge.resolve(te,{resolveAttempt:le});k.mark(`code/extHost/didResolveAuthorityOK/${Z}`);const De={authority:te,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Re={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:De,options:Re,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(k.mark(`code/extHost/didResolveAuthorityError/${Z}`),ve instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(te,le){this.l.info(`$getCanonicalURI invoked for authority (${x(te)})`);const{resolver:Z}=await this.lb(te);if(!Z)return null;const ge=y.URI.revive(le);if(typeof Z.getCanonicalURI>"u")return ge;const ve=await(0,D.asPromise)(()=>Z.getCanonicalURI(ge));return ve||ge}static mb(te,le,Z){const ge=new m.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ge.deltaExtensions(Z.toAdd,Z.toRemove);const ve=(0,g.extensionIdentifiersArrayToSet)(le.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Z.myToRemove)ve.delete(f.ExtensionIdentifier.toKey(Re));for(const Re of Z.myToAdd)ve.add(f.ExtensionIdentifier.toKey(Re));const De=V(ge,ve);return{globalRegistry:ge,myExtensions:De}}$startExtensionHost(te){te.toAdd.forEach(ge=>ge.extensionLocation=y.URI.revive(ge.extensionLocation));const{globalRegistry:le,myExtensions:Z}=Ln.mb(this.F,this.D,te);return this.F.set(le.getAllExtensionDescriptions()),this.D.set(Z),this.kb()}$activateByEvent(te,le){return le===1?this.R(te,!1):this.z.wait().then(Z=>this.R(te,!1))}async $activate(te,le){return await this.z.wait(),this.D.getExtensionDescription(te)?(await this.S(te,le),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(De=>De.extensionLocation=y.URI.revive(De.extensionLocation));const{globalRegistry:le,myExtensions:Z}=Ln.mb(this.F,this.D,te),ge=await this.W(Z);return(await this.getExtensionPathIndex()).setSearchTree(ge),this.F.set(le.getAllExtensionDescriptions()),this.D.set(Z),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const le=h.VSBuffer.alloc(te),Z=Math.random()%256;for(let ge=0;ge<te;ge++)le.writeUInt8(Z,ge);return le}async $updateRemoteConnectionData(te){this.P=te,this.a.fire()}};U=qe([We(0,l.IInstantiationService),We(1,e.IHostUtils),We(2,a.IExtHostRpcService),We(3,d.IExtHostWorkspace),We(4,E.IExtHostConfiguration),We(5,R.ILogService),We(6,u.IExtHostInitDataService),We(7,r.IExtensionStoragePaths),We(8,o.IExtHostTunnelService),We(9,p.IExtHostTerminalService),We(10,N.IExtHostLocalizationService)],U),e.AbstractExtHostExtensionService=U;function H(J,te){return{id:J.identifier.value,name:J.name,extensionVersion:J.version,publisherDisplayName:J.publisher,activationEvents:J.activationEvents?J.activationEvents.join(","):null,isBuiltin:J.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class X{constructor(te,le,Z,ge,ve){M.set(this,void 0),F.set(this,void 0),B.set(this,void 0),Je(this,M,te,"f"),Je(this,F,le,"f"),Je(this,B,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=ge,this.isFromDifferentExtensionHost=ve}get isActive(){return Fe(this,M,"f").isActivated(Fe(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Fe(this,M,"f").getExtensionExports(Fe(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Fe(this,M,"f").activateByIdWithErrors(Fe(this,B,"f"),{startup:!1,extensionId:Fe(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=X,M=new WeakMap,F=new WeakMap,B=new WeakMap;function V(J,te){return J.getAllExtensionDescriptions().filter(le=>te.has(f.ExtensionIdentifier.toKey(le.identifier)))}function x(J){const te=J.indexOf("+");return te===-1?J:J.substring(0,te)}class Y{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.ExtensionPaths=Y}),define(Se[288],ye([1,0,76,2,5,34,26,27,16,25,3,41,36,13,8]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(b,s,i,l,u,r,a){this.c=b,this.d=s,this.e=i,this.f=l,this.g=u,this.h=r,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),c.mark("code/extHost/willWaitForConfig");const b=await this.f.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new m(this.c,s,this.d,b,this.i)),this.register(this.e.createInstance(w,s)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(f,s,this.h.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const s of b.nodeModuleName)this.a.set(s,b);else this.a.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this.b.push(s=>b.alternativeModuleName(s))}};d=qe([We(2,R.IInstantiationService),We(3,A.IExtHostConfiguration),We(4,P.IExtHostExtensionService),We(5,y.IExtHostInitDataService),We(6,C.ILogService)],d),e.RequireInterceptor=d;let g=class ei{constructor(b){if(b.environment.appRoot&&ei.a.size){const s=(0,v.escapeRegExpCharacters)(this.c(b.environment.appRoot.fsPath)),i="[a-z0-9_.-]",l=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${u}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(b){if(!this.b)return;const s=this.b.exec(this.c(b));if(!s)return;const[,i,l,u]=s,r=ei.a.get(l);if(r!==void 0)return console.warn(`${l} as been renamed to ${r}, please update your imports`),i+r+u}c(b){return b.replace(/\\/g,"/")}};g.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=qe([We(0,y.IExtHostInitDataService)],g);class m{constructor(b,s,i,l,u){this.c=b,this.d=s,this.e=i,this.f=l,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(b,s){const i=this.d.findSubstr(s);if(i){let l=this.a.get(T.ExtensionIdentifier.toKey(i.identifier));return l||(l=this.c(i,this.e,this.f),this.a.set(T.ExtensionIdentifier.toKey(i.identifier),l)),l}if(!this.b){let l="";this.d.forEach((u,r)=>l+=`	${r} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${l}`),this.b=this.c(D.nullExtensionDescription,this.e,this.f)}return this.b}}let w=class{constructor(b,s,i){this.d=b,this.nodeModuleName="keytar",this.a=s.getProxy(k.MainContext.MainThreadTelemetry);const{environment:l}=i,u=s.getProxy(k.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;E.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.b=new Set,this.b.add(`${r}/node_modules.asar/keytar`),this.b.add(`${r}/node_modules/keytar`)}this.c={getPassword:(r,a)=>u.$getPassword(r,a),setPassword:(r,a,n)=>u.$setPassword(r,a,n),deletePassword:(r,a)=>u.$deletePassword(r,a),findPassword:r=>u.$findPassword(r),findCredentials(r){return u.$findCredentials(r)}}}load(b,s){const i=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:i?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(b){const s=b.length;if(s<=7||!this.b)return;const i=s-7;if((b.charAt(i)==="/"||b.charAt(i)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.b.has(b)))return"keytar"}};w=qe([We(1,S.IExtHostRpcService),We(2,y.IExtHostInitDataService)],w);let f=class{constructor(b,s,i){this.e=b,this.f=s,this.nodeModuleName=["open","opn"],this.d=i.getProxy(k.MainContext.MainThreadTelemetry);const l=i.getProxy(k.MainContext.MainThreadWindow);this.c=(u,r)=>{const a=t.URI.parse(u);return r?this.g(u,r):a.scheme==="http"||a.scheme==="https"?l.$openUri(a,u,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?l.$openUri(a,u,{}):this.g(u,r)}}load(b,s,i){const l=this.e.findSubstr(s);return l&&(this.a=l.identifier.value,this.h()),this.b=i(b),this.c}g(b,s){return this.i(),this.b(b,s)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};f=qe([We(2,S.IExtHostRpcService)],f)}),define(Se[48],ye([1,0,81,6,9,36,3,58,59,41,7,33,224,34]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class v extends E.AbstractVariableResolverService{constructor(m,w,f,h,b,s,i){function l(){if(f){const u=f.activeEditor();if(u)return u.document.uri;const r=h.tabGroups.all.find(a=>a.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.TextDiffTabInput||r.input instanceof R.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof R.TextTabInput||r.input instanceof R.NotebookEditorTabInput||r.input instanceof R.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:u=>{const r=s.folders.filter(a=>a.name===u);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(u,r)=>b.getConfiguration(void 0,u).get(r),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=l();if(u)return k.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(w){const u=l();if(u){const r=w.getWorkspaceFolder(u);if(r)return k.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(f){const u=f.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(f){const u=f.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>m.getExtension(u)},void 0,i?Promise.resolve(i):void 0,Promise.resolve(A.env))}}let d=class extends t.Disposable{constructor(m,w,f,h,b){super(),this.b=m,this.c=w,this.g=f,this.h=h,this.i=b,this.a=new c.Lazy(async()=>{const s=await this.h.getConfigProvider(),l={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{l.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.i,s,l,this.j())})}getResolver(){return this.a.getValue()}j(){}};d=qe([We(0,y.IExtHostExtensionService),We(1,P.IExtHostWorkspace),We(2,T.IExtHostDocumentsAndEditors),We(3,C.IExtHostConfiguration),We(4,S.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(Se[77],ye([1,0,18,4,11,2,3,5,59,41,16,7,33,131,216,34,48]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let m=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(l,u,r,a,n,o){this.D=u,this.E=r,this.F=a,this.G=n,this.H=o,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=l.getProxy(T.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new f(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(p=>{p.onDidChange(I=>{this.I(p)}),this.I(p)})}asDebugSourceUri(l,u){const r=l;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let a=`debug:${encodeURIComponent(r.path||"")}`,n="?";return u&&(a+=`${n}session=${encodeURIComponent(u.id)}`,n="&"),a+=`${n}ref=${r.sourceReference}`,A.URI.parse(a)}else{if(r.path)return A.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(l){const u=[];for(const r of l.getAllExtensionDescriptions())if(r.contributes){const a=r.contributes.debuggers;if(a&&a.length>0)for(const n of a)(0,v.isDebuggerMainContribution)(n)&&u.push(n.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const l=[];return this.w.forEach(u=>l.push(u)),l}addBreakpoints(l){this.T();const u=l.filter(n=>{const o=n.id;return this.w.has(o)?!1:(this.w.set(o,n),!0)});this.U(u,[],[]);const r=[],a=new Map;for(const n of u)if(n instanceof P.SourceBreakpoint){let o=a.get(n.location.uri.toString());o||(o={type:"sourceMulti",uri:n.location.uri,lines:[]},a.set(n.location.uri.toString(),o),r.push(o)),o.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof P.FunctionBreakpoint&&r.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(r)}removeBreakpoints(l){this.T();const u=l.filter(o=>this.w.delete(o.id));this.U([],u,[]);const r=u.filter(o=>o instanceof P.SourceBreakpoint).map(o=>o.id),a=u.filter(o=>o instanceof P.FunctionBreakpoint).map(o=>o.id),n=u.filter(o=>o instanceof P.DataBreakpoint).map(o=>o.id);return this.k.$unregisterBreakpoints(r,a,n)}startDebugging(l,u,r){return this.k.$startDebugging(l?l.uri:void 0,u,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,suppressSaveBeforeStart:r.suppressSaveBeforeStart,suppressDebugStatusbar:r.suppressDebugStatusbar??r.debugUI?.simple,suppressDebugToolbar:r.suppressDebugToolbar??r.debugUI?.simple,suppressDebugView:r.suppressDebugView??r.debugUI?.simple})}stopDebugging(l){return this.k.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,u,r){if(!u)return new P.Disposable(()=>{});const a=this.d++;return this.f.push({type:l,handle:a,provider:u}),this.k.$registerDebugConfigurationProvider(l,r,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,a),new P.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==u),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(l,u,r){if(!r)return new P.Disposable(()=>{});if(!this.P(l,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:u,handle:a,factory:r}),this.k.$registerDebugAdapterDescriptorFactory(u,a),new P.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==r),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(l,u){if(!u)return new P.Disposable(()=>{});const r=this.i++;return this.j.push({type:l,handle:r,factory:u}),new P.Disposable(()=>{this.j=this.j.filter(a=>a.factory!==u)})}async $runInTerminal(l,u){return Promise.resolve(void 0)}async $substituteVariables(l,u){let r;const a=await this.W(l);return a&&(r={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(r,u)}J(l,u){if(l.type==="implementation")return new b(l.implementation)}K(){}async $startDASession(l,u){const r=this,a=await this.V(u);return this.R(this.M(a.type),a).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const o=this.L(n),p=this.J(o,a);if(!p)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const I=p;return this.A.set(l,I),this.Q(a).then(L=>(L&&this.B.set(l,L),I.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const _=z,q={type:"response",seq:0,command:_.command,request_seq:_.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const N=await this.C.sign(_.arguments.value);q.body={signature:N},I.sendResponse(q)}else throw new Error("no signer")}catch(N){q.success=!1,q.message=N.message,I.sendResponse(q)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(z),z=(0,v.convertToVSCPaths)(z,!0),r.k.$acceptDAMessage(l,z)}),I.onError(z=>{L&&L.onError&&L.onError(z),this.k.$acceptDAError(l,z.name,z.message,z.stack)}),I.onExit(z=>{L&&L.onExit&&L.onExit((0,k.withNullAsUndefined)(z),void 0),this.k.$acceptDAExit(l,(0,k.withNullAsUndefined)(z),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),I.startSession()))})}$sendDAMessage(l,u){u=(0,v.convertToDAPaths)(u,!1);const r=this.B.get(l);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(u),this.A.get(l)?.sendMessage(u)}$stopDASession(l){const u=this.B.get(l);this.B.delete(l),u&&u.onWillStopSession&&u.onWillStopSession();const r=this.A.get(l);return this.A.delete(l),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const u=[],r=[],a=[];if(l.added)for(const n of l.added){const o=n.id;if(o&&!this.w.has(o)){let p;if(n.type==="function")p=new P.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")p=new P.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const I=A.URI.revive(n.uri);p=new P.SourceBreakpoint(new P.Location(I,new P.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}p._id=o,this.w.set(o,p),u.push(p)}}if(l.removed)for(const n of l.removed){const o=this.w.get(n);o&&(this.w.delete(n),r.push(o))}if(l.changed){for(const n of l.changed)if(n.id){const o=this.w.get(n.id);if(o){if(o instanceof P.FunctionBreakpoint&&n.type==="function"){const p=o;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.functionName=n.functionName}else if(o instanceof P.SourceBreakpoint&&n.type==="source"){const p=o;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.location=new P.Location(A.URI.revive(n.uri),new P.Position(n.line,n.character))}a.push(o)}}}this.U(u,r,a)}$provideDebugConfigurations(l,u,r){return(0,c.asPromise)(async()=>{const a=this.O(l);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(u);return a.provideDebugConfigurations(n,r)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(l,u,r,a){return(0,c.asPromise)(async()=>{const n=this.O(l);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const o=await this.W(u);return n.resolveDebugConfiguration(o,r,a)})}$resolveDebugConfigurationWithSubstitutedVariables(l,u,r,a){return(0,c.asPromise)(async()=>{const n=this.O(l);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const o=await this.W(u);return n.resolveDebugConfigurationWithSubstitutedVariables(o,r,a)})}async $provideDebugAdapter(l,u){const r=this.N(l);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(u);return this.R(r,a).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(l){const u=await this.V(l);this.m.fire(u)}async $acceptDebugSessionTerminated(l){const u=await this.V(l);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(l){this.q=l?await this.V(l):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(l,u){(await this.V(l))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(l,u){const a={session:await this.V(l),event:u.event,body:u.body};this.u.fire(a)}L(l){if(l instanceof P.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof P.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}M(l){const u=this.h.filter(r=>r.type===l);if(u.length>0)return u[0].factory}N(l){const u=this.h.filter(r=>r.handle===l);if(u.length>0)return u[0].factory}O(l){const u=this.f.filter(r=>r.handle===l);if(u.length>0)return u[0].provider}P(l,u){if(l.contributes){const r=l.contributes.debuggers;if(r&&r.length>0){for(const a of r)if(a.label&&a.type&&a.type===u)return!0}}return!1}Q(l){const r=l.configuration.type,a=this.j.filter(n=>n.type===r||n.type==="*").map(n=>(0,c.asPromise)(()=>n.factory.createDebugAdapterTracker(l)).then(o=>o,o=>null));return Promise.race([Promise.all(a).then(n=>{const o=n.filter(p=>!!p);if(o.length>0)return new h(o)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(l,u){const r=u.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new P.DebugAdapterServer(r));if(l){const n=await this.E.getExtensionRegistry();return(0,c.asPromise)(()=>l.createDebugAdapterDescriptor(u,this.S(u,n))).then(o=>{if(o)return o})}const a=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,a))}S(l,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(l,u,r){(l.length>0||u.length>0||r.length>0)&&this.z.fire(Object.freeze({added:l,removed:u,changed:r}))}async V(l){if(l)if(typeof l=="string"){const u=this.l.get(l);if(u)return u}else{let u=this.l.get(l.id);if(!u){const r=await this.W(l.folderUri),a=l.parent?this.l.get(l.parent):void 0;u=new w(this.k,l.id,l.type,l.name,r,l.configuration,a),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(l){if(l){const u=A.URI.revive(l);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};m=qe([We(0,R.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,y.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,g.IExtHostVariableResolverProvider)],m),e.ExtHostDebugServiceBase=m;class w{constructor(l,u,r,a,n,o,p){this.d=l,this.f=u,this.g=r,this.h=a,this.i=n,this.j=o,this.k=p}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(l){this.h=l,this.d.$setDebugSessionName(this.f,l)}get parentSession(){return this.k}_acceptNameChanged(l){this.h=l}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(l,u){return this.d.$customDebugAdapterRequest(this.f,l,u)}getDebugProtocolBreakpoint(l){return this.d.$getDebugProtocolBreakpoint(this.f,l.id)}}e.ExtHostDebugSession=w;class f{constructor(l){this.value=Object.freeze({append(u){l.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=f;class h{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(u=>u.onError?u.onError(l):void 0)}onExit(l,u){this.d.forEach(r=>r.onExit?r.onExit(l,u):void 0)}}class b extends C.AbstractDebugAdapter{constructor(l){super(),this.h=l,l.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends m{constructor(l,u,r,a,n,o){super(l,u,r,a,n,o)}};s=qe([We(0,R.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,y.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,g.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(Se[289],ye([1,0,10,76,2,5,281,13,87,88,25,196,16,55,41,94]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class g{static async installEarlyHandler(f){const h=f.get(T.ILogService),s=f.get(E.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(i=>{h.error(i);const l=c.transformErrorForSerialization(i);s.$onUnexpectedError(l)})}static async installFullHandler(f){const h=f.get(T.ILogService),b=f.get(E.IExtHostRpcService),s=f.get(v.IExtHostExtensionService),i=f.get(d.IExtHostTelemetry),l=b.getProxy(A.MainContext.MainThreadExtensionService),u=b.getProxy(A.MainContext.MainThreadErrors),r=await s.getExtensionPathIndex(),a=new WeakMap;Error.prepareStackTrace=(n,o)=>{let p="",I,L;for(const z of o)p+=`
	at ${z.toString()}`,L=z.getFileName(),!I&&L&&(I=r.findSubstr(k.URI.file(L)));return a.set(n,I?.identifier),`${n.name||"Error"}: ${n.message||""}${p}`},c.setUnexpectedErrorHandler(n=>{h.error(n);const o=c.transformErrorForSerialization(n),p=a.get(n);if(!p){u.$onUnexpectedError(o);return}l.$onExtensionRuntimeError(p,o);const I=i.onExtensionError(p,n);h.trace("forwarded error to extension?",I,p)})}}Error.stackTraceLimit=100;class m{constructor(f,h,b,s,i){this.a=b,this.b=new D.RPCProtocol(f,null,s),h=m.e(h,this.b);const l=new y.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());l.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...h,messagePorts:i}),l.set(E.IExtHostRpcService,new E.ExtHostRpcService(this.b)),l.set(C.IURITransformerService,new C.URITransformerService(s)),l.set(v.IHostUtils,b);const u=new P.InstantiationService(l,!0);u.invokeFunction(g.installEarlyHandler),this.d=u.invokeFunction(r=>r.get(T.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",h),this.c=u.invokeFunction(r=>r.get(v.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(g.installFullHandler)}async asBrowserUri(f){const h=this.b.getProxy(A.MainContext.MainThreadExtensionService);return k.URI.revive(await h.$asBrowserUri(f))}terminate(f){this.c.terminate(f)}static e(f,h){f.allExtensions.forEach(s=>{s.extensionLocation=k.URI.revive(h.transformIncomingURIs(s.extensionLocation));const i={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(l=>i[l]=k.URI.revive(h.transformIncomingURIs(s.browserNlsBundleUris[l]))),s.browserNlsBundleUris=i)}),f.environment.appRoot=k.URI.revive(h.transformIncomingURIs(f.environment.appRoot));const b=f.environment.extensionDevelopmentLocationURI;return b&&(f.environment.extensionDevelopmentLocationURI=b.map(s=>k.URI.revive(h.transformIncomingURIs(s)))),f.environment.extensionTestsLocationURI=k.URI.revive(h.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=k.URI.revive(h.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=k.URI.revive(h.transformIncomingURIs(f.environment.workspaceStorageHome)),f.environment.extensionTelemetryLogResource=k.URI.revive(h.transformIncomingURIs(f.environment.extensionTelemetryLogResource)),f.nlsBaseUrl=k.URI.revive(h.transformIncomingURIs(f.nlsBaseUrl)),f.logsLocation=k.URI.revive(h.transformIncomingURIs(f.logsLocation)),f.logFile=k.URI.revive(h.transformIncomingURIs(f.logFile)),f.workspace=h.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=m}),define(Se[290],ye([1,0,18,12,179,195,203,77,59,41,16,40,7,48,33,217,219,34]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends T.ExtHostDebugServiceBase{constructor(i,l,u,r,a,n,o){super(i,l,u,r,n,o),this.Z=a,this.X=new b}J(i,l){switch(i.type){case"server":return new d.SocketDebugAdapter(i);case"pipeServer":return new d.NamedPipeDebugAdapter(i);case"executable":return new d.ExecutableDebugAdapter(i,l.type)}return super.J(i,l)}S(i,l){const u=d.ExecutableDebugAdapter.platformAdapterExecutable(l.getAllExtensionDescriptions(),i.type);if(u)return new E.DebugAdapterExecutable(u.command,u.args,u.options)}K(){return new D.SignService}async $runInTerminal(i,l){if(i.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(N=>{this.X.onTerminalClosed(N)}));const u=await this.F.getConfigProvider(),r=this.Z.getDefaultShell(!0),a=this.Z.getDefaultShellArgs(!0),n=i.title||k.localize(0,null),o=JSON.stringify({shell:r,shellArgs:a});let p=await this.X.checkout(o,n),I,L=!1;if(p)I=i.cwd;else{const N={shellPath:r,shellArgs:a,cwd:i.cwd,name:n,iconPath:new E.ThemeIcon("debug")};L=!0,p=this.Z.createTerminalFromOptions(N,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(p,o)}p.show(!0);const z=await p.processId;L?await new Promise(N=>setTimeout(N,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?p.sendText("cls"):r.indexOf("bash")>=0?p.sendText("clear"):t.isWindows?p.sendText("cls"):p.sendText("clear"));const _=(0,g.prepareCommand)(r,i.args,!!i.argsCanBeInterpretedByShell,I,i.env);p.sendText(_);const q=this.onDidTerminateDebugSession(N=>{N.id===l&&(this.X.free(p),q.dispose())});return z}else if(i.kind==="external")return h(i,await this.F.getConfigProvider());return super.$runInTerminal(i,l)}};w=qe([We(0,R.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,y.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,P.IExtHostTerminalService),We(5,S.IExtHostEditorTabs),We(6,C.IExtHostVariableResolverProvider)],w),e.ExtHostDebugService=w;let f;function h(s,i){if(!f)if(t.isWindows)f=new A.WindowsExternalTerminalService;else if(t.isMacintosh)f=new A.MacExternalTerminalService;else if(t.isLinux)f=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=i.getConfiguration("terminal");return f.runInTerminal(s.title,s.cwd,s.args,s.env||{},l.external||{})}class b{constructor(){this.b=new Map}async checkout(i,l){const r=[...this.b.entries()].map(([a,n])=>(0,c.createCancelablePromise)(async o=>{if(a.name!==l||n.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await a.processId))return null;const p=Date.now();return n.lastUsedAt+b.a>p||o.isCancellationRequested||n.config!==i?null:(n.lastUsedAt=p,a)}));return await(0,c.firstParallel)(r,a=>!!a)}insert(i,l){this.b.set(i,{lastUsedAt:Date.now(),config:l})}free(i){const l=this.b.get(i);l&&(l.lastUsedAt=-1)}onTerminalClosed(i){this.b.delete(i)}}b.a=1e3}),define(Se[291],ye([1,0,9,2,114,33,58,34,46,40,16,25,75,15,13,70,24,86,48]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends E.ExtHostTaskBase{constructor(b,s,i,l,u,r,a,n,o){super(b,s,i,l,u,r,a,n),this.B=i,this.C=o,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,s){const i=s;if(!s.execution&&i._id===void 0)throw new Error("Tasks to execute must include an execution");if(i._id!==void 0){const l=E.TaskHandleDTO.from(i,this.B),u=await this.a.$getTaskExecution(l);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.y(u,s);return this.a.$executeTask(l).catch(()=>{}),r}else{const l=E.TaskDTO.from(s,b);if(l===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(l.execution)&&await this.x(l,s,!1);const u=await this.y(await this.a.$getTaskExecution(l),s);return this.a.$executeTask(l).catch(()=>{}),u}}u(b,s,i,l){const u=[];if(l)for(const r of l){this.z(r,i),(!r.definition||!b[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const a=E.TaskDTO.from(r,i.extension);a&&(u.push(a),E.CustomExecutionDTO.is(a.execution)&&s.push(this.x(a,r,!0)))}return{tasks:u,extension:i.extension}}async v(b){return b}async F(b){let s=b&&b.length>0?b[0]:void 0;if(!s){const i=t.URI.file((0,m.homedir)());s=new S.WorkspaceFolder({uri:i,name:g.basename(i),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(b,s){const i=t.URI.revive(b),l={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(i),r=await this.b.getWorkspaceFolders2()??[],a=await this.C.getResolver(),n=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(r);for(const o of s.variables)l.variables[o]=await a.resolveAsync(n,o);if(s.process!==void 0){let o;if(s.process.path!==void 0){o=s.process.path.split(c.delimiter);for(let p=0;p<o.length;p++)o[p]=await a.resolveAsync(n,o[p])}l.process=await k.win32.findExecutable(await a.resolveAsync(n,s.process.name),s.process.cwd!==void 0?await a.resolveAsync(n,s.process.cwd):void 0,o)}return l}async $jsonTasksSupported(){return!0}async $findExecutable(b,s,i){return k.win32.findExecutable(b,s,i)}};f=qe([We(0,R.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,y.IExtHostTerminalService),We(6,v.ILogService),We(7,d.IExtHostApiDeprecationService),We(8,w.IExtHostVariableResolverProvider)],f),e.ExtHostTask=f}),define(Se[292],ye([1,0,86,48]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class k extends t.ExtHostVariableResolverProviderService{j(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=k}),define(Se[142],ye([1,0,17,18,21,51,15,9,24,2,31]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(w,f,h,b){this.d=w,this.e=f,this.f=h,this.g=b,this.a=null,this.b=!1,this.c=0}search(w,f){const h=this.d.folderQueries||[],b=new k.CancellationTokenSource;return f.onCancellationRequested(()=>b.cancel()),new Promise((s,i)=>{this.a=new C(w);let l=!1;const u=(r,a)=>{if(!l&&!this.b){const n=this.h(r);d(r)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,l=!0,b.cancel(),r=this.j(r,this.d.maxResults-this.c));const o=this.h(r);this.c+=o,(o>0||!d(r))&&this.a.add(r,a)}};Promise.all(h.map((r,a)=>this.k(r,n=>u(n,a),b.token))).then(r=>{b.dispose(),this.a.flush();const a=r.some(n=>!!n&&!!n.limitHit);s({limitHit:this.b||a,messages:(0,c.flatten)(r.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},r=>{b.dispose();const a=(0,A.toErrorMessage)(r);i(new Error(a))})})}h(w){return d(w)?Array.isArray(w.ranges)?w.ranges.length:1:0}j(w,f){const h=Array.isArray(w.ranges)?w.ranges:[w.ranges],b=Array.isArray(w.preview.matches)?w.preview.matches:[w.preview.matches];return{ranges:h.slice(0,f),preview:{matches:b.slice(0,f),text:w.preview.text},uri:w.uri}}async k(w,f,h){const b=new R.QueryGlobTester(this.d,w),s=[],i={report:r=>{if(!this.l(r))return;const a=w.folder.scheme===D.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(r.uri))):void 0,n=S.relativePath(w.folder,r.uri);if(n){const o=b.includedInQuery(n,T.basename(n),a);(0,t.isThenable)(o)?s.push(o.then(p=>{p&&f(r)})):o&&f(r)}}},l=this.n(w),u=await this.e.provideTextSearchResults(E(this.d.contentPattern),l,i,h);return s.length&&await Promise.all(s),u}l(w){if(d(w)){if(Array.isArray(w.ranges)){if(!Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(w.preview.matches.length!==w.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(w){const f=(0,R.resolvePatternsForProvider)(this.d.includePattern,w.includePattern),h=(0,R.resolvePatternsForProvider)(this.d.excludePattern,w.excludePattern),b={folder:y.URI.from(w.folder),excludes:h,includes:f,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,encoding:w.fileEncoding&&this.f.toCanonicalName(w.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.TextSearchManager=P;function E(m){return{isCaseSensitive:m.isCaseSensitive||!1,isRegExp:m.isRegExp||!1,isWordMatch:m.isWordMatch||!1,isMultiline:m.isMultiline||!1,pattern:m.pattern}}class C{constructor(w){this.e=w,this.b=-1,this.d=null,this.a=new g(512,f=>this.g(f))}add(w,f){this.d&&(this.b!==f||!S.isEqual(this.c,w.uri))&&(this.f(),this.d=null),this.d||(this.b=f,this.d={resource:w.uri,results:[]}),this.d.results.push(v(w))}f(){const w=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,w)}flush(){this.f(),this.a.flush()}g(w){this.e(w)}}e.TextSearchResultsCollector=C;function v(m){return d(m)?{preview:{matches:(0,c.mapArrayOrNot)(m.preview.matches,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character})),text:m.preview.text},ranges:(0,c.mapArrayOrNot)(m.ranges,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character}))}:{text:m.text,lineNumber:m.lineNumber}}function d(m){return!!m.preview}e.extensionResultIsMatch=d;class g{constructor(w,f){this.g=w,this.h=f,this.c=0,this.d=[],this.e=0}addItem(w,f){!w||this.j(w,f)}addItems(w,f){!w||this.k(w,f)}j(w,f){this.d.push(w),this.e+=f,this.l()}k(w,f){this.d=this.d.concat(w),this.e+=f,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=g,g.a=4e3,g.b=50}),define(Se[78],ye([1,0,6,5,3,285,16,55,13,2,142]),function(ne,e,c,t,k,A,D,T,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let P=class{constructor(d,g,m){this.k=d,this.l=g,this.n=m,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,g){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const m=this.d++;return this.e.set(m,g),this.c.$registerTextSearchProvider(m,this.o(d)),(0,c.toDisposable)(()=>{this.g.delete(d),this.e.delete(m),this.c.$unregisterProvider(m)})}registerFileSearchProvider(d,g){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const m=this.d++;return this.h.set(m,g),this.c.$registerFileSearchProvider(m,this.o(d)),(0,c.toDisposable)(()=>{this.i.delete(d),this.h.delete(m),this.c.$unregisterProvider(m)})}$provideFileSearchResults(d,g,m,w){const f=E(m),h=this.h.get(d);if(h)return this.j.fileSearch(f,h,b=>{this.c.$handleFileMatch(d,g,b.map(s=>s.resource))},w);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,g,m,w){const f=this.e.get(d);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const h=E(m);return this.q(h,f).search(s=>this.c.$handleTextMatch(d,g,s),w)}$enableExtensionHostSearch(){}q(d,g){return new R.TextSearchManager(d,g,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m},"textSearchProvider")}};P=qe([We(0,D.IExtHostRpcService),We(1,T.IURITransformerService),We(2,S.ILogService)],P),e.ExtHostSearch=P;function E(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(C),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>y.URI.revive(d))}}e.reviveQuery=E;function C(v){return{...v,folder:y.URI.revive(v.folder)}}}),define(Se[293],ye([1,0,87,141,33,138,34,39,58,40,75,77,78,97,54,70,140,71,47,96,94,59,139,13,230,48,95]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h,b,s,i,l,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(r.IExtHostLocalizationService,r.ExtHostLocalizationService,1),(0,c.registerSingleton)(i.ILoggerService,s.ExtHostLoggerService,1),(0,c.registerSingleton)(i.ILogService,l.ExtHostLogService,1),(0,c.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,c.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration,0),(0,c.registerSingleton)(m.IExtHostConsumerFileSystem,m.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,c.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,c.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,0),(0,c.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,0),(0,c.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,c.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,0),(0,c.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow,0),(0,c.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace,0),(0,c.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState,0),(0,c.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry,0),(0,c.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,0),(0,c.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(Se[98],ye([1,0,17,13,31,74]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=D;function T(P,E,C,v){const d=(0,c.mapArrayOrNot)(C,S),g=new k.TextSearchMatch(E,d,v),m=g.preview.matches;return{ranges:(0,c.mapArrayOrNot)(d,y),uri:P,preview:{text:g.preview.text,matches:(0,c.mapArrayOrNot)(m,y)}}}e.createTextSearchResult=T;function S(P){return new k.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function y(P){return new A.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let R=class{constructor(E,C){this.a=E,this.b=C}appendLine(E){this.b.debug(`${this.a}#search`,E)}};R=qe([We(1,t.ILogService)],R),e.OutputChannel=R}),define(Se[294],ye([1,0,45,9,82,32,12,8,98,295]),function(ne,e,c,t,k,A,D,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(f,h,b,s){const i=E(f,h,b,s),l=h.folder.fsPath;return{cmd:c.spawn(R,i.args,{cwd:l}),rgDiskPath:R,siblingClauses:i.siblingClauses,rgArgs:i,cwd:l}}e.spawnRipgrepCmd=P;function E(f,h,b,s){const i=["--files","--hidden","--case-sensitive"];v([h],b,!1).forEach(u=>{const r=(0,S.anchorGlob)(u);if(i.push("-g",r),D.isMacintosh){const a=(0,k.normalizeNFD)(r);a!==r&&i.push("-g",a)}});const l=C([h],s,void 0,!1);return l.globArgs.forEach(u=>{const r=`!${(0,S.anchorGlob)(u)}`;if(i.push("-g",r),D.isMacintosh){const a=(0,k.normalizeNFD)(r);a!==r&&i.push("-g",a)}}),h.disregardIgnoreFiles!==!1?i.push("--no-ignore"):h.disregardParentIgnoreFiles!==!1&&i.push("--no-ignore-parent"),h.ignoreSymlinks||i.push("--follow"),f.exists&&i.push("--quiet"),i.push("--no-config"),h.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:l.siblingClauses}}function C(f,h,b,s=!0){const i=[];let l={};return f.forEach(u=>{const r=Object.assign({},u.excludePattern||{},h||{}),a=d(r,s?u.folder.fsPath:void 0,b);i.push(...a.globArgs),a.siblingClauses&&(l=Object.assign(l,a.siblingClauses))}),{globArgs:i,siblingClauses:l}}e.foldersToRgExcludeGlobs=C;function v(f,h,b=!0){const s=[];return f.forEach(i=>{const l=Object.assign({},h||{},i.includePattern||{}),u=d(l,b?i.folder.fsPath:void 0);s.push(...u.globArgs)}),s}e.foldersToIncludeGlobs=v;function d(f,h,b){const s=[],i={};return Object.keys(f).forEach(l=>{if(b&&b.has(l)||!l)return;const u=f[l];l=m(h?g(h,l):l),l.startsWith("\\\\")?l="\\\\"+l.substr(2).replace(/\\/g,"/"):l=l.replace(/\\/g,"/"),typeof u=="boolean"&&u?(l.startsWith("\\\\")&&(l+="**"),s.push(w(l))):u&&u.when&&(i[l]=u)}),{globArgs:s,siblingClauses:i}}function g(f,h){return t.isAbsolute(h)?h:t.join(f,h)}e.getAbsoluteGlob=g;function m(f){return f=T.rtrim(f,"\\"),T.rtrim(f,"/")}function w(f){return A.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=w}),define(Se[296],ye([1,0,45,65,9,297,17,51,37,82,32,12,44,8,11,29,31,294,109]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(l=>l())});class h{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&S.parse(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,w.prepareQuery)(this.b).normalizedLowercase),this.u=u.excludePattern&&S.parse(u.excludePattern),this.t=new Map,u.folderQueries.forEach(r=>{const a=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),n=r.folder.fsPath;u.folderQueries.map(o=>o.folder.fsPath).filter(o=>o!==n).forEach(o=>{(0,R.isEqualOrParent)(o,n)&&(a[k.relative(n,o)]=!0)}),this.t.set(n,new s(a,n))})}cancel(){this.l=!0,f.forEach(u=>u())}walk(u,r,a,n,o){if(this.m=E.StopWatch.create(!1),this.l)return o(null,this.j);r.forEach(p=>{const I=k.basename(p.fsPath);this.u&&this.u(p.fsPath,I)||this.J(a,{relativePath:p.fsPath,searchPath:void 0})}),this.r=E.StopWatch.create(!1),this.w(u,(p,I)=>{this.x(this.y,this,p,a,n,L=>{if(L){const z=(0,T.toErrorMessage)(L);console.error(z),this.q.push(z),I(L,void 0)}else I(null,void 0)})},(p,I)=>{this.m.stop();const L=p?D.coalesce(p)[0]:null;o(L,this.j)})}w(u,r,a){const n=new Array(u.length),o=new Array(u.length);let p=!1,I=0;if(u.length===0)return a(null,[]);u.forEach((L,z)=>{r(L,(_,q)=>{if(_?(p=!0,n[z]=null,o[z]=_):(n[z]=q,o[z]=null),++I===u.length)return a(p?o:null,n)})})}x(u,r,...a){try{u.apply(r,a)}catch(n){a[a.length-1](n)}}y(u,r,a,n){const o=u.folder.fsPath,p=P.isMacintosh,I=()=>N&&N.kill();f.add(I);let L=U=>{f.delete(I),L=()=>{},n(U)},z="";const _=this.D(),q=(0,m.spawnRipgrepCmd)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),N=q.cmd,M=!Object.keys(q.siblingClauses).length,F=q.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let B=`${q.rgDiskPath} ${F}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),a({message:B}),this.s=0,this.z(N,"utf8",a,(U,H,X)=>{if(U){L(U);return}if(this.j){L();return}const x=(z+(p?y.normalizeNFC(H||""):H)).split(`
`);if(X){const Y=x.length;x[Y-1]=x[Y-1].trim(),x[Y-1]||x.pop()}else z=x.pop()||"";if(x.length&&x[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.s+=x.length,M){for(const Y of x)if(this.J(r,{base:o,relativePath:Y,searchPath:this.N(u,Y)}),this.j){I();break}(X||this.j)&&L();return}this.G(u,_,o,x,r),X&&(this.H(_,o,r),L())})}spawnFindCmd(u){const r=this.t.get(u.folder.fsPath),a=r.getBasenameTerms(),n=r.getPathTerms(),o=["-L","."];if(a.length||n.length){o.push("-not","(","(");for(const p of a)o.push("-name",p),o.push("-o");for(const p of n)o.push("-path",p),o.push("-o");o.pop(),o.push(")","-prune",")")}return o.push("-type","f"),c.spawn("find",o,{cwd:u.folder.fsPath})}readStdout(u,r,a){let n="";this.z(u,r,()=>{},(o,p,I)=>{if(o){a(o);return}n+=p,I&&a(null,n)})}z(u,r,a,n){let o=(L,z,_)=>{(L||_)&&(o=()=>{},this.r?.stop()),n(L,z,_)},p=!1;u.stdout?(this.A(u.stdout,r,o),u.stdout.once("data",()=>p=!0)):a({message:"stdout is null"});let I;u.stderr?I=this.B(u.stderr):a({message:"stderr is null"}),u.on("error",L=>{o(L)}),u.on("close",L=>{let z;!p&&(z=this.C(I,r))&&i(z)?o(new Error(`command failed with error code ${L}: ${this.C(I,r)}`)):(this.g&&L===0&&(this.j=!0),o(null,"",!0))})}A(u,r,a){const n=new A.StringDecoder(r);return u.on("data",o=>{a(null,n.write(o))}),n}B(u){const r=[];return u.on("data",a=>{r.push(a)}),r}C(u,r){const a=new A.StringDecoder(r);return u.map(n=>a.write(n)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:r},a,n,o){n.indexOf(this.b)!==-1&&this.J(o,{base:a,relativePath:this.b,searchPath:this.N(u,this.b)});const p=I=>{const L=k.basename(I),z=k.dirname(I);let _=r[z];_||(_=r[z]=[],p(z)),_.push({base:a,relativePath:I,basename:L,searchPath:this.N(u,I)})};n.forEach(p)}H({rootEntries:u,pathToEntries:r},a,n){const o=this,p=this.t.get(a),I=this.b;function L(z){o.o++;const _=(0,g.hasSiblingFn)(()=>z.map(q=>q.basename));for(let q=0,N=z.length;q<N;q++){const M=z[q],{relativePath:F,basename:B}=M;if(p.test(F,B,I!==B?_:void 0))continue;const U=r[F];if(U)L(U);else{if(o.p++,F===I)continue;o.J(n,M)}if(o.j)break}}L(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,r,a,n,o){const p=u.folder,I=(0,g.hasSiblingFn)(()=>a);this.w(a,(L,z)=>{if(this.l||this.j)return z(null);const _=r?[r,L].join(k.sep):L;if(this.t.get(u.folder.fsPath).test(_,L,this.a.filePattern!==L?I:void 0))return z(null);const q=[p.fsPath,_].join(k.sep);t.lstat(q,(N,M)=>{if(N||this.l||this.j)return z(null);this.L(q,M,(F,B)=>F||this.l||this.j?z(null):B.isDirectory()?(this.o++,this.M(q,M,(U,H)=>U||this.l||this.j||(H=H||"",this.v[H])?z(null):(this.v[H]=!0,d.Promises.readdir(q).then(X=>{if(this.l||this.j)return z(null);this.I(u,_,X,n,V=>z(V||null))},X=>{z(null)})))):(this.p++,_===this.b||this.h&&v.isNumber(B.size)&&B.size>this.h||this.J(n,{base:p.fsPath,relativePath:_,searchPath:this.N(u,_)}),z(null,void 0)))})},L=>{const z=L&&D.coalesce(L);return o(z&&z.length>0?z[0]:void 0)})}J(u,r){this.K(r)&&(!this.d||this.d(r.relativePath,k.basename(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(r))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.isFilePatternMatch)(u,this.c)}return!0}L(u,r,a){return r.isSymbolicLink()?t.stat(u,a):a(null,r)}M(u,r,a){return r.isSymbolicLink()?t.realpath(u,(n,o)=>n?a(n):a(null,o)):a(null,u)}N(u,r){return u.folderName?k.join(u.folderName,r):r}}e.FileWalker=h;class b{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new h(u)}search(u,r,a){this.c.walk(this.a,this.b,u,r,(n,o)=>{a(n,{limitHit:o,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=b;class s{constructor(u,r){this.expression=u,this.c=r,this.d(u)}d(u){let r,a;Object.keys(u).filter(n=>u[n]).forEach(n=>{k.isAbsolute(n)?(r=r||S.getEmptyExpression(),r[n]=u[n]):(a=a||S.getEmptyExpression(),a[n]=u[n])}),this.a=r&&S.parse(r,{trimForExclusions:!0}),this.b=a&&S.parse(a,{trimForExclusions:!0})}test(u,r,a){return this.b&&this.b(u,r,a)||this.a&&this.a(k.join(this.c,u),r,a)}getBasenameTerms(){const u=[];return this.a&&u.push(...S.getBasenameTerms(this.a)),this.b&&u.push(...S.getBasenameTerms(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...S.getPathTerms(this.a)),this.b&&u.push(...S.getPathTerms(this.b)),u}}function i(l){const u=l.trim().split(`
`),r=u[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return C.uppercaseFirstLetter(u[u.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=i}),define(Se[298],ye([1,0,101,22]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(l){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===l)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,D=512,T=512*8,S=512*128;var y;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(y=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(u,r){super(u),this.decodeStreamErrorKind=r}}e.DecodeStreamError=R;class P{static async create(u){let r;if(u!==e.UTF8)r=(await new Promise((n,o)=>{ne(["@vscode/iconv-lite-umd"],n,o)})).getDecoder(d(u));else{const a=new TextDecoder;r={write(n){return a.decode(n,{stream:!0})},end(){return a.decode()}}}return new P(r)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function E(l,u){const r=u.minBytesRequiredForDetection??u.guessEncoding?T:D;return new Promise((a,n)=>{const o=(0,c.newWriteableStream)(q=>q.join("")),p=[];let I=0,L,z;const _=async()=>{try{const q=await i({buffer:t.VSBuffer.concat(p),bytesRead:I},u.guessEncoding);if(q.seemsBinary&&u.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);q.encoding=await u.overwriteEncoding(q.encoding),L=await P.create(q.encoding);const N=L.write(t.VSBuffer.concat(p).buffer);o.write(N),p.length=0,I=0,a({stream:o,detected:q})}catch(q){z?.dispose(),o.destroy(),n(q)}};z=(0,c.listenStream)(l,{onData:async q=>{L?o.write(L.write(q.buffer)):(p.push(q),I+=q.byteLength,I>=r&&(l.pause(),await _(),setTimeout(()=>l.resume())))},onError:q=>o.error(q),onEnd:async()=>{L||await _(),o.end(L?.end())}})})}e.toDecodeStream=E;async function C(l,u,r){const n=(await new Promise((I,L)=>{ne(["@vscode/iconv-lite-umd"],I,L)})).getEncoder(d(u),r);let o=!1,p=!1;return{read(){if(p)return null;const I=l.read();if(typeof I!="string"){if(p=!0,!o&&r?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=n.end();return L&&L.length>0?(o=!0,t.VSBuffer.wrap(L)):null}return o=!0,t.VSBuffer.wrap(n.write(I))}}}e.toEncodeReadable=C;async function v(l){return(await new Promise((r,a)=>{ne(["@vscode/iconv-lite-umd"],r,a)})).encodingExists(d(l))}e.encodingExists=v;function d(l){return l===e.UTF8_with_bom||l===null?e.UTF8:l}e.toNodeEncoding=d;function g(l,u){if(!l||u<e.UTF16be_BOM.length)return null;const r=l.readUInt8(0),a=l.readUInt8(1);if(r===e.UTF16be_BOM[0]&&a===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&a===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const n=l.readUInt8(2);return r===e.UTF8_BOM[0]&&a===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=g;const m=["ascii","utf-16","utf-32"];async function w(l){const u=await new Promise((p,I)=>{ne(["jschardet"],p,I)}),r=l.slice(0,S),a=b(r.buffer),n=u.detect(a);if(!n||!n.encoding)return null;const o=n.encoding.toLowerCase();return 0<=m.indexOf(o)?null:h(n.encoding)}const f={ibm866:"cp866",big5:"cp950"};function h(l){const u=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[u]||u}function b(l){let u="";for(let r=0;r<l.length;r++)u+=String.fromCharCode(l[r]);return u}function s(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=l.match(/windows(\d+)/);return u?"windows-"+u[1]:l}}}e.toCanonicalName=s;function i({buffer:l,bytesRead:u},r){let a=g(l,u),n=!1;if(a!==e.UTF16be&&a!==e.UTF16le&&l){let o=!0,p=!0,I=!1;for(let L=0;L<u&&L<A;L++){const z=L%2===1,_=l.readUInt8(L)===0;if(_&&(I=!0),o&&(z&&!_||!z&&_)&&(o=!1),p&&(z&&_||!z&&!_)&&(p=!1),_&&!o&&!p)break}I&&(o?a=e.UTF16le:p?a=e.UTF16be:n=!0)}return r&&!n&&!a&&l?w(l.slice(0,u)).then(o=>({seemsBinary:!1,encoding:o})):{seemsBinary:n,encoding:a}}e.detectEncodingFromBuffer=i,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[143],ye([1,0,298,29,142]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends k.TextSearchManager{constructor(T,S,y=t,R="searchProcess"){super(T,S,{readdir:P=>y.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,c.toCanonicalName)(P)},R)}}e.NativeTextSearchManager=A}),define(Se[299],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(k){if(k&&this.a.has(k)){const A=this.a.get(k);return this.a.delete(k),A}}addDragOperationTransfer(k,A){this.a.set(k,A)}getRenderedTreeElement(k){if(this.b.has(k))return this.b.get(k)}addRenderedTreeItemElement(k,A){this.b.set(k,A)}removeRenderedTreeItemElement(k){this.b.has(k)&&this.b.delete(k)}}e.TreeviewsService=c}),define(Se[300],ye([1,0,177,7,24,2,4,6,18,7,11,17,14,21,299,26]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(f,h){if((0,R.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let b;return Array.isArray(f.highlights)&&(b=f.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),b=b.length?b:void 0),{label:f.label,highlights:b}}}class m{constructor(h,b,s){this.d=h,this.e=b,this.f=s,this.a=new Map,this.b=new v.TreeviewsService;function i(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}b.registerArgumentProcessor({processArgument:l=>i(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(u=>i(u)?this.i(u):u):l})}registerTreeDataProvider(h,b,s){const i=this.createTreeView(h,{treeDataProvider:b},s);return{dispose:()=>i.dispose()}}createTreeView(h,b,s){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=b.dragAndDropController?.dropMimeTypes??[],l=b.dragAndDropController?.dragMimeTypes??[],u=!!b.dragAndDropController?.handleDrag,r=!!b.dragAndDropController?.handleDrop,a=this.h(h,b,s),n=this.d.$registerTreeViewDataProvider(h,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,dropMimeTypes:i,dragMimeTypes:l,hasHandleDrag:u,hasHandleDrop:r});return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(s,"treeItemCheckbox"),a.onDidChangeCheckboxState},get message(){return a.message},set message(o){a.message=o},get title(){return a.title},set title(o){a.title=o},get description(){return a.description},set description(o){a.description=o},get badge(){return a.badge},set badge(o){o!==void 0&&y.ViewBadge.isViewBadge(o)?a.badge={value:Math.floor(Math.abs(o.value)),tooltip:o.tooltip}:o===void 0&&(a.badge=void 0)},reveal:(o,p)=>a.reveal(o,p),dispose:async()=>{await n,this.a.delete(h),a.dispose()}}}$getChildren(h,b){const s=this.a.get(h);return s?s.getChildren(b):Promise.reject(new Error((0,c.localize)(0,null,h)))}async $handleDrop(h,b,s,i,l,u,r,a){const n=this.a.get(h);if(!n)return Promise.reject(new Error((0,c.localize)(1,null,h)));const o=E.DataTransfer.toDataTransfer(s,async p=>(await this.d.$resolveDropFileData(h,b,p)).buffer);return r===h&&a&&await this.g(o,n,a,l,u),n.onDrop(o,i,l)}async g(h,b,s,i,l){const u=this.b.removeDragOperationTransfer(l);if(u)(await u)?.forEach((r,a)=>{r&&h.set(a,r)});else if(l&&b.handleDrag){const r=b.handleDrag(s,h,i);this.b.addDragOperationTransfer(l,r),await r}return h}async $handleDrag(h,b,s,i){const l=this.a.get(h);if(!l)return Promise.reject(new Error((0,c.localize)(2,null,h)));const u=await this.g(new t.DataTransfer,l,b,i,s);if(!!u)return E.DataTransfer.toDataTransferDTO(u)}async $hasResolve(h){const b=this.a.get(h);if(!b)throw new Error((0,c.localize)(3,null,h));return b.hasResolve}$resolve(h,b,s){const i=this.a.get(h);if(!i)throw new Error((0,c.localize)(4,null,h));return i.resolveTreeItem(b,s)}$setExpanded(h,b,s){const i=this.a.get(h);if(!i)throw new Error((0,c.localize)(5,null,h));i.setExpanded(b,s)}$setSelection(h,b){const s=this.a.get(h);if(!s)throw new Error((0,c.localize)(6,null,h));s.setSelection(b)}$setFocus(h,b){const s=this.a.get(h);if(!s)throw new Error((0,c.localize)(7,null,h));s.setFocus(b)}$setVisible(h,b){const s=this.a.get(h);if(!s)throw new Error((0,c.localize)(8,null,h));s.setVisible(b)}$changeCheckboxState(h,b){const s=this.a.get(h);if(!s)throw new Error((0,c.localize)(9,null,h));s.setCheckboxState(b)}h(h,b,s){const i=new w(h,b,this.d,this.e.converter,this.f,s);return this.a.set(h,i),i}i(h){const b=this.a.get(h.$treeViewId);return b&&"$treeItemHandle"in h?b.getExtensionElement(h.$treeItemHandle):b&&"$focusedTreeItem"in h&&h.$focusedTreeItem?b.focusedElement:null}}e.ExtHostTreeViews=m;class w extends T.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.isUndefinedOrNull)(h))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(h,b,s,i,l,u){if(super(),this.C=h,this.D=s,this.F=i,this.G=l,this.H=u,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new D.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new D.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new D.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new D.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new D.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new D.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new C.CancellationTokenSource,u.contributes&&u.contributes.views)for(const n in u.contributes.views)for(const o of u.contributes.views[n])o.id===h&&(this.J=o.name);this.f=b.treeDataProvider,this.g=b.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let r,a;this.B(D.Event.debounce(this.w.event,(n,o)=>(n||(n={message:!1,elements:[]}),o.element!==!1&&(r||(r=new Promise(p=>a=p),this.y=this.y.then(()=>r)),Array.isArray(o.element)?n.elements.push(...o.element):n.elements.push(o.element)),o.message&&(n.message=!0),n),200,!0)(({message:n,elements:o})=>{o.length&&(this.z=this.z.then(()=>{const p=a;return r=null,this.U(o).then(()=>p())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(h){const b=h?this.getExtensionElement(h):void 0;if(h&&!b)return this.G.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.Q(h);return s||(s=await this.R(b)),s?s.map(i=>i.item):void 0}getExtensionElement(h){return this.i.get(h)}reveal(h,b){b=b||{select:!0,focus:!1};const s=(0,R.isUndefinedOrNull)(b.select)?!0:b.select,i=(0,R.isUndefinedOrNull)(b.focus)?!1:b.focus,l=(0,R.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.y.then(()=>this.N(h)).then(u=>this.P(h,u[u.length-1]).then(r=>this.D.$reveal(this.C,{item:r.item,parentChain:u.map(a=>a.item)},{select:s,focus:i,expand:l})),u=>this.G.error(u)):this.D.$reveal(this.C,void 0,{select:s,focus:i,expand:l})}get message(){return this.I}set message(h){this.I=h,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(h){this.J=h,this.D.$setTitle(this.C,h,this.L)}get description(){return this.L}set description(h){this.L=h,this.D.$setTitle(this.C,this.J,h)}get badge(){return this.M}set badge(h){this.M?.value===h?.value&&this.M?.tooltip===h?.tooltip||(this.M=E.ViewBadge.from(h),this.D.$setBadge(this.C,h))}setExpanded(h,b){const s=this.getExtensionElement(h);s&&(b?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(h){(0,P.equals)(this.l,h)||(this.l=h,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(h){this.m=h}setVisible(h){h!==this.k&&(this.k=h,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(h){const b=(await Promise.all(h.map(async s=>{const i=this.getExtensionElement(s.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:s.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);b.forEach(s=>{s.treeItem.checkboxState=s.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.v.fire({items:b.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,b,s){const i=[];for(const l of h){const u=this.getExtensionElement(l);u&&i.push(u)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,b,s),b}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,b,s){const i=b?this.getExtensionElement(b):void 0;if(!(!i&&b||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(i,h,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,b){if(!this.f.resolveTreeItem)return;const s=this.i.get(h);if(s){const i=this.j.get(s);if(i){const l=await this.f.resolveTreeItem(i.extensionItem,s,b)??i.extensionItem;return this.db(l),i.item.tooltip=this.ab(l.tooltip),i.item.command=this.bb(i.disposableStore,l.command),i.item}}}N(h){return this.O(h).then(b=>b?this.N(b).then(s=>this.P(b,s[s.length-1]).then(i=>(s.push(i),s))):Promise.resolve([]))}O(h){const b=this.j.get(h);return b?Promise.resolve(b.parent?this.i.get(b.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(h))}P(h,b){const s=this.j.get(h);return s?Promise.resolve(s):(0,S.asPromise)(()=>this.f.getTreeItem(h)).then(i=>this.gb(h,i,b,!0)).then(i=>this.getChildren(b?b.item.handle:void 0).then(()=>{const l=this.getExtensionElement(i);if(l){const u=this.j.get(l);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}Q(h){if(h){let b;if(typeof h=="string"){const s=this.getExtensionElement(h);b=s?this.j.get(s):void 0}else b=h;return b&&b.children||void 0}return this.h}async R(h){this.nb(h);const b=new C.CancellationTokenSource(this.S.token);try{const s=h?this.j.get(h):void 0,i=await this.f.getChildren(h);if(b.token.isCancellationRequested)return;const l=await Promise.all((0,P.coalesce)(i||[]).map(async u=>{const r=await this.f.getTreeItem(u);return r&&!b.token.isCancellationRequested?this.Z(u,r,s):null}));return b.token.isCancellationRequested?void 0:(0,P.coalesce)(l)}finally{b.dispose()}}U(h){if(h.some(s=>!s))return this.S.dispose(!0),this.S=new C.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(h);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(h){const b=new Set,s=h.map(l=>this.j.get(l));for(const l of s)if(l&&!b.has(l.item.handle)){let u=l;for(;u&&u.parent&&s.findIndex(r=>u&&u.parent&&r&&r.item.handle===u.parent.item.handle)===-1;){const r=this.i.get(u.parent.item.handle);u=r?this.j.get(r):void 0}u&&!u.parent&&b.add(l.item.handle)}const i=[];return b.forEach(l=>{const u=this.i.get(l);if(u){const r=this.j.get(u);r&&(!r.parent||!b.has(r.parent.item.handle))&&i.push(l)}}),i}X(h){const b={};return Promise.all(h.map(s=>this.Y(s).then(i=>{i&&(b[s]=i.item)}))).then(()=>Object.keys(b).length?this.D.$refresh(this.C,b):void 0)}Y(h){const b=this.getExtensionElement(h);if(b){const s=this.j.get(b);if(s)return this.nb(b),(0,S.asPromise)(()=>this.f.getTreeItem(b)).then(i=>{if(i){const l=this.eb(b,i,s.parent);return this.lb(b,l,s,s.parent),s.dispose(),l}return null})}return Promise.resolve(null)}Z(h,b,s){const i=this.eb(h,b,s);if(b.id&&this.i.has(i.item.handle))throw new Error((0,c.localize)(10,null,b.id));return this.kb(h,i),this.mb(i,s),i}ab(h){return y.MarkdownString.isMarkdownString(h)?E.MarkdownString.from(h):h}bb(h,b){return b?{...this.F.toInternal(b,h),originalId:b.command}:void 0}cb(h){if(!h.checkboxState)return;let b,s;return typeof h.checkboxState=="number"?b=h.checkboxState:(b=h.checkboxState.state,s=h.checkboxState.tooltip),{isChecked:b===y.TreeItemCheckboxState.Checked,tooltip:s}}db(h){if(!y.TreeItem.isTreeItem(h,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(h,b,s){this.db(b);const i=new T.DisposableStore,l=this.gb(h,b,s),u=this.hb(b);return{item:{handle:l,parentHandle:s?s.item.handle:void 0,label:g(b.label,this.H),description:b.description,resourceUri:b.resourceUri,tooltip:this.ab(b.tooltip),command:this.bb(i,b.command),contextValue:b.contextValue,icon:u,iconDark:this.ib(b)||u,themeIcon:this.fb(b),collapsibleState:(0,R.isUndefinedOrNull)(b.collapsibleState)?y.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation,checkbox:this.cb(b)},extensionItem:b,parent:s,children:void 0,disposableStore:i,dispose(){i.dispose()}}}fb(h){return h.iconPath instanceof y.ThemeIcon?h.iconPath:void 0}gb(h,{id:b,label:s,resourceUri:i},l,u){if(b)return`${w.b}/${b}`;const r=g(s,this.H),a=l?l.item.handle:w.a;let n=r?r.label:i?(0,k.basename)(i):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const o=this.j.has(h)?this.j.get(h).item.handle:void 0,p=this.Q(l)||[];let I,L=0;do{if(I=`${a}/${L}:${n}`,u||!this.i.has(I)||o===I)break;L++}while(L<=p.length);return I}hb(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon))return typeof h.iconPath=="string"||A.URI.isUri(h.iconPath)?this.jb(h.iconPath):this.jb(h.iconPath.light)}ib(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon)&&h.iconPath.dark)return this.jb(h.iconPath.dark)}jb(h){return A.URI.isUri(h)?h:A.URI.file(h)}kb(h,b){this.i.set(b.item.handle,h),this.j.set(h,b)}lb(h,b,s,i){this.i.delete(b.item.handle),this.j.delete(h),b.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(h,b);const l=this.Q(i)||[],u=l.filter(r=>r.item.handle===s.item.handle)[0];u&&l.splice(l.indexOf(u),1,b)}mb(h,b){b?(b.children||(b.children=[]),b.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}nb(h){if(h){const b=this.j.get(h);if(b){if(b.children)for(const s of b.children){const i=this.i.get(s.item.handle);i&&this.ob(i)}b.children=void 0}}else this.pb()}ob(h){const b=this.j.get(h);if(b){if(b.children)for(const s of b.children){const i=this.i.get(s.item.handle);i&&this.ob(i)}this.j.delete(h),this.i.delete(b.item.handle),b.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(h=>h.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}w.a="0",w.b="1"}),define(Se[301],ye([1,0,21,10,4,42,2,119,105,151,160,38,5,93,244,243,39,245,34,247,248,249,232,250,58,41,251,252,255,256,257,141,235,262,263,264,97,40,266,300,14,7,128,269,73,140,33,222,254,67,138,75,77,78,13,55,16,25,258,231,54,70,241,267,72,71,272,270,271,242,47,265,268,96,59,94,259,74,260,15,123,234,211,253,6,26,215,95,208,261]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h,b,s,i,l,u,r,a,n,o,p,I,L,z,_,q,N,M,F,B,U,H,X,V,x,Y,J,te,le,Z,ge,ve,De,Re,ze,se,ue,he,ee,ae,re,O,$,G,Q,de,be,Pe,pe,Ce,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe,W,ce,Ie,Le,Be,Xe,Ze,mt,ft){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(he.IExtHostInitDataService),At=ot.get(ke.IExtHostFileSystemInfo),Rt=ot.get(de.IExtHostConsumerFileSystem),Ft=ot.get(u.IExtHostExtensionService),pt=ot.get(J.IExtHostWorkspace),kt=ot.get(nt.IExtHostTelemetry),Bt=ot.get(w.IExtHostConfiguration),Mt=ot.get(se.IURITransformerService),xe=ot.get(ue.IExtHostRpcService),Ot=ot.get(N.IExtHostStorage),Ut=ot.get(Q.IExtensionStoragePaths),Ht=ot.get(ze.ILoggerService),bt=ot.get(ze.ILogService),Lt=ot.get(re.IExtHostTunnelService),Ae=ot.get(O.IExtHostApiDeprecationService),Oe=ot.get(Y.IExtHostWindow),Ee=ot.get(et.IExtHostSecretState),ie=ot.get(_e.IExtHostEditorTabs);xe.set(E.ExtHostContext.ExtHostFileSystemInfo,At),xe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Ht),xe.set(E.ExtHostContext.ExtHostWorkspace,pt),xe.set(E.ExtHostContext.ExtHostConfiguration,Bt),xe.set(E.ExtHostContext.ExtHostExtensionService,Ft),xe.set(E.ExtHostContext.ExtHostStorage,Ot),xe.set(E.ExtHostContext.ExtHostTunnelService,Lt),xe.set(E.ExtHostContext.ExtHostWindow,Oe),xe.set(E.ExtHostContext.ExtHostSecretState,Ee),xe.set(E.ExtHostContext.ExtHostTelemetry,kt),xe.set(E.ExtHostContext.ExtHostEditorTabs,ie);const Ne=xe.set(E.ExtHostContext.ExtHostDecorations,ot.get(ge.IExtHostDecorations)),$e=xe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(l.IExtHostDocumentsAndEditors)),Qe=xe.set(E.ExtHostContext.ExtHostCommands,ot.get(g.IExtHostCommands)),Ve=xe.set(E.ExtHostContext.ExtHostTerminalService,ot.get(M.IExtHostTerminalService)),tt=xe.set(E.ExtHostContext.ExtHostDebugService,ot.get(De.IExtHostDebugService)),It=xe.set(E.ExtHostContext.ExtHostSearch,ot.get(Re.IExtHostSearch)),Et=xe.set(E.ExtHostContext.ExtHostTask,ot.get(ve.IExtHostTask)),Tt=xe.set(E.ExtHostContext.ExtHostOutputService,ot.get(I.IExtHostOutputService)),wt=xe.set(E.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),vt=xe.set(E.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(xe)),yt=xe.set(E.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(xe,$e)),zt=xe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(xe,$e,bt)),xt=xe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(bt,yt,xe.getProxy(E.MainContext.MainThreadBulkEdits))),St=xe.set(E.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(xe,Qe,$e,yt)),on=xe.set(E.ExtHostContext.ExtHostNotebookDocuments,new ce.ExtHostNotebookDocuments(St)),an=xe.set(E.ExtHostContext.ExtHostNotebookEditors,new W.ExtHostNotebookEditors(bt,St)),Zt=xe.set(E.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(xe,rt,St,Qe,bt)),bn=xe.set(E.ExtHostContext.ExtHostNotebookRenderers,new Me.ExtHostNotebookRenderers(xe,St)),Ct=xe.set(E.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(xe,$e)),cn=xe.set(E.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(xe.getProxy(E.MainContext.MainThreadTreeViews),Qe,bt)),On=xe.set(E.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(xe.getProxy(E.MainContext.MainThreadEditorInsets),Ct,rt.remote)),en=xe.set(E.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(xe,bt,At,$e)),jt=xe.set(E.ExtHostContext.ExtHostLanguages,new o.ExtHostLanguages(xe,yt,Qe.converter,Mt)),ut=xe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(xe,Mt,yt,Qe,en,bt,Ae,kt)),wn=xe.set(E.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(xe,ut)),Vt=xe.set(E.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(xe,bt,$e)),_t=xe.set(E.ExtHostContext.ExtHostQuickOpen,(0,z.createExtHostQuickOpen)(xe,pt,Qe)),ln=xe.set(E.ExtHostContext.ExtHostSCM,new _.ExtHostSCM(xe,Qe,bt)),vn=xe.set(E.ExtHostContext.ExtHostComments,(0,m.createExtHostComments)(xe,Qe,yt)),un=xe.set(E.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(xe.getProxy(E.MainContext.MainThreadProgress))),En=xe.set(E.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(xe)),kn=xe.set(E.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(xe)),tn=xe.set(E.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(xe)),Sn=xe.set(E.ExtHostContext.ExtHostTimeline,new G.ExtHostTimeline(xe,Qe)),rn=xe.set(E.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(xe,rt.remote,pt,bt,Ae)),sn=xe.set(E.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(xe,rn,pt)),Nn=xe.set(E.ExtHostContext.ExtHostCustomEditors,new Pe.ExtHostCustomEditors(xe,yt,Ut,rn,sn)),yn=xe.set(E.ExtHostContext.ExtHostWebviewViews,new be.ExtHostWebviewViews(xe,rn)),Qt=xe.set(E.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(xe,Qe,$e)),Fn=xe.set(E.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(xe)),Mn=xe.set(E.ExtHostContext.ExtHostProfileContentHandlers,new ft.ExtHostProfileContentHandlers(xe));xe.set(E.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(xe,St,$e,Qe,bt));const Un=Object.values(E.ExtHostContext);xe.assertRegistered(Un);const Bn=new Ce.ExtHostBulkEdits(xe,$e),zn=new d.ExtHostClipboard(xe),Cn=new p.ExtHostMessageService(xe,bt),dn=new h.ExtHostDialogs(xe),hn=new q.ExtHostStatusBar(xe,Qe.converter);return v.ExtHostApiCommands.register(Qe),function(He,Gt,Tn){const gt=function(){let me=!He.isUnderDevelopment;function we(){me||(bt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Ue(at){if(Array.isArray(at))at.forEach(Ue);else if(typeof at=="string")we();else{const Dt=at;typeof Dt.scheme>"u"&&we(),typeof Dt.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),$n={getSession(me,we,Ue){return tn.getSession(He,me,we,Ue)},async hasSession(me,we){return(0,Be.checkProposedApiEnabled)(He,"authSession"),!!await tn.getSession(He,me,we,{silent:!0})},get onDidChangeSessions(){return tn.onDidChangeSessions},registerAuthenticationProvider(me,we,Ue,at){return tn.registerAuthenticationProvider(me,we,Ue,at)}},Wn={registerCommand(me,we,Ue){return Qe.registerCommand(!0,me,we,Ue,void 0,He)},registerTextEditorCommand(me,we,Ue){return Qe.registerCommand(!0,me,(...at)=>{const Dt=Ct.getActiveTextEditor();if(!Dt){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}return Dt.edit(Pt=>{we.apply(Ue,[Dt,Pt,...at])}).then(Pt=>{Pt||bt.warn("Edits from command "+me+" were not applied.")},Pt=>{bt.warn("An error occurred while running command "+me,Pt)})},void 0,void 0,He)},registerDiffInformationCommand:(me,we,Ue)=>((0,Be.checkProposedApiEnabled)(He,"diffCommand"),Qe.registerCommand(!0,me,async(...at)=>{const Dt=$e.activeEditor(!0);if(!Dt){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Pt=await Ct.getDiffInformation(Dt.id);we.apply(Ue,[Pt,...at])},void 0,void 0,He)),executeCommand(me,...we){return Qe.executeCommand(me,...we)},getCommands(me=!1){return Qe.getCommands(me)}},Pn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return zn.value},get shell(){return Ve.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(He,"envShellEvent"),Ve.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Be.checkProposedApiEnabled)(He,"telemetryLogger"),kt.instantiateLogger(He,me)},openExternal(me,we){return Oe.openUri(me,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===rt.environment.appUriScheme)return vt.createAppUri(me);try{return await Oe.asExternalUri(me,{allowTunneling:!!rt.remote.authority})}catch(we){if((0,oe.matchesScheme)(me,it.Schemas.http)||(0,oe.matchesScheme)(me,it.Schemas.https))return me;throw we}},get remoteName(){return(0,Z.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(He,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Pn);const Hn={createTestController(me,we,Ue){return Qt.createTestController(me,we,Ue)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.createTestObserver()},runTests(me){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.runTests(me)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.results}},nn=rt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,jn={getExtension(me,we){(0,Be.isProposedApiEnabled)(He,"extensionsAny")||(we=!1);const Ue=Gt.mine.getExtensionDescription(me);if(Ue)return new u.Extension(Ft,He.identifier,Ue,nn,!1);if(we){const at=Gt.all.getExtensionDescription(me);if(at)return new u.Extension(Ft,He.identifier,at,nn,!0)}},get all(){const me=[];for(const we of Gt.mine.getAllExtensionDescriptions())me.push(new u.Extension(Ft,He.identifier,we,nn,!1));return me},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(He,"extensionsAny");const me=new Be.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),we=[];for(const Ue of Gt.all.getAllExtensionDescriptions()){const at=!me.has(Ue.identifier);we.push(new u.Extension(Ft,He.identifier,Ue,nn,at))}return we},get onDidChange(){return(0,Be.isProposedApiEnabled)(He,"extensionsAny")?k.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},Kt={createDiagnosticCollection(me){return en.createDiagnosticCollection(He.identifier,me)},get onDidChangeDiagnostics(){return en.onDidChangeDiagnostics},getDiagnostics:me=>en.getDiagnostics(me),getLanguages(){return jt.getLanguages()},setTextDocumentLanguage(me,we){return jt.changeLanguage(me.uri,we)},match(me,we){const Ue=yt.getDocumentData(we.uri)?.notebook;return(0,R.score)(U.LanguageSelector.from(me),we.uri,we.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(me,we,Ue){return ut.registerCodeActionProvider(He,gt(me),we,Ue)},registerDocumentPasteEditProvider(me,we,Ue){return(0,Be.checkProposedApiEnabled)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,gt(me),we,Ue)},registerCodeLensProvider(me,we){return ut.registerCodeLensProvider(He,gt(me),we)},registerDefinitionProvider(me,we){return ut.registerDefinitionProvider(He,gt(me),we)},registerDeclarationProvider(me,we){return ut.registerDeclarationProvider(He,gt(me),we)},registerImplementationProvider(me,we){return ut.registerImplementationProvider(He,gt(me),we)},registerTypeDefinitionProvider(me,we){return ut.registerTypeDefinitionProvider(He,gt(me),we)},registerHoverProvider(me,we){return ut.registerHoverProvider(He,gt(me),we,He.identifier)},registerEvaluatableExpressionProvider(me,we){return ut.registerEvaluatableExpressionProvider(He,gt(me),we,He.identifier)},registerInlineValuesProvider(me,we){return ut.registerInlineValuesProvider(He,gt(me),we,He.identifier)},registerDocumentHighlightProvider(me,we){return ut.registerDocumentHighlightProvider(He,gt(me),we)},registerLinkedEditingRangeProvider(me,we){return ut.registerLinkedEditingRangeProvider(He,gt(me),we)},registerReferenceProvider(me,we){return ut.registerReferenceProvider(He,gt(me),we)},registerRenameProvider(me,we){return ut.registerRenameProvider(He,gt(me),we)},registerDocumentSymbolProvider(me,we,Ue){return ut.registerDocumentSymbolProvider(He,gt(me),we,Ue)},registerWorkspaceSymbolProvider(me){return ut.registerWorkspaceSymbolProvider(He,me)},registerDocumentFormattingEditProvider(me,we){return ut.registerDocumentFormattingEditProvider(He,gt(me),we)},registerDocumentRangeFormattingEditProvider(me,we){return ut.registerDocumentRangeFormattingEditProvider(He,gt(me),we)},registerOnTypeFormattingEditProvider(me,we,Ue,...at){return ut.registerOnTypeFormattingEditProvider(He,gt(me),we,[Ue].concat(at))},registerDocumentSemanticTokensProvider(me,we,Ue){return ut.registerDocumentSemanticTokensProvider(He,gt(me),we,Ue)},registerDocumentRangeSemanticTokensProvider(me,we,Ue){return ut.registerDocumentRangeSemanticTokensProvider(He,gt(me),we,Ue)},registerSignatureHelpProvider(me,we,Ue,...at){return typeof Ue=="object"?ut.registerSignatureHelpProvider(He,gt(me),we,Ue):ut.registerSignatureHelpProvider(He,gt(me),we,typeof Ue>"u"?[]:[Ue,...at])},registerCompletionItemProvider(me,we,...Ue){return ut.registerCompletionItemProvider(He,gt(me),we,Ue)},registerInlineCompletionItemProvider(me,we){return we.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,gt(me),we)},registerDocumentLinkProvider(me,we){return ut.registerDocumentLinkProvider(He,gt(me),we)},registerColorProvider(me,we){return ut.registerColorProvider(He,gt(me),we)},registerFoldingRangeProvider(me,we){return ut.registerFoldingRangeProvider(He,gt(me),we)},registerSelectionRangeProvider(me,we){return ut.registerSelectionRangeProvider(He,me,we)},registerCallHierarchyProvider(me,we){return ut.registerCallHierarchyProvider(He,me,we)},registerTypeHierarchyProvider(me,we){return ut.registerTypeHierarchyProvider(He,me,we)},setLanguageConfiguration:(me,we)=>ut.setLanguageConfiguration(He,me,we),getTokenInformationAtPosition(me,we){return(0,Be.checkProposedApiEnabled)(He,"tokenInformation"),jt.tokenAtPosition(me,we)},registerInlayHintsProvider(me,we){return ut.registerInlayHintsProvider(He,me,we)},createLanguageStatusItem(me,we){return jt.createLanguageStatusItem(He,me,we)},registerDocumentDropEditProvider(me,we){return ut.registerDocumentOnDropEditProvider(He,me,we)}},fn={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return Ve.activeTerminal},get terminals(){return Ve.terminals},async showTextDocument(me,we,Ue){const at=await(D.URI.isUri(me)?Promise.resolve(An.openTextDocument(me)):Promise.resolve(me));return Ct.showTextDocument(at,we,Ue)},createTextEditorDecorationType(me){return Ct.createTextEditorDecorationType(He,me)},onDidChangeActiveTextEditor(me,we,Ue){return Ct.onDidChangeActiveTextEditor(me,we,Ue)},onDidChangeVisibleTextEditors(me,we,Ue){return Ct.onDidChangeVisibleTextEditors(me,we,Ue)},onDidChangeTextEditorSelection(me,we,Ue){return Ct.onDidChangeTextEditorSelection(me,we,Ue)},onDidChangeTextEditorOptions(me,we,Ue){return Ct.onDidChangeTextEditorOptions(me,we,Ue)},onDidChangeTextEditorVisibleRanges(me,we,Ue){return Ct.onDidChangeTextEditorVisibleRanges(me,we,Ue)},onDidChangeTextEditorViewColumn(me,we,Ue){return Ct.onDidChangeTextEditorViewColumn(me,we,Ue)},onDidCloseTerminal(me,we,Ue){return Ve.onDidCloseTerminal(me,we,Ue)},onDidOpenTerminal(me,we,Ue){return Ve.onDidOpenTerminal(me,we,Ue)},onDidChangeActiveTerminal(me,we,Ue){return Ve.onDidChangeActiveTerminal(me,we,Ue)},onDidChangeTerminalDimensions(me,we,Ue){return(0,Be.checkProposedApiEnabled)(He,"terminalDimensions"),Ve.onDidChangeTerminalDimensions(me,we,Ue)},onDidChangeTerminalState(me,we,Ue){return Ve.onDidChangeTerminalState(me,we,Ue)},onDidWriteTerminalData(me,we,Ue){return(0,Be.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Ve.onDidWriteTerminalData(me,we,Ue)},get state(){return Oe.state},onDidChangeWindowState(me,we,Ue){return Oe.onDidChangeWindowState(me,we,Ue)},showInformationMessage(me,...we){return Cn.showMessage(He,A.default.Info,me,we[0],we.slice(1))},showWarningMessage(me,...we){return Cn.showMessage(He,A.default.Warning,me,we[0],we.slice(1))},showErrorMessage(me,...we){return Cn.showMessage(He,A.default.Error,me,we[0],we.slice(1))},showQuickPick(me,we,Ue){return _t.showQuickPick(me,we,Ue)},showWorkspaceFolderPick(me){return _t.showWorkspaceFolderPick(me)},showInputBox(me,we){return _t.showInput(me,we)},showOpenDialog(me){return dn.showOpenDialog(me)},showSaveDialog(me){return dn.showSaveDialog(me)},createStatusBarItem(me,we,Ue){let at,Dt,Pt;return typeof me=="string"?(at=me,Dt=we,Pt=Ue):(Dt=me,Pt=we),hn.createStatusBarEntry(He,at,Dt,Pt)},setStatusBarMessage(me,we){return hn.setStatusBarMessage(me,we)},withScmProgress(me){return Ae.report("window.withScmProgress",He,"Use 'withProgress' instead."),un.withProgress(He,{location:H.ProgressLocation.SourceControl},(we,Ue)=>me({report(at){}}))},withProgress(me,we){return un.withProgress(He,me,we)},createOutputChannel(me,we){return Tt.createOutputChannel(me,we,He)},createWebviewPanel(me,we,Ue,at){return sn.createWebviewPanel(He,me,we,Ue,at)},createWebviewTextEditorInset(me,we,Ue,at){return(0,Be.checkProposedApiEnabled)(He,"editorInsets"),On.createWebviewEditorInset(me,we,Ue,at,He)},createTerminal(me,we,Ue){return typeof me=="object"?"pty"in me?Ve.createExtensionTerminal(me):Ve.createTerminalFromOptions(me):Ve.createTerminal(me,we,Ue)},registerTerminalLinkProvider(me){return Ve.registerLinkProvider(me)},registerTerminalProfileProvider(me,we){return Ve.registerProfileProvider(He,me,we)},registerTerminalQuickFixProvider(me,we){return(0,Be.checkProposedApiEnabled)(He,"terminalQuickFixProvider"),Ve.registerTerminalQuickFixProvider(me,He.identifier.value,we)},registerTreeDataProvider(me,we){return cn.registerTreeDataProvider(me,we,He)},createTreeView(me,we){return cn.createTreeView(me,we,He)},registerWebviewPanelSerializer:(me,we)=>sn.registerWebviewPanelSerializer(He,me,we),registerCustomEditorProvider:(me,we,Ue={})=>Nn.registerCustomEditorProvider(He,me,we,Ue),registerFileDecorationProvider(me){return Ne.registerFileDecorationProvider(me,He)},registerUriHandler(me){return vt.registerUriHandler(He.identifier,me)},createQuickPick(){return _t.createQuickPick(He)},createInputBox(){return _t.createInputBox(He)},get activeColorTheme(){return kn.activeColorTheme},onDidChangeActiveColorTheme(me,we,Ue){return kn.onDidChangeActiveColorTheme(me,we,Ue)},registerWebviewViewProvider(me,we,Ue){return yn.registerWebviewViewProvider(He,me,we,Ue?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,we,Ue){return St.onDidChangeActiveNotebookEditor(me,we,Ue)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,we,Ue){return an.onDidChangeNotebookEditorSelection(me,we,Ue)},onDidChangeNotebookEditorVisibleRanges(me,we,Ue){return an.onDidChangeNotebookEditorVisibleRanges(me,we,Ue)},showNotebookDocument(me,we){return St.showNotebookDocument(me,we)},registerExternalUriOpener(me,we,Ue){return(0,Be.checkProposedApiEnabled)(He,"externalUriOpener"),Fn.registerExternalUriOpener(He.identifier,me,we,Ue)},registerProfileContentHandler(me,we){return(0,Be.checkProposedApiEnabled)(He,"profileContentHandlers"),Mn.registrProfileContentHandler(He,me,we)},get tabGroups(){return ie.tabGroups}},An={get rootPath(){return Ae.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return pt.getWorkspaceFolder(me)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(me){throw t.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,we,...Ue)=>pt.updateWorkspaceFolders(He,me,we||0,...Ue),onDidChangeWorkspaceFolders:function(me,we,Ue){return pt.onDidChangeWorkspace(me,we,Ue)},asRelativePath:(me,we)=>pt.getRelativePath(me,we),findFiles:(me,we,Ue,at)=>pt.findFiles(me,we,Ue,He.identifier,at),findTextInFiles:(me,we,Ue,at)=>{(0,Be.checkProposedApiEnabled)(He,"findTextInFiles");let Dt,Pt;return typeof we=="object"?(Dt=we,Pt=Ue):(Dt={},Pt=we,at=Ue),pt.findTextInFiles(me,Dt||{},Pt,He.identifier,at)},saveAll:me=>pt.saveAll(me),applyEdit(me,we){return Bn.applyWorkspaceEdit(me,He,we)},createFileSystemWatcher:(me,we,Ue,at)=>Vt.createFileSystemWatcher(pt,He,me,we,Ue,at),get textDocuments(){return yt.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let we;const Ue=me;if(typeof me=="string")we=Promise.resolve(D.URI.file(me));else if(D.URI.isUri(me))we=Promise.resolve(me);else if(!Ue||typeof Ue=="object")we=yt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(at=>yt.ensureDocumentData(at).then(Dt=>Dt.document))},onDidOpenTextDocument:(me,we,Ue)=>yt.onDidAddDocument(me,we,Ue),onDidCloseTextDocument:(me,we,Ue)=>yt.onDidRemoveDocument(me,we,Ue),onDidChangeTextDocument:(me,we,Ue)=>yt.onDidChangeDocument(me,we,Ue),onDidSaveTextDocument:(me,we,Ue)=>yt.onDidSaveDocument(me,we,Ue),onWillSaveTextDocument:(me,we,Ue)=>xt.getOnWillSaveTextDocumentEvent(He)(me,we,Ue),get notebookDocuments(){return St.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,we){let Ue;if(D.URI.isUri(me))Ue=me,await St.openNotebookDocument(me);else if(typeof me=="string")Ue=D.URI.revive(await St.createNotebookDocument({viewType:me,content:we}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(me,we,Ue){return on.onDidSaveNotebookDocument(me,we,Ue)},onDidChangeNotebookDocument(me,we,Ue){return on.onDidChangeNotebookDocument(me,we,Ue)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(me,we,Ue,at){return St.registerNotebookSerializer(He,me,we,Ue,(0,Be.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,we,Ue)=>Tn.onDidChangeConfiguration(me,we,Ue),getConfiguration(me,we){return we=arguments.length===1?void 0:we,Tn.getConfiguration(me,we,He)},registerTextDocumentContentProvider(me,we){return zt.registerTextDocumentContentProvider(me,we)},registerTaskProvider:(me,we)=>(Ae.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,me,we)),registerFileSystemProvider(me,we,Ue){return(0,Le.combinedDisposable)(wn.registerFileSystemProvider(He,me,we,Ue),Rt.addFileSystemProvider(me,we))},get fs(){return Rt.value},registerFileSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"fileSearchProvider"),It.registerFileSearchProvider(me,we)),registerTextSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"textSearchProvider"),It.registerTextSearchProvider(me,we)),registerRemoteAuthorityResolver:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Ft.registerRemoteAuthorityResolver(me,we)),registerResourceLabelFormatter:me=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),En.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,we,Ue)=>Vt.onDidCreateFile(me,we,Ue),onDidDeleteFiles:(me,we,Ue)=>Vt.onDidDeleteFile(me,we,Ue),onDidRenameFiles:(me,we,Ue)=>Vt.onDidRenameFile(me,we,Ue),onWillCreateFiles:(me,we,Ue)=>Vt.getOnWillCreateFileEvent(He)(me,we,Ue),onWillDeleteFiles:(me,we,Ue)=>Vt.getOnWillDeleteFileEvent(He)(me,we,Ue),onWillRenameFiles:(me,we,Ue)=>Vt.getOnWillRenameFileEvent(He)(me,we,Ue),openTunnel:me=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Lt.openTunnel(He,me).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Be.checkProposedApiEnabled)(He,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(me,we,Ue)=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Lt.onDidChangeTunnels(me,we,Ue)),registerPortAttributesProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"portsAttributes"),Lt.registerPortsAttributesProvider(me,we)),registerTimelineProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"timeline"),Sn.registerTimelineProvider(me,we,He.identifier,Qe.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:me=>((0,Be.checkProposedApiEnabled)(He,"workspaceTrust"),pt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,we,Ue)=>pt.onDidGrantWorkspaceTrust(me,we,Ue),registerEditSessionIdentityProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(me,we))},$t={get inputBox(){return Ae.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),ln.getLastInputBox(He)},createSourceControl(me,we,Ue){return ln.createSourceControl(He,me,we,Ue)}},mn={createCommentController(me,we){return vn.createCommentController(He,me,we)}},Vn={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(me,we,Ue){return tt.onDidStartDebugSession(me,we,Ue)},onDidTerminateDebugSession(me,we,Ue){return tt.onDidTerminateDebugSession(me,we,Ue)},onDidChangeActiveDebugSession(me,we,Ue){return tt.onDidChangeActiveDebugSession(me,we,Ue)},onDidReceiveDebugSessionCustomEvent(me,we,Ue){return tt.onDidReceiveDebugSessionCustomEvent(me,we,Ue)},onDidChangeBreakpoints(me,we,Ue){return tt.onDidChangeBreakpoints(me,we,Ue)},registerDebugConfigurationProvider(me,we,Ue){return tt.registerDebugConfigurationProvider(me,we,Ue||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,we){return tt.registerDebugAdapterDescriptorFactory(He,me,we)},registerDebugAdapterTrackerFactory(me,we){return tt.registerDebugAdapterTrackerFactory(me,we)},startDebugging(me,we,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?tt.startDebugging(me,we,{parentSession:Ue}):tt.startDebugging(me,we,Ue||{})},stopDebugging(me){return tt.stopDebugging(me)},addBreakpoints(me){return tt.addBreakpoints(me)},removeBreakpoints(me){return tt.removeBreakpoints(me)},asDebugSourceUri(me,we){return tt.asDebugSourceUri(me,we)}},qn={registerTaskProvider:(me,we)=>Et.registerTaskProvider(He,me,we),fetchTasks:me=>Et.fetchTasks(me),executeTask:me=>Et.executeTask(He,me),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(me,we,Ue)=>Et.onDidStartTask(me,we,Ue),onDidEndTask:(me,we,Ue)=>Et.onDidEndTask(me,we,Ue),onDidStartTaskProcess:(me,we,Ue)=>Et.onDidStartTaskProcess(me,we,Ue),onDidEndTaskProcess:(me,we,Ue)=>Et.onDidEndTaskProcess(me,we,Ue)},Gn={createNotebookController(me,we,Ue,at,Dt){return Zt.createNotebookController(He,me,we,Ue,at,(0,Be.isProposedApiEnabled)(He,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(me,we)=>St.registerNotebookCellStatusBarItemProvider(He,me,we),createRendererMessaging(me){return bn.createRendererMessaging(He,me)},createNotebookControllerDetectionTask(me){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(He,me)},registerKernelSourceActionProvider(me,we){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(He,me,we)},onDidChangeNotebookCellExecutionState(me,we,Ue){return(0,Be.checkProposedApiEnabled)(He,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(me,we,Ue)}},Kn={t(...me){if(typeof me[0]=="string"){const we=me.shift(),Ue=!me||typeof me[0]!="object"?me:me[0];return wt.getMessage(He.identifier.value,{message:we,args:Ue})}return wt.getMessage(He.identifier.value,me[0])},get bundle(){return wt.getBundle(He.identifier.value)},get uri(){return wt.getBundleUri(He.identifier.value)}};return{version:rt.version,authentication:$n,commands:Wn,comments:mn,debug:Vn,env:Pn,extensions:jn,l10n:Kn,languages:Kt,notebooks:Gn,scm:$t,tasks:qn,tests:Hn,window:fn,workspace:An,Breakpoint:H.Breakpoint,TerminalOutputAnchor:H.TerminalOutputAnchor,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileDecoration2:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestionList,Hover:H.Hover,IndentAction:y.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TerminalExitReason:H.TerminalExitReason,TerminalQuickFixType:H.TerminalQuickFixType,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,SnippetTextEdit:H.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItem2:H.TreeItem,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:C.UIKind,Uri:D.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,DocumentDropEdit:H.DocumentDropEdit,DocumentPasteEdit:H.DocumentPasteEdit,InlayHint:H.InlayHint,InlayHintLabelPart:H.InlayHintLabelPart,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.NotebookEdit,NotebookKernelSourceAction:H.NotebookKernelSourceAction,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:H.DataTransfer,DataTransferItem:H.DataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.TextTabInput,TabInputTextDiff:H.TextDiffTabInput,TabInputTextMerge:H.TextMergeTabInput,TabInputCustom:H.CustomEditorTabInput,TabInputNotebook:H.NotebookEditorTabInput,TabInputNotebookDiff:H.NotebookDiffEditorTabInput,TabInputWebview:H.WebviewEditorTabInput,TabInputTerminal:H.TerminalEditorTabInput,TabInputInteractiveWindow:H.InteractiveWindowInput,TrustedTelemetryValue:X.TrustedTelemetryValue,LogLevel:ze.LogLevel,EditSessionIdentityMatch:mt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(Se[302],ye([1,0,274,311,312,2,313]),function(ne,e,c,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(P,E,C,v,d,g){const m=g.environment.useHostProxy,w=typeof m=="boolean"?m:!g.remote.isRemote,f=(0,D.createProxyResolver)({resolveProxy:b=>P.resolveProxy(b),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(b,s,...i)=>{switch(b){case D.LogLevel.Trace:v.trace(s,...i);break;case D.LogLevel.Debug:v.debug(s,...i);break;case D.LogLevel.Info:v.info(s,...i);break;case D.LogLevel.Warning:v.warn(s,...i);break;case D.LogLevel.Error:v.error(s,...i);break;case D.LogLevel.Critical:v.error(s,...i);break;case D.LogLevel.Off:break;default:l(b,s,i);break}function l(u,r,...a){v.error("Unknown log level",u),v.error(r,...a)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:w,env:process.env}),h=S(E,f);return R(C,h)}e.connectProxyResolver=T;function S(P,E){const C={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(d=>{C.config=P.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(d=>{v.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,D.createHttpPatch)(c,E,{config:"off"},v,!0)),on:Object.assign({},c,(0,D.createHttpPatch)(c,E,{config:"on"},v,!0)),override:Object.assign({},c,(0,D.createHttpPatch)(c,E,{config:"override"},v,!0)),onRequest:Object.assign({},c,(0,D.createHttpPatch)(c,E,C,v,!0)),default:Object.assign(c,(0,D.createHttpPatch)(c,E,C,v,!1))},https:{off:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"off"},v,!0)),on:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"on"},v,!0)),override:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,D.createHttpPatch)(t,E,C,v,!0)),default:Object.assign(t,(0,D.createHttpPatch)(t,E,C,v,!1))},tls:Object.assign(k,(0,D.createTlsPatch)(k))}}const y=new Map;function R(P,E){return P.getExtensionPathIndex().then(C=>{const v=globalThis._VSCODE_NODE_MODULES.module,d=v._load;v._load=function(m,w,f){if(m==="tls")return E.tls;if(m!=="http"&&m!=="https")return d.apply(this,arguments);const h=E[m],b=C.findSubstr(A.URI.file(w.filename));let s=y.get(b);if(s||y.set(b,s={}),!s[m]){const i=h.default;s[m]={...i}}return s[m]}})}}),define(Se[303],ye([1,0,76,301,288,302,41,276,2,15,7,273,113,275]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends k.RequireInterceptor{j(){const m=this,w=globalThis._VSCODE_NODE_MODULES.module,f=w._load;w._load=function(i,l,u){return i=b(i),m.a.has(i)?m.a.get(i).load(i,S.URI.file((0,E.realpathSync)(l.filename)),r=>f.apply(this,[r,l,u])):f.apply(this,arguments)};const h=w._resolveLookupPaths;w._resolveLookupPaths=(s,i)=>h.call(this,b(s),i);const b=s=>{for(const i of m.b){const l=i(s);if(l){s=l;break}}return s}}}class d extends D.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async nb(){this.h.createInstance(C.ExtHostConsoleForwarder);const m=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(T.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const h=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=h.ipcHandlePath}await this.h.createInstance(v,m,{mine:this.D,all:this.F}).install(),c.mark("code/extHost/didInitAPI");const f=await this.k.getConfigProvider();await(0,A.connectProxyResolver)(this.j,f,this,this.l,this.u,this.f),c.mark("code/extHost/didInitProxyResolver")}ob(m){return m.main}async pb(m,w,f){if(w.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let h=null;f.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this.l.flush();const b=m?.identifier.value;m&&await this.s.initializeLocalizedMessages(m);try{b&&c.mark(`code/extHost/willLoadExtensionCode/${b}`),h=ne.__$__nodeRequire(w.fsPath)}finally{b&&c.mark(`code/extHost/didLoadExtensionCode/${b}`),f.codeLoadingStop()}return h}async $setRemoteEnvironment(m){if(!!this.f.remote.isRemote)for(const w in m){const f=m[w];f===null?delete process.env[w]:process.env[w]=f}}}e.ExtHostExtensionService=d}),define(Se[144],ye([1,0,45,314,297,17,80,37,9,8,2,31,74,315,295,98]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const g=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(p){this.a=p}provideTextSearchResults(p,I,L,z){return this.a.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({...I,folder:I.folder.toString()})}`),new Promise((_,q)=>{z.onCancellationRequested(()=>V());const N=i(p,I),M=I.folder.fsPath,F=N.map(le=>le.match(/^-/)?le:`'${le}'`).join(" ");this.a.appendLine(`${g} ${F}
 - cwd: ${M}`);let B=c.spawn(g,N,{cwd:M});B.on("error",le=>{console.error(le),this.a.appendLine("Error: "+(le&&le.message)),q((0,P.serializeSearchError)(new P.SearchError(le&&le.message,P.SearchErrorCode.rgProcessError)))});let U=!1;const H=new h(I.maxResults,M,I.previewOptions);H.on("result",le=>{U=!0,Y="",L.report(le)});let X=!1;const V=()=>{X=!0,B?.kill(),H?.cancel()};let x=!1;H.on("hitLimit",()=>{x=!0,V()});let Y="";B.stdout.on("data",le=>{H.handleData(le),U||(Y+=le)});let J=!1;B.stdout.once("data",()=>J=!0);let te="";B.stderr.on("data",le=>{const Z=le.toString();this.a.appendLine(Z),te.length+Z.length<1e6&&(te+=Z)}),B.on("close",()=>{if(this.a.appendLine(J?"Got data from stdout":"No data from stdout"),this.a.appendLine(U?"Got result from parser":"No result from parser"),Y&&this.a.appendLine(`Got data without result: ${Y}`),this.a.appendLine(""),X)_({limitHit:x});else{H.flush(),B=null;let le;te&&!J&&(le=w(te))?q((0,P.serializeSearchError)(new P.SearchError(le.message,le.code))):_({limitHit:x})}})})}}e.RipgrepTextSearchEngine=m;function w(o){const p=o.split(`
`),I=p[0].trim();if(p.some(z=>z.startsWith("regex parse error")))return new P.SearchError(f(p),P.SearchErrorCode.regexParseError);const L=I.match(/grep config error: unknown encoding: (.*)/);if(L)return new P.SearchError(`Unknown encoding: ${L[1]}`,P.SearchErrorCode.unknownEncoding);if(I.startsWith("error parsing glob"))return new P.SearchError(I.charAt(0).toUpperCase()+I.substr(1),P.SearchErrorCode.globParseError);if(I.startsWith("the literal"))return new P.SearchError(I.charAt(0).toUpperCase()+I.substr(1),P.SearchErrorCode.invalidLiteral);if(I.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(I,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function f(o){const p=["Regex parse error"],I=o.filter(L=>L.startsWith("PCRE2:"));if(I.length>=1){const L=I[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const z=L.split(":")[1];p.push(":"+z)}}return p.join("")}e.buildRegexParseError=f;class h extends t.EventEmitter{constructor(p,I,L){super(),this.g=p,this.h=I,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new k.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(p,I){return super.on(p,I),this}handleData(p){if(this.b)return;const I=typeof p=="string"?p:this.d.write(p);this.k(I)}k(p){let I=p.indexOf(`
`);const L=this.a+p;if(I>=0)I+=this.a.length;else{this.a=L;return}let z=0;for(;I>=0;)this.m(L.substring(z,I).trim()),z=I+1,I=L.indexOf(`
`,z);this.a=L.substring(z)}m(p){if(this.b||!p)return;let I;try{I=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(I.type==="match"){const L=b(I.data.path),z=R.URI.file(S.join(this.h,L)),_=this.n(I.data,z);this.p(_),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(I.type==="context"){const L=b(I.data.path),z=R.URI.file(S.join(this.h,L));this.o(I.data,z).forEach(q=>this.p(q))}}n(p,I){const L=p.line_number-1,z=b(p.lines),_=Buffer.from(z);let q=0,N=0,M=L;p.submatches.length===0&&p.submatches.push(z.length?{start:0,end:1,match:{text:z[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.coalesce)(p.submatches.map((B,U)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const H=b(B.match),X=_.slice(q,B.start).toString(),V=s(X),x=V.numLines>0?V.lastLineLength:V.lastLineLength+N,Y=s(H),J=V.numLines+M,te=Y.numLines+J,le=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+x;return q=B.end,N=le,M=te,new E.Range(J,x,te,le)}));return(0,d.createTextSearchResult)(I,z,F,this.j)}o(p,I){const L=b(p.lines),z=p.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((_,q)=>({text:_,uri:I,lineNumber:z+q}))}p(p){this.emit("result",p)}}e.RipgrepParser=h;function b(o){return o.bytes?Buffer.from(o.bytes,"base64").toString():o.text}function s(o){const p=/\n/g;let I=0,L=-1,z;for(;z=p.exec(o);)I++,L=z.index;const _=L>=0?o.length-L-1:o.length;return{numLines:I,lastLineLength:_}}function i(o,p){const I=["--hidden"];I.push(o.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:z}=(0,D.groupBy)(p.includes,q=>q.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(z&&z.length){const q=new Set;z.forEach(N=>{q.add(N)}),I.push("-g","!*"),q.forEach(N=>{l(N).map(d.anchorGlob).forEach(M=>{I.push("-g",M)})})}L&&L.length&&L.forEach(q=>{I.push("-g",q)}),p.excludes.map(d.anchorGlob).forEach(q=>I.push("-g",`!${q}`)),p.maxFileSize&&I.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||I.push("--no-ignore-parent"):I.push("--no-ignore"),p.followSymlinks&&I.push("--follow"),p.encoding&&p.encoding!=="utf8"&&I.push("--encoding",p.encoding),o.pattern==="--"&&(o.isRegExp=!0,o.pattern="\\-\\-"),o.isMultiline&&!o.isRegExp&&(o.pattern=(0,y.escapeRegExpCharacters)(o.pattern),o.isRegExp=!0),p.usePCRE2&&I.push("--pcre2"),I.push("--crlf"),o.isRegExp&&(o.pattern=u(o.pattern),I.push("--engine","auto"));let _;if(o.isWordMatch){const N=(0,y.createRegExp)(o.pattern,!!o.isRegExp,{wholeWord:o.isWordMatch}).source.replace(/\\\//g,"/");I.push("--regexp",N)}else if(o.isRegExp){let q=a(o.pattern);q=n(q),I.push("--regexp",q)}else _=o.pattern,I.push("--fixed-strings");return I.push("--no-config"),p.useGlobalIgnoreFiles||I.push("--no-ignore-global"),I.push("--json"),o.isMultiline&&I.push("--multiline"),p.beforeContext&&I.push("--before-context",p.beforeContext+""),p.afterContext&&I.push("--after-context",p.afterContext+""),I.push("--"),_&&I.push(_),I.push("."),I}function l(o){const p=(0,T.splitGlobAware)(o,"/");return p.map((I,L)=>p.slice(0,L+1).join("/"))}e.spreadGlobComponents=l;function u(o){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;o.match(p);)o=o.replace(p,"$1\\x{$2}");const I=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;o.match(I);)o=o.replace(I,"$1\\x{$2}");return o}e.unicodeEscapesToPCRE2=u;const r=o=>o.type==="Assertion"&&o.kind==="lookbehind";function a(o){let p;try{p=new C.RegExpParser().parsePattern(o)}catch{return o}let I="",L=0;const z=(N,M,F)=>{I+=o.slice(L,N)+F,L=M},_=[];return new C.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const M=_[0];if(!M)z(N.start,N.end,"\\r?\\n");else if(!_.some(r))if(M.type==="CharacterClass")if(M.negate){const F=o.slice(M.start+2,N.start)+o.slice(N.end,M.end-1);M.parent?.type==="Quantifier"?z(M.start,M.end,F?`[^${F}]`:"."):z(M.start,M.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=o.slice(M.start+1,N.start)+o.slice(N.end,M.end-1);z(M.start,M.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else M.type==="Quantifier"&&z(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){_.unshift(N)},onQuantifierLeave(){_.shift()},onCharacterClassRangeEnter(N){_.unshift(N)},onCharacterClassRangeLeave(){_.shift()},onCharacterClassEnter(N){_.unshift(N)},onCharacterClassLeave(){_.shift()},onAssertionEnter(N){r(N)&&_.push(N)},onAssertionLeave(N){_[0]===N&&_.shift()}}).visit(p),I+=o.slice(L),I}e.fixRegexNewline=a;function n(o){return o.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(Se[304],ye([1,0,21,144,124,15]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,R,P,E){const C=new t.RipgrepTextSearchEngine(this.b);if(R.folder.scheme===A.Schemas.vscodeUserData){const v={...R,folder:R.folder.with({scheme:A.Schemas.file})},d=new k.Progress(g=>P.report({...g,uri:g.uri.with({scheme:R.folder.scheme})}));return this.c(E,g=>C.provideTextSearchResults(y,v,d,g))}else return this.c(E,v=>C.provideTextSearchResults(y,R,P,v))}async c(y,R){const P=T(y);this.a.add(P);const E=await R(P.token);return this.a.delete(P),E}d(){this.a.forEach(y=>y.cancel())}}e.RipgrepSearchProvider=D;function T(S){const y=new c.CancellationTokenSource;return S.onCancellationRequested(()=>y.cancel()),y}}),define(Se[305],ye([1,0,29,144,143]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.a=S}search(S,y,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(C){R({message:C})}},E=new k.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),c);return new Promise((C,v)=>E.search(d=>{y(d.map(D))},S).then(d=>C({limitHit:d.limitHit,type:"success",stats:d.stats}),v))}}e.TextSearchEngineAdapter=A;function D(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,y)=>{if(y.ranges){const R=y;return S+(Array.isArray(R.ranges)?R.ranges.length:1)}else return S+1},0)}}}),define(Se[306],ye([1,0,17,18,10,4,109,9,44,2,38,31,296,305]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(h="searchProcess"){this.d=h,this.b=Object.create(null)}fileSearch(h){let b;const s=m(h),i=new A.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(l=>this.doFileSearchWithEngine(E.Engine,s,u=>i.fire(u),l)),b.then(l=>i.fire(l),l=>i.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return i.event}textSearch(h){let b;const s=m(h),i=new A.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(l=>this.f(s,u=>i.fire(u),l)),b.then(l=>i.fire(l),l=>i.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return i.event}f(h,b,s){return h.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new C.TextSearchEngineAdapter(h).search(s,b,b)}doFileSearch(h,b,s){return this.doFileSearchWithEngine(E.Engine,h,b,s)}doFileSearchWithEngine(h,b,s,i,l=v.a){let u=0;const r=n=>{Array.isArray(n)?(u+=n.length,s(n.map(o=>this.g(o)))):n.relativePath?(u++,s(this.g(n))):s(n)};if(b.sortByScore){let n=this.k(b,r,i);if(!n){const o=b.maxResults?Object.assign({},b,{maxResults:null}):b,p=new h(o);n=this.h(p,b,s,r,i)}return new Promise((o,p)=>{n.then(([I,L])=>{const z=L.map(_=>this.g(_));this.n(z,s,l),o(I)},p)})}const a=new h(b);return this.q(a,r,l,i).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}g(h){return{path:h.base?(0,T.join)(h.base,h.relativePath):h.relativePath}}h(h,b,s,i,l){const u=new A.Emitter;let r=(0,t.createCancelablePromise)(n=>{let o=[];const p=I=>{Array.isArray(I)?o=I:(i(I),u.fire(I))};return this.q(h,p,-1,n).then(I=>[I,o])}),a;if(b.cacheKey){a=this.j(b.cacheKey);const n={promise:r,event:u.event,resolved:!1};a.resultsToSearchCache[b.filePattern||""]=n,r.then(()=>{n.resolved=!0},o=>{delete a.resultsToSearchCache[b.filePattern||""]}),r=this.r(r)}return r.then(([n,o])=>{const p=a?a.scorerCache:Object.create(null),I=(typeof b.maxResults!="number"||b.maxResults>0)&&S.StopWatch.create(!1);return this.l(b,o,p,l).then(L=>{const z=I?I.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:z,fromCache:!1,type:this.d,workspaceFolderCount:b.folderQueries.length,resultCount:L.length},messages:n.messages,limitHit:n.limitHit||typeof b.maxResults=="number"&&o.length>b.maxResults},L]})})}j(h){const b=this.b[h];return b||(this.b[h]=new d)}k(h,b,s){const i=h.cacheKey&&this.b[h.cacheKey];if(!i)return;const l=this.o(i,h.filePattern||"",b,s);if(l)return l.then(([u,r,a])=>{const n=S.StopWatch.create(!1);return this.l(h,r,i.scorerCache,s).then(o=>{const p=n.elapsed(),I={fromCache:!0,detailStats:a,type:this.d,resultCount:r.length,sortingTime:p};return[{type:"success",limitHit:u.limitHit||typeof h.maxResults=="number"&&r.length>h.maxResults,stats:I},o]})})}l(h,b,s,i){const l=(0,D.prepareQuery)(h.filePattern||""),u=(a,n)=>(0,D.compareItemsByFuzzyScore)(a,n,l,!0,g,s),r=typeof h.maxResults=="number"?h.maxResults:Number.MAX_VALUE;return c.topAsync(b,u,r,1e4,i)}n(h,b,s){if(s&&s>0)for(let i=0;i<h.length;i+=s)b(h.slice(i,i+s));else b(h)}o(h,b,s,i){const l=S.StopWatch.create(!1),u=b.indexOf(T.sep)>=0;let r;for(const p in h.resultsToSearchCache)if(b.startsWith(p)){if(u&&p.indexOf(T.sep)<0&&p!=="")continue;const I=h.resultsToSearchCache[p];r={promise:this.r(I.promise),event:I.event,resolved:I.resolved};break}if(!r)return null;const a=l.elapsed(),n=S.StopWatch.create(!1),o=r.event(s);return i&&i.onCancellationRequested(()=>{o.dispose()}),r.promise.then(([p,I])=>{if(i&&i.isCancellationRequested)throw(0,k.canceled)();const L=[],z=(0,D.prepareQuery)(b).normalizedLowercase;for(const _ of I)!(0,P.isFilePatternMatch)(_,z)||L.push(_);return[p,L,{cacheWasResolved:r.resolved,cacheLookupTime:a,cacheFilterTime:n.elapsed(),cacheEntryCount:I.length}]})}q(h,b,s,i){return new Promise((l,u)=>{let r=[];i?.onCancellationRequested(()=>h.cancel()),h.search(a=>{a&&(s?(r.push(a),s>0&&r.length>=s&&(b(r),r=[])):b(a))},a=>{b(a)},(a,n)=>{r.length&&b(r),a?u(a):l(n)})})}clearCache(h){return delete this.b[h],Promise.resolve(void 0)}r(h){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(b,s){return h.then(b,s)}catch(b){return this.then(void 0,b)}finally(b){return h.finally(b)}}}}e.SearchService=v,v.a=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(f){return(0,T.basename)(f.relativePath)}getItemDescription(f){return(0,T.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(w),extraFileResources:f.extraFileResources&&f.extraFileResources.map(h=>y.URI.revive(h))}}function w(f){return{...f,folder:y.URI.revive(f.folder)}}}),define(Se[307],ye([1,0,6,15,2,29,13,25,16,78,55,31,306,304,98,143]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let g=class extends y.ExtHostSearch{constructor(w,f,h,b){super(w,h,b),this.s=A,this.t=-1,this.v=null,this.w=!1;const s=new v.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new C.RipgrepSearchProvider(s)),f.remote.isRemote&&f.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const w=new v.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new C.RipgrepSearchProvider(w)),this.y(t.Schemas.file,new E.SearchService("fileSearchProvider"))}y(w,f){const h=this.d++;return this.v=f,this.t=h,this.c.$registerFileSearchProvider(h,this.o(w)),(0,c.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(h)})}$provideFileSearchResults(w,f,h,b){const s=(0,y.reviveQuery)(h);return w===this.t?this.z(w,f,s,b):super.$provideFileSearchResults(w,f,h,b)}z(w,f,h,b){const s=i=>{if((0,P.isSerializedFileMatch)(i)&&(i=[i]),Array.isArray(i)){this.c.$handleFileMatch(w,f,i.map(l=>k.URI.file(l.path)));return}i.message&&this.n.debug("ExtHostSearch",i.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(h,s,b)}$clearCache(w){return this.v?.clearCache(w),super.$clearCache(w)}q(w,f){return new d.NativeTextSearchManager(w,f,void 0,"textSearchProvider")}};g=qe([We(0,S.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,R.IURITransformerService),We(3,D.ILogService)],g),e.NativeExtHostSearch=g}),define(Se[308],ye([1,0,87,279,291,290,307,303,280,77,41,78,75,40,54,72,278,277,13,292,48]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m,w,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(R.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,c.registerSingleton)(w.ILoggerService,m.ExtHostLoggerService,1),(0,c.registerSingleton)(d.IExtensionStoragePaths,g.ExtensionStoragePaths,0),(0,c.registerSingleton)(y.IExtHostDebugService,A.ExtHostDebugService,0),(0,c.registerSingleton)(P.IExtHostSearch,D.NativeExtHostSearch,0),(0,c.registerSingleton)(E.IExtHostTask,k.ExtHostTask,0),(0,c.registerSingleton)(C.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,c.registerSingleton)(v.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,c.registerSingleton)(h.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService,0)}),define(Se[316],ye([1,0,218,317,76,10,116,117,199,93,289,22,29,113,18,119,214,228,293,308]),function(ne,e,c,t,k,A,D,T,S,y,R,P,E,C,v,d,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const w=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=globalThis._VSCODE_NODE_MODULES.module,a=r._load;r._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return a.apply(this,arguments)}})();const f=process.exit.bind(process);function h(r){process.exit=function(a){if(r)f(a);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let b=function(r){f()};function s(){const r=(0,m.readExtHostConnection)(process.env);if(r.type===3)return new Promise((a,n)=>{const o=p=>{const I=p[0],L=new D.BufferedEmitter;I.on("message",z=>L.fire(P.VSBuffer.wrap(z.data))),I.on("close",()=>{b("renderer closed the MessagePort")}),I.start(),a({onMessage:L.event,send:z=>I.postMessage(z.buffer)})};process?.parentPort.on("message",p=>o(p.ports))});if(r.type===2)return new Promise((a,n)=>{let o=null;const p=setTimeout(()=>{b("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),I=108e5,L=3e5,z=new v.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (1)"),I),_=new v.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (2)"),L);process.on("message",(N,M)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const F=P.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let B;if(N.skipWebSocketFrames)B=new T.NodeSocket(M,"extHost-socket");else{const U=P.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));B=new T.WebSocketNodeSocket(new T.NodeSocket(M,"extHost-socket"),N.permessageDeflate,U,!1)}o?(z.cancel(),_.cancel(),o.beginAcceptReconnection(B,F),o.endAcceptReconnection(),o.sendResume()):(clearTimeout(p),o=new D.PersistentProtocol(B,F),o.sendResume(),o.onDidDispose(()=>b("renderer disconnected")),a(o),o.onSocketClose(()=>{z.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(_.isScheduled())return;z.isScheduled()&&_.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const a=r.pipeName;return new Promise((n,o)=>{const p=c.createConnection(a,()=>{p.removeListener("error",o);const I=new D.PersistentProtocol(new T.NodeSocket(p,"extHost-renderer"));I.sendResume(),n(I)});p.once("error",o),p.on("close",()=>{b("renderer closed the socket")})})}}async function i(){const r=await s();return new class{constructor(){this.a=new D.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,r.onMessage(a=>{(0,y.isMessageOfType)(a,2)?(this.b=!0,b("received terminate message from renderer")):this.a.fire(a)})}send(a){this.b||r.send(a)}async drain(){if(r.drain)return r.drain()}}}function l(r){return new Promise(a=>{const n=r.onMessage(o=>{n.dispose();const p=JSON.parse(o.toString()),I=p.commit,L=S.default.commit;if(I&&L&&I!==L&&f(55),p.parentPid){let z=0;setInterval(function(){try{process.kill(p.parentPid,0),z=0}catch(q){q&&q.code==="EPERM"?(z++,z>=3&&b(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):b(`parent process ${p.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let _;try{_=globalThis._VSCODE_NODE_MODULES["native-watchdog"],_.start(p.parentPid)}catch(q){(0,A.onUnexpectedError)(q)}}r.send((0,y.createMessageOfType)(0)),a({protocol:r,initData:p})});r.send((0,y.createMessageOfType)(1))})}async function u(){const r=[];process.on("unhandledRejection",(z,_)=>{r.push(_),setTimeout(()=>{const q=r.indexOf(_);q>=0&&_.catch(N=>{r.splice(q,1),(0,A.isCancellationError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),z&&(0,A.onUnexpectedError)(z))})},1e3)}),process.on("rejectionHandled",z=>{const _=r.indexOf(z);_>=0&&r.splice(_,1)}),process.on("uncaughtException",function(z){(0,A.onUnexpectedError)(z)}),k.mark("code/extHost/willConnectToRenderer");const a=await i();k.mark("code/extHost/didConnectToRenderer");const n=await l(a);k.mark("code/extHost/didWaitForInitData");const{initData:o}=n;h(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=w.useHostProxy!==void 0?w.useHostProxy!=="false":void 0,o.environment.skipWorkspaceStorageLock=(0,d.boolean)(w.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(_){f(_)}exists(_){return E.Promises.exists(_)}realpath(_){return(0,C.realpath)(_)}};let I=null;o.remote.authority&&w.transformURIs&&(I=(0,g.createURITransformer)(o.remote.authority));const L=new R.ExtensionHostMain(n.protocol,o,p,I);b=z=>L.terminate(z)}u().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b92894493e6f971a3c71912d823e699d3a05d643/core/vs/workbench/api/node/extensionHostProcess.js.map
