/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/base/common/stopwatch","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(ee){for(var e=[],i=0,T=ee.length;i<T;i++)e[i]=Ie[ee[i]];return e};define(Ie[78],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(C,O){const S=Object.create(null);for(const k of C){const N=O(k);let D=S[N];D||(D=S[N]=[]),D.push(k)}return S}e.groupBy=i;function T(C,O){const S=[],k=[];for(const N of C)O.has(N)||S.push(N);for(const N of O)C.has(N)||k.push(N);return{removed:S,added:k}}e.diffSets=T;function y(C,O){const S=[],k=[];for(const[N,D]of C)O.has(N)||S.push(D);for(const[N,D]of O)C.has(N)||k.push(D);return{removed:S,added:k}}e.diffMaps=y;class L{constructor(){this.a=new Map}add(O,S){let k=this.a.get(O);k||(k=new Set,this.a.set(O,k)),k.add(S)}delete(O,S){const k=this.a.get(O);!k||(k.delete(S),k.size===0&&this.a.delete(O))}forEach(O,S){const k=this.a.get(O);!k||k.forEach(S)}}e.SetMap=L}),define(Ie[60],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(C){return(O,S,k)=>{let N=null,D=null;if(typeof k.value=="function"?(N="value",D=k.value):typeof k.get=="function"&&(N="get",D=k.get),!D)throw new Error("not supported");k[N]=C(D,S)}}function T(C,O,S){let k=null,N=null;if(typeof S.value=="function"?(k="value",N=S.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",N=S.get),!N)throw new Error("not supported");const D=`$memoize$${O}`;S[k]=function(...m){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,m)}),this[D]}}e.memoize=T;function y(C,O,S){return i((k,N)=>{const D=`$debounce$${N}`,m=`$debounce$result$${N}`;return function(...v){this[m]||(this[m]=S?S():void 0),clearTimeout(this[D]),O&&(this[m]=O(this[m],...v),v=[this[m]]),this[D]=setTimeout(()=>{k.apply(this,v),this[m]=S?S():void 0},C)}})}e.debounce=y;function L(C,O,S){return i((k,N)=>{const D=`$throttle$timer$${N}`,m=`$throttle$result$${N}`,v=`$throttle$lastRun$${N}`,h=`$throttle$pending$${N}`;return function(...t){if(this[m]||(this[m]=S?S():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),O&&(this[m]=O(this[m],...t)),this[h])return;const o=this[v]+C;o<=Date.now()?(this[v]=Date.now(),k.apply(this,[this[m]]),this[m]=S?S():void 0):(this[h]=!0,this[D]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),k.apply(this,[this[m]]),this[m]=S?S():void 0},o-Date.now()))}})}e.throttle=L}),define(Ie[79],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(y){this.a=y,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(Ie[108],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var T;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(s){s.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function C(s,r=!1){let a=0;const d=s.length;let c="",u=0,n=16,f=0;function g(A){let F=0,$=0;for(;F<A;){const z=s.charCodeAt(a);if(z>=48&&z<=57)$=$*16+z-48;else if(z>=65&&z<=70)$=$*16+z-65+10;else if(z>=97&&z<=102)$=$*16+z-97+10;else break;a++,F++}return F<A&&($=-1),$}function P(A){a=A,c="",u=0,n=16,f=0}function M(){const A=a;if(s.charCodeAt(a)===48)a++;else for(a++;a<s.length&&k(s.charCodeAt(a));)a++;if(a<s.length&&s.charCodeAt(a)===46)if(a++,a<s.length&&k(s.charCodeAt(a)))for(a++;a<s.length&&k(s.charCodeAt(a));)a++;else return f=3,s.substring(A,a);let F=a;if(a<s.length&&(s.charCodeAt(a)===69||s.charCodeAt(a)===101))if(a++,(a<s.length&&s.charCodeAt(a)===43||s.charCodeAt(a)===45)&&a++,a<s.length&&k(s.charCodeAt(a))){for(a++;a<s.length&&k(s.charCodeAt(a));)a++;F=a}else f=3;return s.substring(A,F)}function q(){let A="",F=a;for(;;){if(a>=d){A+=s.substring(F,a),f=2;break}const $=s.charCodeAt(a);if($===34){A+=s.substring(F,a),a++;break}if($===92){if(A+=s.substring(F,a),a++,a>=d){f=2;break}switch(s.charCodeAt(a++)){case 34:A+='"';break;case 92:A+="\\";break;case 47:A+="/";break;case 98:A+="\b";break;case 102:A+="\f";break;case 110:A+=`
`;break;case 114:A+="\r";break;case 116:A+="	";break;case 117:{const V=g(4);V>=0?A+=String.fromCharCode(V):f=4;break}default:f=5}F=a;continue}if($>=0&&$<=31)if(S($)){A+=s.substring(F,a),f=2;break}else f=6;a++}return A}function J(){if(c="",f=0,u=a,a>=d)return u=d,n=17;let A=s.charCodeAt(a);if(O(A)){do a++,c+=String.fromCharCode(A),A=s.charCodeAt(a);while(O(A));return n=15}if(S(A))return a++,c+=String.fromCharCode(A),A===13&&s.charCodeAt(a)===10&&(a++,c+=`
`),n=14;switch(A){case 123:return a++,n=1;case 125:return a++,n=2;case 91:return a++,n=3;case 93:return a++,n=4;case 58:return a++,n=6;case 44:return a++,n=5;case 34:return a++,c=q(),n=10;case 47:{const F=a-1;if(s.charCodeAt(a+1)===47){for(a+=2;a<d&&!S(s.charCodeAt(a));)a++;return c=s.substring(F,a),n=12}if(s.charCodeAt(a+1)===42){a+=2;const $=d-1;let z=!1;for(;a<$;){if(s.charCodeAt(a)===42&&s.charCodeAt(a+1)===47){a+=2,z=!0;break}a++}return z||(a++,f=1),c=s.substring(F,a),n=13}return c+=String.fromCharCode(A),a++,n=16}case 45:if(c+=String.fromCharCode(A),a++,a===d||!k(s.charCodeAt(a)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=M(),n=11;default:for(;a<d&&x(A);)a++,A=s.charCodeAt(a);if(u!==a){switch(c=s.substring(u,a),c){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return c+=String.fromCharCode(A),a++,n=16}}function x(A){if(O(A)||S(A))return!1;switch(A){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function R(){let A;do A=J();while(A>=12&&A<=15);return A}return{setPosition:P,getPosition:()=>a,scan:r?R:J,getToken:()=>n,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>a-u,getTokenError:()=>f}}e.createScanner=C;function O(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function k(s){return s>=48&&s<=57}var N;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(N||(N={}));function D(s,r){const a=[],d=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function f(g,P,M,q){u.value=g,u.offset=P,u.length=M,u.type=q,u.colonOffset=void 0,c=u}try{E(s,{onObjectBegin:(g,P)=>{if(r<=g)throw d;c=void 0,n=r>g,a.push("")},onObjectProperty:(g,P,M)=>{if(r<P||(f(g,P,M,"property"),a[a.length-1]=g,r<=P+M))throw d},onObjectEnd:(g,P)=>{if(r<=g)throw d;c=void 0,a.pop()},onArrayBegin:(g,P)=>{if(r<=g)throw d;c=void 0,a.push(0)},onArrayEnd:(g,P)=>{if(r<=g)throw d;c=void 0,a.pop()},onLiteralValue:(g,P,M)=>{if(r<P||(f(g,P,M,w(g)),r<=P+M))throw d},onSeparator:(g,P,M)=>{if(r<=P)throw d;if(g===":"&&c&&c.type==="property")c.colonOffset=P,n=!1,c=void 0;else if(g===","){const q=a[a.length-1];typeof q=="number"?a[a.length-1]=q+1:(n=!0,a[a.length-1]=""),c=void 0}}})}catch(g){if(g!==d)throw g}return{path:a,previousNode:c,isAtPropertyKey:n,matches:g=>{let P=0;for(let M=0;P<g.length&&M<a.length;M++)if(g[P]===a[M]||g[P]==="*")P++;else if(g[P]!=="**")return!1;return P===g.length}}}e.getLocation=D;function m(s,r=[],a=L.DEFAULT){let d=null,c=[];const u=[];function n(g){Array.isArray(c)?c.push(g):d!==null&&(c[d]=g)}return E(s,{onObjectBegin:()=>{const g={};n(g),u.push(c),c=g,d=null},onObjectProperty:g=>{d=g},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const g=[];n(g),u.push(c),c=g,d=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:n,onError:(g,P,M)=>{r.push({error:g,offset:P,length:M})}},a),c[0]}e.parse=m;function v(s,r=[],a=L.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(g){d.type==="property"&&(d.length=g-d.offset,d=d.parent)}function u(g){return d.children.push(g),g}E(s,{onObjectBegin:g=>{d=u({type:"object",offset:g,length:-1,parent:d,children:[]})},onObjectProperty:(g,P,M)=>{d=u({type:"property",offset:P,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:g,offset:P,length:M,parent:d})},onObjectEnd:(g,P)=>{d.length=g+P-d.offset,d=d.parent,c(g+P)},onArrayBegin:(g,P)=>{d=u({type:"array",offset:g,length:-1,parent:d,children:[]})},onArrayEnd:(g,P)=>{d.length=g+P-d.offset,d=d.parent,c(g+P)},onLiteralValue:(g,P,M)=>{u({type:w(g),offset:P,length:M,parent:d,value:g}),c(P+M)},onSeparator:(g,P,M)=>{d.type==="property"&&(g===":"?d.colonOffset=P:g===","&&c(P))},onError:(g,P,M)=>{r.push({error:g,offset:P,length:M})}},a);const f=d.children[0];return f&&delete f.parent,f}e.parseTree=v;function h(s,r){if(!s)return;let a=s;for(const d of r)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const u of a.children)if(Array.isArray(u.children)&&u.children[0].value===d){a=u.children[1],c=!0;break}if(!c)return}else{const c=d;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.findNodeAtLocation=h;function t(s){if(!s.parent||!s.parent.children)return[];const r=t(s.parent);if(s.parent.type==="property"){const a=s.parent.children[0].value;r.push(a)}else if(s.parent.type==="array"){const a=s.parent.children.indexOf(s);a!==-1&&r.push(a)}return r}e.getNodePath=t;function o(s){switch(s.type){case"array":return s.children.map(o);case"object":{const r=Object.create(null);for(const a of s.children){const d=a.children[1];d&&(r[a.children[0].value]=o(d))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=o;function l(s,r,a=!1){return r>=s.offset&&r<s.offset+s.length||a&&r===s.offset+s.length}e.contains=l;function b(s,r,a=!1){if(l(s,r,a)){const d=s.children;if(Array.isArray(d))for(let c=0;c<d.length&&d[c].offset<=r;c++){const u=b(d[c],r,a);if(u)return u}return s}}e.findNodeAtOffset=b;function E(s,r,a=L.DEFAULT){const d=C(s,!1);function c(se){return se?()=>se(d.getTokenOffset(),d.getTokenLength()):()=>!0}function u(se){return se?le=>se(le,d.getTokenOffset(),d.getTokenLength()):()=>!0}const n=c(r.onObjectBegin),f=u(r.onObjectProperty),g=c(r.onObjectEnd),P=c(r.onArrayBegin),M=c(r.onArrayEnd),q=u(r.onLiteralValue),J=u(r.onSeparator),x=c(r.onComment),R=u(r.onError),A=a&&a.disallowComments,F=a&&a.allowTrailingComma;function $(){for(;;){const se=d.scan();switch(d.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:A||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(se){case 12:case 13:A?z(10):x();break;case 16:z(1);break;case 15:case 14:break;default:return se}}}function z(se,le=[],_=[]){if(R(se),le.length+_.length>0){let me=d.getToken();for(;me!==17;){if(le.indexOf(me)!==-1){$();break}else if(_.indexOf(me)!==-1)break;me=$()}}}function V(se){const le=d.getTokenValue();return se?q(le):f(le),$(),!0}function K(){switch(d.getToken()){case 11:{let se=0;try{se=JSON.parse(d.getTokenValue()),typeof se!="number"&&(z(2),se=0)}catch{z(2)}q(se);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return $(),!0}function ie(){return d.getToken()!==10?(z(3,[],[2,5]),!1):(V(!1),d.getToken()===6?(J(":"),$(),re()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function ge(){n(),$();let se=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(se||z(4,[],[]),J(","),$(),d.getToken()===2&&F)break}else se&&z(6,[],[]);ie()||z(4,[],[2,5]),se=!0}return g(),d.getToken()!==2?z(7,[2],[]):$(),!0}function ce(){P(),$();let se=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(se||z(4,[],[]),J(","),$(),d.getToken()===4&&F)break}else se&&z(6,[],[]);re()||z(4,[],[4,5]),se=!0}return M(),d.getToken()!==4?z(8,[4],[]):$(),!0}function re(){switch(d.getToken()){case 3:return ce();case 1:return ge();case 10:return V(!0);default:return K()}}return $(),d.getToken()===17?a.allowEmptyContent?!0:(z(4,[],[]),!1):re()?(d.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=E;function p(s,r){const a=C(s),d=[];let c,u=0,n;do switch(n=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:u!==n&&d.push(s.substring(u,n)),r!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,r)),u=a.getPosition();break}while(c!==17);return d.join("")}e.stripComments=p;function w(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(Ie[28],Ce([1,0]),function(ee,e){"use strict";var i,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(h,t,o){let l=h.get(t);return l===void 0&&(l=o,h.set(t,l)),l}e.getOrSet=L;function C(h){const t=[];return h.forEach((o,l)=>{t.push(`${l} => ${o}`)}),`Map(${h.size}) {${t.join(", ")}}`}e.mapToString=C;function O(h){const t=[];return h.forEach(o=>{t.push(o)}),`Set(${h.size}) {${t.join(", ")}}`}e.setToString=O;class S{constructor(t,o){this.uri=t,this.value=o}}class k{constructor(t,o){this[i]="ResourceMap",t instanceof k?(this.b=new Map(t.b),this.c=o??k.a):(this.b=new Map,this.c=t??k.a)}set(t,o){return this.b.set(this.c(t),new S(t,o)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[l,b]of this.b)t(b.value,b.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.ResourceMap=k,k.a=h=>h.toString();class N{constructor(t,o){this[T]="ResourceSet",!t||typeof t=="function"?this.a=new k(t):(this.a=new k(o),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,o){this.a.forEach((l,b)=>t.call(o,b,b,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var D;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class m{constructor(){this[y]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,o=0){const l=this.a.get(t);if(!!l)return o!==0&&this.j(l,o),l.value}set(t,o,l=0){let b=this.a.get(t);if(b)b.value=o,l!==0&&this.j(b,l);else{switch(b={key:t,value:o,next:void 0,previous:void 0},l){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(t,b),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this.a.get(t);if(!!o)return this.a.delete(t),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,o){const l=this.e;let b=this.b;for(;b;){if(o?t.bind(o)(b.value,b.key,this):t(b.value,b.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const t=this,o=this.e;let l=this.b;const b={[Symbol.iterator](){return b},next(){if(t.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.key,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return b}values(){const t=this,o=this.e;let l=this.b;const b={[Symbol.iterator](){return b},next(){if(t.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.value,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return b}entries(){const t=this,o=this.e;let l=this.b;const b={[Symbol.iterator](){return b},next(){if(t.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:[l.key,l.value],done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return b}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.b,l=this.size;for(;o&&l>t;)this.a.delete(o.key),o=o.next,l--;this.b=o,this.d=l,o&&(o.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const o=t.next,l=t.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}t.next=void 0,t.previous=void 0,this.e++}j(t,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this.b)return;const l=t.next,b=t.previous;t===this.c?(b.next=void 0,this.c=b):(l.previous=b,b.next=l),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(o===2){if(t===this.c)return;const l=t.next,b=t.previous;t===this.b?(l.previous=void 0,this.b=l):(l.previous=b,b.next=l),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((o,l)=>{t.push([l,o])}),t}fromJSON(t){this.clear();for(const[o,l]of t)this.set(o,l)}}e.LinkedMap=m;class v extends m{constructor(t,o=1){super(),this.k=t,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=v}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[109],Ce([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Te,De){for(var ke=0;ke<De.length;ke++){var oe=De[ke];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Te,oe.key,oe)}}function i(Te,De,ke){return De&&e(Te.prototype,De),ke&&e(Te,ke),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function T(Te,De){if(!!Te){if(typeof Te=="string")return y(Te,De);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return y(Te,De)}}function y(Te,De){(De==null||De>Te.length)&&(De=Te.length);for(var ke=0,oe=new Array(De);ke<De;ke++)oe[ke]=Te[ke];return oe}function L(Te,De){var ke=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=T(Te))||De&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var oe=0;return function(){return oe>=Te.length?{done:!0}:{done:!1,value:Te[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=C();function O(Te){ee.defaults=Te}var S=/[&<>"']/,k=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(De){return m[De]};function h(Te,De){if(De){if(S.test(Te))return Te.replace(k,v)}else if(N.test(Te))return Te.replace(D,v);return Te}var t=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Te){return Te.replace(t,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var l=/(^|[^\[])\^/g;function b(Te,De){Te=typeof Te=="string"?Te:Te.source,De=De||"";var ke={replace:function(ue,Y){return Y=Y.source||Y,Y=Y.replace(l,"$1"),Te=Te.replace(ue,Y),ke},getRegex:function(){return new RegExp(Te,De)}};return ke}var E=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Te,De,ke){if(Te){var oe;try{oe=decodeURIComponent(o(ke)).replace(E,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}De&&!p.test(ke)&&(ke=c(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var s={},r=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Te,De){s[" "+Te]||(r.test(Te)?s[" "+Te]=Te+"/":s[" "+Te]=g(Te,"/",!0)),Te=s[" "+Te];var ke=Te.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:Te.replace(a,"$1")+De:De.charAt(0)==="/"?ke?De:Te.replace(d,"$1")+De:Te+De}var u={exec:function(){}};function n(Te){for(var De=1,ke,oe;De<arguments.length;De++){ke=arguments[De];for(oe in ke)Object.prototype.hasOwnProperty.call(ke,oe)&&(Te[oe]=ke[oe])}return Te}function f(Te,De){var ke=Te.replace(/\|/g,function(Y,I,U){for(var H=!1,j=I;--j>=0&&U[j]==="\\";)H=!H;return H?"|":" |"}),oe=ke.split(/ \|/),ue=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>De)oe.splice(De);else for(;oe.length<De;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function g(Te,De,ke){var oe=Te.length;if(oe===0)return"";for(var ue=0;ue<oe;){var Y=Te.charAt(oe-ue-1);if(Y===De&&!ke)ue++;else if(Y!==De&&ke)ue++;else break}return Te.slice(0,oe-ue)}function P(Te,De){if(Te.indexOf(De[1])===-1)return-1;for(var ke=Te.length,oe=0,ue=0;ue<ke;ue++)if(Te[ue]==="\\")ue++;else if(Te[ue]===De[0])oe++;else if(Te[ue]===De[1]&&(oe--,oe<0))return ue;return-1}function M(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function q(Te,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=Te),De>>=1,Te+=Te;return ke+Te}function J(Te,De,ke,oe){var ue=De.href,Y=De.title?h(De.title):null,I=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){oe.state.inLink=!0;var U={type:"link",raw:ke,href:ue,title:Y,text:I,tokens:oe.inlineTokens(I)};return oe.state.inLink=!1,U}return{type:"image",raw:ke,href:ue,title:Y,text:h(I)}}function x(Te,De){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return De;var oe=ke[1];return De.split(`
`).map(function(ue){var Y=ue.match(/^\s+/);if(Y===null)return ue;var I=Y[0];return I.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var R=function(){function Te(ke){this.options=ke||ee.defaults}var De=Te.prototype;return De.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},De.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var Y=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:g(Y,`
`)}}},De.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var Y=ue[0],I=x(Y,ue[3]||"");return{type:"code",raw:Y,lang:ue[2]?ue[2].trim():ue[2],text:I}}},De.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var Y=ue[2].trim();if(/#$/.test(Y)){var I=g(Y,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Y=I.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:Y,tokens:this.lexer.inline(Y)}}},De.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var Y=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},De.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var Y,I,U,H,j,Z,de,Se,ae,ve,be,$e,He=ue[1].trim(),tt=He.length>1,xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&($e=!1,!(!(ue=et.exec(oe))||this.rules.block.hr.test(oe)));){if(Y=ue[0],oe=oe.substring(Y.length),Se=ue[2].split(`
`,1)[0],ae=oe.split(`
`,1)[0],this.options.pedantic?(H=2,be=Se.trimLeft()):(H=ue[2].search(/[^ ]/),H=H>4?1:H,be=Se.slice(H),H+=ue[1].length),Z=!1,!Se&&/^ *$/.test(ae)&&(Y+=ae+`
`,oe=oe.substring(ae.length+1),$e=!0),!$e)for(var it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");oe&&(ve=oe.split(`
`,1)[0],Se=ve,this.options.pedantic&&(Se=Se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(Se)||st.test(Se)||it.test(Se)||dt.test(oe)));){if(Se.search(/[^ ]/)>=H||!Se.trim())be+=`
`+Se.slice(H);else if(!Z)be+=`
`+Se;else break;!Z&&!Se.trim()&&(Z=!0),Y+=ve+`
`,oe=oe.substring(ve.length+1)}xe.loose||(de?xe.loose=!0:/\n *\n *$/.test(Y)&&(de=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(be),I&&(U=I[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:Y,task:!!I,checked:U,loose:!1,text:be}),xe.raw+=Y}xe.items[xe.items.length-1].raw=Y.trimRight(),xe.items[xe.items.length-1].text=be.trimRight(),xe.raw=xe.raw.trimRight();var Q=xe.items.length;for(j=0;j<Q;j++){this.lexer.state.top=!1,xe.items[j].tokens=this.lexer.blockTokens(xe.items[j].text,[]);var X=xe.items[j].tokens.filter(function(Me){return Me.type==="space"}),pe=X.every(function(Me){for(var Be=Me.raw.split(""),je=0,Je=L(Be),nt;!(nt=Je()).done;){var vt=nt.value;if(vt===`
`&&(je+=1),je>1)return!0}return!1});!xe.loose&&X.length&&pe&&(xe.loose=!0,xe.items[j].loose=!0)}return xe}},De.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue){var Y={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ue[0]):h(ue[0]);Y.type="paragraph",Y.text=I,Y.tokens=this.lexer.inline(I)}return Y}},De.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Y=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var Y={type:"table",header:f(ue[1]).map(function(de){return{text:de}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=ue[0];var I=Y.align.length,U,H,j,Z;for(U=0;U<I;U++)/^ *-+: *$/.test(Y.align[U])?Y.align[U]="right":/^ *:-+: *$/.test(Y.align[U])?Y.align[U]="center":/^ *:-+ *$/.test(Y.align[U])?Y.align[U]="left":Y.align[U]=null;for(I=Y.rows.length,U=0;U<I;U++)Y.rows[U]=f(Y.rows[U],Y.header.length).map(function(de){return{text:de}});for(I=Y.header.length,H=0;H<I;H++)Y.header[H].tokens=this.lexer.inline(Y.header[H].text);for(I=Y.rows.length,H=0;H<I;H++)for(Z=Y.rows[H],j=0;j<Z.length;j++)Z[j].tokens=this.lexer.inline(Z[j].text);return Y}}},De.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},De.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue){var Y=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:Y,tokens:this.lexer.inline(Y)}}},De.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},De.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:h(ue[1])}},De.tag=function(oe){var ue=this.rules.inline.tag.exec(oe);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):h(ue[0]):ue[0]}},De.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var Y=ue[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var I=g(Y.slice(0,-1),"\\");if((Y.length-I.length)%2===0)return}else{var U=P(ue[2],"()");if(U>-1){var H=ue[0].indexOf("!")===0?5:4,j=H+ue[1].length+U;ue[2]=ue[2].substring(0,U),ue[0]=ue[0].substring(0,j).trim(),ue[3]=""}}var Z=ue[2],de="";if(this.options.pedantic){var Se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);Se&&(Z=Se[1],de=Se[3])}else de=ue[3]?ue[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(Y)?Z=Z.slice(1):Z=Z.slice(1,-1)),J(ue,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},De.reflink=function(oe,ue){var Y;if((Y=this.rules.inline.reflink.exec(oe))||(Y=this.rules.inline.nolink.exec(oe))){var I=(Y[2]||Y[1]).replace(/\s+/g," ");if(I=ue[I.toLowerCase()],!I||!I.href){var U=Y[0].charAt(0);return{type:"text",raw:U,text:U}}return J(Y,I,Y[0],this.lexer)}},De.emStrong=function(oe,ue,Y){Y===void 0&&(Y="");var I=this.rules.inline.emStrong.lDelim.exec(oe);if(!!I&&!(I[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=I[1]||I[2]||"";if(!U||U&&(Y===""||this.rules.inline.punctuation.exec(Y))){var H=I[0].length-1,j,Z,de=H,Se=0,ae=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ue=ue.slice(-1*oe.length+H);(I=ae.exec(ue))!=null;)if(j=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!j){if(Z=j.length,I[3]||I[4]){de+=Z;continue}else if((I[5]||I[6])&&H%3&&!((H+Z)%3)){Se+=Z;continue}if(de-=Z,!(de>0)){if(Z=Math.min(Z,Z+de+Se),Math.min(H,Z)%2){var ve=oe.slice(1,H+I.index+Z);return{type:"em",raw:oe.slice(0,H+I.index+Z+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var be=oe.slice(2,H+I.index+Z-1);return{type:"strong",raw:oe.slice(0,H+I.index+Z+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},De.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var Y=ue[2].replace(/\n/g," "),I=/[^ ]/.test(Y),U=/^ /.test(Y)&&/ $/.test(Y);return I&&U&&(Y=Y.substring(1,Y.length-1)),Y=h(Y,!0),{type:"codespan",raw:ue[0],text:Y}}},De.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},De.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},De.autolink=function(oe,ue){var Y=this.rules.inline.autolink.exec(oe);if(Y){var I,U;return Y[2]==="@"?(I=h(this.options.mangle?ue(Y[1]):Y[1]),U="mailto:"+I):(I=h(Y[1]),U=I),{type:"link",raw:Y[0],text:I,href:U,tokens:[{type:"text",raw:I,text:I}]}}},De.url=function(oe,ue){var Y;if(Y=this.rules.inline.url.exec(oe)){var I,U;if(Y[2]==="@")I=h(this.options.mangle?ue(Y[0]):Y[0]),U="mailto:"+I;else{var H;do H=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(H!==Y[0]);I=h(Y[0]),Y[1]==="www."?U="http://"+I:U=I}return{type:"link",raw:Y[0],text:I,href:U,tokens:[{type:"text",raw:I,text:I}]}}},De.inlineText=function(oe,ue){var Y=this.rules.inline.text.exec(oe);if(Y){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):h(Y[0]):Y[0]:I=h(this.options.smartypants?ue(Y[0]):Y[0]),{type:"text",raw:Y[0],text:I}}},Te}(),A={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};A._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,A._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,A.def=b(A.def).replace("label",A._label).replace("title",A._title).getRegex(),A.bullet=/(?:[*+-]|\d{1,9}[.)])/,A.listItemStart=b(/^( *)(bull) */).replace("bull",A.bullet).getRegex(),A.list=b(A.list).replace(/bull/g,A.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+A.def.source+")").getRegex(),A._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",A._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,A.html=b(A.html,"i").replace("comment",A._comment).replace("tag",A._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),A.paragraph=b(A._paragraph).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.blockquote=b(A.blockquote).replace("paragraph",A.paragraph).getRegex(),A.normal=n({},A),A.gfm=n({},A.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),A.gfm.table=b(A.gfm.table).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.gfm.paragraph=b(A._paragraph).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",A.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.pedantic=n({},A.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",A._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:b(A.normal._paragraph).replace("hr",A.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",A.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=b(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=b(A._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=b(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=b(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=b(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=b(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=b(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=b(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=b(F.reflink).replace("label",F._label).replace("ref",A._label).getRegex(),F.nolink=b(F.nolink).replace("ref",A._label).getRegex(),F.reflinkSearch=b(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:b(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=b(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:b(F.br).replace("{2,}","*").getRegex(),text:b(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Te){var De="",ke,oe,ue=Te.length;for(ke=0;ke<ue;ke++)oe=Te.charCodeAt(ke),Math.random()>.5&&(oe="x"+oe.toString(16)),De+="&#"+oe+";";return De}var V=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ee.defaults,this.options.tokenizer=this.options.tokenizer||new R,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:A.normal,inline:F.normal};this.options.pedantic?(oe.block=A.pedantic,oe.inline=F.pedantic):this.options.gfm&&(oe.block=A.gfm,this.options.breaks?oe.inline=F.breaks:oe.inline=F.gfm),this.tokenizer.rules=oe}Te.lex=function(oe,ue){var Y=new Te(ue);return Y.lex(oe)},Te.lexInline=function(oe,ue){var Y=new Te(ue);return Y.inlineTokens(oe)};var De=Te.prototype;return De.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},De.blockTokens=function(oe,ue){var Y=this;ue===void 0&&(ue=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(de,Se,ae){return Se+"    ".repeat(ae.length)});for(var I,U,H,j;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(I=de.call({lexer:Y},oe,ue))?(oe=oe.substring(I.raw.length),ue.push(I),!0):!1}))){if(I=this.tokenizer.space(oe)){oe=oe.substring(I.raw.length),I.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(I);continue}if(I=this.tokenizer.code(oe)){oe=oe.substring(I.raw.length),U=ue[ue.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+I.raw,U.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):ue.push(I);continue}if(I=this.tokenizer.fences(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.heading(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.hr(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.blockquote(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.list(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.html(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.def(oe)){oe=oe.substring(I.raw.length),U=ue[ue.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+I.raw,U.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.lheading(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(H=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=1/0,Se=oe.slice(1),ae=void 0;Y.options.extensions.startBlock.forEach(function(ve){ae=ve.call({lexer:this},Se),typeof ae=="number"&&ae>=0&&(de=Math.min(de,ae))}),de<1/0&&de>=0&&(H=oe.substring(0,de+1))}(),this.state.top&&(I=this.tokenizer.paragraph(H))){U=ue[ue.length-1],j&&U.type==="paragraph"?(U.raw+=`
`+I.raw,U.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):ue.push(I),j=H.length!==oe.length,oe=oe.substring(I.raw.length);continue}if(I=this.tokenizer.text(oe)){oe=oe.substring(I.raw.length),U=ue[ue.length-1],U&&U.type==="text"?(U.raw+=`
`+I.raw,U.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):ue.push(I);continue}if(oe){var Z="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,ue},De.inline=function(oe,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:oe,tokens:ue}),ue},De.inlineTokens=function(oe,ue){var Y=this;ue===void 0&&(ue=[]);var I,U,H,j=oe,Z,de,Se;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(j))!=null;)ae.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(j=j.slice(0,Z.index)+"["+q("a",Z[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(j))!=null;)j=j.slice(0,Z.index)+"["+q("a",Z[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(j))!=null;)j=j.slice(0,Z.index)+"++"+j.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(de||(Se=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(I=be.call({lexer:Y},oe,ue))?(oe=oe.substring(I.raw.length),ue.push(I),!0):!1}))){if(I=this.tokenizer.escape(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.tag(oe)){oe=oe.substring(I.raw.length),U=ue[ue.length-1],U&&I.type==="text"&&U.type==="text"?(U.raw+=I.raw,U.text+=I.text):ue.push(I);continue}if(I=this.tokenizer.link(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(I.raw.length),U=ue[ue.length-1],U&&I.type==="text"&&U.type==="text"?(U.raw+=I.raw,U.text+=I.text):ue.push(I);continue}if(I=this.tokenizer.emStrong(oe,j,Se)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.codespan(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.br(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.del(oe)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(I=this.tokenizer.autolink(oe,z)){oe=oe.substring(I.raw.length),ue.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(oe,z))){oe=oe.substring(I.raw.length),ue.push(I);continue}if(H=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,$e=oe.slice(1),He=void 0;Y.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},$e),typeof He=="number"&&He>=0&&(be=Math.min(be,He))}),be<1/0&&be>=0&&(H=oe.substring(0,be+1))}(),I=this.tokenizer.inlineText(H,$)){oe=oe.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(Se=I.raw.slice(-1)),de=!0,U=ue[ue.length-1],U&&U.type==="text"?(U.raw+=I.raw,U.text+=I.text):ue.push(I);continue}if(oe){var ve="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ue},i(Te,null,[{key:"rules",get:function(){return{block:A,inline:F}}}]),Te}(),K=function(){function Te(ke){this.options=ke||ee.defaults}var De=Te.prototype;return De.code=function(oe,ue,Y){var I=(ue||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(oe,I);U!=null&&U!==oe&&(Y=!0,oe=U)}return oe=oe.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+h(I,!0)+'">'+(Y?oe:h(oe,!0))+`</code></pre>
`:"<pre><code>"+(Y?oe:h(oe,!0))+`</code></pre>
`},De.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},De.html=function(oe){return oe},De.heading=function(oe,ue,Y,I){if(this.options.headerIds){var U=this.options.headerPrefix+I.slug(Y);return"<h"+ue+' id="'+U+'">'+oe+"</h"+ue+`>
`}return"<h"+ue+">"+oe+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(oe,ue,Y){var I=ue?"ol":"ul",U=ue&&Y!==1?' start="'+Y+'"':"";return"<"+I+U+`>
`+oe+"</"+I+`>
`},De.listitem=function(oe){return"<li>"+oe+`</li>
`},De.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(oe){return"<p>"+oe+`</p>
`},De.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},De.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},De.tablecell=function(oe,ue){var Y=ue.header?"th":"td",I=ue.align?"<"+Y+' align="'+ue.align+'">':"<"+Y+">";return I+oe+("</"+Y+`>
`)},De.strong=function(oe){return"<strong>"+oe+"</strong>"},De.em=function(oe){return"<em>"+oe+"</em>"},De.codespan=function(oe){return"<code>"+oe+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(oe){return"<del>"+oe+"</del>"},De.link=function(oe,ue,Y){if(oe=w(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var I='<a href="'+h(oe)+'"';return ue&&(I+=' title="'+ue+'"'),I+=">"+Y+"</a>",I},De.image=function(oe,ue,Y){if(oe=w(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var I='<img src="'+oe+'" alt="'+Y+'"';return ue&&(I+=' title="'+ue+'"'),I+=this.options.xhtml?"/>":">",I},De.text=function(oe){return oe},Te}(),ie=function(){function Te(){}var De=Te.prototype;return De.strong=function(oe){return oe},De.em=function(oe){return oe},De.codespan=function(oe){return oe},De.del=function(oe){return oe},De.html=function(oe){return oe},De.text=function(oe){return oe},De.link=function(oe,ue,Y){return""+Y},De.image=function(oe,ue,Y){return""+Y},De.br=function(){return""},Te}(),ge=function(){function Te(){this.seen={}}var De=Te.prototype;return De.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(oe,ue){var Y=oe,I=0;if(this.seen.hasOwnProperty(Y)){I=this.seen[oe];do I++,Y=oe+"-"+I;while(this.seen.hasOwnProperty(Y))}return ue||(this.seen[oe]=I,this.seen[Y]=0),Y},De.slug=function(oe,ue){ue===void 0&&(ue={});var Y=this.serialize(oe);return this.getNextSafeSlug(Y,ue.dryrun)},Te}(),ce=function(){function Te(ke){this.options=ke||ee.defaults,this.options.renderer=this.options.renderer||new K,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new ge}Te.parse=function(oe,ue){var Y=new Te(ue);return Y.parse(oe)},Te.parseInline=function(oe,ue){var Y=new Te(ue);return Y.parseInline(oe)};var De=Te.prototype;return De.parse=function(oe,ue){ue===void 0&&(ue=!0);var Y="",I,U,H,j,Z,de,Se,ae,ve,be,$e,He,tt,xe,et,it,dt,Fe,st,Q=oe.length;for(I=0;I<Q;I++){if(be=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(st=this.options.extensions.renderers[be.type].call({parser:this},be),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){Y+=st||"";continue}switch(be.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(be.tokens),be.depth,o(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(ae="",Se="",j=be.header.length,U=0;U<j;U++)Se+=this.renderer.tablecell(this.parseInline(be.header[U].tokens),{header:!0,align:be.align[U]});for(ae+=this.renderer.tablerow(Se),ve="",j=be.rows.length,U=0;U<j;U++){for(de=be.rows[U],Se="",Z=de.length,H=0;H<Z;H++)Se+=this.renderer.tablecell(this.parseInline(de[H].tokens),{header:!1,align:be.align[H]});ve+=this.renderer.tablerow(Se)}Y+=this.renderer.table(ae,ve);continue}case"blockquote":{ve=this.parse(be.tokens),Y+=this.renderer.blockquote(ve);continue}case"list":{for($e=be.ordered,He=be.start,tt=be.loose,j=be.items.length,ve="",U=0;U<j;U++)et=be.items[U],it=et.checked,dt=et.task,xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):xe+=Fe),xe+=this.parse(et.tokens,tt),ve+=this.renderer.listitem(xe,dt,it);Y+=this.renderer.list(ve,$e,He);continue}case"html":{Y+=this.renderer.html(be.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(ve=be.tokens?this.parseInline(be.tokens):be.text;I+1<Q&&oe[I+1].type==="text";)be=oe[++I],ve+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);Y+=ue?this.renderer.paragraph(ve):ve;continue}default:{var X='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return Y},De.parseInline=function(oe,ue){ue=ue||this.renderer;var Y="",I,U,H,j=oe.length;for(I=0;I<j;I++){if(U=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(H=this.options.extensions.renderers[U.type].call({parser:this},U),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){Y+=H||"";continue}switch(U.type){case"escape":{Y+=ue.text(U.text);break}case"html":{Y+=ue.html(U.text);break}case"link":{Y+=ue.link(U.href,U.title,this.parseInline(U.tokens,ue));break}case"image":{Y+=ue.image(U.href,U.title,U.text);break}case"strong":{Y+=ue.strong(this.parseInline(U.tokens,ue));break}case"em":{Y+=ue.em(this.parseInline(U.tokens,ue));break}case"codespan":{Y+=ue.codespan(U.text);break}case"br":{Y+=ue.br();break}case"del":{Y+=ue.del(this.parseInline(U.tokens,ue));break}case"text":{Y+=ue.text(U.text);break}default:{var Z='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return Y},Te}();function re(Te,De,ke){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=n({},re.defaults,De||{}),M(De),ke){var oe=De.highlight,ue;try{ue=V.lex(Te,De)}catch(j){return ke(j)}var Y=function(Z){var de;if(!Z)try{De.walkTokens&&re.walkTokens(ue,De.walkTokens),de=ce.parse(ue,De)}catch(Se){Z=Se}return De.highlight=oe,Z?ke(Z):ke(null,de)};if(!oe||oe.length<3||(delete De.highlight,!ue.length))return Y();var I=0;re.walkTokens(ue,function(j){j.type==="code"&&(I++,setTimeout(function(){oe(j.text,j.lang,function(Z,de){if(Z)return Y(Z);de!=null&&de!==j.text&&(j.text=de,j.escaped=!0),I--,I===0&&Y()})},0))}),I===0&&Y();return}function U(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+h(j.message+"",!0)+"</pre>";throw j}try{var H=V.lex(Te,De);if(De.walkTokens){if(De.async)return Promise.all(re.walkTokens(H,De.walkTokens)).then(function(){return ce.parse(H,De)}).catch(U);re.walkTokens(H,De.walkTokens)}return ce.parse(H,De)}catch(j){U(j)}}re.options=re.setOptions=function(Te){return n(re.defaults,Te),O(re.defaults),re},re.getDefaults=C,re.defaults=ee.defaults,re.use=function(){for(var Te=arguments.length,De=new Array(Te),ke=0;ke<Te;ke++)De[ke]=arguments[ke];var oe=n.apply(void 0,[{}].concat(De)),ue=re.defaults.extensions||{renderers:{},childTokens:{}},Y;De.forEach(function(I){if(I.extensions&&(Y=!0,I.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var j=ue.renderers?ue.renderers[H.name]:null;j?ue.renderers[H.name]=function(){for(var Z=arguments.length,de=new Array(Z),Se=0;Se<Z;Se++)de[Se]=arguments[Se];var ae=H.renderer.apply(this,de);return ae===!1&&(ae=j.apply(this,de)),ae}:ue.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[H.level]?ue[H.level].unshift(H.tokenizer):ue[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ue.startBlock?ue.startBlock.push(H.start):ue.startBlock=[H.start]:H.level==="inline"&&(ue.startInline?ue.startInline.push(H.start):ue.startInline=[H.start]))}H.childTokens&&(ue.childTokens[H.name]=H.childTokens)})),I.renderer&&function(){var H=re.defaults.renderer||new K,j=function(Se){var ae=H[Se];H[Se]=function(){for(var ve=arguments.length,be=new Array(ve),$e=0;$e<ve;$e++)be[$e]=arguments[$e];var He=I.renderer[Se].apply(H,be);return He===!1&&(He=ae.apply(H,be)),He}};for(var Z in I.renderer)j(Z);oe.renderer=H}(),I.tokenizer&&function(){var H=re.defaults.tokenizer||new R,j=function(Se){var ae=H[Se];H[Se]=function(){for(var ve=arguments.length,be=new Array(ve),$e=0;$e<ve;$e++)be[$e]=arguments[$e];var He=I.tokenizer[Se].apply(H,be);return He===!1&&(He=ae.apply(H,be)),He}};for(var Z in I.tokenizer)j(Z);oe.tokenizer=H}(),I.walkTokens){var U=re.defaults.walkTokens;oe.walkTokens=function(H){var j=[];return j.push(I.walkTokens.call(this,H)),U&&(j=j.concat(U.call(this,H))),j}}Y&&(oe.extensions=ue),re.setOptions(oe)})},re.walkTokens=function(Te,De){for(var ke=[],oe=function(){var U=Y.value;switch(ke=ke.concat(De.call(re,U)),U.type){case"table":{for(var H=L(U.header),j;!(j=H()).done;){var Z=j.value;ke=ke.concat(re.walkTokens(Z.tokens,De))}for(var de=L(U.rows),Se;!(Se=de()).done;)for(var ae=Se.value,ve=L(ae),be;!(be=ve()).done;){var $e=be.value;ke=ke.concat(re.walkTokens($e.tokens,De))}break}case"list":{ke=ke.concat(re.walkTokens(U.items,De));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[U.type]?re.defaults.extensions.childTokens[U.type].forEach(function(He){ke=ke.concat(re.walkTokens(U[He],De))}):U.tokens&&(ke=ke.concat(re.walkTokens(U.tokens,De)))}},ue=L(Te),Y;!(Y=ue()).done;)oe();return ke},re.parseInline=function(Te,De){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");De=n({},re.defaults,De||{}),M(De);try{var ke=V.lexInline(Te,De);return De.walkTokens&&re.walkTokens(ke,De.walkTokens),ce.parseInline(ke,De)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+h(oe.message+"",!0)+"</pre>";throw oe}},re.Parser=ce,re.parser=ce.parse,re.Renderer=K,re.TextRenderer=ie,re.Lexer=V,re.lexer=V.lex,re.Tokenizer=R,re.Slugger=ge,re.parse=re;var se=re.options,le=re.setOptions,_=re.use,me=re.walkTokens,we=re.parseInline,Ne=re,We=ce.parse,Qe=V.lex;ee.Lexer=V,ee.Parser=ce,ee.Renderer=K,ee.Slugger=ge,ee.TextRenderer=ie,ee.Tokenizer=R,ee.getDefaults=C,ee.lexer=Qe,ee.marked=re,ee.options=se,ee.parse=Ne,ee.parseInline=we,ee.parser=We,ee.setOptions=le,ee.use=_,ee.walkTokens=me,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ie[110],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(O,S,k){return Math.min(Math.max(O,S),k)}e.clamp=i;function T(O,S){return(S+O%S)%S}e.rot=T;class y{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=y;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const k=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ee(y){const L=[];typeof y=="number"&&L.push("code/timeOrigin",y);function C(S){L.push(S,Date.now())}function O(){const S=[];for(let k=0;k<L.length;k+=2)S.push({name:L[k],startTime:L[k+1]});return S}return{mark:C,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))L.push({name:C.name,startTime:Math.round(y+C.startTime)});return L}};if(typeof process=="object"){const y=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function i(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=i(T))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var T in i)(typeof exports=="object"?exports:ee)[T]=i[T]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function i(T){if(e[T])return e[T].exports;var y=e[T]={i:T,l:!1,exports:{}};return ee[T].call(y.exports,y,y.exports,i),y.l=!0,y.exports}return i.m=ee,i.c=e,i.d=function(T,y,L){i.o(T,y)||Object.defineProperty(T,y,{enumerable:!0,get:L})},i.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},i.t=function(T,y){if(1&y&&(T=i(T)),8&y||4&y&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(i.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&y&&typeof T!="string")for(var C in T)i.d(L,C,function(O){return T[O]}.bind(null,C));return L},i.n=function(T){var y=T&&T.__esModule?function(){return T.default}:function(){return T};return i.d(y,"a",y),y},i.o=function(T,y){return Object.prototype.hasOwnProperty.call(T,y)},i.p="",i(i.s=0)}([function(ee,e,i){(function(T){var y;e=ee.exports=_,y=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],S=e.src=[],k=0,N=k++;S[N]="0|[1-9]\\d*";var D=k++;S[D]="[0-9]+";var m=k++;S[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=k++;S[v]="("+S[N]+")\\.("+S[N]+")\\.("+S[N]+")";var h=k++;S[h]="("+S[D]+")\\.("+S[D]+")\\.("+S[D]+")";var t=k++;S[t]="(?:"+S[N]+"|"+S[m]+")";var o=k++;S[o]="(?:"+S[D]+"|"+S[m]+")";var l=k++;S[l]="(?:-("+S[t]+"(?:\\."+S[t]+")*))";var b=k++;S[b]="(?:-?("+S[o]+"(?:\\."+S[o]+")*))";var E=k++;S[E]="[0-9A-Za-z-]+";var p=k++;S[p]="(?:\\+("+S[E]+"(?:\\."+S[E]+")*))";var w=k++,s="v?"+S[v]+S[l]+"?"+S[p]+"?";S[w]="^"+s+"$";var r="[v=\\s]*"+S[h]+S[b]+"?"+S[p]+"?",a=k++;S[a]="^"+r+"$";var d=k++;S[d]="((?:<|>)?=?)";var c=k++;S[c]=S[D]+"|x|X|\\*";var u=k++;S[u]=S[N]+"|x|X|\\*";var n=k++;S[n]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[l]+")?"+S[p]+"?)?)?";var f=k++;S[f]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[b]+")?"+S[p]+"?)?)?";var g=k++;S[g]="^"+S[d]+"\\s*"+S[n]+"$";var P=k++;S[P]="^"+S[d]+"\\s*"+S[f]+"$";var M=k++;S[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=k++;S[q]="(?:~>?)";var J=k++;S[J]="(\\s*)"+S[q]+"\\s+",O[J]=new RegExp(S[J],"g");var x=k++;S[x]="^"+S[q]+S[n]+"$";var R=k++;S[R]="^"+S[q]+S[f]+"$";var A=k++;S[A]="(?:\\^)";var F=k++;S[F]="(\\s*)"+S[A]+"\\s+",O[F]=new RegExp(S[F],"g");var $=k++;S[$]="^"+S[A]+S[n]+"$";var z=k++;S[z]="^"+S[A]+S[f]+"$";var V=k++;S[V]="^"+S[d]+"\\s*("+r+")$|^$";var K=k++;S[K]="^"+S[d]+"\\s*("+s+")$|^$";var ie=k++;S[ie]="(\\s*)"+S[d]+"\\s*("+r+"|"+S[n]+")",O[ie]=new RegExp(S[ie],"g");var ge=k++;S[ge]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var ce=k++;S[ce]="^\\s*("+S[f]+")\\s+-\\s+("+S[f]+")\\s*$";var re=k++;S[re]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)y(se,S[se]),O[se]||(O[se]=new RegExp(S[se]));function le(ae,ve){if(ae instanceof _)return ae;if(typeof ae!="string"||ae.length>L||!(ve?O[a]:O[w]).test(ae))return null;try{return new _(ae,ve)}catch{return null}}function _(ae,ve){if(ae instanceof _){if(ae.loose===ve)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof _))return new _(ae,ve);y("SemVer",ae,ve),this.loose=ve;var be=ae.trim().match(ve?O[a]:O[w]);if(!be)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var He=+$e;if(He>=0&&He<C)return He}return $e}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=le,e.valid=function(ae,ve){var be=le(ae,ve);return be?be.version:null},e.clean=function(ae,ve){var be=le(ae.trim().replace(/^[=v]+/,""),ve);return be?be.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(ae){return y("SemVer.compare",this.version,this.loose,ae),ae instanceof _||(ae=new _(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},_.prototype.compareMain=function(ae){return ae instanceof _||(ae=new _(ae,this.loose)),we(this.major,ae.major)||we(this.minor,ae.minor)||we(this.patch,ae.patch)},_.prototype.comparePre=function(ae){if(ae instanceof _||(ae=new _(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var ve=0;do{var be=this.prerelease[ve],$e=ae.prerelease[ve];if(y("prerelease compare",ve,be,$e),be===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(be===void 0)return-1;if(be!==$e)return we(be,$e)}while(++ve)},_.prototype.inc=function(ae,ve){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,ve,be,$e){typeof be=="string"&&($e=be,be=void 0);try{return new _(ae,be).inc(ve,$e).version}catch{return null}},e.diff=function(ae,ve){if(Te(ae,ve))return null;var be=le(ae),$e=le(ve);if(be.prerelease.length||$e.prerelease.length){for(var He in be)if((He==="major"||He==="minor"||He==="patch")&&be[He]!==$e[He])return"pre"+He;return"prerelease"}for(var He in be)if((He==="major"||He==="minor"||He==="patch")&&be[He]!==$e[He])return He},e.compareIdentifiers=we;var me=/^[0-9]+$/;function we(ae,ve){var be=me.test(ae),$e=me.test(ve);return be&&$e&&(ae=+ae,ve=+ve),be&&!$e?-1:$e&&!be?1:ae<ve?-1:ae>ve?1:0}function Ne(ae,ve,be){return new _(ae,be).compare(new _(ve,be))}function We(ae,ve,be){return Ne(ae,ve,be)>0}function Qe(ae,ve,be){return Ne(ae,ve,be)<0}function Te(ae,ve,be){return Ne(ae,ve,be)===0}function De(ae,ve,be){return Ne(ae,ve,be)!==0}function ke(ae,ve,be){return Ne(ae,ve,be)>=0}function oe(ae,ve,be){return Ne(ae,ve,be)<=0}function ue(ae,ve,be,$e){var He;switch(ve){case"===":typeof ae=="object"&&(ae=ae.version),typeof be=="object"&&(be=be.version),He=ae===be;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof be=="object"&&(be=be.version),He=ae!==be;break;case"":case"=":case"==":He=Te(ae,be,$e);break;case"!=":He=De(ae,be,$e);break;case">":He=We(ae,be,$e);break;case">=":He=ke(ae,be,$e);break;case"<":He=Qe(ae,be,$e);break;case"<=":He=oe(ae,be,$e);break;default:throw new TypeError("Invalid operator: "+ve)}return He}function Y(ae,ve){if(ae instanceof Y){if(ae.loose===ve)return ae;ae=ae.value}if(!(this instanceof Y))return new Y(ae,ve);y("comparator",ae,ve),this.loose=ve,this.parse(ae),this.semver===I?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(ae,ve){return we(ve,ae)},e.major=function(ae,ve){return new _(ae,ve).major},e.minor=function(ae,ve){return new _(ae,ve).minor},e.patch=function(ae,ve){return new _(ae,ve).patch},e.compare=Ne,e.compareLoose=function(ae,ve){return Ne(ae,ve,!0)},e.rcompare=function(ae,ve,be){return Ne(ve,ae,be)},e.sort=function(ae,ve){return ae.sort(function(be,$e){return e.compare(be,$e,ve)})},e.rsort=function(ae,ve){return ae.sort(function(be,$e){return e.rcompare(be,$e,ve)})},e.gt=We,e.lt=Qe,e.eq=Te,e.neq=De,e.gte=ke,e.lte=oe,e.cmp=ue,e.Comparator=Y;var I={};function U(ae,ve){if(ae instanceof U)return ae.loose===ve?ae:new U(ae.raw,ve);if(ae instanceof Y)return new U(ae.value,ve);if(!(this instanceof U))return new U(ae,ve);if(this.loose=ve,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function H(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function j(ae,ve,be,$e,He,tt,xe,et,it,dt,Fe,st,Q){return((ve=H(be)?"":H($e)?">="+be+".0.0":H(He)?">="+be+"."+$e+".0":">="+ve)+" "+(et=H(it)?"":H(dt)?"<"+(+it+1)+".0.0":H(Fe)?"<"+it+"."+(+dt+1)+".0":st?"<="+it+"."+dt+"."+Fe+"-"+st:"<="+et)).trim()}function Z(ae,ve){for(var be=0;be<ae.length;be++)if(!ae[be].test(ve))return!1;if(ve.prerelease.length){for(be=0;be<ae.length;be++)if(y(ae[be].semver),ae[be].semver!==I&&ae[be].semver.prerelease.length>0){var $e=ae[be].semver;if($e.major===ve.major&&$e.minor===ve.minor&&$e.patch===ve.patch)return!0}return!1}return!0}function de(ae,ve,be){try{ve=new U(ve,be)}catch{return!1}return ve.test(ae)}function Se(ae,ve,be,$e){var He,tt,xe,et,it;switch(ae=new _(ae,$e),ve=new U(ve,$e),be){case">":He=We,tt=oe,xe=Qe,et=">",it=">=";break;case"<":He=Qe,tt=ke,xe=We,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(de(ae,ve,$e))return!1;for(var dt=0;dt<ve.set.length;++dt){var Fe=ve.set[dt],st=null,Q=null;if(Fe.forEach(function(X){X.semver===I&&(X=new Y(">=0.0.0")),st=st||X,Q=Q||X,He(X.semver,st.semver,$e)?st=X:xe(X.semver,Q.semver,$e)&&(Q=X)}),st.operator===et||st.operator===it||(!Q.operator||Q.operator===et)&&tt(ae,Q.semver)||Q.operator===it&&xe(ae,Q.semver))return!1}return!0}Y.prototype.parse=function(ae){var ve=this.loose?O[V]:O[K],be=ae.match(ve);if(!be)throw new TypeError("Invalid comparator: "+ae);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new _(be[2],this.loose):this.semver=I},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(ae){return y("Comparator.test",ae,this.loose),this.semver===I||(typeof ae=="string"&&(ae=new _(ae,this.loose)),ue(ae,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(ae,ve){if(!(ae instanceof Y))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new U(ae.value,ve),de(this.value,be,ve);if(ae.operator==="")return be=new U(this.value,ve),de(ae.semver,be,ve);var $e=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ue(this.semver,"<",ae.semver,ve)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ue(this.semver,">",ae.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return $e||He||tt&&xe||et||it},e.Range=U,U.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},U.prototype.toString=function(){return this.range},U.prototype.parseRange=function(ae){var ve=this.loose;ae=ae.trim(),y("range",ae,ve);var be=ve?O[ce]:O[ge];ae=ae.replace(be,j),y("hyphen replace",ae),ae=ae.replace(O[ie],"$1$2$3"),y("comparator trim",ae,O[ie]),ae=(ae=(ae=ae.replace(O[J],"$1~")).replace(O[F],"$1^")).split(/\s+/).join(" ");var $e=ve?O[V]:O[K],He=ae.split(" ").map(function(tt){return function(xe,et){return y("comp",xe),xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,Q){y("caret",st,Q);var X=Q?O[z]:O[$];return st.replace(X,function(pe,Me,Be,je,Je){var nt;return y("caret",st,pe,Me,Be,je,Je),H(Me)?nt="":H(Be)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":H(je)?nt=Me==="0"?">="+Me+"."+Be+".0 <"+Me+"."+(+Be+1)+".0":">="+Me+"."+Be+".0 <"+(+Me+1)+".0.0":Je?(y("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),nt=Me==="0"?Be==="0"?">="+Me+"."+Be+"."+je+Je+" <"+Me+"."+Be+"."+(+je+1):">="+Me+"."+Be+"."+je+Je+" <"+Me+"."+(+Be+1)+".0":">="+Me+"."+Be+"."+je+Je+" <"+(+Me+1)+".0.0"):(y("no pr"),nt=Me==="0"?Be==="0"?">="+Me+"."+Be+"."+je+" <"+Me+"."+Be+"."+(+je+1):">="+Me+"."+Be+"."+je+" <"+Me+"."+(+Be+1)+".0":">="+Me+"."+Be+"."+je+" <"+(+Me+1)+".0.0"),y("caret return",nt),nt})}(Fe,dt)}).join(" ")}(xe,et),y("caret",xe),xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,Q){var X=Q?O[R]:O[x];return st.replace(X,function(pe,Me,Be,je,Je){var nt;return y("tilde",st,pe,Me,Be,je,Je),H(Me)?nt="":H(Be)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":H(je)?nt=">="+Me+"."+Be+".0 <"+Me+"."+(+Be+1)+".0":Je?(y("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),nt=">="+Me+"."+Be+"."+je+Je+" <"+Me+"."+(+Be+1)+".0"):nt=">="+Me+"."+Be+"."+je+" <"+Me+"."+(+Be+1)+".0",y("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(xe,et),y("tildes",xe),xe=function(it,dt){return y("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(st,Q){st=st.trim();var X=Q?O[P]:O[g];return st.replace(X,function(pe,Me,Be,je,Je,nt){y("xRange",st,pe,Me,Be,je,Je,nt);var vt=H(Be),wt=vt||H(je),Tt=wt||H(Je);return Me==="="&&Tt&&(Me=""),vt?pe=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Tt?(wt&&(je=0),Tt&&(Je=0),Me===">"?(Me=">=",wt?(Be=+Be+1,je=0,Je=0):Tt&&(je=+je+1,Je=0)):Me==="<="&&(Me="<",wt?Be=+Be+1:je=+je+1),pe=Me+Be+"."+je+"."+Je):wt?pe=">="+Be+".0.0 <"+(+Be+1)+".0.0":Tt&&(pe=">="+Be+"."+je+".0 <"+Be+"."+(+je+1)+".0"),y("xRange return",pe),pe})}(Fe,dt)}).join(" ")}(xe,et),y("xrange",xe),xe=function(it,dt){return y("replaceStars",it,dt),it.trim().replace(O[re],"")}(xe,et),y("stars",xe),xe}(tt,ve)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match($e)})),He=He.map(function(tt){return new Y(tt,ve)})},U.prototype.intersects=function(ae,ve){if(!(ae instanceof U))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function($e){return ae.set.some(function(He){return He.every(function(tt){return $e.intersects(tt,ve)})})})})},e.toComparators=function(ae,ve){return new U(ae,ve).set.map(function(be){return be.map(function($e){return $e.value}).join(" ").trim().split(" ")})},U.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new _(ae,this.loose));for(var ve=0;ve<this.set.length;ve++)if(Z(this.set[ve],ae))return!0;return!1},e.satisfies=de,e.maxSatisfying=function(ae,ve,be){var $e=null,He=null;try{var tt=new U(ve,be)}catch{return null}return ae.forEach(function(xe){tt.test(xe)&&($e&&He.compare(xe)!==-1||(He=new _($e=xe,be)))}),$e},e.minSatisfying=function(ae,ve,be){var $e=null,He=null;try{var tt=new U(ve,be)}catch{return null}return ae.forEach(function(xe){tt.test(xe)&&($e&&He.compare(xe)!==1||(He=new _($e=xe,be)))}),$e},e.validRange=function(ae,ve){try{return new U(ae,ve).range||"*"}catch{return null}},e.ltr=function(ae,ve,be){return Se(ae,ve,"<",be)},e.gtr=function(ae,ve,be){return Se(ae,ve,">",be)},e.outside=Se,e.prerelease=function(ae,ve){var be=le(ae,ve);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ae,ve,be){return ae=new U(ae,be),ve=new U(ve,be),ae.intersects(ve)},e.coerce=function(ae){if(ae instanceof _)return ae;if(typeof ae!="string")return null;var ve=ae.match(O[M]);return ve==null?null:le((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,i(1))},function(ee,e){var i,T,y=ee.exports={};function L(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function O(o){if(i===setTimeout)return setTimeout(o,0);if((i===L||!i)&&setTimeout)return i=setTimeout,setTimeout(o,0);try{return i(o,0)}catch{try{return i.call(null,o,0)}catch{return i.call(this,o,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:L}catch{i=L}try{T=typeof clearTimeout=="function"?clearTimeout:C}catch{T=C}})();var S,k=[],N=!1,D=-1;function m(){N&&S&&(N=!1,S.length?k=S.concat(k):D=-1,k.length&&v())}function v(){if(!N){var o=O(m);N=!0;for(var l=k.length;l;){for(S=k,k=[];++D<l;)S&&S[D].run();D=-1,l=k.length}S=null,N=!1,function(b){if(T===clearTimeout)return clearTimeout(b);if((T===C||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(b);try{T(b)}catch{try{return T.call(null,b)}catch{return T.call(this,b)}}}(o)}}function h(o,l){this.fun=o,this.array=l}function t(){}y.nextTick=function(o){var l=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)l[b-1]=arguments[b];k.push(new h(o,l)),k.length!==1||N||O(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=t,y.addListener=t,y.once=t,y.off=t,y.removeListener=t,y.removeAllListeners=t,y.emit=t,y.prependListener=t,y.prependOnceListener=t,y.listeners=function(o){return[]},y.binding=function(o){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(o){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Ie[111],Ce([1,0,11,7]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(p){const w=p;return w?typeof w.read=="function":!1}e.isReadable=y;function L(p){const w=p;return w?[w.on,w.pause,w.resume,w.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=L;function C(p){const w=p;return w?L(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=C;function O(p,w){return new S(p,w)}e.newWriteableStream=O;class S{constructor(w,s){this.e=w,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(s=>s(w))}h(w){this.c.error.length===0?(0,i.onUnexpectedError)(w):this.c.error.slice(0).forEach(s=>s(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,s){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(w,s){if(this.a.destroyed)return;let r;switch(w){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const a=r.indexOf(s);a>=0&&r.splice(a,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(p,w){const s=[];let r;for(;(r=p.read())!==null;)s.push(r);return w(s)}e.consumeReadable=k;function N(p,w,s){const r=[];let a;for(;(a=p.read())!==null&&r.length<s;)r.push(a);return a===null&&r.length>0?w(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return p.read()}}}e.peekReadable=N;function D(p,w){return new Promise((s,r)=>{const a=[];m(p,{onData:d=>{w&&a.push(d)},onError:d=>{w?r(d):s(void 0)},onEnd:()=>{s(w?w(a):void 0)}})})}e.consumeStream=D;function m(p,w){let s=!1;return p.on("error",r=>{s||w.onError(r)}),p.on("end",()=>{s||w.onEnd()}),p.on("data",r=>{s||w.onData(r)}),(0,T.toDisposable)(()=>s=!0)}e.listenStream=m;function v(p,w){return new Promise((s,r)=>{const a=new T.DisposableStore,d=[],c=f=>{if(d.push(f),d.length>w)return a.dispose(),p.pause(),s({stream:p,buffer:d,ended:!1})},u=f=>r(f),n=()=>s({stream:p,buffer:d,ended:!0});a.add((0,T.toDisposable)(()=>p.removeListener("error",u))),p.on("error",u),a.add((0,T.toDisposable)(()=>p.removeListener("end",n))),p.on("end",n),a.add((0,T.toDisposable)(()=>p.removeListener("data",c))),p.on("data",c)})}e.peekStream=v;function h(p,w){const s=O(w);return s.end(p),s}e.toStream=h;function t(){const p=O(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=t;function o(p){let w=!1;return{read:()=>w?null:(w=!0,p)}}e.toReadable=o;function l(p,w,s){const r=O(s);return m(p,{onData:a=>r.write(w.data(a)),onError:a=>r.error(w.error?w.error(a):a),onEnd:()=>r.end()}),r}e.transform=l;function b(p,w,s){let r=!1;return{read:()=>{const a=w.read();return r?a:(r=!0,a!==null?s([p,a]):p)}}}e.prefixedReadable=b;function E(p,w,s){let r=!1;const a=O(s);return m(w,{onData:d=>r?a.write(d):(r=!0,a.write(s([p,d]))),onError:d=>a.error(d),onEnd:()=>{r||(r=!0,a.write(p)),a.end()}}),a}e.prefixedStream=E}),define(Ie[24],Ce([1,0,111]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let y,L;class C{static alloc(f){return T?new C(Buffer.allocUnsafe(f)):new C(new Uint8Array(f))}static wrap(f){return T&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new C(f)}static fromString(f,g){return!(g?.dontUseNodeBuffer||!1)&&T?new C(Buffer.from(f)):(y||(y=new TextEncoder),new C(y.encode(f)))}static fromByteArray(f){const g=C.alloc(f.length);for(let P=0,M=f.length;P<M;P++)g.buffer[P]=f[P];return g}static concat(f,g){if(typeof g>"u"){g=0;for(let q=0,J=f.length;q<J;q++)g+=f[q].byteLength}const P=C.alloc(g);let M=0;for(let q=0,J=f.length;q<J;q++){const x=f[q];P.set(x,M),M+=x.byteLength}return P}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=C.alloc(this.byteLength);return f.set(this),f}toString(){return T?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(f,g){return new C(this.buffer.subarray(f,g))}set(f,g){if(f instanceof C)this.buffer.set(f.buffer,g);else if(f instanceof Uint8Array)this.buffer.set(f,g);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),g);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return k(this.buffer,f)}writeUInt32BE(f,g){N(this.buffer,f,g)}readUInt32LE(f){return D(this.buffer,f)}writeUInt32LE(f,g){m(this.buffer,f,g)}readUInt8(f){return v(this.buffer,f)}writeUInt8(f,g){h(this.buffer,f,g)}}e.VSBuffer=C;function O(n,f){return n[f+0]<<0>>>0|n[f+1]<<8>>>0}e.readUInt16LE=O;function S(n,f,g){n[g+0]=f&255,f=f>>>8,n[g+1]=f&255}e.writeUInt16LE=S;function k(n,f){return n[f]*2**24+n[f+1]*2**16+n[f+2]*2**8+n[f+3]}e.readUInt32BE=k;function N(n,f,g){n[g+3]=f,f=f>>>8,n[g+2]=f,f=f>>>8,n[g+1]=f,f=f>>>8,n[g]=f}e.writeUInt32BE=N;function D(n,f){return n[f+0]<<0>>>0|n[f+1]<<8>>>0|n[f+2]<<16>>>0|n[f+3]<<24>>>0}e.readUInt32LE=D;function m(n,f,g){n[g+0]=f&255,f=f>>>8,n[g+1]=f&255,f=f>>>8,n[g+2]=f&255,f=f>>>8,n[g+3]=f&255}e.writeUInt32LE=m;function v(n,f){return n[f]}e.readUInt8=v;function h(n,f,g){n[g]=f}e.writeUInt8=h;function t(n){return i.consumeReadable(n,f=>C.concat(f))}e.readableToBuffer=t;function o(n){return i.toReadable(n)}e.bufferToReadable=o;function l(n){return i.consumeStream(n,f=>C.concat(f))}e.streamToBuffer=l;async function b(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await l(n.stream)])}e.bufferedStreamToBuffer=b;function E(n){return i.toStream(n,f=>C.concat(f))}e.bufferToStream=E;function p(n){return i.transform(n,{data:f=>typeof f=="string"?C.fromString(f):C.wrap(f)},f=>C.concat(f))}e.streamToBufferReadableStream=p;function w(n){return i.newWriteableStream(f=>C.concat(f),n)}e.newWriteableBufferStream=w;function s(n,f){return i.prefixedReadable(n,f,g=>C.concat(g))}e.prefixedBufferReadable=s;function r(n,f){return i.prefixedStream(n,f,g=>C.concat(g))}e.prefixedBufferStream=r;function a(n){let f=0,g=0,P=0;const M=new Uint8Array(Math.floor(n.length/4*3)),q=x=>{switch(g){case 3:M[P++]=f|x,g=0;break;case 2:M[P++]=f|x>>>2,f=x<<6,g=3;break;case 1:M[P++]=f|x>>>4,f=x<<4,g=2;break;default:f=x<<2,g=1}};for(let x=0;x<n.length;x++){const R=n.charCodeAt(x);if(R>=65&&R<=90)q(R-65);else if(R>=97&&R<=122)q(R-97+26);else if(R>=48&&R<=57)q(R-48+52);else if(R===43||R===45)q(62);else if(R===47||R===95)q(63);else{if(R===61)break;throw new SyntaxError(`Unexpected base64 character ${n[x]}`)}}const J=P;for(;g>0;)q(0);return C.wrap(M).slice(0,J)}e.decodeBase64=a;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:n},f=!0,g=!1){const P=g?c:d;let M="";const q=n.byteLength%3;let J=0;for(;J<n.byteLength-q;J+=3){const x=n[J+0],R=n[J+1],A=n[J+2];M+=P[x>>>2],M+=P[(x<<4|R>>>4)&63],M+=P[(R<<2|A>>>6)&63],M+=P[A&63]}if(q===1){const x=n[J+0];M+=P[x>>>2],M+=P[x<<4&63],f&&(M+="==")}else if(q===2){const x=n[J+0],R=n[J+1];M+=P[x>>>2],M+=P[(x<<4|R>>>4)&63],M+=P[R<<2&63],f&&(M+="=")}return M}e.encodeBase64=u}),define(Ie[34],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(y){return i.test(y)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(O){for(let S=0;S<O.length;S++)O[S]=Math.floor(Math.random()*256);return O};const L=new Uint8Array(16),C=[];for(let O=0;O<256;O++)C.push(O.toString(16).padStart(2,"0"));return function(){y(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,k="";return k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k}}()}),define(Ie[112],Ce([1,0,16,34]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function y(O){return{id:(0,T.generateUuid)(),asString:async()=>O,asFile:()=>{},value:typeof O=="string"?O:void 0}}e.createStringDataTransferItem=y;function L(O,S,k){return{id:(0,T.generateUuid)(),asString:async()=>"",asFile:()=>({name:O,uri:S,data:k}),value:void 0}}e.createFileDataTransferItem=L;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,k){const N=this.a.get(S);N?N.push(k):this.a.set(this.b(S),[k])}replace(S,k){this.a.set(this.b(S),[k])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,k]of this.a.entries())for(const N of k)yield[S,N]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[k,N]of this.entries())S(N,k)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:O=>(0,i.distinct)(O.map(S=>S.toString())).join(`\r
`),split:O=>O.split(`\r
`),parse:O=>e.UriList.split(O).filter(S=>!S.startsWith("#"))})}),define(Ie[113],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[114],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class T{constructor(O){if(this.e=null,this.f=!1,this.open=O.open,this.close=O.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(O.notIn))for(let S=0,k=O.notIn.length;S<k;S++)switch(O.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(O){switch(O){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(O,S){if(O.getTokenCount()===0)return!0;const k=O.findTokenIndexAtOffset(S-2),N=O.getStandardTokenType(k);return this.isOK(N)}g(O,S){for(let k=O;k<=S;k++){const N=String.fromCharCode(k);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=T;class y{constructor(O){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of O)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=y;function L(C,O,S){C.has(O)?C.get(O).push(S):C.set(O,[S])}}),define(Ie[115],Ce([17,18]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ie[116],Ce([1,0,115]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,y=T*60,L=y*24,C=L*7,O=L*30,S=L*365;function k(D,m,v){typeof D!="number"&&(D=D.getTime());const h=Math.round((new Date().getTime()-D)/1e3);if(h<-30)return(0,i.localize)(0,null,k(new Date().getTime()+h*1e3,!1));if(h<30)return(0,i.localize)(1,null);let t;return h<T?(t=h,m?t===1?v?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):v?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?v?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):v?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):h<y?(t=Math.floor(h/T),m?t===1?v?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):v?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?v?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):v?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):h<L?(t=Math.floor(h/y),m?t===1?v?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):v?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?v?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):v?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):h<C?(t=Math.floor(h/L),m?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):h<O?(t=Math.floor(h/C),m?t===1?v?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):v?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?v?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):v?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):h<S?(t=Math.floor(h/O),m?t===1?v?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):v?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?v?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):v?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(h/S),m?t===1?v?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):v?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?v?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):v?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=k;function N(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(Ie[117],Ce([17,18]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ie[45],Ce([1,0,16,9,117]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(D,m){return m&&(D.stack||D.stacktrace)?y.localize(0,null,O(D),C(D.stack)||C(D.stacktrace)):O(D)}function C(D){return Array.isArray(D)?D.join(`
`):D}function O(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function S(D=null,m=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const v=i.coalesce(D),h=S(v[0],m);return v.length>1?y.localize(4,null,h,v.length):h}if(T.isString(D))return D;if(D.detail){const v=D.detail;if(v.error)return L(v.error,m);if(v.exception)return L(v.exception,m)}return D.stack?L(D,m):D.message?D.message:y.localize(5,null)}e.toErrorMessage=S;function k(D){const m=D;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=k;function N(D,m){let v;return typeof D=="string"?v=new Error(D):v=D,v.actions=m,v}e.createErrorWithActions=N}),define(Ie[61],Ce([1,0,19]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(N){const D=(0,i.extname)(N),m=T[D.toLowerCase()];return m!==void 0?m:C(N)}e.getMediaOrTextMime=L;function C(N){const D=(0,i.extname)(N);return y[D.toLowerCase()]}e.getMediaMime=C;function O(N){for(const D in y)if(y[D]===N)return D}e.getExtensionForMimeType=O;const S=/^(.+)\/(.+?)(;.+)?$/;function k(N,D){const m=S.exec(N);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:D?void 0:N}e.normalizeMimeType=k}),define(Ie[39],Ce([1,0,19,21,10,9]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(c){return c===47||c===92}e.isPathSeparator=C;function O(c){return c.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=O;function S(c){return c.indexOf("/")===-1&&(c=O(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=S;function k(c,u=i.posix.sep){if(!c)return"";const n=c.length,f=c.charCodeAt(0);if(C(f)){if(C(c.charCodeAt(1))&&!C(c.charCodeAt(2))){let P=3;const M=P;for(;P<n&&!C(c.charCodeAt(P));P++);if(M!==P&&!C(c.charCodeAt(P+1))){for(P+=1;P<n;P++)if(C(c.charCodeAt(P)))return c.slice(0,P+1).replace(/[\\/]/g,u)}}return u}else if(l(f)&&c.charCodeAt(1)===58)return C(c.charCodeAt(2))?c.slice(0,2)+u:c.slice(0,2);let g=c.indexOf("://");if(g!==-1){for(g+=3;g<n;g++)if(C(c.charCodeAt(g)))return c.slice(0,g+1)}return""}e.getRoot=k;function N(c){if(!T.isWindows||!c||c.length<5)return!1;let u=c.charCodeAt(0);if(u!==92||(u=c.charCodeAt(1),u!==92))return!1;let n=2;const f=n;for(;n<c.length&&(u=c.charCodeAt(n),u!==92);n++);return!(f===n||(u=c.charCodeAt(n+1),isNaN(u)||u===92))}e.isUNC=N;const D=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(c,u=T.isWindows){const n=u?D:m;return!(!c||c.length===0||/^\s+$/.test(c)||(n.lastIndex=0,n.test(c))||u&&v.test(c)||c==="."||c===".."||u&&c[c.length-1]==="."||u&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=h;function t(c,u,n){const f=c===u;return!n||f?f:!c||!u?!1:(0,y.equalsIgnoreCase)(c,u)}e.isEqual=t;function o(c,u,n,f=i.sep){if(c===u)return!0;if(!c||!u||u.length>c.length)return!1;if(n){if(!(0,y.startsWithIgnoreCase)(c,u))return!1;if(u.length===c.length)return!0;let P=u.length;return u.charAt(u.length-1)===f&&P--,c.charAt(P)===f}return u.charAt(u.length-1)!==f&&(u+=f),c.indexOf(u)===0}e.isEqualOrParent=o;function l(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=l;function b(c,u){return T.isWindows&&c.endsWith(":")&&(c+=i.sep),(0,i.isAbsolute)(c)||(c=(0,i.join)(u,c)),c=(0,i.normalize)(c),T.isWindows?(c=(0,y.rtrim)(c,i.sep),c.endsWith(":")&&(c+=i.sep)):(c=(0,y.rtrim)(c,i.sep),c||(c=i.sep)),c}e.sanitizeFilePath=b;function E(c){const u=(0,i.normalize)(c);return T.isWindows?c.length>3?!1:p(u)&&(c.length===2||u.charCodeAt(2)===92):u===i.posix.sep}e.isRootOrDriveLetter=E;function p(c,u=T.isWindows){return u?l(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function w(c){return p(c)?c[0]:void 0}e.getDriveLetter=w;function s(c,u,n){return u.length>c.length?-1:c===u?0:(n&&(c=c.toLowerCase(),u=u.toLowerCase()),c.indexOf(u))}e.indexOfPath=s;function r(c){const u=c.split(":");let n,f,g;for(const P of u){const M=Number(P);(0,L.isNumber)(M)?f===void 0?f=M:g===void 0&&(g=M):n=n?[n,P].join(":"):P}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:f!==void 0?f:void 0,column:g!==void 0?g:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function d(c,u,n=8){let f="";for(let P=0;P<n;P++)f+=a.charAt(Math.floor(Math.random()*a.length));let g;return u?g=`${u}-${f}`:g=f,c?(0,i.join)(c,g):g}e.randomPath=d}),define(Ie[118],Ce([1,0,28,10]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Y){return function(I,U){for(let H=0,j=Y.length;H<j;H++){const Z=Y[H](I,U);if(Z)return Z}return null}}e.or=y,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(Y,I,U){if(!U||U.length<I.length)return null;let H;return Y?H=T.startsWithIgnoreCase(U,I):H=U.indexOf(I)===0,H?I.length>0?[{start:0,end:I.length}]:[]:null}function C(Y,I){const U=I.toLowerCase().indexOf(Y.toLowerCase());return U===-1?null:[{start:U,end:U+Y.length}]}e.matchesContiguousSubString=C;function O(Y,I){return S(Y.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=O;function S(Y,I,U,H){if(U===Y.length)return[];if(H===I.length)return null;if(Y[U]===I[H]){let j=null;return(j=S(Y,I,U+1,H+1))?l({start:H,end:H+1},j):null}return S(Y,I,U,H+1)}function k(Y){return 97<=Y&&Y<=122}function N(Y){return 65<=Y&&Y<=90}e.isUpper=N;function D(Y){return 48<=Y&&Y<=57}function m(Y){return Y===32||Y===9||Y===10||Y===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>v.add(Y.charCodeAt(0)));function h(Y){return m(Y)||v.has(Y)}function t(Y,I){return Y===I||h(Y)&&h(I)}function o(Y){return k(Y)||N(Y)||D(Y)}function l(Y,I){return I.length===0?I=[Y]:Y.end===I[0].start?I[0].start=Y.start:I.unshift(Y),I}function b(Y,I){for(let U=I;U<Y.length;U++){const H=Y.charCodeAt(U);if(N(H)||D(H)||U>0&&!o(Y.charCodeAt(U-1)))return U}return Y.length}function E(Y,I,U,H){if(U===Y.length)return[];if(H===I.length)return null;if(Y[U]!==I[H].toLowerCase())return null;{let j=null,Z=H+1;for(j=E(Y,I,U+1,H+1);!j&&(Z=b(I,Z))<I.length;)j=E(Y,I,U+1,Z),Z++;return j===null?null:l({start:H,end:H+1},j)}}function p(Y){let I=0,U=0,H=0,j=0,Z=0;for(let be=0;be<Y.length;be++)Z=Y.charCodeAt(be),N(Z)&&I++,k(Z)&&U++,o(Z)&&H++,D(Z)&&j++;const de=I/Y.length,Se=U/Y.length,ae=H/Y.length,ve=j/Y.length;return{upperPercent:de,lowerPercent:Se,alphaPercent:ae,numericPercent:ve}}function w(Y){const{upperPercent:I,lowerPercent:U}=Y;return U===0&&I>.6}function s(Y){const{upperPercent:I,lowerPercent:U,alphaPercent:H,numericPercent:j}=Y;return U>.2&&I<.8&&H>.6&&j<.2}function r(Y){let I=0,U=0,H=0,j=0;for(let Z=0;Z<Y.length;Z++)H=Y.charCodeAt(Z),N(H)&&I++,k(H)&&U++,m(H)&&j++;return(I===0||U===0)&&j===0?Y.length<=30:I<=5}function a(Y,I){if(!I||(I=I.trim(),I.length===0)||!r(Y)||I.length>60)return null;const U=p(I);if(!s(U)){if(!w(U))return null;I=I.toLowerCase()}let H=null,j=0;for(Y=Y.toLowerCase();j<I.length&&(H=E(Y,I,0,j))===null;)j=b(I,j+1);return H}e.matchesCamelCase=a;function d(Y,I,U=!1){if(!I||I.length===0)return null;let H=null,j=0;for(Y=Y.toLowerCase(),I=I.toLowerCase();j<I.length&&(H=c(Y,I,0,j,U))===null;)j=u(I,j+1);return H}e.matchesWords=d;function c(Y,I,U,H,j){if(U===Y.length)return[];if(H===I.length)return null;if(t(Y.charCodeAt(U),I.charCodeAt(H))){let Z=null,de=H+1;if(Z=c(Y,I,U+1,H+1,j),!j)for(;!Z&&(de=u(I,de))<I.length;)Z=c(Y,I,U+1,de,j),de++;return Z?Y.charCodeAt(U)!==I.charCodeAt(H)?Z:l({start:H,end:H+1},Z):null}else return null}function u(Y,I){for(let U=I;U<Y.length;U++)if(h(Y.charCodeAt(U))||U>0&&h(Y.charCodeAt(U-1)))return U;return Y.length}const n=y(e.matchesPrefix,a,C),f=y(e.matchesPrefix,a,O),g=new i.LRUCache(1e4);function P(Y,I,U=!1){if(typeof Y!="string"||typeof I!="string")return null;let H=g.get(Y);H||(H=new RegExp(T.convertSimple2RegExpPattern(Y),"i"),g.set(Y,H));const j=H.exec(I);return j?[{start:j.index,end:j.index+j[0].length}]:U?f(Y,I):n(Y,I)}e.matchesFuzzy=P;function M(Y,I){const U=We(Y,Y.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?J(U):null}e.matchesFuzzy2=M;function q(Y,I,U,H,j,Z){const de=Math.min(13,Y.length);for(;U<de;U++){const Se=We(Y,I,U,H,j,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Se)return Se}return[0,Z]}e.anyScore=q;function J(Y){if(typeof Y>"u")return[];const I=[],U=Y[1];for(let H=Y.length-1;H>1;H--){const j=Y[H]+U,Z=I[I.length-1];Z&&Z.end===j?Z.end=j+1:I.push({start:j,end:j+1})}return I}e.createMatches=J;const x=128;function R(){const Y=[],I=[];for(let U=0;U<=x;U++)I[U]=0;for(let U=0;U<=x;U++)Y.push(I.slice(0));return Y}function A(Y){const I=[];for(let U=0;U<=Y;U++)I[U]=0;return I}const F=A(2*x),$=A(2*x),z=R(),V=R(),K=R(),ie=!1;function ge(Y,I,U,H,j){function Z(Se,ae,ve=" "){for(;Se.length<ae;)Se=ve+Se;return Se}let de=` |   |${H.split("").map(Se=>Z(Se,3)).join("|")}
`;for(let Se=0;Se<=U;Se++)Se===0?de+=" |":de+=`${I[Se-1]}|`,de+=Y[Se].slice(0,j+1).map(ae=>Z(ae.toString(),3)).join("|")+`
`;return de}function ce(Y,I,U,H){Y=Y.substr(I),U=U.substr(H),console.log(ge(V,Y,Y.length,U,U.length)),console.log(ge(K,Y,Y.length,U,U.length)),console.log(ge(z,Y,Y.length,U,U.length))}function re(Y,I){if(I<0||I>=Y.length)return!1;const U=Y.codePointAt(I);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(U)}}function se(Y,I){if(I<0||I>=Y.length)return!1;switch(Y.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function le(Y,I,U){return I[Y]!==U[Y]}function _(Y,I,U,H,j,Z,de=!1){for(;I<U&&j<Z;)Y[I]===H[j]&&(de&&(F[I]=j),I+=1),j+=1;return I===U}e.isPatternInWord=_;var me;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(me||(me={}));var we;(function(Y){Y.Default=[-100,0];function I(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}Y.isDefault=I})(we=e.FuzzyScore||(e.FuzzyScore={}));class Ne{constructor(I,U){this.firstMatchCanBeWeak=I,this.boostFullMatch=U}}e.FuzzyScoreOptions=Ne,Ne.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function We(Y,I,U,H,j,Z,de=Ne.default){const Se=Y.length>x?x:Y.length,ae=H.length>x?x:H.length;if(U>=Se||Z>=ae||Se-U>ae-Z||!_(I,U,Se,j,Z,ae,!0))return;Qe(Se,ae,U,Z,I,j);let ve=1,be=1,$e=U,He=Z;const tt=[!1];for(ve=1,$e=U;$e<Se;ve++,$e++){const Fe=F[$e],st=$[$e],Q=$e+1<Se?$[$e+1]:ae;for(be=Fe-Z+1,He=Fe;He<Q;be++,He++){let X=Number.MIN_SAFE_INTEGER,pe=!1;He<=st&&(X=Te(Y,I,$e,U,H,j,He,ae,Z,z[ve-1][be-1]===0,tt));let Me=0;X!==Number.MAX_SAFE_INTEGER&&(pe=!0,Me=X+V[ve-1][be-1]);const Be=He>Fe,je=Be?V[ve][be-1]+(z[ve][be-1]>0?-5:0):0,Je=He>Fe+1&&z[ve][be-1]>0,nt=Je?V[ve][be-2]+(z[ve][be-2]>0?-5:0):0;if(Je&&(!Be||nt>=je)&&(!pe||nt>=Me))V[ve][be]=nt,K[ve][be]=3,z[ve][be]=0;else if(Be&&(!pe||je>=Me))V[ve][be]=je,K[ve][be]=2,z[ve][be]=0;else if(pe)V[ve][be]=Me,K[ve][be]=1,z[ve][be]=z[ve-1][be-1]+1;else throw new Error("not possible")}}if(ie&&ce(Y,U,H,Z),!tt[0]&&!de.firstMatchCanBeWeak)return;ve--,be--;const xe=[V[ve][be],Z];let et=0,it=0;for(;ve>=1;){let Fe=be;do{const st=K[ve][Fe];if(st===3)Fe=Fe-2;else if(st===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[U+ve-1]===j[Z+be-1]&&!le(Fe+Z-1,H,j)&&et+1>z[ve][Fe]&&(Fe=be),Fe===be?et++:et=1,it||(it=Fe),ve--,be=Fe-1,xe.push(be)}ae===Se&&de.boostFullMatch&&(xe[0]+=2);const dt=it-Se;return xe[0]-=dt,xe}e.fuzzyScore=We;function Qe(Y,I,U,H,j,Z){let de=Y-1,Se=I-1;for(;de>=U&&Se>=H;)j[de]===Z[Se]&&($[de]=Se,de--),Se--}function Te(Y,I,U,H,j,Z,de,Se,ae,ve,be){if(I[U]!==Z[de])return Number.MIN_SAFE_INTEGER;let $e=1,He=!1;return de===U-H?$e=Y[U]===j[de]?7:5:le(de,j,Z)&&(de===0||!le(de-1,j,Z))?($e=Y[U]===j[de]?7:5,He=!0):re(Z,de)&&(de===0||!re(Z,de-1))?$e=5:(re(Z,de-1)||se(Z,de-1))&&($e=5,He=!0),$e>1&&U===H&&(be[0]=!0),He||(He=le(de,j,Z)||re(Z,de-1)||se(Z,de-1)),U===H?de>ae&&($e-=He?3:5):ve?$e+=He?2:0:$e+=He?0:1,de+1===Se&&($e-=He?3:5),$e}function De(Y,I,U,H,j,Z,de){return oe(Y,I,U,H,j,Z,!0,de)}e.fuzzyScoreGracefulAggressive=De;function ke(Y,I,U,H,j,Z,de){return oe(Y,I,U,H,j,Z,!1,de)}e.fuzzyScoreGraceful=ke;function oe(Y,I,U,H,j,Z,de,Se){let ae=We(Y,I,U,H,j,Z,Se);if(ae&&!de)return ae;if(Y.length>=3){const ve=Math.min(7,Y.length-1);for(let be=U+1;be<ve;be++){const $e=ue(Y,be);if($e){const He=We($e,$e.toLowerCase(),U,H,j,Z,Se);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ue(Y,I){if(I+1>=Y.length)return;const U=Y[I],H=Y[I+1];if(U!==H)return Y.slice(0,I)+H+U+Y.slice(I+2)}}),define(Ie[119],Ce([1,0,120,118,10]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",C=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(i.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${C.source}`,"g");function k(l){return l.replace(S,(b,E)=>E?b:`\\${b}`)}e.escapeIcons=k;const N=new RegExp(`\\\\${C.source}`,"g");function D(l){return l.replace(N,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=D;const m=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function v(l){return l.indexOf(L)===-1?l:l.replace(m,(b,E,p,w)=>p?b:E||w||"")}e.stripIcons=v;function h(l){const b=l.indexOf(L);return b===-1?{text:l}:t(l,b)}e.parseLabelWithIcons=h;function t(l,b){const E=[];let p="";function w(f){if(f){p+=f;for(const g of f)E.push(a)}}let s=-1,r="",a=0,d,c,u=b;const n=l.length;for(w(l.substr(0,b));u<n;)d=l[u],c=l[u+1],d===L[0]&&c===L[1]?(s=u,w(r),r=L,u++):d===")"&&s!==-1?(a+=u-s+1,s=-1,r=""):s!==-1?O.test(d)?r+=d:(w(r),s=-1,r=""):w(d),u++;return w(r),{text:p,iconOffsets:E}}function o(l,b,E=!1){const{text:p,iconOffsets:w}=b;if(!w||w.length===0)return(0,T.matchesFuzzy)(l,p,E);const s=(0,y.ltrim)(p," "),r=p.length-s.length,a=(0,T.matchesFuzzy)(l,s,E);if(a)for(const d of a){const c=w[d.start+r]+r;d.start+=c,d.end+=c}return a}e.matchesFuzzyIconAware=o}),define(Ie[29],Ce([1,0,10]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(T||(T={})),function(y){const L="error",C="warning",O="warn",S="info",k="ignore";function N(m){return m?i.equalsIgnoreCase(L,m)?y.Error:i.equalsIgnoreCase(C,m)||i.equalsIgnoreCase(O,m)?y.Warning:i.equalsIgnoreCase(S,m)?y.Info:y.Ignore:y.Ignore}y.fromValue=N;function D(m){switch(m){case y.Error:return L;case y.Warning:return C;case y.Info:return S;default:return k}}y.toString=D}(T||(T={})),e.default=T}),define(Ie[46],Ce([1,0,16,10]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const h=v.charCodeAt(0),t=this.b.charCodeAt(this.c);return h-t}value(){return this.b[this.c]}}e.StringIterator=y;class L{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,T.compareSubstring)(v,this.b,0,v.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class C{constructor(v=!0,h=!0){this.f=v,this.g=h}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let h=v.length-1;h>=0;h--,this.c--){const t=this.b.charCodeAt(h);if(!(t===47||this.f&&t===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,T.compareSubstring)(v,this.b,0,v.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var O;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(O||(O={}));class S{constructor(v,h){this.f=v,this.g=h,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(v,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,T.compare)(v,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(N||(N={}));class D{static forUris(v=()=>!1,h=()=>!1){return new D(new S(v,h))}static forPaths(v=!1){return new D(new C(void 0,!v))}static forStrings(){return new D(new y)}static forConfigKeys(){return new D(new L)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,h){if(h){const t=h.slice(0);(0,i.shuffle)(t);for(const o of t)this.set(o,v)}else{const t=v.slice(0);(0,i.shuffle)(t);for(const o of t)this.set(o[0],o[1])}}set(v,h){const t=this.b.reset(v);let o;this.c||(this.c=new k,this.c.segment=t.value());const l=[];for(o=this.c;;){const E=t.cmp(o.segment);if(E>0)o.left||(o.left=new k,o.left.segment=t.value()),l.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new k,o.right.segment=t.value()),l.push([1,o]),o=o.right;else if(t.hasNext())t.next(),o.mid||(o.mid=new k,o.mid.segment=t.value()),l.push([0,o]),o=o.mid;else break}const b=o.value;o.value=h,o.key=v;for(let E=l.length-1;E>=0;E--){const p=l[E][1];p.updateHeight();const w=p.balanceFactor();if(w<-1||w>1){const s=l[E][0],r=l[E+1][0];if(s===1&&r===1)l[E][1]=p.rotateLeft();else if(s===-1&&r===-1)l[E][1]=p.rotateRight();else if(s===1&&r===-1)p.right=l[E+1][1]=l[E+1][1].rotateRight(),l[E][1]=p.rotateLeft();else if(s===-1&&r===1)p.left=l[E+1][1]=l[E+1][1].rotateLeft(),l[E][1]=p.rotateRight();else throw new Error;if(E>0)switch(l[E-1][0]){case-1:l[E-1][1].left=l[E][1];break;case 1:l[E-1][1].right=l[E][1];break;case 0:l[E-1][1].mid=l[E][1];break}else this.c=l[0][1]}}return b}get(v){return this.d(v)?.value}d(v){const h=this.b.reset(v);let t=this.c;for(;t;){const o=h.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(h.hasNext())h.next(),t=t.mid;else break}return t}has(v){const h=this.d(v);return!(h?.value===void 0&&h?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,h){const t=this.b.reset(v),o=[];let l=this.c;for(;l;){const b=t.cmp(l.segment);if(b>0)o.push([-1,l]),l=l.left;else if(b<0)o.push([1,l]),l=l.right;else if(t.hasNext())t.next(),o.push([0,l]),l=l.mid;else break}if(!!l){if(h?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const b=this.f(l.right);if(b.key){const{key:E,value:p,segment:w}=b;this.e(b.key,!1),l.key=E,l.value=p,l.segment=w}}else{const b=l.left??l.right;if(o.length>0){const[E,p]=o[o.length-1];switch(E){case-1:p.left=b;break;case 0:p.mid=b;break;case 1:p.right=b;break}}else this.c=b}for(let b=o.length-1;b>=0;b--){const E=o[b][1];E.updateHeight();const p=E.balanceFactor();if(p>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),o[b][1]=E.rotateLeft()):p<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),o[b][1]=E.rotateRight()),b>0)switch(o[b-1][0]){case-1:o[b-1][1].left=o[b][1];break;case 1:o[b-1][1].right=o[b][1];break;case 0:o[b-1][1].mid=o[b][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const h=this.b.reset(v);let t=this.c,o;for(;t;){const l=h.cmp(t.segment);if(l>0)t=t.left;else if(l<0)t=t.right;else if(h.hasNext())h.next(),o=t.value||o,t=t.mid;else break}return t&&t.value||o}findSuperstr(v){const h=this.b.reset(v);let t=this.c;for(;t;){const o=h.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(h.hasNext())h.next(),t=t.mid;else return t.mid?this.g(t.mid):void 0}}forEach(v){for(const[h,t]of this)v(t,h)}*[Symbol.iterator](){yield*this.g(this.c)}g(v){const h=[];return this.h(v,h),h[Symbol.iterator]()}h(v,h){!v||(v.left&&this.h(v.left,h),v.value&&h.push([v.key,v.value]),v.mid&&this.h(v.mid,h),v.right&&this.h(v.right,h))}_isBalanced(){const v=h=>{if(!h)return!0;const t=h.balanceFactor();return t<-1||t>1?!1:v(h.left)&&v(h.right)};return v(this.c)}}e.TernarySearchTree=D}),define(Ie[80],Ce([1,0,24,10,2]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(k){return JSON.stringify(k,O)}e.stringify=L;function C(k){let N=JSON.parse(k);return N=S(N),N}e.parse=C;function O(k,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,T.regExpFlags)(N)}:N}function S(k,N=0){if(!k||N>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return y.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let D=0;D<k.length;++D)k[D]=S(k[D],N+1);else for(const D in k)Object.hasOwnProperty.call(k,D)&&(k[D]=S(k[D],N+1))}return k}e.revive=S}),define(Ie[13],Ce([1,0,21,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(k){this.d=k}setDelegate(k){this.e=k}setServerRootPath(k){this.f=`${k}/${y.vscodeRemoteResource}`}set(k,N,D){this.a[k]=N,this.b[k]=D}setConnectionToken(k,N){this.c[k]=N}getPreferredWebSchema(){return this.d}rewrite(k){if(this.e)return this.e(k);const N=k.authority;let D=this.a[N];D&&D.indexOf(":")!==-1&&D.indexOf("[")===-1&&(D=`[${D}]`);const m=this.b[N],v=this.c[N];let h=`path=${encodeURIComponent(k.path)}`;return typeof v=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),T.URI.from({scheme:i.isWeb?this.d:y.vscodeRemoteResource,authority:`${D}:${m}`,path:this.f,query:h})}}e.RemoteAuthorities=new L,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(k){const N=this.b(k,ee);return this.uriToBrowserUri(N)}uriToBrowserUri(k){return k.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===y.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${y.vscodeFileResource}://${C.a}`)?k.with({scheme:y.vscodeFileResource,authority:k.authority||C.a,query:null,fragment:null}):k}asFileUri(k){const N=this.b(k,ee);return this.uriToFileUri(N)}uriToFileUri(k){return k.scheme===y.vscodeFileResource?k.with({scheme:y.file,authority:k.authority!==C.a?k.authority:null,query:null,fragment:null}):k}b(k,N){return T.URI.isUri(k)?k:T.URI.parse(N.toUrl(k))}}C.a="vscode-app",e.FileAccess=new C;var O;(function(S){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(k.get("3"));const N="vscode-coi";function D(v){let h;typeof v=="string"?h=new URL(v).searchParams:v instanceof URL?h=v.searchParams:T.URI.isUri(v)&&(h=new URL(v.toString(!0)).searchParams);const t=h?.get(N);if(!!t)return k.get(t)}S.getHeadersFromQuery=D;function m(v,h,t){if(!globalThis.crossOriginIsolated)return;const o=h&&t?"3":t?"2":"1";v instanceof URLSearchParams?v.set(N,o):v[N]=o}S.addSearchParam=m})(O=e.COI||(e.COI={}))}),define(Ie[22],Ce([1,0,39,13,19,21,10,2]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(v){return(0,O.uriToFsPath)(v,!0)}e.originalFSPath=S;class k{constructor(h){this.a=h}compare(h,t,o=!1){return h===t?0:(0,C.compare)(this.getComparisonKey(h,o),this.getComparisonKey(t,o))}isEqual(h,t,o=!1){return h===t?!0:!h||!t?!1:this.getComparisonKey(h,o)===this.getComparisonKey(t,o)}getComparisonKey(h,t=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,t,o=!1){if(h.scheme===t.scheme){if(h.scheme===T.Schemas.file)return i.isEqualOrParent(S(h),S(t),this.a(h))&&h.query===t.query&&(o||h.fragment===t.fragment);if((0,e.isEqualAuthority)(h.authority,t.authority))return i.isEqualOrParent(h.path,t.path,this.a(h),"/")&&h.query===t.query&&(o||h.fragment===t.fragment)}return!1}joinPath(h,...t){return O.URI.joinPath(h,...t)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let t;return h.scheme===T.Schemas.file?t=O.URI.file(y.dirname(S(h))).path:(t=y.posix.dirname(h.path),h.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),t="/")),h.with({path:t})}normalizePath(h){if(!h.path.length)return h;let t;return h.scheme===T.Schemas.file?t=O.URI.file(y.normalize(S(h))).path:t=y.posix.normalize(h.path),h.with({path:t})}relativePath(h,t){if(h.scheme!==t.scheme||!(0,e.isEqualAuthority)(h.authority,t.authority))return;if(h.scheme===T.Schemas.file){const b=y.relative(S(h),S(t));return L.isWindows?i.toSlashes(b):b}let o=h.path||"/";const l=t.path||"/";if(this.a(h)){let b=0;for(const E=Math.min(o.length,l.length);b<E&&!(o.charCodeAt(b)!==l.charCodeAt(b)&&o.charAt(b).toLowerCase()!==l.charAt(b).toLowerCase());b++);o=l.substr(0,b)+o.substr(b)}return y.posix.relative(o,l)}resolvePath(h,t){if(h.scheme===T.Schemas.file){const o=O.URI.file(y.resolve(S(h),t));return h.with({authority:o.authority,path:o.path})}return t=i.toPosixPath(t),h.with({path:y.posix.resolve(h.path,t)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,t){return h===t||h!==void 0&&t!==void 0&&(0,C.equalsIgnoreCase)(h,t)}hasTrailingPathSeparator(h,t=y.sep){if(h.scheme===T.Schemas.file){const o=S(h);return o.length>i.getRoot(o).length&&o[o.length-1]===t}else{const o=h.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,t=y.sep){return(0,e.hasTrailingPathSeparator)(h,t)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,t=y.sep){let o=!1;if(h.scheme===T.Schemas.file){const l=S(h);o=l!==void 0&&l.length===i.getRoot(l).length&&l[l.length-1]===t}else{t="/";const l=h.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(h,t)?h.with({path:h.path+"/"}):h}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(v=>v.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new k(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(v,h){const t=[];for(let o=0;o<v.length;o++){const l=h(v[o]);v.some((b,E)=>E===o?!1:(0,e.isEqualOrParent)(l,h(b)))||t.push(v[o])}return t}e.distinctParents=N;var D;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(t){const o=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(E=>{const[p,w]=E.split(":");p&&w&&o.set(p,w)});const b=t.path.substring(0,t.path.indexOf(";"));return b&&o.set(v.META_DATA_MIME,b),o}v.parseMetaData=h})(D=e.DataUri||(e.DataUri={}));function m(v,h,t){if(h){let o=v.path;return o&&o[0]!==y.posix.sep&&(o=y.posix.sep+o),v.with({scheme:t,authority:h,path:o})}return v.with({scheme:t})}e.toLocalResource=m}),define(Ie[14],Ce([1,0,20,11,5,7,22,21]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(le){return!!le&&typeof le.then=="function"}e.isThenable=S;function k(le){const _=new i.CancellationTokenSource,me=le(_.token),we=new Promise((Ne,We)=>{const Qe=_.token.onCancellationRequested(()=>{Qe.dispose(),_.dispose(),We(new T.CancellationError)});Promise.resolve(me).then(Te=>{Qe.dispose(),_.dispose(),Ne(Te)},Te=>{Qe.dispose(),_.dispose(),We(Te)})});return new class{cancel(){_.cancel()}then(Ne,We){return we.then(Ne,We)}catch(Ne){return this.then(void 0,Ne)}finally(Ne){return we.finally(Ne)}}}e.createCancelablePromise=k;function N(le,_,me){return new Promise((we,Ne)=>{const We=_.onCancellationRequested(()=>{We.dispose(),we(me)});le.then(we,Ne).finally(()=>We.dispose())})}e.raceCancellation=N;function D(le,_){return new Promise((me,we)=>{const Ne=_.onCancellationRequested(()=>{Ne.dispose(),we(new T.CancellationError)});le.then(me,we).finally(()=>Ne.dispose())})}e.raceCancellationError=D;async function m(le){let _=-1;const me=le.map((Ne,We)=>Ne.then(Qe=>(_=We,Qe))),we=await Promise.race(me);return le.forEach((Ne,We)=>{We!==_&&Ne.cancel()}),we}e.raceCancellablePromises=m;function v(le,_,me){let we;const Ne=setTimeout(()=>{we?.(void 0),me?.()},_);return Promise.race([le.finally(()=>clearTimeout(Ne)),new Promise(We=>we=We)])}e.raceTimeout=v;function h(le){return new Promise((_,me)=>{const we=le();S(we)?we.then(_,me):_(we)})}e.asPromise=h;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(_){if(this.a){if(this.d=_,!this.b){const me=()=>{this.b=null;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(me,me).then(we)})}return new Promise((me,we)=>{this.b.then(me,we)})}return this.a=_(),new Promise((me,we)=>{this.a.then(Ne=>{this.a=null,me(Ne)},Ne=>{this.a=null,we(Ne)})})}}e.Throttler=t;class o{constructor(){this.a=Promise.resolve(null)}queue(_){return this.a=this.a.then(()=>_(),()=>_())}}e.Sequencer=o;class l{constructor(){this.a=new Map}queue(_,me){const Ne=(this.a.get(_)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.a.get(_)===Ne&&this.a.delete(_)});return this.a.set(_,Ne),Ne}}e.SequencerByKey=l;const b=(le,_)=>{let me=!0;const we=setTimeout(()=>{me=!1,_()},le);return{isTriggered:()=>me,dispose:()=>{clearTimeout(we),me=!1}}},E=le=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,le())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(_){this.defaultDelay=_,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(_,me=this.defaultDelay){this.g=_,this.h(),this.b||(this.b=new Promise((Ne,We)=>{this.d=Ne,this.f=We}).then(()=>{if(this.b=null,this.d=null,this.g){const Ne=this.g;return this.g=null,Ne()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=me===e.MicrotaskDelay?E(we):b(me,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class w{constructor(_){this.a=new p(_),this.b=new t}trigger(_,me){return this.a.trigger(()=>this.b.queue(_),me)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class s{constructor(){this.a=!1,this.b=new Promise((_,me)=>{this.d=_})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(_){super(),this.f=setTimeout(()=>this.open(),_)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function a(le,_){return _?new Promise((me,we)=>{const Ne=setTimeout(()=>{We.dispose(),me()},le),We=_.onCancellationRequested(()=>{clearTimeout(Ne),We.dispose(),we(new T.CancellationError)})}):k(me=>a(le,me))}e.timeout=a;function d(le,_=0){const me=setTimeout(le,_);return(0,L.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=d;function c(le){const _=[];let me=0;const we=le.length;function Ne(){return me<we?le[me++]():null}function We(Qe){Qe!=null&&_.push(Qe);const Te=Ne();return Te?Te.then(We):Promise.resolve(_)}return Promise.resolve(null).then(We)}e.sequence=c;function u(le,_=we=>!!we,me=null){let we=0;const Ne=le.length,We=()=>{if(we>=Ne)return Promise.resolve(me);const Qe=le[we++];return Promise.resolve(Qe()).then(De=>_(De)?Promise.resolve(De):We())};return We()}e.first=u;function n(le,_=we=>!!we,me=null){if(le.length===0)return Promise.resolve(me);let we=le.length;const Ne=()=>{we=-1;for(const We of le)We.cancel?.()};return new Promise((We,Qe)=>{for(const Te of le)Te.then(De=>{--we>=0&&_(De)?(Ne(),We(De)):we===0&&We(me)}).catch(De=>{--we>=0&&(Ne(),Qe(De))})})}e.firstParallel=n;class f{constructor(_){this.a=0,this.d=_,this.f=[],this.b=0,this.g=new y.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(_){return this.a++,new Promise((me,we)=>{this.f.push({factory:_,c:me,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const _=this.f.shift();this.b++;const me=_.factory();me.then(_.c,_.e),me.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=f;class g extends f{constructor(){super(1)}}e.Queue=g;class P{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const _=new K;return this.b.add(_),_.p}d(){for(const[,_]of this.a)if(_.size>0)return!1;return!0}queueFor(_,me=C.extUri){const we=me.getComparisonKey(_);let Ne=this.a.get(we);return Ne||(Ne=new g,y.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(we),this.f()}),this.a.set(we,Ne)),Ne}f(){!this.d()||this.g()}g(){for(const _ of this.b)_.complete();this.b.clear()}dispose(){for(const[,_]of this.a)_.dispose();this.a.clear(),this.g()}}e.ResourceQueue=P;class M{constructor(_,me){this.a=-1,typeof _=="function"&&typeof me=="number"&&this.setIfNotSet(_,me)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(_,me){this.cancel(),this.a=setTimeout(()=>{this.a=-1,_()},me)}setIfNotSet(_,me){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,_()},me))}}e.TimeoutTimer=M;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(_,me){this.cancel(),this.a=setInterval(()=>{_()},me)}}e.IntervalTimer=q;class J{constructor(_,me){this.b=-1,this.a=_,this.d=me,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(_=this.d){this.cancel(),this.b=setTimeout(this.f,_)}get delay(){return this.d}set delay(_){this.d=_}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=J;class x{constructor(_,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.a=_,this.b=me,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(_=this.b){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(_/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class R extends J{constructor(_,me){super(_,me),this.j=[]}work(_){this.j.push(_),this.isScheduled()||this.schedule()}h(){const _=this.j;this.j=[],this.a?.(_)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=R;class A extends L.Disposable{constructor(_,me){super(),this.g=_,this.h=me,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(_){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+_.length>this.g.maxBufferedWork)return!1}else if(this.pending+_.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(..._),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=A,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,O.setTimeout0)(()=>{if(_)return;const me=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(le,_)=>{const me=requestIdleCallback(le,typeof _=="number"?{timeout:_}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(me))}}}}();class F{constructor(_){this.d=!1,this.a=()=>{try{this.f=_()}catch(me){this.g=me}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function $(le,_,me){let we;for(let Ne=0;Ne<me;Ne++)try{return await le()}catch(We){we=We,await a(_)}throw we}e.retry=$;class z{hasPending(_){return this.a?typeof _=="number"?this.a.taskId===_:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(_,me,we){return this.a={taskId:_,cancel:()=>we?.(),promise:me},me.then(()=>this.d(_),()=>this.d(_)),me}d(_){this.a&&_===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const _=this.b;this.b=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this.b)this.b.run=_;else{let me,we;const Ne=new Promise((We,Qe)=>{me=We,we=Qe});this.b={run:_,promise:Ne,promiseResolve:me,promiseReject:we}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class V{constructor(_,me=()=>Date.now()){this.d=_,this.f=me,this.a=0,this.b=0}increment(){const _=this.f();return _-this.a>this.d&&(this.a=_,this.b=0),this.b++,this.b}}e.IntervalCounter=V;class K{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((_,me)=>{this.a=_,this.b=me})}complete(_){return new Promise(me=>{this.a(_),this.f=!0,me()})}error(_){return new Promise(me=>{this.b(_),this.d=!0,me()})}cancel(){new Promise(_=>{this.b(new T.CancellationError),this.d=!0,_()})}}e.DeferredPromise=K;var ie;(function(le){async function _(we){let Ne;const We=await Promise.all(we.map(Qe=>Qe.then(Te=>Te,Te=>{Ne||(Ne=Te)})));if(typeof Ne<"u")throw Ne;return We}le.settled=_;function me(we){return new Promise(async(Ne,We)=>{try{await we(Ne,We)}catch(Qe){We(Qe)}})}le.withAsyncBody=me})(ie=e.Promises||(e.Promises={}));var ge;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(ge||(ge={}));class ce{static fromArray(_){return new ce(me=>{me.emitMany(_)})}static fromPromise(_){return new ce(async me=>{me.emitMany(await _)})}static fromPromises(_){return new ce(async me=>{await Promise.all(_.map(async we=>me.emitOne(await we)))})}static merge(_){return new ce(async me=>{await Promise.all(_.map(async we=>{for await(const Ne of we)me.emitOne(Ne)}))})}constructor(_){this.a=0,this.b=[],this.d=null,this.f=new y.Emitter,queueMicrotask(async()=>{const me={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(_(me)),this.j()}catch(we){this.k(we)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(_<this.b.length)return{done:!1,value:this.b[_++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(_,me){return new ce(async we=>{for await(const Ne of _)we.emitOne(me(Ne))})}map(_){return ce.map(this,_)}static filter(_,me){return new ce(async we=>{for await(const Ne of _)me(Ne)&&we.emitOne(Ne)})}filter(_){return ce.filter(this,_)}static coalesce(_){return ce.filter(_,me=>!!me)}coalesce(){return ce.coalesce(this)}static async toPromise(_){const me=[];for await(const we of _)me.push(we);return me}toPromise(){return ce.toPromise(this)}g(_){this.a===0&&(this.b.push(_),this.f.fire())}h(_){this.a===0&&(this.b=this.b.concat(_),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(_){this.a===0&&(this.a=2,this.d=_,this.f.fire())}}e.AsyncIterableObject=ce,ce.EMPTY=ce.fromArray([]);class re extends ce{constructor(_,me){super(me),this.l=_}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=re;function se(le){const _=new i.CancellationTokenSource,me=le(_.token);return new re(_,async we=>{const Ne=_.token.onCancellationRequested(()=>{Ne.dispose(),_.dispose(),we.reject(new T.CancellationError)});try{for await(const We of me){if(_.token.isCancellationRequested)return;we.emitOne(We)}Ne.dispose(),_.dispose()}catch(We){Ne.dispose(),_.dispose(),we.reject(We)}})}e.createCancelableAsyncIterable=se}),define(Ie[121],Ce([1,0,14,19]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new i.IdleValue(()=>{const g=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:g,collatorIsNumeric:g.resolvedOptions().numeric}}),L=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(g,P,M=!1){const q=g||"",J=P||"",x=y.value.collator.compare(q,J);return y.value.collatorIsNumeric&&x===0&&q!==J?q<J?-1:1:x}e.compareFileNames=O;function S(g,P){const M=L.value.collator;return g=g||"",P=P||"",w(M,g,P)}e.compareFileNamesDefault=S;function k(g,P){const M=L.value.collator;return g=g||"",P=P||"",d(g,P)||w(M,g,P)}e.compareFileNamesUpper=k;function N(g,P){const M=L.value.collator;return g=g||"",P=P||"",a(g,P)||w(M,g,P)}e.compareFileNamesLower=N;function D(g,P){return g=g||"",P=P||"",g===P?0:g<P?-1:1}e.compareFileNamesUnicode=D;function m(g,P,M=!1){M||(g=g&&g.toLowerCase(),P=P&&P.toLowerCase());const[q,J]=E(g),[x,R]=E(P);return q!==x?q<x?-1:1:J===R?0:J<R?-1:1}e.noIntlCompareFileNames=m;function v(g,P){const[M,q]=E(g),[J,x]=E(P);let R=y.value.collator.compare(q,x);if(R===0){if(y.value.collatorIsNumeric&&q!==x)return q<x?-1:1;if(R=y.value.collator.compare(M,J),y.value.collatorIsNumeric&&R===0&&M!==J)return M<J?-1:1}return R}e.compareFileExtensions=v;function h(g,P){g=g||"",P=P||"";const M=p(g),q=p(P),J=L.value.collator,x=C.value.collator;return w(x,M,q)||w(J,g,P)}e.compareFileExtensionsDefault=h;function t(g,P){g=g||"",P=P||"";const M=p(g),q=p(P),J=L.value.collator,x=C.value.collator;return w(x,M,q)||d(g,P)||w(J,g,P)}e.compareFileExtensionsUpper=t;function o(g,P){g=g||"",P=P||"";const M=p(g),q=p(P),J=L.value.collator,x=C.value.collator;return w(x,M,q)||a(g,P)||w(J,g,P)}e.compareFileExtensionsLower=o;function l(g,P){g=g||"",P=P||"";const M=p(g).toLowerCase(),q=p(P).toLowerCase();return M!==q?M<q?-1:1:g!==P?g<P?-1:1:0}e.compareFileExtensionsUnicode=l;const b=/^(.*?)(\.([^.]*))?$/;function E(g,P=!1){const M=g?b.exec(g):[];let q=[M&&M[1]||"",M&&M[3]||""];return P&&(!q[0]&&q[1]||q[0]&&q[0].charAt(0)===".")&&(q=[q[0]+"."+q[1],""]),q}function p(g){const P=g?b.exec(g):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function w(g,P,M){const q=g.compare(P,M);return q!==0?q:P.length!==M.length?P.length<M.length?-1:1:0}function s(g){const P=g.charAt(0);return P.toLocaleUpperCase()!==P}function r(g){const P=g.charAt(0);return P.toLocaleLowerCase()!==P}function a(g,P){return s(g)&&r(P)?-1:r(g)&&s(P)?1:0}function d(g,P){return r(g)&&s(P)?-1:s(g)&&r(P)?1:0}function c(g,P,M=!1){return M||(g=g&&g.toLowerCase(),P=P&&P.toLowerCase()),g===P?0:g<P?-1:1}function u(g,P,M=!1){const q=g.split(T.sep),J=P.split(T.sep),x=q.length-1,R=J.length-1;let A,F;for(let $=0;;$++){if(A=x===$,F=R===$,A&&F)return O(q[$],J[$],M);if(A)return-1;if(F)return 1;const z=c(q[$],J[$],M);if(z!==0)return z}}e.comparePaths=u;function n(g,P,M){const q=g.toLowerCase(),J=P.toLowerCase(),x=f(g,P,M);if(x)return x;const R=q.endsWith(M),A=J.endsWith(M);if(R!==A)return R?-1:1;const F=O(q,J);return F!==0?F:q.localeCompare(J)}e.compareAnything=n;function f(g,P,M){const q=g.toLowerCase(),J=P.toLowerCase(),x=q.startsWith(M),R=J.startsWith(M);if(x!==R)return x?-1:1;if(x&&R){if(q.length<J.length)return-1;if(q.length>J.length)return 1}return 0}e.compareByPrefix=f}),define(Ie[35],Ce([1,0,16,14,39,28,19,21,10]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",D="[^/\\\\]",m=/\//g;function v(K,ie){switch(K){case 0:return"";case 1:return`${D}*?`;default:return`(?:${N}|${D}+${N}${ie?`|${N}${D}+`:""})*?`}}function h(K,ie){if(!K)return[];const ge=[];let ce=!1,re=!1,se="";for(const le of K){switch(le){case ie:if(!ce&&!re){ge.push(se),se="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":re=!0;break;case"]":re=!1;break}se+=le}return se&&ge.push(se),ge}e.splitGlobAware=h;function t(K){if(!K)return"";let ie="";const ge=h(K,e.GLOB_SPLIT);if(ge.every(ce=>ce===e.GLOBSTAR))ie=".*";else{let ce=!1;ge.forEach((re,se)=>{if(re===e.GLOBSTAR){if(ce)return;ie+=v(2,se===ge.length-1)}else{let le=!1,_="",me=!1,we="";for(const Ne of re){if(Ne!=="}"&&le){_+=Ne;continue}if(me&&(Ne!=="]"||!we)){let We;Ne==="-"?We=Ne:(Ne==="^"||Ne==="!")&&!we?We="^":Ne===e.GLOB_SPLIT?We="":We=(0,S.escapeRegExpCharacters)(Ne),we+=We;continue}switch(Ne){case"{":le=!0;continue;case"[":me=!0;continue;case"}":{ie+=`(?:${h(_,",").map(Te=>t(Te)).join("|")})`,le=!1,_="";break}case"]":{ie+="["+we+"]",me=!1,we="";break}case"?":ie+=D;continue;case"*":ie+=v(1);continue;default:ie+=(0,S.escapeRegExpCharacters)(Ne)}}se<ge.length-1&&(ge[se+1]!==e.GLOBSTAR||se+2<ge.length)&&(ie+=N)}ce=re===e.GLOBSTAR})}return ie}const o=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new L.LRUCache(1e4),r=function(){return!1},a=function(){return null};function d(K,ie){if(!K)return a;let ge;typeof K!="string"?ge=K.pattern:ge=K,ge=ge.trim();const ce=`${ge}_${!!ie.trimForExclusions}`;let re=s.get(ce);if(re)return c(re,K);let se;return o.test(ge)?re=n(ge.substr(4),ge):(se=l.exec(u(ge,ie)))?re=f(se[1],ge):(ie.trimForExclusions?E:b).test(ge)?re=g(ge,ie):(se=p.exec(u(ge,ie)))?re=P(se[1].substr(1),ge,!0):(se=w.exec(u(ge,ie)))?re=P(se[1],ge,!1):re=M(ge),s.set(ce,re),c(re,K)}function c(K,ie){if(typeof ie=="string")return K;const ge=function(ce,re){return(0,y.isEqualOrParent)(ce,ie.base,!O.isLinux)?K((0,S.ltrim)(ce.substr(ie.base.length),C.sep),re):null};return ge.allBasenames=K.allBasenames,ge.allPaths=K.allPaths,ge.basenames=K.basenames,ge.patterns=K.patterns,ge}function u(K,ie){return ie.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function n(K,ie){return function(ge,ce){return typeof ge=="string"&&ge.endsWith(K)?ie:null}}function f(K,ie){const ge=`/${K}`,ce=`\\${K}`,re=function(le,_){return typeof le!="string"?null:_?_===K?ie:null:le===K||le.endsWith(ge)||le.endsWith(ce)?ie:null},se=[K];return re.basenames=se,re.patterns=[ie],re.allBasenames=se,re}function g(K,ie){const ge=z(K.slice(1,-1).split(",").map(_=>d(_,ie)).filter(_=>_!==a),K),ce=ge.length;if(!ce)return a;if(ce===1)return ge[0];const re=function(_,me){for(let we=0,Ne=ge.length;we<Ne;we++)if(ge[we](_,me))return K;return null},se=ge.find(_=>!!_.allBasenames);se&&(re.allBasenames=se.allBasenames);const le=ge.reduce((_,me)=>me.allPaths?_.concat(me.allPaths):_,[]);return le.length&&(re.allPaths=le),re}function P(K,ie,ge){const ce=C.sep===C.posix.sep,re=ce?K:K.replace(m,C.sep),se=C.sep+re,le=C.posix.sep+K;let _;return ge?_=function(me,we){return typeof me=="string"&&(me===re||me.endsWith(se)||!ce&&(me===K||me.endsWith(le)))?ie:null}:_=function(me,we){return typeof me=="string"&&(me===re||!ce&&me===K)?ie:null},_.allPaths=[(ge?"*/":"./")+K],_}function M(K){try{const ie=new RegExp(`^${t(K)}$`);return function(ge){return ie.lastIndex=0,typeof ge=="string"&&ie.test(ge)?K:null}}catch{return a}}function q(K,ie,ge){return!K||typeof ie!="string"?!1:J(K)(ie,void 0,ge)}e.match=q;function J(K,ie={}){if(!K)return r;if(typeof K=="string"||x(K)){const ge=d(K,ie);if(ge===a)return r;const ce=function(re,se){return!!ge(re,se)};return ge.allBasenames&&(ce.allBasenames=ge.allBasenames),ge.allPaths&&(ce.allPaths=ge.allPaths),ce}return F(K,ie)}e.parse=J;function x(K){const ie=K;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=x;function R(K){return K.allBasenames||[]}e.getBasenameTerms=R;function A(K){return K.allPaths||[]}e.getPathTerms=A;function F(K,ie){const ge=z(Object.getOwnPropertyNames(K).map(_=>$(_,K[_],ie)).filter(_=>_!==a)),ce=ge.length;if(!ce)return a;if(!ge.some(_=>!!_.requiresSiblings)){if(ce===1)return ge[0];const _=function(Ne,We){let Qe;for(let Te=0,De=ge.length;Te<De;Te++){const ke=ge[Te](Ne,We);if(typeof ke=="string")return ke;(0,T.isThenable)(ke)&&(Qe||(Qe=[]),Qe.push(ke))}return Qe?(async()=>{for(const Te of Qe){const De=await Te;if(typeof De=="string")return De}return null})():null},me=ge.find(Ne=>!!Ne.allBasenames);me&&(_.allBasenames=me.allBasenames);const we=ge.reduce((Ne,We)=>We.allPaths?Ne.concat(We.allPaths):Ne,[]);return we.length&&(_.allPaths=we),_}const re=function(_,me,we){let Ne,We;for(let Qe=0,Te=ge.length;Qe<Te;Qe++){const De=ge[Qe];De.requiresSiblings&&we&&(me||(me=(0,C.basename)(_)),Ne||(Ne=me.substr(0,me.length-(0,C.extname)(_).length)));const ke=De(_,me,Ne,we);if(typeof ke=="string")return ke;(0,T.isThenable)(ke)&&(We||(We=[]),We.push(ke))}return We?(async()=>{for(const Qe of We){const Te=await Qe;if(typeof Te=="string")return Te}return null})():null},se=ge.find(_=>!!_.allBasenames);se&&(re.allBasenames=se.allBasenames);const le=ge.reduce((_,me)=>me.allPaths?_.concat(me.allPaths):_,[]);return le.length&&(re.allPaths=le),re}function $(K,ie,ge){if(ie===!1)return a;const ce=d(K,ge);if(ce===a)return a;if(typeof ie=="boolean")return ce;if(ie){const re=ie.when;if(typeof re=="string"){const se=(le,_,me,we)=>{if(!we||!ce(le,_))return null;const Ne=re.replace("$(basename)",me),We=we(Ne);return(0,T.isThenable)(We)?We.then(Qe=>Qe?K:null):We?K:null};return se.requiresSiblings=!0,se}}return ce}function z(K,ie){const ge=K.filter(_=>!!_.basenames);if(ge.length<2)return K;const ce=ge.reduce((_,me)=>{const we=me.basenames;return we?_.concat(we):_},[]);let re;if(ie){re=[];for(let _=0,me=ce.length;_<me;_++)re.push(ie)}else re=ge.reduce((_,me)=>{const we=me.patterns;return we?_.concat(we):_},[]);const se=function(_,me){if(typeof _!="string")return null;if(!me){let Ne;for(Ne=_.length;Ne>0;Ne--){const We=_.charCodeAt(Ne-1);if(We===47||We===92)break}me=_.substr(Ne)}const we=ce.indexOf(me);return we!==-1?re[we]:null};se.basenames=ce,se.patterns=re,se.allBasenames=ce;const le=K.filter(_=>!_.basenames);return le.push(se),le}function V(K,ie){return(0,i.equals)(K,ie,(ge,ce)=>typeof ge=="string"&&typeof ce=="string"?ge===ce:typeof ge!="string"&&typeof ce!="string"?ge.base===ce.base&&ge.pattern===ce.pattern:!1)}e.patternsEquals=V}),define(Ie[81],Ce([1,0,11,119,22,10,2]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var O;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(O=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(l="",b=!1){if(this.value=l,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(l,b=0){return this.value+=m(this.supportThemeIcons?(0,T.escapeIcons)(l):l).replace(/([ \t]+)/g,(E,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,b){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(l,b,E){return this.value+="[",this.value+=this.c(b,"]"),this.value+="](",this.value+=this.c(String(l),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(l,b){const E=new RegExp((0,L.escapeRegExpCharacters)(b),"g");return l.replace(E,(p,w)=>l.charAt(w-1)!=="\\"?`\\${p}`:p)}}e.MarkdownString=S;function k(o){return N(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function N(o){return o instanceof S?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function D(o,l){return o===l?!0:!o||!l?!1:o.value===l.value&&o.isTrusted===l.isTrusted&&o.supportThemeIcons===l.supportThemeIcons&&o.supportHtml===l.supportHtml&&(o.baseUri===l.baseUri||!!o.baseUri&&!!l.baseUri&&(0,y.isEqual)(C.URI.from(o.baseUri),C.URI.from(l.baseUri)))}e.markdownStringEqual=D;function m(o){return o.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function v(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=v;function h(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function t(o){const l=[],b=o.split("|").map(p=>p.trim());o=b[0];const E=b[1];if(E){const p=/height=(\d+)/.exec(E),w=/width=(\d+)/.exec(E),s=p?p[1]:"",r=w?w[1]:"",a=isFinite(parseInt(r)),d=isFinite(parseInt(s));a&&l.push(`width="${r}"`),d&&l.push(`height="${s}"`)}return{href:o,dimensions:l}}e.parseHrefAndDimensions=t}),define(Ie[82],Ce([1,0,16,39,19,21,22,10]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(a,d){const{os:c,tildify:u,relative:n}=d;if(n){const P=k(a,n,c);if(typeof P=="string")return P}let f=a.fsPath;if(c===1&&!L.isWindows?f=f.replace(/\//g,"\\"):c!==1&&L.isWindows&&(f=f.replace(/\\/g,"/")),c!==1&&u?.userHome){const P=u.userHome.fsPath;let M;a.scheme!==u.userHome.scheme&&a.path.startsWith(y.posix.sep)?M=u.userHome.with({path:a.path}).fsPath:M=a.fsPath,f=m(M,P,c)}return(c===1?y.win32:y.posix).normalize(N(f,c===1))}e.getPathLabel=S;function k(a,d,c){const u=c===1?y.win32:y.posix,n=c===3?C.extUri:C.extUriIgnorePathCase,f=d.getWorkspace(),g=(0,i.firstOrDefault)(f.folders);if(!g)return;a.scheme!==g.uri.scheme&&a.path.startsWith(y.posix.sep)&&(a=g.uri.with({path:a.path}));const P=d.getWorkspaceFolder(a);if(!P)return;let M;if(n.isEqual(P.uri,a)?M="":M=n.relativePath(P.uri,a)??"",M&&(M=u.normalize(M)),f.folders.length>1&&!d.noPrefix){const q=P.name?P.name:n.basenameOrAuthority(P.uri);M=M?`${q} \u2022 ${M}`:q}return M}function N(a,d=L.isWindows){return(0,T.hasDriveLetter)(a,d)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=N;let D=Object.create(null);function m(a,d,c=L.OS){if(c===1||!a||!d)return a;let u=D.original===d?D.normalized:void 0;u||(u=d,L.isWindows&&(u=(0,T.toSlashes)(u)),u=`${(0,O.rtrim)(u,y.posix.sep)}${y.posix.sep}`,D={original:d,normalized:u});let n=a;return L.isWindows&&(n=(0,T.toSlashes)(n)),(c===3?n.startsWith(u):(0,O.startsWithIgnoreCase)(n,u))?`~/${n.substr(u.length)}`:a}e.tildify=m;function v(a,d){return a.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=v;const h="\u2026",t="\\\\",o="~";function l(a,d=y.sep){const c=new Array(a.length);let u=!1;for(let n=0;n<a.length;n++){const f=a[n];if(f===""){c[n]=`.${d}`;continue}if(!f){c[n]=f;continue}u=!0;let g="",P=f;P.indexOf(t)===0?(g=P.substr(0,P.indexOf(t)+t.length),P=P.substr(P.indexOf(t)+t.length)):P.indexOf(d)===0?(g=P.substr(0,P.indexOf(d)+d.length),P=P.substr(P.indexOf(d)+d.length)):P.indexOf(o)===0&&(g=P.substr(0,P.indexOf(o)+o.length),P=P.substr(P.indexOf(o)+o.length));const M=P.split(d);for(let q=1;u&&q<=M.length;q++)for(let J=M.length-q;u&&J>=0;J--){u=!1;let x=M.slice(J,J+q).join(d);for(let R=0;!u&&R<a.length;R++)if(R!==n&&a[R]&&a[R].indexOf(x)>-1){const A=J+q===M.length,F=J>0&&a[R].indexOf(d)>-1?d+x:x,$=a[R].endsWith(F);u=!A||$}if(!u){let R="";(M[0].endsWith(":")||g!=="")&&(J===1&&(J=0,q++,x=M[0]+d+x),J>0&&(R=M[0]+d),R=g+R),J>0&&(R=R+h+d),R=R+x,J+q<M.length&&(R=R+d+h),c[n]=R}}u&&(c[n]=f)}return c}e.shorten=l;var b;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function E(a,d=Object.create(null)){const c=[];let u=!1,n="";for(const f of a)if(f==="$"||u&&f==="{")n&&c.push({value:n,type:b.TEXT}),n="",u=!0;else if(f==="}"&&u){const g=d[n];if(typeof g=="string")g.length&&c.push({value:g,type:b.VARIABLE});else if(g){const P=c[c.length-1];(!P||P.type!==b.SEPARATOR)&&c.push({value:g.label,type:b.SEPARATOR})}n="",u=!1}else n+=f;return n&&!u&&c.push({value:n,type:b.TEXT}),c.filter((f,g)=>{if(f.type===b.SEPARATOR){const P=c[g-1],M=c[g+1];return[P,M].every(q=>q&&(q.type===b.VARIABLE||q.type===b.TEXT)&&q.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=E;function p(a,d){return L.isMacintosh||d?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function w(a,d){return L.isMacintosh||d?a.replace(/\(&&\w\)|&&/g,""):L.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function s(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(a){const d=a.indexOf("/")!==-1?y.posix:y.win32,c=d.basename(a),u=d.dirname(a);return c.length?{name:c,parentPath:u}:{name:u,parentPath:""}}e.splitName=r}),define(Ie[122],Ce([1,0,2]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(N){return N.toJSON()}class y{constructor(D){this.a=D}transformIncoming(D){const m=this.a.transformIncoming(D);return m===D?D:T(i.URI.from(m))}transformOutgoing(D){const m=this.a.transformOutgoing(D);return m===D?D:T(i.URI.from(m))}transformOutgoingURI(D){const m=this.a.transformOutgoing(D);return m===D?D:i.URI.from(m)}transformOutgoingScheme(D){return this.a.transformOutgoingScheme(D)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(N){return N}transformOutgoing(N){return N}transformOutgoingURI(N){return N}transformOutgoingScheme(N){return N}};function L(N,D,m){if(!N||m>200)return null;if(typeof N=="object"){if(N instanceof i.URI)return D.transformOutgoing(N);for(const v in N)if(Object.hasOwnProperty.call(N,v)){const h=L(N[v],D,m+1);h!==null&&(N[v]=h)}}return null}function C(N,D){const m=L(N,D,0);return m===null?N:m}e.transformOutgoingURIs=C;function O(N,D,m,v){if(!N||v>200)return null;if(typeof N=="object"){if(N.$mid===1)return m?i.URI.revive(D.transformIncoming(N)):D.transformIncoming(N);for(const h in N)if(Object.hasOwnProperty.call(N,h)){const t=O(N[h],D,m,v+1);t!==null&&(N[h]=t)}}return null}function S(N,D){const m=O(N,D,!1,0);return m===null?N:m}e.transformIncomingURIs=S;function k(N,D){const m=O(N,D,!0,0);return m===null?N:m}e.transformAndReviveIncomingURIs=k}),define(Ie[123],Ce([1,0,35,19]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(L,C,O,S,k,N){if(Array.isArray(L)){let D=0;for(const m of L){const v=y(m,C,O,S,k,N);if(v===10)return v;v>D&&(D=v)}return D}else{if(typeof L=="string")return S?L==="*"?5:L===O?10:0:0;if(L){const{language:D,pattern:m,scheme:v,hasAccessToAllModels:h,notebookType:t}=L;if(!S&&!h)return 0;t&&k&&(C=k);let o=0;if(v)if(v===C.scheme)o=10;else if(v==="*")o=5;else return 0;if(D)if(D===O)o=10;else if(D==="*")o=Math.max(o,5);else return 0;if(t)if(t===N)o=10;else if(t==="*"&&N!==void 0)o=Math.max(o,5);else return 0;if(m){let l;if(typeof m=="string"?l=m:l={...m,base:(0,T.normalize)(m.base)},l===C.fsPath||(0,i.match)(l,C.fsPath))o=10;else return 0}return o}else return 0}}e.score=y}),define(Ie[83],Ce([1,0,24,21]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(y||(y={}));function L(D){for(let m=0,v=D.length;m<v;m+=4){const h=D[m+0],t=D[m+1],o=D[m+2],l=D[m+3];D[m+0]=l,D[m+1]=o,D[m+2]=t,D[m+3]=h}}function C(D){const m=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return T.isLittleEndian()||L(m),i.VSBuffer.wrap(m)}function O(D){const m=D.buffer;if(T.isLittleEndian()||L(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const v=new Uint8Array(m.byteLength);return v.set(m),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function S(D){const m=new Uint32Array(k(D));let v=0;if(m[v++]=D.id,D.type==="full")m[v++]=1,m[v++]=D.data.length,m.set(D.data,v),v+=D.data.length;else{m[v++]=2,m[v++]=D.deltas.length;for(const h of D.deltas)m[v++]=h.start,m[v++]=h.deleteCount,h.data?(m[v++]=h.data.length,m.set(h.data,v),v+=h.data.length):m[v++]=0}return C(m)}e.encodeSemanticTokensDto=S;function k(D){let m=0;if(m+=1+1,D.type==="full")m+=1+D.data.length;else{m+=1,m+=(1+1+1)*D.deltas.length;for(const v of D.deltas)v.data&&(m+=v.data.length)}return m}function N(D){const m=O(D);let v=0;const h=m[v++];if(m[v++]===1){const b=m[v++],E=m.subarray(v,v+b);return v+=b,{id:h,type:"full",data:E}}const o=m[v++],l=[];for(let b=0;b<o;b++){const E=m[v++],p=m[v++],w=m[v++];let s;w>0&&(s=m.subarray(v,v+w),v+=w),l[b]={start:E,deleteCount:p,data:s}}return{id:h,type:"delta",deltas:l}}e.decodeSemanticTokensDto=N}),define(Ie[124],Ce([17,18]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ie[125],Ce([1,0,124,21,126,16,23,113]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=k;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class D{constructor(X,pe,Me,Be){this.id=X,this.name=pe,this.defaultValue=Me,this.schema=Be}applyUpdate(X,pe){return v(X,pe)}compute(X,pe,Me){return Me}}class m{constructor(X,pe){this.newValue=X,this.didChange=pe}}e.ApplyUpdateResult=m;function v(Q,X){if(typeof Q!="object"||typeof X!="object"||!Q||!X)return new m(X,Q!==X);if(Array.isArray(Q)||Array.isArray(X)){const Me=Array.isArray(Q)&&Array.isArray(X)&&L.equals(Q,X);return new m(X,!Me)}let pe=!1;for(const Me in X)if(X.hasOwnProperty(Me)){const Be=v(Q[Me],X[Me]);Be.didChange&&(Q[Me]=Be.newValue,pe=!0)}return new m(Q,pe)}class h{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,pe){return v(X,pe)}validate(X){return this.defaultValue}}class t{constructor(X,pe,Me,Be){this.id=X,this.name=pe,this.defaultValue=Me,this.schema=Be}applyUpdate(X,pe){return v(X,pe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,pe,Me){return Me}}function o(Q,X){return typeof Q>"u"?X:Q==="false"?!1:Boolean(Q)}e.boolean=o;class l extends t{constructor(X,pe,Me,Be=void 0){typeof Be<"u"&&(Be.type="boolean",Be.default=Me),super(X,pe,Me,Be)}validate(X){return o(X,this.defaultValue)}}function b(Q,X,pe,Me){if(typeof Q>"u")return X;let Be=parseInt(Q,10);return isNaN(Be)?X:(Be=Math.max(pe,Be),Be=Math.min(Me,Be),Be|0)}e.clampedInt=b;class E extends t{static clampedInt(X,pe,Me,Be){return b(X,pe,Me,Be)}constructor(X,pe,Me,Be,je,Je=void 0){typeof Je<"u"&&(Je.type="integer",Je.default=Me,Je.minimum=Be,Je.maximum=je),super(X,pe,Me,Je),this.minimum=Be,this.maximum=je}validate(X){return E.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class p extends t{static clamp(X,pe,Me){return X<pe?pe:X>Me?Me:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X>"u")return pe;const Me=parseFloat(X);return isNaN(Me)?pe:Me}constructor(X,pe,Me,Be,je){typeof je<"u"&&(je.type="number",je.default=Me),super(X,pe,Me,je),this.validationFn=Be}validate(X){return this.validationFn(p.float(X,this.defaultValue))}}class w extends t{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,Me,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.default=Me),super(X,pe,Me,Be)}validate(X){return w.string(X,this.defaultValue)}}function s(Q,X,pe){return typeof Q!="string"||pe.indexOf(Q)===-1?X:Q}e.stringSet=s;class r extends t{constructor(X,pe,Me,Be,je=void 0){typeof je<"u"&&(je.type="string",je.enum=Be,je.default=Me),super(X,pe,Me,je),this.c=Be}validate(X){return s(X,this.defaultValue,this.c)}}class a extends D{constructor(X,pe,Me,Be,je,Je,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=je,nt.default=Be),super(X,pe,Me,nt),this.c=je,this.d=Je}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function d(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,Me){return Me===0?X.accessibilitySupport:Me}}class u extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:i.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function f(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(Q){switch(Q){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function M(Q){switch(Q){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class q extends h{constructor(){super(133)}compute(X,pe,Me){const Be=["monaco-editor"];return pe.get(34)&&Be.push(pe.get(34)),X.extraEditorClassName&&Be.push(X.extraEditorClassName),pe.get(68)==="default"?Be.push("mouse-default"):pe.get(68)==="copy"&&Be.push("mouse-copy"),pe.get(103)&&Be.push("showUnused"),pe.get(131)&&Be.push("showDeprecated"),Be.join(" ")}}class J extends l{constructor(){super(33,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(X,pe,Me){return Me&&X.emptySelectionClipboard}}class x extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:i.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:i.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class R extends D{constructor(){super(46,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?R.OFF:X==="true"?R.ON:X:Boolean(X)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class A extends D{constructor(){super(49,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?A.OFF:X==="true"?A.TRANSLATE:X:Boolean(X)?A.TRANSLATE:A.OFF}compute(X,pe,Me){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=A,A.OFF="normal",A.TRANSLATE="translate";class F extends h{constructor(){super(45)}compute(X,pe,Me){return X.fontInfo}}class $ extends t{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(X){const pe=p.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(pe,6,100)}compute(X,pe,Me){return X.fontInfo.fontSize}}class z extends D{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(E.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class V extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Me,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Me,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Me,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Me,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Me,description:i.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends D{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:i.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:E.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),above:o(pe.above,this.defaultValue.above)}}}var ie;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class ge extends h{constructor(){super(136)}compute(X,pe,Me){return ge.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,Me=X.scrollBeyondLastLine?pe-1:0,Be=(X.viewLineCount+Me)/(X.pixelRatio*X.height),je=Math.floor(X.viewLineCount/Be);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Me,desiredRatio:Be,minimapLineCount:je}}static c(X,pe){const Me=X.outerWidth,Be=X.outerHeight,je=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Je=pe.stableMinimapLayoutInput,nt=Je&&X.outerHeight===Je.outerHeight&&X.lineHeight===Je.lineHeight&&X.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&X.pixelRatio===Je.pixelRatio&&X.scrollBeyondLastLine===Je.scrollBeyondLastLine&&X.minimap.enabled===Je.minimap.enabled&&X.minimap.side===Je.minimap.side&&X.minimap.size===Je.minimap.size&&X.minimap.showSlider===Je.minimap.showSlider&&X.minimap.renderCharacters===Je.minimap.renderCharacters&&X.minimap.maxColumn===Je.minimap.maxColumn&&X.minimap.scale===Je.minimap.scale&&X.verticalScrollbarWidth===Je.verticalScrollbarWidth&&X.isViewportWrapping===Je.isViewportWrapping,vt=X.lineHeight,wt=X.typicalHalfwidthCharacterWidth,Tt=X.scrollBeyondLastLine,lt=X.minimap.renderCharacters;let at=je>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Ut=X.minimap.maxColumn,Ft=X.minimap.size,Nt=X.minimap.side,ft=X.verticalScrollbarWidth,Ct=X.viewLineCount,Bt=X.remainingWidth,Mt=X.isViewportWrapping,Ge=lt?2:3;let Rt=Math.floor(je*Be);const Lt=Rt/je;let Ht=!1,mt=!1,At=Ge*at,ye=at/je,Pe=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:It,desiredRatio:bt,minimapLineCount:kt}=ge.computeContainedMinimapLineCount({viewLineCount:Ct,scrollBeyondLastLine:Tt,height:Be,lineHeight:vt,pixelRatio:je});if(Ct/kt>1)Ht=!0,mt=!0,at=1,At=1,ye=at/je;else{let pt=!1,St=at+1;if(Ft==="fit"){const $t=Math.ceil((Ct+It)*At);Mt&&nt&&Bt<=pe.stableFitRemainingWidth?(pt=!0,St=pe.stableFitMaxMinimapScale):pt=$t>Rt}if(Ft==="fill"||pt){Ht=!0;const $t=at;At=Math.min(vt*je,Math.max(1,Math.floor(1/bt))),Mt&&nt&&Bt<=pe.stableFitRemainingWidth&&(St=pe.stableFitMaxMinimapScale),at=Math.min(St,Math.max(1,Math.floor(At/Ge))),at>$t&&(Pe=Math.min(2,at/$t)),ye=at/je/Pe,Rt=Math.ceil(Math.max(Ze,Ct+It)*At),Mt?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=Bt,pe.stableFitMaxMinimapScale=at):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const fe=Math.floor(Ut*ye),G=Math.min(fe,Math.max(0,Math.floor((Bt-ft-2)*ye/(wt+ye)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(je*G);const Le=Ae/je;Ae=Math.floor(Ae*Pe);const Xe=lt?1:2,ze=Nt==="left"?0:Me-G-ft;return{renderMinimap:Xe,minimapLeft:ze,minimapWidth:G,minimapHeightIsEditorHeight:Ht,minimapIsSampling:mt,minimapScale:at,minimapLineHeight:At,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Lt}}static computeLayout(X,pe){const Me=pe.outerWidth|0,Be=pe.outerHeight|0,je=pe.lineHeight|0,Je=pe.lineNumbersDigitCount|0,nt=pe.typicalHalfwidthCharacterWidth,vt=pe.maxDigitWidth,wt=pe.pixelRatio,Tt=pe.viewLineCount,lt=X.get(128),at=lt==="inherit"?X.get(127):lt,Ut=at==="inherit"?X.get(123):at,Ft=X.get(126),Nt=pe.isDominatedByLongLines,ft=X.get(52),Ct=X.get(62).renderType!==0,Bt=X.get(63),Mt=X.get(97),Ge=X.get(67),Rt=X.get(95),Lt=Rt.verticalScrollbarSize,Ht=Rt.verticalHasArrows,mt=Rt.arrowSize,At=Rt.horizontalScrollbarSize,ye=X.get(38),Pe=X.get(102)!=="never";let fe=X.get(60);ye&&Pe&&(fe+=16);let G=0;if(Ct){const Et=Math.max(Je,Bt);G=Math.round(Et*vt)}let Ae=0;ft&&(Ae=je);let Le=0,Xe=Le+Ae,ze=Xe+G,Ze=ze+fe;const It=Me-Ae-G-fe;let bt=!1,kt=!1,gt=-1;at==="inherit"&&Nt?(bt=!0,kt=!0):Ut==="on"||Ut==="bounded"?kt=!0:Ut==="wordWrapColumn"&&(gt=Ft);const pt=ge.c({outerWidth:Me,outerHeight:Be,lineHeight:je,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:Mt,minimap:Ge,verticalScrollbarWidth:Lt,viewLineCount:Tt,remainingWidth:It,isViewportWrapping:kt},pe.memory||new N);pt.renderMinimap!==0&&pt.minimapLeft===0&&(Le+=pt.minimapWidth,Xe+=pt.minimapWidth,ze+=pt.minimapWidth,Ze+=pt.minimapWidth);const St=It-pt.minimapWidth,$t=Math.max(1,Math.floor((St-Lt-2)/nt)),Xt=Ht?mt:0;return kt&&(gt=Math.max(1,$t),Ut==="bounded"&&(gt=Math.min(gt,Ft))),{width:Me,height:Be,glyphMarginLeft:Le,glyphMarginWidth:Ae,lineNumbersLeft:Xe,lineNumbersWidth:G,decorationsLeft:ze,decorationsWidth:fe,contentLeft:Ze,contentWidth:St,minimap:pt,viewportColumn:$t,isWordWrapMinified:bt,isViewportWrapping:kt,wrappingColumn:gt,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:At,overviewRuler:{top:Xt,width:Lt,height:Be-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=ge;class ce extends D{constructor(){super(130,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(X){return s(X,"simple",["simple","advanced"])}compute(X,pe,Me){return pe.get(2)===2?"advanced":Me}}class re extends D{constructor(){const X={enabled:!0};super(59,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:i.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:o(X.enabled,this.defaultValue.enabled)}}}class se extends D{constructor(){const X={enabled:!1,maxLineCount:5};super(107,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(132,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:i.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(53,null),i.localize(54,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:i.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:i.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:i.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class _ extends D{constructor(){super(60,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):E.clampedInt(X,this.defaultValue,0,1e3)}compute(X,pe,Me){return Me<0?E.clampedInt(-Me*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class me extends p{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>p.clamp(X,0,150),{markdownDescription:i.localize(60,null)})}compute(X,pe,Me){return X.fontInfo.lineHeight}}class we extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:i.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:i.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)],default:X.size,description:i.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:i.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:i.localize(68,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:i.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:i.localize(71,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(pe.scale,1,1,3),maxColumn:E.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ne(Q){return Q==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class We extends D{constructor(){super(78,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:E.clampedInt(pe.top,0,0,1e3),bottom:E.clampedInt(pe.bottom,0,0,1e3)}}}class Qe extends D{constructor(){const X={enabled:!0,cycle:!1};super(79,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:i.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:i.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class Te extends h{constructor(){super(134)}compute(X,pe,Me){return X.pixelRatio}}class De extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(76,null),i.localize(77,null),i.localize(78,null)]}];super(82,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:X.strings,description:i.localize(79,null)},comments:{anyOf:pe,default:X.comments,description:i.localize(80,null)},other:{anyOf:pe,default:X.other,description:i.localize(81,null)}},default:X,markdownDescription:i.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const wt=X?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!X||typeof X!="object")return this.defaultValue;const{other:pe,comments:Me,strings:Be}=X,je=["on","inline","off"];let Je,nt,vt;return typeof pe=="boolean"?Je=pe?"on":"off":Je=s(pe,this.defaultValue.other,je),typeof Me=="boolean"?nt=Me?"on":"off":nt=s(Me,this.defaultValue.comments,je),typeof Be=="boolean"?vt=Be?"on":"off":vt=s(Be,this.defaultValue.strings,je),{other:Je,comments:nt,strings:vt}}}var ke;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends D{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(83,null),i.localize(84,null),i.localize(85,null),i.localize(86,null)],default:"on",description:i.localize(87,null)})}validate(X){let pe=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(pe=4,Me=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:Me}}}function ue(Q){const X=Q.get(90);return X==="editable"?Q.get(84):X!=="on"}e.filterValidationDecorations=ue;class Y extends D{constructor(){const X=[],pe={type:"number",description:i.localize(88,null)};super(94,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:i.localize(89,null),format:"color-hex"}}}]},default:X,description:i.localize(90,null)})}validate(X){if(Array.isArray(X)){const pe=[];for(const Me of X)if(typeof Me=="number")pe.push({column:E.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const Be=Me;pe.push({column:E.clampedInt(Be.column,0,0,1e4),color:Be.color})}return pe.sort((Me,Be)=>Me.column-Be.column),pe}return this.defaultValue}}function I(Q,X){if(typeof Q!="string")return X;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(95,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(91,null),i.localize(92,null),i.localize(93,null)],default:"auto",description:i.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(95,null),i.localize(96,null),i.localize(97,null)],default:"auto",description:i.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:i.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:i.localize(101,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,Me=E.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=E.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(pe.vertical,this.defaultValue.vertical),horizontal:I(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:E.clampedInt(pe.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:E.clampedInt(pe.verticalSliderSize,Be,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(117,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:i.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:i.localize(108,null)}})}applyUpdate(X,pe){let Me=!1;pe.allowedCharacters&&X&&(C.equals(X.allowedCharacters,pe.allowedCharacters)||(X={...X,allowedCharacters:pe.allowedCharacters},Me=!0)),pe.allowedLocales&&X&&(C.equals(X.allowedLocales,pe.allowedLocales)||(X={...X,allowedLocales:pe.allowedLocales},Me=!0));const Be=super.applyUpdate(X,pe);return Me?new m(Be.newValue,!0):Be}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{nonBasicASCII:Se(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Se(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Se(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,pe){if(typeof X!="object"||!X)return pe;const Me={};for(const[Be,je]of Object.entries(X))je===!0&&(Me[Be]=!0);return Me}}class j extends D{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:i.localize(109,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Z extends D{constructor(){const X={enabled:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:i.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:i.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class de extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(112,null),i.localize(113,null),i.localize(114,null)],default:X.bracketPairs,description:i.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(116,null),i.localize(117,null),i.localize(118,null)],default:X.bracketPairsHorizontal,description:i.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:i.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:i.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(122,null),i.localize(123,null),i.localize(124,null)],default:X.highlightActiveIndentation,description:i.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{bracketPairs:Se(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Se(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Se(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Se(Q,X,pe){const Me=pe.indexOf(Q);return Me===-1?X:pe[Me]}class ae extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(110,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(126,null),i.localize(127,null)],default:X.insertMode,description:i.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:i.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:i.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:i.localize(131,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:i.localize(132,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:i.localize(133,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:i.localize(134,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:i.localize(135,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:i.localize(136,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(137,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(138,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(139,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:o(pe.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class ve extends D{constructor(){super(105,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(169,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class be extends h{constructor(){super(135)}compute(X,pe,Me){return pe.get(84)?!0:X.tabFocusMode}}var $e;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})($e=e.WrappingIndent||(e.WrappingIndent={}));class He extends D{constructor(){super(129,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(170,null),i.localize(171,null),i.localize(172,null),i.localize(173,null)],description:i.localize(174,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,pe,Me){return pe.get(2)===2?0:Me}}class tt extends h{constructor(){super(137)}compute(X,pe,Me){const Be=pe.get(136);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}class xe extends D{constructor(){const X={enabled:!0};super(32,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:i.localize(175,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:o(X.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?it:T.isLinux?dt:et,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var st;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.columnSelection=18]="columnSelection",Q[Q.comments=19]="comments",Q[Q.contextmenu=20]="contextmenu",Q[Q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=22]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=24]="cursorStyle",Q[Q.cursorSurroundingLines=25]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=27]="cursorWidth",Q[Q.disableLayerHinting=28]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",Q[Q.domReadOnly=30]="domReadOnly",Q[Q.dragAndDrop=31]="dragAndDrop",Q[Q.dropIntoEditor=32]="dropIntoEditor",Q[Q.emptySelectionClipboard=33]="emptySelectionClipboard",Q[Q.extraEditorClassName=34]="extraEditorClassName",Q[Q.fastScrollSensitivity=35]="fastScrollSensitivity",Q[Q.find=36]="find",Q[Q.fixedOverflowWidgets=37]="fixedOverflowWidgets",Q[Q.folding=38]="folding",Q[Q.foldingStrategy=39]="foldingStrategy",Q[Q.foldingHighlight=40]="foldingHighlight",Q[Q.foldingImportsByDefault=41]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=42]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=44]="fontFamily",Q[Q.fontInfo=45]="fontInfo",Q[Q.fontLigatures=46]="fontLigatures",Q[Q.fontSize=47]="fontSize",Q[Q.fontWeight=48]="fontWeight",Q[Q.fontVariations=49]="fontVariations",Q[Q.formatOnPaste=50]="formatOnPaste",Q[Q.formatOnType=51]="formatOnType",Q[Q.glyphMargin=52]="glyphMargin",Q[Q.gotoLocation=53]="gotoLocation",Q[Q.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",Q[Q.hover=55]="hover",Q[Q.inDiffEditor=56]="inDiffEditor",Q[Q.inlineSuggest=57]="inlineSuggest",Q[Q.letterSpacing=58]="letterSpacing",Q[Q.lightbulb=59]="lightbulb",Q[Q.lineDecorationsWidth=60]="lineDecorationsWidth",Q[Q.lineHeight=61]="lineHeight",Q[Q.lineNumbers=62]="lineNumbers",Q[Q.lineNumbersMinChars=63]="lineNumbersMinChars",Q[Q.linkedEditing=64]="linkedEditing",Q[Q.links=65]="links",Q[Q.matchBrackets=66]="matchBrackets",Q[Q.minimap=67]="minimap",Q[Q.mouseStyle=68]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=70]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=72]="multiCursorModifier",Q[Q.multiCursorPaste=73]="multiCursorPaste",Q[Q.multiCursorLimit=74]="multiCursorLimit",Q[Q.occurrencesHighlight=75]="occurrencesHighlight",Q[Q.overviewRulerBorder=76]="overviewRulerBorder",Q[Q.overviewRulerLanes=77]="overviewRulerLanes",Q[Q.padding=78]="padding",Q[Q.parameterHints=79]="parameterHints",Q[Q.peekWidgetDefaultFocus=80]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=81]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=82]="quickSuggestions",Q[Q.quickSuggestionsDelay=83]="quickSuggestionsDelay",Q[Q.readOnly=84]="readOnly",Q[Q.renameOnType=85]="renameOnType",Q[Q.renderControlCharacters=86]="renderControlCharacters",Q[Q.renderFinalNewline=87]="renderFinalNewline",Q[Q.renderLineHighlight=88]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=89]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=90]="renderValidationDecorations",Q[Q.renderWhitespace=91]="renderWhitespace",Q[Q.revealHorizontalRightPadding=92]="revealHorizontalRightPadding",Q[Q.roundedSelection=93]="roundedSelection",Q[Q.rulers=94]="rulers",Q[Q.scrollbar=95]="scrollbar",Q[Q.scrollBeyondLastColumn=96]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=97]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=98]="scrollPredominantAxis",Q[Q.selectionClipboard=99]="selectionClipboard",Q[Q.selectionHighlight=100]="selectionHighlight",Q[Q.selectOnLineNumbers=101]="selectOnLineNumbers",Q[Q.showFoldingControls=102]="showFoldingControls",Q[Q.showUnused=103]="showUnused",Q[Q.snippetSuggestions=104]="snippetSuggestions",Q[Q.smartSelect=105]="smartSelect",Q[Q.smoothScrolling=106]="smoothScrolling",Q[Q.stickyScroll=107]="stickyScroll",Q[Q.stickyTabStops=108]="stickyTabStops",Q[Q.stopRenderingLineAfter=109]="stopRenderingLineAfter",Q[Q.suggest=110]="suggest",Q[Q.suggestFontSize=111]="suggestFontSize",Q[Q.suggestLineHeight=112]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=113]="suggestOnTriggerCharacters",Q[Q.suggestSelection=114]="suggestSelection",Q[Q.tabCompletion=115]="tabCompletion",Q[Q.tabIndex=116]="tabIndex",Q[Q.unicodeHighlighting=117]="unicodeHighlighting",Q[Q.unusualLineTerminators=118]="unusualLineTerminators",Q[Q.useShadowDOM=119]="useShadowDOM",Q[Q.useTabStops=120]="useTabStops",Q[Q.wordBreak=121]="wordBreak",Q[Q.wordSeparators=122]="wordSeparators",Q[Q.wordWrap=123]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=124]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=125]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=126]="wordWrapColumn",Q[Q.wordWrapOverride1=127]="wordWrapOverride1",Q[Q.wordWrapOverride2=128]="wordWrapOverride2",Q[Q.wrappingIndent=129]="wrappingIndent",Q[Q.wrappingStrategy=130]="wrappingStrategy",Q[Q.showDeprecated=131]="showDeprecated",Q[Q.inlayHints=132]="inlayHints",Q[Q.editorClassName=133]="editorClassName",Q[Q.pixelRatio=134]="pixelRatio",Q[Q.tabFocusMode=135]="tabFocusMode",Q[Q.layoutInfo=136]="layoutInfo",Q[Q.wrappingInfo=137]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(176,null)})),acceptSuggestionOnEnter:Fe(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(177,null),""],markdownDescription:i.localize(178,null)})),accessibilitySupport:Fe(new c),accessibilityPageSize:Fe(new E(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(179,null),tags:["accessibility"]})),ariaLabel:Fe(new w(4,"ariaLabel",i.localize(180,null))),autoClosingBrackets:Fe(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(181,null),i.localize(182,null),""],description:i.localize(183,null)})),autoClosingDelete:Fe(new r(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(184,null),""],description:i.localize(185,null)})),autoClosingOvertype:Fe(new r(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(186,null),""],description:i.localize(187,null)})),autoClosingQuotes:Fe(new r(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(188,null),i.localize(189,null),""],description:i.localize(190,null)})),autoIndent:Fe(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[i.localize(191,null),i.localize(192,null),i.localize(193,null),i.localize(194,null),i.localize(195,null)],description:i.localize(196,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new r(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(197,null),i.localize(198,null),i.localize(199,null),""],description:i.localize(200,null)})),bracketPairColorization:Fe(new Z),bracketPairGuides:Fe(new de),stickyTabStops:Fe(new l(108,"stickyTabStops",!1,{description:i.localize(201,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:i.localize(202,null)})),codeLensFontFamily:Fe(new w(15,"codeLensFontFamily","",{description:i.localize(203,null)})),codeLensFontSize:Fe(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(204,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:i.localize(205,null)})),columnSelection:Fe(new l(18,"columnSelection",!1,{description:i.localize(206,null)})),comments:Fe(new u),contextmenu:Fe(new l(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(21,"copyWithSyntaxHighlighting",!0,{description:i.localize(207,null)})),cursorBlinking:Fe(new a(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:i.localize(208,null)})),cursorSmoothCaretAnimation:Fe(new l(23,"cursorSmoothCaretAnimation",!1,{description:i.localize(209,null)})),cursorStyle:Fe(new a(24,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:i.localize(210,null)})),cursorSurroundingLines:Fe(new E(25,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(211,null)})),cursorSurroundingLinesStyle:Fe(new r(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(212,null),i.localize(213,null)],description:i.localize(214,null)})),cursorWidth:Fe(new E(27,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(215,null)})),disableLayerHinting:Fe(new l(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(30,"domReadOnly",!1)),dragAndDrop:Fe(new l(31,"dragAndDrop",!0,{description:i.localize(216,null)})),emptySelectionClipboard:Fe(new J),dropIntoEditor:Fe(new xe),stickyScroll:Fe(new se),extraEditorClassName:Fe(new w(34,"extraEditorClassName","")),fastScrollSensitivity:Fe(new p(35,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:i.localize(217,null)})),find:Fe(new x),fixedOverflowWidgets:Fe(new l(37,"fixedOverflowWidgets",!1)),folding:Fe(new l(38,"folding",!0,{description:i.localize(218,null)})),foldingStrategy:Fe(new r(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(219,null),i.localize(220,null)],description:i.localize(221,null)})),foldingHighlight:Fe(new l(40,"foldingHighlight",!0,{description:i.localize(222,null)})),foldingImportsByDefault:Fe(new l(41,"foldingImportsByDefault",!1,{description:i.localize(223,null)})),foldingMaximumRegions:Fe(new E(42,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(224,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(43,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(225,null)})),fontFamily:Fe(new w(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(226,null)})),fontInfo:Fe(new F),fontLigatures2:Fe(new R),fontSize:Fe(new $),fontWeight:Fe(new z),fontVariations:Fe(new A),formatOnPaste:Fe(new l(50,"formatOnPaste",!1,{description:i.localize(227,null)})),formatOnType:Fe(new l(51,"formatOnType",!1,{description:i.localize(228,null)})),glyphMargin:Fe(new l(52,"glyphMargin",!0,{description:i.localize(229,null)})),gotoLocation:Fe(new V),hideCursorInOverviewRuler:Fe(new l(54,"hideCursorInOverviewRuler",!1,{description:i.localize(230,null)})),hover:Fe(new K),inDiffEditor:Fe(new l(56,"inDiffEditor",!1)),letterSpacing:Fe(new p(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>p.clamp(Q,-5,20),{description:i.localize(231,null)})),lightbulb:Fe(new re),lineDecorationsWidth:Fe(new _),lineHeight:Fe(new me),lineNumbers:Fe(new oe),lineNumbersMinChars:Fe(new E(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(64,"linkedEditing",!1,{description:i.localize(232,null)})),links:Fe(new l(65,"links",!0,{description:i.localize(233,null)})),matchBrackets:Fe(new r(66,"matchBrackets","always",["always","near","never"],{description:i.localize(234,null)})),minimap:Fe(new we),mouseStyle:Fe(new r(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new p(69,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:i.localize(235,null)})),mouseWheelZoom:Fe(new l(70,"mouseWheelZoom",!1,{markdownDescription:i.localize(236,null)})),multiCursorMergeOverlapping:Fe(new l(71,"multiCursorMergeOverlapping",!0,{description:i.localize(237,null)})),multiCursorModifier:Fe(new a(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ne,{markdownEnumDescriptions:[i.localize(238,null),i.localize(239,null)],markdownDescription:i.localize(240,null)})),multiCursorPaste:Fe(new r(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(241,null),i.localize(242,null)],markdownDescription:i.localize(243,null)})),multiCursorLimit:Fe(new E(74,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(244,null)})),occurrencesHighlight:Fe(new l(75,"occurrencesHighlight",!0,{description:i.localize(245,null)})),overviewRulerBorder:Fe(new l(76,"overviewRulerBorder",!0,{description:i.localize(246,null)})),overviewRulerLanes:Fe(new E(77,"overviewRulerLanes",3,0,3)),padding:Fe(new We),parameterHints:Fe(new Qe),peekWidgetDefaultFocus:Fe(new r(80,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(247,null),i.localize(248,null)],description:i.localize(249,null)})),definitionLinkOpensInPeek:Fe(new l(81,"definitionLinkOpensInPeek",!1,{description:i.localize(250,null)})),quickSuggestions:Fe(new De),quickSuggestionsDelay:Fe(new E(83,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(251,null)})),readOnly:Fe(new l(84,"readOnly",!1)),renameOnType:Fe(new l(85,"renameOnType",!1,{description:i.localize(252,null),markdownDeprecationMessage:i.localize(253,null)})),renderControlCharacters:Fe(new l(86,"renderControlCharacters",!0,{description:i.localize(254,null),restricted:!0})),renderFinalNewline:Fe(new r(87,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(255,null)})),renderLineHighlight:Fe(new r(88,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(256,null)],description:i.localize(257,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(89,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(258,null)})),renderValidationDecorations:Fe(new r(90,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new r(91,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(259,null),i.localize(260,null),i.localize(261,null),""],description:i.localize(262,null)})),revealHorizontalRightPadding:Fe(new E(92,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(93,"roundedSelection",!0,{description:i.localize(263,null)})),rulers:Fe(new Y),scrollbar:Fe(new U),scrollBeyondLastColumn:Fe(new E(96,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(264,null)})),scrollBeyondLastLine:Fe(new l(97,"scrollBeyondLastLine",!0,{description:i.localize(265,null)})),scrollPredominantAxis:Fe(new l(98,"scrollPredominantAxis",!0,{description:i.localize(266,null)})),selectionClipboard:Fe(new l(99,"selectionClipboard",!0,{description:i.localize(267,null),included:T.isLinux})),selectionHighlight:Fe(new l(100,"selectionHighlight",!0,{description:i.localize(268,null)})),selectOnLineNumbers:Fe(new l(101,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new r(102,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(269,null),i.localize(270,null),i.localize(271,null)],description:i.localize(272,null)})),showUnused:Fe(new l(103,"showUnused",!0,{description:i.localize(273,null)})),showDeprecated:Fe(new l(131,"showDeprecated",!0,{description:i.localize(274,null)})),inlayHints:Fe(new le),snippetSuggestions:Fe(new r(104,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(275,null),i.localize(276,null),i.localize(277,null),i.localize(278,null)],description:i.localize(279,null)})),smartSelect:Fe(new ve),smoothScrolling:Fe(new l(106,"smoothScrolling",!1,{description:i.localize(280,null)})),stopRenderingLineAfter:Fe(new E(109,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ae),inlineSuggest:Fe(new j),suggestFontSize:Fe(new E(111,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(281,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new E(112,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(282,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(113,"suggestOnTriggerCharacters",!0,{description:i.localize(283,null)})),suggestSelection:Fe(new r(114,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(284,null),i.localize(285,null),i.localize(286,null)],description:i.localize(287,null)})),tabCompletion:Fe(new r(115,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(288,null),i.localize(289,null),i.localize(290,null)],description:i.localize(291,null)})),tabIndex:Fe(new E(116,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new H),unusualLineTerminators:Fe(new r(118,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(292,null),i.localize(293,null),i.localize(294,null)],description:i.localize(295,null)})),useShadowDOM:Fe(new l(119,"useShadowDOM",!0)),useTabStops:Fe(new l(120,"useTabStops",!0,{description:i.localize(296,null)})),wordBreak:Fe(new r(121,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(297,null),i.localize(298,null)],description:i.localize(299,null)})),wordSeparators:Fe(new w(122,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:i.localize(300,null)})),wordWrap:Fe(new r(123,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(301,null),i.localize(302,null),i.localize(303,null),i.localize(304,null)],description:i.localize(305,null)})),wordWrapBreakAfterCharacters:Fe(new w(124,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new w(125,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new E(126,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(306,null)})),wordWrapOverride1:Fe(new r(127,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new r(128,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new q),pixelRatio:Fe(new Te),tabFocusMode:Fe(new be),layoutInfo:Fe(new ge),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new ce)}}),define(Ie[127],Ce([17,18]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[128],Ce([17,18]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[129],Ce([17,18]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[130],Ce([17,18]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ie[131],Ce([17,18]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ie[132],Ce([17,18]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ie[133],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[134],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[135],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[136],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[137],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[138],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[139],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[140],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ie[141],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[142],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[143],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[144],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[145],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[146],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[147],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[148],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this.a=new Map}register(L,C){this.a.set(L,C)}updateManifest(L){if(!(typeof L.main>"u"&&typeof L.browser>"u")&&(L.activationEvents===void 0&&Object.assign(L,{activationEvents:[]}),!(!Array.isArray(L.activationEvents)||!L.contributes)))for(const C in L.contributes){const O=this.a.get(C);if(!O)continue;const S=L.contributes[C],k=Array.isArray(S)?S:[S];try{O(k,L.activationEvents)}catch(N){(0,i.onUnexpectedError)(N)}}}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(Ie[149],Ce([1,0,22,29,129,248]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,O=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||C.test(l)}e.isValidVersionStr=S;function k(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=l.match(C);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=k;function N(l){if(!l)return null;const b=l.majorBase,E=l.majorMustEqual,p=l.minorBase;let w=l.minorMustEqual;const s=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(b===0||(w=!1),r=!1);let a=0;if(l.preRelease){const d=O.exec(l.preRelease);if(d){const[,c,u,n]=d;a=Date.UTC(Number(c),Number(u)-1,Number(n))}}return{majorBase:b,majorMustEqual:E,minorBase:p,minorMustEqual:w,patchBase:s,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=N;function D(l,b,E){let p;typeof l=="string"?p=N(k(l)):p=l;let w;b instanceof Date?w=b.getTime():typeof b=="string"&&(w=new Date(b).getTime());let s;if(typeof E=="string"?s=N(k(E)):s=E,!p||!s)return!1;const r=p.majorBase,a=p.minorBase,d=p.patchBase;let c=s.majorBase,u=s.minorBase,n=s.patchBase;const f=s.notBefore;let g=s.majorMustEqual,P=s.minorMustEqual,M=s.patchMustEqual;return s.isMinimum?r>c?!0:r<c?!1:a>u?!0:a<u||w&&w<f?!1:d>=n:(r===1&&c===0&&(!g||!P||!M)&&(c=1,u=0,n=0,g=!0,P=!1,M=!1),r<c?!1:r>c?!g:a<u?!1:a>u?!P:d<n?!1:d>n?!M:!(w&&w<f))}e.isValidVersion=D;function m(l,b,E,p,w){const s=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return s.push([T.default.Error,y.localize(0,null)]),s;if(typeof p.name!="string")return s.push([T.default.Error,y.localize(1,null,"name")]),s;if(typeof p.version!="string")return s.push([T.default.Error,y.localize(2,null,"version")]),s;if(!p.engines)return s.push([T.default.Error,y.localize(3,null,"engines")]),s;if(typeof p.engines.vscode!="string")return s.push([T.default.Error,y.localize(4,null,"engines.vscode")]),s;if(typeof p.extensionDependencies<"u"&&!o(p.extensionDependencies))return s.push([T.default.Error,y.localize(5,null,"extensionDependencies")]),s;if(typeof p.activationEvents<"u"){if(!o(p.activationEvents))return s.push([T.default.Error,y.localize(6,null,"activationEvents")]),s;if(typeof p.main>"u"&&typeof p.browser>"u")return s.push([T.default.Error,y.localize(7,null,"activationEvents","main")]),s}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&s.push([T.default.Warning,y.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return s.push([T.default.Error,y.localize(9,null,"main")]),s;{const d=(0,i.joinPath)(E,p.main);(0,i.isEqualOrParent)(d,E)||s.push([T.default.Warning,y.localize(10,null,d.path,E.path)])}if(typeof p.activationEvents>"u")return s.push([T.default.Error,y.localize(11,null,"activationEvents","main")]),s}if(typeof p.browser<"u"){if(typeof p.browser!="string")return s.push([T.default.Error,y.localize(12,null,"browser")]),s;{const d=(0,i.joinPath)(E,p.browser);(0,i.isEqualOrParent)(d,E)||s.push([T.default.Warning,y.localize(13,null,d.path,E.path)])}if(typeof p.activationEvents>"u")return s.push([T.default.Error,y.localize(14,null,"activationEvents","browser")]),s}if(!L.valid(p.version))return s.push([T.default.Error,y.localize(15,null)]),s;const r=[];if(!v(l,b,p,w,r))for(const d of r)s.push([T.default.Error,d]);return s}e.validateExtensionManifest=m;function v(l,b,E,p,w){return p||typeof E.main>"u"&&typeof E.browser>"u"?!0:t(l,b,E.engines.vscode,w)}e.isValidExtensionVersion=v;function h(l,b,E){return l==="*"||t(b,E,l)}e.isEngineValid=h;function t(l,b,E,p=[]){const w=N(k(E));if(!w)return p.push(y.localize(16,null,E)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return p.push(y.localize(17,null,E)),!1}else if(!w.majorMustEqual)return p.push(y.localize(18,null,E)),!1;return D(l,b,w)?!0:(p.push(y.localize(19,null,l,E)),!1)}function o(l){if(!Array.isArray(l))return!1;for(let b=0,E=l.length;b<E;b++)if(typeof l[b]!="string")return!1;return!0}}),define(Ie[84],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(y,L=[],C=!1){this.ctor=y,this.staticArguments=L,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=i}),define(Ie[62],Ce([1,0,84]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var y;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(y=e.InstantiationType||(e.InstantiationType={}));function L(O,S,k){S instanceof i.SyncDescriptor||(S=new i.SyncDescriptor(S,[],Boolean(k))),T.push([O,S])}e.registerSingleton=L;function C(){return T}e.getSingletonServiceDescriptors=C}),define(Ie[150],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(L,C){this.key=L,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const C of this.a.values())C.outgoing.size===0&&L.push(C);return L}insertEdge(L,C){const O=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(C);O.outgoing.set(S.key,S),S.incoming.set(O.key,O)}removeNode(L){const C=this.b(L);this.a.delete(C);for(const O of this.a.values())O.outgoing.delete(C),O.incoming.delete(C)}lookupOrInsertNode(L){const C=this.b(L);let O=this.a.get(C);return O||(O=new i(C,L),this.a.set(C,O)),O}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[C,O]of this.a)L.push(`${C}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,C]of this.a){const O=new Set([L]),S=this.c(C,O);if(S)return S}}c(L,C){for(const[O,S]of L.outgoing){if(C.has(O))return[...C,O].join(" -> ");C.add(O);const k=this.c(S,C);if(k)return k;C.delete(O)}}}e.Graph=T}),define(Ie[3],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function O(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=O})(i=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function T(C,O,S){O[i.DI_TARGET]===O?O[i.DI_DEPENDENCIES].push({id:C,index:S}):(O[i.DI_DEPENDENCIES]=[{id:C,index:S}],O[i.DI_TARGET]=O)}function y(C){if(i.serviceIds.has(C))return i.serviceIds.get(C);const O=function(S,k,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(O,S,N)};return O.toString=()=>C,i.serviceIds.set(C,O),O}e.createDecorator=y;function L(C){return C}e.refineServiceDecorator=L}),define(Ie[40],Ce([1,0,9,2,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationOverrides=L;function C(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=C;var O;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(O=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function k(l,b){const E=Object.create(null);for(const p in l)N(E,p,l[p],b);return E}e.toValuesTree=k;function N(l,b,E,p){const w=b.split("."),s=w.pop();let r=l;for(let a=0;a<w.length;a++){const d=w[a];let c=r[d];switch(typeof c){case"undefined":c=r[d]=Object.create(null);break;case"object":break;default:p(`Ignoring ${b} as ${w.slice(0,a+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[s]=E}catch{p(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(r)}`)}else p(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=N;function D(l,b){const E=b.split(".");m(l,E)}e.removeFromValueTree=D;function m(l,b){const E=b.shift();if(b.length===0){delete l[E];return}if(Object.keys(l).indexOf(E)!==-1){const p=l[E];typeof p=="object"&&!Array.isArray(p)&&(m(p,b),Object.keys(p).length===0&&delete l[E])}}function v(l,b,E){function p(r,a){let d=r;for(const c of a){if(typeof d!="object"||d===null)return;d=d[c]}return d}const w=b.split("."),s=p(l,w);return typeof s>"u"?E:s}e.getConfigurationValue=v;function h(l,b,E){Object.keys(b).forEach(p=>{p!=="__proto__"&&(p in l?i.isObject(l[p])&&i.isObject(b[p])?h(l[p],b[p],E):E&&(l[p]=b[p]):l[p]=b[p])})}e.merge=h;function t(l,b,E){const p=l.inspect(b),w=l.inspect(E);return typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:p.defaultValue}e.getMigratedSettingValue=t;function o(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(Ie[41],Ce([1,0,21,10,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",i.isMacintosh),L.set("isLinux",i.isLinux),L.set("isWindows",i.isWindows),L.set("isWeb",i.isWeb),L.set("isMacNative",i.isMacintosh&&!i.isWeb),L.set("isEdge",i.isEdge),L.set("isFirefox",i.isFirefox),L.set("isChrome",i.isChrome),L.set("isSafari",i.isSafari);const C=Object.prototype.hasOwnProperty;var O;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(O=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return D.INSTANCE}static true(){return m.INSTANCE}static has(R){return v.create(R)}static equals(R,A){return h.create(R,A)}static notEquals(R,A){return l.create(R,A)}static regex(R,A){return a.create(R,A)}static in(R,A){return t.create(R,A)}static notIn(R,A){return o.create(R,A)}static not(R){return b.create(R)}static and(...R){return u.create(R,null,!0)}static or(...R){return n.create(R,null,!0)}static greater(R,A){return p.create(R,A)}static greaterEquals(R,A){return w.create(R,A)}static smaller(R,A){return s.create(R,A)}static smallerEquals(R,A){return r.create(R,A)}static deserialize(R,A=!1){if(!!R)return this.c(R,A)}static c(R,A){const F=R.split("||");return n.create(F.map($=>this.d($,A)),null,!0)}static d(R,A){const F=R.split("&&");return u.create(F.map($=>this.f($,A)),null,!0)}static f(R,A){if(R=R.trim(),R.indexOf("!=")>=0){const F=R.split("!=");return l.create(F[0].trim(),this.g(F[1],A))}if(R.indexOf("==")>=0){const F=R.split("==");return h.create(F[0].trim(),this.g(F[1],A))}if(R.indexOf("=~")>=0){const F=R.split("=~");return a.create(F[0].trim(),this.h(F[1],A))}if(R.indexOf(" not in ")>=0){const F=R.split(" not in ");return o.create(F[0].trim(),this.g(F[1],A))}if(R.indexOf(" in ")>=0){const F=R.split(" in ");return t.create(F[0].trim(),this.g(F[1],A))}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const F=R.split(">=");return w.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const F=R.split(">");return p.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const F=R.split("<=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const F=R.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(R)?b.create(R.substr(1).trim()):v.create(R)}static g(R,A){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;const F=/^'([^']*)'$/.exec(R);return F?F[1].trim():R}static h(R,A){if((0,T.isFalsyOrWhitespace)(R)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=R.indexOf("/"),$=R.lastIndexOf("/");if(F===$||F<0){if(A)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}const z=R.slice(F+1,$),V=R[$+1]==="i"?"i":"";try{return new RegExp(z,V)}catch(K){if(A)throw new Error(`bad regexp-value '${R}', parse error: ${K}`);return console.warn(`bad regexp-value '${R}', parse error: ${K}`),null}}}e.ContextKeyExpr=S;function k(x,R){const A=x?x.substituteConstants():void 0,F=R?R.substituteConstants():void 0;return!A&&!F?!0:!A||!F?!1:A.equals(F)}e.expressionsAreEqualWithConstantSubstitution=k;function N(x,R){return x.cmp(R)}class D{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class m{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class v{static create(R,A=null){const F=L.get(R);return typeof F=="boolean"?F?m.INSTANCE:D.INSTANCE:new v(R,A)}constructor(R,A){this.key=R,this.c=A,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:g(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?m.INSTANCE:D.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=b.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=v;class h{static create(R,A,F=null){if(typeof A=="boolean")return A?v.create(R,F):b.create(R,F);const $=L.get(R);return typeof $=="boolean"?A===($?"true":"false")?m.INSTANCE:D.INSTANCE:new h(R,A,F)}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=L.get(this.c);if(typeof R=="boolean"){const A=R?"true":"false";return this.d===A?m.INSTANCE:D.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class t{static create(R,A){return new t(R,A)}constructor(R,A){this.d=R,this.f=A,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:P(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const A=R.getValue(this.f),F=R.getValue(this.d);return Array.isArray(A)?A.includes(F):typeof F=="string"&&typeof A=="object"&&A!==null?C.call(A,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=t;class o{static create(R,A){return new o(R,A)}constructor(R,A){this.d=R,this.f=A,this.type=11,this.c=t.create(R,A)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class l{static create(R,A,F=null){if(typeof A=="boolean")return A?b.create(R,F):v.create(R,F);const $=L.get(R);return typeof $=="boolean"?A===($?"true":"false")?D.INSTANCE:m.INSTANCE:new l(R,A,F)}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=L.get(this.c);if(typeof R=="boolean"){const A=R?"true":"false";return this.d===A?D.INSTANCE:m.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class b{static create(R,A=null){const F=L.get(R);return typeof F=="boolean"?F?D.INSTANCE:m.INSTANCE:new b(R,A)}constructor(R,A){this.c=R,this.d=A,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:g(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=L.get(this.c);return typeof R=="boolean"?R?D.INSTANCE:m.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.ContextKeyNotExpr=b;function E(x,R){if(typeof x=="string"){const A=parseFloat(x);isNaN(A)||(x=A)}return typeof x=="string"||typeof x=="number"?R(x):D.INSTANCE}class p{static create(R,A,F=null){return E(A,$=>new p(R,$,F))}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=p;class w{static create(R,A,F=null){return E(A,$=>new w(R,$,F))}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class s{static create(R,A,F=null){return E(A,$=>new s(R,$,F))}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class r{static create(R,A,F=null){return E(A,$=>new r(R,$,F))}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class a{static create(R,A){return new a(R,A)}constructor(R,A){this.d=R,this.f=A,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const A=this.f?this.f.source:"",F=R.f?R.f.source:"";return A<F?-1:A>F?1:0}equals(R){if(R.type===this.type){const A=this.f?this.f.source:"",F=R.f?R.f.source:"";return this.d===R.d&&A===F}return!1}substituteConstants(){return this}evaluate(R){const A=R.getValue(this.d);return this.f?this.f.test(A):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=d.create(this)),this.c}}e.ContextKeyRegexExpr=a;class d{static create(R){return new d(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(R){return new d(this.c.map(R))}negate(){return this.c}}e.ContextKeyNotRegexExpr=d;function c(x){let R=null;for(let A=0,F=x.length;A<F;A++){const $=x[A].substituteConstants();if(x[A]!==$&&R===null){R=[];for(let z=0;z<A;z++)R[z]=x[z]}R!==null&&(R[A]=$)}return R===null?x:R}class u{static create(R,A,F){return u.d(R,A,F)}constructor(R,A){this.expr=R,this.c=A,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const $=N(this.expr[A],R.expr[A]);if($!==0)return $}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(R.expr[A]))return!1;return!0}return!1}substituteConstants(){const R=c(this.expr);return R===this.expr?this:u.create(R,this.c,!1)}evaluate(R){for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].evaluate(R))return!1;return!0}static d(R,A,F){const $=[];let z=!1;for(const V of R)if(!!V){if(V.type===1){z=!0;continue}if(V.type===0)return D.INSTANCE;if(V.type===6){$.push(...V.expr);continue}$.push(V)}if($.length===0&&z)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(N);for(let V=1;V<$.length;V++)$[V-1].equals($[V])&&($.splice(V,1),V--);if($.length===1)return $[0];for(;$.length>1;){const V=$[$.length-1];if(V.type!==9)break;$.pop();const K=$.pop(),ie=$.length===0,ge=n.create(V.expr.map(ce=>u.create([ce,K],null,F)),null,ie);ge&&($.push(ge),$.sort(N))}if($.length===1)return $[0];if(F){for(let V=0;V<$.length;V++)for(let K=V+1;K<$.length;K++)if($[V].negate().equals($[K]))return D.INSTANCE;if($.length===1)return $[0]}return new u($,A)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const A of this.expr)R.push(...A.keys());return R}map(R){return new u(this.expr.map(A=>A.map(R)),null)}negate(){if(!this.c){const R=[];for(const A of this.expr)R.push(A.negate());this.c=n.create(R,this,!0)}return this.c}}class n{static create(R,A,F){return n.d(R,A,F)}constructor(R,A){this.expr=R,this.c=A,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const $=N(this.expr[A],R.expr[A]);if($!==0)return $}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(R.expr[A]))return!1;return!0}return!1}substituteConstants(){const R=c(this.expr);return R===this.expr?this:n.create(R,this.c,!1)}evaluate(R){for(let A=0,F=this.expr.length;A<F;A++)if(this.expr[A].evaluate(R))return!0;return!1}static d(R,A,F){let $=[],z=!1;if(R){for(let V=0,K=R.length;V<K;V++){const ie=R[V];if(!!ie){if(ie.type===0){z=!0;continue}if(ie.type===1)return m.INSTANCE;if(ie.type===9){$=$.concat(ie.expr);continue}$.push(ie)}}if($.length===0&&z)return D.INSTANCE;$.sort(N)}if($.length!==0){if($.length===1)return $[0];for(let V=1;V<$.length;V++)$[V-1].equals($[V])&&($.splice(V,1),V--);if($.length===1)return $[0];if(F){for(let V=0;V<$.length;V++)for(let K=V+1;K<$.length;K++)if($[V].negate().equals($[K]))return m.INSTANCE;if($.length===1)return $[0]}return new n($,A)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const A of this.expr)R.push(...A.keys());return R}map(R){return new n(this.expr.map(A=>A.map(R)),null)}negate(){if(!this.c){const R=[];for(const A of this.expr)R.push(A.negate());for(;R.length>1;){const A=R.shift(),F=R.shift(),$=[];for(const z of J(A))for(const V of J(F))$.push(u.create([z,V],null,!1));R.unshift(n.create($,null,!1))}this.c=n.create(R,this,!0)}return this.c}}class f extends v{static all(){return f.d.values()}constructor(R,A,F){super(R,null),this.f=A,typeof F=="object"?f.d.push({...F,key:R}):F!==!0&&f.d.push({key:R,description:F,type:A!=null?typeof A:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return h.create(this.key,R)}notEqualsTo(R){return l.create(this.key,R)}}e.RawContextKey=f,f.d=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService");function g(x,R){return x<R?-1:x>R?1:0}function P(x,R,A,F){return x<A?-1:x>A?1:R<F?-1:R>F?1:0}function M(x,R){if(x.type===0||R.type===1)return!0;if(x.type===9)return R.type===9?q(x.expr,R.expr):!1;if(R.type===9){for(const A of R.expr)if(M(x,A))return!0;return!1}if(x.type===6){if(R.type===6)return q(R.expr,x.expr);for(const A of x.expr)if(M(A,R))return!0;return!1}return x.equals(R)}e.implies=M;function q(x,R){let A=0,F=0;for(;A<x.length&&F<R.length;){const $=x[A].cmp(R[F]);if($<0)return!1;$===0&&A++,F++}return A===x.length}function J(x){return x.type===9?x.expr:[x]}}),define(Ie[151],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[85],Ce([1,0,128,3]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function C(l,b){switch(l){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function O(l,b){return b==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=O;function S(l,b,E){return O(b,E)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===E?!0:k(E).includes(l)}e.isTargetPlatformCompatible=S;function k(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function N(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=N;var D;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var t;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(t=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(b,E){super(b),this.code=E,this.name=E}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[36],Ce([1,0,46,19,10,9,2,130,3]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var N;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(N=e.FileType||(e.FileType={}));var D;(function(z){z[z.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var m;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=v;function h(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=h;function t(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=t;function o(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function l(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=l;function b(z){return v(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var E;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(V,K){super(V),this.code=K}}e.FileSystemProviderError=p;function w(z,V){const K=new p(z.toString(),V);return r(K,V),K}e.createFileSystemProviderError=w;function s(z){return z||w((0,O.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=s;function r(z,V){return z.name=V?`${V} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=r;function a(z){if(!z)return E.Unknown;if(z instanceof p)return z.code;const V=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!V)return E.Unknown;switch(V[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=a;function d(z){if(z instanceof P)return z.fileOperationResult;switch(a(z)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=d;var c;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class u{constructor(V,K,ie){this.resource=V,this.operation=K,this.target=ie}isOperation(V){return this.operation===V}}e.FileOperationEvent=u;var n;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class f{constructor(V,K){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=V;const ie=new Map;for(const ge of V){const ce=ie.get(ge.type);switch(ce?ce.push([ge.resource,ge]):ie.set(ge.type,[[ge.resource,ge]]),ge.type){case 1:this.rawAdded.push(ge.resource);break;case 0:this.rawUpdated.push(ge.resource);break;case 2:this.rawDeleted.push(ge.resource);break}}for(const[ge,ce]of ie)switch(ge){case 1:this.a=i.TernarySearchTree.forUris(()=>K),this.a.fill(ce);break;case 0:this.b=i.TernarySearchTree.forUris(()=>K),this.b.fill(ce);break;case 2:this.c=i.TernarySearchTree.forUris(()=>K),this.c.fill(ce);break}}contains(V,...K){return this.d(V,{includeChildren:!1},...K)}affects(V,...K){return this.d(V,{includeChildren:!0},...K)}d(V,K,...ie){if(!V)return!1;const ge=ie.length>0;return!!((!ge||ie.includes(1))&&(this.a?.get(V)||K.includeChildren&&this.a?.findSuperstr(V))||(!ge||ie.includes(0))&&(this.b?.get(V)||K.includeChildren&&this.b?.findSuperstr(V))||(!ge||ie.includes(2))&&(this.c?.findSubstr(V)||K.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=f;function g(z,V,K){return!z||!V||z===V||V.length>z.length?!1:(V.charAt(V.length-1)!==T.sep&&(V+=T.sep),K?(0,y.startsWithIgnoreCase)(z,V):z.indexOf(V)===0)}e.isParent=g;class P extends Error{constructor(V,K,ie){super(V),this.fileOperationResult=K,this.options=ie}}e.FileOperationError=P;class M extends P{constructor(V,K,ie){super(V,2,ie),this.stat=K}}e.NotModifiedSinceFileOperationError=M;var q;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var J;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(J=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function x(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=x;async function R(z,V){if(!V.hasProvider(C.URI.from({scheme:z.scheme})))return new Promise(K=>{const ie=V.onDidChangeFileSystemProviderRegistrations(ge=>{ge.scheme===z.scheme&&ge.added&&(ie.dispose(),K())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class A{static formatSize(V){return(0,L.isNumber)(V)||(V=0),V<A.KB?(0,O.localize)(1,null,V.toFixed(0)):V<A.MB?(0,O.localize)(2,null,(V/A.KB).toFixed(2)):V<A.GB?(0,O.localize)(3,null,(V/A.MB).toFixed(2)):V<A.TB?(0,O.localize)(4,null,(V/A.GB).toFixed(2)):(0,O.localize)(5,null,(V/A.TB).toFixed(2))}}e.ByteSize=A,A.KB=1024,A.MB=A.KB*A.KB,A.GB=A.MB*A.KB,A.TB=A.GB*A.KB;var F;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(z){return{maxFileSize:z===0?300*A.MB:16*A.GB,maxHeapSize:z===0?700*A.MB:2*700*A.MB}}e.getPlatformLimits=$}),define(Ie[63],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...y){this.a=new Map;for(const[L,C]of y)this.set(L,C)}set(y,L){const C=this.a.get(y);return this.a.set(y,L),C}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.ServiceCollection=i}),define(Ie[152],Ce([1,0,14,11,7,84,150,3,63,153]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class D extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class m{constructor(o=new S.ServiceCollection,l=!1,b,E=N){this.f=o,this.g=l,this.h=b,this.i=E,this.o=new Set,this.f.set(O.IInstantiationService,this),this._globalGraph=E?b?._globalGraph??new C.Graph(p=>p):void 0}createChild(o){return new m(o,this.g,this,this.i)}invokeFunction(o,...l){const b=h.traceInvocation(this.i,o);let E=!1;try{return o({get:w=>{if(E)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(w,b);if(!s)throw new Error(`[invokeFunction] unknown service '${w}'`);return s}},...l)}finally{E=!0,b.stop()}}createInstance(o,...l){let b,E;return o instanceof L.SyncDescriptor?(b=h.traceCreation(this.i,o.ctor),E=this.j(o.ctor,o.staticArguments.concat(l),b)):(b=h.traceCreation(this.i,o),E=this.j(o,l,b)),b.stop(),E}j(o,l=[],b){const E=O._util.getServiceDependencies(o).sort((s,r)=>s.index-r.index),p=[];for(const s of E){const r=this.m(s.id,b);r||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${s.id}.`,!1),p.push(r)}const w=E.length>0?E[0].index:l.length;if(l.length!==w){console.trace(`[createInstance] First service dependency of ${o.name} at position ${w+1} conflicts with ${l.length} static arguments`);const s=w-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,w)}return Reflect.construct(o,l.concat(p))}k(o,l){if(this.f.get(o)instanceof L.SyncDescriptor)this.f.set(o,l);else if(this.h)this.h.k(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const l=this.f.get(o);return!l&&this.h?this.h.l(o):l}m(o,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const b=this.l(o);return b instanceof L.SyncDescriptor?this.q(o,b,l.branch(o,!0)):(l.branch(o,!1),b)}q(o,l,b){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,l,b)}finally{this.o.delete(o)}}r(o,l,b){const E=new C.Graph(s=>s.id.toString());let p=0;const w=[{id:o,desc:l,_trace:b}];for(;w.length;){const s=w.pop();if(E.lookupOrInsertNode(s),p++>1e3)throw new D(E);for(const r of O._util.getServiceDependencies(s.desc.ctor)){const a=this.l(r.id);if(a||this.u(`[createInstance] ${o} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(r.id)),a instanceof L.SyncDescriptor){const d={id:r.id,desc:a,_trace:s._trace.branch(r.id,!0)};E.insertEdge(s,d),w.push(d)}}}for(;;){const s=E.roots();if(s.length===0){if(!E.isEmpty())throw new D(E);break}for(const{data:r}of s){if(this.l(r.id)instanceof L.SyncDescriptor){const d=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,d)}E.removeNode(r)}}return this.l(o)}s(o,l,b=[],E,p){if(this.f.get(o)instanceof L.SyncDescriptor)return this.t(o,l,b,E,p);if(this.h)return this.h.s(o,l,b,E,p);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(o,l,b=[],E,p){if(E){const w=new m(void 0,this.g,this,this.i);w.c=String(o);const s=new Map,r=new i.IdleValue(()=>{const a=w.j(l,b,p);for(const[d,c]of s){const u=a[d];if(typeof u=="function")for(const n of c)u.apply(a,n)}return s.clear(),a});return new Proxy(Object.create(null),{get(a,d){if(!r.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let n=s.get(d);return n||(n=new k.LinkedList,s.set(d,n)),(g,P,M)=>{const q=n.push([g,P,M]);return(0,y.toDisposable)(q)}}if(d in a)return a[d];const c=r.value;let u=c[d];return typeof u!="function"||(u=u.bind(c),a[d]=u),u},set(a,d,c){return r.value[d]=c,!0},getPrototypeOf(a){return l.prototype}})}else return this.j(l,b,p)}u(o,l){if(l&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=m;var v;(function(t){t[t.None=0]="None",t[t.Creation=1]="Creation",t[t.Invocation=2]="Invocation",t[t.Branch=3]="Branch"})(v||(v={}));class h{static traceInvocation(o,l){return o?new h(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(o,l){return o?new h(1,l.name):h.c}constructor(o,l){this.type=o,this.name=l,this.g=Date.now(),this.h=[]}branch(o,l){const b=new h(3,o.toString());return this.h.push([o,l,b]),b}stop(){const o=Date.now()-this.g;h.f+=o;let l=!1;function b(p,w){const s=[],r=new Array(p+1).join("	");for(const[a,d,c]of w.h)if(d&&c){l=!0,s.push(`${r}CREATES -> ${a}`);const u=b(p+1,c);u&&s.push(u)}else s.push(`${r}uses -> ${a}`);return s.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(o>2||l)&&h.all.add(E.join(`
`))}}e.Trace=h,h.all=new Set,h.c=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}},h.f=0}),define(Ie[12],Ce([1,0,45,5,7,28,21,2,3]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function k(){return new Date().toISOString()}var N;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(N=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=N.Info;function D(u,n,f){switch(n){case N.Trace:u.trace(f);break;case N.Debug:u.debug(f);break;case N.Info:u.info(f);break;case N.Warning:u.warn(f);break;case N.Error:u.error(f);break;case N.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=D;function m(u){let n="";for(let f=0;f<u.length;f++){let g=u[f];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}n+=(f>0?" ":"")+g}return n}e.format=m;class v extends y.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==N.Off&&this.b<=n}}e.AbstractLogger=v;class h extends v{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...f){this.f(N.Trace)&&this.g(N.Trace,m([n,...f]))}debug(n,...f){this.f(N.Debug)&&this.g(N.Debug,m([n,...f]))}info(n,...f){this.f(N.Info)&&this.g(N.Info,m([n,...f]))}warn(n,...f){this.f(N.Warning)&&this.g(N.Warning,m([n,...f]))}error(n,...f){if(this.f(N.Error))if(n instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=n.stack,this.g(N.Error,m(g))}else this.g(N.Error,m([n,...f]))}flush(){}}e.AbstractMessageLogger=h;class t extends v{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!C.isWindows}trace(n,...f){this.f(N.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...f):console.log(`[main ${k()}]`,n,...f))}debug(n,...f){this.f(N.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...f):console.log(`[main ${k()}]`,n,...f))}info(n,...f){this.f(N.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...f):console.log(`[main ${k()}]`,n,...f))}warn(n,...f){this.f(N.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,n,...f):console.warn(`[main ${k()}]`,n,...f))}error(n,...f){this.f(N.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,n,...f):console.error(`[main ${k()}]`,n,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=t;class o extends v{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...f){this.f(N.Trace)&&console.log("%cTRACE","color: #888",n,...f)}debug(n,...f){this.f(N.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...f)}info(n,...f){this.f(N.Info)&&console.log("%c INFO","color: #33f",n,...f)}warn(n,...f){this.f(N.Warning)&&console.log("%c WARN","color: #993",n,...f)}error(n,...f){this.f(N.Error)&&console.log("%c  ERR","color: #f33",n,...f)}dispose(){}flush(){}}e.ConsoleLogger=o;class l extends v{constructor(n,f=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(f)}trace(n,...f){this.f(N.Trace)&&this.g.log(N.Trace,[this.h(n),...f])}debug(n,...f){this.f(N.Debug)&&this.g.log(N.Debug,[this.h(n),...f])}info(n,...f){this.f(N.Info)&&this.g.log(N.Info,[this.h(n),...f])}warn(n,...f){this.f(N.Warning)&&this.g.log(N.Warning,[this.h(n),...f])}error(n,...f){this.f(N.Error)&&this.g.log(N.Error,[this.h(n),...f])}h(n){return typeof n=="string"?n:(0,i.toErrorMessage)(n,this.f(N.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class b extends v{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const f of this.g)f.setLevel(n);super.setLevel(n)}trace(n,...f){for(const g of this.g)g.trace(n,...f)}debug(n,...f){for(const g of this.g)g.debug(n,...f)}info(n,...f){for(const g of this.g)g.info(n,...f)}warn(n,...f){for(const g of this.g)g.warn(n,...f)}error(n,...f){for(const g of this.g)g.error(n,...f)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=b;class E extends y.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...f){this.b.trace(n,...f)}debug(n,...f){this.b.debug(n,...f)}info(n,...f){this.b.info(n,...f)}warn(n,...f){this.b.warn(n,...f)}error(n,...f){this.b.error(n,...f)}flush(){this.b.flush()}}e.LogService=E;class p extends y.Disposable{constructor(n,f){super(),this.c=n,this.b=new L.ResourceMap,this.B(f(g=>this.setLevel(g)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,f,g){let P=this.b.get(n)?.logger;return P||(g=f?.always?N.Trace:g,P=this.f(n,g??this.c,f),this.b.set(n,{logger:P,logLevel:g})),P}setLevel(n,f){const g=O.URI.isUri(n)?n:void 0,P=g?f:n;if(g){const M=this.b.get(g);M&&M.logLevel!==P&&(M.logLevel=P,M.logger.setLevel(P))}else this.c=P,this.b.forEach(({logLevel:M,logger:q})=>{M===void 0&&q.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=p;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(n){}getLevel(){return N.Info}trace(n,...f){}debug(n,...f){}info(n,...f){}warn(n,...f){}error(n,...f){}critical(n,...f){}dispose(){}flush(){}}e.NullLogger=w;class s extends w{}e.NullLogService=s;class r extends p{constructor(){super(N.Info,T.Event.None)}f(n,f,g){return new w}}e.NullLoggerService=r;function a(u){if(u.verbose)return N.Trace;if(typeof u.logLevel=="string"){const n=c(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function d(u){switch(u){case N.Trace:return"trace";case N.Debug:return"debug";case N.Info:return"info";case N.Warning:return"warn";case N.Error:return"error";case N.Off:return"off"}}e.LogLevelToString=d;function c(u){switch(u){case"trace":return N.Trace;case"debug":return N.Debug;case"info":return N.Info;case"warn":return N.Warning;case"error":return N.Error;case"critical":return N.Error;case"off":return N.Off}}e.parseLogLevel=c}),define(Ie[86],Ce([1,0,29,131,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(h,t){return t-h}S.compare=k;const N=Object.create(null);N[S.Error]=(0,T.localize)(0,null),N[S.Warning]=(0,T.localize)(1,null),N[S.Info]=(0,T.localize)(2,null);function D(h){return N[h]||""}S.toString=D;function m(h){switch(h){case i.default.Error:return S.Error;case i.default.Warning:return S.Warning;case i.default.Info:return S.Info;case i.default.Ignore:return S.Hint}}S.fromSeverity=m;function v(h){switch(h){case S.Error:return i.default.Error;case S.Warning:return i.default.Warning;case S.Info:return i.default.Info;case S.Hint:return i.default.Ignore}}S.toSeverity=v}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var O;(function(S){const k="";function N(m){return D(m,!0)}S.makeKey=N;function D(m,v){const h=[k];return m.source?h.push(m.source.replace("\xA6","\\\xA6")):h.push(k),m.code?typeof m.code=="string"?h.push(m.code.replace("\xA6","\\\xA6")):h.push(m.code.value.replace("\xA6","\\\xA6")):h.push(k),m.severity!==void 0&&m.severity!==null?h.push(C.toString(m.severity)):h.push(k),m.message&&v?h.push(m.message.replace("\xA6","\\\xA6")):h.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?h.push(m.startLineNumber.toString()):h.push(k),m.startColumn!==void 0&&m.startColumn!==null?h.push(m.startColumn.toString()):h.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?h.push(m.endLineNumber.toString()):h.push(k),m.endColumn!==void 0&&m.endColumn!==null?h.push(m.endColumn.toString()):h.push(k),h.push(k),h.join("\xA6")}S.makeKeyOptionalMessage=D})(O=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(Ie[154],Ce([1,0,5,29,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,y.createDecorator)("notificationService");var L;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class O{constructor(){this.progress=new S,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=O;class S{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=S}),define(Ie[87],Ce([1,0,10,2,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function L(k,N){return T.URI.isUri(k)?(0,i.equalsIgnoreCase)(k.scheme,N):(0,i.startsWithIgnoreCase)(k,N+":")}e.matchesScheme=L;function C(k,...N){return N.some(D=>L(k,D))}e.matchesSomeScheme=C;function O(k,N){return k.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=O;function S(k){let N;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return D&&(N={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},k=k.with({fragment:""})),{selection:N,uri:k}}e.extractSelection=S}),define(Ie[155],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ee,e,i,T){var y=arguments.length,L=y<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,i):T,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ee,e,i,T);else for(var O=ee.length-1;O>=0;O--)(C=ee[O])&&(L=(y<3?C(L):y>3?C(e,i,L):C(e,i))||L);return y>3&&L&&Object.defineProperty(e,i,L),L},Ve=this&&this.__param||function(ee,e){return function(i,T){e(i,T,ee)}};define(Ie[156],Ce([1,0,14,20,7,3]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var C;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class O{get value(){return this.a}constructor(D){this.b=D}report(D){this.a=D,this.b(this.a)}}e.Progress=O,O.None=Object.freeze({report(){}});let S=class extends y.Disposable{constructor(D,m){super(),this.a=new i.DeferredPromise,m.withProgress(D,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,y.toDisposable)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};S=qe([Ve(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends y.Disposable{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new y.DisposableStore)}start(D){this.stop();const m=++this.a,v=new T.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,y.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,y.toDisposable)(()=>v.cancel())),this.b.add((0,y.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:v.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Ie[30],Ce([1,0,47,9]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.a=new Map}add(C,O){i.ok(T.isString(C)),i.ok(T.isObject(O)),i.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,O)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new y}),define(Ie[88],Ce([1,0,5,30]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class L{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,k){this.a[y(S)]=k,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new L;T.Registry.add(e.Extensions.JSONContribution,C)}),define(Ie[89],Ce([1,0,16,5,9,127,40,88,30]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=S.Registry.as(O.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const a=this.k(s,r);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(s){const r=this.l(s);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:s,remove:r}){const a=[];a.push(...this.l(r)),a.push(...this.k(s,!1)),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,i.distinct)(a)})}registerDefaultConfigurations(s){const r=[],a=[];for(const{overrides:d,source:c}of s)for(const u in d)if(r.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const n=this.a.get(u),f=n?.valuesSources??new Map;if(c)for(const q of Object.keys(d[u]))f.set(q,c);const g={...n?.value||{},...d[u]};this.a.set(u,{source:c,value:g,valuesSources:f});const P=(0,C.getLanguageTagSettingPlainKey)(u),M={type:"object",default:g,description:L.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:y.isString(c)?void 0:c,defaultValueSource:c};a.push(...t(u)),this.d[u]=M,this.b.properties[u]=M}else{this.a.set(u,{value:d[u],source:c});const n=this.d[u];n&&(this.s(u,n),this.o(u,n))}this.registerOverrideIdentifiers(a),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:a,source:d}of s)for(const c in a){const u=this.a.get(c),n=y.isString(d)?d:d?.id,f=y.isString(u?.source)?u?.source:u?.source?.id;if(n===f)if(r.push(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const g=this.d[c];g&&(this.s(c,g),this.o(c,g))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){for(const r of s)this.h.add(r);this.q()}k(s,r){const a=[];return s.forEach(d=>{a.push(...this.m(d,r,d.extensionInfo,d.restrictedProperties)),this.c.push(d),this.n(d)}),a}l(s){const r=[],a=d=>{if(d.properties)for(const c in d.properties){r.push(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.p(c,d.properties[c])}d.allOf?.forEach(c=>a(c))};for(const d of s){a(d);const c=this.c.indexOf(d);c!==-1&&this.c.splice(c,1)}return r}m(s,r=!0,a,d,c=3){c=y.isUndefinedOrNull(s.scope)?c:s.scope;const u=[],n=s.properties;if(n)for(const g in n){const P=n[g];if(r&&E(g,P)){delete n[g];continue}if(P.source=a,P.defaultDefaultValue=n[g].default,this.s(g,P),e.OVERRIDE_PROPERTY_REGEX.test(g)?P.scope=void 0:(P.scope=y.isUndefinedOrNull(P.scope)?c:P.scope,P.restricted=y.isUndefinedOrNull(P.restricted)?!!d?.includes(g):P.restricted),n[g].hasOwnProperty("included")&&!n[g].included){this.f[g]=n[g],delete n[g];continue}else this.d[g]=n[g],n[g].policy?.name&&this.e.set(n[g].policy.name,g);!n[g].deprecationMessage&&n[g].markdownDeprecationMessage&&(n[g].deprecationMessage=n[g].markdownDeprecationMessage),u.push(g)}const f=s.allOf;if(f)for(const g of f)u.push(...this.m(g,r,a,d,c));return u}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(s){const r=a=>{const d=a.properties;if(d)for(const u in d)this.o(u,d[u]);a.allOf?.forEach(r)};r(s)}o(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.g.properties[s]=r;break}}p(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}q(){for(const s of this.h.values()){const r=`[${s}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this.i.fire()}r(){const s={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}s(s,r){const a=this.a.get(s);let d=a?.value,c=a?.source;y.isUndefined(d)&&(d=r.defaultDefaultValue,c=void 0),y.isUndefined(d)&&(d=l(r.type)),r.default=d,r.defaultValueSource=c}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(w){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let r=h.exec(w);for(;r?.length;){const a=r[1].trim();a&&s.push(a),r=h.exec(w)}}return(0,i.distinct)(s)}e.overrideIdentifiersFromKey=t;function o(w){return w.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=o;function l(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const b=new m;S.Registry.add(e.Extensions.Configuration,b);function E(w,s){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?L.localize(7,null,w):b.getConfigurationProperties()[w]!==void 0?L.localize(8,null,w):s.policy?.name&&b.getPolicyConfigurations().get(s.policy?.name)!==void 0?L.localize(9,null,w,s.policy?.name,b.getPolicyConfigurations().get(s.policy?.name)):null:L.localize(6,null)}e.validateProperty=E;function p(){const w=[],s=b.getConfigurationProperties();for(const r of Object.keys(s))w.push([r,s[r].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=p}),define(Ie[157],Ce([1,0,16,5,108,7,28,23,9,2,40,89,30]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(r={},a=[],d=[],c){this.c=r,this.d=a,this.f=d,this.raw=c,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof v)return a;const d=new h("");return d.parseRaw(a),d.configurationModel});this.g=r.reduce((a,d)=>d===a?d:a.merge(d),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,N.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const d=this.rawConfiguration.getValue(r),c=a?this.rawConfiguration.getOverrideValue(r,a):void 0,u=a?this.rawConfiguration.override(a).getValue(r):d;return{value:d,override:c,merged:u}}getOverrideValue(r,a){const d=this.l(a);return d?r?(0,N.getConfigurationValue)(d,r):d:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const d of this.overrides)d.identifiers.includes(r)&&a.push(...d.keys);return i.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return i.distinct(r)}override(r){let a=this.b.get(r);return a||(a=this.h(r),this.b.set(r,a)),a}merge(...r){const a=O.deepClone(this.contents),d=O.deepClone(this.overrides),c=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const n of r)if(u.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(a,n.contents);for(const f of n.overrides){const[g]=d.filter(P=>i.equals(P.identifiers,f.identifiers));g?(this.j(g.contents,f.contents),g.keys.push(...f.keys),g.keys=i.distinct(g.keys)):d.push(O.deepClone(f))}for(const f of n.keys)c.indexOf(f)===-1&&c.push(f)}return new v(a,c,d,u.every(n=>n instanceof v)?void 0:u)}freeze(){return this.a=!0,this}clone(){return new v(O.deepClone(this.contents),[...this.keys],O.deepClone(this.overrides))}h(r){const a=this.l(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const d={};for(const c of i.distinct([...Object.keys(this.contents),...Object.keys(a)])){let u=this.contents[c];const n=a[c];n&&(typeof u=="object"&&typeof n=="object"?(u=O.deepClone(u),this.j(u,n)):u=n),d[c]=u}return new v(d,this.keys,this.overrides)}j(r,a){for(const d of Object.keys(a)){if(d in r&&S.isObject(r[d])&&S.isObject(a[d])){this.j(r[d],a[d]);continue}r[d]=O.deepClone(a[d])}}k(r){return this.a&&!Object.isFrozen(r)?O.deepFreeze(r):r}l(r){let a=null,d=null;const c=u=>{u&&(d?this.j(d,u):d=O.deepClone(u))};for(const u of this.overrides)i.equals(u.identifiers,[r])?a=u.contents:u.identifiers.includes(r)&&c(u.contents);return c(a),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,a){this.m(r),(0,N.addToValueTree)(this.contents,r,a,d=>{throw new Error(d)})}removeValue(r){this.n(r)&&(0,N.removeFromValueTree)(this.contents,r)}m(r){let a=this.keys.length;for(let d=0;d<a;d++)r.indexOf(this.keys[d])===0&&(a=d);this.keys.splice(a,1,r)}n(r){const a=this.keys.indexOf(r);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,a){if(!S.isUndefinedOrNull(r)){const d=this.g(r);this.parseRaw(d,a)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,a){this.a=r;const{contents:d,keys:c,overrides:u,restricted:n,hasExcludedProperties:f}=this.h(r,a);this.b=new v(d,c,u,f?[r]:void 0),this.c=n||[]}g(r){let a={},d=null,c=[];const u=[],n=[];function f(P){Array.isArray(c)?c.push(P):d!==null&&(c[d]=P)}const g={onObjectBegin:()=>{const P={};f(P),u.push(c),c=P,d=null},onObjectProperty:P=>{d=P},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const P=[];f(P),u.push(c),c=P,d=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:f,onError:(P,M,q)=>{n.push({error:P,offset:M,length:q})}};if(r)try{y.visit(r,g),a=c[0]||{}}catch(P){console.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return a}h(r,a){const d=m.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),c=this.j(r,d,!0,a);r=c.raw;const u=(0,N.toValuesTree)(r,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),n=Object.keys(r),f=this.l(r,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:u,keys:n,overrides:f,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(r,a,d,c){let u=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:u};const n={},f=[];for(const g in r)if(D.OVERRIDE_PROPERTY_REGEX.test(g)&&d){const P=this.j(r[g],a,!1,c);n[g]=P.raw,u=u||P.hasExcludedProperties,f.push(...P.restricted)}else{const P=a[g],M=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&f.push(g),(M===void 0||c.scopes===void 0||c.scopes.includes(M))&&!(c.skipRestricted&&P?.restricted)?n[g]=r[g]:u=!0}return{raw:n,restricted:f,hasExcludedProperties:u}}l(r,a){const d=[];for(const c of Object.keys(r))if(D.OVERRIDE_PROPERTY_REGEX.test(c)){const u={};for(const n in r[c])u[n]=r[c][n];d.push({identifiers:(0,D.overrideIdentifiersFromKey)(c),keys:Object.keys(u),contents:(0,N.toValuesTree)(u,a)})}return d}}e.ConfigurationModelParser=h;class t extends L.Disposable{constructor(r,a,d,c){super(),this.f=r,this.g=a,this.h=c,this.c=this.B(new T.Emitter),this.onDidChange=this.c.event,this.a=new h(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(d.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(T.Event.any(T.Event.filter(this.h.onDidFilesChange,u=>u.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&d.isEqual(u.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new v}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class o{constructor(r,a,d,c,u,n,f,g,P,M,q,J,x){this.a=r,this.b=a,this.value=d,this.overrideIdentifiers=c,this.c=u,this.d=n,this.f=f,this.g=g,this.h=P,this.j=M,this.k=q,this.l=J,this.m=x}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(r,a,d,c,u=new v,n=new v,f=new C.ResourceMap,g=new v,P=new C.ResourceMap,M=!0){this.c=r,this.d=a,this.f=d,this.g=c,this.h=u,this.j=n,this.l=f,this.m=g,this.n=P,this.p=M,this.a=null,this.b=new C.ResourceMap,this.q=null}getValue(r,a,d){return this.s(r,a,d).getValue(r)}updateValue(r,a,d={}){let c;d.resource?(c=this.n.get(d.resource),c||(c=new v,this.n.set(d.resource,c))):c=this.m,a===void 0?c.removeValue(r):c.setValue(r,a),d.resource||(this.a=null)}inspect(r,a,d){const c=this.s(r,a,d),u=i.distinct(c.overrides.map(g=>g.identifiers).flat()).filter(g=>c.getOverrideValue(r,g)!==void 0),n=this.w(a.resource,d),f=a.resource?this.n.get(a.resource)||this.m:this.m;return new o(r,a,c.getValue(r),u.length?u:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),d?this.j.freeze():void 0,n?n.freeze():void 0,f.inspect(r,a.overrideIdentifier))}keys(r){const a=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,a){this.l.set(r,a),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const d=[];if(!a){const{added:c,updated:u,removed:n}=p(this.c,r);a=[...c,...u,...n]}for(const c of a)for(const u of(0,D.overrideIdentifiersFromKey)(c)){const n=this.c.getKeysForOverrideIdentifier(u),f=r.getKeysForOverrideIdentifier(u),g=[...f.filter(P=>n.indexOf(P)===-1),...n.filter(P=>f.indexOf(P)===-1),...n.filter(P=>!O.equals(this.c.override(u).getValue(P),r.override(u).getValue(P)))];d.push([u,g])}return this.updateDefaultConfiguration(r),{keys:a,overrides:d}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:d,removed:c}=p(this.d,r),u=[...a,...d,...c];return u.length&&this.updatePolicyConfiguration(r),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=p(this.applicationConfiguration,r),n=[...a,...d,...c];return n.length&&this.updateApplicationConfiguration(r),{keys:n,overrides:u}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=p(this.localUserConfiguration,r),n=[...a,...d,...c];return n.length&&this.updateLocalUserConfiguration(r),{keys:n,overrides:u}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=p(this.remoteUserConfiguration,r),n=[...a,...d,...c];return n.length&&this.updateRemoteUserConfiguration(r),{keys:n,overrides:u}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=p(this.workspaceConfiguration,r),n=[...a,...d,...c];return n.length&&this.updateWorkspaceConfiguration(r),{keys:n,overrides:u}}compareAndUpdateFolderConfiguration(r,a){const d=this.r.get(r),{added:c,updated:u,removed:n,overrides:f}=p(d,a),g=[...c,...u,...n];return(g.length||!d)&&this.updateFolderConfiguration(r,a),{keys:g,overrides:f}}compareAndDeleteFolderConfiguration(r){const a=this.r.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:d,updated:c,removed:u,overrides:n}=p(a,void 0);return{keys:[...d,...c,...u],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,a,d){let c=this.t(a,d);return a.overrideIdentifier&&(c=c.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}t({resource:r},a){let d=this.u();if(a&&r){const c=a.getFolder(r);c&&(d=this.v(c.uri)||d);const u=this.n.get(r);u&&(d=d.merge(u))}return d}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let a=this.b.get(r);if(!a){const d=this.u(),c=this.l.get(r);c?(a=d.merge(c),this.p&&(a=a.freeze()),this.b.set(r,a)):a=d}return a}w(r,a){if(a&&r){const d=a.getFolder(r);if(d)return this.l.get(d.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,a)=>{const{contents:d,overrides:c,keys:u}=this.l.get(a);return r.push([a,{contents:d,overrides:c,keys:u}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(a=>r.add(a)),this.userConfiguration.freeze().keys.forEach(a=>r.add(a)),this.j.freeze().keys.forEach(a=>r.add(a)),this.l.forEach(a=>a.freeze().keys.forEach(d=>r.add(d))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.j.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.l.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(d=>r.add(d))),[...r.values()]}y(r){const a=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(d=>a.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(d=>a.add(d)),this.j.getKeysForOverrideIdentifier(r).forEach(d=>a.add(d)),this.l.forEach(d=>d.getKeysForOverrideIdentifier(r).forEach(c=>a.add(c))),[...a.values()]}static parse(r){const a=this.z(r.defaults),d=this.z(r.policy),c=this.z(r.application),u=this.z(r.user),n=this.z(r.workspace),f=r.folders.reduce((g,P)=>(g.set(k.URI.revive(P[0]),this.z(P[1])),g),new C.ResourceMap);return new l(a,d,c,u,new v,n,f,new v,new C.ResourceMap,!1)}static z(r){return new v(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,a=new Map;for(const c of s)c.keys.forEach(u=>r.add(u)),c.overrides.forEach(([u,n])=>{const f=(0,C.getOrSet)(a,u,new Set);n.forEach(g=>f.add(g))});const d=[];return a.forEach((c,u)=>d.push([u,[...c.values()]])),{keys:[...r.values()],overrides:d}}e.mergeChanges=b;class E{constructor(r,a,d,c){this.change=r,this.b=a,this.c=d,this.d=c,this.f=void 0;const u=new Set;r.keys.forEach(f=>u.add(f)),r.overrides.forEach(([,f])=>f.forEach(g=>u.add(g))),this.affectedKeys=[...u.values()];const n=new v;this.affectedKeys.forEach(f=>n.setValue(f,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(r,a){if(this.g(this.a,r)){if(a){const d=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.b?.workspace):void 0,c=this.c.getValue(r,a,this.d);return!O.equals(d,c)}return!0}return!1}g(r,a){let d=(0,N.toValuesTree)({[a]:!0},()=>{}),c;for(;typeof d=="object"&&(c=Object.keys(d)[0]);){if(r=r[c],!r)return!1;d=d[c]}return!0}}e.ConfigurationChangeEvent=E;function p(s,r){const{added:a,removed:d,updated:c}=w(r?.rawConfiguration,s?.rawConfiguration),u=[],n=s?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const g=f.filter(P=>!n.includes(P));for(const P of g)u.push([P,r.getKeysForOverrideIdentifier(P)])}if(s){const g=n.filter(P=>!f.includes(P));for(const P of g)u.push([P,s.getKeysForOverrideIdentifier(P)])}if(r&&s){for(const g of n)if(f.includes(g)){const P=w({contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)},{contents:r.getOverrideValue(void 0,g)||{},keys:r.getKeysForOverrideIdentifier(g)});u.push([g,[...P.added,...P.removed,...P.updated]])}}return{added:a,removed:d,updated:c,overrides:u}}function w(s,r){const a=s?r?s.keys.filter(u=>r.keys.indexOf(u)===-1):[...s.keys]:[],d=r?s?r.keys.filter(u=>s.keys.indexOf(u)===-1):[...r.keys]:[],c=[];if(s&&r){for(const u of r.keys)if(s.keys.indexOf(u)!==-1){const n=(0,N.getConfigurationValue)(r.contents,u),f=(0,N.getConfigurationValue)(s.contents,u);O.equals(n,f)||c.push(u)}}return{added:a,removed:d,updated:c}}}),define(Ie[90],Ce([1,0,11,3]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var y;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends i.ErrorNoTelemetry{static isNotAvailable(O){return O instanceof L&&O._code===y.NotAvailable}static isTemporarilyNotAvailable(O){return O instanceof L&&O._code===y.TemporarilyNotAvailable}static isNoResolverFound(O){return O instanceof L&&O._code===y.NoResolverFound}static isHandled(O){return O instanceof L&&O.isHandled}constructor(O,S=y.Unknown,k){super(O),this._message=O,this._code=S,this._detail=k,this.isHandled=S===y.NotAvailable&&k===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(Ie[48],Ce([1,0,13]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=T;function y(k){if(!k)return;const N=k.indexOf("+");return N<0?k:k.substr(0,N)}e.getRemoteName=y;function L(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=L;function C(k){const{host:N,port:D}=S(k);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:D}}e.parseAuthorityWithPort=C;function O(k,N){let{host:D,port:m}=S(k);return typeof m>"u"&&(m=N),{host:D,port:m}}e.parseAuthorityWithOptionalPort=O;function S(k){const N=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const D=k.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(Ie[26],Ce([1,0,10,3,48]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=L;function C(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));var S;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,o){if(typeof t>"u"||t===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof t=="string"||typeof o=="string"){const l=typeof t=="string"?t:t.value,b=typeof o=="string"?o:o.value;return i.equalsIgnoreCase(l,b)}return t.c===o.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=k;function N(h){return D(h)}e.isApplicationScopedExtension=N;function D(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function m(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function v(h,t){if(t){const o=`onResolveRemoteAuthority:${(0,y.getRemoteName)(t)}`;return h.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[158],Ce([1,0,10,85,26,21,2,11,49]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,i.compareIgnoreCase)(r.id,a.id)===0}e.areSameExtensions=k;const N=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class D{static create(a){const d=a.manifest?a.manifest.version:a.version,c=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new D(a.identifier,d,c)}static parse(a){const d=N.exec(a);return d&&d[1]&&d[2]?new D({id:d[1]},d[2],d[4]||void 0):null}constructor(a,d,c="undefined"){this.version=d,this.targetPlatform=c,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof D?k(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=D;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const a=m.exec(r);return a&&a[1]?[t(a[1]),a[2]]:[t(r),void 0]}e.getIdAndVersion=v;function h(r,a){return`${r}.${a}`}e.getExtensionId=h;function t(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function o(r,a){return t(h(r,a))}e.getGalleryExtensionId=o;function l(r,a){const d=[],c=u=>{for(const n of d)if(n.some(f=>k(a(f),a(u))))return n;return null};for(const u of r){const n=c(u);n?n.push(u):d.push([u])}return d}e.groupByExtension=l;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function E(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function p(r,a){const d=[],c=a.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const u=c.shift();if(u&&d.every(n=>!k(n.identifier,{id:u}))){const n=r.filter(f=>k(f.identifier,{id:u}));n.length===1&&(d.push(n[0]),c.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=p;async function w(r,a){if(!L.isLinux)return!1;let d;try{d=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){a.debug("Error while getting the os-release file.",(0,O.getErrorMessage)(u))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=w;async function s(r,a){const d=await w(r,a),c=(0,T.getTargetPlatform)(d?"alpine":L.platform,S.arch);return a.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=s}),define(Ie[159],Ce([1,0,21,49,2,34]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function O(k,N,D,m,v,h,t,o,l,b){const E=Object.create(null);E["common.machineId"]=t,E.sessionID=(0,L.generateUuid)()+Date.now(),E.commitHash=v,E.version=h,E["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,i.PlatformToString)(i.platform),E["common.nodePlatform"]=T.platform,E["common.nodeArch"]=m,E["common.product"]=b||"desktop",o&&(E["common.msftInternal"]=o);let p=0;const w=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),i.isLinuxSnap&&(E["common.snap"]="true");const s=C(D);s&&(E["common.platformDetail"]=s);try{const r=await k.readFile(y.URI.file(l));E["common.source"]=r.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=O;function S(k){const N=T.env.USERDNSDOMAIN;if(!N)return!1;const D=N.toLowerCase();return k.some(m=>D===m)}e.verifyMicrosoftInternalDomain=S}),define(Ie[160],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[91],Ce([1,0,23,9,40,48,159,160]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(u){this.value=u}}e.TrustedTelemetryValue=S;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(u,n){return Promise.resolve(void 0)}publicLog2(u,n){return this.publicLog(u,n)}publicLogError(u,n){return Promise.resolve(void 0)}publicLogError2(u,n){return this.publicLogError(u,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class N{async publicLog(u,n,f){}async publicLogError(u,n,f){}}e.NullEndpointTelemetryService=N,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(c,u){return u.onDidChangeConfiguration(n=>{n.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,y.ConfigurationTargetToString)(n.source),configurationKeys:E(n.sourceConfig)})})}e.configurationTelemetry=D;function m(c,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!c.enableTelemetry||u.extensionTestsLocationURI)}e.supportsTelemetry=m;function v(c,u){return!(u.isBuilt||u.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=v;function h(c){const u=c.getValue(O.TELEMETRY_SETTING_ID),n=c.getValue("telemetry.enableCrashReporter");if(c.getValue(O.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=h;function t(c){const u={},n={},f={};b(c,f);for(let g in f){g=g.length>150?g.substr(g.length-149):g;const P=f[g];typeof P=="number"?n[g]=P:typeof P=="boolean"?n[g]=P?1:0:typeof P=="string"?(P.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${P.length}`),u[g]=P.substring(0,8191)):typeof P<"u"&&P!==null&&(u[g]=P)}return{properties:u,measurements:n}}e.validateTelemetryData=t;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(c){if(!c)return"none";const u=(0,L.getRemoteName)(c);return o.has(u)?u:"other"}e.cleanRemoteAuthority=l;function b(c,u,n=0,f){if(!!c)for(const g of Object.getOwnPropertyNames(c)){const P=c[g],M=f?f+g:g;Array.isArray(P)?u[M]=(0,i.safeStringify)(P):P instanceof Date?u[M]=P.toISOString():(0,T.isObject)(P)?n<2?b(P,u,n+1,M+"."):u[M]=(0,i.safeStringify)(P):u[M]=P}}function E(c){if(!c)return[];const u=[];return p(u,"",c),u}function p(c,u,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(f=>p(c,u?`${u}.${f}`:f,n[f])):c.push(u)}function w(c,u){const n=c.msftInternalDomains||[],f=u.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(n)||f}e.isInternalTelemetry=w;function s(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=s;function r(c,u){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let n=c;const f=[];for(const q of u)for(;;){const J=q.exec(c);if(!J)break;f.push([J.index,q.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,P=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(n="";;){const q=P.exec(c);if(!q)break;const J=f.some(([x,R])=>q.index<R&&x<P.lastIndex);!g.test(q[0])&&!J&&(n+=c.substring(M,q.index)+"<REDACTED: user-file-path>",M=P.lastIndex)}return M<c.length&&(n+=c.substr(M)),n}function a(c){if(!c)return c;const u=c.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of n)if(f.regex.test(u))return`<REDACTED: ${f.label}>`;return c}function d(c,u){return(0,i.cloneAndChange)(c,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let f=n.replaceAll("%20"," ");f=r(f,u);for(const g of u)f=f.replace(g,"");return f=a(f),f}})}e.cleanData=d}),define(Ie[161],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(y){this.b=y,this.a=new Map}dispose(){for(const y of this.a.values())y.dispose()}startBuffering(y,L,C=5){const O=L(S=>{const k=typeof S=="string"?S:S.data;let N=this.a.get(y);if(N){N.data.push(k);return}const D=setTimeout(()=>this.flushBuffer(y),C);N={data:[k],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(y),O.dispose()}},this.a.set(y,N)});return O}stopBuffering(y){this.a.get(y)?.dispose()}flushBuffer(y){const L=this.a.get(y);L&&(this.a.delete(y),this.b(y,L.data.join("")))}}e.TerminalDataBufferer=i}),define(Ie[162],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function T(L){return L===i.HIGH_CONTRAST_DARK||L===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=T;function y(L){return L===i.DARK||L===i.HIGH_CONTRAST_DARK}e.isDark=y}),define(Ie[64],Ce([1,0,120,5,7,3,30,162]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var S;(function(o){function l(b){return b&&typeof b=="object"&&typeof b.id=="string"}o.isThemeColor=l})(S=e.ThemeColor||(e.ThemeColor={}));function k(o){return{id:o}}e.themeColorFromId=k;var N;(function(o){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||S.isThemeColor(d.color))}o.isThemeIcon=l;const b=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function E(d){const c=b.exec(d);if(!c)return;const[,u]=c;return{id:u}}o.fromString=E;function p(d){return{id:d}}o.fromId=p;function w(d,c){let u=d.id;const n=u.lastIndexOf("~");return n!==-1&&(u=u.substring(0,n)),c&&(u=`${u}~${c}`),{id:u}}o.modify=w;function s(d){const c=d.id.lastIndexOf("~");if(c!==-1)return d.id.substring(c+1)}o.getModifier=s;function r(d,c){return d.id===c.id&&d.color?.id===c.color?.id}o.isEqual=r;function a(d,c){return{id:d.id,color:c?k(c):void 0}}o.asThemeIcon=a,o.asClassNameArray=i.CSSIcon.asClassNameArray,o.asClassName=i.CSSIcon.asClassName,o.asCSSSelector=i.CSSIcon.asCSSSelector})(N=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function D(o){switch(o){case O.ColorScheme.DARK:return"vs-dark";case O.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case O.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.a=[],this.a=[],this.b=new T.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,y.toDisposable)(()=>{const b=this.a.indexOf(l);this.a.splice(b,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const v=new m;C.Registry.add(e.Extensions.ThemingContribution,v);function h(o){return v.onColorThemeChange(o)}e.registerThemingParticipant=h;class t extends y.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(b=>this.n(b)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,b){let E=this.h.getColor(l);return E&&b&&(E=b(E,this.h)),E?E.toString():null}}e.Themable=t}),define(Ie[163],Ce([1,0,5,40,3,12]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var C;(function(t){t.Http="http",t.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var O;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(O=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=D;function m(t,o,l,b){if(l===1)return!1;if(l===2&&D(o)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.isPortPrivileged=m;class v{constructor(o,l,b){this.remoteAddress=o,this.localAddress=l,this.b=b,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=v;let h=class{constructor(o,l){this.i=o,this.j=l,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],l=Array.from(this.d.values());for(const b of l){const E=Array.from(b.values());for(const p of E){const w=await p.value;w&&o.push(w)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:l}of o.values())await l.then(b=>b?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,l,b,E,p){this.o(o,l,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:l,localAddress:b,privacy:E,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,l){(D(o)||N(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const b=this.q(o,l);if(b)return++b.refcount,b.value}openTunnel(o,l,b,E,p=!1,w,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${b} on local port ${E}.`),!o)return;if(l||(l="localhost"),this.e&&this.h.has(b)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(o,l,b,E,p,w,s);return r?r.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,b);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.m(a);return(a.tunnelRemoteHost!==l||a.tunnelRemotePort!==b)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(d),d}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const l=this.d.get(o.tunnelRemoteHost);if(l){const b=l.get(o.tunnelRemotePort);b&&(b.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,b))}}}}async n(o,l,b){if(b.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${l}.`);const E=b.value.then(async p=>{p&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(l),E}}async closeTunnel(o,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${l} `);const b=this.d.get(o);if(b&&b.has(l)){const E=b.get(l);E.refcount=0,await this.n(o,l,E)}}o(o,l,b){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(l,{refcount:1,value:b})}async p(o,l){const b=this.d.get(o);b&&(await b.get(l)||b.delete(l),b.size===0&&this.d.delete(o))}q(o,l){const b=[o];N(o)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):D(o)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const E=b.map(p=>this.d.get(p));for(const p of E){const w=p?.get(l);if(w)return w}}canTunnel(o){return!!k(o)}s(o,l,b,E,p,w,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${b} on local port ${E}.`);const r=b;this.h.add(r);const a=E===void 0?b:E,d={elevationRequired:p?this.isPortPrivileged(a):!1},c={remoteAddress:{host:l,port:b},localAddressPort:E,privacy:w,public:w?w!==O.Private:void 0,protocol:s},u=o.forwardPort(c,d);return u?(this.o(l,b,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),u}};h=qe([Ve(0,L.ILogService),Ve(1,T.IConfigurationService)],h),e.AbstractTunnelService=h}),define(Ie[164],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var T;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(T=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[165],Ce([1,0,13]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(S){return S.scheme!==i.Schemas.file&&S.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=T;function y(S){if(S.folders.length)return S.folders.every(k=>T(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function L(S){return y(S)?.scheme}e.getVirtualWorkspaceScheme=L;function C(S){return y(S)?.authority}e.getVirtualWorkspaceAuthority=C;function O(S){return y(S)!==void 0}e.isVirtualWorkspace=O}),define(Ie[50],Ce([1,0,132,19,46,22,2,3,13]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,O.createDecorator)("contextService");function k(r){const a=r;return typeof a?.id=="string"&&C.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function N(r,a){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,T.basename)(r)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const d=r;if(d.configuration)return{id:d.id,configPath:d.configuration};if(d.folders.length===1)return{id:d.id,uri:d.folders[0].uri}}e.toWorkspaceIdentifier=N;function D(r){const a=r;return typeof a?.id=="string"&&C.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=D;function m(r){const a=r;if(a?.uri)return{id:a.id,uri:C.URI.revive(a.uri)};const d=r;if(d?.configPath)return{id:d.id,configPath:C.URI.revive(d.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=m;var v;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=h;function t(r){const a=r;return!!(a&&typeof a=="object"&&C.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=t;class o{constructor(a,d,c,u,n){this.h=a,this.j=c,this.k=u,this.l=n,this.c=y.TernarySearchTree.forUris(this.l,()=>!0),this.folders=d}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=y.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class l{constructor(a,d){this.raw=d,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,L.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function b(r){return new l({uri:r,index:0,name:(0,L.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(r,a){return L.extUriBiasedIgnorePathCase.isEqualOrParent(r,a.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function p(r){let a;return C.URI.isUri(r)?a=r:a=r.configuration,a?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=p;function w(r,a){return!E(r,a)&&!p(r)}e.isSavedWorkspace=w;function s(r){return(typeof r=="string"?(0,T.extname)(r):(0,L.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Ie[51],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(y){this.d=y,this.b=new Map,this.c=1}add(y){const L=this.c++;return this.b.set(L,y),this.e(),L}get(y,L){return this.b.has(y)?this.b.get(y)[L]:void 0}delete(y){this.b.delete(y),this.e()}e(){!i.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=i,i.a=!1}),define(Ie[37],Ce([1,0,13,22,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new T.ExtUri(O=>{const S=this.b.get(O.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(O,S){S===null?this.b.delete(O.scheme):this.b.set(O.scheme,S)}isFreeScheme(O){return!this.b.has(O)&&!this.a.has(O)}getCapabilities(O){return this.b.get(O)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(Ie[166],Ce([1,0,14]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(C,O,S){this.h=new Map,this.a=C,this.b=O,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new i.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of k.values())N.complete()}catch(N){for(const D of k.values())D.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,O){let S=this.f[C];return typeof S>"u"&&(S=O),S}update(C,O){this.f[C]=O;const S=this.h.get(C);if(S!==void 0)return S.p;const k=new i.DeferredPromise;return this.h.set(C,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=T;class y extends T{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,O){super(C.identifier.value,!0,O),this.j=C}}e.ExtensionGlobalMemento=y}),define(Ie[167],Ce([1,0,5,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(C){this.c=C,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,O,S,k){const D=this.c.getNotebookDocument(T.URI.revive(C)).acceptModelChanged(O.value,S,k);this.b.fire(D)}$acceptDirtyStateChanged(C,O){this.c.getNotebookDocument(T.URI.revive(C)).acceptDirty(O)}$acceptModelSaved(C){const O=this.c.getNotebookDocument(T.URI.revive(C));this.a.fire(O.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(Ie[15],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=T});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[168],Ce([1,0,26,5]),function(ee,e,i,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(O,S){y.set(this,void 0),this.b=new T.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(O.identifier),Ye(this,y,S,"f"),Re(this,y,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(O){return Re(this,y,"f").get(this.a,O)}store(O,S){return Re(this,y,"f").store(this.a,O,S)}delete(O){return Re(this,y,"f").delete(this.a,O)}}e.ExtensionSecrets=L,y=new WeakMap}),define(Ie[65],Ce([1,0,3,163,5,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function k(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:D.protocol}}S.fromApiTunnel=k;function N(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==T.TunnelPrivacyId.ConstantPrivate&&D.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}S.fromServiceTunnel=N})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let O=class{constructor(k){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,N){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,N){return{dispose:()=>{}}}async $providePortAttributes(k,N,D,m,v){return[]}async $forwardPort(k,N){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};O=qe([Ve(0,L.IExtHostRpcService)],O),e.ExtHostTunnelService=O}),define(Ie[52],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=T}),define(Ie[169],Ce([1,0,24]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function y(O,S){if(S.serializeBuffersForPostMessage){const k=new T,N=(v,h)=>{if(h instanceof ArrayBuffer){const t=k.add(h);return{$$vscode_array_buffer_reference$$:!0,index:t}}else if(ArrayBuffer.isView(h)){const t=L(h);if(t){const o=k.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:t,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},D=JSON.stringify(O,N),m=k.buffers.map(v=>{const h=new Uint8Array(v);return i.VSBuffer.wrap(h)});return{message:D,buffers:m}}else return{message:JSON.stringify(O),buffers:[]}}e.serializeWebviewMessage=y;function L(O){switch(O.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(O,S){const k=S.map(m=>{const v=new ArrayBuffer(m.byteLength);return new Uint8Array(v).set(m.buffer),v}),N=S.length?(m,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const h=v,{index:t}=h,o=k[t];if(h.view)switch(h.view.type){case 1:return new Int8Array(o,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(O,N),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(Ie[92],Ce([1,0,140,9,2,7,3,30,36,13]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var N;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(N=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var D;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(D=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(K){const ie=K;return!!ie&&typeof ie.getSelection=="function"&&!!ie.onDidChangeSelection}e.isEditorPaneWithSelection=m;function v(K,ie,ge){for(const ce of ge.visibleEditorPanes)if(ce.group.id===ie&&K.matches(ce.input))return ce.getViewState()}e.findViewStateForEditor=v;function h(K){if(c(K))return!1;const ie=K;return y.URI.isUri(ie?.resource)}e.isResourceEditorInput=h;function t(K){if(c(K))return!1;const ie=K;return ie?.original!==void 0&&ie.modified!==void 0}e.isResourceDiffEditorInput=t;function o(K){if(c(K)||t(K))return!1;const ie=K;return ie?.primary!==void 0&&ie.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function l(K){if(c(K))return!1;const ie=K;return ie?ie.resource===void 0||ie.resource.scheme===k.Schemas.untitled||ie.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;const b=/Untitled-\d+/;function E(K){return K.scheme===k.Schemas.untitled&&K.path.length>1&&!b.test(K.path)}e.isUntitledWithAssociatedResource=E;function p(K){if(c(K))return!1;const ie=K;return y.URI.isUri(ie?.base?.resource)&&y.URI.isUri(ie?.input1?.resource)&&y.URI.isUri(ie?.input2?.resource)&&y.URI.isUri(ie?.result?.resource)}e.isResourceMergeEditorInput=p;var w;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var s;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.a=new Map}registerSource(ie,ge){let ce=this.a.get(ie);return ce||(ce={source:ie,label:ge},this.a.set(ie,ce)),ce.source}getSourceLabel(ie){return this.a.get(ie)?.label??ie}}e.SaveSourceRegistry=new r;var a;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends L.Disposable{}e.AbstractEditorInput=d;function c(K){return K instanceof d}e.isEditorInput=c;function u(K){const ie=K;return y.URI.isUri(ie?.preferredResource)}function n(K){const ie=K;return c(ie?.primary)&&c(ie?.secondary)}e.isSideBySideEditorInput=n;function f(K){const ie=K;return c(ie?.modified)&&c(ie?.original)}e.isDiffEditorInput=f;function g(K){return c(K?.editor)}e.isEditorInputWithOptions=g;function P(K){const ie=K;return g(K)&&ie?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function M(K){const ie=K;return typeof ie?.groupId=="number"&&c(ie.editor)}e.isEditorIdentifier=M;var q;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(q=e.EditorCloseContext||(e.EditorCloseContext={}));var J;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(J=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class R{getOriginalUri(ie,ge){if(!ie)return;if(p(ie))return e.EditorResourceAccessor.getOriginalUri(ie.result,ge);if(ge?.supportSideBySide){const{primary:re,secondary:se}=this.a(ie);if(re&&se){if(ge?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(re,{filterByScheme:ge.filterByScheme}),secondary:this.getOriginalUri(se,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===x.ANY)return this.getOriginalUri(re,{filterByScheme:ge.filterByScheme})??this.getOriginalUri(se,{filterByScheme:ge.filterByScheme});ie=ge.supportSideBySide===x.PRIMARY?re:se}}if(t(ie)||o(ie)||p(ie))return;const ce=u(ie)?ie.preferredResource:ie.resource;return!ce||!ge||!ge.filterByScheme?ce:this.b(ce,ge.filterByScheme)}a(ie){return n(ie)||o(ie)?{primary:ie.primary,secondary:ie.secondary}:f(ie)||t(ie)?{primary:ie.modified,secondary:ie.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ie,ge){if(!ie)return;if(p(ie))return e.EditorResourceAccessor.getCanonicalUri(ie.result,ge);if(ge?.supportSideBySide){const{primary:re,secondary:se}=this.a(ie);if(re&&se){if(ge?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(re,{filterByScheme:ge.filterByScheme}),secondary:this.getCanonicalUri(se,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===x.ANY)return this.getCanonicalUri(re,{filterByScheme:ge.filterByScheme})??this.getCanonicalUri(se,{filterByScheme:ge.filterByScheme});ie=ge.supportSideBySide===x.PRIMARY?re:se}}if(t(ie)||o(ie)||p(ie))return;const ce=ie.resource;return!ce||!ge||!ge.filterByScheme?ce:this.b(ce,ge.filterByScheme)}b(ie,ge){if(Array.isArray(ge)){if(ge.some(ce=>ie.scheme===ce))return ie}else if(ge===ie.scheme)return ie}}e.EditorResourceAccessor=new R;var A;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(A=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(ie){const ge=this.a=ie.get(C.IInstantiationService);for(const[ce,re]of this.c)this.e(ce,re,ge);this.c.clear()}e(ie,ge,ce){const re=ce.createInstance(ge);this.d.set(ie,re)}registerFileEditorFactory(ie){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ie}getFileEditorFactory(){return(0,T.assertIsDefined)(this.b)}registerEditorSerializer(ie,ge){if(this.c.has(ie)||this.d.has(ie))throw new Error(`A editor serializer with type ID '${ie}' was already registered.`);return this.a?this.e(ie,ge,this.a):this.c.set(ie,ge),(0,L.toDisposable)(()=>{this.c.delete(ie),this.d.delete(ie)})}getEditorSerializer(ie){return this.d.get(typeof ie=="string"?ie:ie.typeId)}}O.Registry.add(e.EditorExtensions.EditorFactory,new F);async function $(K,ie,ge){return!K||!K.length?[]:await Promise.all(K.map(async ce=>{const re=y.URI.revive(ce.fileUri);if(!re){ge.info("Cannot resolve the path because it is not valid.",ce);return}if(!await ie.canHandleResource(re)){ge.info("Cannot resolve the path because it cannot be handled",ce);return}let le=ce.exists,_=ce.type;if(typeof le!="boolean"||typeof _!="number")try{_=(await ie.stat(re)).isDirectory?S.FileType.Directory:S.FileType.Unknown,le=!0}catch(we){ge.error(we),le=!1}if(!le&&ce.openOnlyIfExists){ge.info("Cannot resolve the path because it does not exist",ce);return}if(_===S.FileType.Directory){ge.info("Cannot resolve the path because it is a directory",ce);return}const me={...ce.options,pinned:!0};return le?{resource:re,options:me}:{resource:re,options:me,forceUntitled:!0}}))}e.pathsToEditors=$;var z;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function V(K){const ie=K;if(!ie)return!1;const ge=ie;if(ge.modified)return V(ge.modified);const ce=ie;return!!(ce.contributionsState&&ce.viewState&&Array.isArray(ce.cursorState))}e.isTextEditorViewState=V}),define(Ie[170],Ce([1,0,5,14,141]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(O){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=O}onEvent(O){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=O}onRequest(O){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.s("response",O)}sendRequest(O,S,k,N){const D={command:O};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.s("request",D),typeof N=="number"){const m=setTimeout(()=>{clearTimeout(m);const v=this.f.get(D.seq);if(v){this.f.delete(D.seq);const h={type:"response",seq:0,request_seq:D.seq,success:!1,command:O,message:(0,y.localize)(0,null,N,O)};v(h)}},N)}return k&&this.f.set(D.seq,k),D.seq}acceptMessage(O){this.j?this.j(O):(this.k.push(O),this.k.length===1&&this.q())}o(O,S){return O.type!=="event"||S.type!=="event"}async q(){let O;for(;this.k.length;){if((!O||this.o(this.k[0],O))&&await(0,T.timeout)(0),O=this.k.shift(),!O)return;switch(O.type){case"event":this.i?.(O);break;case"request":this.g?.(O);break;case"response":{const S=O,k=this.f.get(S.request_seq);k&&(this.f.delete(S.request_seq),k(S));break}}}}s(O,S){S.type=O,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((S,k)=>O.set(k,S)),await(0,T.timeout)(500),O.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(Ie[171],Ce([1,0,142,41,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(49,null)});const L=m=>i.localize(50,null,m);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(51,null)};var C;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(C=e.State||(e.State={}));function O(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=O;var S;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,y.createDecorator)("debugService");var D;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(D=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[172],Ce([1,0,10,2,19,23,13]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function S(a,d,c){return a.replace(O,function(u,n){return d&&n.length>0&&n[0]!=="_"?u:c&&c.hasOwnProperty(n)?c[n]:u})}e.formatPII=S;function k(a){const d={};for(const c of Object.keys(a))c.startsWith("!")||(d[c]=a[c]);return d}e.filterExceptionsFromTelemetry=k;function N(a){return a.configuration.request==="attach"&&!D(a)&&(!a.parentSession||N(a.parentSession))}e.isSessionAttach=N;function D(a){let d=a.configuration.type;if(!!d)return d==="vslsShare"&&(d=a.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(d,"extensionhost")||(0,i.equalsIgnoreCase)(d,"pwa-extensionhost")?a:a.parentSession?D(a.parentSession):void 0}e.getExtensionHostDebugSession=D;function m(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=m;function v(a,d,c){let u,n=0;const f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=f.exec(a);){const P=g.index+1,M=P+g[0].length;if(P<=d&&M>=c){u=g[0],n=P;break}}if(u){const P=/\w+/g;let M=null;for(;(M=P.exec(u))&&!(M.index+1+n+M[0].length>=c););M&&(u=u.substring(0,P.lastIndex))}return u?{start:n,end:n+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=v;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(a){return!!(a&&a.match(h))}e.isUri=t;function o(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(t(a.path))return T.URI.parse(a.path);if((0,y.isAbsolute)(a.path))return T.URI.file(a.path)}return a.path}function l(a){if(typeof a.path=="object"){const d=T.URI.revive(a.path);if(d)return d.scheme===C.Schemas.file?d.fsPath:d.toString()}return a.path}function b(a,d){const c=d?o:l,u=(0,L.deepClone)(a);return p(u,(n,f)=>{n&&f&&(f.path=c(f))}),u}e.convertToDAPaths=b;function E(a,d){const c=d?o:l,u=(0,L.deepClone)(a);return p(u,(n,f)=>{!n&&f&&(f.path=c(f))}),u}e.convertToVSCPaths=E;function p(a,d){switch(a.type){case"event":{const c=a;switch(c.event){case"output":d(!1,c.body.source);break;case"loadedSource":d(!1,c.body.source);break;case"breakpoint":d(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=a;switch(c.command){case"setBreakpoints":d(!0,c.arguments.source);break;case"breakpointLocations":d(!0,c.arguments.source);break;case"source":d(!0,c.arguments.source);break;case"gotoTargets":d(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(u=>d(!1,u));break;default:break}break}case"response":{const c=a;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(u=>d(!1,u.source));break;case"loadedSources":c.body.sources.forEach(u=>d(!1,u));break;case"scopes":c.body.scopes.forEach(u=>d(!1,u.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(u=>d(!1,u.source));break;case"setBreakpoints":c.body.breakpoints.forEach(u=>d(!1,u.source));break;case"disassemble":c.body?.instructions.forEach(n=>d(!1,n.location));break;default:break}break}}}function w(a){return a.filter(d=>!d.presentation?.hidden).sort((d,c)=>d.presentation?c.presentation?d.presentation.group?c.presentation.group?d.presentation.group!==c.presentation.group?d.presentation.group.localeCompare(c.presentation.group):s(d.presentation.order,c.presentation.order):-1:c.presentation.group?1:s(d.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=w;function s(a,d){return typeof a!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:a-d}async function r(a,d){const c=a.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(c!=="none"&&(await d.saveAll(),c==="allEditorsInActiveGroup")){const u=d.activeEditorPane;u&&u.input.resource?.scheme===C.Schemas.untitled&&await d.save({editor:u.input,groupId:u.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(Ie[66],Ce([1,0,24,35,173,61,13,19,21,41]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var m;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var v;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(v=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var h;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(h=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var t;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(t=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var l;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var b;(function($){$.scheme=C.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${z.join("")}]+`),K=7;function ie(_,me){const we=me.toString(K),We=`${we.length<z.length?z[we.length-1]:"z"}${we}s${(0,i.encodeBase64)(i.VSBuffer.fromString(_.scheme),!0,!0)}`;return _.with({scheme:$.scheme,fragment:We})}$.generate=ie;function ge(_){if(_.scheme!==$.scheme)return;const me=_.fragment.indexOf("s");if(me<0)return;const we=parseInt(_.fragment.substring(0,me).replace(V,""),K),Ne=(0,i.decodeBase64)(_.fragment.substring(me+1)).toString();if(!isNaN(we))return{handle:we,notebook:_.with({scheme:Ne,fragment:null})}}$.parse=ge;function ce(_,me){return _.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${_.scheme!==C.Schemas.file?_.scheme:""}`})}$.generateCellOutputUri=ce;function re(_){if(_.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!me)return;const we=me[1]&&me[1]!==""?me[1]:void 0,Ne=me[2];return{outputId:we,notebook:_.with({scheme:Ne||C.Schemas.file,fragment:null})}}$.parseCellOutputUri=re;function se(_,me,we){return $.generate(_,me).with({scheme:we})}$.generateCellPropertyUri=se;function le(_,me){if(_.scheme===me)return $.parse(_.with({scheme:$.scheme}))}$.parseCellPropertyUri=le})(b=e.CellUri||(e.CellUri={}));const E=$=>S.isWindows?$.replace(/\//g,"\\"):$;class p{constructor(z=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.e=V,this.d=[...new Set(z)].map(K=>({pattern:K,matches:T.parse(E(K))}))}sort(z){const V=new Map(y.Iterable.map(z,ie=>[ie,E(ie)]));let K=[];for(const{matches:ie}of this.d)for(const[ge,ce]of V)if(ie(ce)){K.push(ge),V.delete(ge);break}return V.size&&(K=K.concat([...V.keys()].sort((ie,ge)=>this.e.indexOf(ie)-this.e.indexOf(ge)))),K}prioritize(z,V){const K=this.f(z);if(K===-1){this.d.unshift({pattern:z,matches:T.parse(E(z))});return}const ie=new Set(V.map(ce=>this.f(ce,K)));ie.delete(-1);const ge=Array.from(ie).sort();this.d.splice(K+1,0,...ge.map(ce=>this.d[ce]));for(let ce=ge.length-1;ce>=0;ce--)this.d.splice(ge[ce],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,V=this.d.length){const K=E(z);for(let ie=0;ie<V;ie++)if(this.d[ie].matches(K))return ie;return-1}}e.MimeTypeDisplayOrder=p;function w($,z,V,K=(ie,ge)=>ie===ge){const ie=[];function ge(se,le,_){if(le===0&&_.length===0)return;const me=ie[ie.length-1];me&&me.start+me.deleteCount===se?(me.deleteCount+=le,me.toInsert.push(..._)):ie.push({start:se,deleteCount:le,toInsert:_})}let ce=0,re=0;for(;;){if(ce===$.length){ge(ce,0,z.slice(re));break}if(re===z.length){ge(ce,$.length-ce,[]);break}const se=$[ce],le=z[re];if(K(se,le)){ce+=1,re+=1;continue}V(le)?(ge(ce,1,[]),ce+=1):(ge(ce,0,[le]),re+=1)}return ie}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function($){$.default="default",$.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r($){const z=$;return!!((typeof z.include=="string"||T.isRelativePattern(z.include))&&(typeof z.exclude=="string"||T.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=r;function a($,z,V){if(Array.isArray($.viewType)&&$.viewType.indexOf(z)>=0||$.viewType===z)return!0;if($.filenamePattern){const K=r($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,ie=r($.filenamePattern)?$.filenamePattern.exclude:void 0;if(T.match(K,(0,O.basename)(V.fsPath).toLowerCase()))return!(ie&&T.match(ie,(0,O.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var d;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(z){return`${c.d}${z}`}static parse(z){if(z.startsWith(c.d))return z.substring(c.d.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c.d="notebook/";function u($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=u;const n=new TextDecoder;function f($){const z=[];let V=!1;for(const K of $)(z.length===0||V)&&(z.push(K),V=!0);return q(z),F(i.VSBuffer.concat(z.map(K=>i.VSBuffer.wrap(K))))}e.compressOutputItemStreams=f;const g=`${String.fromCharCode(27)}[A`,P=g.split("").map($=>$.charCodeAt(0)),M=10;function q($){$.forEach((z,V)=>{if(V===0||z.length<g.length)return;const K=$[V-1],ie=z.subarray(0,g.length);if(ie[0]===P[0]&&ie[1]===P[1]&&ie[2]===P[2]){const ge=K.lastIndexOf(M);if(ge===-1)return;$[V-1]=K.subarray(0,ge),$[V]=z.subarray(g.length)}})}function J($){let z=$;do $=z,z=$.replace(/[^\n]\x08/gm,"");while(z.length<$.length);return $}function x($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const z=$.match(/^(.*)\r+/m)[1];let V=$.match(/\r+(.*)$/m)[1];V=V+z.slice(V.length,z.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return $}const R="\b".charCodeAt(0),A="\r".charCodeAt(0);function F($){return!$.buffer.includes(R)&&!$.buffer.includes(A)?$:i.VSBuffer.fromString(x(J(n.decode($.buffer))))}}),define(Ie[174],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(Ie[175],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=i;function T(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=T;function y(C){return Array.from(C.entries()).map(O=>[O[0],i(O[1].map)])}e.serializeEnvironmentVariableCollections=y;function L(C){return new Map(C.map(O=>[O[0],{map:T(O[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(Ie[42],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(L){L.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class y{static fromExtHostTestItem(C,O,S=C.parent){if(C._isRoot)return new y([O]);const k=[C.id];for(let N=S;N&&N.id!==O;N=N.parent)k.push(N.id);return k.push(O),new y(k.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const O=C.indexOf("\0");return O===-1?C:C.slice(0,O)}static fromString(C){return new y(C.split("\0"))}static join(C,O){return new y([...C.path,O])}static joinToString(C,O){return C.toString()+"\0"+O}static parentId(C){const O=C.lastIndexOf("\0");return O===-1?void 0:C.slice(0,O)}static compare(C,O){return C===O?0:O.startsWith(C+"\0")?2:C.startsWith(O+"\0")?3:1}constructor(C,O=C.length){if(this.path=C,this.d=O,C.length===0||O<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new y(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new y(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new y(this.path,C)}compare(C){if(typeof C=="string")return y.compare(this.toString(),C);for(let O=0;O<C.d&&O<this.d;O++)if(C.path[O]!==this.path[O])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=y}),define(Ie[53],Ce([1,0,2,54,42]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var L;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(L=e.TestResultState||(e.TestResultState={}));var C;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var O;(function(u){u.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),u.deserialize=n=>({range:T.Range.lift(n.range),uri:i.URI.revive(n.uri)})})(O=e.IRichLocation||(e.IRichLocation={}));var S;(function(u){u[u.Error=0]="Error",u[u.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var k;(function(u){u.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&O.serialize(n.location)}),u.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&O.deserialize(n.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const N=(u,n)=>`${n?"s":"e"}${u}`;e.getMarkId=N;var D;(function(u){u.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&O.serialize(n.location)}),u.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&O.deserialize(n.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(u){u.serialize=n=>n.type===0?k.serialize(n):D.serialize(n),u.deserialize=n=>n.type===0?k.deserialize(n):D.deserialize(n)})(m=e.ITestMessage||(e.ITestMessage={}));var v;(function(u){u.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),u.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(m.serialize)}),u.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(m.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const h="\0",t=(u,n)=>u+h+n;e.namespaceTestTag=t;const o=u=>{const n=u.indexOf(h);return{ctrlId:u.slice(0,n),tagId:u.slice(n+1)}};e.denamespaceTestTag=o;var l;(function(u){u.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),u.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?i.URI.revive(n.uri):void 0,range:n.range?T.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(l=e.ITestItem||(e.ITestItem={}));var b;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var E;(function(u){u.serialize=n=>({expand:n.expand,item:l.serialize(n.item)}),u.deserialize=n=>({controllerId:y.TestId.root(n.item.extId),expand:n.expand,item:l.deserialize(n.item)})})(E=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(u){u.serialize=n=>{let f;return n.item&&(f={},n.item.label!==void 0&&(f.label=n.item.label),n.item.tags!==void 0&&(f.tags=n.item.tags),n.item.busy!==void 0&&(f.busy=n.item.busy),n.item.uri!==void 0&&(f.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(f.range=n.item.range?.toJSON()),n.item.description!==void 0&&(f.description=n.item.description),n.item.error!==void 0&&(f.error=n.item.error),n.item.sortText!==void 0&&(f.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:f}},u.deserialize=n=>{let f;return n.item&&(f={},n.item.label!==void 0&&(f.label=n.item.label),n.item.tags!==void 0&&(f.tags=n.item.tags),n.item.busy!==void 0&&(f.busy=n.item.busy),n.item.range!==void 0&&(f.range=n.item.range?T.Range.lift(n.item.range):null),n.item.description!==void 0&&(f.description=n.item.description),n.item.error!==void 0&&(f.error=n.item.error),n.item.sortText!==void 0&&(f.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:f}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(u,n)=>{n.expand!==void 0&&(u.expand=n.expand),n.item!==void 0&&(u.item=u.item?Object.assign(u.item,n.item):n.item)};e.applyTestItemUpdate=w;var s;(function(u){u.serializeWithoutMessages=n=>({...E.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.serializeWithoutMessages),retired:n.retired}),u.serialize=n=>({...E.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.serialize),retired:n.retired}),u.deserialize=n=>({...E.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var a;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.DocumentSynced=2]="DocumentSynced",u[u.Remove=3]="Remove",u[u.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",u[u.Retire=5]="Retire",u[u.AddTag=6]="AddTag",u[u.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(u){u.deserialize=n=>n.op===0?{op:n.op,item:E.deserialize(n.item)}:n.op===1?{op:n.op,item:p.deserialize(n.item)}:n.op===2?{op:n.op,uri:i.URI.revive(n.uri),docv:n.docv}:n,u.serialize=n=>n.op===0?{op:n.op,item:E.serialize(n.item)}:n.op===1?{op:n.op,item:p.serialize(n.item)}:n})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const f=this.o();for(const g of n)switch(g.op){case 0:this.j(E.deserialize(g.item),f);break;case 1:this.k(p.deserialize(g.item),f);break;case 3:this.l(g.itemId,f);break;case 5:this.m(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.c.set(g.tag.id,g.tag);break;case 7:this.c.delete(g.id);break}f.complete?.()}j(n,f){const g=y.TestId.parentId(n.item.extId)?.toString();let P;if(!g)P=this.p(n),this.f.add(P),this.d.set(n.item.extId,P);else if(this.d.has(g)){const M=this.d.get(g);M.children.add(n.item.extId),P=this.p(n,M),this.d.set(n.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return f.add?.(P),n.expand===2&&this.g++,P}k(n,f){const g=this.d.get(n.extId);if(!!g)return n.expand!==void 0&&(g.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(g,n),f.update?.(g),g}l(n,f){const g=this.d.get(n);if(!g)return;const P=y.TestId.parentId(g.item.extId)?.toString();P?this.d.get(P).children.delete(g.item.extId):this.f.delete(g);const M=[[n]];for(;M.length;)for(const q of M.pop()){const J=this.d.get(q);J&&(M.push(J.children),this.d.delete(q),f.remove?.(J,J!==g),J.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(Ie[67],Ce([1,0,14,5,7,47,53,42]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(b){b[b.Upsert=0]="Upsert",b[b.SetTags=1]="SetTags",b[b.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",b[b.RemoveChild=3]="RemoveChild",b[b.SetProp=4]="SetProp",b[b.Bulk=5]="Bulk",b[b.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(b,E)=>b===E,D=Object.entries({range:(b,E)=>b===E?!0:!b||!E?!1:b.equalsRange(E),busy:k,label:k,description:k,error:k,sortText:k,tags:(b,E)=>!(b.length!==E.length||b.some(p=>!E.includes(p)))}),m=(b,E)=>{let p;for(const[w,s]of D)s(b[w],E[w])||(p?p[w]=E[w]:p={[w]:E[w]});return p};class v extends y.Disposable{get root(){return this.m.root}constructor(E){super(),this.m=E,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new T.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(E){this.h=E;for(const p of this.tree.values())this.G(p)}collectDiff(){const E=this.k;return this.k=[],E}pushDiff(E){switch(E.op){case 2:{for(const p of this.k)if(p.op===2&&p.uri===E.uri){p.docv=E.docv;return}break}case 1:{const p=this.k[this.k.length-1];if(p){if(p.op===1&&p.item.extId===E.item.extId){(0,C.applyTestItemUpdate)(p.item,E.item);return}if(p.op===0&&p.item.item.extId===E.item.extId){(0,C.applyTestItemUpdate)(p.item,E.item);return}}break}}this.k.push(E),this.f.isScheduled()||this.f.schedule()}expand(E,p){const w=this.tree.get(E);if(!!w){if((w.expandLevels===void 0||p>w.expandLevels)&&(w.expandLevels=p),w.expand===1){const s=this.I(w);return s.isOpen()?this.H(w,p-1):s.wait().then(()=>this.H(w,p-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,p-1)):this.H(w,p-1)}}dispose(){for(const E of this.tree.values())this.m.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(E,p){switch(p.op){case 3:this.L(O.TestId.joinToString(E.fullId,p.id));break;case 0:this.u(p.item,E);break;case 5:for(const w of p.ops)this.p(E,w);break;case 1:this.w(p.new,p.old,E.fullId.toString());break;case 2:this.G(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:p.update}});break;case 6:this.s(E.actual.uri);break;default:(0,L.assertNever)(p)}}s(E){E&&this.pushDiff({op:2,uri:E,docv:this.m.getDocumentVersion(E)})}u(E,p){const w=O.TestId.fromExtHostTestItem(E,this.root.id,p?.actual),s=this.m.getApiFor(E);s.parent&&s.parent!==p?.actual&&this.m.getChildren(s.parent).delete(E.id);let r=this.tree.get(w.toString());if(!r){r={fullId:w,actual:E,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},E.tags.forEach(this.y,this),this.tree.set(r.fullId.toString(),r),this.C(E,p),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:r.expand,item:this.m.toITestItem(E)}}),this.F(E,r,p);return}if(r.actual===E){this.D(E,r,p);return}if(r.actual.uri?.toString()!==E.uri?.toString())return this.L(w.toString()),this.u(E,p);const a=this.m.getChildren(r.actual),d=r.actual,c=m(this.m.toITestItem(d),this.m.toITestItem(E));this.m.getApiFor(d).listener=void 0,r.actual=E,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(E.tags,d.tags,w.toString()),delete c.tags),this.p(r,{op:4,update:c})),this.F(E,r,p);for(const[u,n]of a)this.m.getChildren(E).get(n.id)||this.L(O.TestId.joinToString(w,n.id));this.s(r.actual.uri)}w(E,p,w){const s=new Set(p.map(r=>r.id));for(const r of E)s.delete(r.id)||this.y(r);this.pushDiff({op:1,item:{extId:w,item:{tags:E.map(r=>(0,C.namespaceTestTag)(this.m.controllerId,r.id))}}}),s.forEach(this.z,this)}y(E){const p=this.j.get(E.id);p?p.refCount++:(this.j.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,E.id)}}))}z(E){const p=this.j.get(E);p&&!--p.refCount&&(this.j.delete(E),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,E)}))}C(E,p){this.m.getApiFor(E).parent=p&&p.actual!==this.root?p.actual:void 0}D(E,p,w){this.C(E,w);const s=this.m.getApiFor(E);s.parent=w?.actual,s.listener=r=>this.p(p,r),this.G(p)}F(E,p,w){this.D(E,p,w);for(const[s,r]of this.m.getChildren(E))this.u(r,p)}G(E){let p;this.h?E.resolveBarrier?p=E.resolveBarrier.isOpen()?3:2:p=E.actual.canResolveChildren?1:0:p=0,p!==E.expand&&(E.expand=p,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:p}}),p===1&&E.expandLevels!==void 0&&this.I(E))}H(E,p){if(p<0)return;const w=[];for(const[s,r]of this.m.getChildren(E.actual)){const a=this.expand(O.TestId.joinToString(E.fullId,r.id),p);(0,i.isThenable)(a)&&w.push(a)}if(w.length)return Promise.all(w).then(()=>{})}I(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this.h){const r=new i.Barrier;return r.open(),r}E.expand=2,this.J(E);const p=E.resolveBarrier=new i.Barrier,w=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,r)};let s;try{s=this.h(E.actual===this.root?void 0:E.actual)}catch(r){w(r)}return(0,i.isThenable)(s)?s.catch(w).then(()=>{p.open(),this.G(E)}):(p.open(),this.G(E)),E.resolveBarrier}J(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}L(E){const p=this.tree.get(E);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const w=[p];for(;w.length;){const s=w.pop();if(!!s){this.m.getApiFor(s.actual).listener=void 0;for(const r of s.actual.tags)this.z(r.id);this.tree.delete(s.fullId.toString());for(const[r,a]of this.m.getChildren(s.actual))w.push(this.tree.get(O.TestId.joinToString(s.fullId,a.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.g.fire(E)}}e.TestItemCollection=v;class h extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=h;class t extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=t;class o extends Error{constructor(E,p,w){super(`TestItem with ID "${E}" is from controller "${p}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=o;const l=(b,E,p)=>{let w=new Map;return{get size(){return w.size},forEach(s,r){for(const a of w.values())s.call(r,a,this)},[Symbol.iterator](){return w.entries()},replace(s){const r=new Map,a=new Set(w.keys()),d={op:5,ops:[]};for(const c of s){if(!(c instanceof p))throw new t(c.id);const u=E(c).controllerId;if(u!==b.controllerId)throw new o(c.id,u,b.controllerId);if(r.has(c.id))throw new h(c.id);r.set(c.id,c),a.delete(c.id),d.ops.push({op:0,item:c})}for(const c of a.keys())d.ops.push({op:3,id:c});b.listener?.(d),w=r},add(s){if(!(s instanceof p))throw new t(s.id);w.set(s.id,s),b.listener?.({op:0,item:s})},delete(s){w.delete(s)&&b.listener?.({op:3,id:s})},get(s){return w.get(s)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=l}),define(Ie[93],Ce([1,0,67]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,y=(C,O)=>{const S={controllerId:O};return T.set(C,S),S};e.createPrivateApiFor=y;const L=C=>{const O=T.get(C);if(!O)throw new i.InvalidTestItemError(C?.id||"<unknown>");return O};e.getPrivateApiFor=L}),define(Ie[68],Ce([1,0,13,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(O,S){return O.scheme===i.Schemas.http||O.scheme===i.Schemas.https?O:(S&&S.authority&&S.isRemote&&O.scheme===i.Schemas.file&&(O=T.URI.from({scheme:i.Schemas.vscodeRemote,authority:S.authority,path:O.path})),T.URI.from({scheme:i.Schemas.https,authority:`${O.scheme}+${L(O.authority)}.${e.webviewRootResourceAuthority}`,path:O.path,fragment:O.fragment,query:O.query}))}e.asWebviewUri=y;function L(O){return O.replace(/./g,S=>{const k=S.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?S:"-"+k.toString(16).padStart(4,"0")})}function C(O){return O.replace(/-([0-9a-f]{4})/g,(S,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=C}),define(Ie[176],Ce([1,0,5,7,68]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(O,S,k){this.d=O,this.e=S,this.f=k,this.a=0,this.b=new T.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const N=S.getVisibleTextEditors();for(const D of this.c.values())N.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,S,k,N,D){let m;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===O){m=E;break}if(!m)throw new Error("not a visible editor");const v=this,h=this.a++,t=new i.Emitter,o=new i.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,y.asWebviewUri)(E,v.f)}get cspSource(){return y.webviewGenericCspSource}set options(E){this.b=E,v.d.$setOptions(h,E)}get options(){return this.b}set html(E){this.a=E,v.d.$setHtml(h,E)}get html(){return this.a}get onDidReceiveMessage(){return t.event}postMessage(E){return v.d.$postMessage(h,E)}},b=new class{constructor(){this.editor=O,this.line=S,this.height=k,this.webview=l,this.onDidDispose=o.event}dispose(){v.c.has(h)&&(v.c.delete(h),v.d.$disposeEditorInset(h),o.fire(),o.dispose(),t.dispose())}};return this.d.$createEditorInset(h,m.id,m.value.document.uri,S+1,k,N||{},D.identifier,D.extensionLocation),this.c.set(h,{editor:O,inset:b,onDidReceiveMessage:t}),b}$onDidDispose(O){const S=this.c.get(O);S&&S.inset.dispose()}$onDidReceiveMessage(O,S){this.c.get(O)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=L}),define(Ie[177],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T=e.VariableKind||(e.VariableKind={}));class y extends Error{constructor(C,O){super(O),this.variable=C}}e.VariableError=y}),define(Ie[178],Ce([1,0,19,49,9,23,21,82,145,177,10]),function(ee,e,i,T,y,L,C,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(v,h,t,o){this.g=new Map,this.a=v,this.b=h,this.d=t,o&&(this.c=o.then(l=>this.h(l)))}h(v){if(C.isWindows){const h=Object.create(null);return Object.keys(v).forEach(t=>{h[t.toLowerCase()]=v[t]}),h}return v}resolveWithEnvironment(v,h,t){return this.j({env:this.h(v),userHome:void 0},h?h.uri:void 0,t)}async resolveAsync(v,h){const t={env:await this.c,userHome:await this.d};return this.j(t,v?v.uri:void 0,h)}async i(v,h,t,o){const l=L.deepClone(h);C.isWindows&&l.windows?Object.keys(l.windows).forEach(E=>l[E]=l.windows[E]):C.isMacintosh&&l.osx?Object.keys(l.osx).forEach(E=>l[E]=l.osx[E]):C.isLinux&&l.linux&&Object.keys(l.linux).forEach(E=>l[E]=l.linux[E]),delete l.windows,delete l.osx,delete l.linux;const b={env:await this.c,userHome:await this.d};return this.j(b,v?v.uri:void 0,l,t,o)}async resolveAnyAsync(v,h,t){return this.i(v,h,t)}async resolveAnyMap(v,h,t){const o=new Map;return{newConfig:await this.i(v,h,t,o),resolvedVariables:o}}resolveWithInteractionReplace(v,h,t,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,h,t,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,h){if(this.g.has(v))throw new Error("Variable "+v+" is contributed twice.");this.g.set(v,h)}async j(v,h,t,o,l){if(y.isString(t))return this.l(v,h,t,o,l);if(Array.isArray(t))return Promise.all(t.map(b=>this.j(v,h,b,o,l)));if(y.isObject(t)){const b=Object.create(null),E=await Promise.all(Object.keys(t).map(async p=>[await this.l(v,h,p,o,l),await this.j(v,h,t[p],o,l)]));for(const[p,w]of E)b[p]=w;return b}return t}l(v,h,t,o,l){return(0,N.replaceAsync)(t,D.VARIABLE_REGEXP,async(b,E)=>{if(E.includes(D.VARIABLE_LHS))return b;let p=await this.n(v,b,E,h,o);return l?.set(E,p),p!==b&&y.isString(p)&&p.match(D.VARIABLE_REGEXP)&&(p=await this.l(v,h,p,o,l)),p})}m(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async n(v,h,t,o,l){let b;const E=t.split(":");E.length>1&&(t=E[0],b=E[1]);const p=r=>{const a=this.a.getFilePath();if(a)return(0,O.normalizeDriveLetter)(a);throw new k.VariableError(r,(0,S.localize)(0,null,h))},w=r=>{const a=p(r);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,O.normalizeDriveLetter)(d)}throw new k.VariableError(r,(0,S.localize)(1,null,h,i.basename(a)))},s=r=>{if(b){const a=this.a.getFolderUri(b);if(a)return a;throw new k.VariableError(r,(0,S.localize)(2,null,h,b))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(r,(0,S.localize)(3,null,h)):new k.VariableError(r,(0,S.localize)(4,null,h))};switch(t){case"env":if(b){if(v.env){const r=v.env[C.isWindows?b.toLowerCase():b];if(y.isString(r))return r}return""}throw new k.VariableError(k.VariableKind.Env,(0,S.localize)(5,null,h));case"config":if(b){const r=this.a.getConfigurationValue(o,b);if(y.isUndefinedOrNull(r))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(6,null,h,b));if(y.isObject(r))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(7,null,h,b));return r}throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(8,null,h));case"command":return this.o(k.VariableKind.Command,h,b,l,"command");case"input":return this.o(k.VariableKind.Input,h,b,l,"input");case"extensionInstallFolder":if(b){const r=await this.a.getExtension(b);if(!r)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,h,b));return this.m(r.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,h));default:switch(t){case"workspaceRoot":case"workspaceFolder":return(0,O.normalizeDriveLetter)(this.m(s(k.VariableKind.WorkspaceFolder)));case"cwd":return o||b?(0,O.normalizeDriveLetter)(this.m(s(k.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.normalizeDriveLetter)(i.basename(this.m(s(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,S.localize)(11,null,h))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new k.VariableError(k.VariableKind.LineNumber,(0,S.localize)(12,null,h))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new k.VariableError(k.VariableKind.SelectedText,(0,S.localize)(13,null,h))}case"file":return p(k.VariableKind.File);case"fileWorkspaceFolder":return w(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||b?i.relative(this.m(s(k.VariableKind.RelativeFile)),p(k.VariableKind.RelativeFile)):p(k.VariableKind.RelativeFile);case"relativeFileDirname":{const r=i.dirname(p(k.VariableKind.RelativeFileDirname));if(o||b){const a=i.relative(this.m(s(k.VariableKind.RelativeFileDirname)),r);return a.length===0?".":a}return r}case"fileDirname":return i.dirname(p(k.VariableKind.FileDirname));case"fileExtname":return i.extname(p(k.VariableKind.FileExtname));case"fileBasename":return i.basename(p(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=i.basename(p(k.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-i.extname(r).length)}case"fileDirnameBasename":return i.basename(i.dirname(p(k.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||h}case"execInstallFolder":{const r=this.a.getAppRoot();return r||h}case"pathSeparator":return i.sep;default:try{const r=b?`${t}:${b}`:t;return this.o(k.VariableKind.Unknown,h,r,l,void 0)}catch{return h}}}}o(v,h,t,o,l){if(t&&o){const b=l===void 0?o[t]:o[l+":"+t];if(typeof b=="string")return b;throw new k.VariableError(v,(0,S.localize)(14,null,h))}return h}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[94],Ce([1,0,3,92]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var y;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var L;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var O;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(O=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function k(h){const t=h;return(0,T.isEditorInput)(t?.editor)&&(0,T.isEditorInput)(t?.replacement)}e.isEditorReplacement=k;var N;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function m(h){const t=h;return!!t&&typeof t.id=="number"&&Array.isArray(t.editors)}e.isEditorGroup=m;function v(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(Ie[179],Ce([1,0,3,94]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(L){const C=L;return typeof L=="number"||(0,T.isEditorGroup)(C)}e.isPreferredGroup=y}),define(Ie[180],Ce([1,0,3,151]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(T.IEnvironmentService)}),define(Ie[181],Ce([1,0,26,5,19]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(D){this.removedDueToLooping=D}}e.DeltaExtensionsResult=L;class C{constructor(D){this.c=new T.Emitter,this.onDidChange=this.c.event,this.d=D,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const D of this.d){if(this.e.has(i.ExtensionIdentifier.toKey(D.identifier))){console.error("Extension `"+D.identifier.value+"` is already registered");continue}if(this.e.set(i.ExtensionIdentifier.toKey(D.identifier),D),this.f.push(D),Array.isArray(D.activationEvents))for(let m of D.activationEvents)m==="onUri"&&(m=`onUri:${i.ExtensionIdentifier.toKey(D.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(D)}}set(D){this.d=D,this.h(),this.c.fire(void 0)}deltaExtensions(D,m){this.d=k(this.d,m),this.d=this.d.concat(D);const v=C.j(this.d);return this.d=k(this.d,v.map(h=>h.identifier)),this.h(),this.c.fire(void 0),new L(v)}static j(D){const m=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,b){this.addNode(l),this.addNode(b),this.c.has(l)?this.c.get(l).push(b):this.c.set(l,[b])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,b){const E=m.getArcs(l);for(let p=0;p<E.length;p++)if(!b.has(E[p]))return!1;return!0}getNodes(){return this.e}},v=new Map;for(const l of D){const b=i.ExtensionIdentifier.toKey(l.identifier);if(v.set(b,l),l.extensionDependencies)for(const E of l.extensionDependencies){const p=i.ExtensionIdentifier.toKey(E);m.addArc(b,p)}}const h=new Set;m.getNodes().filter(l=>m.getArcs(l).length===0).forEach(l=>h.add(l));const t=m.getNodes().filter(l=>!h.has(l));let o;do{o=!1;for(let l=0;l<t.length;l++){const b=t[l];m.hasOnlyGoodArcs(b,h)&&(t.splice(l,1),l--,h.add(b),o=!0)}}while(o);return t.map(l=>v.get(l))}containsActivationEvent(D){return this.g.has(D)}containsExtension(D){return this.e.has(i.ExtensionIdentifier.toKey(D))}getExtensionDescriptionsForActivationEvent(D){const m=this.g.get(D);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(D){const m=this.e.get(i.ExtensionIdentifier.toKey(D));return m||void 0}getExtensionDescriptionByUUID(D){for(const m of this.f)if(m.uuid===D)return m}getExtensionDescriptionByIdOrUUID(D,m){return this.getExtensionDescription(D)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=C;var O;(function(N){N[N.Builtin=0]="Builtin",N[N.User=1]="User",N[N.Dev=2]="Dev"})(O||(O={}));function S(N,D){const m=N.isBuiltin?0:N.isUnderDevelopment?2:1,v=D.isBuiltin?0:D.isUnderDevelopment?2:1;if(m!==v)return m-v;const h=y.posix.basename(N.extensionLocation.path),t=y.posix.basename(D.extensionLocation.path);return h<t?-1:h>t?1:0}function k(N,D){const m=new Set;return D.forEach(v=>m.add(i.ExtensionIdentifier.toKey(v))),N.filter(v=>!m.has(i.ExtensionIdentifier.toKey(v.identifier)))}}),define(Ie[69],Ce([1,0,24]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function C(k){const N=i.VSBuffer.alloc(1);switch(k){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=C;function O(k,N){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=O;var S;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[70],Ce([1,0,3,5,12,27,69,48,91,23,2]),function(ee,e,i,T,y,L,C,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let D=class{constructor(t,o){this.i=t,this.a=new T.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new T.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=o.createLogger(N.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(t,o){const l=this.getTelemetryDetails(),b=new m(o,t,this.g,this.f,this.getBuiltInCommonProperties(t),{isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled});return this.h.set(t.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(t,o,l){this.d=t,this.f=o,this.c=l??{usage:!0,error:!0}}getBuiltInCommonProperties(t){const o={};switch(o["common.extname"]=t.name,o["common.extversion"]=t.version,o["common.vscodemachineid"]=this.i.telemetryInfo.machineId,o["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,o["common.vscodeversion"]=this.i.version,o["common.isnewappinstall"]=v(this.i.telemetryInfo.firstSessionDate),o["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:o["common.uikind"]="web";break;case C.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,O.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),o}$onDidChangeTelemetryLevel(t){this.e=this.getTelemetryConfiguration(),this.d=t;const o=this.getTelemetryDetails();this.h.forEach(l=>{l.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(t,o){const l=this.h.get(t.value);return l?(l.logError(o),!0):!1}};D=qe([Ve(0,L.IExtHostInitDataService),Ve(1,y.ILoggerService)],D),e.ExtHostTelemetry=D;class m{constructor(t,o,l,b,E,p){this.e=o,this.f=l,this.g=b,this.h=E,this.b=new T.Emitter,this.a=t,this.c={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(t,o){this.d&&(this.c={isUsageEnabled:t,isErrorsEnabled:o},this.b.fire(this.d))}mixInCommonPropsAndCleanData(t){let o=t.properties??t;return o=(0,S.cleanData)(o,[]),this.a.additionalCommonProperties&&(o=(0,k.mixin)(o,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(o=(0,k.mixin)(o,this.h)),t.properties?t.properties=o:t=o,t}i(t,o){this.e.publisher==="vscode"?t=this.e.name+"/"+t:t=this.e.identifier.value+"/"+t,o=this.mixInCommonPropsAndCleanData(o||{}),this.g||this.a.logEvent(t,o),this.f.trace(t,o)}logUsage(t,o){!this.c.isUsageEnabled||this.i(t,o)}logError(t,o){!this.c.isErrorsEnabled||(typeof t=="string"?this.i(t,o):this.a.logException(t,o))}get apiTelemetryLogger(){if(!this.d){const t=this,o={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.c.isUsageEnabled},get isErrorsEnabled(){return t.c.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.b.event.bind(t)};this.d=Object.freeze(o)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function v(h){const t=Date.now()-new Date(h).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=v,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(Ie[25],Ce([1,0,5,2,3,26,158]),function(ee,e,i,T,y,L,C){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class S{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class k{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class N{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=N;class D{constructor(u){this.dependency=u}}e.MissingExtensionDependency=D;var m;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function v(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=v;class h{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,n){const f=[],g=[],P=[],M=[],q=l(this.c),J=l(u),x=($,z)=>$.extensionLocation.toString()===z.extensionLocation.toString()||$.isBuiltin===z.isBuiltin||$.isUserBuiltin===z.isUserBuiltin||$.isUnderDevelopment===z.isUnderDevelopment;for(const $ of this.c){const z=J.get(L.ExtensionIdentifier.toKey($.identifier));if(!z){f.push($.identifier),q.delete(L.ExtensionIdentifier.toKey($.identifier));continue}if(!x($,z)){f.push($.identifier),q.delete(L.ExtensionIdentifier.toKey($.identifier));continue}}for(const $ of u){const z=q.get(L.ExtensionIdentifier.toKey($.identifier));if(!z){g.push($);continue}if(!x(z,$)){f.push(z.identifier),q.delete(L.ExtensionIdentifier.toKey(z.identifier));continue}}const R=o(this.d),A=o(n);for(const $ of this.d)A.has(L.ExtensionIdentifier.toKey($))||P.push($);for(const $ of n)R.has(L.ExtensionIdentifier.toKey($))||M.push($);const F={toRemove:f,toAdd:g,myToRemove:P,myToAdd:M};return this.delta(F),F}delta(u){const{toRemove:n,toAdd:f,myToRemove:g,myToAdd:P}=u,M=o(n),q=o(g);for(let J=0;J<this.c.length;J++)M.has(L.ExtensionIdentifier.toKey(this.c[J].identifier))&&(this.c.splice(J,1),J--);for(let J=0;J<this.d.length;J++)q.has(L.ExtensionIdentifier.toKey(this.d[J]))&&(this.d.splice(J,1),J--);for(const J of f)this.c.push(J);for(const J of P)this.d.push(J)}containsExtension(u){for(const n of this.d)if(L.ExtensionIdentifier.equals(n,u))return!0;return!1}}e.ExtensionHostExtensions=h;class t{constructor(u){if(this[O]="ExtensionIdentifierSet",this.c=new Map,this.d=L.ExtensionIdentifier.toKey,u)for(const n of u)this.add(n)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,n){this.c.forEach(f=>u.call(n,f,f,this))}*entries(){for(const[u,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=t;function o(c){const u=new Set;for(const n of c)u.add(L.ExtensionIdentifier.toKey(n));return u}e.extensionIdentifiersArrayToSet=o;function l(c){const u=new Map;for(const n of c)u.set(L.ExtensionIdentifier.toKey(n.identifier),n);return u}function b(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=b;function E(c,u){if(!b(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=E;class p{constructor(u,n,f,g){this.codeLoadingTime=u,this.activateCallTime=n,this.activateResolvedTime=f,this.activationReason=g}}e.ActivationTimes=p;class w{constructor(u,n){this.description=u,this.value=n}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function a(c,u){return{identifier:new L.ExtensionIdentifier((0,C.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=a;class d{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,n){return Promise.resolve(0)}getInspectPorts(u,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=d}),define(Ie[182],Ce([1,0,11,26,25,12,14]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class O{constructor(o,l,b,E){this.startup=o,this.codeLoadingTime=l,this.activateCallTime=b,this.activateResolvedTime=E}}e.ExtensionActivationTimes=O,O.NONE=new O(!1,-1,-1,-1);class S{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,l){return o===-1||l===-1?-1:l-o}build(){return new O(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=S;class k{constructor(o,l,b,E,p,w){this.activationFailed=o,this.activationFailedError=l,this.activationTimes=b,this.module=E,this.exports=p,this.subscriptions=w}}e.ActivatedExtension=k;class N extends k{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=N;class D extends k{constructor(){super(!1,null,O.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=D;class m extends k{constructor(o){super(!0,o,O.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,l,b,E,p){this.h=p,this.a=o,this.b=new Set,l.forEach(w=>this.b.add(T.ExtensionIdentifier.toKey(w))),this.c=new Map,b.forEach(w=>this.c.set(T.ExtensionIdentifier.toKey(w),w)),this.d=E,this.f=new Map,this.g=Object.create(null)}dispose(){for(const[o,l]of this.f)l.dispose()}isActivated(o){const l=this.f.get(T.ExtensionIdentifier.toKey(o));return Boolean(l&&l.value)}getActivatedExtension(o){const l=this.f.get(T.ExtensionIdentifier.toKey(o));if(!l||!l.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return l.value}async activateByEvent(o,l){if(this.g[o])return;const b=this.a.getExtensionDescriptionsForActivationEvent(o);await this.j(b.map(E=>({id:E.identifier,reason:{startup:l,extensionId:E.identifier,activationEvent:o}}))),this.g[o]=!0}activateById(o,l){const b=this.a.getExtensionDescription(o);if(!b)throw new Error(`Extension '${o}' is not known`);return this.j([{id:b.identifier,reason:l}])}async j(o){const l=o.filter(b=>!this.isActivated(b.id)).map(b=>this.k(b));await Promise.all(l.map(b=>b.wait()))}k(o){if(this.f.has(T.ExtensionIdentifier.toKey(o.id)))return this.f.get(T.ExtensionIdentifier.toKey(o.id));if(this.c.has(T.ExtensionIdentifier.toKey(o.id)))return this.l(o,null,[],null);const l=this.a.getExtensionDescription(o.id);if(!l){const p=new Error(`Cannot activate unknown extension '${o.id.value}'`),w=this.l(o,null,[],new m(p));return this.d.onExtensionActivationError(o.id,p,new y.MissingExtensionDependency(o.id.value)),w}const b=[],E=typeof l.extensionDependencies>"u"?[]:l.extensionDependencies;for(const p of E){if(this.b.has(T.ExtensionIdentifier.toKey(p)))continue;const w=this.f.get(T.ExtensionIdentifier.toKey(p));if(w){b.push(w);continue}if(this.c.has(T.ExtensionIdentifier.toKey(p))){b.push(this.k({id:this.c.get(T.ExtensionIdentifier.toKey(p)),reason:o.reason}));continue}const s=this.a.getExtensionDescription(p);if(s){if(!s.main&&!s.browser)continue;b.push(this.k({id:s.identifier,reason:o.reason}));continue}const r=l.displayName||l.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),d=this.l(o,l.displayName,[],new m(a));return this.d.onExtensionActivationError(l.identifier,a,new y.MissingExtensionDependency(p)),d}return this.l(o,l.displayName,b,null)}l(o,l,b,E){const p=new h(o.id,l,o.reason,b,E,this.d,this.h);return this.f.set(T.ExtensionIdentifier.toKey(o.id),p),p}};v=qe([Ve(4,L.ILogService)],v),e.ExtensionsActivator=v;let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,l,b,E,p,w,s){this.c=o,this.d=l,this.f=b,this.g=E,this.h=p,this.j=w,this.k=s,this.a=new C.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const l=this.g[o];if(l.value&&!l.value.activationFailed){this.g.splice(o,1),o--;continue}if(l.value&&l.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${l.friendlyName}' failed to activate`);b.detail=l.value.activationFailedError,this.h=new m(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const l=new Error;if(o&&o.name&&(l.name=o.name),o&&o.message?l.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:l.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(l.stack=o.stack),this.h=new m(l),this.b&&i.isCancellationError(o))return;this.j.onExtensionActivationError(this.c,l,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};h=qe([Ve(6,L.ILogService)],h)}),define(Ie[183],Ce([1,0,12,27,25]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends i.LogService{constructor(O,S){super(O.createLogger(S.logFile,{name:y.ExtensionHostLogFileName}))}};L=qe([Ve(0,i.ILoggerService),Ve(1,T.IExtHostInitDataService)],L),e.ExtHostLogService=L});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[6],Ce([1,0,16,11,81,28,61,10,9,2,34,36,90,66,25]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h){"use strict";var t,o,l,b,E,p,w,s,r,a,d,c,u,n,f,g,P,M,q,J,x,R,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(W){return Object.assign(W,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(W,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(W,[]);{const[te,...Ee]=arguments;return Reflect.construct(W,Ee,te.constructor)}}})}var $;(function(W){W.top="top",W.bottom="bottom"})($=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(W){W.command="command",W.opener="opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let V=p=class{static from(...B){let te=B;return new p(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}constructor(B){t.set(this,void 0),Ye(this,t,B,"f")}dispose(){typeof Re(this,t,"f")=="function"&&(Re(this,t,"f").call(this),Ye(this,t,void 0,"f"))}};t=new WeakMap,V=p=qe([F],V),e.Disposable=V;let K=w=class{static Min(...B){if(B.length===0)throw new TypeError;let te=B[0];for(let Ee=1;Ee<B.length;Ee++){const Ke=B[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...B){if(B.length===0)throw new TypeError;let te=B[0];for(let Ee=1;Ee<B.length;Ee++){const Ke=B[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(B){if(!B)return!1;if(B instanceof w)return!0;const{line:te,character:Ee}=B;return typeof te=="number"&&typeof Ee=="number"}static of(B){if(B instanceof w)return B;if(this.isPosition(B))return new w(B.line,B.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(B,te){if(B<0)throw(0,T.illegalArgument)("line must be non-negative");if(te<0)throw(0,T.illegalArgument)("character must be non-negative");this.c=B,this.e=te}isBefore(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<B.e}isBeforeOrEqual(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<=B.e}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this.c===B.c&&this.e===B.e}compareTo(B){return this.c<B.c?-1:this.c>B.line?1:this.e<B.e?-1:this.e>B.e?1:0}translate(B,te=0){if(B===null||te===null)throw(0,T.illegalArgument)();let Ee;return typeof B>"u"?Ee=0:typeof B=="number"?Ee=B:(Ee=typeof B.lineDelta=="number"?B.lineDelta:0,te=typeof B.characterDelta=="number"?B.characterDelta:0),Ee===0&&te===0?this:new w(this.line+Ee,this.character+te)}with(B,te=this.character){if(B===null||te===null)throw(0,T.illegalArgument)();let Ee;return typeof B>"u"?Ee=this.line:typeof B=="number"?Ee=B:(Ee=typeof B.line=="number"?B.line:this.line,te=typeof B.character=="number"?B.character:this.character),Ee===this.line&&te===this.character?this:new w(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};K=w=qe([F],K),e.Position=K;let ie=s=class{static isRange(B){return B instanceof s?!0:B?K.isPosition(B.start)&&K.isPosition(B.end):!1}static of(B){if(B instanceof s)return B;if(this.isRange(B))return new s(B.start,B.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(B,te,Ee,Ke){let _e,ot;if(typeof B=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(_e=new K(B,te),ot=new K(Ee,Ke)):K.isPosition(B)&&K.isPosition(te)&&(_e=K.of(B),ot=K.of(te)),!_e||!ot)throw new Error("Invalid arguments");_e.isBefore(ot)?(this.c=_e,this.e=ot):(this.c=ot,this.e=_e)}contains(B){return s.isRange(B)?this.contains(B.start)&&this.contains(B.end):K.isPosition(B)?!(K.of(B).isBefore(this.c)||this.e.isBefore(B)):!1}isEqual(B){return this.c.isEqual(B.c)&&this.e.isEqual(B.e)}intersection(B){const te=K.Max(B.start,this.c),Ee=K.Min(B.end,this.e);if(!te.isAfter(Ee))return new s(te,Ee)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const te=K.Min(B.start,this.c),Ee=K.Max(B.end,this.end);return new s(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(B,te=this.end){if(B===null||te===null)throw(0,T.illegalArgument)();let Ee;return B?K.isPosition(B)?Ee=B:(Ee=B.start||this.start,te=B.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new s(Ee,te)}toJSON(){return[this.start,this.end]}};ie=s=qe([F],ie),e.Range=ie;let ge=r=class extends ie{static isSelection(B){return B instanceof r?!0:B?ie.isRange(B)&&K.isPosition(B.anchor)&&K.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(B,te,Ee,Ke){let _e,ot;if(typeof B=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(_e=new K(B,te),ot=new K(Ee,Ke)):K.isPosition(B)&&K.isPosition(te)&&(_e=K.of(B),ot=K.of(te)),!_e||!ot)throw new Error("Invalid arguments");super(_e,ot),this.f=_e,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ge=r=qe([F],ge),e.Selection=ge;class ce{constructor(B,te,Ee){if(typeof B!="string"||B.length===0)throw(0,T.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,T.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,T.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(te),this.connectionToken=Ee}}e.ResolvedAuthority=ce;class re extends Error{static NotAvailable(B,te){return new re(B,m.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(B){return new re(B,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(B,te=m.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(B),this._message=B,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,re.prototype)}}e.RemoteAuthorityResolverError=re;var se;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(se=e.EndOfLine||(e.EndOfLine={}));var le;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(le=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let _=a=class{static isTextEdit(B){return B instanceof a?!0:B?ie.isRange(B)&&typeof B.newText=="string":!1}static replace(B,te){return new a(B,te)}static insert(B,te){return a.replace(new ie(B,B),te)}static delete(B){return a.replace(B,"")}static setEndOfLine(B){const te=new a(new ie(new K(0,0),new K(0,0)),"");return te.newEol=B,te}get range(){return this.c}set range(B){if(B&&!ie.isRange(B))throw(0,T.illegalArgument)("range");this.c=B}get newText(){return this.e||""}set newText(B){if(B&&typeof B!="string")throw(0,T.illegalArgument)("newText");this.e=B}get newEol(){return this.f}set newEol(B){if(B&&typeof B!="number")throw(0,T.illegalArgument)("newEol");this.f=B}constructor(B,te){this.c=B,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};_=a=qe([F],_),e.TextEdit=_;let me=d=class{static isNotebookCellEdit(B){return B instanceof d?!0:B?Gt.isNotebookRange(B)&&Array.isArray(B.newCells):!1}static replaceCells(B,te){return new d(B,te)}static insertCells(B,te){return new d(new Gt(B,B),te)}static deleteCells(B){return new d(B,[])}static updateCellMetadata(B,te){const Ee=new d(new Gt(B,B),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(B){const te=new d(new Gt(0,0),[]);return te.newNotebookMetadata=B,te}constructor(B,te){this.range=B,this.newCells=te}};me=d=qe([F],me),e.NotebookEdit=me;class we{static isSnippetTextEdit(B){return B instanceof we?!0:B?ie.isRange(B.range)&&Qe.isSnippetString(B.snippet):!1}static replace(B,te){return new we(B,te)}static insert(B,te){return we.replace(new ie(B,B),te)}constructor(B,te){this.range=B,this.snippet=te}}e.SnippetTextEdit=we;var Ne;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(Ne=e.FileEditType||(e.FileEditType={}));let We=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(B,te,Ee,Ke){this.c.push({_type:1,from:B,to:te,options:Ee,metadata:Ke})}createFile(B,te,Ee){this.c.push({_type:1,from:void 0,to:B,options:te,metadata:Ee})}deleteFile(B,te,Ee){this.c.push({_type:1,from:B,to:void 0,options:te,metadata:Ee})}e(B,te,Ee){this.c.push({_type:3,metadata:Ee,uri:B,edit:{editType:5,metadata:te},notebookMetadata:te})}f(B,te,Ee,Ke){const _e=te.start,ot=te.end;(_e!==ot||Ee.length>0)&&this.c.push({_type:5,uri:B,index:_e,count:ot-_e,cells:Ee,metadata:Ke})}g(B,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:B,edit:{editType:8,index:te,metadata:Ee}})}replace(B,te,Ee,Ke){this.c.push({_type:2,uri:B,edit:new _(te,Ee),metadata:Ke})}insert(B,te,Ee,Ke){this.replace(B,new ie(te,te),Ee,Ke)}delete(B,te,Ee){this.replace(B,te,"",Ee)}has(B){return this.c.some(te=>te._type===2&&te.uri.toString()===B.toString())}set(B,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,_e;Array.isArray(Ee)?(Ke=Ee[0],_e=Ee[1]):Ke=Ee,me.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(B,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(B,Ke.newNotebookMetadata,_e):this.f(B,Ke.range,Ke.newCells,_e):we.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:B,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:B,edit:Ke,metadata:_e})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===B.toString()&&(this.c[Ee]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(B){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===B.toString()&&te.push(Ee.edit);return te}entries(){const B=new L.ResourceMap;for(const te of this.c)if(te._type===2){let Ee=B.get(te.uri);Ee||(Ee=[te.uri,[]],B.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};We=qe([F],We),e.WorkspaceEdit=We;let Qe=c=class{static isSnippetString(B){return B instanceof c?!0:B?typeof B.value=="string":!1}static c(B){return B.replace(/\$|}|\\/g,"\\$&")}constructor(B){this.e=1,this.value=B||""}appendText(B){return this.value+=c.c(B),this}appendTabstop(B=this.e++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,te=this.e++){if(typeof B=="function"){const Ee=new c;Ee.e=this.e,B(Ee),this.e=Ee.e,B=Ee.value}else B=c.c(B);return this.value+="${",this.value+=te,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,te=this.e++){const Ee=B.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(B,te){if(typeof te=="function"){const Ee=new c;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,te&&(this.value+=":",this.value+=te),this.value+="}",this}};Qe=c=qe([F],Qe),e.SnippetString=Qe;var Te;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var De;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(De=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=u=class{static isLocation(B){return B instanceof u?!0:B?ie.isRange(B.range)&&k.URI.isUri(B.uri):!1}constructor(B,te){if(this.uri=B,te)if(ie.isRange(te))this.range=ie.of(te);else if(K.isPosition(te))this.range=new ie(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=u=qe([F],ke),e.Location=ke;let oe=class{static is(B){return B?typeof B.message=="string"&&B.location&&ie.isRange(B.location.range)&&k.URI.isUri(B.location.uri):!1}constructor(B,te){this.location=B,this.message=te}static isEqual(B,te){return B===te?!0:!B||!te?!1:B.message===te.message&&B.location.range.isEqual(te.location.range)&&B.location.uri.toString()===te.location.uri.toString()}};oe=qe([F],oe),e.DiagnosticRelatedInformation=oe;let ue=class{constructor(B,te,Ee=De.Error){if(!ie.isRange(B))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=B,this.message=te,this.severity=Ee}toJSON(){return{severity:De[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,te){return B===te?!0:!B||!te?!1:B.message===te.message&&B.severity===te.severity&&B.code===te.code&&B.severity===te.severity&&B.source===te.source&&B.range.isEqual(te.range)&&(0,i.equals)(B.tags,te.tags)&&(0,i.equals)(B.relatedInformation,te.relatedInformation,oe.isEqual)}};ue=qe([F],ue),e.Diagnostic=ue;let Y=class{constructor(B,te){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=te}};Y=qe([F],Y),e.Hover=Y;var I;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let U=class{constructor(B,te=I.Text){this.range=B,this.kind=te}toJSON(){return{range:this.range,kind:I[this.kind]}}};U=qe([F],U),e.DocumentHighlight=U;var H;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(H=e.SymbolKind||(e.SymbolKind={}));var j;(function(W){W[W.Deprecated=1]="Deprecated"})(j=e.SymbolTag||(e.SymbolTag={}));let Z=n=class{static validate(B){if(!B.name)throw new Error("name must not be falsy")}constructor(B,te,Ee,Ke,_e){this.name=B,this.kind=te,this.containerName=_e,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof ke?this.location=Ke:Ee instanceof ie&&(this.location=new ke(Ke,Ee)),n.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};Z=n=qe([F],Z),e.SymbolInformation=Z;let de=f=class{static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children?.forEach(f.validate)}constructor(B,te,Ee,Ke,_e){this.name=B,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=_e,this.children=[],f.validate(this)}};de=f=qe([F],de),e.DocumentSymbol=de;var Se;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(Se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(B,te){this.title=B,this.kind=te}};ae=qe([F],ae),e.CodeAction=ae;let ve=g=class{constructor(B){this.value=B}append(B){return new g(this.value?this.value+g.c+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+g.c)}};ve.c=".",ve=g=qe([F],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let be=class{constructor(B,te){if(this.range=B,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=qe([F],be),e.SelectionRange=be;class $e{constructor(B,te,Ee,Ke,_e,ot){this.kind=B,this.name=te,this.detail=Ee,this.uri=Ke,this.range=_e,this.selectionRange=ot}}e.CallHierarchyItem=$e;class He{constructor(B,te){this.fromRanges=te,this.from=B}}e.CallHierarchyIncomingCall=He;class tt{constructor(B,te){this.fromRanges=te,this.to=B}}e.CallHierarchyOutgoingCall=tt;var xe;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(B,te){this.range=B,this.command=te}get isResolved(){return!!this.command}};et=qe([F],et),e.CodeLens=et;let it=P=class{static isMarkdownString(B){return B instanceof P?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}constructor(B,te=!1){o.set(this,void 0),Ye(this,o,new y.MarkdownString(B,{supportThemeIcons:te}),"f")}get value(){return Re(this,o,"f").value}set value(B){Re(this,o,"f").value=B}get isTrusted(){return Re(this,o,"f").isTrusted}set isTrusted(B){Re(this,o,"f").isTrusted=B}get supportThemeIcons(){return Re(this,o,"f").supportThemeIcons}set supportThemeIcons(B){Re(this,o,"f").supportThemeIcons=B}get supportHtml(){return Re(this,o,"f").supportHtml}set supportHtml(B){Re(this,o,"f").supportHtml=B}get baseUri(){return Re(this,o,"f").baseUri}set baseUri(B){Re(this,o,"f").baseUri=B}appendText(B){return Re(this,o,"f").appendText(B),this}appendMarkdown(B){return Re(this,o,"f").appendMarkdown(B),this}appendCodeblock(B,te){return Re(this,o,"f").appendCodeblock(te??"",B),this}};o=new WeakMap,it=P=qe([F],it),e.MarkdownString=it;let dt=class{constructor(B,te){this.label=B,this.documentation=te}};dt=qe([F],dt),e.ParameterInformation=dt;let Fe=class{constructor(B,te){this.label=B,this.documentation=te,this.parameters=[]}};Fe=qe([F],Fe),e.SignatureInformation=Fe;let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};st=qe([F],st),e.SignatureHelp=st;var Q;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(Q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var X;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(X=e.InlayHintKind||(e.InlayHintKind={}));let pe=class{constructor(B){this.value=B}};pe=qe([F],pe),e.InlayHintLabelPart=pe;let Me=class{constructor(B,te,Ee){this.position=B,this.label=te,this.kind=Ee}};Me=qe([F],Me),e.InlayHint=Me;var Be;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var Je;(function(W){W[W.Deprecated=1]="Deprecated"})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(B,te){this.label=B,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([F],nt),e.CompletionItem=nt;let vt=class{constructor(B=[],te=!1){this.items=B,this.isIncomplete=te}};vt=qe([F],vt),e.CompletionList=vt;let wt=class{constructor(B,te,Ee){this.insertText=B,this.range=te,this.command=Ee}};wt=qe([F],wt),e.InlineSuggestion=wt;let Tt=class{constructor(B){this.commands=void 0,this.items=B}};Tt=qe([F],Tt),e.InlineSuggestionList=Tt;var lt;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var at;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ut;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(Ut=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ft;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ct;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(Ct=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function B(te){switch(te){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=B}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Mt=class{constructor(B,te){if(te&&!k.URI.isUri(te))throw(0,T.illegalArgument)("target");if(!ie.isRange(B)||B.isEmpty)throw(0,T.illegalArgument)("range");this.range=B,this.target=te}};Mt=qe([F],Mt),e.DocumentLink=Mt;let Ge=class{constructor(B,te,Ee,Ke){this.red=B,this.green=te,this.blue=Ee,this.alpha=Ke}};Ge=qe([F],Ge),e.Color=Ge;let Rt=class{constructor(B,te){if(te&&!(te instanceof Ge))throw(0,T.illegalArgument)("color");if(!ie.isRange(B)||B.isEmpty)throw(0,T.illegalArgument)("range");this.range=B,this.color=te}};Rt=qe([F],Rt),e.ColorInformation=Rt;let Lt=class{constructor(B){if(!B||typeof B!="string")throw(0,T.illegalArgument)("label");this.label=B}};Lt=qe([F],Lt),e.ColorPresentation=Lt;var Ht;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ht=e.ColorFormat||(e.ColorFormat={}));var mt;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(mt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var At;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(At=e.TerminalExitReason||(e.TerminalExitReason={}));class ye{constructor(B,te,Ee){if(this.startIndex=B,this.length=te,this.tooltip=Ee,typeof B!="number"||B<0)throw(0,T.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,T.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=ye;var Pe;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(Pe=e.TerminalLocation||(e.TerminalLocation={}));class fe{constructor(B){if(this.options=B,typeof B!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=fe;var G;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(G=e.TaskRevealKind||(e.TaskRevealKind={}));var Ae;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(Ae=e.TaskPanelKind||(e.TaskPanelKind={}));let Le=M=class{static from(B){switch(B){case"clean":return M.Clean;case"build":return M.Build;case"rebuild":return M.Rebuild;case"test":return M.Test;default:return}}constructor(B,te){if(this.label=te,typeof B!="string"||typeof te!="string")throw(0,T.illegalArgument)("name");this.c=B}get id(){return this.c}};Le.Clean=new M("clean","Clean"),Le.Build=new M("build","Build"),Le.Rebuild=new M("rebuild","Rebuild"),Le.Test=new M("test","Test"),Le=M=qe([F],Le),e.TaskGroup=Le;function Xe(W){let B="";for(let te=0;te<W.length;te++)B+=W[te].replace(/,/g,",,")+",";return B}let ze=class{constructor(B,te,Ee){if(typeof B!="string")throw(0,T.illegalArgument)("process");this.e=[],this.c=B,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(B){if(typeof B!="string")throw(0,T.illegalArgument)("process");this.c=B}get args(){return this.e}set args(B){Array.isArray(B)||(B=[]),this.e=B}get options(){return this.f}set options(B){this.f=B}computeId(){const B=[];if(B.push("process"),this.c!==void 0&&B.push(this.c),this.e&&this.e.length>0)for(const te of this.e)B.push(te);return Xe(B)}};ze=qe([F],ze),e.ProcessExecution=ze;let Ze=class{constructor(B,te,Ee){if(this.f=[],Array.isArray(te)){if(!B)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,T.illegalArgument)("command");this.e=B,this.f=te,this.g=Ee}else{if(typeof B!="string")throw(0,T.illegalArgument)("commandLine");this.c=B,this.g=te}}get commandLine(){return this.c}set commandLine(B){if(typeof B!="string")throw(0,T.illegalArgument)("commandLine");this.c=B}get command(){return this.e?this.e:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,T.illegalArgument)("command");this.e=B}get args(){return this.f}set args(B){this.f=B||[]}get options(){return this.g}set options(B){this.g=B}computeId(){const B=[];if(B.push("shell"),this.c!==void 0&&B.push(this.c),this.e!==void 0&&B.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)B.push(typeof te=="string"?te:te.value);return Xe(B)}};Ze=qe([F],Ze),e.ShellExecution=Ze;var It;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class kt{constructor(B){this.c=B}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(B){this.c=B}get callback(){return this.c}}e.CustomExecution=kt;let gt=q=class{constructor(B,te,Ee,Ke,_e,ot){this.j=!1,this.k=this.definition=B;let ut;typeof te=="string"?(this.m=this.name=te,this.t=this.source=Ee,this.execution=Ke,ut=_e,this.j=!0):te===bt.Global||te===bt.Workspace?(this.target=te,this.m=this.name=Ee,this.t=this.source=Ke,this.execution=_e,ut=ot):(this.target=te,this.m=this.name=Ee,this.t=this.source=Ke,this.execution=_e,ut=ot),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(B){this.h=B}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ze?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof Ze?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof kt?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,N.generateUuid)()}}get definition(){return this.k}set definition(B){if(B==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=B}get scope(){return this.l}set target(B){this.y(),this.l=B}get name(){return this.m}set name(B){if(typeof B!="string")throw(0,T.illegalArgument)("name");this.y(),this.m=B}get execution(){return this.n}set execution(B){B===null&&(B=void 0),this.y(),this.n=B;const te=this.k.type;(q.g===te||q.e===te||q.f===te||q.c===te)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(B){if(Array.isArray(B))this.y(),this.o=B,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.y(),this.r=B}get source(){return this.t}set source(B){if(typeof B!="string"||B.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.y(),this.t=B}get group(){return this.u}set group(B){B===null&&(B=void 0),this.y(),this.u=B}get detail(){return this.x}set detail(B){B===null&&(B=void 0),this.x=B}get presentationOptions(){return this.v}set presentationOptions(B){B==null&&(B=Object.create(null)),this.y(),this.v=B}get runOptions(){return this.w}set runOptions(B){B==null&&(B=Object.create(null)),this.y(),this.w=B}};gt.c="customExecution",gt.e="process",gt.f="shell",gt.g="$empty",gt=q=qe([F],gt),e.Task=gt;var pt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(pt=e.ProgressLocation||(e.ProgressLocation={}));var St;(function(W){function B(te){const Ee=te;return(0,S.isNumber)(Ee.value)?Ee.tooltip&&!(0,S.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}W.isViewBadge=B})(St=e.ViewBadge||(e.ViewBadge={}));let $t=J=class{static isTreeItem(B,te){if(B instanceof J)return!0;const Ee=B;if(Ee.label!==void 0&&!(0,S.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,S.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,S.isString)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,S.isString)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}if(Ee.description!==void 0&&!(0,S.isString)(Ee.description)&&typeof Ee.description!="boolean")return console.log("INVALID tree item, invalid description",Ee.description),!1;if(Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1;if(Ee.tooltip!==void 0&&!(0,S.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1;if(Ee.command!==void 0&&!Ee.command.command)return console.log("INVALID tree item, invalid command",Ee.command),!1;if(Ee.collapsibleState!==void 0&&Ee.collapsibleState<Xt.None&&Ee.collapsibleState>Xt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1;if(Ee.contextValue!==void 0&&!(0,S.isString)(Ee.contextValue))return console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1;if(Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1;if(Ee.checkboxState!==void 0){(0,h.checkProposedApiEnabled)(te,"treeItemCheckbox");const Ke=(0,S.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,S.isObject)(Ee.checkboxState)&&(0,S.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,_e=!(0,S.isNumber)(Ee.checkboxState)&&(0,S.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Et.Checked&&Ke!==Et.Unchecked||_e!==void 0&&!(0,S.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}return!0}constructor(B,te=Xt.None){this.collapsibleState=te,k.URI.isUri(B)?this.resourceUri=B:this.label=B}};$t=J=qe([F],$t),e.TreeItem=$t;var Xt;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Xt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Et;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(Et=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let si=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(B,te){this.value=B,this.id=te??(0,N.generateUuid)()}};si=qe([F],si),e.DataTransferItem=si;let oi=class{constructor(B){l.set(this,new Map);for(const[te,Ee]of B??[]){const Ke=Re(this,l,"f").get(te);Ke?Ke.push(Ee):Re(this,l,"f").set(te,[Ee])}}get(B){return Re(this,l,"f").get(B)?.[0]}set(B,te){Re(this,l,"f").set(B,[te])}forEach(B,te){for(const[Ee,Ke]of Re(this,l,"f"))for(const _e of Ke)B.call(te,_e,Ee,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[B,te]of Re(this,l,"f"))for(const Ee of te)yield[B,Ee]}};oi=qe([F],oi),e.DataTransfer=oi;let Zt=class{constructor(B){this.insertText=B}};Zt=qe([F],Zt),e.DocumentDropEdit=Zt;let pi=class{constructor(B){this.insertText=B}};pi=qe([F],pi),e.DocumentPasteEdit=pi;let yt=class{constructor(B,te){this.id=B,this.color=te}static isThemeIcon(B){return typeof B.id!="string"?(console.log("INVALID ThemeIcon, invalid id",B.id),!1):!0}};yt=qe([F],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let ai=class{constructor(B){this.id=B}};ai=qe([F],ai),e.ThemeColor=ai;var Oi;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(Oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(B){this.c=B,this.e=k.URI.file(B)}get baseUri(){return this.e}set baseUri(B){this.e=B,this.c=B.fsPath}constructor(B,te){if(typeof B!="string"&&(!B||!k.URI.isUri(B)&&!k.URI.isUri(B.uri)))throw(0,T.illegalArgument)("base");if(typeof te!="string")throw(0,T.illegalArgument)("pattern");typeof B=="string"?this.baseUri=k.URI.file(B):k.URI.isUri(B)?this.baseUri=B:this.baseUri=B.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([F],ei),e.RelativePattern=ei;let Vt=class{constructor(B,te,Ee,Ke){this.enabled=typeof B=="boolean"?B:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,N.generateUuid)()),this.c}};Vt=qe([F],Vt),e.Breakpoint=Vt;let ct=class extends Vt{constructor(B,te,Ee,Ke,_e){if(super(te,Ee,Ke,_e),B===null)throw(0,T.illegalArgument)("location");this.location=B}};ct=qe([F],ct),e.SourceBreakpoint=ct;let vi=class extends Vt{constructor(B,te,Ee,Ke,_e){super(te,Ee,Ke,_e),this.functionName=B}};vi=qe([F],vi),e.FunctionBreakpoint=vi;let jt=class extends Vt{constructor(B,te,Ee,Ke,_e,ot,ut){if(super(Ke,_e,ot,ut),!te)throw(0,T.illegalArgument)("dataId");this.label=B,this.dataId=te,this.canPersist=Ee}};jt=qe([F],jt),e.DataBreakpoint=jt;let Qt=class{constructor(B,te,Ee){this.command=B,this.args=te||[],this.options=Ee}};Qt=qe([F],Qt),e.DebugAdapterExecutable=Qt;let ci=class{constructor(B,te){this.port=B,this.host=te}};ci=qe([F],ci),e.DebugAdapterServer=ci;let bi=class{constructor(B){this.path=B}};bi=qe([F],bi),e.DebugAdapterNamedPipeServer=bi;let ui=class{constructor(B){this.implementation=B}};ui=qe([F],ui),e.DebugAdapterInlineImplementation=ui;let Ei=class{constructor(B,te){this.range=B,this.expression=te}};Ei=qe([F],Ei),e.EvaluatableExpression=Ei;var Ci;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(Ci=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(B,te){this.range=B,this.text=te}};ti=qe([F],ti),e.InlineValueText=ti;let wi=class{constructor(B,te,Ee=!0){this.range=B,this.variableName=te,this.caseSensitiveLookup=Ee}};wi=qe([F],wi),e.InlineValueVariableLookup=wi;let ni=class{constructor(B,te){this.range=B,this.expression=te}};ni=qe([F],ni),e.InlineValueEvaluatableExpression=ni;let ri=class{constructor(B,te){this.frameId=B,this.stoppedLocation=te}};ri=qe([F],ri),e.InlineValueContext=ri;var Fi;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Fi=e.FileChangeType||(e.FileChangeType={}));let Si=x=class extends Error{static FileExists(B){return new x(B,D.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(B){return new x(B,D.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(B){return new x(B,D.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(B){return new x(B,D.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(B){return new x(B,D.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(B){return new x(B,D.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(B,te=D.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(B)?B.toString(!0):B),this.code=Ee?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,te),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};Si=x=qe([F],Si),e.FileSystemError=Si;let _t=class{constructor(B,te,Ee){this.start=B,this.end=te,this.kind=Ee}};_t=qe([F],_t),e.FoldingRange=_t;var Ni;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Ni=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mi;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Mi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Li;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(Li=e.CommentMode||(e.CommentMode={}));var Ui;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(Ui=e.CommentThreadState||(e.CommentThreadState={}));class Bi{constructor(B,te=[]){this.tokenTypes=B,this.tokenModifiers=te}}e.SemanticTokensLegend=Bi;function yi(W){return typeof W>"u"||(0,S.isStringArray)(W)}class li{constructor(B){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,B){this.l=!0;for(let te=0,Ee=B.tokenTypes.length;te<Ee;te++)this.j.set(B.tokenTypes[te],te);for(let te=0,Ee=B.tokenModifiers.length;te<Ee;te++)this.k.set(B.tokenModifiers[te],te)}}push(B,te,Ee,Ke,_e){if(typeof B=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(B,te,Ee,Ke,_e);if(ie.isRange(B)&&typeof te=="string"&&yi(Ee))return this.m(B,te,Ee);throw(0,T.illegalArgument)()}m(B,te,Ee){if(!this.l)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=B.start.line,_e=B.start.character,ot=B.end.character-B.start.character,ut=this.j.get(te);let Ot=0;if(Ee)for(const Wt of Ee){if(!this.k.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Wt);Ot|=1<<qt>>>0}this.n(Ke,_e,ot,ut,Ot)}n(B,te,Ee,Ke,_e){if(this.f&&(B<this.c||B===this.c&&te<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Wt=0,qt=0;for(let xt=0;xt<Ot;xt++){let Yt=this.g[5*xt],Di=this.g[5*xt+1];Yt===0?(Yt=Wt,Di+=qt):Yt+=Wt,this.g[5*xt]=Yt,this.g[5*xt+1]=Di,Wt=Yt,qt=Di}}let ot=B,ut=te;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ut-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ut,this.g[this.h++]=Ee,this.g[this.h++]=Ke,this.g[this.h++]=_e,this.c=B,this.e=te}static o(B){const te=[],Ee=B.length/5|0;for(let ut=0;ut<Ee;ut++)te[ut]=ut;te.sort((ut,Ot)=>{const Wt=B[5*ut],qt=B[5*Ot];if(Wt===qt){const xt=B[5*ut+1],Yt=B[5*Ot+1];return xt-Yt}return Wt-qt});const Ke=new Uint32Array(B.length);let _e=0,ot=0;for(let ut=0;ut<Ee;ut++){const Ot=5*te[ut],Wt=B[Ot+0],qt=B[Ot+1],xt=B[Ot+2],Yt=B[Ot+3],Di=B[Ot+4],en=Wt-_e,Cn=en===0?qt-ot:qt,Ii=5*ut;Ke[Ii+0]=en,Ke[Ii+1]=Cn,Ke[Ii+2]=xt,Ke[Ii+3]=Yt,Ke[Ii+4]=Di,_e=Wt,ot=qt}return Ke}build(B){return this.f?new di(new Uint32Array(this.g),B):new di(li.o(this.g),B)}}e.SemanticTokensBuilder=li;class di{constructor(B,te){this.resultId=te,this.data=B}}e.SemanticTokens=di;class Ue{constructor(B,te,Ee){this.start=B,this.deleteCount=te,this.data=Ee}}e.SemanticTokensEdit=Ue;class Kt{constructor(B,te){this.resultId=te,this.edits=B}}e.SemanticTokensEdits=Kt;var ki;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(ki=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ht=class{constructor(){}};ht.Back={iconPath:new yt("arrow-left")},ht=qe([F],ht),e.QuickInputButtons=ht;var $i;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})($i=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(zi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ti;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(Ti=e.ExtensionKind||(e.ExtensionKind={}));class Wi{static validate(B){if(typeof B.badge=="string"){let te=(0,O.nextCharLength)(B.badge,0);if(te<B.badge.length&&(te+=(0,O.nextCharLength)(B.badge,te)),B.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(B.badge&&!yt.isThemeIcon(B.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty");return!0}constructor(B,te,Ee){this.badge=B,this.tooltip=te,this.color=Ee}}e.FileDecoration=Wi;let ii=class{constructor(B){this.kind=B}};ii=qe([F],ii),e.ColorTheme=ii;var Hi;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(Hi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(B){return B instanceof Gt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(B,te){if(B<0)throw(0,T.illegalArgument)("start must be positive");if(te<0)throw(0,T.illegalArgument)("end must be positive");B<=te?(this.c=B,this.e=te):(this.c=te,this.e=B)}with(B){let te=this.c,Ee=this.e;return B.start!==void 0&&(te=B.start),B.end!==void 0&&(Ee=B.end),te===this.c&&Ee===this.e?this:new Gt(te,Ee)}}e.NotebookRange=Gt;class hi{static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(te=>hi.isNotebookCellData(te))}static isNotebookCellData(B){return!0}constructor(B,te,Ee,Ke,_e,ot,ut){this.kind=B,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=_e??[],this.metadata=ot,this.executionSummary=ut,hi.validate(this)}}e.NotebookCellData=hi;class Pi{constructor(B){this.cells=B}}e.NotebookData=Pi;class zt{static isNotebookCellOutputItem(B){return B instanceof zt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const te={name:B.name,message:B.message,stack:B.stack};return zt.json(te,"application/vnd.code.notebook.error")}static stdout(B){return zt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return zt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,te="application/octet-stream"){return new zt(B,te)}static text(B,te=C.Mimes.text){const Ee=Re(zt,b,"f",E).encode(String(B));return new zt(Ee,te)}static json(B,te="text/x-json"){const Ee=JSON.stringify(B,void 0,"	");return zt.text(Ee,te)}constructor(B,te){this.data=B,this.mime=te;const Ee=(0,C.normalizeMimeType)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.NotebookCellOutputItem=zt,b=zt,E={value:new TextEncoder};class fi{static isNotebookCellOutput(B){return B instanceof fi?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&Array.isArray(B.items)}static ensureUniqueMimeTypes(B,te=!1){const Ee=new Set,Ke=new Set;for(let _e=0;_e<B.length;_e++){const ot=B[_e],ut=(0,C.normalizeMimeType)(ot.mime);if(!Ee.has(ut)||(0,v.isTextStreamMime)(ut)){Ee.add(ut);continue}Ke.add(_e),te&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?B:B.filter((_e,ot)=>!Ke.has(ot))}constructor(B,te,Ee){this.items=fi.ensureUniqueMimeTypes(B,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,N.generateUuid)(),this.metadata=te??Ee)}}e.NotebookCellOutput=fi;var Vi;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(Vi=e.NotebookCellKind||(e.NotebookCellKind={}));var ji;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(ji=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var qi;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(qi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ki;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ki=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ne{constructor(B,te){this.text=B,this.alignment=te}}e.NotebookCellStatusBarItem=ne;var he;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(he=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Oe;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(Oe=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rt{constructor(B,te=[]){this.uri=B,this.provides=(0,i.asArray)(te)}}e.NotebookRendererScript=rt;class Dt{constructor(B){this.label=B}}e.NotebookKernelSourceAction=Dt;let Pt=class{constructor(B,te){this.label=B,this.timestamp=te}};Pt=qe([F],Pt),e.TimelineItem=Pt;var sn;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(sn=e.ExtensionMode||(e.ExtensionMode={}));var on;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(on=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class cn{constructor(B,te){this.ranges=B,this.wordPattern=te}}e.LinkedEditingRanges=cn;class un{constructor(B,te){this.c=B,this.e=te}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=un;var ln;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(ln=e.TestResultState||(e.TestResultState={}));var dn;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(dn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Gi=class{constructor(B=void 0,te=void 0,Ee=void 0){this.include=B,this.exclude=te,this.profile=Ee}};Gi=qe([F],Gi),e.TestRunRequest=Gi;let xi=R=class{static diff(B,te,Ee){const Ke=new R(B);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(B){this.message=B}};xi=R=qe([F],xi),e.TestMessage=xi;let Xi=class{constructor(B){this.id=B}};Xi=qe([F],Xi),e.TestTag=Xi;let mi=class{constructor(B,te){this.covered=B,this.total=te}};mi=qe([F],mi),e.CoveredCount=mi;let Qi=A=class{static fromDetails(B,te){const Ee=new mi(0,0),Ke=new mi(0,0),_e=new mi(0,0);for(const ut of te)if("branches"in ut){Ee.total+=1,Ee.covered+=ut.executionCount>0?1:0;for(const Ot of ut.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else _e.total+=1,_e.covered+=ut.executionCount>0?1:0;const ot=new A(B,Ee,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return ot.detailedCoverage=te,ot}constructor(B,te,Ee,Ke){this.uri=B,this.statementCoverage=te,this.branchCoverage=Ee,this.functionCoverage=Ke}};Qi=A=qe([F],Qi),e.FileCoverage=Qi;let _i=class{constructor(B,te,Ee=[]){this.executionCount=B,this.location=te,this.branches=Ee}};_i=qe([F],_i),e.StatementCoverage=_i;let Yi=class{constructor(B,te){this.executionCount=B,this.location=te}};Yi=qe([F],Yi),e.BranchCoverage=Yi;let Ji=class{constructor(B,te){this.executionCount=B,this.location=te}};Ji=qe([F],Ji),e.FunctionCoverage=Ji;var hn;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mn;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gn{constructor(B,te,Ee,Ke,_e,ot){this.kind=B,this.name=te,this.detail=Ee,this.uri=Ke,this.range=_e,this.selectionRange=ot}}e.TypeHierarchyItem=gn;class pn{constructor(B){this.uri=B}}e.TextTabInput=pn;class vn{constructor(B,te){this.original=B,this.modified=te}}e.TextDiffTabInput=vn;class bn{constructor(B,te,Ee,Ke){this.base=B,this.input1=te,this.input2=Ee,this.result=Ke}}e.TextMergeTabInput=bn;class En{constructor(B,te){this.uri=B,this.viewType=te}}e.CustomEditorTabInput=En;class wn{constructor(B){this.viewType=B}}e.WebviewEditorTabInput=wn;class Sn{constructor(B,te){this.uri=B,this.notebookType=te}}e.NotebookEditorTabInput=Sn;class yn{constructor(B,te,Ee){this.original=B,this.modified=te,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=yn;class Dn{constructor(){}}e.TerminalEditorTabInput=Dn;class In{constructor(B,te){this.uri=B,this.inputBoxUri=te}}e.InteractiveWindowInput=In}),define(Ie[95],Ce([1,0,47,13,10,249,126,6,16]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function N(h,t){t?k.set(h,t):k.delete(h)}e.setWordDefinitionFor=N;function D(h){return k.get(h)}class m extends L.MirrorTextModel{constructor(t,o,l,b,E,p,w,s){super(o,l,b,E),this.m=t,this.p=p,this.q=w,this.notebook=s,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(t){return(0,S.equals)(this.d,t)}get document(){if(!this.a){const t=this;this.a={get uri(){return t.c},get fileName(){return t.c.fsPath},get isUntitled(){return t.c.scheme===T.Schemas.untitled},get languageId(){return t.p},get version(){return t.g},get isClosed(){return t.b},get isDirty(){return t.q},save(){return t.r()},getText(o){return o?t.s(o):t.getText()},get eol(){return t.f===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return t.d.length},lineAt(o){return t.t(o)},offsetAt(o){return t.u(o)},positionAt(o){return t.v(o)},validateRange(o){return t.w(o)},validatePosition(o){return t.x(o)},getWordRangeAtPosition(o,l){return t.y(o,l)}}}return Object.freeze(this.a)}_acceptLanguageId(t){(0,i.ok)(!this.b),this.p=t}_acceptIsDirty(t){(0,i.ok)(!this.b),this.q=t}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(t){const o=this.w(t);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const l=this.f,b=o.start.line,E=o.end.line,p=[];p.push(this.d[b].substring(o.start.character));for(let w=b+1;w<E;w++)p.push(this.d[w]);return p.push(this.d[E].substring(0,o.end.character)),p.join(l)}t(t){let o;if(t instanceof O.Position?o=t.line:typeof t=="number"&&(o=t),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.d[o],o===this.d.length-1)}u(t){return t=this.x(t),this.k(),this.h.getPrefixSum(t.line-1)+t.character}v(t){t=Math.floor(t),t=Math.max(0,t),this.k();const o=this.h.getIndexOf(t),l=this.d[o.index].length;return new O.Position(o.index,Math.min(o.remainder,l))}w(t){if(!(t instanceof O.Range))throw new Error("Invalid argument");const o=this.x(t.start),l=this.x(t.end);return o===t.start&&l===t.end?t:new O.Range(o.line,o.character,l.line,l.character)}x(t){if(!(t instanceof O.Position))throw new Error("Invalid argument");if(this.d.length===0)return t.with(0,0);let{line:o,character:l}=t,b=!1;if(o<0)o=0,l=0,b=!0;else if(o>=this.d.length)o=this.d.length-1,l=this.d[o].length,b=!0;else{const E=this.d[o].length;l<0?(l=0,b=!0):l>E&&(l=E,b=!0)}return b?new O.Position(o,l):t}y(t,o){const l=this.x(t);if(!o)o=D(this.p);else if((0,y.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const b=(0,C.getWordAtText)(l.character+1,(0,C.ensureValidWordDefinition)(o),this.d[l.line],0);if(b)return new O.Range(l.line,b.startColumn-1,l.line,b.endColumn-1)}}e.ExtHostDocumentData=m;class v{constructor(t,o,l){this.a=t,this.b=o,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=v}),define(Ie[184],Ce([1,0,6,15,5]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(O){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new y.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(O){let S;switch(O){case"light":S=i.ColorThemeKind.Light;break;case"hcDark":S=i.ColorThemeKind.HighContrast;break;case"hcLight":S=i.ColorThemeKind.HighContrastLight;break;default:S=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};L=qe([Ve(0,T.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(Ie[8],Ce([1,0,16,24,112,185,81,28,109,80,61,23,9,2,54,71,86,93,92,66,42,53,179,6]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E,p,w,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ye){function Pe(G){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:Xe,positionColumn:ze}=G,Ze=new r.Position(Ae-1,Le-1),It=new r.Position(Xe-1,ze-1);return new r.Selection(Ze,It)}ye.to=Pe;function fe(G){const{anchor:Ae,active:Le}=G;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ye.from=fe})(a=e.Selection||(e.Selection={}));var d;(function(ye){function Pe(G){if(!G)return;const{start:Ae,end:Le}=G;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ye.from=Pe;function fe(G){if(!G)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:Xe,endColumn:ze}=G;return new r.Range(Ae-1,Le-1,Xe-1,ze-1)}ye.to=fe})(d=e.Range||(e.Range={}));var c;(function(ye){function Pe(fe){switch(fe){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}ye.to=Pe})(c=e.TokenType||(e.TokenType={}));var u;(function(ye){function Pe(G){return new r.Position(G.lineNumber-1,G.column-1)}ye.to=Pe;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}ye.from=fe})(u=e.Position||(e.Position={}));var n;(function(ye){function Pe(Ae,Le){return(0,i.coalesce)((0,i.asArray)(Ae).map(Xe=>fe(Xe,Le)))}ye.from=Pe;function fe(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:G(Ae.scheme,Le),pattern:X.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function G(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(n=e.DocumentSelector||(e.DocumentSelector={}));var f;(function(ye){function Pe(G){switch(G){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}ye.from=Pe;function fe(G){switch(G){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}ye.to=fe})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(ye){function Pe(G){let Ae;return G.code&&((0,m.isString)(G.code)||(0,m.isNumber)(G.code)?Ae=String(G.code):Ae={value:String(G.code.value),target:G.code.target}),{...d.from(G.range),message:G.message,source:G.source,code:Ae,severity:M.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(P.from),tags:Array.isArray(G.tags)?(0,i.coalesce)(G.tags.map(f.from)):void 0}}ye.from=Pe;function fe(G){const Ae=new r.Diagnostic(d.to(G),G.message,M.to(G.severity));return Ae.source=G.source,Ae.code=(0,m.isString)(G.code)?G.code:G.code?.value,Ae.relatedInformation=G.relatedInformation&&G.relatedInformation.map(P.to),Ae.tags=G.tags&&(0,i.coalesce)(G.tags.map(f.to)),Ae}ye.to=fe})(g=e.Diagnostic||(e.Diagnostic={}));var P;(function(ye){function Pe(G){return{...d.from(G.location.range),message:G.message,resource:G.location.uri}}ye.from=Pe;function fe(G){return new r.DiagnosticRelatedInformation(new r.Location(G.resource,d.to(G)),G.message)}ye.to=fe})(P=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var M;(function(ye){function Pe(G){switch(G){case r.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}ye.from=Pe;function fe(G){switch(G){case o.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}ye.to=fe})(M=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var q;(function(ye){function Pe(G){return typeof G=="number"&&G>=r.ViewColumn.One?G-1:G===r.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}ye.from=Pe;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=fe})(q=e.ViewColumn||(e.ViewColumn={}));function J(ye){return typeof ye.range<"u"}function x(ye){return ye.length===0?!0:!!J(ye[0])}e.isDecorationOptionsArr=x;var R;(function(ye){function Pe(ze){return ze.map(ye.from)}ye.fromMany=Pe;function fe(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function G(ze){let Ze;if(fe(ze)){const{language:gt,value:pt}=ze;Ze={value:"```"+gt+`
`+pt+"\n```\n"}}else r.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const It=Object.create(null);Ze.uris=It;const bt=gt=>{try{let pt=v.URI.parse(gt,!0);pt=pt.with({query:Ae(pt.query,It)}),It[gt]=pt}catch{}return""},kt=new S.marked.Renderer;return kt.link=bt,kt.image=gt=>typeof gt=="string"?bt(C.parseHrefAndDimensions(gt).href):"",(0,S.marked)(Ze.value,{renderer:kt}),Ze}ye.from=G;function Ae(ze,Ze){if(!ze)return ze;let It;try{It=(0,k.parse)(ze)}catch{}if(!It)return ze;let bt=!1;return It=(0,D.cloneAndChange)(It,kt=>{if(v.URI.isUri(kt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[gt]=kt,bt=!0,gt}else return}),bt?JSON.stringify(It):ze}function Le(ze){const Ze=new r.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?v.URI.from(ze.baseUri):void 0,Ze}ye.to=Le;function Xe(ze){if(!!ze)return typeof ze=="string"?ze:ye.from(ze)}ye.fromStrict=Xe})(R=e.MarkdownString||(e.MarkdownString={}));function A(ye){return x(ye)?ye.map(Pe=>({range:d.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?R.fromMany(Pe.hoverMessage):Pe.hoverMessage?R.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):ye.map(Pe=>({range:d.from(Pe)}))}e.fromRangeOrRangeWithMessage=A;function F(ye){return typeof ye>"u"?ye:typeof ye=="string"?v.URI.file(ye):ye}e.pathOrURIToURI=F;var $;(function(ye){function Pe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?F(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ye.from=Pe})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(ye){function Pe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?F(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?$.from(fe.before):void 0,after:fe.after?$.from(fe.after):void 0}}ye.from=Pe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(ye){function Pe(fe){if(typeof fe>"u")return fe;switch(fe){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Pe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var K;(function(ye){function Pe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?V.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?z.from(fe.light):void 0,dark:fe.dark?z.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?F(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?$.from(fe.before):void 0,after:fe.after?$.from(fe.after):void 0}}ye.from=Pe})(K=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(ye){function Pe(G){return{text:G.newText,eol:G.newEol&&it.from(G.newEol),range:d.from(G.range)}}ye.from=Pe;function fe(G){const Ae=new r.TextEdit(d.to(G.range),G.text);return Ae.newEol=typeof G.eol>"u"?void 0:it.to(G.eol),Ae}ye.to=fe})(ie=e.TextEdit||(e.TextEdit={}));var ge;(function(ye){function Pe(G,Ae){const Le={edits:[]};if(G instanceof r.WorkspaceEdit){const Xe=new O.ResourceSet;for(const ze of G._allEntries())ze._type===1&&v.URI.isUri(ze.to)&&ze.from===void 0&&Xe.add(ze.to);for(const ze of G._allEntries())ze._type===1?Le.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,T.encodeBase64)(T.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Le.edits.push({resource:ze.uri,textEdit:ie.from(ze.edit),versionId:Xe.has(ze.uri)?void 0:Ae?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Le.edits.push({resource:ze.uri,textEdit:{range:d.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Xe.has(ze.uri)?void 0:Ae?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Le.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Le.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(vt.from)}})}return Le}ye.from=Pe;function fe(G){const Ae=new r.WorkspaceEdit;for(const Le of G.edits)Le.textEdit?Ae.replace(v.URI.revive(Le.resource),d.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(v.URI.revive(Le.oldResource),v.URI.revive(Le.newResource),Le.options);return Ae}ye.to=fe})(ge=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ce;(function(ye){const Pe=Object.create(null);Pe[r.SymbolKind.File]=0,Pe[r.SymbolKind.Module]=1,Pe[r.SymbolKind.Namespace]=2,Pe[r.SymbolKind.Package]=3,Pe[r.SymbolKind.Class]=4,Pe[r.SymbolKind.Method]=5,Pe[r.SymbolKind.Property]=6,Pe[r.SymbolKind.Field]=7,Pe[r.SymbolKind.Constructor]=8,Pe[r.SymbolKind.Enum]=9,Pe[r.SymbolKind.Interface]=10,Pe[r.SymbolKind.Function]=11,Pe[r.SymbolKind.Variable]=12,Pe[r.SymbolKind.Constant]=13,Pe[r.SymbolKind.String]=14,Pe[r.SymbolKind.Number]=15,Pe[r.SymbolKind.Boolean]=16,Pe[r.SymbolKind.Array]=17,Pe[r.SymbolKind.Object]=18,Pe[r.SymbolKind.Key]=19,Pe[r.SymbolKind.Null]=20,Pe[r.SymbolKind.EnumMember]=21,Pe[r.SymbolKind.Struct]=22,Pe[r.SymbolKind.Event]=23,Pe[r.SymbolKind.Operator]=24,Pe[r.SymbolKind.TypeParameter]=25;function fe(Ae){return typeof Pe[Ae]=="number"?Pe[Ae]:6}ye.from=fe;function G(Ae){for(const Le in Pe)if(Pe[Le]===Ae)return Number(Le);return r.SymbolKind.Property}ye.to=G})(ce=e.SymbolKind||(e.SymbolKind={}));var re;(function(ye){function Pe(G){switch(G){case r.SymbolTag.Deprecated:return 1}}ye.from=Pe;function fe(G){switch(G){case 1:return r.SymbolTag.Deprecated}}ye.to=fe})(re=e.SymbolTag||(e.SymbolTag={}));var se;(function(ye){function Pe(G){return{name:G.name,kind:ce.from(G.kind),tags:G.tags&&G.tags.map(re.from),containerName:G.containerName,location:Ne.from(G.location)}}ye.from=Pe;function fe(G){const Ae=new r.SymbolInformation(G.name,ce.to(G.kind),G.containerName,Ne.to(G.location));return Ae.tags=G.tags&&G.tags.map(re.to),Ae}ye.to=fe})(se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(ye){function Pe(G){const Ae={name:G.name||"!!MISSING: name!!",detail:G.detail,range:d.from(G.range),selectionRange:d.from(G.selectionRange),kind:ce.from(G.kind),tags:G.tags?.map(re.from)??[]};return G.children&&(Ae.children=G.children.map(Pe)),Ae}ye.from=Pe;function fe(G){const Ae=new r.DocumentSymbol(G.name,G.detail,ce.to(G.kind),d.to(G.range),d.to(G.selectionRange));return(0,i.isNonEmptyArray)(G.tags)&&(Ae.tags=G.tags.map(re.to)),G.children&&(Ae.children=G.children.map(fe)),Ae}ye.to=fe})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var _;(function(ye){function Pe(G){const Ae=new r.CallHierarchyItem(ce.to(G.kind),G.name,G.detail||"",v.URI.revive(G.uri),d.to(G.range),d.to(G.selectionRange));return Ae._sessionId=G._sessionId,Ae._itemId=G._itemId,Ae}ye.to=Pe;function fe(G,Ae,Le){if(Ae=Ae??G._sessionId,Le=Le??G._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:G.name,detail:G.detail,kind:ce.from(G.kind),uri:G.uri,range:d.from(G.range),selectionRange:d.from(G.selectionRange),tags:G.tags?.map(re.from)}}ye.from=fe})(_=e.CallHierarchyItem||(e.CallHierarchyItem={}));var me;(function(ye){function Pe(fe){return new r.CallHierarchyIncomingCall(_.to(fe.from),fe.fromRanges.map(G=>d.to(G)))}ye.to=Pe})(me=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var we;(function(ye){function Pe(fe){return new r.CallHierarchyOutgoingCall(_.to(fe.to),fe.fromRanges.map(G=>d.to(G)))}ye.to=Pe})(we=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ne;(function(ye){function Pe(G){return{range:G.range&&d.from(G.range),uri:G.uri}}ye.from=Pe;function fe(G){return new r.Location(v.URI.revive(G.uri),d.to(G.range))}ye.to=fe})(Ne=e.location||(e.location={}));var We;(function(ye){function Pe(G){const Ae=G,Le=G;return{originSelectionRange:Ae.originSelectionRange?d.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:d.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?d.from(Ae.targetSelectionRange):void 0}}ye.from=Pe;function fe(G){return{targetUri:v.URI.revive(G.uri),targetRange:d.to(G.range),targetSelectionRange:G.targetSelectionRange?d.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?d.to(G.originSelectionRange):void 0}}ye.to=fe})(We=e.DefinitionLink||(e.DefinitionLink={}));var Qe;(function(ye){function Pe(G){return{range:d.from(G.range),contents:R.fromMany(G.contents)}}ye.from=Pe;function fe(G){return new r.Hover(G.contents.map(R.to),d.to(G.range))}ye.to=fe})(Qe=e.Hover||(e.Hover={}));var Te;(function(ye){function Pe(G){return{range:d.from(G.range),expression:G.expression}}ye.from=Pe;function fe(G){return new r.EvaluatableExpression(d.to(G.range),G.expression)}ye.to=fe})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var De;(function(ye){function Pe(G){if(G instanceof r.InlineValueText)return{type:"text",range:d.from(G.range),text:G.text};if(G instanceof r.InlineValueVariableLookup)return{type:"variable",range:d.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Pe;function fe(G){switch(G.type){case"text":return{range:d.to(G.range),text:G.text};case"variable":return{range:d.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:d.to(G.range),expression:G.expression}}}ye.to=fe})(De=e.InlineValue||(e.InlineValue={}));var ke;(function(ye){function Pe(G){return{frameId:G.frameId,stoppedLocation:d.from(G.stoppedLocation)}}ye.from=Pe;function fe(G){return new r.InlineValueContext(G.frameId,d.to(G.stoppedLocation))}ye.to=fe})(ke=e.InlineValueContext||(e.InlineValueContext={}));var oe;(function(ye){function Pe(G){return{range:d.from(G.range),kind:G.kind}}ye.from=Pe;function fe(G){return new r.DocumentHighlight(d.to(G.range),G.kind)}ye.to=fe})(oe=e.DocumentHighlight||(e.DocumentHighlight={}));var ue;(function(ye){function Pe(fe){switch(fe){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}ye.to=Pe})(ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(ye){function Pe(fe){return{triggerKind:ue.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ye.to=Pe})(Y=e.CompletionContext||(e.CompletionContext={}));var I;(function(ye){function Pe(G){switch(G){case r.CompletionItemTag.Deprecated:return 1}}ye.from=Pe;function fe(G){switch(G){case 1:return r.CompletionItemTag.Deprecated}}ye.to=fe})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(ye){const Pe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function fe(Le){return Pe.get(Le)??9}ye.from=fe;const G=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ae(Le){return G.get(Le)??r.CompletionItemKind.Property}ye.to=Ae})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(ye){function Pe(fe,G){const Ae=new r.CompletionItem(fe.label);return Ae.insertText=fe.insertText,Ae.kind=U.to(fe.kind),Ae.tags=fe.tags?.map(I.to),Ae.detail=fe.detail,Ae.documentation=C.isMarkdownString(fe.documentation)?R.to(fe.documentation):fe.documentation,Ae.sortText=fe.sortText,Ae.filterText=fe.filterText,Ae.preselect=fe.preselect,Ae.commitCharacters=fe.commitCharacters,h.Range.isIRange(fe.range)?Ae.range=d.to(fe.range):typeof fe.range=="object"&&(Ae.range={inserting:d.to(fe.range.insert),replacing:d.to(fe.range.replace)}),Ae.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Ae.insertText=new r.SnippetString(fe.insertText):(Ae.insertText=fe.insertText,Ae.textEdit=Ae.range instanceof r.Range?new r.TextEdit(Ae.range,Ae.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ae.additionalTextEdits=fe.additionalTextEdits.map(Le=>ie.to(Le))),Ae.command=G&&fe.command?G.fromInternal(fe.command):void 0,Ae}ye.to=Pe})(H=e.CompletionItem||(e.CompletionItem={}));var j;(function(ye){function Pe(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:R.fromStrict(G.documentation)}}ye.from=Pe;function fe(G){return{label:G.label,documentation:C.isMarkdownString(G.documentation)?R.to(G.documentation):G.documentation}}ye.to=fe})(j=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(ye){function Pe(G){return{label:G.label,documentation:R.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(j.from):[],activeParameter:G.activeParameter}}ye.from=Pe;function fe(G){return{label:G.label,documentation:C.isMarkdownString(G.documentation)?R.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(j.to):[],activeParameter:G.activeParameter}}ye.to=fe})(Z=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(ye){function Pe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Z.from):[]}}ye.from=Pe;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Z.to):[]}}ye.to=fe})(de=e.SignatureHelp||(e.SignatureHelp={}));var Se;(function(ye){function Pe(fe,G){const Ae=new r.InlayHint(u.to(G.position),typeof G.label=="string"?G.label:G.label.map(ae.to.bind(void 0,fe)),G.kind&&ve.to(G.kind));return Ae.textEdits=G.textEdits&&G.textEdits.map(ie.to),Ae.tooltip=C.isMarkdownString(G.tooltip)?R.to(G.tooltip):G.tooltip,Ae.paddingLeft=G.paddingLeft,Ae.paddingRight=G.paddingRight,Ae}ye.to=Pe})(Se=e.InlayHint||(e.InlayHint={}));var ae;(function(ye){function Pe(fe,G){const Ae=new r.InlayHintLabelPart(G.label);return Ae.tooltip=C.isMarkdownString(G.tooltip)?R.to(G.tooltip):G.tooltip,t.Command.is(G.command)&&(Ae.command=fe.fromInternal(G.command)),G.location&&(Ae.location=Ne.to(G.location)),Ae}ye.to=Pe})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(ye){function Pe(G){return G}ye.from=Pe;function fe(G){return G}ye.to=fe})(ve=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(ye){function Pe(G){return{range:d.from(G.range),url:G.target,tooltip:G.tooltip}}ye.from=Pe;function fe(G){let Ae;if(G.url)try{Ae=typeof G.url=="string"?v.URI.parse(G.url,!0):v.URI.revive(G.url)}catch{}return new r.DocumentLink(d.to(G.range),Ae)}ye.to=fe})(be=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ye){function Pe(G){const Ae=new r.ColorPresentation(G.label);return G.textEdit&&(Ae.textEdit=ie.to(G.textEdit)),G.additionalTextEdits&&(Ae.additionalTextEdits=G.additionalTextEdits.map(Le=>ie.to(Le))),Ae}ye.to=Pe;function fe(G){return{label:G.label,textEdit:G.textEdit?ie.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ae=>ie.from(Ae)):void 0}}ye.from=fe})($e=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(ye){function Pe(G){return new r.Color(G[0],G[1],G[2],G[3])}ye.to=Pe;function fe(G){return[G.red,G.green,G.blue,G.alpha]}ye.from=fe})(He=e.Color||(e.Color={}));var tt;(function(ye){function Pe(G){return{range:d.from(G.range)}}ye.from=Pe;function fe(G){return new r.SelectionRange(d.to(G.range))}ye.to=fe})(tt=e.SelectionRange||(e.SelectionRange={}));var xe;(function(ye){function Pe(fe){switch(fe){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}ye.to=Pe})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(ye){function Pe(G){switch(G){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Pe;function fe(G){switch(G){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}ye.to=fe})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(ye){function Pe(G){if(G===r.EndOfLine.CRLF)return 1;if(G===r.EndOfLine.LF)return 0}ye.from=Pe;function fe(G){if(G===1)return r.EndOfLine.CRLF;if(G===0)return r.EndOfLine.LF}ye.to=fe})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(ye){function Pe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(ye){function Pe(fe){const G={start:fe.start+1,end:fe.end+1};return fe.kind&&(G.kind=st.from(fe.kind)),G}ye.from=Pe})(Fe=e.FoldingRange||(e.FoldingRange={}));var st;(function(ye){function Pe(fe){if(fe)switch(fe){case r.FoldingRangeKind.Comment:return t.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return t.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return t.FoldingRangeKind.Region}}ye.from=Pe})(st=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(ye){function Pe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?d.from(fe.selection):void 0,override:typeof fe.override=="boolean"?b.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Pe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var X;(function(ye){function Pe(Le){return Le instanceof r.RelativePattern?Le.toJSON():typeof Le=="string"?Le:fe(Le)||G(Le)?new r.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}ye.from=Pe;function fe(Le){const Xe=Le;return Xe?v.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function G(Le){const Xe=Le;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new r.RelativePattern(v.URI.revive(Le.baseUri),Le.pattern)}ye.to=Ae})(X=e.GlobPattern||(e.GlobPattern={}));var pe;(function(ye){function Pe(fe){if(fe){if(Array.isArray(fe))return fe.map(Pe);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:X.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}ye.from=Pe})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(ye){function Pe(G){return{start:G.start,end:G.end}}ye.from=Pe;function fe(G){return new r.NotebookRange(G.start,G.end)}ye.to=fe})(Me=e.NotebookRange||(e.NotebookRange={}));var Be;(function(ye){function Pe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}ye.to=Pe;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}ye.from=fe})(Be=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(ye){function Pe(fe){if(fe===E.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(fe===E.NotebookCellExecutionState.Pending)return;if(fe===E.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ye.to=Pe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Je;(function(ye){function Pe(G){switch(G){case r.NotebookCellKind.Markup:return E.CellKind.Markup;case r.NotebookCellKind.Code:default:return E.CellKind.Code}}ye.from=Pe;function fe(G){switch(G){case E.CellKind.Markup:return r.NotebookCellKind.Markup;case E.CellKind.Code:default:return r.NotebookCellKind.Code}}ye.to=fe})(Je=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(ye){function Pe(G){const Ae={metadata:G.metadata??Object.create(null),cells:[]};for(const Le of G.cells)r.NotebookCellData.validate(Le),Ae.cells.push(vt.from(Le));return Ae}ye.from=Pe;function fe(G){const Ae=new r.NotebookData(G.cells.map(vt.to));return(0,m.isEmptyObject)(G.metadata)||(Ae.metadata=G.metadata),Ae}ye.to=fe})(nt=e.NotebookData||(e.NotebookData={}));var vt;(function(ye){function Pe(G){return{cellKind:Je.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Be.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Tt.from):[]}}ye.from=Pe;function fe(G){return new r.NotebookCellData(Je.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Tt.to):void 0,G.metadata,G.internalMetadata?Be.to(G.internalMetadata):void 0)}ye.to=fe})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(ye){function Pe(G){return{mime:G.mime,valueBytes:T.VSBuffer.wrap(G.data)}}ye.from=Pe;function fe(G){return new r.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}ye.to=fe})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Tt;(function(ye){function Pe(G){return{outputId:G.id,items:G.items.map(wt.from),metadata:G.metadata}}ye.from=Pe;function fe(G){const Ae=G.items.map(wt.to);return new r.NotebookCellOutput(Ae,G.outputId,G.metadata)}ye.to=fe})(Tt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(ye){function Pe(Ae){return G(Ae)?{include:(0,m.withNullAsUndefined)(X.from(Ae.include)),exclude:(0,m.withNullAsUndefined)(X.from(Ae.exclude))}:(0,m.withNullAsUndefined)(X.from(Ae))}ye.from=Pe;function fe(Ae){return G(Ae)?{include:X.to(Ae.include),exclude:X.to(Ae.exclude)}:X.to(Ae)}ye.to=fe;function G(Ae){const Le=Ae;return Le?!(0,m.isUndefinedOrNull)(Le.include)&&!(0,m.isUndefinedOrNull)(Le.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(ye){function Pe(fe,G,Ae){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Le,Ae),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ye.from=Pe})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ut;(function(ye){function Pe(fe,G,Ae){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(Le,Ae),label:fe.label,description:fe.description,detail:fe.detail}}ye.from=Pe})(Ut=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ft;(function(ye){function Pe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ye.from=Pe})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Nt;(function(ye){function Pe(G){return{uri:G.uri,provides:G.provides}}ye.from=Pe;function fe(G){return new r.NotebookRendererScript(v.URI.revive(G.uri),G.provides)}ye.to=fe})(Nt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(ye){function Pe(G){return{message:R.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:d.from(G.location.range),uri:G.location.uri}}}ye.from=Pe;function fe(G){const Ae=new r.TestMessage(typeof G.message=="string"?G.message:R.to(G.message));return Ae.actualOutput=G.actual,Ae.expectedOutput=G.expected,Ae.location=G.location?Ne.to(G.location):void 0,Ae}ye.to=fe})(ft=e.TestMessage||(e.TestMessage={}));var Ct;(function(ye){ye.namespace=w.namespaceTestTag,ye.denamespace=w.denamespaceTestTag})(Ct=e.TestTag||(e.TestTag={}));var Bt;(function(ye){function Pe(G){const Ae=(0,l.getPrivateApiFor)(G).controllerId;return{extId:p.TestId.fromExtHostTestItem(G,Ae).toString(),label:G.label,uri:v.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Le=>Ct.namespace(Ae,Le.id)),range:h.Range.lift(d.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&R.fromStrict(G.error)||null}}ye.from=Pe;function fe(G){return{parent:void 0,error:void 0,id:p.TestId.fromString(G.extId).localId,label:G.label,uri:v.URI.revive(G.uri),tags:(G.tags||[]).map(Ae=>{const{tagId:Le}=Ct.denamespace(Ae);return new r.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}ye.toPlain=fe})(Bt=e.TestItem||(e.TestItem={})),function(ye){function Pe(G){return{id:G.id}}ye.from=Pe;function fe(G){return new r.TestTag(G.id)}ye.to=fe}(Ct=e.TestTag||(e.TestTag={}));var Mt;(function(ye){const Pe=(G,Ae)=>{const Le=[];for(const[ze,Ze]of Ae)p.TestId.compare(Ze.item.extId,ze)===2&&(Ae.delete(ze),Le.push(Ze));const Xe={...Bt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:Le.map(ze=>Pe(ze,Ae))};for(const ze of Xe.children)ze.parent=Xe;return Xe};function fe(G){const Ae=[],Le=new Map;for(const Xe of G.items){Le.set(Xe.item.extId,Xe);const ze=p.TestId.root(Xe.item.extId);G.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(Xe.item.extId))&&Ae.push(Xe)}return{completedAt:G.completedAt,results:Ae.map(Xe=>Pe(Xe,Le))}}ye.to=fe})(Mt=e.TestResults||(e.TestResults={}));var Ge;(function(ye){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function fe(Le){return"line"in Le?u.from(Le):d.from(Le)}function G(Le){return"branches"in Le?{count:Le.executionCount,location:fe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&fe(Xe.location)})):void 0}:{type:0,count:Le.executionCount,location:fe(Le.location)}}ye.fromDetailed=G;function Ae(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(G)}}ye.fromFile=Ae})(Ge=e.TestCoverage||(e.TestCoverage={}));var Rt;(function(ye){function Pe(fe){switch(fe){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}ye.to=Pe})(Rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(ye){function Pe(G){const Ae=new r.TypeHierarchyItem(ce.to(G.kind),G.name,G.detail||"",v.URI.revive(G.uri),d.to(G.range),d.to(G.selectionRange));return Ae._sessionId=G._sessionId,Ae._itemId=G._itemId,Ae}ye.to=Pe;function fe(G,Ae,Le){if(Ae=Ae??G._sessionId,Le=Le??G._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:ce.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:d.from(G.range),selectionRange:d.from(G.selectionRange),tags:G.tags?.map(re.from)}}ye.from=fe})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ht;(function(ye){function Pe(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}ye.from=Pe})(Ht=e.ViewBadge||(e.ViewBadge={}));var mt;(function(ye){function Pe(Le,Xe,ze){const Ze=Xe.fileData;return Ze?new class extends r.DataTransferItem{asFile(){return{name:Ze.name,uri:v.URI.revive(Ze.uri),data:(0,L.once)(()=>ze())}}}("",Xe.id):Le===N.Mimes.uriList&&Xe.uriListData?new r.DataTransferItem(Ae(Xe.uriListData)):new r.DataTransferItem(Xe.asString)}ye.to=Pe;async function fe(Le,Xe){const ze=await Xe.asString();if(Le===N.Mimes.uriList)return{id:Xe.id,asString:"",fileData:void 0,uriListData:G(ze)};const Ze=Xe.asFile();return{id:Xe.id,asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}ye.from=fe;function G(Le){return y.UriList.split(Le).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return v.URI.parse(Xe)}catch{}return Xe})}function Ae(Le){return y.UriList.create(Le.map(Xe=>typeof Xe=="string"?Xe:v.URI.revive(Xe)))}})(mt=e.DataTransferItem||(e.DataTransferItem={}));var At;(function(ye){function Pe(G,Ae){const Le=G.items.map(([Xe,ze])=>[Xe,mt.to(Xe,ze,()=>Ae(ze.id))]);return new r.DataTransfer(Le)}ye.toDataTransfer=Pe;async function fe(G){const Ae={items:[]},Le=[];return G.forEach((Xe,ze)=>{Le.push((async()=>{Ae.items.push([ze,await mt.from(ze,Xe)])})())}),await Promise.all(Le),Ae}ye.toDataTransferDTO=fe})(At=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[186],Ce([1,0,2,11,6,8,153]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class O{constructor(k,N,D,m={timeout:1500,errors:3}){this.c=k,this.d=N,this.f=D,this.g=m,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(N,D,m)=>{const h={dispose:this.a.push([N,D,k])};return Array.isArray(m)&&m.push(h),h}}async $participateInSave(k,N){const D=i.URI.revive(k);let m=!1;const v=setTimeout(()=>m=!0,this.g.timeout),h=[];try{for(const t of[...this.a]){if(m)break;const o=this.d.getDocument(D),l=await this.h(t,{document:o,reason:L.TextDocumentSaveReason.to(N)});h.push(l)}}finally{clearTimeout(v)}return h}h([k,N,D],m){const v=this.b.get(k);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(D,k,N,m).then(()=>!0,h=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const t=this.b.get(k);this.b.set(k,t?t+1:1),typeof t=="number"&&t>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,N,D,m){const v=[],h=Date.now(),{document:t,reason:o}=m,{version:l}=t,b=Object.freeze({document:t,reason:o,waitUntil(E){if(Object.isFrozen(v))throw(0,T.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(E))}});try{N.apply(D,[b])}catch(E){return Promise.reject(E)}return Object.freeze(v),new Promise((E,p)=>{const w=setTimeout(()=>p(new Error("timeout")),this.g.timeout);return Promise.all(v).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(w),E(s)}).catch(s=>{clearTimeout(w),p(s)})}).then(E=>{const p={edits:[]};for(const w of E)if(Array.isArray(w)&&w.every(s=>s instanceof y.TextEdit))for(const{newText:s,newEol:r,range:a}of w)p.edits.push({resource:t.uri,versionId:void 0,textEdit:{range:a&&L.Range.from(a),text:s,eol:r&&L.EndOfLine.from(r)}});if(p.edits.length!==0)return l===t.version?this.f.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=O}),define(Ie[187],Ce([1,0,13,2,8,6,66]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class O{constructor(D,m,v,h){this.start=D,this.deletedCount=m,this.deletedItems=v,this.items=h}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(D,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,m,v){this.notebook=D,this.h=m,this.j=v,this.handle=v.handle,this.uri=T.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(y.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(y.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:y.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return D.g},set mime(h){D.g=h},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(v)}return this.f}setOutputs(D){this.a=D.map(y.NotebookCellOutput.to)}setOutputItems(D,m,v){const h=v.map(y.NotebookCellOutputItem.to),t=this.a.find(o=>o.id===D);if(t&&(m||(t.items.length=0),t.items.push(...h),t.items.length>1&&t.items.every(o=>C.isTextStreamMime(o.mime)))){const o=new Map,l=[];t.items.forEach(b=>{let E;o.has(b.mime)?E=o.get(b.mime):(E=[],o.set(b.mime,E),l.push(b.mime)),E.push(b.data)}),t.items.length=0,l.forEach(b=>{const E=C.compressOutputItemStreams(o.get(b));t.items.push({mime:b,data:E.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(y.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=S;class k{constructor(D,m,v,h,t){this.k=D,this.l=m,this.m=v,this.uri=h,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=t.viewType,this.f=Object.freeze(t.metadata??Object.create(null)),this.r([[0,0,t.cells]],!0,void 0),this.g=t.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const D=this,m={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===i.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(v){return v=D.n(v),D.b[v].apiCell},getCells(v){return(v?D.p(v):D.b).map(t=>t.apiCell)},save(){return D.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,m,v){this.g=D.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:v});const h={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},t=[];for(const l of D.rawEvents)l.kind===C.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,h.contentChanges):l.kind===C.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,h.contentChanges):l.kind===C.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),t.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),t.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),t.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===C.NotebookCellsChangeType.ChangeCellContent?t.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),t.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),t.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const o=new Map;for(let l=0;l<t.length;l++){const b=t[l],E=o.get(b.cell);if(E===void 0){const p=h.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});o.set(b.cell,p-1)}else h.cellChanges[E]={...h.cellChanges[E],...b}}return Object.freeze(h),Object.freeze(h.cellChanges),Object.freeze(h.contentChanges),h}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let m=D.start|0,v=D.end|0;return m<0&&(m=0),v>this.b.length&&(v=this.b.length),D.with({start:m,end:v})}p(D){D=this.o(D);const m=[];for(let v=D.start;v<D.end;v++)m.push(this.b[v]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,m,v){if(this.j)return;const h=[],t=[],o=[];if(D.reverse().forEach(l=>{const E=l[2].map(s=>{const r=new S(this,this.l,s);return m||t.push(S.asModelAddData(this.apiNotebook,s)),r}),p=new O(l[0],l[1],[],E),w=this.b.splice(l[0],l[1],...E);for(const s of w)o.push(s.uri),p.deletedItems.push(s.apiCell);h.push(p)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:t,removedDocuments:o}),v)for(const l of h)v.push(l.asApiEvent())}s(D,m,v,h){const t=this.b.splice(D,m);this.b.splice(v,0,...t);const o=[new O(D,m,t.map(l=>l.apiCell),[]),new O(v,0,[],t)];for(const l of o)h.push(l.asApiEvent())}t(D,m){this.b[D].setOutputs(m)}u(D,m,v,h){this.b[D].setOutputItems(m,v,h)}v(D,m){const v=this.b[D];v.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(v.uri,m)}w(D,m){const v=this.b[D];v.apiCell.mime=m}x(D,m){this.b[D].setMetadata(m)}y(D,m){this.b[D].setInternalMetadata(m)}getCellFromApiCell(D){return this.b.find(m=>m.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(m=>m.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.ExtHostNotebookDocument=k,k.a=0}),define(Ie[96],Ce([1,0,11,8,6]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(O,S,k,N,D,m){this.id=O,this.f=S,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=N,this.c=m}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(S){this.selections=[S]},get selections(){return O.a},set selections(S){if(!Array.isArray(S)||!S.every(y.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");O.a=S,O.g(S)},get visibleRanges(){return O.b},revealRange(S,k){O.f.$tryRevealRange(O.id,T.NotebookRange.from(S),k??y.NotebookEditorRevealType.Default)},get viewColumn(){return O.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(T.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(Ie[188],Ce([1,0,5,12,8]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(O,S){this.c=O,this.d=S,this.a=new i.Emitter,this.b=new i.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,S);const k=this.d.getEditorById(O);S.visibleRanges&&k._acceptVisibleRanges(S.visibleRanges.ranges.map(y.NotebookRange.to)),S.selections&&k._acceptSelections(S.selections.selections.map(y.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const S in O)this.d.getEditorById(S)._acceptViewColumn(y.ViewColumn.to(O[S]))}};L=qe([Ve(0,T.ILogService)],L),e.ExtHostNotebookEditors=L}),define(Ie[189],Ce([1,0,8,156,135,20,60,11]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,v,h){const t=this.b++,{title:o,location:l,cancellable:b}=v,E={label:(0,y.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(t,{location:i.ProgressLocation.from(l),title:o,source:E,cancellable:b},m.isUnderDevelopment?void 0:m.identifier.value).catch(O.onUnexpectedExternalError),this.d(t,h,!!b)}d(m,v,h){let t;h&&(t=new L.CancellationTokenSource,this.c.set(m,t));const o=b=>{this.a.$progressEnd(b),this.c.delete(b),t?.dispose()};let l;try{l=v(new N(this.a,m),h&&t?t.token:L.CancellationToken.None)}catch(b){throw o(m),b}return l.then(b=>o(m),b=>o(m)),l}$acceptProgressCanceled(m){const v=this.c.get(m);v&&(v.cancel(),this.c.delete(m))}}e.ExtHostProgress=S;function k(D,m){return D.message=m.message,typeof m.increment=="number"&&(typeof D.increment=="number"?D.increment+=m.increment:D.increment=m.increment),D}class N extends T.Progress{constructor(m,v){super(h=>this.throttledReport(h)),this.c=m,this.d=v}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,C.throttle)(100,(D,m)=>k(D,m),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(Ie[97],Ce([1,0,54,93,42,67,53,8,2]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(E,p,w,s)=>{let r=p;return{enumerable:!0,configurable:!1,get(){return r},set(a){if(!w(r,a)){const d=r;r=a,E.listener?.(s(a,d))}}}},N=(E,p)=>E===p,D={range:(E,p)=>E===p?!0:!E||!p?!1:E.isEqual(p),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(E,p)=>!(E.length!==p.length||E.some(w=>!p.find(s=>w.id===s.id)))},m=E=>p=>({op:4,update:E(p)}),v=(E,p)=>({range:(()=>{let w;const s=m(r=>({range:i.Range.lift(O.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return w},set(r){E.listener?.({op:6}),D.range(w,r)||(w=r,E.listener?.(s(r)))}}})(),label:k(E,p,D.label,m(w=>({label:w}))),description:k(E,void 0,D.description,m(w=>({description:w}))),sortText:k(E,void 0,D.sortText,m(w=>({sortText:w}))),canResolveChildren:k(E,!1,D.canResolveChildren,w=>({op:2,state:w})),busy:k(E,!1,D.busy,m(w=>({busy:w}))),error:k(E,void 0,D.error,m(w=>({error:O.MarkdownString.fromStrict(w)||null}))),tags:k(E,[],D.tags,(w,s)=>({op:1,new:w.map(O.TestTag.from),old:s.map(O.TestTag.from)}))}),h=E=>{const p=y.TestId.fromString(E.extId),w=new o(p.controllerId,p.localId,E.label,S.URI.revive(E.uri)||void 0);return w.range=O.Range.to(E.range||void 0),w.description=E.description||void 0,w.sortText=E.sortText||void 0,w.tags=E.tags.map(s=>O.TestTag.to({id:(0,C.denamespaceTestTag)(s).tagId})),w},t=E=>{let p;for(const w of E.tests){const s=h(w.item);(0,T.getPrivateApiFor)(s).parent=p,p=s}return p};e.toItemFromContext=t;class o{constructor(p,w,s,r){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const a=(0,T.createPrivateApiFor)(this,p);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof l?void 0:a.parent}},children:{value:(0,L.createTestItemChildren)(a,T.getPrivateApiFor,o),enumerable:!0,writable:!1},...v(a,s)})}}e.TestItemImpl=o;class l extends o{constructor(p,w){super(p,p,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class b extends L.TestItemCollection{constructor(p,w,s){super({controllerId:p,getDocumentVersion:r=>r&&s.getDocument(r)?.version,getApiFor:T.getPrivateApiFor,getChildren:r=>r.children,root:new l(p,w),toITestItem:O.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(Ie[98],Ce([1,0,47,11,79,8,6]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class O{constructor(m,v,h){const t=O.c.nextId();m.$registerTextEditorDecorationType(v.identifier,t,L.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:t,dispose(){m.$removeTextEditorDecorationType(t)}})}}e.TextEditorDecorationType=O,O.c=new y.IdGenerator("TextEditorDecorationType");class S{constructor(m,v){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,v){this.k();let h=null;if(m instanceof C.Position)h=new C.Range(m,m);else if(m instanceof C.Range)h=m;else throw new Error("Unrecognized location");this.l(h,v,!1)}insert(m,v){this.k(),this.l(new C.Range(m,m),v,!0)}delete(m){this.k();let v=null;if(m instanceof C.Range)v=m;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(m,v,h){const t=this.c.validateRange(m);this.g.push({range:t,text:v,forceMoveMarkers:h})}setEndOfLine(m){if(this.k(),m!==C.EndOfLine.LF&&m!==C.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this.h=m}}class k{constructor(m,v,h,t){this.c=m,this.d=v,this._accept(h),this.e=t;const o=this;this.value={get tabSize(){return o.f},set tabSize(l){o.m(l)},get indentSize(){return o.g},set indentSize(l){o.o(l)},get insertSpaces(){return o.h},set insertSpaces(l){o.q(l)},get cursorStyle(){return o.j},set cursorStyle(l){o.s(l)},get lineNumbers(){return o.k},set lineNumbers(l){o.t(l)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}m(m){const v=this.l(m);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}o(m){const v=this.n(m);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}q(m){const v=this.p(m);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const v={};let h=!1;if(typeof m.tabSize<"u"){const t=this.l(m.tabSize);t==="auto"?(h=!0,v.tabSize=t):typeof t=="number"&&this.f!==t&&(this.f=t,h=!0,v.tabSize=t)}if(typeof m.indentSize<"u"){const t=this.n(m.indentSize);t==="tabSize"?(h=!0,v.indentSize=t):typeof t=="number"&&this.g!==t&&(this.g=t,h=!0,v.indentSize=t)}if(typeof m.insertSpaces<"u"){const t=this.p(m.insertSpaces);t==="auto"?(h=!0,v.insertSpaces=t):this.h!==t&&(this.h=t,h=!0,v.insertSpaces=t)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,h=!0,v.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,h=!0,v.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),h&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(m,v){v.catch(h=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(h)})}}e.ExtHostTextEditorOptions=k;class N{constructor(m,v,h,t,o,l,b,E){this.id=m,this.j=v,this.k=h,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,l,h),this.e=b,this.f=E;const p=this;this.value=Object.freeze({get document(){return t.getValue()},set document(w){throw(0,T.readonly)("document")},get selection(){return p.c&&p.c[0]},set selection(w){if(!(w instanceof C.Selection))throw(0,T.illegalArgument)("selection");p.c=[w],p.l()},get selections(){return p.c},set selections(w){if(!Array.isArray(w)||w.some(s=>!(s instanceof C.Selection)))throw(0,T.illegalArgument)("selections");p.c=w,p.l()},get visibleRanges(){return p.e},set visibleRanges(w){throw(0,T.readonly)("visibleRanges")},get options(){return p.d.value},set options(w){p.g||p.d.assign(w)},get viewColumn(){return p.f},set viewColumn(w){throw(0,T.readonly)("viewColumn")},edit(w,s={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new S(t.getValue(),s);return w(r),p.m(r)},insertSnippet(w,s,r={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!s||Array.isArray(s)&&s.length===0)a=p.c.map(d=>L.Range.from(d));else if(s instanceof C.Position){const{lineNumber:d,column:c}=L.Position.from(s);a=[{startLineNumber:d,startColumn:c,endLineNumber:d,endColumn:c}]}else if(s instanceof C.Range)a=[L.Range.from(s)];else{a=[];for(const d of s)if(d instanceof C.Range)a.push(L.Range.from(d));else{const{lineNumber:c,column:u}=L.Position.from(d);a.push({startLineNumber:c,startColumn:u,endLineNumber:c,endColumn:u})}}return v.$tryInsertSnippet(m,t.getValue().version,w.value,a,r)},setDecorations(w,s){const r=s.length===0;r&&!p.h.has(w.key)||(r?p.h.delete(w.key):p.h.add(w.key),p.n(()=>{if(L.isDecorationOptionsArr(s))return v.$trySetDecorations(m,w.key,L.fromRangeOrRangeWithMessage(s));{const a=new Array(4*s.length);for(let d=0,c=s.length;d<c;d++){const u=s[d];a[4*d]=u.start.line+1,a[4*d+1]=u.start.character+1,a[4*d+2]=u.end.line+1,a[4*d+3]=u.end.character+1}return v.$trySetDecorationsFast(m,w.key,a)}}))},revealRange(w,s){p.n(()=>v.$tryRevealRange(m,L.Range.from(w),s||C.TextEditorRevealType.Default))},show(w){v.$tryShowEditor(m,L.ViewColumn.from(w))},hide(){v.$tryHideEditor(m)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,i.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,i.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,i.ok)(!this.g),this.f=m}_acceptSelections(m){(0,i.ok)(!this.g),this.c=m}async l(){const m=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const v=m.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const h=v.edits.map(o=>o.range);h.sort((o,l)=>o.end.line===l.end.line?o.end.character===l.end.character?o.start.line===l.start.line?o.start.character-l.start.character:o.start.line-l.start.line:o.end.character-l.end.character:o.end.line-l.end.line);for(let o=0,l=h.length-1;o<l;o++){const b=h[o].end;if(h[o+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const t=v.edits.map(o=>({range:L.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,t,{setEndOfLine:typeof v.setEndOfLine=="number"?L.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.ExtHostTextEditor=N}),define(Ie[190],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[191],Ce([1,0,146,11,29,85,88,30,26,190,155,148]),function(ee,e,i,T,y,L,C,O,S,k,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=O.Registry.as(C.Extensions.JSONContribution);class v{constructor(w,s,r){this.a=w,this.b=s,this.c=r}d(w,s){this.a({type:w,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(y.default.Error,w)}warn(w){this.d(y.default.Warning,w)}info(w){this.d(y.default.Info,w)}}e.ExtensionMessageCollector=v;class h{static a(w){const s=new Set;for(let r=0,a=w.length;r<a;r++)s.add(S.ExtensionIdentifier.toKey(w[r].description.identifier));return s}static compute(w,s){if(!w||!w.length)return new h(s,[]);if(!s||!s.length)return new h([],w);const r=this.a(w),a=this.a(s),d=s.filter(u=>!r.has(S.ExtensionIdentifier.toKey(u.description.identifier))),c=w.filter(u=>!a.has(S.ExtensionIdentifier.toKey(u.description.identifier)));return new h(d,c)}constructor(w,s){this.added=w,this.removed=s}}e.ExtensionPointUserDelta=h;class t{constructor(w,s){this.name=w,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=h.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,T.onUnexpectedError)(w)}}}e.ExtensionPoint=t;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:i.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(30,null)},{label:"onUri",body:"onUri",description:i.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(35,null)},{label:"onRenderer",description:i.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(37,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(39,null)},{label:"*",description:i.localize(40,null),body:"*"}]}},badges:{type:"array",description:i.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(42,null)},href:{type:"string",description:i.localize(43,null)},description:{type:"string",description:i.localize(44,null)}}}},markdown:{type:"string",description:i.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(49,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(50,null)},{body:["workspace"],description:i.localize(51,null)},{body:["ui","workspace"],description:i.localize(52,null)},{body:["workspace","ui"],description:i.localize(53,null)},{body:[],description:i.localize(54,null)}]},capabilities:{description:i.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(58,null),i.localize(59,null),i.localize(60,null)]},description:{type:"string",markdownDescription:i.localize(61,null)}}},untrustedWorkspaces:{description:i.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(64,null),i.localize(65,null),i.localize(66,null)]},restrictedConfigurations:{description:i.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(68,null)}}}}},sponsor:{description:i.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(71,null),type:"string"},"vscode:uninstall":{description:i.localize(72,null),type:"string"}}},icon:{type:"string",description:i.localize(73,null)},l10n:{type:"string",description:i.localize(74,null)}}};class b{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const s=new t(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,s),w.activationEventsGenerator&&D.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,m.registerSchema(l,e.schema),s}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=b;const E={ExtensionsRegistry:"ExtensionsRegistry"};O.Registry.add(E.ExtensionsRegistry,new b),e.ExtensionsRegistry=O.Registry.as(E.ExtensionsRegistry),m.registerSchema(l,e.schema),m.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ie[192],Ce([1,0,143,9,23,191,41,5]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(m){function v(h,t,o){if(!h)return;const l=T.isString(h.type)?h.type:void 0;if(!l||l.length===0){o.error(i.localize(3,null));return}const b=[];if(Array.isArray(h.required))for(const E of h.required)T.isString(E)&&b.push(E);return{extensionId:t.value,taskType:l,required:b,properties:h.properties?y.deepClone(h.properties):{},when:h.when?C.ContextKeyExpr.deserialize(h.when):void 0}}m.from=v})(k||(k={}));const N=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:S}});class D{constructor(){this.d=new O.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,h)=>{N.setHandler((t,o)=>{this.c=void 0;try{for(const l of o.removed){const b=l.value;for(const E of b)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const l of o.added){const b=l.value;for(const E of b){const p=k.from(E,l.description.identifier,l.collector);p&&(this.a[p.taskType]=p)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const h of this.all()){const t={type:"object",additionalProperties:!1};h.required.length>0&&(t.required=h.required.slice(0)),h.properties!==void 0?t.properties=y.deepClone(h.properties):t.properties=Object.create(null),t.properties.type={type:"string",enum:[h.taskType]},v.push(t)}this.c={oneOf:v}}return this.c}}e.TaskDefinitionRegistry=new D}),define(Ie[193],Ce([1,0,144,9,22,23,41,192]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function $(z){if(!z)return F.Strong;switch(z.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=$}(S=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var N;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(F){function $(z){switch(z.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=$}(N=e.RevealKind||(e.RevealKind={}));var D;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(D=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function $(z){switch(z.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=$}(D=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(F){function $(z){switch(z.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=$}(m=e.PanelKind||(e.PanelKind={}));var v;(function(F){F.defaults={echo:!0,reveal:N.Always,revealProblems:D.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(v=e.PresentationOptions||(e.PresentationOptions={}));var h;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(h=e.RuntimeType||(e.RuntimeType={})),function(F){function $(V){switch(V.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=$;function z(V){switch(V){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=z}(h=e.RuntimeType||(e.RuntimeType={}));var t;(function(F){function $(z){return T.isString(z)?z:z.value}F.value=$})(t=e.CommandString||(e.CommandString={}));var o;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function $(V){return V===F.Clean._id||V===F.Build._id||V===F.Rebuild._id||V===F.Test._id}F.is=$;function z(V){if(V!==void 0)return T.isString(V)?$(V)?{_id:V,isDefault:!1}:void 0:V}F.from=z})(o=e.TaskGroup||(e.TaskGroup={}));var l;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var b;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function $(z){switch(z){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=$})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(F){F.parallel="parallel",F.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var p;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(p=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:p.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class s{constructor($,z,V,K,ie,ge){this._label="",this._id=$,z&&(this._label=z),V&&(this.type=V),this.runOptions=K,this.configurationProperties=ie,this._source=ge}getDefinition($){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const $={folder:this.d(),id:this._id};return JSON.stringify($)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches($,z=!1){if($===void 0)return!1;if(T.isString($))return $===this._label||$===this.configurationProperties.identifier||z&&$===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===$._key}getQualifiedLabel(){const $=this.getWorkspaceFolder();return $?`${this._label} (${$.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages($){this.c===void 0&&(this.c=[]),$&&(this.c=this.c.concat($))}get taskLoadMessages(){return this.c}}e.CommonTask=s;class r extends s{constructor($,z,V,K,ie,ge,ce,re){super($,V,void 0,ce,re,z),this.command={},this._source=z,this.hasDefinedMatchers=ge,ie&&(this.command=ie)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition($=!1){if($&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case h.Shell:z="shell";break;case h.Process:z="process";break;case h.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is($){return $ instanceof r}getMapKey(){const $=this._source.config.workspaceFolder;return $?`${$.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let z=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:z};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f($){return new r($._id,$._source,$._label,$.type,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.CustomTask=r;class a extends s{constructor($,z,V,K,ie,ge,ce){super($,V,K,ge,ce,z),this._source=z,this.configures=ie}static is($){return $ instanceof a}f($){return $}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let z=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:z};return JSON.stringify(V)}}e.ConfiguringTask=a;class d extends s{constructor($,z,V,K,ie,ge,ce,re,se){super($,V,K,re,se,z),this.defines=ie,this.hasDefinedMatchers=ce,this.command=ge,this.icon=se.icon,this.hide=se.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is($){return $ instanceof d}getMapKey(){const $=this._source.workspaceFolder;return $?`${this._source.scope.toString()}|${$.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const $={type:"contributed",scope:this._source.scope,id:this._id};return $.folder=this.d(),JSON.stringify($)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f($){return new d($._id,$._source,$._label,$.type,$.defines,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.ContributedTask=d;class c extends s{constructor($,z,V,K,ie,ge){super($,V,K,ie,ge,z),this._source=z}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is($){return $ instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f($){return new c($._id,$._source,$._label,$.type,$.runOptions,$.configurationProperties)}}e.InMemoryTask=c;var u;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class f{constructor($){this.c=new Map;for(let z=0;z<$.length;z++)this.c.set($[z].uri.toString(),z)}compare($,z){const V=$.getWorkspaceFolder(),K=z.getWorkspaceFolder();if(V&&K){let ie=this.c.get(V.uri.toString());ie=ie===void 0?0:ie+1;let ge=this.c.get(K.uri.toString());return ge=ge===void 0?0:ge+1,ie===ge?$._label.localeCompare(z._label):ie-ge}else return!V&&K?-1:V&&!K?1:0}}e.TaskSorter=f;var g;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(F){F.SingleRun="singleRun",F.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var M;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(M=e.TaskRunSource||(e.TaskRunSource={}));var q;(function(F){function $(z,V,K,ie){if(V){const ge={kind:z,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:K,__task:V};return z==="start"?ge.resolvedVariables=ie:z==="processStarted"?ge.processId=ie:z==="processEnded"&&(ge.exitCode=ie),Object.freeze(ge)}else return Object.freeze({kind:"changed"})}F.create=$})(q=e.TaskEvent||(e.TaskEvent={}));var J;(function(F){function $(V){const K=Object.keys(V).sort();let ie="";for(const ge of K){let ce=V[ge];ce instanceof Object?ce=$(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),ie+=ge+","+ce+","}return ie}function z(V){const ie={_key:$(V),type:V.taskType};return Object.assign(ie,V),ie}F.create=z})(J=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var R;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(R=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var A;(function(F){function $(z,V){const K=O.TaskDefinitionRegistry.get(z.type);if(K===void 0){const re=L.deepClone(z);return delete re._key,J.create(re)}const ie=Object.create(null);ie.type=K.taskType;const ge=new Set;K.required.forEach(re=>ge.add(re));const ce=K.properties;for(const re of Object.keys(ce)){const se=z[re];if(se!=null)ie[re]=se;else if(ge.has(re)){const le=ce[re];if(le.default!==void 0)ie[re]=L.deepClone(le.default);else switch(le.type){case"boolean":ie[re]=!1;break;case"number":case"integer":ie[re]=0;break;case"string":ie[re]="";break;default:V.error(i.localize(2,null,JSON.stringify(z,void 0,0),re));return}}}return J.create(ie)}F.createTaskIdentifier=$})(A=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[194],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,O)=>{this.b=C,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,i.onUnexpectedError)(C))}then(C,O){return this.j().then(C,O)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=T;class y extends T{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=y}),define(Ie[43],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const T=[];function y(O){const S=new i(O);return T[S.nid]=S,S}e.createProxyIdentifier=y;function L(O){return T[O].sid}e.getStringIdentifierForProxy=L;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(Ie[4],Ce([1,0,43]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(t){t[t.UnknownInput=0]="UnknownInput",t[t.TextInput=1]="TextInput",t[t.TextDiffInput=2]="TextDiffInput",t[t.TextMergeInput=3]="TextMergeInput",t[t.NotebookInput=4]="NotebookInput",t[t.NotebookDiffInput=5]="NotebookDiffInput",t[t.CustomEditorInput=6]="CustomEditorInput",t[t.WebviewEditorInput=7]="WebviewEditorInput",t[t.TerminalEditorInput=8]="TerminalEditorInput",t[t.InteractiveEditorInput=9]="InteractiveEditorInput"})(y=e.TabInputKind||(e.TabInputKind={}));var L;(function(t){t[t.TAB_OPEN=0]="TAB_OPEN",t[t.TAB_CLOSE=1]="TAB_CLOSE",t[t.TAB_UPDATE=2]="TAB_UPDATE",t[t.TAB_MOVE=3]="TAB_MOVE"})(L=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(t){t[t.Editable=0]="Editable",t[t.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var O;(function(t){t[t.Int8Array=1]="Int8Array",t[t.Uint8Array=2]="Uint8Array",t[t.Uint8ClampedArray=3]="Uint8ClampedArray",t[t.Int16Array=4]="Int16Array",t[t.Uint16Array=5]="Uint16Array",t[t.Int32Array=6]="Int32Array",t[t.Uint32Array=7]="Uint32Array",t[t.Float32Array=8]="Float32Array",t[t.Float64Array=9]="Float64Array",t[t.BigInt64Array=10]="BigInt64Array",t[t.BigUint64Array=11]="BigUint64Array"})(O=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(t){t[t.Text=1]="Text",t[t.Error=2]="Error",t[t.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(t){t[t.None=0]="None",t[t.Process=1]="Process",t[t.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(o){return o._id=D.a++,o}}e.IdObject=D,D.a=0;var m;(function(t){t.label="a",t.kind="b",t.detail="c",t.documentation="d",t.sortText="e",t.filterText="f",t.preselect="g",t.insertText="h",t.insertTextRules="i",t.range="j",t.commitCharacters="k",t.additionalTextEdits="l",t.kindModifier="m",t.commandIdent="n",t.commandId="o",t.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(t){t.defaultRanges="a",t.completions="b",t.isIncomplete="c",t.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(t){t[t.Workspace=0]="Workspace",t[t.TextDocument=1]="TextDocument"})(h=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[72],Ce([1,0,3,12,4,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,k){this.c=k,this.a=new Set,this.b=S.getProxy(y.MainContext.MainThreadTelemetry)}report(S,k,N){const D=this.d(S,k);this.a.has(D)||(this.a.add(D),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}d(S,k){return`${S}-${k.identifier.value}`}};C=qe([Ve(0,L.IExtHostRpcService),Ve(1,T.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(O,S,k){}})}),define(Ie[195],Ce([1,0,5,4,6,26]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,k,N,D={}){const m=L.ExtensionIdentifier.toKey(S.identifier),v=this.f.get(m)||[],h=[...N].sort().join(" ");let t=v.find(o=>o.providerId===k&&o.scopes===h);if(t)return t.result;{const o=this.g(S,m,k,N,D);t={providerId:k,scopes:h,result:o},v.push(t),this.f.set(m,v);try{await o}finally{const l=v.findIndex(b=>b.providerId===k&&b.scopes===h);l>-1&&(v.splice(l),this.f.set(m,v))}return o}}async g(S,k,N,D,m={}){await this.a.$ensureProvider(N);const v=S.displayName||S.name;return this.a.$getSession(N,D,k,v,m)}async removeSession(S,k){const N=this.b.get(S);return N?N.provider.removeSession(k):this.a.$removeSession(S,k)}registerAuthenticationProvider(S,k,N,D){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:k,provider:N,options:D??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===S)||this.c.push({id:S,label:k});const m=N.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(S,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(S,k,D?.supportsMultipleAccounts??!1),new y.Disposable(()=>{m.dispose(),this.b.delete(S);const v=this.c.findIndex(h=>h.id===S);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this.d.fire({provider:{id:S,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ie[196],Ce([1,0,4,15,8]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(O,S){this.a=O.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>S.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(O,S,k){const N=y.WorkspaceEdit.from(O,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,k?.isRefactoring??!1)}};L=qe([Ve(0,T.IExtHostRpcService)],L),e.ExtHostBulkEdits=L}),define(Ie[197],Ce([1,0,4]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(L){const C=L.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(O){return C.$writeText(O)}})}}e.ExtHostClipboard=T});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[38],Ce([1,0,9,6,8,23,4,16,12,80,54,250,2,7,3,15,97,24,43,45,99]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E,p){"use strict";var w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(f,g){w.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),Ye(this,w,f.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=g,Ye(this,s,f.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new a(this,P=>{const M=this.c.get(P);return M?.result===c.Void?M:void 0},g),this.f=[{processArgument(P){return(0,k.revive)(P)}},{processArgument(P){return(0,L.cloneAndChange)(P,function(M){if(N.Range.isIRange(M))return y.Range.to(M);if(D.Position.isIPosition(M))return y.Position.to(M);if(N.Range.isIRange(M.range)&&m.URI.isUri(M.uri))return y.location.to(M);if(M instanceof l.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const g=this.registerCommand(!1,f.id,async(...P)=>{const M=f.args.map((J,x)=>{if(!J.validate(P[x]))throw new Error(`Invalid argument '${J.name}' when running '${f.id}', received: ${P[x]}`);return J.convert(P[x])}),q=await this.executeCommand(f.internalId,...M);return f.result.convert(q,P,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new T.Disposable(()=>{g.dispose(),this.c.delete(f.id)})}registerCommand(f,g,P,M,q,J){if(this.d.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this.b.has(g))throw new Error(`command '${g}' already exists`);return this.b.set(g,{callback:P,thisArg:M,description:q,extension:J}),f&&Re(this,w,"f").$registerCommand(g),new T.Disposable(()=>{this.b.delete(g)&&f&&Re(this,w,"f").$unregisterCommand(g)})}executeCommand(f,...g){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,g,!0)}async g(f,g,P){if(this.b.has(f))return Re(this,w,"f").$fireCommandActivationEvent(f),this.h(f,g,!1);{let M=!1;const q=(0,L.cloneAndChange)(g,function(J){if(J instanceof T.Position)return y.Position.from(J);if(J instanceof T.Range)return y.Range.from(J);if(J instanceof T.Location)return y.location.from(J);if(T.NotebookRange.isNotebookRange(J))return y.NotebookRange.from(J);if(J instanceof ArrayBuffer)return M=!0,l.VSBuffer.wrap(new Uint8Array(J));if(J instanceof Uint8Array)return M=!0,l.VSBuffer.wrap(J);if(J instanceof l.VSBuffer)return M=!0,J;if(!Array.isArray(J))return J});try{const J=await Re(this,w,"f").$executeCommand(f,M?new b.SerializableObjectWithBuffers(q):q,P);return(0,k.revive)(J)}catch(J){if(J instanceof Error&&J.message==="$executeCommand:retry")return this.g(f,g,!1);throw J}}}async h(f,g,P){const M=this.b.get(f);if(!M)throw new Error("Unknown command");const{callback:q,thisArg:J,description:x}=M;if(x)for(let A=0;A<x.args.length;A++)try{(0,i.validateConstraint)(g[A],x.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${x.args[A].name}' - ${x.args[A].description}`)}const R=p.StopWatch.create();try{return await q.apply(J,g)}catch(A){if(f===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...g);F&&(f=F.command)}throw this.d.error(A,f,M.extension?.identifier),P?new class extends Error{constructor(){super((0,E.toErrorMessage)(A)),this.id=f,this.source=M.extension?.displayName??M.extension?.name}}:A}finally{this.j(M,f,R.elapsed())}}j(f,g,P){!f.extension||f.extension.isBuiltin||Re(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:g,duration:P})}$executeContributedCommand(f,...g){return this.d.trace("ExtHostCommands#$executeContributedCommand",f),this.b.has(f)?(g=g.map(P=>this.f.reduce((M,q)=>q.processArgument(M),P)),this.h(f,g,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),Re(this,w,"f").$getCommands().then(g=>(f&&(g=g.filter(P=>P[0]!=="_")),g))}$getContributedCommandHandlerDescriptions(){const f=Object.create(null);for(const[g,P]of this.b){const{description:M}=P;M&&(f[g]=M)}return Promise.resolve(f)}};w=new WeakMap,s=new WeakMap,r=qe([Ve(0,t.IExtHostRpcService),Ve(1,S.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class a{constructor(f,g,P){this.d=f,this.f=g,this.g=P,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,g){if(!f)return;const P={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return P;const M=this.f(f.command);if(M)P.id=M.internalId,P.arguments=M.args.map((q,J)=>q.convert(f.arguments&&f.arguments[J]));else if((0,O.isNonEmptyArray)(f.arguments)){const q=`${f.command}/${++this.c}`;this.b.set(q,f),g.add((0,v.toDisposable)(()=>{this.b.delete(q),this.g.trace("CommandsConverter#DISPOSE",q)})),P.$ident=q,P.id=this.delegatingCommandId,P.arguments=[q],this.g.trace("CommandsConverter#CREATE",f.command,q)}return P}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const g=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],g?g.command:"MISSING"),g?this.d.executeCommand(g.command,...g.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.CommandsConverter=a;class d{constructor(f,g,P,M){this.name=f,this.description=g,this.validate=P,this.convert=M}optional(){return new d(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,g){return new d(f??this.name,g??this.description,this.validate,this.convert)}}e.ApiCommandArgument=d,d.Uri=new d("uri","Uri of a text document",n=>m.URI.isUri(n),n=>n),d.Position=new d("position","A position in a text document",n=>T.Position.isPosition(n),y.Position.from),d.Range=new d("range","A range in a text document",n=>T.Range.isRange(n),y.Range.from),d.Selection=new d("selection","A selection in a text document",n=>T.Selection.isSelection(n),y.Selection.from),d.Number=new d("number","",n=>typeof n=="number",n=>n),d.String=new d("string","",n=>typeof n=="string",n=>n),d.CallHierarchyItem=new d("item","A call hierarchy item",n=>n instanceof T.CallHierarchyItem,y.CallHierarchyItem.from),d.TypeHierarchyItem=new d("item","A type hierarchy item",n=>n instanceof T.TypeHierarchyItem,y.TypeHierarchyItem.from),d.TestItem=new d("testItem","A VS Code TestItem",n=>n instanceof o.TestItemImpl,y.TestItem.from);class c{constructor(f,g){this.description=f,this.convert=g}}e.ApiCommandResult=c,c.Void=new c("no result",n=>n);class u{constructor(f,g,P,M,q){this.id=f,this.internalId=g,this.description=P,this.args=M,this.result=q}}e.ApiCommand=u}),define(Ie[198],Ce([1,0,2,8,6,71,38,16,83,87,13]),function(ee,e,i,T,y,L,C,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",v(T.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,o)=>{if((0,O.isFalsyOrEmpty)(t))return;class l extends y.SymbolInformation{static to(E){const p=new l(E.name,T.SymbolKind.to(E.kind),E.containerName||"",new y.Location(o[0],T.Range.to(E.range)));return p.detail=E.detail,p.range=p.location.range,p.selectionRange=T.Range.to(E.selectionRange),p.children=E.children?E.children.map(l.to):[],p}}return t.map(l.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(T.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(T.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(o=>y.Position.isPosition(o)),t=>t.map(T.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(o=>{let l;for(const b of o.reverse())l=new y.SelectionRange(T.Range.to(b),l);return l}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(T.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(T.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(T.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(T.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:T.Range.to(t.range),placeholder:t.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return T.WorkspaceEdit.to(t)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(T.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,S.decodeSemanticTokensDto)(t);if(o.type==="full")return new y.SemanticTokens(o.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,S.decodeSemanticTokensDto)(t);if(o.type==="full")return new y.SemanticTokens(o.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,o,l)=>{if(!t)return new y.CompletionList([]);const b=t.suggestions.map(E=>T.CompletionItem.to(E,l));return new y.CompletionList(b,t.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return T.SignatureHelp.to(t)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,o,l)=>v(b=>new y.CodeLens(T.Range.to(b.range),b.command&&l.fromInternal(b.command)))(t))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>y.Range.isRange(t),t=>y.Selection.isSelection(t)?T.Selection.from(t):T.Range.from(t)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,o,l)=>v(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(b.command)}else{const E=new y.CodeAction(b.title,b.kind?new y.CodeActionKind(b.kind):void 0);return b.edit&&(E.edit=T.WorkspaceEdit.to(b.edit)),b.command&&(E.command=l.fromInternal(b.command)),E.isPreferred=b.isPreferred,E}})(t))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(o=>new y.ColorInformation(T.Range.to(o.range),T.Color.to(o.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",t=>t instanceof y.Color,T.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:T.Range.from(t.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(T.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,o,l)=>t.map(T.InlayHint.to.bind(void 0,l)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(o=>T.NotebookExclusiveDocumentPattern.to(o))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(T.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>i.URI.isUri(t)||typeof t=="string"&&(0,k.matchesSomeScheme)(t,N.Schemas.http,N.Schemas.https),t=>t),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[T.ViewColumn.from(t),void 0]:[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[T.ViewColumn.from(t),void 0]:[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],C.ApiCommandResult.Void)];class m{static register(o){D.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=m;function v(t){return o=>{if(Array.isArray(o))return o.map(t)}}function h(t){if(!Array.isArray(t))return;const o=[];for(const l of t)L.isLocationLink(l)?o.push(T.DefinitionLink.to(l)):o.push(T.location.to(l));return o}}),define(Ie[199],Ce([1,0,14,60,5,7,2,71,26,8,6,25,4]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(h,t,o){const l=h.getProxy(m.MainContext.MainThreadComments);class b{constructor(){this.b=new Map,this.c=new Map,t.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const n=this.b.get(u.handle);return n?n.value:u}else if(u&&u.$mid===7){const n=this.b.get(u.commentControlHandle);if(!n)return u;const f=n.getCommentThread(u.commentThreadHandle);return f?f.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const f=n.getCommentThread(u.thread.commentThreadHandle);return f?u.$mid===8?f.value:{thread:f.value,text:u.text}:u}else if(u&&u.$mid===10){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const f=n.getCommentThread(u.thread.commentThreadHandle);if(!f)return u;const g=u.commentUniqueId,P=f.getCommentByUniqueId(g);return P||u}else if(u&&u.$mid===11){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const f=n.getCommentThread(u.thread.commentThreadHandle);if(!f)return u;const g=u.text,P=u.commentUniqueId,M=f.getCommentByUniqueId(P);return M?(typeof M.body=="string"?M.body=g:M.body.value=g,M):u}return u}})}createCommentController(u,n,f){const g=b.a++,P=new p(u,g,n,f);this.b.set(P.handle,P);const M=this.c.get(S.ExtensionIdentifier.toKey(u.identifier))||[];return M.push(P),this.c.set(S.ExtensionIdentifier.toKey(u.identifier),M),P.value}$createCommentThreadTemplate(u,n,f){const g=this.b.get(u);!g||g.$createCommentThreadTemplate(n,f)}async $updateCommentThreadTemplate(u,n,f){const g=this.b.get(u);!g||g.$updateCommentThreadTemplate(n,f)}$deleteCommentThread(u,n){this.b.get(u)?.$deleteCommentThread(n)}$provideCommentingRanges(u,n,f){const g=this.b.get(u);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const P=o.getDocument(C.URI.revive(n));return(0,i.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(P,f)).then(M=>M?M.map(q=>k.Range.from(q)):void 0)}$toggleReaction(u,n,f,g,P){const M=this.b.get(u);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const q=M.getCommentThread(n);if(q){const J=q.getCommentByUniqueId(g.uniqueIdInThread);if(M!==void 0&&J&&M.reactionHandler)return M.reactionHandler(J,r(P))}return Promise.resolve(void 0)})}dispose(){}}b.a=0;class E{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){u.isEqual(this.p)||(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(u){(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,n,f,g,P,M,q,J){this.m=n,this.n=f,this.o=g,this.p=P,this.q=M,this.extensionDescription=q,this.r=J,this.handle=E.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new y.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${u}.${this.handle}`),l.$createCommentThread(n,this.handle,this.n,this.o,k.Range.from(this.p),q.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this.i.push({dispose:()=>{l.$deleteCommentThread(n,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(R){x.range=R},get comments(){return x.comments},set comments(R){x.comments=R},get collapsibleState(){return x.collapsibleState},set collapsibleState(R){x.collapsibleState=R},get canReply(){return x.canReply},set canReply(R){x.canReply=R},get contextValue(){return x.contextValue},set contextValue(R){x.contextValue=R},get label(){return x.label},set label(R){x.label=R},get state(){return x.state},set state(R){x.state=R},dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const u=f=>Object.prototype.hasOwnProperty.call(this.b,f),n={};u("range")&&(n.range=k.Range.from(this.p)),u("label")&&(n.label=this.label),u("contextValue")&&(n.contextValue=this.contextValue??null),u("comments")&&(n.comments=this.q.map(f=>w(this,f,this.k))),u("collapsibleState")&&(n.collapseState=a(this.g)),u("canReply")&&(n.canReply=this.canReply),u("state")&&(n.state=d(this.h)),u("isTemplate")&&(n.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(u){for(const n of this.k){const f=n[0],g=n[1];if(u===g)return f}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}E.a=0,qe([(0,T.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,l.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,n,f,g){this.f=u,this.g=n,this.h=f,this.i=g,this.a=new Map,l.$registerCommentController(this.handle,f,g);const P=this;this.value=Object.freeze({id:P.id,label:P.label,get options(){return P.options},set options(M){P.options=M},get commentingRangeProvider(){return P.commentingRangeProvider},set commentingRangeProvider(M){P.commentingRangeProvider=M},get reactionHandler(){return P.reactionHandler},set reactionHandler(M){P.reactionHandler=M},createCommentThread(M,q,J){return P.createCommentThread(M,q,J).value},dispose:()=>{P.dispose()}}),this.e=[],this.e.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(u,n,f,g){if(typeof u=="string"){const P=new E(this.id,this.handle,u,n,f,g,this.f,!1);return this.a.set(P.handle,P),P}else{const P=new E(this.id,this.handle,void 0,u,n,f,this.f,!1);return this.a.set(P.handle,P),P}}$createCommentThreadTemplate(u,n){const f=new E(this.id,this.handle,void 0,C.URI.revive(u),k.Range.to(n),[],this.f,!0);return f.collapsibleState=O.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(u,n){const f=this.a.get(u);f&&(f.range=k.Range.to(n))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function w(c,u,n){let f=n.get(u);f||(f=++c.commentHandle,n.set(u,f));const g=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:f,body:typeof u.body=="string"?u.body:k.MarkdownString.from(u.body),userName:u.author.name,userIconPath:g,label:u.label,commentReactions:u.reactions?u.reactions.map(P=>s(P)):void 0,timestamp:u.timestamp?.toJSON()}}function s(c){return{label:c.label,iconPath:c.iconPath?k.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?C.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function a(c){if(c!==void 0)switch(c){case N.CommentThreadCollapsibleState.Expanded:return O.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return O.CommentThreadCollapsibleState.Collapsed}return O.CommentThreadCollapsibleState.Collapsed}function d(c){if(c!==void 0)switch(c){case N.CommentThreadState.Unresolved:return O.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return O.CommentThreadState.Resolved}return O.CommentThreadState.Unresolved}return new b}e.createExtHostComments=v}),define(Ie[200],Ce([1,0,23,4,27,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(N,D){this.a=N.getProxy(T.MainContext.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(N,D){const m=this,v=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){m.e(N,D,v,arguments)}})}e(N,D,m,v){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:S(v,this.b)}),this.c&&this.f(N,m,v)}};C=qe([Ve(0,L.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const O=1e5;function S(k,N){const D=[];if(k.length)for(let m=0;m<k.length;m++){let v=k[m];if(typeof v>"u")v="undefined";else if(v instanceof Error){const h=v;h.stack?v=h.stack:v=h.toString()}D.push(v)}if(N){const m=new Error().stack;m&&D.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,i.safeStringify)(D);return m.length>O?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ie[100],Ce([1,0,2,4,6,3,15,12,16,10,19,25]),function(ee,e,i,T,y,L,C,O,S,k,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class Ai{constructor(h,t){this.h=t,this.f=new Map,this.g=h.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,t){const o=Ai.c++;this.f.set(o,{provider:h,extensionDescription:t}),this.g.$registerDecorationProvider(o,t.identifier.value);const l=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(o,null);return}const E=(0,S.asArray)(b);if(E.length<=Ai.d){this.g.$onDidChange(o,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const p=E.map(r=>({uri:r,rank:(0,k.count)(r.path,"/")})),w=(0,S.groupBy)(p,(r,a)=>r.rank-a.rank||(0,k.compare)(r.uri.path,a.uri.path)),s=[];e:for(const r of w){let a;for(const d of r){const c=(0,N.dirname)(d.uri.path);if(a!==c&&(a=c,s.push(d.uri)>=Ai.d))break e}}this.g.$onDidChange(o,s)});return new y.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(h,t,o){if(!this.f.has(h))return Object.create(null);const l=Object.create(null),{provider:b,extensionDescription:E}=this.f.get(h);return await Promise.all(t.map(async p=>{try{const{uri:w,id:s}=p,r=await Promise.resolve(b.provideFileDecoration(i.URI.revive(w),o));if(!r)return;try{y.FileDecoration.validate(r),r.badge&&typeof r.badge!="string"&&(0,D.checkProposedApiEnabled)(E,"codiconDecoration"),l[s]=[r.propagate,r.tooltip,r.badge,r.color]}catch(a){this.h.warn(`INVALID decoration from extension '${E}': ${a}`)}}catch(w){this.h.error(w)}})),l}};m.c=0,m.d=250,m=qe([Ve(0,C.IExtHostRpcService),Ve(1,O.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[201],Ce([1,0,133,86,2,4,6,8,5,12,28,37]),function(ee,e,i,T,y,L,C,O,S,k,N,D){"use strict";var m,v,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class t{constructor(b,E,p,w,s,r,a){this.d=b,this.e=E,this.f=p,this.g=w,m.set(this,void 0),v.set(this,void 0),h.set(this,void 0),this.c=!1,Ye(this,h,new N.ResourceMap(d=>s.getComparisonKey(d)),"f"),Ye(this,m,r,"f"),Ye(this,v,a,"f")}dispose(){this.c||(Re(this,v,"f").fire([...Re(this,h,"f").keys()]),Re(this,m,"f")?.$clear(this.e),Re(this,h,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(b,E){if(!b){this.clear();return}this.h();let p=[];if(y.URI.isUri(b)){if(!E){this.delete(b);return}Re(this,h,"f").set(b,E.slice()),p=[b]}else if(Array.isArray(b)){p=[];let s;b=[...b].sort(t.j);for(const r of b){const[a,d]=r;if((!s||a.toString()!==s.toString())&&(s&&Re(this,h,"f").get(s).length===0&&Re(this,h,"f").delete(s),s=a,p.push(a),Re(this,h,"f").set(a,[])),d)Re(this,h,"f").get(a)?.push(...d);else{const c=Re(this,h,"f").get(a);c&&(c.length=0)}}}if(Re(this,v,"f").fire(p),!Re(this,m,"f"))return;const w=[];for(const s of p){let r=[];const a=Re(this,h,"f").get(s);if(a)if(a.length>this.f){r=[];const d=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const u of a)if(u.severity===d[c]&&r.push({...O.Diagnostic.from(u),modelVersionId:this.g(s)})===this.f)break e;r.push({severity:T.MarkerSeverity.Info,message:(0,i.localize)(0,null,a.length-this.f),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=a.map(d=>({...O.Diagnostic.from(d),modelVersionId:this.g(s)}));w.push([s,r])}Re(this,m,"f").$changeMany(this.e,w)}delete(b){this.h(),Re(this,v,"f").fire([b]),Re(this,h,"f").delete(b),Re(this,m,"f")?.$changeMany(this.e,[[b,void 0]])}clear(){this.h(),Re(this,v,"f").fire([...Re(this,h,"f").keys()]),Re(this,h,"f").clear(),Re(this,m,"f")?.$clear(this.e)}forEach(b,E){this.h();for(const[p,w]of this)b.call(E,p,w,this)}*[(m=new WeakMap,v=new WeakMap,h=new WeakMap,Symbol.iterator)](){this.h();for(const b of Re(this,h,"f").keys())yield[b,this.get(b)]}get(b){this.h();const E=Re(this,h,"f").get(b);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(b){return this.h(),Array.isArray(Re(this,h,"f").get(b))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(b,E){return b[0].toString()<E[0].toString()?-1:b[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=t;let o=class gi{static _mapper(b){const E=new N.ResourceMap;for(const p of b)E.set(p,p);return{uris:Object.freeze(Array.from(E.values()))}}constructor(b,E,p,w){this.h=E,this.j=p,this.k=w,this.f=new Map,this.g=new S.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,gi._mapper),this.e=b.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,E){const{f:p,e:w,g:s,h:r,j:a,k:d}=this,c=new class{$changeMany(f,g){w.$changeMany(f,g),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,f,g.length===0?"CLEARING":g)}$clear(f){w.$clear(f),r.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,f)}dispose(){w.dispose()}};let u;if(!E)E="_generated_diagnostic_collection_name_#"+gi.c++,u=E;else if(!p.has(E))u=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do u=E+gi.c++;while(p.has(u))}return new class extends t{constructor(){super(E,u,gi.d,f=>d.getDocument(f)?.version,a.extUri,c,s),p.set(u,this)}dispose(){super.dispose(),p.delete(u)}}}getDiagnostics(b){if(b)return this.l(b);{const E=new Map,p=[];for(const w of this.f.values())w.forEach((s,r)=>{let a=E.get(s.toString());typeof a>"u"&&(a=p.length,E.set(s.toString(),a),p.push([s,[]])),p[a][1]=p[a][1].concat(...r)});return p}}l(b){let E=[];for(const p of this.f.values())p.has(b)&&(E=E.concat(p.get(b)));return E}$acceptMarkersChange(b){if(!this.m){const E="_generated_mirror",p=new t(E,E,gi.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(E,p),this.m=p}for(const[E,p]of b)this.m.set(y.URI.revive(E),p.map(O.Diagnostic.to))}};o.c=0,o.d=1e3,o=qe([Ve(1,k.ILogService),Ve(2,D.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(Ie[202],Ce([1,0,2,4]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(C){this.a=C.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(O=>O?O.map(S=>i.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(O=>O?i.URI.revive(O):void 0)}}e.ExtHostDialogs=y}),define(Ie[203],Ce([1,0,11,2,6,4,13,20,10]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(D,m,v){this.d=m,this.e=v,this.b=new Map,this.c=D.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,m){if(Object.keys(C.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const v=k.a++;this.b.set(v,m),this.c.$registerTextContentProvider(v,D);let h;return typeof m.onDidChange=="function"&&(h=m.onDidChange(t=>{if(t.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${t.scheme}' which will be IGNORED`);return}this.d.getDocument(t)&&this.$provideTextDocumentContent(v,t).then(o=>{if(!o&&typeof o!="string")return;const l=this.d.getDocument(t);if(!l)return;const b=(0,S.splitLines)(o);if(!l.equalLines(b))return this.c.$onVirtualDocumentChange(t,o)},i.onUnexpectedError)})),new y.Disposable(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(D,m){const v=this.b.get(D);return v?Promise.resolve(v.provideTextDocumentContent(T.URI.revive(m),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=k,k.a=0}),define(Ie[204],Ce([1,0,5,7,2,4,95,8,9,23,6]),function(ee,e,i,T,y,L,C,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(v,h){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.DisposableStore,this.h=new Map,this.f=v.getProxy(L.MainContext.MainThreadDocuments),this.g=h,this.g.onDidRemoveDocuments(t=>{for(const o of t)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const o of t)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const h=this.g.getDocument(v);if(h)return h}getDocument(v){const h=this.getDocumentData(v);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return h.document}ensureDocumentData(v){const h=this.g.getDocument(v);if(h)return Promise.resolve(h);let t=this.h.get(v.toString());return t||(t=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const l=y.URI.revive(o);return(0,S.assertIsDefined)(this.g.getDocument(l))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),t)),t}createDocumentData(v){return this.f.$tryCreateDocument(v).then(h=>y.URI.revive(h))}$acceptModelLanguageChanged(v,h){const t=y.URI.revive(v),o=this.g.getDocument(t);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(h),this.a.fire(o.document)}$acceptModelSaved(v){const h=y.URI.revive(v),t=this.g.getDocument(h);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(v,h){const t=y.URI.revive(v),o=this.g.getDocument(t);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,h,t){const o=y.URI.revive(v),l=this.g.getDocument(o);if(!l)throw new Error("unknown document");l._acceptIsDirty(t),l.onEvents(h);let b;h.isUndoing?b=N.TextDocumentChangeReason.Undo:h.isRedoing&&(b=N.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:l.document,contentChanges:h.changes.map(E=>({range:O.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:b}))}setWordDefinitionFor(v,h){(0,C.setWordDefinitionFor)(v,h)}}e.ExtHostDocuments=D}),define(Ie[55],Ce([1,0,47,5,7,2,3,4,95,15,98,8,12,28,13,173,205]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(p){this.value=p,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let b=class{constructor(p,w){this.h=p,this.i=w,this.a=null,this.b=new Map,this.c=new v.ResourceMap,this.d=new T.Emitter,this.e=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const w=[],s=[],r=[];if(p.removedDocuments)for(const a of p.removedDocuments){const d=L.URI.revive(a),c=this.c.get(d);c?.unref()&&(this.c.delete(d),w.push(c.value))}if(p.addedDocuments)for(const a of p.addedDocuments){const d=L.URI.revive(a.uri);let c=this.c.get(d);if(c&&d.scheme!==h.Schemas.vscodeNotebookCell&&d.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);c||(c=new l(new S.ExtHostDocumentData(this.h.getProxy(O.MainContext.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(d,c),s.push(c.value)),c.ref()}if(p.removedEditors)for(const a of p.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&r.push(d)}if(p.addedEditors)for(const a of p.addedEditors){const d=L.URI.revive(a.documentUri);i.ok(this.c.has(d),`document '${d}' does not exist`),i.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const c=this.c.get(d).value,u=new N.ExtHostTextEditor(a.id,this.h.getProxy(O.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>c.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(n=>D.Range.to(n)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,u)}p.newActiveEditor!==void 0&&(i.ok(p.newActiveEditor===null||this.b.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this.a=p.newActiveEditor),(0,y.dispose)(w),(0,y.dispose)(r),p.removedDocuments&&this.e.fire(w),p.addedDocuments&&this.d.fire(s),(p.removedEditors||p.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),p.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(p){return this.c.get(p)?.value}allDocuments(){return t.Iterable.map(this.c.values(),p=>p.value)}getEditor(p){return this.b.get(p)}activeEditor(p){if(!this.a)return;const w=this.b.get(this.a);return p?w:w?.value}allEditors(){return[...this.b.values()]}};b=qe([Ve(0,k.IExtHostRpcService),Ve(1,m.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[56],Ce([1,0,8,4,2,5,3,6,15,9,78]),function(ee,e,i,T,y,L,C,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class D{constructor(o,l,b){this.e=b,this.d=l,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.TextTabInput(y.URI.revive(this.b.input.uri));case 2:return new O.TextDiffTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified));case 3:return new O.TextMergeTabInput(y.URI.revive(this.b.input.base),y.URI.revive(this.b.input.input1),y.URI.revive(this.b.input.input2),y.URI.revive(this.b.input.result));case 6:return new O.CustomEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.WebviewEditorTabInput(this.b.input.viewType);case 4:return new O.NotebookEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.NotebookDiffEditorTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.TerminalEditorTabInput;case 9:return new O.InteractiveWindowInput(y.URI.revive(this.b.input.uri),y.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(o,l){this.c=[],this.d="",this.b=o,this.e=l;for(const b of o.tabs)b.isActive&&(this.d=b.id),this.c.push(new D(b,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return i.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(b=>b.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(b=>b.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const b=new D(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,b),o.tabDto.isActive&&(this.d=b.tabId),b}else if(o.kind===1){const b=this.c.splice(o.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return b.tabId===this.d&&(this.d=""),b}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this.c.splice(o.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,b),b}const l=this.c.find(b=>b.tabId===o.tabDto.id);if(!l)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(o.tabDto),l}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=o.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,l={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(b=>b.apiObject))},get activeTabGroup(){const b=o.d;return(0,k.assertIsDefined)(o.e.find(p=>p.groupId===b)?.apiObject)},close:async(b,E)=>{const p=Array.isArray(b)?b:[b];return p.length?h(p[0])?this.j(p,E):this.i(p,E):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(o){const l=new Set(this.e.map(a=>a.groupId)),b=new Set(o.map(a=>a.groupId)),E=(0,N.diffSets)(l,b),p=this.e.filter(a=>E.removed.includes(a.groupId)).map(a=>a.apiObject),w=[],s=[];this.e=o.map(a=>{const d=new m(a,()=>this.d);return E.added.includes(d.groupId)?w.push(d.apiObject):s.push(d.apiObject),d});const r=(0,k.assertIsDefined)(o.find(a=>a.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:w,closed:p,changed:s}))}$acceptTabGroupUpdate(o){const l=this.e.find(b=>b.groupId===o.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const l=this.e.find(E=>E.groupId===o.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const b=l.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}g(o){for(const l of this.e)for(const b of l.tabs)if(b.apiObject===o)return b}h(o){return this.e.find(l=>l.apiObject===o)}async i(o,l){const b=[];for(const E of o){const p=this.g(E);if(!p)throw new Error("Tab close: Invalid tab not found!");b.push(p.tabId)}return this.a.$closeTab(b,l)}async j(o,l){const b=[];for(const E of o){const p=this.h(E);if(!p)throw new Error("Group close: Invalid group not found!");b.push(p.groupId)}return this.a.$closeGroup(b,l)}};v=qe([Ve(0,S.IExtHostRpcService)],v),e.ExtHostEditorTabs=v;function h(t){return t.tabs!==void 0}}),define(Ie[206],Ce([1,0,2,4,7,6,8,251,10,24,25]),function(ee,e,i,T,y,L,C,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const t=this.a.indexOf(h);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),t=[];let o,l,b=14,E=14;for(const p of h){let w=o?(0,S.commonPrefixLength)(o,p):0;for(w===0?l=1:l=E;w<p.length;w++)w+1===p.length?(b=E,E=9):E+=1,t.push([l,p.toUpperCase().charCodeAt(w),E]),t.push([l,p.toLowerCase().charCodeAt(w),E]),l=E;o=p,E=b}t.push([9,58,10]),t.push([10,47,12]),this.b=new O.StateMachine(t)}}provideDocumentLinks(h){this.c();const t=[],o=O.LinkComputer.computeLinks({getLineContent(l){return h.lineAt(l-1).text},getLineCount(){return h.lineCount}},this.b);for(const l of o){const b=C.DocumentLink.to(l);b.target&&t.push(b)}return t}}class m{constructor(h,t){this.i=t,this.b=new D,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,t,o,l={}){if(this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const b=this.h++;this.b.add(t),this.d.add(t),this.c.set(b,o);let E=2;l.isCaseSensitive&&(E+=1024),l.isReadonly&&(E+=2048),typeof o.copy=="function"&&(E+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,N.checkProposedApiEnabled)(h,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(b,t,E).catch(w=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${t}`),console.error(w)});const p=o.onDidChangeFile(w=>{const s=[];for(const r of w){const{uri:a,type:d}=r;if(a.scheme!==t)continue;let c;switch(d){case L.FileChangeType.Changed:c=0;break;case L.FileChangeType.Created:c=1;break;case L.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:a,type:c})}this.a.$onFileSystemChange(b,s)});return(0,y.toDisposable)(()=>{p.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(h){const{type:t,ctime:o,mtime:l,size:b,permissions:E}=h;return{type:t,ctime:o,mtime:l,size:b,permissions:E}}$stat(h,t){return Promise.resolve(this.k(h).stat(i.URI.revive(t))).then(o=>m.j(o))}$readdir(h,t){return Promise.resolve(this.k(h).readDirectory(i.URI.revive(t)))}$readFile(h,t){return Promise.resolve(this.k(h).readFile(i.URI.revive(t))).then(o=>k.VSBuffer.wrap(o))}$writeFile(h,t,o,l){return Promise.resolve(this.k(h).writeFile(i.URI.revive(t),o.buffer,l))}$delete(h,t,o){return Promise.resolve(this.k(h).delete(i.URI.revive(t),o))}$rename(h,t,o,l){return Promise.resolve(this.k(h).rename(i.URI.revive(t),i.URI.revive(o),l))}$copy(h,t,o,l){const b=this.k(h);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(i.URI.revive(t),i.URI.revive(o),l))}$mkdir(h,t){return Promise.resolve(this.k(h).createDirectory(i.URI.revive(t)))}$watch(h,t,o,l){const b=this.k(h).watch(i.URI.revive(o),l);this.f.set(t,b)}$unwatch(h,t){const o=this.f.get(t);o&&(o.dispose(),this.f.delete(t))}$open(h,t,o){const l=this.k(h);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(i.URI.revive(t),o))}$close(h,t){const o=this.k(h);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(t))}$read(h,t,o,l){const b=this.k(h);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(l);return Promise.resolve(b.read(t,o,E.buffer,0,l)).then(p=>E.slice(0,p))}$write(h,t,o,l){const b=this.k(h);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(t,o,l.buffer,0,l.byteLength))}k(h){const t=this.c.get(h);if(!t){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return t}}e.ExtHostFileSystem=m}),define(Ie[57],Ce([1,0,4,36,6,24,3,15,37,7]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class Jt{constructor(m,v){this.b=new Map,this.a=m.getProxy(i.MainContext.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(t){try{const o=h.b.get(t.scheme);if(!o)return await h.a.$stat(t);await h.a.$ensureActivation(t.scheme);const l=await o.stat(t);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(o){Jt.c(o)}},async readDirectory(t){try{const o=h.b.get(t.scheme);return o?(await h.a.$ensureActivation(t.scheme),(await o.readDirectory(t)).slice()):await h.a.$readdir(t)}catch(o){return Jt.c(o)}},async createDirectory(t){try{return await h.a.$mkdir(t)}catch(o){return Jt.c(o)}},async readFile(t){try{const o=h.b.get(t.scheme);return o?(await h.a.$ensureActivation(t.scheme),(await o.readFile(t)).slice()):(await h.a.$readFile(t)).buffer}catch(o){return Jt.c(o)}},async writeFile(t,o){try{return await h.a.$writeFile(t,L.VSBuffer.wrap(o))}catch(l){return Jt.c(l)}},async delete(t,o){try{const l=h.b.get(t.scheme);return l?(await h.a.$ensureActivation(t.scheme),await l.delete(t,{recursive:!1,...o})):await h.a.$delete(t,{recursive:!1,useTrash:!1,...o})}catch(l){return Jt.c(l)}},async rename(t,o,l){try{return await h.a.$rename(t,o,{overwrite:!1,...l})}catch(b){return Jt.c(b)}},async copy(t,o,l){try{return await h.a.$copy(t,o,{overwrite:!1,...l})}catch(b){return Jt.c(b)}},isWritableFileSystem(t){const o=v.getCapabilities(t);if(typeof o=="number")return!(o&2048)}})}static c(m){if(m instanceof y.FileSystemError)throw m;if(!(m instanceof Error))throw new y.FileSystemError(String(m));if(m.name==="ENOPRO")throw y.FileSystemError.Unavailable(m.message);switch(m.name){case T.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(m.message);case T.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(m.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(m.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(m.message);case T.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(m.message);case T.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(m.message);default:throw new y.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,v){return this.b.set(m,v),(0,k.toDisposable)(()=>this.b.delete(m))}};N=qe([Ve(0,O.IExtHostRpcService),Ve(1,S.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[207],Ce([1,0,5,35,2,4,8,6]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(D,m,v,h,t,o,l,b){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const E=this.h(D,v,t);this.g=0,o&&(this.g+=1),l&&(this.g+=2),b&&(this.g+=4);const p=(0,T.parse)(t),w=typeof t=="string",s=h(r=>{if(!o)for(const a of r.created){const d=y.URI.revive(a);p(d.fsPath)&&(!w||m.getWorkspaceFolder(d))&&this.a.fire(d)}if(!l)for(const a of r.changed){const d=y.URI.revive(a);p(d.fsPath)&&(!w||m.getWorkspaceFolder(d))&&this.b.fire(d)}if(!b)for(const a of r.deleted){const d=y.URI.revive(a);p(d.fsPath)&&(!w||m.getWorkspaceFolder(d))&&this.c.fire(d)}});this.d=O.Disposable.from(E,this.a,this.b,this.c,s)}h(D,m,v){const h=O.Disposable.from();if(typeof v=="string")return h;const t=D.getProxy(L.MainContext.MainThreadFileSystem);let o=!1;(v.pattern.includes(T.GLOBSTAR)||v.pattern.includes(T.GLOB_SPLIT))&&(o=!0);const l=Math.random();return t.$watch(m.identifier.value,l,v.baseUri,{recursive:o,excludes:[]}),O.Disposable.from({dispose:()=>t.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(D,m,v){this.j=D,this.k=m,this.l=v,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,m,v,h,t,o){return new S(this.j,D,m,this.a.event,C.GlobPattern.from(v),h,t,o)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,m){switch(D){case 2:this.b.fire(Object.freeze({files:m.map(v=>({oldUri:y.URI.revive(v.source),newUri:y.URI.revive(v.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(v=>y.URI.revive(v.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(v=>y.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,m){return(v,h,t)=>{const o=function(b){v.call(h,b)};return o.extension=D,m.event(o,void 0,t)}}async $onWillRunFileOperation(D,m,v,h){switch(D){case 2:return await this.n(this.g,{files:m.map(t=>({oldUri:y.URI.revive(t.source),newUri:y.URI.revive(t.target)}))},v,h);case 1:return await this.n(this.i,{files:m.map(t=>y.URI.revive(t.target))},v,h);case 0:case 3:return await this.n(this.h,{files:m.map(t=>y.URI.revive(t.target))},v,h)}}async n(D,m,v,h){const t=new Set,o=[];if(await D.fireAsync(m,h,async(b,E)=>{const p=Date.now(),w=await Promise.resolve(b);w instanceof O.WorkspaceEdit&&(o.push([E.extension,w]),t.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-p>v&&this.k.warn("SLOW file-participant",E.extension.identifier)}),h.isCancellationRequested||o.length===0)return;const l={edits:[]};for(const[,b]of o){const{edits:E}=C.WorkspaceEdit.from(b,{getTextDocumentVersion:p=>this.l.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(E)}return{edit:l,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=k}),define(Ie[208],Ce([1,0,2,38]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(C,O,S,k,N){this.a=O,this.b=S,this.c=k;const D=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new T.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new T.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new T.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new T.ApiCommandResult("Notebook and input URI",m=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const v=this.a.getEditorById(m.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri),notebookEditor:v.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(C,O,S,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=y}),define(Ie[209],Ce([1,0,7,4]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(C){this.b=0,this.a=C.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,C),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.ExtHostLabelService=y}),define(Ie[210],Ce([1,0,2,23,8,6,71,4,10,54,16,9,252,20,7,83,79,51,99,11,14,25]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(I,U){this.d=I,this.e=U}async provideDocumentSymbols(I,U){const H=this.d.getDocument(I),j=await this.e.provideDocumentSymbols(H,U);if(!(0,N.isFalsyOrEmpty)(j))return j[0]instanceof L.DocumentSymbol?j.map(y.DocumentSymbol.from):s.f(j)}static f(I){I=I.slice(0).sort((j,Z)=>{let de=j.location.range.start.compareTo(Z.location.range.start);return de===0&&(de=Z.location.range.end.compareTo(j.location.range.end)),de});const U=[],H=[];for(const j of I){const Z={name:j.name||"!!MISSING: name!!",kind:y.SymbolKind.from(j.kind),tags:j.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:y.Range.from(j.location.range),selectionRange:y.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(Z),U.push(Z);break}const de=H[H.length-1];if(k.Range.containsRange(de.range,Z.range)&&!k.Range.equalsRange(de.range,Z.range)){de.children?.push(Z),H.push(Z);break}H.pop()}}return U}}class r{constructor(I,U,H){this.g=I,this.h=U,this.j=H,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,U){const H=this.g.getDocument(I),j=await this.j.provideCodeLenses(H,U);if(!j||U.isCancellationRequested)return;const Z=this.e.add(j),de=new h.DisposableStore;this.f.set(Z,de);const Se={cacheId:Z,lenses:[]};for(let ae=0;ae<j.length;ae++)Se.lenses.push({cacheId:[Z,ae],range:y.Range.from(j[ae].range),command:this.h.toInternal(j[ae].command,de)});return Se}async resolveCodeLens(I,U){const H=I.cacheId&&this.e.get(...I.cacheId);if(!H)return;let j;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?j=H:j=await this.j.resolveCodeLens(H,U),j||(j=H),U.isCancellationRequested)return;const Z=I.cacheId&&this.f.get(I.cacheId[0]);if(!!Z)return I.command=this.h.toInternal(j.command??r.d,Z),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}r.d={command:"missing",title:"!!MISSING: command!!"};function a(Y){return Array.isArray(Y)?Y.map(y.DefinitionLink.from):Y?[y.DefinitionLink.from(Y)]:[]}class d{constructor(I,U){this.d=I,this.e=U}async provideDefinition(I,U,H){const j=this.d.getDocument(I),Z=y.Position.to(U),de=await this.e.provideDefinition(j,Z,H);return a(de)}}class c{constructor(I,U){this.d=I,this.e=U}async provideDeclaration(I,U,H){const j=this.d.getDocument(I),Z=y.Position.to(U),de=await this.e.provideDeclaration(j,Z,H);return a(de)}}class u{constructor(I,U){this.d=I,this.e=U}async provideImplementation(I,U,H){const j=this.d.getDocument(I),Z=y.Position.to(U),de=await this.e.provideImplementation(j,Z,H);return a(de)}}class n{constructor(I,U){this.d=I,this.e=U}async provideTypeDefinition(I,U,H){const j=this.d.getDocument(I),Z=y.Position.to(U),de=await this.e.provideTypeDefinition(j,Z,H);return a(de)}}class f{constructor(I,U){this.d=I,this.e=U}async provideHover(I,U,H){const j=this.d.getDocument(I),Z=y.Position.to(U),de=await this.e.provideHover(j,Z,H);if(!(!de||(0,N.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=j.getWordRangeAtPosition(Z)),de.range||(de.range=new L.Range(Z,Z)),y.Hover.from(de)}}class g{constructor(I,U){this.d=I,this.e=U}async provideEvaluatableExpression(I,U,H){const j=this.d.getDocument(I),Z=y.Position.to(U),de=await this.e.provideEvaluatableExpression(j,Z,H);if(de)return y.EvaluatableExpression.from(de)}}class P{constructor(I,U){this.d=I,this.e=U}async provideInlineValues(I,U,H,j){const Z=this.d.getDocument(I),de=await this.e.provideInlineValues(Z,y.Range.to(U),y.InlineValueContext.to(H),j);if(Array.isArray(de))return de.map(Se=>y.InlineValue.from(Se))}}class M{constructor(I,U){this.d=I,this.e=U}async provideDocumentHighlights(I,U,H){const j=this.d.getDocument(I),Z=y.Position.to(U),de=await this.e.provideDocumentHighlights(j,Z,H);if(Array.isArray(de))return de.map(y.DocumentHighlight.from)}}class q{constructor(I,U){this.d=I,this.e=U}async provideLinkedEditingRanges(I,U,H){const j=this.d.getDocument(I),Z=y.Position.to(U),de=await this.e.provideLinkedEditingRanges(j,Z,H);if(de&&Array.isArray(de.ranges))return{ranges:(0,N.coalesce)(de.ranges.map(y.Range.from)),wordPattern:de.wordPattern}}}class J{constructor(I,U){this.d=I,this.e=U}async provideReferences(I,U,H,j){const Z=this.d.getDocument(I),de=y.Position.to(U),Se=await this.e.provideReferences(Z,de,H,j);if(Array.isArray(Se))return Se.map(y.location.from)}}class x{constructor(I,U,H,j,Z,de,Se){this.g=I,this.h=U,this.j=H,this.k=j,this.l=Z,this.m=de,this.n=Se,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,U,H,j){const Z=this.g.getDocument(I),de=m.Selection.isISelection(U)?y.Selection.to(U):y.Range.to(U),Se=[];for(const tt of this.j.getDiagnostics(I))if(de.intersection(tt.range)&&Se.push(tt)>x.d)break;const ae={diagnostics:Se,only:H.only?new L.CodeActionKind(H.only):void 0,triggerKind:y.CodeActionTriggerKind.to(H.trigger)},ve=await this.k.provideCodeActions(Z,de,ae,j);if(!(0,N.isNonEmptyArray)(ve)||j.isCancellationRequested)return;const be=this.e.add(ve),$e=new h.DisposableStore;this.f.set(be,$e);const He=[];for(let tt=0;tt<ve.length;tt++){const xe=ve[tt];!xe||(x.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,$e)})):(ae.only&&(xe.kind?ae.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[be,tt],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,$e),diagnostics:xe.diagnostics&&xe.diagnostics.map(y.Diagnostic.from),edit:xe.edit&&y.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,disabled:xe.disabled?.reason})))}return{cacheId:be,actions:He}}async resolveCodeAction(I,U){const[H,j]=I,Z=this.e.get(H,j);if(!Z||x.o(Z)||!this.k.resolveCodeAction)return;const de=await this.k.resolveCodeAction(Z,U)??Z;return de?.edit?y.WorkspaceEdit.from(de.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}x.d=1e3;class R{constructor(I,U,H,j){this.d=I,this.e=U,this.f=H,this.g=j}async prepareDocumentPaste(I,U,H,j){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(I),de=U.map(ae=>y.Range.to(ae)),Se=y.DataTransfer.toDataTransfer(H,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(Z,de,Se,j),y.DataTransfer.toDataTransferDTO(Se)}async providePasteEdits(I,U,H,j,Z){const de=this.e.getDocument(U),Se=H.map(be=>y.Range.to(be)),ae=y.DataTransfer.toDataTransfer(j,async be=>(await this.d.$resolvePasteFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentPasteEdits(de,Se,ae,Z);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?y.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class A{constructor(I,U){this.d=I,this.e=U}async provideDocumentFormattingEdits(I,U,H){const j=this.d.getDocument(I),Z=await this.e.provideDocumentFormattingEdits(j,U,H);if(Array.isArray(Z))return Z.map(y.TextEdit.from)}}class F{constructor(I,U){this.d=I,this.e=U}async provideDocumentRangeFormattingEdits(I,U,H,j){const Z=this.d.getDocument(I),de=y.Range.to(U),Se=await this.e.provideDocumentRangeFormattingEdits(Z,de,H,j);if(Array.isArray(Se))return Se.map(y.TextEdit.from)}}class ${constructor(I,U){this.d=I,this.e=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,U,H,j,Z){const de=this.d.getDocument(I),Se=y.Position.to(U),ae=await this.e.provideOnTypeFormattingEdits(de,Se,H,j,Z);if(Array.isArray(ae))return ae.map(y.TextEdit.from)}}class z{constructor(I,U){this.e=I,this.f=U,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,U){const H=await this.e.provideWorkspaceSymbols(I,U);if(!(0,N.isNonEmptyArray)(H))return{symbols:[]};const j=this.d.add(H),Z={cacheId:j,symbols:[]};for(let de=0;de<H.length;de++){const Se=H[de];if(!Se||!Se.name){this.f.warn("INVALID SymbolInformation",Se);continue}Z.symbols.push({...y.WorkspaceSymbol.from(Se),cacheId:[j,de]})}return Z}async resolveWorkspaceSymbol(I,U){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this.d.get(...I.cacheId);if(H){const j=await this.e.resolveWorkspaceSymbol(H,U);return j&&(0,T.mixin)(I,y.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class V{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,U,H){this.d=I,this.e=U,this.f=H}async provideRenameEdits(I,U,H,j){const Z=this.d.getDocument(I),de=y.Position.to(U);try{const Se=await this.e.provideRenameEdits(Z,de,H,j);return Se?y.WorkspaceEdit.from(Se):void 0}catch(Se){const ae=V.g(Se);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation(I,U,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const j=this.d.getDocument(I),Z=y.Position.to(U);try{const de=await this.e.prepareRename(j,Z,H);let Se,ae;if(L.Range.isRange(de)?(Se=de,ae=j.getText(de)):(0,D.isObject)(de)&&(Se=de.range,ae=de.placeholder),!Se||!ae)return;if(Se.start.line>Z.line||Se.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(Se),text:ae}}catch(de){const Se=V.g(de);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(de)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class K{constructor(I,U){this.resultId=I,this.tokens=U}}class ie{constructor(I,U){this.f=I,this.g=U,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,U,H){const j=this.f.getDocument(I),Z=U!==0?this.d.get(U):null;let de=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(j,Z.resultId,H):await this.g.provideDocumentSemanticTokens(j,H);return Z&&this.d.delete(U),de?(de=ie.h(de),this.o(ie.n(Z,de),de)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return ie.j(I)?ie.k(I)?I:new L.SemanticTokens(new Uint32Array(I.data),I.resultId):ie.l(I)?ie.m(I)?I:new L.SemanticTokensEdits(I.edits.map(U=>new L.SemanticTokensEdit(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const U of I.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static n(I,U){if(!ie.j(U)||!I||!I.tokens)return U;const H=I.tokens,j=H.length,Z=U.data,de=Z.length;let Se=0;const ae=Math.min(j,de);for(;Se<ae&&H[Se]===Z[Se];)Se++;if(Se===j&&Se===de)return new L.SemanticTokensEdits([],U.resultId);let ve=0;const be=ae-Se;for(;ve<be&&H[j-ve-1]===Z[de-ve-1];)ve++;return new L.SemanticTokensEdits([{start:Se,deleteCount:j-Se-ve,data:Z.subarray(Se,de-ve)}],U.resultId)}o(I,U){if(ie.j(I)){const H=this.e++;return this.d.set(H,new K(I.resultId,I.data)),(0,t.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(ie.l(I)){const H=this.e++;return ie.j(U)?this.d.set(H,new K(U.resultId,U.data)):this.d.set(H,new K(I.resultId)),(0,t.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class ge{constructor(I,U){this.d=I,this.e=U}async provideDocumentRangeSemanticTokens(I,U,H){const j=this.d.getDocument(I),Z=await this.e.provideDocumentRangeSemanticTokens(j,y.Range.to(U),H);return Z?this.f(Z):null}f(I){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ce{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,U,H,j,Z){this.f=I,this.g=U,this.h=H,this.j=j,this.k=Z,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,U,H,j){const Z=this.f.getDocument(I),de=y.Position.to(U),Se=Z.getWordRangeAtPosition(de)||new L.Range(de,de),ae=Se.with({end:de}),ve=new b.StopWatch(!0),be=await this.h.provideCompletionItems(Z,de,j,y.CompletionContext.to(H));if(!be||j.isCancellationRequested)return;const $e=Array.isArray(be)?new L.CompletionList(be):be,He=ce.supportsResolving(this.h)?this.d.add($e.items):this.d.add([]),tt=new h.DisposableStore;this.e.set(He,tt);const xe=[],et={x:He,b:xe,a:{replace:y.Range.from(Se),insert:y.Range.from(ae)},c:$e.isIncomplete||void 0,d:ve.elapsed()};for(let it=0;it<$e.items.length;it++){const dt=$e.items[it],Fe=this.l(dt,[He,it],ae,Se);xe.push(Fe)}return et}async resolveCompletionItem(I,U){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...I);if(!H)return;const j=await this.h.resolveCompletionItem(H,U);if(!!j)return this.l(j,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,U,H,j){const Z=this.e.get(U[0]);if(!Z)throw Error("DisposableStore is missing...");const de=this.g.toInternal(I.command,Z),Se={x:U,a:I.label,b:I.kind!==void 0?y.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(y.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:y.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(y.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Se.h=I.textEdit.newText):typeof I.insertText=="string"?Se.h=I.insertText:I.insertText instanceof L.SnippetString&&(Se.h=I.insertText.value,Se.i|=4);let ae;return I.textEdit?ae=I.textEdit.range:I.range&&(ae=I.range),L.Range.isRange(ae)?Se.j=y.Range.from(ae):ae&&(!H?.isEqual(ae.inserting)||!j?.isEqual(ae.replacing))&&(Se.j={insert:y.Range.from(ae.inserting),replace:y.Range.from(ae.replacing)}),Se}}class re{async provideInlineCompletions(I,U,H,j){}disposeCompletions(I){}handleDidShowCompletionItem(I,U){}}class se extends re{constructor(I,U,H,j){super(),this.f=I,this.g=U,this.h=H,this.j=j,this.d=new le,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,U,H,j){const Z=this.g.getDocument(I),de=y.Position.to(U),Se=await this.h.provideInlineCompletionItems(Z,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:y.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},j);if(!Se||j.isCancellationRequested)return;const ae=Array.isArray(Se)?Se:Se.items,ve=this.e?Array.isArray(Se)?[]:Se.commands||[]:[];let be;return{pid:this.d.createReferenceId({dispose(){be?.dispose()},items:ae}),items:ae.map((He,tt)=>{let xe;He.command&&(be||(be=new h.DisposableStore),xe=this.j.toInternal(He.command,be));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?y.Range.from(He.range):void 0,command:xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:ve.map(He=>(be||(be=new h.DisposableStore),this.j.toInternal(He,be)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,U){const H=this.d.get(I)?.items[U];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}}class le{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const U=this.e++;return this.d.set(U,I),U}disposeReferenceId(I){const U=this.d.get(I);return this.d.delete(I),U}get(I){return this.d.get(I)}}class _{constructor(I,U){this.e=I,this.f=U,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(I,U,H,j){const Z=this.e.getDocument(I),de=y.Position.to(U),Se=this.g(H),ae=await this.f.provideSignatureHelp(Z,de,j,Se);if(ae){const ve=this.d.add([ae]);return{...y.SignatureHelp.from(ae),id:ve}}}g(I){let U;if(I.activeSignatureHelp){const H=y.SignatureHelp.to(I.activeSignatureHelp),j=this.d.get(I.activeSignatureHelp.id,0);j?(U=j,U.activeSignature=H.activeSignature,U.activeParameter=H.activeParameter):U=H}return{...I,activeSignatureHelp:U}}releaseSignatureHelp(I){this.d.delete(I)}}class me{constructor(I,U,H,j,Z){this.f=I,this.g=U,this.h=H,this.j=j,this.k=Z,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,U,H){const j=this.f.getDocument(I),Z=y.Range.to(U),de=await this.h.provideInlayHints(j,Z,H);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${U}`);return}if(H.isCancellationRequested)return;const Se=this.d.add(de);this.e.set(Se,new h.DisposableStore);const ae={hints:[],cacheId:Se};for(let ve=0;ve<de.length;ve++)this.l(de[ve],Z)&&ae.hints.push(this.m(de[ve],[Se,ve]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${U}`),ae}async resolveInlayHint(I,U){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...I);if(!H)return;const j=await this.h.resolveInlayHint(H,U);if(!!j&&!!this.l(j))return this.m(j,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,U){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(U&&!U.contains(I.position))}m(I,U){const H=this.e.get(U[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:U,tooltip:y.MarkdownString.fromStrict(I.tooltip),position:y.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(y.TextEdit.from),kind:I.kind&&y.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?j.label=I.label:j.label=I.label.map(Z=>{const de={label:Z.value};return de.tooltip=y.MarkdownString.fromStrict(Z.tooltip),L.Location.isLocation(Z.location)&&(de.location=y.location.from(Z.location)),Z.command&&(de.command=this.g.toInternal(Z.command,H)),de}),j}}class we{constructor(I,U){this.e=I,this.f=U,this.d=new l.Cache("DocumentLink")}async provideLinks(I,U){const H=this.e.getDocument(I),j=await this.f.provideDocumentLinks(H,U);if(!(!Array.isArray(j)||j.length===0)&&!U.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:j.filter(we.g).map(y.DocumentLink.from)};{const Z=this.d.add(j),de={links:[],cacheId:Z};for(let Se=0;Se<j.length;Se++){if(!we.g(j[Se]))continue;const ae=y.DocumentLink.from(j[Se]);ae.cacheId=[Z,Se],de.links.push(ae)}return de}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,U){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...I);if(!H)return;const j=await this.f.resolveDocumentLink(H,U);if(!(!j||!we.g(j)))return y.DocumentLink.from(j)}releaseLinks(I){this.d.delete(I)}}class Ne{constructor(I,U){this.d=I,this.e=U}async provideColors(I,U){const H=this.d.getDocument(I),j=await this.e.provideDocumentColors(H,U);return Array.isArray(j)?j.map(de=>({color:y.Color.from(de.color),range:y.Range.from(de.range)})):[]}async provideColorPresentations(I,U,H){const j=this.d.getDocument(I),Z=y.Range.to(U.range),de=y.Color.to(U.color),Se=await this.e.provideColorPresentations(de,{document:j,range:Z},H);if(!!Array.isArray(Se))return Se.map(y.ColorPresentation.from)}}class We{constructor(I,U){this.d=I,this.e=U}async provideFoldingRanges(I,U,H){const j=this.d.getDocument(I),Z=await this.e.provideFoldingRanges(j,U,H);if(!!Array.isArray(Z))return Z.map(y.FoldingRange.from)}}class Qe{constructor(I,U,H){this.d=I,this.e=U,this.f=H}async provideSelectionRanges(I,U,H){const j=this.d.getDocument(I),Z=U.map(y.Position.to),de=await this.e.provideSelectionRanges(j,Z,H);if(!(0,N.isNonEmptyArray)(de))return[];if(de.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let ae=0;ae<Z.length;ae++){const ve=[];Se.push(ve);let be=Z[ae],$e=de[ae];for(;;){if(!$e.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(y.SelectionRange.from($e)),!$e.parent)break;be=$e.range,$e=$e.parent}}return Se}}class Te{constructor(I,U){this.f=I,this.g=U,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,U,H){const j=this.f.getDocument(I),Z=y.Position.to(U),de=await this.g.prepareCallHierarchy(j,Z,H);if(!de)return;const Se=this.d.nextId();return this.e.set(Se,new Map),Array.isArray(de)?de.map(ae=>this.h(Se,ae)):[this.h(Se,de)]}async provideCallsTo(I,U,H){const j=this.j(I,U);if(!j)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(j,H);if(!!Z)return Z.map(de=>({from:this.h(I,de.from),fromRanges:de.fromRanges.map(Se=>y.Range.from(Se))}))}async provideCallsFrom(I,U,H){const j=this.j(I,U);if(!j)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(j,H);if(!!Z)return Z.map(de=>({to:this.h(I,de.to),fromRanges:de.fromRanges.map(Se=>y.Range.from(Se))}))}releaseSession(I){this.e.delete(I)}h(I,U){const H=this.e.get(I),j=y.CallHierarchyItem.from(U,I,H.size.toString(36));return H.set(j._itemId,U),j}j(I,U){return this.e.get(I)?.get(U)}}class De{constructor(I,U){this.f=I,this.g=U,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,U,H){const j=this.f.getDocument(I),Z=y.Position.to(U),de=await this.g.prepareTypeHierarchy(j,Z,H);if(!de)return;const Se=this.d.nextId();return this.e.set(Se,new Map),Array.isArray(de)?de.map(ae=>this.h(Se,ae)):[this.h(Se,de)]}async provideSupertypes(I,U,H){const j=this.j(I,U);if(!j)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(j,H);if(!!Z)return Z.map(de=>this.h(I,de))}async provideSubtypes(I,U,H){const j=this.j(I,U);if(!j)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(j,H);if(!!Z)return Z.map(de=>this.h(I,de))}releaseSession(I){this.e.delete(I)}h(I,U){const H=this.e.get(I),j=y.TypeHierarchyItem.from(U,I,H.size.toString(36));return H.set(j._itemId,U),j}j(I,U){return this.e.get(I)?.get(U)}}class ke{constructor(I,U,H,j){this.d=I,this.e=U,this.f=H,this.g=j}async provideDocumentOnDropEdits(I,U,H,j,Z){const de=this.e.getDocument(U),Se=y.Position.to(H),ae=y.DataTransfer.toDataTransfer(j,async be=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentDropEdits(de,Se,ae,Z);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?y.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class oe{constructor(I,U){this.adapter=I,this.extension=U}}class ue{constructor(I,U,H,j,Z,de,Se,ae){this.g=U,this.h=H,this.j=j,this.k=Z,this.l=de,this.m=Se,this.n=ae,this.f=new Map,this.e=I.getProxy(O.MainContext.MainThreadLanguageFeatures)}o(I){return y.DocumentSelector.from(I,this.g)}p(I){return new L.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ue.d++}async s(I,U,H,j,Z,de=!1){const Se=this.f.get(I);if(!Se||!(Se.adapter instanceof U))return j;const ae=Date.now();de||this.l.trace(`[${Se.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ve=H(Se.adapter,Se.extension);return Promise.resolve(ve).catch(be=>{(0,E.isCancellationError)(be)||(this.l.error(`[${Se.extension.identifier.value}] provider FAILED`),this.l.error(be),this.n.onExtensionError(Se.extension.identifier,be))}).finally(()=>{de||this.l.trace(`[${Se.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),v.CancellationToken.isCancellationToken(Z)?(0,p.raceCancellationError)(ve,Z):ve}t(I,U){const H=this.q();return this.f.set(H,new oe(I,U)),H}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,U,H,j){const Z=this.t(new s(this.h,H),I),de=j&&j.label||ue.u(I);return this.e.$registerDocumentSymbolProvider(Z,this.o(U),de),this.p(Z)}$provideDocumentSymbols(I,U,H){return this.s(I,s,j=>j.provideDocumentSymbols(i.URI.revive(U),H),void 0,H)}registerCodeLensProvider(I,U,H){const j=this.q(),Z=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(j,new oe(new r(this.h,this.j.converter,H),I)),this.e.$registerCodeLensSupport(j,this.o(U),Z);let de=this.p(j);if(Z!==void 0){const Se=H.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(Z));de=L.Disposable.from(de,Se)}return de}$provideCodeLenses(I,U,H){return this.s(I,r,j=>j.provideCodeLenses(i.URI.revive(U),H),void 0,H)}$resolveCodeLens(I,U,H){return this.s(I,r,j=>j.resolveCodeLens(U,H),void 0,void 0)}$releaseCodeLenses(I,U){this.s(I,r,H=>Promise.resolve(H.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(I,U,H){const j=this.t(new d(this.h,H),I);return this.e.$registerDefinitionSupport(j,this.o(U)),this.p(j)}$provideDefinition(I,U,H,j){return this.s(I,d,Z=>Z.provideDefinition(i.URI.revive(U),H,j),[],j)}registerDeclarationProvider(I,U,H){const j=this.t(new c(this.h,H),I);return this.e.$registerDeclarationSupport(j,this.o(U)),this.p(j)}$provideDeclaration(I,U,H,j){return this.s(I,c,Z=>Z.provideDeclaration(i.URI.revive(U),H,j),[],j)}registerImplementationProvider(I,U,H){const j=this.t(new u(this.h,H),I);return this.e.$registerImplementationSupport(j,this.o(U)),this.p(j)}$provideImplementation(I,U,H,j){return this.s(I,u,Z=>Z.provideImplementation(i.URI.revive(U),H,j),[],j)}registerTypeDefinitionProvider(I,U,H){const j=this.t(new n(this.h,H),I);return this.e.$registerTypeDefinitionSupport(j,this.o(U)),this.p(j)}$provideTypeDefinition(I,U,H,j){return this.s(I,n,Z=>Z.provideTypeDefinition(i.URI.revive(U),H,j),[],j)}registerHoverProvider(I,U,H,j){const Z=this.t(new f(this.h,H),I);return this.e.$registerHoverProvider(Z,this.o(U)),this.p(Z)}$provideHover(I,U,H,j){return this.s(I,f,Z=>Z.provideHover(i.URI.revive(U),H,j),void 0,j)}registerEvaluatableExpressionProvider(I,U,H,j){const Z=this.t(new g(this.h,H),I);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(U)),this.p(Z)}$provideEvaluatableExpression(I,U,H,j){return this.s(I,g,Z=>Z.provideEvaluatableExpression(i.URI.revive(U),H,j),void 0,j)}registerInlineValuesProvider(I,U,H,j){const Z=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new P(this.h,H),I);this.e.$registerInlineValuesProvider(de,this.o(U),Z);let Se=this.p(de);if(Z!==void 0){const ae=H.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(Z));Se=L.Disposable.from(Se,ae)}return Se}$provideInlineValues(I,U,H,j,Z){return this.s(I,P,de=>de.provideInlineValues(i.URI.revive(U),H,j,Z),void 0,Z)}registerDocumentHighlightProvider(I,U,H){const j=this.t(new M(this.h,H),I);return this.e.$registerDocumentHighlightProvider(j,this.o(U)),this.p(j)}$provideDocumentHighlights(I,U,H,j){return this.s(I,M,Z=>Z.provideDocumentHighlights(i.URI.revive(U),H,j),void 0,j)}registerLinkedEditingRangeProvider(I,U,H){const j=this.t(new q(this.h,H),I);return this.e.$registerLinkedEditingRangeProvider(j,this.o(U)),this.p(j)}$provideLinkedEditingRanges(I,U,H,j){return this.s(I,q,async Z=>{const de=await Z.provideLinkedEditingRanges(i.URI.revive(U),H,j);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?ue.w(de.wordPattern):void 0}},void 0,j)}registerReferenceProvider(I,U,H){const j=this.t(new J(this.h,H),I);return this.e.$registerReferenceSupport(j,this.o(U)),this.p(j)}$provideReferences(I,U,H,j,Z){return this.s(I,J,de=>de.provideReferences(i.URI.revive(U),H,j,Z),void 0,Z)}registerCodeActionProvider(I,U,H,j){const Z=new h.DisposableStore,de=this.t(new x(this.h,this.j.converter,this.k,H,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(de,this.o(U),{providedKinds:j?.providedCodeActionKinds?.map(Se=>Se.value),documentation:j?.documentation?.map(Se=>({kind:Se.kind.value,command:this.j.converter.toInternal(Se.command,Z)}))},ue.u(I),Boolean(H.resolveCodeAction)),Z.add(this.p(de)),Z}$provideCodeActions(I,U,H,j,Z){return this.s(I,x,de=>de.provideCodeActions(i.URI.revive(U),H,j,Z),void 0,Z)}$resolveCodeAction(I,U,H){return this.s(I,x,j=>j.resolveCodeAction(U,H),void 0,void 0)}$releaseCodeActions(I,U){this.s(I,x,H=>Promise.resolve(H.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(I,U,H){const j=this.t(new A(this.h,H),I);return this.e.$registerDocumentFormattingSupport(j,this.o(U),I.identifier,I.displayName||I.name),this.p(j)}$provideDocumentFormattingEdits(I,U,H,j){return this.s(I,A,Z=>Z.provideDocumentFormattingEdits(i.URI.revive(U),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(I,U,H){const j=this.t(new F(this.h,H),I);return this.e.$registerRangeFormattingSupport(j,this.o(U),I.identifier,I.displayName||I.name),this.p(j)}$provideDocumentRangeFormattingEdits(I,U,H,j,Z){return this.s(I,F,de=>de.provideDocumentRangeFormattingEdits(i.URI.revive(U),H,j,Z),void 0,Z)}registerOnTypeFormattingEditProvider(I,U,H,j){const Z=this.t(new $(this.h,H),I);return this.e.$registerOnTypeFormattingSupport(Z,this.o(U),j,I.identifier),this.p(Z)}$provideOnTypeFormattingEdits(I,U,H,j,Z,de){return this.s(I,$,Se=>Se.provideOnTypeFormattingEdits(i.URI.revive(U),H,j,Z,de),void 0,de)}registerWorkspaceSymbolProvider(I,U){const H=this.t(new z(U,this.l),I);return this.e.$registerNavigateTypeSupport(H,typeof U.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(I,U,H){return this.s(I,z,j=>j.provideWorkspaceSymbols(U,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,U,H){return this.s(I,z,j=>j.resolveWorkspaceSymbol(U,H),void 0,void 0)}$releaseWorkspaceSymbols(I,U){this.s(I,z,H=>H.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(I,U,H){const j=this.t(new V(this.h,H,this.l),I);return this.e.$registerRenameSupport(j,this.o(U),V.supportsResolving(H)),this.p(j)}$provideRenameEdits(I,U,H,j,Z){return this.s(I,V,de=>de.provideRenameEdits(i.URI.revive(U),H,j,Z),void 0,Z)}$resolveRenameLocation(I,U,H,j){return this.s(I,V,Z=>Z.resolveRenameLocation(i.URI.revive(U),H,j),void 0,j)}registerDocumentSemanticTokensProvider(I,U,H,j){const Z=this.t(new ie(this.h,H),I),de=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(U),j,de);let Se=this.p(Z);if(de){const ae=H.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(de));Se=L.Disposable.from(Se,ae)}return Se}$provideDocumentSemanticTokens(I,U,H,j){return this.s(I,ie,Z=>Z.provideDocumentSemanticTokens(i.URI.revive(U),H,j),null,j)}$releaseDocumentSemanticTokens(I,U){this.s(I,ie,H=>H.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,U,H,j){const Z=this.t(new ge(this.h,H),I);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(U),j),this.p(Z)}$provideDocumentRangeSemanticTokens(I,U,H,j){return this.s(I,ge,Z=>Z.provideDocumentRangeSemanticTokens(i.URI.revive(U),H,j),null,j)}registerCompletionItemProvider(I,U,H,j){const Z=this.t(new ce(this.h,this.j.converter,H,this.m,I),I);return this.e.$registerCompletionsProvider(Z,this.o(U),j,ce.supportsResolving(H),`${I.identifier.value}(${j.join("")})`),this.p(Z)}$provideCompletionItems(I,U,H,j,Z){return this.s(I,ce,de=>de.provideCompletionItems(i.URI.revive(U),H,j,Z),void 0,Z)}$resolveCompletionItem(I,U,H){return this.s(I,ce,j=>j.resolveCompletionItem(U,H),void 0,H)}$releaseCompletionItems(I,U){this.s(I,ce,H=>H.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(I,U,H){const j=new se(I,this.h,H,this.j.converter),Z=this.t(j,I);return this.e.$registerInlineCompletionsSupport(Z,this.o(U),j.supportsHandleDidShowCompletionItem),this.p(Z)}$provideInlineCompletions(I,U,H,j,Z){return this.s(I,re,de=>de.provideInlineCompletions(i.URI.revive(U),H,j,Z),void 0,Z)}$handleInlineCompletionDidShow(I,U,H){this.s(I,re,async j=>{j.handleDidShowCompletionItem(U,H)},void 0,void 0)}$freeInlineCompletionsList(I,U){this.s(I,re,async H=>{H.disposeCompletions(U)},void 0,void 0)}registerSignatureHelpProvider(I,U,H,j){const Z=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,de=this.t(new _(this.h,H),I);return this.e.$registerSignatureHelpProvider(de,this.o(U),Z),this.p(de)}$provideSignatureHelp(I,U,H,j,Z){return this.s(I,_,de=>de.provideSignatureHelp(i.URI.revive(U),H,j,Z),void 0,Z)}$releaseSignatureHelp(I,U){this.s(I,_,H=>H.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(I,U,H){const j=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new me(this.h,this.j.converter,H,this.l,I),I);this.e.$registerInlayHintsProvider(Z,this.o(U),typeof H.resolveInlayHint=="function",j,ue.u(I));let de=this.p(Z);if(j!==void 0){const Se=H.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(j));de=L.Disposable.from(de,Se)}return de}$provideInlayHints(I,U,H,j){return this.s(I,me,Z=>Z.provideInlayHints(i.URI.revive(U),H,j),void 0,j)}$resolveInlayHint(I,U,H){return this.s(I,me,j=>j.resolveInlayHint(U,H),void 0,H)}$releaseInlayHints(I,U){this.s(I,me,H=>H.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(I,U,H){const j=this.t(new we(this.h,H),I);return this.e.$registerDocumentLinkProvider(j,this.o(U),typeof H.resolveDocumentLink=="function"),this.p(j)}$provideDocumentLinks(I,U,H){return this.s(I,we,j=>j.provideLinks(i.URI.revive(U),H),void 0,H,U.scheme==="output")}$resolveDocumentLink(I,U,H){return this.s(I,we,j=>j.resolveLink(U,H),void 0,void 0,!0)}$releaseDocumentLinks(I,U){this.s(I,we,H=>H.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(I,U,H){const j=this.t(new Ne(this.h,H),I);return this.e.$registerDocumentColorProvider(j,this.o(U)),this.p(j)}$provideDocumentColors(I,U,H){return this.s(I,Ne,j=>j.provideColors(i.URI.revive(U),H),[],H)}$provideColorPresentations(I,U,H,j){return this.s(I,Ne,Z=>Z.provideColorPresentations(i.URI.revive(U),H,j),void 0,j)}registerFoldingRangeProvider(I,U,H){const j=this.q(),Z=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(j,new oe(new We(this.h,H),I)),this.e.$registerFoldingRangeProvider(j,this.o(U),I.identifier,Z);let de=this.p(j);if(Z!==void 0){const Se=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));de=L.Disposable.from(de,Se)}return de}$provideFoldingRanges(I,U,H,j){return this.s(I,We,Z=>Z.provideFoldingRanges(i.URI.revive(U),H,j),void 0,j)}registerSelectionRangeProvider(I,U,H){const j=this.t(new Qe(this.h,H,this.l),I);return this.e.$registerSelectionRangeProvider(j,this.o(U)),this.p(j)}$provideSelectionRanges(I,U,H,j){return this.s(I,Qe,Z=>Z.provideSelectionRanges(i.URI.revive(U),H,j),[],j)}registerCallHierarchyProvider(I,U,H){const j=this.t(new Te(this.h,H),I);return this.e.$registerCallHierarchyProvider(j,this.o(U)),this.p(j)}$prepareCallHierarchy(I,U,H,j){return this.s(I,Te,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(U),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(I,U,H,j){return this.s(I,Te,Z=>Z.provideCallsTo(U,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(I,U,H,j){return this.s(I,Te,Z=>Z.provideCallsFrom(U,H,j),void 0,j)}$releaseCallHierarchy(I,U){this.s(I,Te,H=>Promise.resolve(H.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(I,U,H){const j=this.t(new De(this.h,H),I);return this.e.$registerTypeHierarchyProvider(j,this.o(U)),this.p(j)}$prepareTypeHierarchy(I,U,H,j){return this.s(I,De,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(U),H,j)),void 0,j)}$provideTypeHierarchySupertypes(I,U,H,j){return this.s(I,De,Z=>Z.provideSupertypes(U,H,j),void 0,j)}$provideTypeHierarchySubtypes(I,U,H,j){return this.s(I,De,Z=>Z.provideSubtypes(U,H,j),void 0,j)}$releaseTypeHierarchy(I,U){this.s(I,De,H=>Promise.resolve(H.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(I,U,H){const j=this.q();return this.f.set(j,new oe(new ke(this.e,this.h,H,j),I)),this.e.$registerDocumentOnDropEditProvider(j,this.o(U)),this.p(j)}$provideDocumentOnDropEdits(I,U,H,j,Z,de){return this.s(I,ke,Se=>Promise.resolve(Se.provideDocumentOnDropEdits(U,i.URI.revive(H),j,Z,de)),void 0,void 0)}registerDocumentPasteEditProvider(I,U,H,j){const Z=this.q();return this.f.set(Z,new oe(new R(this.e,this.h,H,Z),I)),this.e.$registerPasteEditProvider(Z,this.o(U),!!H.prepareDocumentPaste,j.pasteMimeTypes),this.p(Z)}$prepareDocumentPaste(I,U,H,j,Z){return this.s(I,R,de=>de.prepareDocumentPaste(i.URI.revive(U),H,j,Z),void 0,Z)}$providePasteEdits(I,U,H,j,Z,de){return this.s(I,R,Se=>Se.providePasteEdits(U,i.URI.revive(H),j,Z,de),void 0,de)}static w(I){return{pattern:I.source,flags:(0,S.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ue.w(I.decreaseIndentPattern),increaseIndentPattern:ue.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ue.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ue.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ue.w(I.beforeText),afterText:I.afterText?ue.w(I.afterText):void 0,previousLineText:I.previousLineText?ue.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ue.z)}setLanguageConfiguration(I,U,H){const{wordPattern:j}=H;if(j&&(0,S.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this.h.setWordDefinitionFor(U,j):this.h.setWordDefinitionFor(U,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const Z=this.q(),de={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ue.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ue.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ue.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(Z,U,de),this.p(Z)}$setWordDefinitions(I){for(const U of I)this.h.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.ExtHostLanguageFeatures=ue,ue.d=0}),define(Ie[211],Ce([1,0,4,8,6,29,14,7]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(N,D,m,v){this.c=D,this.d=m,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=N.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this.b=N}async getLanguages(){return this.b.slice(0)}async changeLanguage(N,D){await this.a.$changeLanguage(N,D);const m=this.c.getDocumentData(N);if(!m)throw new Error(`document '${N.toString()}' NOT found`);return m.document}async tokenAtPosition(N,D){const m=N.version,v=T.Position.from(D),h=await this.a.$tokensAtPosition(N.uri,v),t={type:y.StandardTokenType.Other,range:N.getWordRangeAtPosition(D)??new y.Range(D.line,D.character,D.line,D.character)};if(!h)return t;const o={range:T.Range.to(h.range),type:T.TokenType.to(h.type)};return!o.range.contains(D)||m!==N.version?t:o}createLanguageStatusItem(N,D,m){const v=this.f++,h=this.a,t=this.g,o=`${N.identifier.value}/${D}`;if(t.has(o))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);t.add(o);const l={selector:m,id:D,name:N.displayName??N.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const E=new O.DisposableStore,p=()=>{b?.dispose(),b=(0,C.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(v,{id:o,name:l.name??N.displayName??N.name,source:N.displayName??N.name,selector:T.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===y.LanguageStatusSeverity.Error?L.default.Error:l.severity===y.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:l.command&&this.d.toInternal(l.command,E),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},w={dispose(){E.dispose(),b?.dispose(),h.$removeLanguageStatus(v),t.delete(o)},get id(){return l.id},get name(){return l.name},set name(s){l.name=s,p()},get selector(){return l.selector},set selector(s){l.selector=s,p()},get text(){return l.text},set text(s){l.text=s,p()},get detail(){return l.detail},set detail(s){l.detail=s,p()},get severity(){return l.severity},set severity(s){l.severity=s,p()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(s){l.accessibilityInformation=s,p()},get command(){return l.command},set command(s){l.command=s,p()},get busy(){return l.busy},set busy(s){l.busy=s,p()}};return p(),w}}e.ExtHostLanguages=S}),define(Ie[73],Ce([1,0,21,10,2,3,12,4,27,15]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(m,v,h){this.f=h,this.d=new Map,this.a=v.getProxy(O.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(m,v){const{message:h,args:t,comment:o}=v;if(this.c)return(0,T.format2)(h,t??{});let l=h;o&&o.length>0&&(l+=`/${Array.isArray(o)?o.join():o}`);const b=this.d.get(m)?.contents[l];return b||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,T.format2)(b??h,t??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let v;const h=await this.g(m);if(!h){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const t=await this.a.$fetchBundleContents(h),o=JSON.parse(t);v=m.isBuiltin?o.contents?.bundle:o}catch(t){this.f.error(`Failed to load translations for ${m.identifier.value} from ${h}: ${t.message}`);return}v&&this.d.set(m.identifier.value,{contents:v,uri:h})}async g(m){if(m.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(m.identifier.value);return y.URI.revive(v)}return m.l10n?y.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};N=qe([Ve(0,S.IExtHostInitDataService),Ve(1,k.IExtHostRpcService),Ve(2,C.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Ie[212],Ce([1,0,12,4,27,15,2,5,9]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends i.AbstractLoggerService{constructor(m,v){super(v.logLevel,O.Event.None),this.g=m.getProxy(T.MainContext.MainThreadLogger)}$setLevel(m,v){v?this.setLevel(C.URI.revive(v),m):(0,S.isUndefined)(m)||this.setLevel(m)}f(m,v,h){return new N(this.g,m,v,h)}};k=qe([Ve(0,L.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class N extends i.AbstractMessageLogger{constructor(m,v,h,t){super(t?.always),this.m=m,this.n=v,this.k=!1,this.l=[],this.setLevel(h),this.m.$createLogger(v,t).then(()=>{this.r(this.l),this.k=!0})}g(m,v){const h=[[m,v]];this.k?this.r(h):this.l.push(...h)}r(m){this.m.$log(this.n,m)}}}),define(Ie[213],Ce([1,0,4,12,25]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(O){return O&&O.title}let C=class{constructor(S,k){this.b=k,this.a=S.getProxy(i.MainContext.MainThreadMessageService)}showMessage(S,k,N,D,m){const v={source:{identifier:S.identifier,label:S.displayName||S.name}};let h;typeof D=="string"||L(D)?h=[D,...m]:(v.modal=D?.modal,v.useCustom=D?.useCustom,v.detail=D?.detail,h=m),v.useCustom&&(0,y.checkProposedApiEnabled)(S,"resolvers");const t=[];for(let o=0;o<h.length;o++){const l=h[o];if(typeof l=="string")t.push({title:l,handle:o,isCloseAffordance:!1});else if(typeof l=="object"){const{title:b,isCloseAffordance:E}=l;t.push({title:b,isCloseAffordance:!!E,handle:o})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(k,N,v,t).then(o=>{if(typeof o=="number")return h[o]})}};C=qe([Ve(1,T.ILogService)],C),e.ExtHostMessageService=C}),define(Ie[214],Ce([1,0,24,5,7,28,10,9,2,51,4,38,8,6,43,187,96]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,p,w,s){this.q=w,this.r=s,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new T.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new T.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new T.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(N.MainContext.MainThreadNotebook),this.c=E.getProxy(N.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(N.MainContext.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const a=r.notebookEditor?.notebookUri,d=r.cell.handle,u=this.g.get(a)?.getCell(d);if(u)return u.apiCell}if(r&&r.$mid===14){const a=r.uri,d=this.g.get(a);if(d)return d.apiNotebook}return r}}),l.x(p)}getEditorById(E){const p=this.h.get(E);if(!p)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(E){for(const[p,w]of this.h)if(w.apiEditor===E)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,p){const w=this.g.get(E);if(!w&&!p)throw new Error(`NO notebook document for '${E}'`);return w}static s(E,p){if(!p)return;const w=p.filenamePattern.map(s=>m.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(p.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:p.displayName,filenamePattern:w,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,p,w){const s=l.a++,r=typeof w.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(s,w),this.b.$registerNotebookCellStatusBarItemProvider(s,r,p);let a;return r!==void 0&&(a=w.onDidChangeCellStatusBarItems(d=>this.b.$emitCellStatusBarEvent(r))),new v.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,r),a?.dispose()})}async createNotebookDocument(E){const p=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&m.NotebookData.from(E.content)});return S.URI.revive(p)}async openNotebookDocument(E){const p=this.g.get(E);if(p)return p.apiNotebook;const w=await this.c.$tryOpenNotebook(E),s=this.g.get(S.URI.revive(w));return(0,O.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(E,p){S.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let w;typeof p=="object"?w={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(m.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:w={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,w),r=s&&this.h.get(s)?.apiEditor;if(r)return r;throw s?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,p,w,s){const r=this.f.get(E),a=S.URI.revive(p),d=this.g.get(a);if(!d||!r)return;const c=d.getCellFromIndex(w);if(!c)return;const u=await r.provideCellStatusBarItems(c.apiCell,s);if(!u)return;const n=new y.DisposableStore,f=this.p.add([n]),P=(Array.isArray(u)?u:[u]).map(M=>m.NotebookStatusBarItem.from(M,this.i,n));return{cacheId:f,items:P}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,p,w,s,r){if((0,C.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,w),this.b.$registerNotebookSerializer(a,{id:E.identifier,location:E.extensionLocation},p,m.NotebookDocumentContentOptions.from(s),l.s(E,r)),(0,y.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(E,p,w){const s=this.u.get(E);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(p.buffer,w);return new h.SerializableObjectWithBuffers(m.NotebookData.from(r))}async $notebookToData(E,p,w){const s=this.u.get(E);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(m.NotebookData.to(p.value),w);return i.VSBuffer.wrap(r)}w(E,p,w){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const s=new o.ExtHostNotebookEditor(p,this.d,E,w.visibleRanges.map(m.NotebookRange.to),w.selections.map(m.NotebookRange.to),typeof w.viewColumn=="number"?m.ViewColumn.to(w.viewColumn):void 0);this.h.set(p,s)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const w of E.value.removedDocuments){const s=S.URI.revive(w),r=this.g.get(s);r&&(r.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(r.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===s.toString()&&this.h.delete(a.id)}if(E.value.addedDocuments){const w=[];for(const s of E.value.addedDocuments){const r=S.URI.revive(s.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const a=new t.ExtHostNotebookDocument(this.c,this.q,this.r,r,s);w.push(...s.cells.map(d=>t.ExtHostCell.asModelAddData(a.apiNotebook,d))),this.g.get(r)?.dispose(),this.g.set(r,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(a.apiNotebook)}}if(E.value.addedEditors)for(const w of E.value.addedEditors){if(this.h.has(w.id))return;const s=S.URI.revive(w.documentUri),r=this.g.get(s);r&&this.w(r,w.id,w)}const p=[];if(E.value.removedEditors)for(const w of E.value.removedEditors){const s=this.h.get(w);s&&(this.h.delete(w),this.k?.id===s.id&&(this.k=void 0),p.push(s))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const w=new Set;this.l.forEach(s=>w.add(s.id));for(const s of this.h.values()){const r=w.has(s.id);s._acceptVisibility(r)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const p=D.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new D.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>i.VSBuffer.wrap(r))],new D.ApiCommandResult("Notebook Data",r=>m.NotebookData.to(r.value))),s=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new h.SerializableObjectWithBuffers(m.NotebookData.from(r)))],new D.ApiCommandResult("Bytes",r=>r.buffer));E.registerApiCommand(w),E.registerApiCommand(s)}}e.ExtHostNotebookController=l,l.a=0}),define(Ie[215],Ce([1,0,16,14,20,5,7,28,2,26,12,51,4,38,8,6,68,174,25,43]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let p=class{constructor(c,u,n,f,g){this.k=u,this.l=n,this.m=f,this.n=g,this.b=new O.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new D.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(m.MainContext.MainThreadNotebookKernels);const P=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const q=this.l.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:q}}else if(M&&"notebookEditor"in M){const q=this.l.getIdByEditor(M.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return M})],v.ApiCommandResult.Void);this.m.registerApiCommand(P)}createNotebookController(c,u,n,f,g,P){for(const re of this.h.values())if(re.controller.id===u&&k.ExtensionIdentifier.equals(c.identifier,re.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const M=this.i++,q=this;this.n.trace(`NotebookController[${M}], CREATED by ${c.identifier.value}, ${u}`);const J=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${c.identifier}'`);let x=!1;const R=new C.DisposableStore,A=new L.Emitter,F=new L.Emitter,$={id:a(c.identifier,u),notebookType:n,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:f||c.identifier.value,preloads:P?P.map(h.NotebookRendererScript.from):[]};let z=g??J,V;this.a.$addKernel(M,$).catch(re=>{console.log(re),x=!0});let K=0;const ie=()=>{if(x)return;const re=++K;Promise.resolve().then(()=>{re===K&&this.a.$updateKernel(M,$)})},ge=new O.ResourceMap,ce={get id(){return u},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return $.label},set label(re){$.label=re??c.displayName??c.name,ie()},get detail(){return $.detail??""},set detail(re){$.detail=re,ie()},get description(){return $.description??""},set description(re){$.description=re,ie()},get kind(){return(0,b.checkProposedApiEnabled)(c,"notebookControllerKind"),$.kind??""},set kind(re){(0,b.checkProposedApiEnabled)(c,"notebookControllerKind"),$.kind=re,ie()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(re){$.supportedLanguages=re,ie()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(re){$.supportsExecutionOrder=re,ie()},get rendererScripts(){return $.preloads?$.preloads.map(h.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(re){z=re??J},get interruptHandler(){return V},set interruptHandler(re){V=re,$.supportsInterrupt=Boolean(re),ie()},createNotebookCellExecution(re){if(x)throw new Error("notebook controller is DISPOSED");if(!ge.has(re.notebook.uri))throw q.n.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ge.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return q._createNotebookCellExecution(re,a(c.identifier,this.id))},dispose:()=>{x||(this.n.trace(`NotebookController[${M}], DISPOSED`),x=!0,this.h.delete(M),R.dispose(),A.dispose(),F.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(re,se){se===t.NotebookControllerAffinity2.Hidden&&(0,b.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(M,re.uri,se)},onDidReceiveMessage:F.event,postMessage(re,se){return(0,b.checkProposedApiEnabled)(c,"notebookMessaging"),q.a.$postMessage(M,se&&q.l.getIdByEditor(se),re)},asWebviewUri(re){return(0,b.checkProposedApiEnabled)(c,"notebookMessaging"),(0,o.asWebviewUri)(re,q.k.remote)}};return this.h.set(M,{extensionId:c.identifier,controller:ce,onDidReceiveMessage:F,onDidChangeSelection:A,associatedNotebooks:ge}),ce}getIdByController(c){for(const[u,n]of this.h)if(n.controller===c)return a(n.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,u){const n=this.d++,f=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(n,u);const g={dispose:()=>{this.c.delete(n),f.a.$removeKernelDetectionTask(n)}};return this.c.set(n,g),g}registerKernelSourceActionProvider(c,u,n){const f=this.f++,g=this;return this.e.set(f,n),this.n.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(f,u),{dispose:()=>{this.e.delete(f),g.a.$removeKernelSourceActionProvider(f)}}}async $provideKernelSourceActions(c,u){const n=this.e.get(c);if(n){const f=new C.DisposableStore;return this.g.add([f]),(await n.provideNotebookKernelSourceActions(u)??[]).map(P=>h.NotebookKernelSourceAction.from(P,this.m.converter,f))}return[]}$acceptNotebookAssociation(c,u,n){const f=this.h.get(c);if(f){const g=this.l.getNotebookDocument(S.URI.revive(u));n?f.associatedNotebooks.set(g.uri,!0):f.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,g.uri.toString(),n),f.onDidChangeSelection.fire({selected:n,notebook:g.apiNotebook})}}async $executeCells(c,u,n){const f=this.h.get(c);if(!f)return;const g=this.l.getNotebookDocument(S.URI.revive(u)),P=[];for(const M of n){const q=g.getCell(M);q&&P.push(q.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,g.uri.toString(),P.length),await f.controller.executeHandler.call(f.controller,P,g.apiNotebook,f.controller)}catch(M){this.n.error(`NotebookController[${c}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(c,u,n){const f=this.h.get(c);if(!f)return;const g=this.l.getNotebookDocument(S.URI.revive(u));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,g.apiNotebook);else for(const P of n){const M=g.getCell(P);M&&this.b.get(M.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,u,n){const f=this.h.get(c);if(!f)return;const g=this.l.getEditorById(u);f.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:n}))}$cellExecutionChanged(c,u,n){const g=this.l.getNotebookDocument(S.URI.revive(c)).getCell(u);if(g){const P=n?h.NotebookCellExecutionState.to(n):t.NotebookCellExecutionState.Idle;P!==void 0&&this.j.fire({cell:g.apiCell,state:P})}}_createNotebookCellExecution(c,u){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const g=new s(u,f,this.a);this.b.set(f.uri,g);const P=g.onDidChangeState(()=>{g.state===w.Resolved&&(g.dispose(),P.dispose(),this.b.delete(f.uri))});return g.asApiObject()}};p=qe([Ve(4,N.ILogService)],p),e.ExtHostNotebookKernels=p;var w;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(w||(w={}));class s extends C.Disposable{get state(){return this.f}constructor(c,u,n){super(),this.j=u,this.k=n,this.b=s.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new y.CancellationTokenSource),this.h=new r(10,f=>this.m(f)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const u=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(u))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let u=this.j;if(c&&(u=this.j.notebook.getCellFromApiCell(c)),!u)throw new Error("INVALID cell");return u.handle}s(c){return c.map(u=>{const n=t.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return n===u.items?h.NotebookCellOutput.from(u):h.NotebookCellOutput.from({items:n,id:u.id,metadata:u.metadata})})}async t(c,u,n){const f=this.r(u),g=this.s((0,i.asArray)(c));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:f,append:n,outputs:g})}async w(c,u,n){return c=t.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(c),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:c.map(h.NotebookCellOutputItem.from),outputId:u.id,append:n})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(n){c.i=n,c.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(n){if(c.f===w.Resolved||c.f===w.Started)throw new Error("Cannot call start again");c.f=w.Started,c.c.fire(),c.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,f){if(c.f===w.Resolved)throw new Error("Cannot call resolve twice");c.f=w.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new E.SerializableObjectWithBuffers({runEndTime:f,lastRunSuccess:n}))},clearOutput(n){return c.n(),c.t([],n,!1)},appendOutput(n,f){return c.n(),c.t(n,f,!0)},replaceOutput(n,f){return c.n(),c.t(n,f,!1)},appendOutputItems(n,f){return c.n(),c.w(n,f,!0)},replaceOutputItems(n,f){return c.n(),c.w(n,f,!1)}})}}s.a=0;class r{constructor(c,u){this.d=c,this.e=u,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new T.DeferredPromise,this.b=Date.now(),(0,T.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const u=this.a;return this.a=[],this.e(u).finally(()=>c.complete())}}function a(d,c){return`${d.value}/${c}`}e.createKernelId=a}),define(Ie[216],Ce([1,0,5,4,96]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(O,S){this.c=S,this.a=new Map,this.b=O.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(O,S,k){const N=this.c.getEditorById(O);this.a.get(S)?.fire({editor:N.apiEditor,message:k})}createRendererMessaging(O,S){if(!O.contributes?.notebookRenderer?.some(N=>N.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(N,D,m)=>this.d(S).event(N,D,m),postMessage:(N,D)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,D]=[D,N]);const m=D&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.b.$postMessage(m?.id,S,N)}}}d(O){let S=this.a.get(O);return S||(S=new i.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(O)}}),this.a.set(O,S),S)}}e.ExtHostNotebookRenderers=L}),define(Ie[217],Ce([1,0,7,2,25,4]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class C{constructor(S){this.b=new Map,this.a=S.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,k,N){if((0,y.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.b.set(k,N),this.a.$registerProfileContentHandler(k,N.name,S.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(k),this.a.$unregisterProfileContentHandler(k)})}async $saveProfile(S,k,N,D){const m=this.b.get(S);if(!m)throw new Error(`Unknown handler with id: ${S}`);return m.saveProfile(k,N,D)}async $readProfile(S,k,N){const D=this.b.get(S);if(!D)throw new Error(`Unknown handler with id: ${S}`);return D.readProfile(T.URI.revive(k),N)}}e.ExtHostProfileContentHandlers=C}),define(Ie[218],Ce([1,0,20,5,7,4,2,6,11,16,29,64]),function(ee,e,i,T,y,L,C,O,S,k,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(v,h,t){const o=v.getProxy(L.MainContext.MainThreadQuickOpen);class l{constructor(c,u){this.e=new Map,this.f=0,this.a=c,this.b=u}showQuickPick(c,u,n=i.CancellationToken.None){this.c=void 0;const f=Promise.resolve(c),g=++this.f,P=o.$show(g,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},n),M={},q=P.then(()=>M);return Promise.race([q,f]).then(J=>{if(J!==M)return f.then(x=>{const R=[];for(let A=0;A<x.length;A++){const F=x[A];typeof F=="string"?R.push({label:F,handle:A}):F.kind===O.QuickPickItemKind.Separator?R.push({type:"separator",label:F.label}):R.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:A})}return u&&typeof u.onDidSelectItem=="function"&&(this.c=A=>{u.onDidSelectItem(x[A])}),o.$setItems(g,R),P.then(A=>{if(typeof A=="number")return x[A];if(Array.isArray(A))return A.map(F=>x[F])})})}).then(void 0,J=>{if(!(0,S.isCancellationError)(J))return o.$setError(g,J),Promise.reject(J)})}$onItemSelected(c){this.c?.(c)}showInput(c,u=i.CancellationToken.None){return this.d=c?.validateInput,o.$input(c,typeof this.d=="function",u).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(c){if(!this.d)return;const u=await this.d(c);if(!u||typeof u=="string")return u;let n;switch(u.severity){case O.InputBoxValidationSeverity.Info:n=N.default.Info;break;case O.InputBoxValidationSeverity.Warning:n=N.default.Warning;break;case O.InputBoxValidationSeverity.Error:n=N.default.Error;break;default:n=u.message?N.default.Error:N.default.Ignore;break}return{content:u.message,severity:n}}async showWorkspaceFolderPick(c,u=i.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!n)return;const f=await this.a.getWorkspaceFolders2();if(!!f)return f.find(g=>g.uri.toString()===n.uri.toString())}createQuickPick(c){const u=new r(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(c){const u=new a(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(c,u){this.e.get(c)?._fireDidChangeValue(u)}$onDidAccept(c){this.e.get(c)?._fireDidAccept()}$onDidChangeActive(c,u){const n=this.e.get(c);n instanceof r&&n._fireDidChangeActive(u)}$onDidChangeSelection(c,u){const n=this.e.get(c);n instanceof r&&n._fireDidChangeSelection(u)}$onDidTriggerButton(c,u){this.e.get(c)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(c,u,n){const f=this.e.get(c);f instanceof r&&f._fireDidTriggerItemButton(u,n)}$onDidHide(c){this.e.get(c)?._fireDidHide()}}class b{constructor(c,u){this.x=c,this.y=u,this._id=r.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.Emitter,this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(c){this.b=c,this.z({title:c})}get step(){return this.c}set step(c){this.c=c,this.z({step:c})}get totalSteps(){return this.d}set totalSteps(c){this.d=c,this.z({totalSteps:c})}get enabled(){return this.g}set enabled(c){this.g=c,this.z({enabled:c})}get busy(){return this.j}set busy(c){this.j=c,this.z({busy:c})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(c){this.k=c,this.z({ignoreFocusOut:c})}get value(){return this.l}set value(c){this.l=c,this.z({value:c})}get placeholder(){return this.m}set placeholder(c){this.m=c,this.z({placeholder:c})}get buttons(){return this.n}set buttons(c){this.n=c.slice(),this.o.clear(),c.forEach((u,n)=>{const f=u===O.QuickInputButtons.Back?-1:n;this.o.set(f,u)}),this.z({buttons:c.map((u,n)=>({...s(u),tooltip:u.tooltip,handle:u===O.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(c){this.l=c,this.q.fire(c)}_fireDidTriggerButton(c){const u=this.o.get(c);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,y.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),o.$dispose(this._id))}z(c){if(!this.v){for(const u of Object.keys(c)){const n=c[u];this.u[u]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){o.$createOrUpdate(this.u),this.u={id:this._id}}}b.a=1;function E(d){if(d instanceof O.ThemeIcon)return{id:d.id};const c=w(d),u=p(d);return{dark:typeof c=="string"?C.URI.file(c):c,light:typeof u=="string"?C.URI.file(u):u}}function p(d){return typeof d=="object"&&"light"in d?d.light:d}function w(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const c=E(d.iconPath);let u,n;return"id"in c?n=D.ThemeIcon.asClassName(c):u=c,{iconPath:u,iconClass:n}}class r extends b{constructor(c,u){super(c.identifier,u),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.Emitter,this.L=[],this.M=new T.Emitter,this.N=new T.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(c){this.B=c.slice(),this.C.clear(),this.D.clear(),c.forEach((n,f)=>{this.C.set(f,n),this.D.set(n,f)});const u=[];for(let n=0;n<c.length;n++){const f=c[n];f.kind===O.QuickPickItemKind.Separator?u.push({type:"separator",label:f.label}):u.push({handle:n,label:f.label,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,buttons:f.buttons?.map((g,P)=>({...s(g),tooltip:g.tooltip,handle:P}))})}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(c){this.E=c,this.z({canSelectMany:c})}get matchOnDescription(){return this.F}set matchOnDescription(c){this.F=c,this.z({matchOnDescription:c})}get matchOnDetail(){return this.G}set matchOnDetail(c){this.G=c,this.z({matchOnDetail:c})}get sortByLabel(){return this.H}set sortByLabel(c){this.H=c,this.z({sortByLabel:c})}get keepScrollPosition(){return this.I}set keepScrollPosition(c){this.I=c,this.z({keepScrollPosition:c})}get activeItems(){return this.J}set activeItems(c){this.J=c.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(c){this.L=c.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(c){const u=(0,k.coalesce)(c.map(n=>this.C.get(n)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(c){const u=(0,k.coalesce)(c.map(n=>this.C.get(n)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(c,u){const n=this.C.get(c);if(!n||!n.buttons||!n.buttons.length)return;const f=n.buttons[u];f&&this.N.fire({button:f,item:n})}}class a extends b{constructor(c,u){super(c.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(c){this.B=c,this.z({password:c})}get prompt(){return this.C}set prompt(c){this.C=c,this.z({prompt:c})}get valueSelection(){return this.D}set valueSelection(c){this.D=c,this.z({valueSelection:c})}get validationMessage(){return this.E}set validationMessage(c){this.E=c,c?typeof c=="string"?this.z({validationMessage:c,severity:N.default.Error}):this.z({validationMessage:c.message,severity:c.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new l(h,t)}e.createExtHostQuickOpen=m});var Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)},Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i};define(Ie[219],Ce([1,0,2,5,60,7,14,4,16,121,12,26,64,8,25]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h){"use strict";var t,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(f){if(f)return typeof f.iconPath=="string"?i.URI.file(f.iconPath):i.URI.isUri(f.iconPath)||m.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function b(f,g){if(!f.iconPath&&!g.iconPath)return 0;if(f.iconPath){if(!g.iconPath)return 1}else return-1;const P=typeof f.iconPath=="string"?f.iconPath:i.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,M=typeof g.iconPath=="string"?g.iconPath:i.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,k.comparePaths)(P,M)}function E(f,g){let P=0;if(f.strikeThrough!==g.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==g.faded)return f.faded?1:-1;if(f.tooltip!==g.tooltip)return(f.tooltip||"").localeCompare(g.tooltip||"");if(P=b(f,g),P!==0)return P;if(f.light&&g.light)P=b(f.light,g.light);else{if(f.light)return 1;if(g.light)return-1}if(P!==0)return P;if(f.dark&&g.dark)P=b(f.dark,g.dark);else{if(f.dark)return 1;if(g.dark)return-1}return P}function p(f,g){if(f.command!==g.command)return f.command<g.command?-1:1;if(f.title!==g.title)return f.title<g.title?-1:1;if(f.tooltip!==g.tooltip){if(f.tooltip!==void 0&&g.tooltip!==void 0)return f.tooltip<g.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(f.arguments===g.arguments)return 0;if(f.arguments)if(g.arguments){if(f.arguments.length!==g.arguments.length)return f.arguments.length-g.arguments.length}else return 1;else return-1;for(let P=0;P<f.arguments.length;P++){const M=f.arguments[P],q=g.arguments[P];if(M!==q)return M<q?-1:1}return 0}function w(f,g){let P=(0,k.comparePaths)(f.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(P!==0)return P;if(f.command&&g.command)P=p(f.command,g.command);else{if(f.command)return 1;if(g.command)return-1}if(P!==0)return P;if(f.decorations&&g.decorations)P=E(f.decorations,g.decorations);else{if(f.decorations)return 1;if(g.decorations)return-1}return P}function s(f,g){for(let P=0;P<f.length;P++)if(f[P]!==g[P])return!1;return!0}function r(f,g){return f.command===g.command&&f.title===g.title&&f.tooltip===g.tooltip&&(f.arguments&&g.arguments?s(f.arguments,g.arguments):f.arguments===g.arguments)}function a(f,g){return(0,S.equals)(f,g,r)}class d{get value(){return this.d}set value(g){g=g??"",Re(this,t,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Re(this,t,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,h.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,h.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Re(this,t,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Re(this,t,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Re(this,t,"f").$setInputBoxVisibility(this.l,g))}constructor(g,P,M){this.k=g,this.l=M,t.set(this,void 0),this.d="",this.e=new T.Emitter,this.f="",this.h=!0,this.j=!0,Ye(this,t,P,"f")}showValidationMessage(g,P){(0,h.checkProposedApiEnabled)(this.k,"scmValidation"),Re(this,t,"f").$showValidationMessage(this.l,g,P)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=d,t=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,P,M,q,J){this.q=g,this.s=P,this.t=M,this.u=q,this.v=J,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,P){const M=this.h.get(g);return M?(0,C.asPromise)(()=>this.s.executeCommand(M.command,...M.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(w),M=(0,S.sortedDiff)(this.o,g,w).map(x=>{const R=x.toInsert.map(A=>{const F=this.e++;this.g.set(F,A);const $=A.resourceUri;let z;if(A.command)if(A.command.command==="vscode.open"||A.command.command==="vscode.diff"){const me=new L.DisposableStore;z=this.s.converter.toInternal(A.command,me),this.j.set(F,me)}else this.h.set(F,A.command);const V=l(A.decorations),K=A.decorations&&l(A.decorations.light)||V,ie=A.decorations&&l(A.decorations.dark)||V,ge=[K,ie],ce=A.decorations&&A.decorations.tooltip||"",re=A.decorations&&!!A.decorations.strikeThrough,se=A.decorations&&!!A.decorations.faded,le=A.contextValue||"";return{rawResource:[F,$,ge,ce,re,se,le,z],handle:F}});return{start:x.start,deleteCount:x.deleteCount,toInsert:R}}),q=M.map(({start:x,deleteCount:R,toInsert:A})=>[x,R,A.map(F=>F.rawResource)]),J=M.reverse();for(const{start:x,deleteCount:R,toInsert:A}of J){const F=A.map(z=>z.handle),$=this.n.splice(x,R,...F);for(const z of $)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=g,q}dispose(){this.l=!0,this.m.fire()}}c.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Re(this,o,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Re(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Re(this,o,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new L.DisposableStore,this.l=g;const P=this.v.converter.toInternal(g,this.k.value);Re(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:P})}get actionButton(){return(0,h.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,h.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=g;const P=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(M=>M.map(q=>this.v.converter.toInternal(q,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Re(this,o,"f").$updateSourceControl(this.t,{actionButton:P??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&a(this.p,g))return;this.o.value=new L.DisposableStore,this.p=g;const P=(g||[]).map(M=>this.v.converter.toInternal(M,this.o.value));Re(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:P})}get selected(){return this.q}constructor(g,P,M,q,J,x){this.u=g,this.v=M,this.w=q,this.x=J,this.y=x,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new T.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,Ye(this,o,P,"f"),this.f=new d(g,Re(this,o,"f"),this.t),Re(this,o,"f").$registerSourceControl(this.t,q,J,x)}createResourceGroup(g,P){const M=new c(Re(this,o,"f"),this.v,this.t,g,P),q=T.Event.once(M.onDidDispose)(()=>this.z.delete(M));return this.z.set(M,q),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const g=[],P=[];for(const[M,q]of this.z){q.dispose();const J=M.onDidUpdateResourceStates(()=>{this.A.add(M),this.eventuallyUpdateResourceStates()});T.Event.once(M.onDidDispose)(()=>{this.A.delete(M),J.dispose(),this.e.delete(M.handle),Re(this,o,"f").$unregisterGroup(this.t,M.handle)}),g.push([M.handle,M.id,M.label,M.features]);const x=M._takeResourceStateSnapshot();x.length>0&&P.push([M.handle,x]),this.e.set(M.handle,M)}Re(this,o,"f").$registerGroups(this.t,g,P),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(P=>{const M=P._takeResourceStateSnapshot();M.length!==0&&g.push([P.handle,M])}),g.length>0&&Re(this,o,"f").$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Re(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,u.d=0,qe([(0,y.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),qe([(0,y.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let n=class tn{get onDidChangeActiveProvider(){return this.j.event}constructor(g,P,M){this.l=P,this.m=M,this.g=new Map,this.h=new Map,this.j=new T.Emitter,this.e=g.getProxy(O.MainContext.MainThreadSCM),this.f=g.getProxy(O.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const J=this.g.get(q.sourceControlHandle);if(!J)return q;const x=J.getResourceGroup(q.groupHandle);return x?x.getResourceState(q.handle):q}else if(q&&q.$mid===4){const J=this.g.get(q.sourceControlHandle);return J?J.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const J=this.g.get(q.handle);return J||q}return q}})}createSourceControl(g,P,M,q){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,P,M,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const J=tn.d++,x=new u(g,this.e,this.l,P,M,q);this.g.set(J,x);const R=this.h.get(D.ExtensionIdentifier.toKey(g.identifier))||[];return R.push(x),this.h.set(D.ExtensionIdentifier.toKey(g.identifier),R),x}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const P=this.h.get(D.ExtensionIdentifier.toKey(g.identifier)),M=P&&P[P.length-1];return M&&M.inputBox}$provideOriginalResource(g,P,M){const q=i.URI.revive(P);this.m.trace("ExtHostSCM#$provideOriginalResource",g,q.toString());const J=this.g.get(g);return!J||!J.quickDiffProvider||!J.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>J.quickDiffProvider.provideOriginalResource(q,M)).then(x=>x||null)}$onInputBoxValueChange(g,P){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const M=this.g.get(g);return M&&M.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(g,P,M,q){this.m.trace("ExtHostSCM#$executeResourceCommand",g,P,M);const J=this.g.get(g);if(!J)return Promise.resolve(void 0);const x=J.getResourceGroup(P);return x?x.$executeResourceCommand(M,q):Promise.resolve(void 0)}$validateInput(g,P,M){this.m.trace("ExtHostSCM#$validateInput",g);const q=this.g.get(g);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>q.inputBox.validateInput(P,M)).then(J=>{if(!J)return Promise.resolve(void 0);const x=v.MarkdownString.fromStrict(J.message);return x?Promise.resolve([x,J.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};n.d=0,n=qe([Ve(2,N.ILogService)],n),e.ExtHostSCM=n}),define(Ie[74],Ce([1,0,4,5,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(O){this.b=new T.Emitter,this.onDidChangePassword=this.b.event,this.a=O.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,S){return this.a.$getPassword(O,S)}store(O,S,k){return this.a.$setPassword(O,S,k)}delete(O,S){return this.a.$deletePassword(O,S)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[220],Ce([1,0,6,4,136,7,8,9]),function(ee,e,i,T,y,L,C,O){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(h,t,o,l,b=i.StatusBarAlignment.Left,E){S.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new L.DisposableStore,Ye(this,S,h,"f"),Ye(this,k,t,"f"),this.c=N.a++,this.e=o,this.f=l,this.g=b,this.h=this.t(E)}t(h){if(!!(0,O.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(h){this.k=h,this.u()}set name(h){this.m=h,this.u()}set tooltip(h){this.l=h,this.u()}set color(h){this.n=h,this.u()}set backgroundColor(h){h&&!N.b.has(h.id)&&(h=void 0),this.o=h,this.u()}set command(h){this.q?.fromApi!==h&&(this.p.clear(),typeof h=="string"?this.q={fromApi:h,internal:Re(this,k,"f").toInternal({title:"",command:h},this.p)}:h?this.q={fromApi:h,internal:Re(this,k,"f").toInternal(h,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(h){this.s=h,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Re(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let h;this.e?this.f?h=`${this.e.identifier.value}.${this.f}`:h=this.e.identifier.value:h=this.f;let t;this.m?t=this.m:t=(0,y.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=N.b.get(this.o.id));const l=C.MarkdownString.fromStrict(this.l);Re(this,S,"f").$setEntry(this.c,h,t,this.k,l,this.q?.internal,o,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=N,S=new WeakMap,k=new WeakMap,N.a=0,N.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(h){this.b=[],this.a=h.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,y.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(h){const t={message:h};return this.b.unshift(t),this.c(),new i.Disposable(()=>{const o=this.b.indexOf(t);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(h,t){this.a=h.getProxy(T.MainContext.MainThreadStatusBar),this.b=t,this.c=new D(this)}createStatusBarEntry(h,t,o,l){return new N(this.a,this.b,h,t,o,l)}setStatusBarMessage(h,t){const o=this.c.setMessage(h);let l;return typeof t=="number"?l=setTimeout(()=>o.dispose(),t):typeof t<"u"&&t.then(()=>o.dispose(),()=>o.dispose()),new i.Disposable(()=>{o.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=m}),define(Ie[75],Ce([1,0,4,5,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(O,S){this.c=S,this.b=new T.Emitter,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(O,S){this.a.$registerExtensionStorageKeysToSync(O,S)}async initializeExtensionStorage(O,S,k){const N=await this.a.$initializeExtensionStorage(O,S);let D;return N&&(D=this.d(O,S,N)),D||k}setValue(O,S,k){return this.a.$setValue(O,S,k)}$acceptValue(O,S,k){const N=this.d(O,S,k);N&&this.b.fire({shared:O,key:S,value:N})}d(O,S,k){try{return JSON.parse(k)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${O}): ${N}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(Ie[76],Ce([1,0,3,27,12,57,2]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let O=class{constructor(k,N,D){this.d=N,this.f=D,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(k){return C.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,N=await this.g(k);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(C.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(k){if(this.c)return C.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return C.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};O=qe([Ve(0,T.IExtHostInitDataService),Ve(1,y.ILogService),Ve(2,L.IExtHostConsumerFileSystem)],O),e.ExtensionStoragePaths=O}),define(Ie[58],Ce([1,0,5,4,3,2,15,7,6,137,11,175,20,34,161,64,9,14,8]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class E{constructor(n,f,g,P){this.k=n,this._id=f,this.l=g,this.m=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(q=>this.f=q);const M=this;this.value={get name(){return M.m||""},get processId(){return M.b},get creationOptions(){return M.l},get exitStatus(){return M.h},get state(){return M.j},sendText(q,J=!0){M.o(),M.k.$sendText(M._id,q,J)},show(q){M.o(),M.k.$show(M._id,q)},hide(){M.o(),M.k.$hide(M._id)},dispose(){M.a||(M.a=!0,M.k.$dispose(M._id))},get dimensions(){if(!(M.d===void 0||M.g===void 0))return{columns:M.d,rows:M.g}}}}async create(n,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,o.withNullAsUndefined)(n.shellPath),shellArgs:(0,o.withNullAsUndefined)(n.shellArgs),cwd:(0,o.withNullAsUndefined)(n.cwd),env:(0,o.withNullAsUndefined)(n.env),icon:(0,o.withNullAsUndefined)(d(n.iconPath)),color:t.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,o.withNullAsUndefined)(n.message),strictEnv:(0,o.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(f?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(f?.useShellEnvironment),location:f?.location||this.n(n.location,f?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,f,g,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:t.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.n(n,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,f){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in n?{viewColumn:b.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,f){this.h=Object.freeze({code:n,reason:f})}setDimensions(n,f){return n===this.d&&f===this.g||n===0||f===0?!1:(this.d=n,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(f=>{f!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=E;class p{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,f){this.g.setDimensions?.({columns:n,rows:f})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let w=1,s=class extends O.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,f){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=f.getProxy(T.MainContext.MainThreadTerminalService),this.s=new h.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[g,P]of this.g)P.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,f){const g=new E(this.a,(0,v.generateUuid)(),n,n.name),P=new p(n.pty);return g.createExtensionTerminal(n.location,this.L(n,f).resolvedExtHostIdentifier,d(n.iconPath),c(n.color)).then(M=>{const q=this.M(M,P);this.h[M]=q}),this.f.push(g),g.value}L(n,f){if(f=f||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const g=n.location.parentTerminal;if(g){const P=this.f.find(M=>M.value===g);P&&(f.resolvedExtHostIdentifier=P._id)}}else n.location&&typeof n.location!="object"?f.location=n.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(n,f){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const P=new p(f),M=this.M(n,P);this.h[n]=M}async $acceptActiveTerminalChanged(n){const f=this.b;if(n===null){this.b=void 0,f!==this.b&&this.F.fire(this.b);return}const g=this.O(n);g&&(this.b=g,f!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,f){const g=this.O(n);g&&this.I.fire({terminal:g.value,data:f})}async $acceptTerminalDimensions(n,f,g){const P=this.O(n);P&&P.setDimensions(f,g)&&this.G.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(n,f,g){this.g.get(n)?.resize(f,g)}async $acceptTerminalTitleChange(n,f){const g=this.O(n);g&&(g.name=f)}async $acceptTerminalClosed(n,f,g){const P=this.Q(this.f,n);if(P!==null){const M=this.f.splice(P,1)[0];M.setExitStatus(f,g),this.C.fire(M.value)}}$acceptTerminalOpened(n,f,g,P){if(f){const J=this.Q(this.f,f);if(J!==null){this.f[J]._id=n,this.D.fire(this.terminals[J]),this.f[J].isOpen=!0;return}}const M={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},q=new E(this.a,n,M,g);this.f.push(q),this.D.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(n,f){this.O(n)?._setProcessId(f)}async $startExtensionTerminal(n,f){const g=this.O(n);if(!g)return{message:(0,k.localize)(0,null,n)};g.isOpen||await new Promise(M=>{const q=this.onDidOpenTerminal(async J=>{J===g.value&&(q.dispose(),M())})});const P=this.g.get(n);P?P.startSendingEvents(f):this.j[n]={initialDimensions:f}}M(n,f){const g=new O.DisposableStore;g.add(f.onProcessReady(M=>this.a.$sendProcessReady(n,M.pid,M.cwd))),g.add(f.onDidChangeProperty(M=>this.a.$sendProcessProperty(n,M))),this.s.startBuffering(n,f.onProcessData),g.add(f.onProcessExit(M=>this.N(n,M))),this.g.set(n,f);const P=this.j[n];return P&&f instanceof p&&(f.startSendingEvents(P.initialDimensions),delete this.j[n]),g}$acceptProcessAckDataEvent(n,f){this.g.get(n)?.acknowledgeDataEvent(f)}$acceptProcessInput(n,f){this.g.get(n)?.input(f)}$acceptTerminalInteraction(n){const f=this.O(n);f?.setInteractedWith()&&this.H.fire(f.value)}$acceptProcessResize(n,f,g){try{this.g.get(n)?.resize(f,g)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(n,f){this.g.get(n)?.shutdown(f)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(f=>this.a.$sendProcessProperty(n,{type:"cwd",value:f}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,f,g){if(this.v.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.v.set(f,g),this.a.$registerProfileProvider(f,n.identifier.value),new S.Disposable(()=>{this.v.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(n,f,g){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,g),this.a.$registerQuickFixProvider(n,f),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,f){const g=new m.CancellationTokenSource().token;if(g.isCancellationRequested)return;const P=this.w.get(n);if(!!P)return P.provideTerminalQuickFixes(f,g)}async $createContributedProfileTerminal(n,f){const g=new m.CancellationTokenSource().token;let P=await this.v.get(n)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,f);return}this.createTerminalFromOptions(P.options,f)}}async $provideLinks(n,f){const g=this.O(n);if(!g)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const M=new m.CancellationTokenSource;this.z.set(n,M);const q=[],J={terminal:g.value,line:f},x=[];for(const F of this.u)x.push(l.Promises.withAsyncBody(async $=>{M.token.onCancellationRequested(()=>$({provider:F,links:[]}));const z=await F.provideTerminalLinks(J,M.token)||[];M.token.isCancellationRequested||$({provider:F,links:z})}));const R=await Promise.all(x);if(M.token.isCancellationRequested)return[];const A=new Map;for(const F of R)F&&F.links.length>0&&q.push(...F.links.map($=>{const z={id:w++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return A.set(z.id,{provider:F.provider,link:$}),z}));return this.y.set(n,A),q}$activateLink(n,f){const g=this.y.get(n)?.get(f);!g||g.provider.handleTerminalLink(g.link)}N(n,f){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const g=this.h[n];g&&(g.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,f)}O(n){return this.P(this.f,n)}P(n,f){const g=this.Q(n,f);return g!==null?n[g]:null}Q(n,f){let g=null;return n.some((P,M)=>P._id===f?(g=M,!0):!1),g}getEnvironmentVariableCollection(n){let f=this.l.get(n.identifier.value);return f||(f=new r,this.S(n.identifier.value,f)),f}R(n,f){const g=(0,D.serializeEnvironmentVariableCollection)(f.map);this.a.$setEnvironmentVariableCollection(n,f.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(n){n.forEach(f=>{const g=f[0],P=new r(f[1]);this.S(g,P)})}$acceptDefaultProfile(n,f){const g=this.m;this.m=n,this.n=f,g?.path!==n.path&&this.J.fire(n.path)}S(n,f){this.l.set(n,f),f.onDidChangeCollection(()=>{this.R(n,f)})}};s=qe([Ve(1,C.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class r{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new i.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,f){this.d(n,{value:f,type:S.EnvironmentVariableMutatorType.Replace})}append(n,f){this.d(n,{value:f,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,f){this.d(n,{value:f,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,f){const g=this.map.get(n);(!g||g.value!==f.value||g.type!==f.type)&&(this.map.set(n,f),this.b.fire())}get(n){return this.map.get(n)}forEach(n,f){this.map.forEach((g,P)=>n.call(f,P,g,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let a=class extends s{constructor(n){super(!1,n)}createTerminal(n,f,g){throw new N.NotSupportedError}createTerminalFromOptions(n,f){throw new N.NotSupportedError}};a=qe([Ve(0,C.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function d(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function c(u){return t.ThemeColor.isThemeColor(u)?u:void 0}});var Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)},Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i};define(Ie[221],Ce([1,0,16,14,24,20,5,185,222,7,23,9,34,4,15,97,8,6,42,67,53]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E,p){"use strict";var w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(A,F,$){this.j=$,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=A.getProxy(v.MainContext.MainThreadTesting),this.h=new q(this.f),this.g=new u(this.f),F.registerArgumentProcessor({processArgument:z=>{if(z?.$mid!==15)return z;const V=z,K=V.tests[V.tests.length-1].item.extId;return this.d.get(b.TestId.root(K))?.collection.tree.get(K)?.actual??(0,t.toItemFromContext)(z)}})}createTestController(A,F,$){if(this.d.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const z=new k.DisposableStore,V=z.add(new t.ExtHostTestItemCollection(A,F,this.j));V.root.label=F;const K=new Map,ie=this.f,ge={items:V.root.children,get label(){return F},set label(re){F=re,V.root.label=re,ie.$updateController(A,{label:F})},get refreshHandler(){return $},set refreshHandler(re){$=re,ie.$updateController(A,{canRefresh:!!re})},get id(){return A},createRunProfile:(re,se,le,_,me)=>{let we=(0,S.hash)(re);for(;K.has(we);)we++;return new J(this.f,K,A,we,re,se,le,_,me)},createTestItem(re,se,le){return new t.TestItemImpl(A,re,se,le)},createTestRun:(re,se,le=!0)=>this.g.createTestRun(A,V,re,se,le),set resolveHandler(re){V.resolveHandler=re},get resolveHandler(){return V.resolveHandler},dispose:()=>{z.dispose()}};ie.$registerTestController(A,F,!!$),z.add((0,k.toDisposable)(()=>ie.$unregisterTestController(A)));const ce={controller:ge,collection:V,profiles:K};return this.d.set(A,ce),z.add((0,k.toDisposable)(()=>this.d.delete(A))),z.add(V.onDidGenerateDiff(re=>ie.$publishDiff(A,re.map(p.TestsDiffOp.serialize)))),ge}createTestObserver(){return this.h.checkout()}async runTests(A,F=L.CancellationToken.None){const $=n(A);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.d.get($.controllerId);if(!z)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:A.include?.map(V=>b.TestId.fromExtHostTestItem(V,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:x[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:A.exclude?.map(V=>V.id)},F)}$syncTests(){for(const{collection:A}of this.d.values())A.flushDiff();return Promise.resolve()}$provideFileCoverage(A,F,$){return(0,i.mapFind)(this.g.trackers,V=>V.id===A?V.getCoverage(F):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(A,F,$,z){return(0,i.mapFind)(this.g.trackers,K=>K.id===A?K.getCoverage(F):void 0)?.resolveFileCoverage($,z)??Promise.resolve([])}$configureRunProfile(A,F){this.d.get(A)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(A,F){await this.d.get(A)?.controller.refreshHandler?.(F)}$publishTestResults(A){this.results=Object.freeze(A.map(F=>(0,N.deepFreeze)(o.TestResults.to(F))).concat(this.results).sort((F,$)=>$.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(A,F){const $=this.d.get(b.TestId.fromString(A).controllerId)?.collection;$&&(await $.expand(A,F<0?1/0:F),$.flushDiff())}$acceptDiff(A){this.h.applyDiff(A.map(p.TestsDiffOp.deserialize))}async $runControllerTests(A,F){return Promise.all(A.map($=>this.runControllerTestRequest($,F)))}async runControllerTestRequest(A,F){const $=this.d.get(A.controllerId);if(!$)return{};const{collection:z,profiles:V}=$,K=V.get(A.profileId);if(!K)return{};const ie=A.testIds.map(se=>z.tree.get(se)).filter(D.isDefined),ge=A.excludeExtIds.map(se=>$.collection.tree.get(se)).filter(D.isDefined).filter(se=>ie.some(le=>le.fullId.compare(se.fullId)===2));if(!ie.length)return{};const ce=new l.TestRunRequest(ie.some(se=>se.actual instanceof t.TestItemRootImpl)?void 0:ie.map(se=>se.actual),ge.map(se=>se.actual),K),re=this.g.prepareForMainThreadTestRun(ce,f.fromInternal(A,$.collection),F);try{return await K.runHandler(ce,F),{}}catch(se){return{error:String(se)}}finally{re.hasRunningTasks&&!F.isCancellationRequested&&await C.Event.toPromise(re.onEnd),re.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.g.cancelAllRuns():this.g.cancelRunById(A)}};r=qe([Ve(0,h.IExtHostRpcService)],r),e.ExtHostTesting=r;const a=1e4;var d;(function(R){R[R.Running=0]="Running",R[R.Cancelling=1]="Cancelling",R[R.Ended=2]="Ended"})(d||(d={}));class c extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(A,F,$){super(),this.k=A,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new L.CancellationTokenSource($));const z=this.B(new T.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>z.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(A){return this.f.get(A)?.coverage}createRun(A){const F=this.k.id,$=this.k.controllerId,z=(0,m.generateUuid)(),V=new g(this.l,F,z),K=re=>(se,...le)=>{if(ge){console.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(se)||(this.s(se),re(se,...le))},ie=(re,se)=>{const le=se instanceof Array?se.map(o.TestMessage.from):[o.TestMessage.from(se)];if(re.uri&&re.range){const _={range:o.Range.from(re.range),uri:re.uri};for(const me of le)me.location=me.location||_}this.l.$appendTestMessagesInRun(F,z,b.TestId.fromExtHostTestItem(re,$).toString(),le)};let ge=!1;const ce={isPersisted:this.k.isPersisted,token:this.h.token,name:A,get coverageProvider(){return V.coverageProvider},set coverageProvider(re){V.coverageProvider=re},enqueued:K(re=>{this.l.$updateTestStateInRun(F,z,b.TestId.fromExtHostTestItem(re,$).toString(),1)}),skipped:K(re=>{this.l.$updateTestStateInRun(F,z,b.TestId.fromExtHostTestItem(re,$).toString(),5)}),started:K(re=>{this.l.$updateTestStateInRun(F,z,b.TestId.fromExtHostTestItem(re,$).toString(),2)}),errored:K((re,se,le)=>{ie(re,se),this.l.$updateTestStateInRun(F,z,b.TestId.fromExtHostTestItem(re,$).toString(),6,le)}),failed:K((re,se,le)=>{ie(re,se),this.l.$updateTestStateInRun(F,z,b.TestId.fromExtHostTestItem(re,$).toString(),4,le)}),passed:K((re,se)=>{this.l.$updateTestStateInRun(F,z,b.TestId.fromExtHostTestItem(re,this.k.controllerId).toString(),3,se)}),appendOutput:(re,se,le)=>{ge||(le&&(this.k.isIncluded(le)?this.s(le):le=void 0),this.l.$appendOutputToRun(F,z,y.VSBuffer.fromString(re),se&&o.location.from(se),le&&b.TestId.fromExtHostTestItem(le,$).toString()))},end:()=>{ge||(ge=!0,this.l.$finishedTestRunTask(F,z),this.f.delete(z),this.f.size||this.p())}};return this.f.set(z,{run:ce,coverage:V}),this.l.$startedTestRunTask(F,{id:z,name:A,running:!0}),ce}m(){for(const{run:A}of this.f.values())A.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(A){if(!(A instanceof t.TestItemImpl))throw new E.InvalidTestItemError(A.id);if(this.g.has(b.TestId.fromExtHostTestItem(A,this.k.controllerId).toString()))return;const F=[],$=this.k.colllection.root;for(;;){const z=o.TestItem.from(A);if(F.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),A===$))break;A=A.parent||$}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class u{get trackers(){return this.c.values()}constructor(A){this.d=A,this.c=new Map}prepareForMainThreadTestRun(A,F,$){return this.f(A,F,$)}cancelRunById(A){for(const F of this.c.values())if(F.id===A){F.cancel();return}}cancelAllRuns(){for(const A of this.c.values())A.cancel()}createTestRun(A,F,$,z,V){const K=this.c.get($);if(K)return K.createRun(z);const ie=f.fromPublic(A,F,$,V),ge=n($);this.d.$startedExtensionTestRun({controllerId:A,profile:ge&&{group:x[ge.kind],id:ge.profileId},exclude:$.exclude?.map(re=>b.TestId.fromExtHostTestItem(re,F.root.id).toString())??[],id:ie.id,include:$.include?.map(re=>b.TestId.fromExtHostTestItem(re,F.root.id).toString())??[F.root.id],persist:V});const ce=this.f($,ie);return ce.onEnd(()=>{this.d.$finishedExtensionTestRun(ie.id),ce.dispose()}),ce.createRun(z)}f(A,F,$){const z=new c(F,this.d,$);return this.c.set(A,z),z.onEnd(()=>this.c.delete(A)),z}}e.TestRunCoordinator=u;const n=R=>{if(!!R.profile){if(!(R.profile instanceof J))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class f{static fromPublic(A,F,$,z){return new f(A,(0,m.generateUuid)(),$.include?.map(V=>b.TestId.fromExtHostTestItem(V,A).toString())??[A],$.exclude?.map(V=>b.TestId.fromExtHostTestItem(V,A).toString())??[],z,F)}static fromInternal(A,F){return new f(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,F)}constructor(A,F,$,z,V,K){this.controllerId=A,this.id=F,this.isPersisted=V,this.colllection=K,this.c=$.map(ie=>ie+"\0"),this.d=z.map(ie=>ie+"\0")}isIncluded(A){const F=b.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const $ of this.d)if(F===$||F.startsWith($))return!1;for(const $ of this.c)if(F===$||F.startsWith($))return!0;return!1}}e.TestRunDto=f;class g{set coverageProvider(A){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this.c=A,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(A,F,$){this.f=A,this.g=F,this.h=$}async provideFileCoverage(A){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(A))());try{return(await this.d)?.map(o.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(A,F){const $=await this.d;let z=$?.[A];return!this.c||!$||!z?[]:(z.detailedCoverage||(z=$[A]=await this.c.resolveFileCoverage?.(z,F)??z),z.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class P{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(A){this.h=A,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(A){this.c.add(A)}update(A){Object.assign(A.revived,o.TestItem.toPlain(A.item)),this.c.has(A)||this.d.add(A)}remove(A){if(this.c.has(A)){this.c.delete(A);return}this.d.delete(A);const F=b.TestId.parentId(A.item.extId);if(F&&this.g.has(F.toString())){this.g.add(A.item.extId);return}this.f.add(A)}getChangeEvent(){const{c:A,d:F,f:$}=this;return{get added(){return[...A].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...$].map(z=>z.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class M extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(A){return this.d.get(A)}getMirroredTestDataByReference(A){return this.d.get(A.id)}p(A,F){return{...A,revived:o.TestItem.toPlain(A.item),depth:F?F.depth+1:0,children:new Set}}o(){return new P(this.q)}}e.MirroredTestCollection=M;class q{constructor(A){this.d=A}checkout(){this.c||(this.c=this.f());const A=this.c;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(F=>F.revived)},dispose:(0,O.once)(()=>{--A.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(A){return this.c?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.c?.tests.apply(A)}f(){const A=new M;return this.d.$subscribeToDiffs(),{observers:0,tests:A}}}class J{get label(){return this.d}set label(A){A!==this.d&&(this.d=A,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this.f}set isDefault(A){A!==this.f&&(this.f=A,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?o.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this.c}set configureHandler(A){A!==this.c&&(this.c=A,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}constructor(A,F,$,z,V,K,ie,ge=!1,ce=void 0){this.controllerId=$,this.profileId=z,this.d=V,this.kind=K,this.runHandler=ie,this.f=ge,this._tag=ce,w.set(this,void 0),s.set(this,void 0),Ye(this,w,A,"f"),Ye(this,s,F,"f"),F.set(z,this);const re=x[K];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Re(this,w,"f").$publishTestRunProfile({profileId:z,controllerId:$,tag:ce?o.TestTag.namespace(this.controllerId,ce.id):null,label:V,group:re,isDefault:ge,hasConfigurationHandler:!1})}dispose(){Re(this,s,"f")?.delete(this.profileId)&&(Ye(this,s,void 0,"f"),Re(this,w,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=J,w=new WeakMap,s=new WeakMap;const x={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ie[223],Ce([1,0,16,5,4,98,8,6]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(N,D){this.i=D,this.a=new T.Emitter,this.b=new T.Emitter,this.c=new T.Emitter,this.d=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(y.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const D=this.i.allEditors();return N?D:D.map(m=>m.value)}async showTextDocument(N,D,m){let v;typeof D=="number"?v={position:C.ViewColumn.from(D),preserveFocus:m}:typeof D=="object"?v={position:C.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?C.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:v={preserveFocus:!1};const h=await this.h.$tryShowTextDocument(N.uri,v),t=h&&this.i.getEditor(h);if(t)return t.value;throw h?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,D){return new L.TextEditorDecorationType(this.h,N,D).value}$acceptEditorPropertiesChanged(N,D){const m=this.i.getEditor(N);if(!m)throw new Error("unknown text editor");if(D.options&&m._acceptOptions(D.options),D.selections){const v=D.selections.selections.map(C.Selection.to);m._acceptSelections(v)}if(D.visibleRanges){const v=i.coalesce(D.visibleRanges.map(C.Range.to));m._acceptVisibleRanges(v)}if(D.options&&this.b.fire({textEditor:m.value,options:{...D.options,lineNumbers:C.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const v=O.TextEditorSelectionChangeKind.fromValue(D.selections.source),h=D.selections.selections.map(C.Selection.to);this.a.fire({textEditor:m.value,selections:h,kind:v})}if(D.visibleRanges){const v=i.coalesce(D.visibleRanges.map(C.Range.to));this.c.fire({textEditor:m.value,visibleRanges:v})}}$acceptEditorPositionData(N){for(const D in N){const m=this.i.getEditor(D);if(!m)throw new Error("Unknown text editor");const v=C.ViewColumn.to(N[D]);m.value.viewColumn!==v&&(m._acceptViewColumn(v),this.d.fire({textEditor:m.value,viewColumn:v}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.ExtHostEditors=S}),define(Ie[224],Ce([1,0,2,3,4,7,6,8,9]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class k{constructor(m,v){this.b=new Map,this.c=new Map,this.a=m.getProxy(y.MainContext.MainThreadTimeline),v.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===12){const t=h.uri===void 0?void 0:i.URI.revive(h.uri);return this.c.get(h.source)?.get(N(t))?.get(h.handle)}return h}})}async $getTimeline(m,v,h,t){return this.b.get(m)?.provideTimeline(i.URI.revive(v),h,t)}registerTimelineProvider(m,v,h,t){const o=new L.DisposableStore,l=this.d(v.id,t,o).bind(this);let b;v.onDidChange&&(b=v.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:v.id}),this));const E=this.c;return this.f({...v,scheme:m,onDidChange:void 0,async provideTimeline(p,w,s){w?.resetCache&&(o.clear(),E.get(v.id)?.clear());const r=await v.provideTimeline(p,w,s);if(r==null)return;const a=l(p,w);return{...r,source:v.id,items:r.items.map(a)}},dispose(){for(const p of E.values())p.get(v.id)?.clear();b?.dispose(),o.dispose()}})}d(m,v,h){return(t,o)=>{let l;if(o?.cacheResults){let b=this.c.get(m);b===void 0&&(b=new Map,this.c.set(m,b));const E=N(t);l=b.get(E),l===void 0&&(l=new Map,b.set(E,l))}return b=>{const{iconPath:E,...p}=b,w=`${m}|${b.id??b.timestamp}`;l?.set(w,b);let s,r,a;b.iconPath&&(E instanceof C.ThemeIcon?a={id:E.id,color:E.color}:i.URI.isUri(E)?(s=E,r=E):{light:s,dark:r}=E);let d;return C.MarkdownString.isMarkdownString(p.tooltip)?d=O.MarkdownString.from(p.tooltip):(0,S.isString)(p.tooltip)?d=p.tooltip:C.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=O.MarkdownString.from(p.detail)):(0,S.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=p.detail),{...p,id:p.id??void 0,handle:w,source:m,command:b.command?v.toInternal(b.command,h):void 0,icon:s,iconDark:r,themeIcon:a,tooltip:d,accessibilityInformation:b.accessibilityInformation}}}}f(m){if(this.b.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this.a.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this.b.set(m.id,m),(0,L.toDisposable)(()=>{for(const h of this.c.values())h.get(m.id)?.clear();this.b.delete(m.id),this.a.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=k;function N(D){return D?.toString()}}),define(Ie[225],Ce([1,0,7,13,2,4]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,N,D){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=D.schemes.find(v=>!C.a.has(v));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(k,N),this.b.$registerUriOpener(k,D.schemes,S,D.label),(0,i.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(S,k,N){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const m=y.URI.revive(k);return D.canOpenExternalUri(m,N)}async $openUri(S,k,N){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(y.URI.revive(k.resolvedUri),{sourceUri:y.URI.revive(k.sourceUri)},N)}}e.ExtHostUriOpeners=C,C.a=new Set([T.Schemas.http,T.Schemas.https])}),define(Ie[226],Ce([1,0,4,2,7,11,26]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class O{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,N){if(this.c.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const D=O.a++;return this.c.add(C.ExtensionIdentifier.toKey(k)),this.d.set(D,N),this.b.$registerUriHandler(D,k),(0,y.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(k)),this.d.delete(D),this.b.$unregisterUriHandler(D)})}$handleExternalUri(k,N){const D=this.d.get(k);if(!D)return Promise.resolve(void 0);try{D.handleUri(T.URI.revive(N))}catch(m){(0,L.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this.b.$createAppUri(k))}}e.ExtHostUrls=O,O.a=0});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[59],Ce([1,0,5,13,23,2,149,169,68,4]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";var N,D,m,v,h,t,o,l,b,E,p,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class r{constructor(M,q,J,x,R,A,F){N.set(this,void 0),D.set(this,void 0),m.set(this,void 0),v.set(this,void 0),h.set(this,void 0),t.set(this,void 0),o.set(this,""),l.set(this,void 0),b.set(this,!1),E.set(this,!1),p.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new i.Emitter),this._onDidDispose=Re(this,s,"f").event,Ye(this,N,M,"f"),Ye(this,D,q,"f"),Ye(this,l,J,"f"),Ye(this,v,x,"f"),Ye(this,h,R,"f"),Ye(this,t,A,"f"),Ye(this,p,a(A),"f"),Ye(this,w,d(A),"f"),Ye(this,m,F,"f")}dispose(){Ye(this,b,!0,"f"),Re(this,s,"f").fire(),Re(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(M){return Ye(this,E,!0,"f"),(0,S.asWebviewUri)(M,Re(this,v,"f"))}get cspSource(){const M=Re(this,t,"f").extensionLocation;if(M.scheme===T.Schemas.https||M.scheme===T.Schemas.http){let q=M.toString();return q.endsWith("/")||(q+="/"),q+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Re(this,o,"f")}set html(M){this.a(),Re(this,o,"f")!==M&&(Ye(this,o,M,"f"),Re(this,w,"f")&&!Re(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(M)&&(Ye(this,E,!0,"f"),Re(this,m,"f").report("Webview vscode-resource: uris",Re(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,D,"f").$setHtml(Re(this,N,"f"),this.b(M)))}get options(){return this.a(),Re(this,l,"f")}set options(M){this.a(),y.equals(Re(this,l,"f"),M)||Re(this,D,"f").$setOptions(Re(this,N,"f"),n(Re(this,t,"f"),Re(this,h,"f"),M)),Ye(this,l,M,"f")}async postMessage(M){if(Re(this,b,"f"))return!1;const q=(0,O.serializeWebviewMessage)(M,{serializeBuffersForPostMessage:Re(this,p,"f")});return Re(this,D,"f").$postMessage(Re(this,N,"f"),q.message,...q.buffers)}a(){if(Re(this,b,"f"))throw new Error("Webview is disposed")}b(M){if(!Re(this,w,"f"))return M;const q=Re(this,t,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,J=Re(this,t,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Re(this,t,"f").extensionLocation.authority:void 0;return M.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,R,A,F,$,z)=>{const V=L.URI.from({scheme:F||"file",path:decodeURIComponent($)}),K=(0,S.asWebviewUri)(V,{isRemote:q,authority:J}).toString();return`${R}${K}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,R,A,F,$,z)=>{const V=L.URI.from({scheme:F||"file",path:decodeURIComponent($)}),K=(0,S.asWebviewUri)(V,{isRemote:q,authority:J}).toString();return`${R}${K}${z}`})}}e.ExtHostWebview=r,N=new WeakMap,D=new WeakMap,m=new WeakMap,v=new WeakMap,h=new WeakMap,t=new WeakMap,o=new WeakMap,l=new WeakMap,b=new WeakMap,E=new WeakMap,p=new WeakMap,w=new WeakMap,s=new WeakMap;function a(P){try{const M=(0,C.normalizeVersion)((0,C.parseVersion)(P.engines.vscode));return!!M&&M.majorBase>=1&&M.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function d(P){try{const M=(0,C.normalizeVersion)((0,C.parseVersion)(P.engines.vscode));return M?M.majorBase<1||M.majorBase===1&&M.minorBase<60:!1}catch{return!1}}class c{constructor(M,q,J,x,R){this.c=q,this.d=J,this.e=x,this.f=R,this.b=new Map,this.a=M.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(M,q,J){const x=this.g(M);if(x){const{message:R}=(0,O.deserializeWebviewMessage)(q,J.value);x._onMessageEmitter.fire(R)}}$onMissingCsp(M,q){this.e.warn(`${q} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(M,q,J){const x=new r(M,this.a,f(q),this.c,this.d,J,this.f);return this.b.set(M,x),x._onDidDispose(()=>{this.b.delete(M)}),x}deleteWebview(M){this.b.delete(M)}g(M){return this.b.get(M)}}e.ExtHostWebviews=c;function u(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=u;function n(P,M,q){return{enableCommandUris:q.enableCommandUris,enableScripts:q.enableScripts,enableForms:q.enableForms,portMapping:q.portMapping,localResourceRoots:q.localResourceRoots||g(P,M)}}e.serializeWebviewOptions=n;function f(P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots?.map(M=>L.URI.from(M))}}function g(P,M){return[...(M?.getWorkspaceFolders()||[]).map(q=>q.uri),P.extensionLocation]}}),define(Ie[227],Ce([1,0,20,222,7,13,22,2,8,59,51,4,6]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class v{constructor(r,a){this.document=r,this.b=a,this.a=1,this.c=new N.Cache("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,a){await this.f(r).undo(),a||this.disposeBackup()}async redo(r,a){await this.f(r).redo(),a||this.disposeBackup()}disposeEdits(r){for(const a of r)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=w(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const a=this.c.get(r,0);if(!a)throw new Error("No edit found");return a}}class h{constructor(){this.a=new Map}get(r,a){return this.a.get(this.b(r,a))}add(r,a,d){const c=this.b(r,a.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${a.uri}`);const u=new v(a,d);return this.a.set(c,u),u}delete(r,a){const d=this.b(r,a.uri);this.a.delete(d)}b(r,a){return`${r}@@@${a}`}}var t;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(t||(t={}));class o{constructor(){this.a=new Map}addTextProvider(r,a,d){return this.b(0,r,a,d)}addCustomProvider(r,a,d){return this.b(1,r,a,d)}get(r){return this.a.get(r)}b(r,a,d,c){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:r,extension:d,provider:c}),new m.Disposable(()=>this.a.delete(a))}}class l{constructor(r,a,d,c,u){this.d=a,this.f=d,this.g=c,this.h=u,this.b=new o,this.c=new h,this.a=r.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,a,d,c){const u=new y.DisposableStore;return E(d)?(u.add(this.b.addTextProvider(a,r,d)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(r),a,c.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(r))):(u.add(this.b.addCustomProvider(a,r,d)),b(d)&&u.add(d.onDidChangeCustomDocument(n=>{const f=this.i(a,n.document.uri);if(p(n)){const g=f.addEdit(n);this.a.$onDidEdit(n.document.uri,a,g,n.label)}else this.a.$onContentChange(n.document.uri,a)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(r),a,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(r))),m.Disposable.from(u,new m.Disposable(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(r,a,d,c,u){const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${a}'`);const f=O.URI.revive(r),g=await n.provider.openCustomDocument(f,{backupId:d,untitledDocumentData:c?.buffer},u);let P;return b(n.provider)&&this.f&&(P=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(a,g,P),{editable:b(n.provider)}}async $disposeCustomDocument(r,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const c=O.URI.revive(r),{document:u}=this.i(a,c);this.c.delete(a,u),u.dispose()}async $resolveWebviewEditor(r,a,d,c,u,n){const f=this.b.get(d);if(!f)throw new Error(`No provider found for '${d}'`);const g=S.ViewColumn.to(u),P=this.g.createNewWebview(a,c.contentOptions,f.extension),M=this.h.createNewWebviewPanel(a,d,c.title,g,c.options,P,!0),q=O.URI.revive(r);switch(f.type){case 1:{const{document:J}=this.i(d,q);return f.provider.resolveCustomEditor(J,M,n)}case 0:{const J=this.d.getDocument(q);return f.provider.resolveCustomTextEditor(J,M,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,a,d){this.i(a,r).disposeEdits(d)}async $onMoveCustomEditor(r,a,d){const c=this.b.get(d);if(!c)throw new Error(`No provider found for '${d}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const u=this.h.getWebviewPanel(r);if(!u)throw new Error("No webview found");const n=O.URI.revive(a),f=this.d.getDocument(n);await c.provider.moveCustomTextEditor(f,u,i.CancellationToken.None)}async $undo(r,a,d,c){return this.i(a,r).undo(d,c)}async $redo(r,a,d,c){return this.i(a,r).redo(d,c)}async $revert(r,a,d){const c=this.i(a,r);await this.j(a).revertCustomDocument(c.document,d),c.disposeBackup()}async $onSave(r,a,d){const c=this.i(a,r);await this.j(a).saveCustomDocument(c.document,d),c.disposeBackup()}async $onSaveAs(r,a,d,c){const u=this.i(a,r);return this.j(a).saveCustomDocumentAs(u.document,O.URI.revive(d),c)}async $backup(r,a,d){const c=this.i(a,r),n=await this.j(a).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},d);return c.updateBackup(n),n.id}i(r,a){const d=this.c.get(r,O.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(r){const d=this.b.get(r)?.provider;if(!d||!b(d))throw new Error("Custom document is not editable");return d}}e.ExtHostCustomEditors=l;function b(s){return!!s.onDidChangeCustomDocument}function E(s){return typeof s.resolveCustomTextEditor=="function"}function p(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function w(s){const r=s.scheme===L.Schemas.file||s.scheme===L.Schemas.untitled?s.fsPath:s.toString();return(0,T.hash)(r)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[228],Ce([1,0,5,7,2,34,8,59,4,6]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";var N,D,m,v,h,t,o,l,b,E,p,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends T.Disposable{constructor(u,n,f,g){super(),N.set(this,void 0),D.set(this,void 0),m.set(this,void 0),v.set(this,void 0),h.set(this,void 0),t.set(this,void 0),o.set(this,void 0),l.set(this,void 0),b.set(this,!0),E.set(this,void 0),p.set(this,!1),w.set(this,this.B(new i.Emitter)),this.onDidDispose=Re(this,w,"f").event,s.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Re(this,s,"f").event,Ye(this,N,u,"f"),Ye(this,D,n,"f"),Ye(this,v,f,"f"),Ye(this,m,g.viewType,"f"),Ye(this,h,g.panelOptions,"f"),Ye(this,l,g.viewColumn,"f"),Ye(this,t,g.title,"f"),Ye(this,E,g.active,"f")}dispose(){Re(this,p,"f")||(Ye(this,p,!0,"f"),Re(this,w,"f").fire(),Re(this,D,"f").$disposeWebview(Re(this,N,"f")),Re(this,v,"f").dispose(),super.dispose())}get webview(){return this.c(),Re(this,v,"f")}get viewType(){return this.c(),Re(this,m,"f")}get title(){return this.c(),Re(this,t,"f")}set title(u){this.c(),Re(this,t,"f")!==u&&(Ye(this,t,u,"f"),Re(this,D,"f").$setTitle(Re(this,N,"f"),u))}get iconPath(){return this.c(),Re(this,o,"f")}set iconPath(u){this.c(),Re(this,o,"f")!==u&&(Ye(this,o,u,"f"),Re(this,D,"f").$setIconPath(Re(this,N,"f"),y.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Re(this,h,"f")}get viewColumn(){if(this.c(),!(typeof Re(this,l,"f")=="number"&&Re(this,l,"f")<0))return Re(this,l,"f")}get active(){return this.c(),Re(this,E,"f")}get visible(){return this.c(),Re(this,b,"f")}_updateViewState(u){Re(this,p,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Ye(this,E,u.active,"f"),Ye(this,b,u.visible,"f"),Ye(this,l,u.viewColumn,"f"),Re(this,s,"f").fire({webviewPanel:this}))}reveal(u,n){this.c(),Re(this,D,"f").$reveal(Re(this,N,"f"),{viewColumn:typeof u>"u"?void 0:C.ViewColumn.from(u),preserveFocus:!!n})}c(){if(Re(this,p,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,D=new WeakMap,m=new WeakMap,v=new WeakMap,h=new WeakMap,t=new WeakMap,o=new WeakMap,l=new WeakMap,b=new WeakMap,E=new WeakMap,p=new WeakMap,w=new WeakMap,s=new WeakMap;class a{static c(){return(0,L.generateUuid)()}constructor(u,n,f){this.g=n,this.h=f,this.e=new Map,this.f=new Map,this.d=u.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,n,f,g,P={}){const M=typeof g=="object"?g.viewColumn:g,q={viewColumn:C.ViewColumn.from(M),preserveFocus:typeof g=="object"&&!!g.preserveFocus},J=(0,O.shouldSerializeBuffersForPostMessage)(u),x=a.c();this.d.$createWebviewPanel((0,O.toExtensionData)(u),x,n,{title:f,panelOptions:d(P),webviewOptions:(0,O.serializeWebviewOptions)(u,this.h,P),serializeBuffersForPostMessage:J},q);const R=this.g.createNewWebview(x,P,u);return this.createNewWebviewPanel(x,n,f,M,P,R,!0)}$onDidChangeWebviewPanelViewStates(u){const n=Object.keys(u);n.sort((f,g)=>{const P=u[f],M=u[g];return P.active?1:M.active?-1:+P.visible-+M.visible});for(const f of n){const g=this.getWebviewPanel(f);if(!g)continue;const P=u[f];g._updateViewState({active:P.active,visible:P.visible,viewColumn:C.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.e.delete(u),this.g.deleteWebview(u)}registerWebviewPanelSerializer(u,n,f){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:f,extension:u}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,O.shouldSerializeBuffersForPostMessage)(u)}),new k.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(u,n,f,g){const P=this.f.get(n);if(!P)throw new Error(`No serializer found for '${n}'`);const{serializer:M,extension:q}=P,J=this.g.createNewWebview(u,f.webviewOptions,q),x=this.createNewWebviewPanel(u,n,f.title,g,f.panelOptions,J,f.active);await M.deserializeWebviewPanel(x,f.state)}createNewWebviewPanel(u,n,f,g,P,M,q){const J=new r(u,this.d,M,{viewType:n,title:f,viewColumn:g,panelOptions:P,active:q});return this.e.set(u,J),J}getWebviewPanel(u){return this.e.get(u)}}e.ExtHostWebviewPanels=a;function d(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[229],Ce([1,0,5,7,59,8,4,6]),function(ee,e,i,T,y,L,C,O){"use strict";var S,k,N,D,m,v,h,t,o,l,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends T.Disposable{constructor(s,r,a,d,c,u){super(),S.set(this,void 0),k.set(this,void 0),N.set(this,void 0),D.set(this,void 0),m.set(this,!1),v.set(this,void 0),h.set(this,void 0),t.set(this,void 0),o.set(this,void 0),l.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Re(this,l,"f").event,b.set(this,this.B(new i.Emitter)),this.onDidDispose=Re(this,b,"f").event,Ye(this,N,a,"f"),Ye(this,h,d,"f"),Ye(this,S,s,"f"),Ye(this,k,r,"f"),Ye(this,D,c,"f"),Ye(this,v,u,"f")}dispose(){Re(this,m,"f")||(Ye(this,m,!0,"f"),Re(this,b,"f").fire(),Re(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Re(this,h,"f")}set title(s){this.a(),Re(this,h,"f")!==s&&(Ye(this,h,s,"f"),Re(this,k,"f").$setWebviewViewTitle(Re(this,S,"f"),s))}get description(){return this.a(),Re(this,t,"f")}set description(s){this.a(),Re(this,t,"f")!==s&&(Ye(this,t,s,"f"),Re(this,k,"f").$setWebviewViewDescription(Re(this,S,"f"),s))}get visible(){return Re(this,v,"f")}get webview(){return Re(this,D,"f")}get viewType(){return Re(this,N,"f")}_setVisible(s){s===Re(this,v,"f")||Re(this,m,"f")||(Ye(this,v,s,"f"),Re(this,l,"f").fire())}get badge(){return this.a(),Re(this,o,"f")}set badge(s){this.a(),!(s?.value===Re(this,o,"f")?.value&&s?.tooltip===Re(this,o,"f")?.tooltip)&&(Ye(this,o,L.ViewBadge.from(s),"f"),Re(this,k,"f").$setWebviewViewBadge(Re(this,S,"f"),s))}show(s){this.a(),Re(this,k,"f").$show(Re(this,S,"f"),!!s)}a(){if(Re(this,m,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,k=new WeakMap,N=new WeakMap,D=new WeakMap,m=new WeakMap,v=new WeakMap,h=new WeakMap,t=new WeakMap,o=new WeakMap,l=new WeakMap,b=new WeakMap;class p{constructor(s,r){this.d=r,this.b=new Map,this.c=new Map,this.a=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,r,a,d){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:a,extension:s}),this.a.$registerWebviewViewProvider((0,y.toExtensionData)(s),r,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(s)}),new O.Disposable(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(s,r,a,d,c){const u=this.b.get(r);if(!u)throw new Error(`No view provider found for '${r}'`);const{provider:n,extension:f}=u,g=this.d.createNewWebview(s,{},f),P=new E(s,this.a,r,a,g,!0);this.c.set(s,P),await n.resolveWebviewView(P,{state:d},c)}async $onDidChangeWebviewViewVisibility(s,r){this.e(s)._setVisible(r)}async $disposeWebviewView(s){const r=this.e(s);this.c.delete(s),r.dispose(),this.d.deleteWebview(s)}e(s){const r=this.c.get(s);if(!r)throw new Error("No webview found");return r}}e.ExtHostWebviewViews=p}),define(Ie[101],Ce([1,0,5,4,2,13,10,3,15]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class nn{get state(){return this.d}constructor(D){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=nn.a,this.b=D.getProxy(T.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(D){D!==this.d.focused&&(this.d={...this.d,focused:D},this.c.fire(this.d))}openUri(D,m){let v;if(typeof D=="string"){v=D;try{D=y.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,C.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this.b.$openUri(D,v,m)}async asExternalUri(D,m){if((0,C.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(D,m);return y.URI.from(v)}};k.a={focused:!0},k=qe([Ve(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,O.createDecorator)("IExtHostWindow")}),define(Ie[230],Ce([1,0,200,27,15]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends i.AbstractExtHostConsoleForwarder{constructor(O,S){super(O,S)}f(O,S,k){S.apply(console,k)}};L=qe([Ve(0,y.IExtHostRpcService),Ve(1,T.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(Ie[231],Ce([1,0,14,24,20,11,5,7,122,194,43]),function(ee,e,i,T,y,L,C,O,S,k,N){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(P,M){try{return JSON.stringify(P,M)}catch{return"null"}}const v="$$ref$$",h={[v]:-1};class t{constructor(M,q){this.jsonString=M,this.referencedBuffers=q}}function o(P,M=null,q=!1){const J=[];return{jsonString:(q?m:JSON.stringify)(P,(R,A)=>{if(typeof A>"u")return h;if(typeof A=="object"){if(A instanceof T.VSBuffer){const F=J.push(A)-1;return{[v]:F}}if(M)return M(R,A)}return A}),referencedBuffers:J}}e.stringifyJsonWithBufferRefs=o;function l(P,M,q){return JSON.parse(P,(J,x)=>{if(x){const R=x[v];if(typeof R=="number")return M[R];if(q&&x.$mid===1)return q.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=l;function b(P,M){return JSON.stringify(P,M)}function E(P){return P?(M,q)=>q&&q.$mid===1?P.transformOutgoing(q):q:null}var p;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},r=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends O.Disposable{constructor(M,q=null,J=null){super(),this[D]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=M,this.f=q,this.g=J,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let x=0,R=N.ProxyIdentifier.count;x<R;x++)this.k[x]=null,this.l[x]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(x=>this.G(x))}dispose(){this.j=!0,Object.keys(this.s).forEach(M=>{this.s[M].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(M){this.u===0&&(this.v=Date.now()+d.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(M){this.v=Date.now()+d.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(M){this.t!==M&&(this.t=M,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(M){return this.g?(0,S.transformIncomingURIs)(M,this.g):M}getProxy(M){const{nid:q,sid:J}=M;return this.l[q]||(this.l[q]=this.F(q,J)),this.l[q]}F(M,q){const J={get:(x,R)=>(typeof R=="string"&&!x[R]&&R.charCodeAt(0)===36&&(x[R]=(...A)=>this.O(M,R,A)),R===a?q:x[R])};return new Proxy(Object.create(null),J)}set(M,q){return this.k[M.nid]=q,q}assertRegistered(M){for(let q=0,J=M.length;q<J;q++){const x=M[q];if(!this.k[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}G(M){if(this.j)return;const q=M.byteLength,J=c.read(M,0),x=J.readUInt8(),R=J.readUInt32();switch(x){case 1:case 2:{let{rpcId:A,method:F,args:$}=n.deserializeRequestJSONArgs(J);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.H(q,R,A,F,$,x===2);break}case 3:case 4:{let{rpcId:A,method:F,args:$}=n.deserializeRequestMixedArgs(J);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.H(q,R,A,F,$,x===4);break}case 5:{this.f?.logIncoming(q,R,0,"ack"),this.z(R);break}case 6:{this.I(q,R);break}case 7:{this.J(q,R,void 0);break}case 9:{let A=n.deserializeReplyOKJSON(J);this.g&&(A=(0,S.transformIncomingURIs)(A,this.g)),this.J(q,R,A);break}case 10:{const A=n.deserializeReplyOKJSONWithBuffers(J,this.g);this.J(q,R,A);break}case 8:{const A=n.deserializeReplyOKVSBuffer(J);this.J(q,R,A);break}case 11:{let A=n.deserializeReplyErrError(J);this.g&&(A=(0,S.transformIncomingURIs)(A,this.g)),this.L(q,R,A);break}case 12:{this.L(q,R,void 0);break}default:console.error("received unexpected message"),console.error(M)}}H(M,q,J,x,R,A){this.f?.logIncoming(M,q,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(J)}.${x}(`,R);const F=String(q);let $,z;if(A){const K=new y.CancellationTokenSource;R.push(K.token),$=this.M(J,x,R),z=()=>K.cancel()}else $=this.M(J,x,R),z=s;this.p[F]=z;const V=n.serializeAcknowledged(q);this.f?.logOutgoing(V.byteLength,q,1,"ack"),this.c.send(V),$.then(K=>{delete this.p[F];const ie=n.serializeReplyOK(q,K,this.h);this.f?.logOutgoing(ie.byteLength,q,1,"reply:",K),this.c.send(ie)},K=>{delete this.p[F];const ie=n.serializeReplyErr(q,K);this.f?.logOutgoing(ie.byteLength,q,1,"replyErr:",K),this.c.send(ie)})}I(M,q){this.f?.logIncoming(M,q,1,"receiveCancel");const J=String(q);this.p[J]?.()}J(M,q,J){this.f?.logIncoming(M,q,0,"receiveReply:",J);const x=String(q);if(!this.s.hasOwnProperty(x))return;const R=this.s[x];delete this.s[x],R.resolveOk(J)}L(M,q,J){this.f?.logIncoming(M,q,0,"receiveReplyErr:",J);const x=String(q);if(!this.s.hasOwnProperty(x))return;const R=this.s[x];delete this.s[x];let A;J&&(J.$isError?(A=new Error,A.name=J.name,A.message=J.message,A.stack=J.stack):A=J),R.resolveErr(A)}M(M,q,J){try{return Promise.resolve(this.N(M,q,J))}catch(x){return Promise.reject(x)}}N(M,q,J){const x=this.k[M];if(!x)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(M));const R=x[q];if(typeof R!="function")throw new Error("Unknown method "+q+" on actor "+(0,N.getStringIdentifierForProxy)(M));return R.apply(x,J)}O(M,q,J){if(this.j)return new k.CanceledLazyPromise;let x=null;if(J.length>0&&y.CancellationToken.isCancellationToken(J[J.length-1])&&(x=J.pop()),x&&x.isCancellationRequested)return Promise.reject(L.canceled());const R=n.serializeRequestArguments(J,this.h),A=++this.m,F=String(A),$=new k.LazyPromise;x&&x.onCancellationRequested(()=>{const V=n.serializeCancel(A);this.f?.logOutgoing(V.byteLength,A,0,"cancel"),this.c.send(n.serializeCancel(A))}),this.s[F]=$,this.y(A);const z=n.serializeRequest(A,M,q,R,!!x);return this.f?.logOutgoing(z.byteLength,A,0,`request: ${(0,N.getStringIdentifierForProxy)(M)}.${q}(`,J),this.c.send(z),$}}e.RPCProtocol=d,D=r,d.a=3*1e3;class c{static alloc(M,q,J){const x=new c(T.VSBuffer.alloc(J+1+4),0);return x.writeUInt8(M),x.writeUInt32(q),x}static read(M,q){return new c(M,q)}get buffer(){return this.a}constructor(M,q){this.a=M,this.b=q}static sizeUInt8(){return 1}writeUInt8(M){this.a.writeUInt8(M,this.b),this.b+=1}readUInt8(){const M=this.a.readUInt8(this.b);return this.b+=1,M}writeUInt32(M){this.a.writeUInt32BE(M,this.b),this.b+=4}readUInt32(){const M=this.a.readUInt32BE(this.b);return this.b+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this.a.writeUInt8(M.byteLength,this.b),this.b+=1,this.a.set(M,this.b),this.b+=M.byteLength}readShortString(){const M=this.a.readUInt8(this.b);this.b+=1;const J=this.a.slice(this.b,this.b+M).toString();return this.b+=M,J}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readLongString(){const M=this.a.readUInt32BE(this.b);this.b+=4;const J=this.a.slice(this.b,this.b+M).toString();return this.b+=M,J}writeBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readVSBuffer(){const M=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+M);return this.b+=M,q}static sizeMixedArray(M){let q=0;q+=1;for(let J=0,x=M.length;J<x;J++){const R=M[J];switch(q+=1,R.type){case 1:q+=this.sizeLongString(R.value);break;case 2:q+=this.sizeVSBuffer(R.value);break;case 3:q+=this.sizeUInt32,q+=this.sizeLongString(R.value);for(let A=0;A<R.buffers.length;++A)q+=this.sizeVSBuffer(R.buffers[A]);break;case 4:break}}return q}writeMixedArray(M){this.a.writeUInt8(M.length,this.b),this.b+=1;for(let q=0,J=M.length;q<J;q++){const x=M[q];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let R=0;R<x.buffers.length;++R)this.writeBuffer(x.buffers[R]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this.a.readUInt8(this.b);this.b+=1;const q=new Array(M);for(let J=0;J<M;J++)switch(this.readUInt8()){case 1:q[J]=this.readLongString();break;case 2:q[J]=this.readVSBuffer();break;case 3:{const R=this.readUInt32(),A=this.readLongString(),F=[];for(let $=0;$<R;++$)F.push(this.readVSBuffer());q[J]=new N.SerializableObjectWithBuffers(l(A,F,null));break}case 4:q[J]=void 0;break}return q}}c.sizeUInt32=4;var u;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(u||(u={}));class n{static a(M){for(let q=0,J=M.length;q<J;q++)if(M[q]instanceof T.VSBuffer||M[q]instanceof N.SerializableObjectWithBuffers||typeof M[q]>"u")return!0;return!1}static serializeRequestArguments(M,q){if(this.a(M)){const J=[];for(let x=0,R=M.length;x<R;x++){const A=M[x];if(A instanceof T.VSBuffer)J[x]={type:2,value:A};else if(typeof A>"u")J[x]={type:4};else if(A instanceof N.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:$}=o(A.value,q);J[x]={type:3,value:T.VSBuffer.fromString(F),buffers:$}}else J[x]={type:1,value:T.VSBuffer.fromString(b(A,q))}}return{type:1,args:J}}return{type:0,args:b(M,q)}}static serializeRequest(M,q,J,x,R){switch(x.type){case 0:return this.b(M,q,J,x.args,R);case 1:return this.c(M,q,J,x.args,R)}}static b(M,q,J,x,R){const A=T.VSBuffer.fromString(J),F=T.VSBuffer.fromString(x);let $=0;$+=c.sizeUInt8(),$+=c.sizeShortString(A),$+=c.sizeLongString(F);const z=c.alloc(R?2:1,M,$);return z.writeUInt8(q),z.writeShortString(A),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(M){const q=M.readUInt8(),J=M.readShortString(),x=M.readLongString();return{rpcId:q,method:J,args:JSON.parse(x)}}static c(M,q,J,x,R){const A=T.VSBuffer.fromString(J);let F=0;F+=c.sizeUInt8(),F+=c.sizeShortString(A),F+=c.sizeMixedArray(x);const $=c.alloc(R?4:3,M,F);return $.writeUInt8(q),$.writeShortString(A),$.writeMixedArray(x),$.buffer}static deserializeRequestMixedArgs(M){const q=M.readUInt8(),J=M.readShortString(),x=M.readMixedArray(),R=new Array(x.length);for(let A=0,F=x.length;A<F;A++){const $=x[A];typeof $=="string"?R[A]=JSON.parse($):R[A]=$}return{rpcId:q,method:J,args:R}}static serializeAcknowledged(M){return c.alloc(5,M,0).buffer}static serializeCancel(M){return c.alloc(6,M,0).buffer}static serializeReplyOK(M,q,J){if(typeof q>"u")return this.d(M);if(q instanceof T.VSBuffer)return this.e(M,q);if(q instanceof N.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:R}=o(q.value,J,!0);return this.g(M,x,R)}else return this.f(M,m(q,J))}static d(M){return c.alloc(7,M,0).buffer}static e(M,q){let J=0;J+=c.sizeVSBuffer(q);const x=c.alloc(8,M,J);return x.writeVSBuffer(q),x.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static f(M,q){const J=T.VSBuffer.fromString(q);let x=0;x+=c.sizeLongString(J);const R=c.alloc(9,M,x);return R.writeLongString(J),R.buffer}static g(M,q,J){const x=T.VSBuffer.fromString(q);let R=0;R+=c.sizeUInt32,R+=c.sizeLongString(x);for(const F of J)R+=c.sizeVSBuffer(F);const A=c.alloc(10,M,R);A.writeUInt32(J.length),A.writeLongString(x);for(const F of J)A.writeBuffer(F);return A.buffer}static deserializeReplyOKJSON(M){const q=M.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(M,q){const J=M.readUInt32(),x=M.readLongString(),R=[];for(let A=0;A<J;++A)R.push(M.readVSBuffer());return new N.SerializableObjectWithBuffers(l(x,R,q))}static serializeReplyErr(M,q){const J=q?m(L.transformErrorForSerialization(q),null):void 0;if(typeof J!="string")return this.h(M);const x=T.VSBuffer.fromString(J);let R=0;R+=c.sizeLongString(x);const A=c.alloc(11,M,R);return A.writeLongString(x),A.buffer}static deserializeReplyErrError(M){const q=M.readLongString();return JSON.parse(q)}static h(M){return c.alloc(12,M,0).buffer}}var f;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var g;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(g||(g={}))}),define(Ie[232],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(L){const C=O=>{self.removeEventListener("message",C);const S=O.data;Object.defineProperties(self,{postMessage:{value(k,N){S.postMessage(k,N)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",C)}.toString();class T extends EventTarget{constructor(L,C,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${i})('${C}'))`,k=new Blob([S],{type:"application/javascript"}),N=URL.createObjectURL(k),D=new MessageChannel,m=N,v={type:"_newWorker",id:m,port:D.port2,url:N,options:O};L(v,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:m}),URL.revokeObjectURL(N),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(h){D.port1.onmessage=h}},onmessageerror:{get(){return D.port1.onmessageerror},set(h){D.port1.onmessageerror=h}}}),D.port1.addEventListener("messageerror",h=>{const t=new MessageEvent("messageerror",{data:h.data});this.dispatchEvent(t)}),D.port1.addEventListener("message",h=>{const t=new MessageEvent("message",{data:h.data});this.dispatchEvent(t)}),D.port1.start()}}e.NestedWorker=T}),define(Ie[233],Ce([1,0,5,30,41,3,36,11,14]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class N{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(h){this.a.has(h.id)||(this.a.set(h.id,h),this.b.fire(h.id))}getChannels(){const h=[];return this.a.forEach(t=>h.push(t)),h}getChannel(h){return this.a.get(h)}removeChannel(h){this.a.delete(h),this.c.fire(h)}}T.Registry.add(e.Extensions.OutputChannels,new N);function D(v,h,t,o,l){return(0,S.createCancelablePromise)(async b=>{await(0,C.whenProviderRegistered)(t,o);const E=T.Registry.as(e.Extensions.OutputChannels);try{await m(t,1,o,l,b),E.registerChannel({id:v,label:h,file:t,log:!0})}catch(p){(0,O.isCancellationError)(p)||l.error("Error while registering log channel",t.toString(),(0,O.getErrorMessage)(p))}})}e.registerLogChannel=D;async function m(v,h,t,o,l){if(!await t.exists(v)){if(l.isCancellationRequested)throw new O.CancellationError;if(h>10)throw new Error("Timed out while waiting for file to be created");o.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",v.toString()),await(0,S.timeout)(1e3,l),await m(v,h+1,t,o,l)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(Ie[102],Ce([1,0,4,3,15,26,12,233,57,27,37,116,24,9,36,5,7]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(w,s,r,a,d){super(),this.id=w,this.name=s,this.m=r,this.n=a,this.extension=d,this.k=0,this.l=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Clear,w)}replace(w){const s=this.k;this.info(w),this.n.$update(this.id,O.OutputChannelUpdateMode.Replace,s),this.visible&&this.m.flush()}show(w,s){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:s))}hide(){this.n.$close(this.id)}g(w,s){this.k+=m.VSBuffer.fromString(s).byteLength,(0,C.log)(this.m,w,s),this.visible&&(this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class b extends l{appendLine(w){this.append(w)}}let E=class{constructor(w,s,r,a,d,c){this.i=s,this.j=r,this.k=a,this.l=d,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[s,r]of this.g)r.visible=s===this.h}createOutputChannel(w,s,r){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const a=typeof s=="object"&&s.log,d=(0,v.isString)(s)?s:void 0;if((0,v.isString)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const u=this.i.environment.extensionLogLevel?.find(([f])=>L.ExtensionIdentifier.equals(r.identifier,f))?.[1];u&&(c=(0,C.parseLogLevel)(u));const n=a?this.o(w,c,r):this.n(w,d,r);return n.then(f=>{this.g.set(f.id,f),f.visible=f.id===this.h}),a?this.r(w,c??this.m.getLevel(),n):this.q(w,n)}async n(w,s,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(d,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.a.$register(w,d,!1,s,r.identifier.value);return new l(u,w,c,this.a,r)}async o(w,s,r){const a=await this.p(r),d=this.k.extUri.joinPath(a,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(d,{name:w},s),u=await this.a.$register(w,d,!0,void 0,r.identifier.value);return new b(u,w,c,this.a,r)}p(w){let s=this.d.get(w.identifier.value);if(!s){const r=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(r)}catch(a){if((0,h.toFileSystemProviderErrorCode)(a)!==h.FileSystemProviderErrorCode.FileExists)throw a}return r})())}return s}q(w,s){let r=!1;const a=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return w},append(d){a(),s.then(c=>c.append(d))},appendLine(d){a(),s.then(c=>c.appendLine(d))},clear(){a(),s.then(d=>d.clear())},replace(d){a(),s.then(c=>c.replace(d))},show(d,c){a(),s.then(u=>u.show(d,c))},hide(){a(),s.then(d=>d.hide())},dispose(){r=!0,s.then(d=>d.dispose())}}}r(w,s,r){const a=new o.DisposableStore,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},c=a.add(new t.Emitter);return r.then(u=>{a.add(u),a.add(u.onDidChangeLogLevel(n=>{s=n,c.fire(n)}))}),{...this.q(w,r),get logLevel(){return s},onDidChangeLogLevel:c.event,trace(u,...n){d(),r.then(f=>f.trace(u,...n))},debug(u,...n){d(),r.then(f=>f.debug(u,...n))},info(u,...n){d(),r.then(f=>f.info(u,...n))},warn(u,...n){d(),r.then(f=>f.warn(u,...n))},error(u,...n){d(),r.then(f=>f.error(u,...n))},dispose(){a.dispose()}}}};E=qe([Ve(0,y.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,S.IExtHostConsumerFileSystem),Ve(3,N.IExtHostFileSystemInfo),Ve(4,C.ILoggerService),Ve(5,C.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(Ie[234],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(Ie[235],Ce([1,0,39,13,19,21,22,2,3,165,50,180,234]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let v=class rn{constructor(t,o,l,b){this.d=t,this.e=o,this.f=l,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,o,l){return typeof o=="string"||typeof o>"u"?this.a.then(b=>this.h(t,b,o)):this.h(t,o,l)}h(t,o,l){return t.scheme===T.Schemas.file||t.scheme===T.Schemas.vscodeRemote?(0,i.isValidBasename)(l??(0,C.basename)(t),o===1):!0}get defaultUriScheme(){return rn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,o){if(t.remoteAuthority)return T.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(l)return l;const b=o.getWorkspace().folders[0];if(b)return b.uri.scheme;const E=o.getWorkspace().configuration;return E?E.scheme:T.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?y.win32:y.posix)}async fileURI(t){let o="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const b=t.indexOf("/",2);b===-1?(o=t.substring(2),t="/"):(o=t.substring(2,b),t=t.substring(b)||"/")}return O.URI.from({scheme:T.Schemas.file,authority:o,path:t,query:"",fragment:""})}};v=qe([Ve(1,m.IRemoteAgentService),Ve(2,D.IWorkbenchEnvironmentService),Ve(3,N.IWorkspaceContextService)],v),e.AbstractPathService=v}),define(Ie[103],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(C,O){this.line=C,this.character=O}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,O){return new i(0,0)}with(C){return new i(0,0)}}e.Position=i;class T{constructor(C,O,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(C,O),this.end=new i(S,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new T(0,0,0,0)}with(C){return new T(0,0,0,0)}}e.Range=T;var y;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[44],Ce([1,0,16,35,23,39,10,3,19,11,103,14]),function(ee,e,i,T,y,L,C,O,S,k,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",v=" characters skipped \u27EB",h=(m.length+v.length+5)*2;e.ISearchService=(0,O.createDecorator)("searchService");var t;(function(ce){ce[ce.file=0]="file",ce[ce.text=1]="text"})(t=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(ce){ce[ce.File=1]="File",ce[ce.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function l(ce){return!!ce.preview}e.resultIsMatch=l;function b(ce){return!!ce.resource}e.isFileMatch=b;function E(ce){return!!ce.message}e.isProgressMessage=E;var p;(function(ce){ce[ce.Normal=0]="Normal",ce[ce.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(re){this.resource=re,this.results=[]}}e.FileMatch=w;class s{constructor(re,se,le){this.ranges=se;const _=Array.isArray(se)?se:[se];if(le&&le.matchLines===1&&r(_)){re=(0,C.getNLines)(re,le.matchLines);let me="",we=0,Ne=0;const We=Math.floor(le.charsPerLine/5),Qe=[];for(const Te of _){const De=Math.max(Te.startColumn-We,0),ke=Te.startColumn+le.charsPerLine;if(De>Ne+We+h){const oe=m+(De-Ne)+v;me+=oe+re.slice(De,ke),we+=De-(Ne+oe.length)}else me+=re.slice(Ne,ke);Qe.push(new d(0,Te.startColumn-we,Te.endColumn-we)),Ne=ke}this.preview={text:me,matches:Array.isArray(this.ranges)?Qe:Qe[0]}}else{const me=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:re,matches:(0,i.mapArrayOrNot)(se,we=>new a(we.startLineNumber-me,we.startColumn,we.endLineNumber-me,we.endColumn))}}}}e.TextSearchMatch=s;function r(ce){const re=ce[0].startLineNumber;for(const se of ce)if(se.startLineNumber!==re||se.endLineNumber!==re)return!1;return!0}class a{constructor(re,se,le,_){this.startLineNumber=re,this.startColumn=se,this.endLineNumber=le,this.endColumn=_}}e.SearchRange=a;class d extends a{constructor(re,se,le){super(re,se,re,le)}}e.OneLineRange=d;var c;(function(ce){ce.List="list",ce.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var u;(function(ce){ce.Default="default",ce.FileNames="fileNames",ce.Type="type",ce.Modified="modified",ce.CountDescending="countDescending",ce.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function n(ce,re=!0){const se=ce&&ce.files&&ce.files.exclude,le=re&&ce&&ce.search&&ce.search.exclude;if(!se&&!le)return;if(!se||!le)return se||le;let _=Object.create(null);return _=y.mixin(_,y.deepClone(se)),_=y.mixin(_,y.deepClone(le),!0),_}e.getExcludes=n;function f(ce,re){return ce.excludePattern&&T.match(ce.excludePattern,re)?!1:ce.includePattern||ce.usingSearchPaths?ce.includePattern&&T.match(ce.includePattern,re)?!0:ce.usingSearchPaths?!!ce.folderQueries&&ce.folderQueries.some(se=>{const le=se.folder.fsPath;if(L.isEqualOrParent(re,le)){const _=S.relative(le,re);return!se.includePattern||!!T.match(se.includePattern,_)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var g;(function(ce){ce[ce.unknownEncoding=1]="unknownEncoding",ce[ce.regexParseError=2]="regexParseError",ce[ce.globParseError=3]="globParseError",ce[ce.invalidLiteral=4]="invalidLiteral",ce[ce.rgProcessError=5]="rgProcessError",ce[ce.other=6]="other",ce[ce.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(re,se){super(re),this.code=se}}e.SearchError=P;function M(ce){const re=ce.message;if((0,k.isCancellationError)(ce))return new P(re,g.canceled);try{const se=JSON.parse(re);return new P(se.message,se.code)}catch{return new P(re,g.other)}}e.deserializeSearchError=M;function q(ce){const re={message:ce.message,code:ce.code};return new Error(JSON.stringify(re))}e.serializeSearchError=q;function J(ce){return ce.type==="error"?!0:ce.type==="success"}e.isSerializedSearchComplete=J;function x(ce){return ce.type==="success"}e.isSerializedSearchSuccess=x;function R(ce){return!!ce.path}e.isSerializedFileMatch=R;function A(ce,re){const se=ce.searchPath?ce.searchPath:ce.relativePath;return(0,C.fuzzyContains)(se,re)}e.isFilePatternMatch=A;class F{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function $(ce,re){const se={...ce||{},...re||{}};return Object.keys(se).filter(le=>{const _=se[le];return typeof _=="boolean"&&_})}e.resolvePatternsForProvider=$;class z{constructor(re,se){this.c=null,this.a={...re.excludePattern||{},...se.excludePattern||{}},this.b=T.parse(this.a);let le=re.includePattern;se.includePattern&&(le?le={...le,...se.includePattern}:le=se.includePattern),le&&(this.c=T.parse(le))}matchesExcludesSync(re,se,le){return!!(this.b&&this.b(re,se,le))}includedInQuerySync(re,se,le){return!(this.b&&this.b(re,se,le)||this.c&&!this.c(re,se,le))}includedInQuery(re,se,le){const _=this.b(re,se,le),me=()=>this.c?!!this.c(re,se,le):!0;return(0,D.isThenable)(_)?_.then(we=>we?!1:me()):me()}hasSiblingExcludeClauses(){return V(this.a)}}e.QueryGlobTester=z;function V(ce){for(const re in ce)if(typeof ce[re]!="boolean")return!0;return!1}function K(ce){if(!ce)return;let re;return se=>(re||(re=(ce()||Promise.resolve([])).then(le=>le?ge(le):{})),re.then(le=>!!le[se]))}e.hasSiblingPromiseFn=K;function ie(ce){if(!ce)return;let re;return se=>{if(!re){const le=ce();re=le?ge(le):{}}return!!re[se]}}e.hasSiblingFn=ie;function ge(ce){const re={};for(const se of ce)re[se]=!0;return re}}),define(Ie[31],Ce([1,0,16,14,20,5,7,46,13,110,22,10,9,2,139,3,12,154,50,37,27,15,8,6,52,44,4]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E,p,w,s,r,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(x,R,A){return new N.ExtUri(F=>P(F,A)).isEqual(x,R)}function n(x,R,A){return u(x.uri,R.uri,A)?0:(0,D.compare)(x.uri.toString(),R.uri.toString())}function f(x,R,A){return x.index!==R.index?x.index<R.index?-1:1:u(x.uri,R.uri,A)?(0,D.compare)(x.name,R.name):(0,D.compare)(x.uri.toString(),R.uri.toString())}function g(x,R,A,F){const $=x.slice(0).sort((V,K)=>A(V,K,F)),z=R.slice(0).sort((V,K)=>A(V,K,F));return(0,i.delta)($,z,(V,K)=>A(V,K,F))}function P(x,R){const A=R.getCapabilities(x.scheme);return!(A&&A&1024)}class M extends b.Workspace{static toExtHostWorkspace(R,A,F,$){if(!R)return{workspace:null,added:[],removed:[]};const{id:z,name:V,folders:K,configuration:ie,transient:ge,isUntitled:ce}=R,re=[],se=A;A?K.forEach((we,Ne)=>{const We=v.URI.revive(we.uri),Qe=M.e(F||A,We,$);Qe?(Qe.name=we.name,Qe.index=we.index,re.push(Qe)):re.push({uri:We,name:we.name,index:Ne})}):re.push(...K.map(({uri:we,name:Ne,index:We})=>({uri:v.URI.revive(we),name:Ne,index:We}))),re.sort((we,Ne)=>we.index<Ne.index?-1:1);const le=new M(z,V,re,!!ge,ie?v.URI.revive(ie):null,!!ce,we=>P(we,$)),{added:_,removed:me}=g(se?se.workspaceFolders:[],le.workspaceFolders,n,$);return{workspace:le,added:_,removed:me}}static e(R,A,F){for(let $=0;$<R.folders.length;$++){const z=R.workspaceFolders[$];if(u(z.uri,A,F))return z}}constructor(R,A,F,$,z,V,K){super(R,F.map(ie=>new b.WorkspaceFolder(ie)),$,z,K),this.s=A,this.t=V,this.o=[],this.q=O.TernarySearchTree.forUris(K),F.forEach(ie=>{this.o.push(ie),this.q.set(ie.uri,ie)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(R,A){return A&&this.q.get(R)&&(R=(0,N.dirname)(R)),this.q.findSubstr(R)}resolveWorkspaceFolder(R){return this.q.get(R)}}let q=class{constructor(R,A,F,$,z){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new L.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=$,this.q=F,this.s=z,this.h=new k.Counter,this.j=new T.Barrier,this.n=R.getProxy(c.MainContext.MainThreadWorkspace),this.o=R.getProxy(c.MainContext.MainThreadMessageService);const V=A.workspace;this.k=V?new M(V.id,V.name,[],!!V.transient,V.configuration?v.URI.revive(V.configuration):null,!!V.isUntitled,K=>P(K,F)):void 0}$initializeWorkspace(R,A){this.u=A,this.$acceptWorkspaceData(R),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?v.URI.from({scheme:S.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(R,A,F,...$){const z=[];if(Array.isArray($)&&$.forEach(ce=>{v.URI.isUri(ce.uri)&&!z.some(re=>u(re.uri,ce.uri,this.q))&&z.push({uri:ce.uri,name:ce.name||(0,N.basenameOrAuthority)(ce.uri)})}),this.l||[A,F].some(ce=>typeof ce!="number"||ce<0)||F===0&&z.length===0)return!1;const V=this.w?this.w.workspaceFolders:[];if(A+F>V.length)return!1;const K=V.slice(0);K.splice(A,F,...z.map(ce=>({uri:ce.uri,name:ce.name||(0,N.basenameOrAuthority)(ce.uri),index:void 0})));for(let ce=0;ce<K.length;ce++){const re=K[ce];if(K.some((se,le)=>le!==ce&&u(re.uri,se.uri,this.q)))return!1}K.forEach((ce,re)=>ce.index=re);const{added:ie,removed:ge}=g(V,K,f,this.q);if(ie.length===0&&ge.length===0)return!1;if(this.n){const ce=R.displayName||R.name;this.n.$updateWorkspaceFolders(ce,A,F,z).then(void 0,re=>{this.l=void 0;const se={source:{identifier:R.identifier,label:R.displayName||R.name}};this.o.$showMessage(l.Severity.Error,(0,h.localize)(0,null,ce,re.toString()),se,[])})}return this.x(K),!0}getWorkspaceFolder(R,A){if(!!this.w)return this.w.getWorkspaceFolder(R,A)}async getWorkspaceFolder2(R,A){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(R,A)}async resolveWorkspaceFolder(R){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(R)}getPath(){if(!this.w)return;const{folders:R}=this.w;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,A){let F,$="";if(typeof R=="string"?(F=v.URI.file(R),$=R):typeof R<"u"&&(F=R,$=R.fsPath),!F)return $;const z=this.getWorkspaceFolder(F,!0);if(!z)return $;typeof A>"u"&&this.w&&(A=this.w.folders.length>1);let V=(0,N.relativePath)(z.uri,F);return A&&z.name&&(V=`${z.name}/${V}`),V}x(R){this.w&&(this.l=M.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:R,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:A,added:F,removed:$}=M.toExtHostWorkspace(R,this.k,this.l,this.q);this.k=A||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:$}))}findFiles(R,A,F,$,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let V;if(A===null?V=!1:A&&(typeof A=="string"?V=A:V=A.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:ie}=J(s.GlobPattern.from(R));return this.n.$startFileSearch((0,m.withUndefinedAsNull)(K),(0,m.withUndefinedAsNull)(ie),(0,m.withUndefinedAsNull)(V),(0,m.withUndefinedAsNull)(F),z).then(ge=>Array.isArray(ge)?ge.map(ce=>v.URI.revive(ce)):[])}async findTextInFiles(R,A,F,$,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const V=this.h.getNext(),K=typeof A.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:ie,folder:ge}=J(s.GlobPattern.from(A.include)),ce=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,re={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:K,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:ie,excludePattern:ce},se=!1;if(this.t[V]=le=>{if(se)return;const _=v.URI.revive(le.resource);le.results.forEach(me=>{(0,d.resultIsMatch)(me)?F({uri:_,preview:{text:me.preview.text,matches:(0,i.mapArrayOrNot)(me.preview.matches,we=>new r.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,i.mapArrayOrNot)(me.ranges,we=>new r.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):F({uri:_,text:me.text,lineNumber:me.lineNumber})})},z.isCancellationRequested)return{};try{const le=await this.n.$startTextSearch(R,(0,m.withUndefinedAsNull)(ge),re,V,z);return delete this.t[V],le||{}}catch(le){throw delete this.t[V],le}}$handleTextSearchResult(R,A){this.t[A]?.(R)}saveAll(R){return this.n.$saveAll(R)}resolveProxy(R){return this.n.$resolveProxy(R)}get trusted(){return this.u}requestWorkspaceTrust(R){return this.n.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(R,A){if(this.v.has(R))throw new Error(`A provider has already been registered for scheme ${R}`);this.v.set(R,A);const F=this.s.transformOutgoingScheme(R),$=this.y++;return this.n.$registerEditSessionIdentityProvider($,F),(0,C.toDisposable)(()=>{this.v.delete(R),this.n.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(R,A){this.g.info("Getting edit session identifier for workspaceFolder",R);const F=await this.resolveWorkspaceFolder(v.URI.revive(R));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const $=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!$),!$)return;const z=await $.provideEditSessionIdentity(F,A);if(this.g.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(R,A,F,$){this.g.info("Getting edit session identifier for workspaceFolder",R);const z=await this.resolveWorkspaceFolder(v.URI.revive(R));if(!z){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const V=this.v.get(z.uri.scheme);if(this.g.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!V),!V)return;const K=await V.provideEditSessionIdentityMatch?.(A,F,$);if(this.g.info("Provider returned edit session identifier match result: ",K),!!K)return K}};q=qe([Ve(0,w.IExtHostRpcService),Ve(1,p.IExtHostInitDataService),Ve(2,E.IExtHostFileSystemInfo),Ve(3,o.ILogService),Ve(4,a.IURITransformerService)],q),e.ExtHostWorkspace=q,e.IExtHostWorkspace=(0,t.createDecorator)("IExtHostWorkspace");function J(x){let R,A;return x&&(typeof x=="string"?R=x:(R=x.pattern,A=v.URI.revive(x.baseUri))),{includePattern:R,folder:A}}}),define(Ie[32],Ce([1,0,23,5,31,4,6,157,89,9,14,3,15,12,2]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function t(r,a){if(a){const d=a.split(".");let c=r;for(let u=0;c&&u<d.length;u++)c=c[d[u]];return c}}function o(r){return r instanceof h.URI}function l(r){return r&&r.uri instanceof h.URI&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&r.uri instanceof h.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function p(r){if(o(r))return{resource:r};if(l(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(b(r))return{overrideIdentifier:r.languageId};if(E(r))return{resource:r.uri};if(r===null)return{resource:null}}let w=class{constructor(a,d,c){this.a=a.getProxy(L.MainContext.MainThreadConfiguration),this.c=d,this.b=c,this.d=new N.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new s(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,d))}};w=qe([Ve(0,m.IExtHostRpcService),Ve(1,y.IExtHostWorkspace),Ve(2,v.ILogService)],w),e.ExtHostConfiguration=w;class s{constructor(a,d,c,u){this.a=new T.Emitter,this.b=a,this.f=u,this.c=d,this.e=O.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=O.Configuration.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,c))}getConfiguration(a,d,c){const u=p(d)||{},n=this.g(a?t(this.e.getValue(void 0,u,this.c.workspace),a):this.e.getValue(void 0,u,this.c.workspace));a&&this.h(a,u,c?.identifier);function f(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(P){return typeof t(n,P)<"u"},get:(P,M)=>{this.h(a?`${a}.${P}`:P,u,c?.identifier);let q=t(n,P);if(typeof q>"u")q=M;else{let J;const x=(R,A)=>{let F;const $=()=>{J=J||(0,i.deepClone)(n),F=F||t(J,A)};return(0,k.isObject)(R)?new Proxy(R,{get:(z,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return $(),()=>F;if(J)return F=F||t(J,A),F[V];const K=z[V];return typeof V=="string"?x(K,`${A}.${V}`):K},set:(z,V,K)=>($(),F&&(F[V]=K),!0),deleteProperty:(z,V)=>($(),F&&delete F[V],!0),defineProperty:(z,V,K)=>($(),F&&Object.defineProperty(F,V,K),!0)}):R};q=x(q,P)}return q},update:(P,M,q,J)=>{P=a?`${a}.${P}`:P;const x=f(q);return M!==void 0?this.b.$updateConfigurationOption(x,P,M,u,J):this.b.$removeConfigurationOption(x,P,u,J)},inspect:P=>{P=a?`${a}.${P}`:P;const M=this.e.inspect(P,u,this.c.workspace);if(M)return{key:P,defaultValue:(0,i.deepClone)(M.policy?.value??M.default?.value),globalValue:(0,i.deepClone)(M.user?.value??M.application?.value),workspaceValue:(0,i.deepClone)(M.workspace?.value),workspaceFolderValue:(0,i.deepClone)(M.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(M.default?.override),globalLanguageValue:(0,i.deepClone)(M.user?.override??M.application?.override),workspaceLanguageValue:(0,i.deepClone)(M.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(M.workspaceFolder?.override),languageIds:(0,i.deepClone)(M.overrideIdentifiers)}}};return typeof n=="object"&&(0,i.mixin)(g,n,!1),Object.freeze(g)}g(a){const d=c=>(0,k.isObject)(c)?new Proxy(c,{get:(u,n)=>d(u[n]),set:(u,n,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(u,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(u,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return d(a)}h(a,d,c){const u=S.OVERRIDE_PROPERTY_REGEX.test(a)?4:this.d.get(a),n=c?`[${c.value}] `:"";if(u===4){typeof d?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){d?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const c=new O.ConfigurationChangeEvent(a,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,n)=>c.affectsConfiguration(u,p(n))})}k(a){return a.reduce((d,c)=>(d.set(c[0],c[1]),d),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[104],Ce([1,0,2,14,5,4,6,31,55,32,20,58,15,27,3,13,21,12,72,193,11]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E,p){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(R){function A($){if($!=null)return $}R.from=A;function F($){if($!=null)return $}R.to=F})(s||(s={}));var r;(function(R){function A($){if($!=null)return $}R.from=A;function F($){if($!=null)return $}R.to=F})(r||(r={}));var a;(function(R){function A($){if($!=null)return $}R.from=A;function F($){if($!=null)return $}R.to=F})(a||(a={}));var d;(function(R){function A(z){if(z){const V=z;return V&&!!V.process}else return!1}R.is=A;function F(z){if(z==null)return;const V={process:z.process,args:z.args};return z.options&&(V.options=a.from(z.options)),V}R.from=F;function $(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}R.to=$})(d||(d={}));var c;(function(R){function A($){if($!=null)return $}R.from=A;function F($){if($!=null)return $}R.to=F})(c||(c={}));var u;(function(R){function A(z){if(z){const V=z;return V&&(!!V.commandLine||!!V.command)}else return!1}R.is=A;function F(z){if(z==null)return;const V={};return z.commandLine!==void 0?V.commandLine=z.commandLine:(V.command=z.command,V.args=z.args),z.options&&(V.options=c.from(z.options)),V}R.from=F;function $(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}R.to=$})(u||(u={}));var n;(function(R){function A(z){if(z){const V=z;return V&&V.customExecution==="customExecution"}else return!1}R.is=A;function F(z){return{customExecution:"customExecution"}}R.from=F;function $(z,V){return V.get(z)}R.to=$})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function(R){function A(F,$){let z;return F.scope!==void 0&&typeof F.scope!="number"?z=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===C.TaskScope.Workspace&&$&&$.workspaceFile?z=$.workspaceFile:z=E.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:z}}R.from=A})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(R){function A(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}R.from=A})(g||(g={}));var P;(function(R){function A(z,V){if(z==null)return[];const K=[];for(const ie of z){const ge=F(ie,V);ge&&K.push(ge)}return K}R.fromMany=A;function F(z,V){if(z==null)return;let K;z.execution instanceof C.ProcessExecution?K=d.from(z.execution):z.execution instanceof C.ShellExecution?K=u.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(K=n.from(z.execution));const ie=s.from(z.definition);let ge;return z.scope?typeof z.scope=="number"?ge=z.scope:ge=z.scope.uri:ge=C.TaskScope.Workspace,!ie||!ge?void 0:{_id:z._id,definition:ie,name:z.name,source:{extensionId:V.identifier.value,label:z.source,scope:ge},execution:K,isBackground:z.isBackground,group:g.from(z.group),presentationOptions:r.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}R.from=F;async function $(z,V,K){if(z==null)return;let ie;d.is(z.execution)?ie=d.to(z.execution):u.is(z.execution)?ie=u.to(z.execution):n.is(z.execution)&&(ie=n.to(z._id,K));const ge=s.to(z.definition);let ce;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ce=z.source.scope:ce=await V.resolveWorkspaceFolder(i.URI.revive(z.source.scope)):ce=C.TaskScope.Workspace),!ge||!ce)return;const re=new C.Task(ge,ce,z.name,z.source.label,ie,z.problemMatchers);return z.isBackground!==void 0&&(re.isBackground=z.isBackground),z.group!==void 0&&(re.group=C.TaskGroup.from(z.group._id),re.group&&z.group.isDefault&&(re.group=new C.TaskGroup(re.group.id,re.group.label),z.group.isDefault===!0&&(re.group.isDefault=z.group.isDefault))),z.presentationOptions&&(re.presentationOptions=r.to(z.presentationOptions)),z._id&&(re._id=z._id),z.detail&&(re.detail=z.detail),re}R.to=$})(P=e.TaskDTO||(e.TaskDTO={}));var M;(function(R){function A($){return $}R.from=A;function F($){if(!!$)return Object.assign(Object.create(null),$)}R.to=F})(M||(M={}));class q{constructor(A,F,$){this._id=F,this.a=$,w.set(this,void 0),Ye(this,w,A,"f")}get task(){return this.a}terminate(){Re(this,w,"f").terminateTask(this)}fireDidStartProcess(A){}fireDidEndProcess(A){}}w=new WeakMap;let J=class{constructor(A,F,$,z,V,K,ie,ge){this.q=new y.Emitter,this.r=new y.Emitter,this.s=new y.Emitter,this.t=new y.Emitter,this.a=A.getProxy(L.MainContext.MainThreadTask),this.b=$,this.c=z,this.d=V,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=ge,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(A,F,$){if(!$)return new C.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:F,provider:$,extension:A}),this.a.$registerTaskProvider(z,F),new C.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(A,F){this.a.$registerTaskSystem(A,F)}fetchTasks(A){return this.a.$fetchTasks(M.from(A)).then(async F=>{const $=[];for(const z of F){const V=await P.to(z,this.b,this.m);V&&$.push(V)}return $})}get taskExecutions(){const A=[];return this.k.forEach(F=>A.push(F)),A}terminateTask(A){if(!(A instanceof q))throw new Error("No valid task execution provided");return this.a.$terminateTask(A._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(A,F,$){const z=this.m.get(A.id);z&&(this.o.set(A.id,z),this.e.attachPtyToTerminal(F,await z.callback($))),this.p=A.id,this.q.fire({execution:await this.y(A)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(A){const F=await this.y(A);this.l.delete(A.id),this.k.delete(A.id),this.A(A),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(A){const F=await this.y(A.id);this.s.fire({execution:F,processId:A.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(A){const F=await this.y(A.id);this.t.fire({execution:F,exitCode:A.exitCode})}$provideTasks(A,F){const $=this.j.get(A);if(!$)return Promise.reject(new Error("no handler found"));const z=[],V=(0,T.asPromise)(()=>$.provider.provideTasks(N.CancellationToken.None)).then(K=>this.u(F,z,$,K));return new Promise(K=>{V.then(ie=>{Promise.all(z).then(()=>{K(ie)})})})}async $resolveTask(A,F){const $=this.j.get(A);if(!$)return Promise.reject(new Error("no handler found"));if(F.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${$.type}].`);const z=await P.to(F,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const V=await $.provider.resolveTask(z,N.CancellationToken.None);if(!V)return;this.z(V,$);const K=P.from(V,$.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(K.execution)&&await this.x(K,V,!0),await this.v(K)}w(){return this.h++}async x(A,F,$){const z=await this.a.$createTaskId(A);!$&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,F.execution)),this.m.set(z,F.execution)}async y(A,F){if(typeof A=="string"){const V=this.l.get(A);if(!V)throw new p.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const $=this.l.get(A.id);if($)return $;const z=new Promise((V,K)=>{function ie(ge,ce,re){re?V(new q(ge,ce.id,re)):K("Unexpected: Task does not exist.")}F?ie(this,A,F):P.to(A.task,this.b,this.m).then(ge=>ie(this,A,ge))});return this.l.set(A.id,z),z.then(V=>(this.k.set(A.id,V),V),V=>Promise.reject(V))}z(A,F){A._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(A){this.o.get(A.id)&&this.o.delete(A.id),this.n.has(A.id)&&this.p!==A.id&&(this.m.delete(A.id),this.n.delete(A.id));const $=this.n.values();let z=$.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=$.next()}};J=qe([Ve(0,m.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,O.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,b.IExtHostApiDeprecationService)],J),e.ExtHostTaskBase=J;let x=class extends J{constructor(A,F,$,z,V,K,ie,ge){super(A,F,$,z,V,K,ie,ge),this.registerTaskSystem(t.Schemas.vscodeRemote,{scheme:t.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(A,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const $=P.from(F,A);if($===void 0)throw new Error("Task is not valid");if(n.is($.execution))await this.x($,F,!1);else throw new p.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution($),F);return this.a.$executeTask($).catch(V=>{throw new Error(V)}),z}u(A,F,$,z){const V=[];if(z)for(const K of z){this.z(K,$),(!K.definition||!A[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=P.from(K,$.extension);ie&&n.is(ie.execution)?(V.push(ie),F.push(this.x(ie,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:$.extension}}async v(A){if(n.is(A.execution))return A;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(A,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(A,F,$){}};x=qe([Ve(0,m.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,O.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,b.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(Ie[236],Ce([1,0,19,20,45,35,22,99,44]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(m,v,h){this.k=m,this.l=v,this.o=h,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&L.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&L.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const v=this.k.folderQueries||[];return new Promise((h,t)=>{const o=l=>{this.f++,m(l)};if(this.g)return h({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const b=l.toString(),E=i.basename(b);this.j&&this.j(b,E)||this.v(o,{base:l,basename:E})}),Promise.all(v.map(l=>this.p(l,o))).then(l=>{h({limitHit:this.e,stats:l[0]||void 0})},l=>{t(new Error((0,y.toErrorMessage)(l)))})})}async p(m,v){const h=new T.CancellationTokenSource,t=this.q(m),o=this.r(),l=new S.QueryGlobTester(this.k,m),b=!l.hasSiblingExcludeClauses();let E;try{this.h.add(h),E=O.StopWatch.create();const p=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},t,h.token),w=E.elapsed(),s=O.StopWatch.create();return this.g&&!this.e||(p&&p.forEach(r=>{const a=i.posix.relative(m.folder.path,r.path);if(b){const d=i.basename(r.path);this.v(v,{base:m.folder,relativePath:a,basename:d});return}this.s(o,m.folder,a,v)}),this.g&&!this.e)?null:(this.u(o,l,v),{providerTime:w,postProcessTime:s.elapsed()})}finally{h.dispose(),this.h.delete(h)}}q(m){const v=(0,S.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),h=(0,S.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:h,includes:v,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},v,h,t){if(h===this.a){const l=i.basename(this.a);this.v(t,{base:v,relativePath:this.a,basename:l})}function o(l){const b=i.basename(l),E=i.dirname(l);let p=m[E];p||(p=m[E]=[],o(E)),p.push({base:v,relativePath:l,basename:b})}o(h)}u({rootEntries:m,pathToEntries:v},h,t){const o=this,l=this.a;function b(E){const p=(0,S.hasSiblingFn)(()=>E.map(w=>w.basename));for(let w=0,s=E.length;w<s;w++){const r=E[w],{relativePath:a,basename:d}=r;if(h.matchesExcludesSync(a,d,l!==d?p:void 0))continue;const c=v[a];if(c)b(c);else{if(a===l)continue;o.v(t,r)}if(o.e)break}}b(m)}v(m,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(v))}}class N{constructor(){this.b=new Map}fileSearch(m,v,h,t){const o=this.c(m.cacheKey),l=new k(m,v,o&&o.token);let b=0;const E=p=>{b+=p.length,h(p.map(w=>this.d(w)))};return this.e(l,N.a,E,t).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:p.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(!!m)return this.b.has(m)||this.b.set(m,new T.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:C.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,v,h,t){t.onCancellationRequested(()=>{m.cancel()});const o=b=>{b&&(l.push(b),v>0&&l.length>=v&&(h(l),l=[]))};let l=[];return m.search(o).then(b=>(l.length&&h(l),b),b=>(l.length&&h(l),Promise.reject(b)))}}e.FileSearchManager=N,N.a=512}),define(Ie[237],Ce([1,0,16,78,35,82,28,13,19,22,10,9,2,253,147,40,12,50,94,235,44]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(g,P,M,q,J){this.a=g,this.b=P,this.c=M,this.d=q,this.e=J}text(g,P,M={}){g=this.f(g,M);const q=this.a.getValue(),J=P&&P.some(R=>!this.a.getValue({resource:R}).search.useRipgrep);return{...this.h(P?.map(l.toWorkspaceFolder),M),type:2,contentPattern:g,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:q.search.usePCRE2||J||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}f(g,P){const M=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const q={...g,wordSeparators:M.editor.wordSeparators};return this.j(g,P)&&(q.isCaseSensitive=!0),this.k(g)&&(q.isMultiline=!0),q}file(g,P={}){return{...this.h(g,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}g(g,P){return g?(g=Array.isArray(g)?g.map(c):c(g),P?this.parseSearchPaths(g):{pattern:r(...Array.isArray(g)?g:[g])}):{}}h(g=[],P={}){const M=this.g(P.includePattern,P.expandPatterns),q=this.g(P.excludePattern,P.expandPatterns),J=g.length>1,x=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(F=>this.q(F,P,q)):g.map(F=>this.r(F,P,q,J))).filter(F=>!!F),R={_reason:P._reason,folderQueries:x,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:q.pattern,includePattern:M.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const F=i.coalesce(i.flatten(this.c.groups.map(V=>V.editors.map(K=>K.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const $=F.filter(V=>(0,p.pathIncludedInQuery)(R,V.fsPath)),z=this.i($);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...R,...z}}const A=P.extraFileResources&&P.extraFileResources.filter(F=>(0,p.pathIncludedInQuery)(R,F.fsPath));return R.extraFileResources=A&&A.length?A:void 0,R}i(g){const P=[],M=new C.ResourceMap,q={};let J=!1;return g.forEach(x=>{if(x.scheme===O.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(x)){const A=this.b.getWorkspaceFolder(x)?.uri??x.with({path:S.dirname(x.fsPath)});let F=M.get(A);F||(J=!0,F={folder:A,includePattern:{}},P.push(F),M.set(A,F));const $=S.relative(A.fsPath,x.fsPath);(0,D.assertIsDefined)(F.includePattern)[$.replace(/\\/g,"/")]=!0}else x.fsPath&&(J=!0,q[x.fsPath]=!0)}),{folderQueries:P,includePattern:q,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}j(g,P){if(P.isSmartCase){if(g.isRegExp){if(N.containsUppercaseCharacter(g.pattern,!0))return!0}else if(N.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,v.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const P=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),q=(Array.isArray(g)?g:a(g)).map(z=>{const V=this.e.resolvedUserHome;return V?(0,L.untildify)(z,V.scheme===O.Schemas.file?V.fsPath:V.path):z}),J=T.groupBy(q,z=>P(z)?"searchPaths":"exprSegments"),x=(J.exprSegments||[]).map(z=>N.rtrim(z,"/")).map(z=>N.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),d(z))),R={},A=this.m(J.searchPaths||[]);A&&A.length&&(R.searchPaths=A);const F=i.flatten(x),$=r(...F);return $&&(R.pattern=$),R}l(g,P){return P.disregardExcludeSettings?void 0:(0,p.getExcludes)(g,!P.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const P=i.flatten(g.map(q=>{let{pathPortion:J,globPortion:x}=s(q);x&&(x=u(x));const R=this.n(J);return i.flatten(R.map(A=>this.o(A,x)))})),M=new Map;return P.forEach(q=>{const J=q.searchPath.toString(),x=M.get(J);x?q.pattern&&(x.pattern=x.pattern||{},x.pattern[q.pattern]=!0):M.set(J,{searchPath:q.searchPath,pattern:q.pattern?r(q.pattern):void 0})}),Array.from(M.values())}n(g){if(S.isAbsolute(g)){const P=this.b.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==O.Schemas.file?[{searchPath:P[0].uri.with({path:g})}]:[{searchPath:m.URI.file(S.normalize(g))}]}if(this.b.getWorkbenchState()===2){const P=this.b.getWorkspace().folders[0].uri;if(g=c(g),g.startsWith("../")||g===".."){const q=S.posix.resolve(P.path,g);return[{searchPath:P.with({path:q})}]}const M=u(g);return[{searchPath:P,pattern:M}]}else{if(g==="./"||g===".\\")return[];{const P=g.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(J=>{const x=P.match(new RegExp(`^${N.escapeRegExpCharacters(J.name)}(?:/(.*)|$)`));return x?{match:x,folder:J}:null}).filter(D.isDefined);if(q.length)return q.map(J=>{const x=J.match[1];return{searchPath:J.folder.uri,pattern:x&&u(x)}});{const J=g.match(/\.[\/\\](.+)[\/\\]?/),x=J?J[1]:g,R=h.localize(0,null,x);throw new Error(R)}}}}o(g,P){const M=g.pattern&&P?`${g.pattern}/${P}`:g.pattern||P,q=[{searchPath:g.searchPath,pattern:M}];return M&&!M.endsWith("**")&&q.push({searchPath:g.searchPath,pattern:M+"/**"}),q}q(g,P,M){const q=this.r((0,l.toWorkspaceFolder)(g.searchPath),P,M,!1);return q?{...q,includePattern:g.pattern}:null}r(g,P,M,q){let J;const x=m.URI.isUri(g)?g:g.uri;if(M.searchPaths){const z=M.searchPaths.filter(V=>(0,k.isEqual)(V.searchPath,x))[0];if(z&&!z.pattern)return null;z&&(J=z.pattern)}const R=this.a.getValue({resource:x}),F={...this.l(R,P)||{},...J||{}},$=m.URI.isUri(g)?(0,k.basename)(g):g.name;return{folder:x,folderName:q?$:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:R.files&&R.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!R.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!R.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof P.disregardParentIgnoreFiles=="boolean"?P.disregardParentIgnoreFiles:!R.search.useParentIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!R.search.followSymlinks}}};w=qe([Ve(0,t.IConfigurationService),Ve(1,l.IWorkspaceContextService),Ve(2,b.IEditorGroupsService),Ve(3,o.ILogService),Ve(4,E.IPathService)],w),e.QueryBuilder=w;function s(f){const g=f.match(/[\*\{\}\(\)\[\]\?]/);if(g){const P=g.index,M=f.substr(0,P).match(/[/|\\][^/\\]*$/);if(M){let q=f.substr(0,M.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:f.substr((M.index||0)+1)}}}return{pathPortion:f}}function r(...f){return f.length?f.reduce((g,P)=>(g[P]=!0,g),Object.create(null)):void 0}function a(f){return y.splitGlobAware(f,",").map(g=>g.trim()).filter(g=>!!g.length)}function d(f){return[`**/${f}/**`,`**/${f}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function c(f){return f.replace(/\\/g,"/")}function u(f){return c(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(f,g){f=i.distinct(f,q=>q.toString());const P=[],M=g.getWorkspace();return f&&f.forEach(q=>{let J;if(g.getWorkbenchState()===2)J=(0,k.relativePath)(M.folders[0].uri,q),J&&J!=="."&&(J="./"+J);else{const x=g.getWorkspaceFolder(q);if(x){const R=x.name;if(M.folders.filter(F=>F.name===R).length===1){const F=(0,k.relativePath)(x.uri,q);F===""?J=`./${x.name}`:J=`./${x.name}/${F}`}else J=q.fsPath}}J&&P.push(J)}),P}e.resolveResourcesForSearchIncludes=n}),define(Ie[238],Ce([1,0,22,2,20,11,3,237,44,50]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function D(t,o){const l=o.activationEvents;if(!l)return Promise.resolve(void 0);const b=[],E=[];for(const d of l)if(/^workspaceContains:/.test(d)){const c=d.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||t.forceUsingSearch?E.push(c):b.push(c)}if(b.length===0&&E.length===0)return Promise.resolve(void 0);let p;const w=new Promise((d,c)=>{p=d}),s=d=>p({activationEvent:d}),r=Promise.all(b.map(d=>m(t,d,s))).then(()=>{}),a=v(t,o.identifier,E,s);return Promise.all([r,a]).then(()=>{p(void 0)}),w}e.checkActivateWorkspaceContainsExtension=D;async function m(t,o,l){for(const b of t.folders)if(await t.exists(i.joinPath(T.URI.revive(b),o))){l(`workspaceContains:${o}`);return}}async function v(t,o,l,b){if(l.length===0)return Promise.resolve(void 0);const E=new y.CancellationTokenSource,p=t.checkExists(t.folders,l,E.token),w=setTimeout(async()=>{E.cancel(),t.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},N);let s=!1;try{s=await p}catch(r){L.isCancellationError(r)||L.onUnexpectedError(r)}E.dispose(),clearTimeout(w),s&&b(`workspaceContains:${l.join(",")}`)}function h(t,o,l,b){const E=t.get(C.IInstantiationService),p=t.get(S.ISearchService),s=E.createInstance(O.QueryBuilder).file(o.map(r=>(0,k.toWorkspaceFolder)(T.URI.revive(r))),{_reason:"checkExists",includePattern:l,exists:!0});return p.fileSearch(s,b).then(r=>!!r.limitHit,r=>L.isCancellationError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=h});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[33],Ce([1,0,134,19,77,22,14,7,46,2,12,4,32,182,75,31,25,181,11,26,24,166,6,90,3,27,76,15,63,65,58,5,238,74,168,13,73]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E,p,w,s,r,a,d,c,u,n,f,g,P,M,q,J,x,R){"use strict";var A,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let z=class Ri extends O.Disposable{constructor(se,le,_,me,we,Ne,We,Qe,Te,De,ke){super(),this.a=this.B(new P.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=le,this.g=_,this.f=We,this.j=me,this.k=we,this.l=Ne,this.m=Te,this.p=De,this.s=ke,this.t=this.g.getProxy(D.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(D.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(D.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const oe=(0,o.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(ie(this.F,oe)),this.G=new h.ExtHostStorage(this.g,this.l),this.H=new q.ExtHostSecretState(this.g),this.I=Qe,this.h=se.createChild(new n.ServiceCollection([h.IExtHostStorage,this.G],[q.IExtHostSecretState,this.H]));const ue=this.f.allExtensions.filter(U=>!U.main&&!U.browser).map(U=>U.identifier),Y=this.f.allExtensions.filter(U=>!oe.has(E.ExtensionIdentifier.toKey(U.identifier.value))).filter(U=>(U.main||U.browser)&&U.api==="none").map(U=>U.identifier),I=(0,o.extensionIdentifiersArrayToSet)(Y);this.J=this.B(new v.ExtensionsActivator(this.D,ue,Y,{onExtensionActivationError:(U,H,j)=>{this.v.$onExtensionActivationError(U,b.transformErrorForSerialization(H),j)},actualActivateExtension:async(U,H)=>{if(I.has(E.ExtensionIdentifier.toKey(U)))return await this.v.$activateExtension(U,H),new v.HostExtension;const j=this.D.getExtensionDescription(U);return this.Y(j,H)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),y.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(se){b.onUnexpectedError(se)}}async Q(){this.I.onWillDeactivateAll();let se=[];try{se=this.D.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.X(we))}catch{}await Promise.all(se)}terminate(se,le=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${se}`),this.l.flush(),this.p.dispose(),this.J.dispose(),b.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const _=this.Q();Promise.race([(0,C.timeout)(5e3),_]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${le}`):this.l.info(`Extension host exiting with code ${le}`),this.l.flush(),this.l.dispose(),this.c.exit(le)})}isActivated(se){return this.z.isOpen()?this.J.isActivated(se):!1}async getExtension(se){const le=await this.v.$getExtension(se);let _;if(le?.browserNlsBundleUris){_={};for(const me of Object.keys(le.browserNlsBundleUris))_[me]=k.URI.revive(le.browserNlsBundleUris[me])}return le&&{...le,identifier:new E.ExtensionIdentifier(le.identifier.value),extensionLocation:k.URI.revive(le.extensionLocation),browserNlsBundleUris:_}}R(se,le){return this.J.activateByEvent(se,le)}S(se,le){return this.J.activateById(se,le)}activateByIdWithErrors(se,le){return this.S(se,le).then(()=>{const _=this.J.getActivatedExtension(se);if(_.activationFailed)return Promise.reject(_.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(se=>this.D)}getExtensionExports(se){return this.z.isOpen()?this.J.getActivatedExtension(se).exports:null}async U(se){if(se.scheme!==x.Schemas.file)return se;const le=await this.c.realpath(se.fsPath);return k.URI.file(le)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(se=>new ce(se))),this.L}async W(se){const le=S.TernarySearchTree.forUris(_=>L.extUriBiasedIgnorePathCase.ignorePathCasing(_));return await Promise.all(se.map(async _=>{if(this.ob(_)){const me=await this.U(_.extensionLocation);le.set(me,_)}})),le}X(se){let le=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(se))return le;const _=this.J.getActivatedExtension(se);if(!_)return le;try{typeof _.module.deactivate=="function"&&(le=Promise.resolve(_.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${se.value}':`),this.l.error(me)}try{(0,O.dispose)(_.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${se.value}':`),this.l.error(me)}return le}async Y(se,le){return this.f.remote.isRemote?this.v.$onWillActivateExtension(se.identifier):await this.v.$onWillActivateExtension(se.identifier),this.ab(se,le).then(_=>{const me=_.activationTimes;return this.v.$onDidActivateExtension(se.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,le),this.Z(se,le,"success",me),_},_=>{throw this.Z(se,le,"failure"),_})}Z(se,le,_,me){const we=V(se,le);this.u.$publicLog2("extensionActivationTimes",{...we,...me||{},outcome:_})}ab(se,le){const _=V(se,le);this.u.$publicLog2("activatePlugin",_);const me=this.ob(se);if(!me)return Promise.resolve(new v.EmptyExtension(v.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${se.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${se.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this.l.flush();const we=new v.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this.pb(se,(0,L.joinPath)(se.extensionLocation,me),we),this.bb(se)]).then(Ne=>(y.mark(`code/extHost/willActivateExtension/${se.identifier.value}`),Ri.cb(this.l,se.identifier,Ne[0],Ne[1],we))).then(Ne=>(y.mark(`code/extHost/didActivateExtension/${se.identifier.value}`),Ne))}bb(se){const le=new w.ExtensionGlobalMemento(se,this.G),_=new w.ExtensionMemento(se.identifier.value,!1,this.G),me=new J.ExtensionSecrets(se,this.H),we=se.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Ne=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${se.identifier.value}`),Promise.all([le.whenReady,_.whenReady,this.I.whenReady]).then(()=>{const We=this;let Qe,Te;const De=(0,o.isProposedApiEnabled)(se,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(se.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:_,secrets:me,subscriptions:[],get extensionUri(){return se.extensionLocation},get extensionPath(){return se.extensionLocation.fsPath},asAbsolutePath(ke){return T.join(se.extensionLocation.fsPath,ke)},get storagePath(){return We.I.workspaceValue(se)?.fsPath},get globalStoragePath(){return We.I.globalValue(se).fsPath},get logPath(){return T.join(We.f.logsLocation.fsPath,se.identifier.value)},get logUri(){return k.URI.joinPath(We.f.logsLocation,se.identifier.value)},get storageUri(){return We.I.workspaceValue(se)},get globalStorageUri(){return We.I.globalValue(se)},get extensionMode(){return we},get extension(){return Qe===void 0&&(Qe=new K(We,se.identifier,se,Ne,!1)),Qe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(se,"extensionRuntime"),We.extensionRuntime},get environmentVariableCollection(){return We.p.getEnvironmentVariableCollection(se)},get messagePassingProtocol(){if(!Te){if(!De)return;const ke=P.Event.buffer(P.Event.fromDOMEventEmitter(De,"message",oe=>oe.data));De.start(),Te={onDidReceiveMessage:ke,postMessage:De.postMessage.bind(De)}}return Te}})})}static cb(se,le,_,me,we){return _=_||{activate:void 0,deactivate:void 0},this.db(se,le,_,me,we).then(Ne=>new v.ActivatedExtension(!1,null,we.build(),_,Ne,me.subscriptions))}static db(se,le,_,me,we){if(typeof _.activate=="function")try{we.activateCallStart(),se.trace(`ExtensionService#_callActivateOptional ${le.value}`);const Ne=typeof global=="object"?global:self,We=_.activate.apply(Ne,[me]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(We).then(Qe=>(we.activateResolveStop(),Qe))}catch(Ne){return Promise.reject(Ne)}else return Promise.resolve(_)}eb(se,le){this.S(se.identifier,{startup:!1,extensionId:se.identifier,activationEvent:le}).then(void 0,_=>{this.l.error(_)})}fb(){this.v.$setPerformanceMarks(y.getMarks());for(const se of this.D.getAllExtensionDescriptions())if(se.activationEvents)for(const le of se.activationEvents)le==="onStartupFinished"&&this.eb(se,le)}gb(){const se=this.R("*",!0).then(void 0,we=>{this.l.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.hb(we.added)));const le=this.j.workspace?this.j.workspace.folders:[],_=this.hb(le),me=Promise.all([se,_]).then(()=>{});return Promise.race([me,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),me}hb(se){return se.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(le=>this.ib(se,le))).then(()=>{})}async ib(se,le){if(this.isActivated(le.identifier))return;const _=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:se.map(Ne=>Ne.uri),forceUsingSearch:_,exists:Ne=>this.c.exists(Ne.fsPath),checkExists:(Ne,We,Qe)=>this.t.$checkExists(Ne,We,Qe)},we=await(0,M.checkActivateWorkspaceContainsExtension)(me,le);if(!!we)return this.S(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:we.activationEvent}).then(void 0,Ne=>this.l.error(Ne))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(se){throw console.error(se),se}}async jb(){const{extensionDevelopmentLocationURI:se,extensionTestsLocationURI:le}=this.f.environment;if(!se||!le)throw new Error(i.localize(0,null));const _=await this.pb(null,le,new v.ExtensionActivationTimesBuilder(!1));if(!_||typeof _.run!="function")throw new Error(i.localize(1,null,le.toString()));return new Promise((me,we)=>{const Ne=(Te,De)=>{Te?we(Te):me(typeof De=="number"&&De>0?1:0)},We=(0,L.originalFSPath)(le),Qe=_.run(We,Ne);Qe&&Qe.then&&Qe.then(()=>{me(0)}).catch(Te=>{we(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(se,le){return this.M[se]=le,(0,O.toDisposable)(()=>{delete this.M[se]})}async lb(se){const le=se.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const _=se.substr(0,le);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${_}`,!1),{authorityPrefix:_,resolver:this.M[_]}}async $resolveAuthority(se,le){this.l.info(`$resolveAuthority invoked for authority (${ge(se)})`);const{authorityPrefix:_,resolver:me}=await this.lb(se);if(!me)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${_}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(me)),y.mark(`code/extHost/willResolveAuthority/${_}`);const we=await me.resolve(se,{resolveAttempt:le});y.mark(`code/extHost/didResolveAuthorityOK/${_}`);const Ne={authority:se,host:we.host,port:we.port,connectionToken:we.connectionToken},We={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ne,options:We,tunnelInformation:{environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures}}}}catch(we){if(y.mark(`code/extHost/didResolveAuthorityError/${_}`),we instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}async $getCanonicalURI(se,le){this.l.info(`$getCanonicalURI invoked for authority (${ge(se)})`);const{resolver:_}=await this.lb(se);if(!_)return null;const me=k.URI.revive(le);if(typeof _.getCanonicalURI>"u")return me;const we=await(0,C.asPromise)(()=>_.getCanonicalURI(me));return we||me}static mb(se,le,_){const me=new l.ExtensionDescriptionRegistry(se.getAllExtensionDescriptions());me.deltaExtensions(_.toAdd,_.toRemove);const we=(0,o.extensionIdentifiersArrayToSet)(le.getAllExtensionDescriptions().map(We=>We.identifier));for(const We of _.myToRemove)we.delete(E.ExtensionIdentifier.toKey(We));for(const We of _.myToAdd)we.add(E.ExtensionIdentifier.toKey(We));const Ne=ie(me,we);return{globalRegistry:me,myExtensions:Ne}}$startExtensionHost(se){se.toAdd.forEach(me=>me.extensionLocation=k.URI.revive(me.extensionLocation));const{globalRegistry:le,myExtensions:_}=Ri.mb(this.F,this.D,se);return this.F.set(le.getAllExtensionDescriptions()),this.D.set(_),this.kb()}$activateByEvent(se,le){return le===1?this.R(se,!1):this.z.wait().then(_=>this.R(se,!1))}async $activate(se,le){return await this.z.wait(),this.D.getExtensionDescription(se)?(await this.S(se,le),!0):!1}async $deltaExtensions(se){se.toAdd.forEach(Ne=>Ne.extensionLocation=k.URI.revive(Ne.extensionLocation));const{globalRegistry:le,myExtensions:_}=Ri.mb(this.F,this.D,se),me=await this.W(_);return(await this.getExtensionPathIndex()).setSearchTree(me),this.F.set(le.getAllExtensionDescriptions()),this.D.set(_),Promise.resolve(void 0)}async $test_latency(se){return se}async $test_up(se){return se.byteLength}async $test_down(se){const le=p.VSBuffer.alloc(se),_=Math.random()%256;for(let me=0;me<se;me++)le.writeUInt8(_,me);return le}async $updateRemoteConnectionData(se){this.P=se,this.a.fire()}};z=qe([Ve(0,a.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,u.IExtHostRpcService),Ve(3,t.IExtHostWorkspace),Ve(4,m.IExtHostConfiguration),Ve(5,N.ILogService),Ve(6,d.IExtHostInitDataService),Ve(7,c.IExtensionStoragePaths),Ve(8,f.IExtHostTunnelService),Ve(9,g.IExtHostTerminalService),Ve(10,R.IExtHostLocalizationService)],z),e.AbstractExtHostExtensionService=z;function V(re,se){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:se.activationEvent,reasonId:se.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class K{constructor(se,le,_,me,we){A.set(this,void 0),F.set(this,void 0),$.set(this,void 0),Ye(this,A,se,"f"),Ye(this,F,le,"f"),Ye(this,$,_.identifier,"f"),this.id=_.identifier.value,this.extensionUri=_.extensionLocation,this.extensionPath=T.normalize((0,L.originalFSPath)(_.extensionLocation)),this.packageJSON=_,this.extensionKind=me,this.isFromDifferentExtensionHost=we}get isActive(){return Re(this,A,"f").isActivated(Re(this,$,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Re(this,A,"f").getExtensionExports(Re(this,$,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Re(this,A,"f").activateByIdWithErrors(Re(this,$,"f"),{startup:!1,extensionId:Re(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=K,A=new WeakMap,F=new WeakMap,$=new WeakMap;function ie(re,se){return re.getAllExtensionDescriptions().filter(le=>se.has(E.ExtensionIdentifier.toKey(le.identifier)))}function ge(re){const se=re.indexOf("+");return se===-1?re:re.substring(0,se)}class ce{constructor(se){this.a=se}setSearchTree(se){this.a=se}findSubstr(se){return this.a.findSubstr(se)}forEach(se){return this.a.forEach(se)}}e.ExtensionPaths=ce}),define(Ie[239],Ce([1,0,77,2,4,32,25,26,15,27,3,33,49,12,10]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(w,s,r,a,d,c,u){this.c=w,this.d=s,this.e=r,this.f=a,this.g=d,this.h=c,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new l(this.c,s,this.d,w,this.i)),this.register(this.e.createInstance(b,s)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,s,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const s of w.nodeModuleName)this.a.set(s,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(s=>w.alternativeModuleName(s))}};t=qe([Ve(2,N.IInstantiationService),Ve(3,L.IExtHostConfiguration),Ve(4,D.IExtHostExtensionService),Ve(5,k.IExtHostInitDataService),Ve(6,v.ILogService)],t),e.RequireInterceptor=t;let o=class Zi{constructor(w){if(w.environment.appRoot&&Zi.a.size){const s=(0,h.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),r="[a-z0-9_.-]",a=`@${r}+\\/${r}+|${r}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const s=this.b.exec(this.c(w));if(!s)return;const[,r,a,d]=s,c=Zi.a.get(a);if(c!==void 0)return console.warn(`${a} as been renamed to ${c}, please update your imports`),r+c+d}c(w){return w.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=qe([Ve(0,k.IExtHostInitDataService)],o);class l{constructor(w,s,r,a,d){this.c=w,this.d=s,this.e=r,this.f=a,this.g=d,this.nodeModuleName="vscode",this.a=new Map}load(w,s){const r=this.d.findSubstr(s);if(r){let a=this.a.get(O.ExtensionIdentifier.toKey(r.identifier));return a||(a=this.c(r,this.e,this.f),this.a.set(O.ExtensionIdentifier.toKey(r.identifier),a)),a}if(!this.b){let a="";this.d.forEach((d,c)=>a+=`	${c} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${a}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let b=class{constructor(w,s,r){this.d=w,this.nodeModuleName="keytar",this.a=s.getProxy(y.MainContext.MainThreadTelemetry);const{environment:a}=r,d=s.getProxy(y.MainContext.MainThreadKeytar);if(a.appRoot){let c=a.appRoot.fsPath;m.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,u)=>d.$getPassword(c,u),setPassword:(c,u,n)=>d.$setPassword(c,u,n),deletePassword:(c,u)=>d.$deletePassword(c,u),findPassword:c=>d.$findPassword(c),findCredentials(c){return d.$findCredentials(c)}}}load(w,s){const r=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:r?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const s=w.length;if(s<=7||!this.b)return;const r=s-7;if((w.charAt(r)==="/"||w.charAt(r)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};b=qe([Ve(1,S.IExtHostRpcService),Ve(2,k.IExtHostInitDataService)],b);let E=class{constructor(w,s,r){this.e=w,this.f=s,this.nodeModuleName=["open","opn"],this.d=r.getProxy(y.MainContext.MainThreadTelemetry);const a=r.getProxy(y.MainContext.MainThreadWindow);this.c=(d,c)=>{const u=T.URI.parse(d);return c?this.g(d,c):u.scheme==="http"||u.scheme==="https"?a.$openUri(u,d,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?a.$openUri(u,d,{}):this.g(d,c)}}load(w,s,r){const a=this.e.findSubstr(s);return a&&(this.a=a.identifier.value,this.h()),this.b=r(w),this.c}g(w,s){return this.i(),this.b(w,s)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=qe([Ve(2,S.IExtHostRpcService)],E)}),define(Ie[105],Ce([1,0,205,7,19,49,3,55,56,33,6,31,178,32]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class h extends m.AbstractVariableResolverService{constructor(l,b,E,p,w,s,r){function a(){if(E){const d=E.activeEditor();if(d)return d.document.uri;const c=p.tabGroups.all.find(u=>u.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof N.TextDiffTabInput||c.input instanceof N.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof N.TextTabInput||c.input instanceof N.NotebookEditorTabInput||c.input instanceof N.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:d=>{const c=s.folders.filter(u=>u.name===d);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(d,c)=>w.getConfiguration(void 0,d).get(c),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return y.normalize(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const d=a();if(d){const c=b.getWorkspaceFolder(d);if(c)return y.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(E){const d=E.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(E){const d=E.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>l.getExtension(d)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(L.env))}}let t=class extends T.Disposable{constructor(l,b,E,p,w){super(),this.b=l,this.c=b,this.g=E,this.h=p,this.i=w,this.a=new i.Lazy(async()=>{const s=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new h(this.b,this.c,this.g,this.i,s,a,this.j())})}getResolver(){return this.a.getValue()}j(){}};t=qe([Ve(0,k.IExtHostExtensionService),Ve(1,D.IExtHostWorkspace),Ve(2,O.IExtHostDocumentsAndEditors),Ve(3,v.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs)],t),e.ExtHostVariableResolverProviderService=t}),define(Ie[106],Ce([1,0,14,5,9,2,3,4,56,33,15,6,31,170,172,32,105]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,d,c,u,n,f){this.D=d,this.E=c,this.F=u,this.G=n,this.H=f,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new T.Emitter,this.n=new T.Emitter,this.o=new T.Emitter,this.u=new T.Emitter,this.k=a.getProxy(O.MainContext.MainThreadDebugService),this.z=new T.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(g=>{g.onDidChange(P=>{this.I(g)}),this.I(g)})}asDebugSourceUri(a,d){const c=a;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let u=`debug:${encodeURIComponent(c.path||"")}`,n="?";return d&&(u+=`${n}session=${encodeURIComponent(d.id)}`,n="&"),u+=`${n}ref=${c.sourceReference}`,L.URI.parse(u)}else{if(c.path)return L.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(a){const d=[];for(const c of a.getAllExtensionDescriptions())if(c.contributes){const u=c.contributes.debuggers;if(u&&u.length>0)for(const n of u)(0,h.isDebuggerMainContribution)(n)&&d.push(n.type)}this.k.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const a=[];return this.w.forEach(d=>a.push(d)),a}addBreakpoints(a){this.T();const d=a.filter(n=>{const f=n.id;return this.w.has(f)?!1:(this.w.set(f,n),!0)});this.U(d,[],[]);const c=[],u=new Map;for(const n of d)if(n instanceof D.SourceBreakpoint){let f=u.get(n.location.uri.toString());f||(f={type:"sourceMulti",uri:n.location.uri,lines:[]},u.set(n.location.uri.toString(),f),c.push(f)),f.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof D.FunctionBreakpoint&&c.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(a){this.T();const d=a.filter(f=>this.w.delete(f.id));this.U([],d,[]);const c=d.filter(f=>f instanceof D.SourceBreakpoint).map(f=>f.id),u=d.filter(f=>f instanceof D.FunctionBreakpoint).map(f=>f.id),n=d.filter(f=>f instanceof D.DataBreakpoint).map(f=>f.id);return this.k.$unregisterBreakpoints(c,u,n)}startDebugging(a,d,c){return this.k.$startDebugging(a?a.uri:void 0,d,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,d,c){if(!d)return new D.Disposable(()=>{});const u=this.d++;return this.f.push({type:a,handle:u,provider:d}),this.k.$registerDebugConfigurationProvider(a,c,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,u),new D.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==d),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(a,d,c){if(!c)return new D.Disposable(()=>{});if(!this.P(a,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.M(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:d,handle:u,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(d,u),new D.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(a,d){if(!d)return new D.Disposable(()=>{});const c=this.i++;return this.j.push({type:a,handle:c,factory:d}),new D.Disposable(()=>{this.j=this.j.filter(u=>u.factory!==d)})}async $runInTerminal(a,d){return Promise.resolve(void 0)}async $substituteVariables(a,d){let c;const u=await this.W(a);return u&&(c={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(c,d)}J(a,d){if(a.type==="implementation")return new w(a.implementation)}K(){}async $startDASession(a,d){const c=this,u=await this.V(d);return this.R(this.M(u.type),u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const f=this.L(n),g=this.J(f,u);if(!g)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const P=g;return this.A.set(a,P),this.Q(u).then(M=>(M&&this.B.set(a,M),P.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const J=q,x={type:"response",seq:0,command:J.command,request_seq:J.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const R=await this.C.sign(J.arguments.value);x.body={signature:R},P.sendResponse(x)}else throw new Error("no signer")}catch(R){x.success=!1,x.message=R.message,P.sendResponse(x)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(q),q=(0,h.convertToVSCPaths)(q,!0),c.k.$acceptDAMessage(a,q)}),P.onError(q=>{M&&M.onError&&M.onError(q),this.k.$acceptDAError(a,q.name,q.message,q.stack)}),P.onExit(q=>{M&&M.onExit&&M.onExit((0,y.withNullAsUndefined)(q),void 0),this.k.$acceptDAExit(a,(0,y.withNullAsUndefined)(q),void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),P.startSession()))})}$sendDAMessage(a,d){d=(0,h.convertToDAPaths)(d,!1);const c=this.B.get(a);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(d),this.A.get(a)?.sendMessage(d)}$stopDASession(a){const d=this.B.get(a);this.B.delete(a),d&&d.onWillStopSession&&d.onWillStopSession();const c=this.A.get(a);return this.A.delete(a),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const d=[],c=[],u=[];if(a.added)for(const n of a.added){const f=n.id;if(f&&!this.w.has(f)){let g;if(n.type==="function")g=new D.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")g=new D.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const P=L.URI.revive(n.uri);g=new D.SourceBreakpoint(new D.Location(P,new D.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}g._id=f,this.w.set(f,g),d.push(g)}}if(a.removed)for(const n of a.removed){const f=this.w.get(n);f&&(this.w.delete(n),c.push(f))}if(a.changed){for(const n of a.changed)if(n.id){const f=this.w.get(n.id);if(f){if(f instanceof D.FunctionBreakpoint&&n.type==="function"){const g=f;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.functionName=n.functionName}else if(f instanceof D.SourceBreakpoint&&n.type==="source"){const g=f;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.location=new D.Location(L.URI.revive(n.uri),new D.Position(n.line,n.character))}u.push(f)}}}this.U(d,c,u)}$provideDebugConfigurations(a,d,c){return(0,i.asPromise)(async()=>{const u=this.O(a);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(d);return u.provideDebugConfigurations(n,c)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(a,d,c,u){return(0,i.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const f=await this.W(d);return n.resolveDebugConfiguration(f,c,u)})}$resolveDebugConfigurationWithSubstitutedVariables(a,d,c,u){return(0,i.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const f=await this.W(d);return n.resolveDebugConfigurationWithSubstitutedVariables(f,c,u)})}async $provideDebugAdapter(a,d){const c=this.N(a);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(d);return this.R(c,u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(a){const d=await this.V(a);this.m.fire(d)}async $acceptDebugSessionTerminated(a){const d=await this.V(a);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,d){(await this.V(a))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(a,d){const u={session:await this.V(a),event:d.event,body:d.body};this.u.fire(u)}L(a){if(a instanceof D.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof D.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}M(a){const d=this.h.filter(c=>c.type===a);if(d.length>0)return d[0].factory}N(a){const d=this.h.filter(c=>c.handle===a);if(d.length>0)return d[0].factory}O(a){const d=this.f.filter(c=>c.handle===a);if(d.length>0)return d[0].provider}P(a,d){if(a.contributes){const c=a.contributes.debuggers;if(c&&c.length>0){for(const u of c)if(u.label&&u.type&&u.type===d)return!0}}return!1}Q(a){const c=a.configuration.type,u=this.j.filter(n=>n.type===c||n.type==="*").map(n=>(0,i.asPromise)(()=>n.factory.createDebugAdapterTracker(a)).then(f=>f,f=>null));return Promise.race([Promise.all(u).then(n=>{const f=n.filter(g=>!!g);if(f.length>0)return new p(f)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(a,d){const c=d.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new D.DebugAdapterServer(c));if(a){const n=await this.E.getExtensionRegistry();return(0,i.asPromise)(()=>a.createDebugAdapterDescriptor(d,this.S(d,n))).then(f=>{if(f)return f})}const u=await this.E.getExtensionRegistry();return Promise.resolve(this.S(d,u))}S(a,d){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(a,d,c){(a.length>0||d.length>0||c.length>0)&&this.z.fire(Object.freeze({added:a,removed:d,changed:c}))}async V(a){if(a)if(typeof a=="string"){const d=this.l.get(a);if(d)return d}else{let d=this.l.get(a.id);if(!d){const c=await this.W(a.folderUri),u=a.parent?this.l.get(a.parent):void 0;d=new b(this.k,a.id,a.type,a.name,c,a.configuration,u),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(a){if(a){const d=L.URI.revive(a);return this.D.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};l=qe([Ve(0,N.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,t.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class b{constructor(a,d,c,u,n,f,g){this.d=a,this.f=d,this.g=c,this.h=u,this.i=n,this.j=f,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,d){return this.d.$customDebugAdapterRequest(this.f,a,d)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.ExtHostDebugSession=b;class E{constructor(a){this.value=Object.freeze({append(d){a.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=E;class p{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(d=>d.onError?d.onError(a):void 0)}onExit(a,d){this.d.forEach(c=>c.onExit?c.onExit(a,d):void 0)}}class w extends v.AbstractDebugAdapter{constructor(a){super(),this.h=a,a.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends l{constructor(a,d,c,u,n,f){super(a,d,c,u,n,f)}};s=qe([Ve(0,N.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,t.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(Ie[240],Ce([1,0,11,77,2,4,231,12,62,63,27,152,15,52,33,70]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(E){const p=E.get(O.ILogService),s=E.get(m.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(r=>{p.error(r);const a=i.transformErrorForSerialization(r);s.$onUnexpectedError(a)})}static async installFullHandler(E){const p=E.get(O.ILogService),w=E.get(m.IExtHostRpcService),s=E.get(h.IExtHostExtensionService),r=E.get(t.IExtHostTelemetry),a=w.getProxy(L.MainContext.MainThreadExtensionService),d=w.getProxy(L.MainContext.MainThreadErrors),c=await s.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(n,f)=>{let g="",P,M;for(const q of f)g+=`
	at ${q.toString()}`,M=q.getFileName(),!P&&M&&(P=c.findSubstr(y.URI.file(M)));return u.set(n,P?.identifier),`${n.name||"Error"}: ${n.message||""}${g}`},i.setUnexpectedErrorHandler(n=>{p.error(n);const f=i.transformErrorForSerialization(n),g=u.get(n);if(!g){d.$onUnexpectedError(f);return}a.$onExtensionRuntimeError(g,f);const P=r.onExtensionError(g,n);p.trace("forwarded error to extension?",P,g)})}}Error.stackTraceLimit=100;class l{constructor(E,p,w,s,r){this.a=w,this.b=new C.RPCProtocol(E,null,s),p=l.e(p,this.b);const a=new k.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());a.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...p,messagePorts:r}),a.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),a.set(v.IURITransformerService,new v.URITransformerService(s)),a.set(h.IHostUtils,w);const d=new D.InstantiationService(a,!0);d.invokeFunction(o.installEarlyHandler),this.d=d.invokeFunction(c=>c.get(O.ILogService)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",p),this.c=d.invokeFunction(c=>c.get(h.IExtHostExtensionService)),this.c.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(E){const p=this.b.getProxy(L.MainContext.MainThreadExtensionService);return y.URI.revive(await p.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,p){E.allExtensions.forEach(s=>{s.extensionLocation=y.URI.revive(p.transformIncomingURIs(s.extensionLocation));const r={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(a=>r[a]=y.URI.revive(p.transformIncomingURIs(s.browserNlsBundleUris[a]))),s.browserNlsBundleUris=r)}),E.environment.appRoot=y.URI.revive(p.transformIncomingURIs(E.environment.appRoot));const w=E.environment.extensionDevelopmentLocationURI;return w&&(E.environment.extensionDevelopmentLocationURI=w.map(s=>y.URI.revive(p.transformIncomingURIs(s)))),E.environment.extensionTestsLocationURI=y.URI.revive(p.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=y.URI.revive(p.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=y.URI.revive(p.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=y.URI.revive(p.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=y.URI.revive(p.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=y.URI.revive(p.transformIncomingURIs(E.logsLocation)),E.logFile=y.URI.revive(p.transformIncomingURIs(E.logFile)),E.workspace=p.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=l}),define(Ie[241],Ce([1,0,16,14,20,45,13,19,22,2,44]),function(ee,e,i,T,y,L,C,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(b,E,p,w){this.d=b,this.e=E,this.f=p,this.g=w,this.a=null,this.b=!1,this.c=0}search(b,E){const p=this.d.folderQueries||[],w=new y.CancellationTokenSource;return E.onCancellationRequested(()=>w.cancel()),new Promise((s,r)=>{this.a=new v(b);let a=!1;const d=(c,u)=>{if(!a&&!this.b){const n=this.h(c);t(c)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,a=!0,w.cancel(),c=this.j(c,this.d.maxResults-this.c));const f=this.h(c);this.c+=f,(f>0||!t(c))&&this.a.add(c,u)}};Promise.all(p.map((c,u)=>this.k(c,n=>d(n,u),w.token))).then(c=>{w.dispose(),this.a.flush();const u=c.some(n=>!!n&&!!n.limitHit);s({limitHit:this.b||u,messages:(0,i.flatten)(c.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},c=>{w.dispose();const u=(0,L.toErrorMessage)(c);r(new Error(u))})})}h(b){return t(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}j(b,E){const p=Array.isArray(b.ranges)?b.ranges:[b.ranges],w=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:p.slice(0,E),preview:{matches:w.slice(0,E),text:b.preview.text},uri:b.uri}}async k(b,E,p){const w=new N.QueryGlobTester(this.d,b),s=[],r={report:c=>{if(!this.l(c))return;const u=b.folder.scheme===C.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(c.uri))):void 0,n=S.relativePath(b.folder,c.uri);if(n){const f=w.includedInQuery(n,O.basename(n),u);(0,T.isThenable)(f)?s.push(f.then(g=>{g&&E(c)})):f&&E(c)}}},a=this.n(b),d=await this.e.provideTextSearchResults(m(this.d.contentPattern),a,r,p);return s.length&&await Promise.all(s),d}l(b){if(t(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(b){const E=(0,N.resolvePatternsForProvider)(this.d.includePattern,b.includePattern),p=(0,N.resolvePatternsForProvider)(this.d.excludePattern,b.excludePattern),w={folder:k.URI.from(b.folder),excludes:p,includes:E,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.f.toCanonicalName(b.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=D;function m(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class v{constructor(b){this.e=b,this.b=-1,this.d=null,this.a=new o(512,E=>this.g(E))}add(b,E){this.d&&(this.b!==E||!S.isEqual(this.c,b.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:b.uri,results:[]}),this.d.results.push(h(b))}f(){const b=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,b)}flush(){this.f(),this.a.flush()}g(b){this.e(b)}}e.TextSearchResultsCollector=v;function h(l){return t(l)?{preview:{matches:(0,i.mapArrayOrNot)(l.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:l.preview.text},ranges:(0,i.mapArrayOrNot)(l.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function t(l){return!!l.preview}e.extensionResultIsMatch=t;class o{constructor(b,E){this.g=b,this.h=E,this.c=0,this.d=[],this.e=0}addItem(b,E){!b||this.j(b,E)}addItems(b,E){!b||this.k(b,E)}j(b,E){this.d.push(b),this.e+=E,this.l()}k(b,E){this.d=this.d.concat(b),this.e+=E,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=o,o.a=4e3,o.b=50}),define(Ie[107],Ce([1,0,7,4,3,236,15,52,12,2,241]),function(ee,e,i,T,y,L,C,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let D=class{constructor(t,o,l){this.k=t,this.l=o,this.n=l,this.c=this.k.getProxy(T.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(t){return this.l.transformOutgoingScheme(t)}registerTextSearchProvider(t,o){if(this.g.has(t))throw new Error(`a text search provider for the scheme '${t}' is already registered`);this.g.add(t);const l=this.d++;return this.e.set(l,o),this.c.$registerTextSearchProvider(l,this.o(t)),(0,i.toDisposable)(()=>{this.g.delete(t),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(t,o){if(this.i.has(t))throw new Error(`a file search provider for the scheme '${t}' is already registered`);this.i.add(t);const l=this.d++;return this.h.set(l,o),this.c.$registerFileSearchProvider(l,this.o(t)),(0,i.toDisposable)(()=>{this.i.delete(t),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(t,o,l,b){const E=m(l),p=this.h.get(t);if(p)return this.j.fileSearch(E,p,w=>{this.c.$handleFileMatch(t,o,w.map(s=>s.resource))},b);throw new Error("unknown provider: "+t)}$clearCache(t){return this.j.clearCache(t),Promise.resolve(void 0)}$provideTextSearchResults(t,o,l,b){const E=this.e.get(t);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${t}`);const p=m(l);return this.q(p,E).search(s=>this.c.$handleTextMatch(t,o,s),b)}$enableExtensionHostSearch(){}q(t,o){return new N.TextSearchManager(t,o,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};D=qe([Ve(0,C.IExtHostRpcService),Ve(1,O.IURITransformerService),Ve(2,S.ILogService)],D),e.ExtHostSearch=D;function m(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(v),extraFileResources:h.extraFileResources&&h.extraFileResources.map(t=>k.URI.revive(t))}}e.reviveQuery=m;function v(h){return{...h,folder:k.URI.revive(h.folder)}}}),define(Ie[242],Ce([1,0,62,102,31,100,32,38,55,58,104,106,107,75,65,72,101,57,37,74,70,56,212,12,183,105,73]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E,p,w,s,r,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,i.registerSingleton)(r.ILoggerService,s.ExtHostLoggerService,1),(0,i.registerSingleton)(r.ILogService,a.ExtHostLogService,1),(0,i.registerSingleton)(t.IExtHostApiDeprecationService,t.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(O.IExtHostCommands,O.ExtHostCommands,0),(0,i.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,i.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,i.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,i.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,i.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,i.registerSingleton)(v.IExtHostStorage,v.ExtHostStorage,0),(0,i.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService,0),(0,i.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,i.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,i.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,i.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry,0),(0,i.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,i.registerSingleton)(d.IExtHostVariableResolverProvider,d.ExtHostVariableResolverProviderService,0)}),define(Ie[243],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(y){if(y&&this.a.has(y)){const L=this.a.get(y);return this.a.delete(y),L}}addDragOperationTransfer(y,L){this.a.set(y,L)}getRenderedTreeElement(y){if(this.b.has(y))return this.b.get(y)}addRenderedTreeItemElement(y,L){this.b.set(y,L)}removeRenderedTreeItemElement(y){this.b.has(y)&&this.b.delete(y)}}e.TreeviewsService=i}),define(Ie[244],Ce([1,0,138,6,22,2,5,7,14,6,9,16,8,20,243,25]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(E,p){if((0,N.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let w;return Array.isArray(E.highlights)&&(w=E.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),w=w.length?w:void 0),{label:E.label,highlights:w}}}class l{constructor(p,w,s){this.d=p,this.e=w,this.f=s,this.a=new Map,this.b=new h.TreeviewsService;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:a=>r(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(d=>r(d)?this.i(d):d):a})}registerTreeDataProvider(p,w,s){const r=this.createTreeView(p,{treeDataProvider:w},s);return{dispose:()=>r.dispose()}}createTreeView(p,w,s){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=w.dragAndDropController?.dropMimeTypes??[],a=w.dragAndDropController?.dragMimeTypes??[],d=!!w.dragAndDropController?.handleDrag,c=!!w.dragAndDropController?.handleDrop,u=this.h(p,w,s),n=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:d,hasHandleDrop:c});return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(s,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(f){u.message=f},get title(){return u.title},set title(f){u.title=f},get description(){return u.description},set description(f){u.description=f},get badge(){return u.badge},set badge(f){f!==void 0&&k.ViewBadge.isViewBadge(f)?u.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(u.badge=void 0)},reveal:(f,g)=>u.reveal(f,g),dispose:async()=>{await n,this.a.delete(p),u.dispose()}}}$getChildren(p,w){const s=this.a.get(p);return s?s.getChildren(w):Promise.reject(new Error((0,i.localize)(0,null,p)))}async $handleDrop(p,w,s,r,a,d,c,u){const n=this.a.get(p);if(!n)return Promise.reject(new Error((0,i.localize)(1,null,p)));const f=m.DataTransfer.toDataTransfer(s,async g=>(await this.d.$resolveDropFileData(p,w,g)).buffer);return c===p&&u&&await this.g(f,n,u,a,d),n.onDrop(f,r,a)}async g(p,w,s,r,a){const d=this.b.removeDragOperationTransfer(a);if(d)(await d)?.forEach((c,u)=>{c&&p.set(u,c)});else if(a&&w.handleDrag){const c=w.handleDrag(s,p,r);this.b.addDragOperationTransfer(a,c),await c}return p}async $handleDrag(p,w,s,r){const a=this.a.get(p);if(!a)return Promise.reject(new Error((0,i.localize)(2,null,p)));const d=await this.g(new T.DataTransfer,a,w,r,s);if(!!d)return m.DataTransfer.toDataTransferDTO(d)}async $hasResolve(p){const w=this.a.get(p);if(!w)throw new Error((0,i.localize)(3,null,p));return w.hasResolve}$resolve(p,w,s){const r=this.a.get(p);if(!r)throw new Error((0,i.localize)(4,null,p));return r.resolveTreeItem(w,s)}$setExpanded(p,w,s){const r=this.a.get(p);if(!r)throw new Error((0,i.localize)(5,null,p));r.setExpanded(w,s)}$setSelection(p,w){const s=this.a.get(p);if(!s)throw new Error((0,i.localize)(6,null,p));s.setSelection(w)}$setFocus(p,w){const s=this.a.get(p);if(!s)throw new Error((0,i.localize)(7,null,p));s.setFocus(w)}$setVisible(p,w){const s=this.a.get(p);if(!s)throw new Error((0,i.localize)(8,null,p));s.setVisible(w)}$changeCheckboxState(p,w){const s=this.a.get(p);if(!s)throw new Error((0,i.localize)(9,null,p));s.setCheckboxState(w)}h(p,w,s){const r=new b(p,w,this.d,this.e.converter,this.f,s);return this.a.set(p,r),r}i(p){const w=this.a.get(p.$treeViewId);return w&&"$treeItemHandle"in p?w.getExtensionElement(p.$treeItemHandle):w&&"$focusedTreeItem"in p&&p.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=l;class b extends O.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,N.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,w,s,r,a,d){if(super(),this.C=p,this.D=s,this.F=r,this.G=a,this.H=d,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new v.CancellationTokenSource,d.contributes&&d.contributes.views)for(const n in d.contributes.views)for(const f of d.contributes.views[n])f.id===p&&(this.J=f.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let c,u;this.B(C.Event.debounce(this.w.event,(n,f)=>(n||(n={message:!1,elements:[]}),f.element!==!1&&(c||(c=new Promise(g=>u=g),this.y=this.y.then(()=>c)),Array.isArray(f.element)?n.elements.push(...f.element):n.elements.push(f.element)),f.message&&(n.message=!0),n),200,!0)(({message:n,elements:f})=>{f.length&&(this.z=this.z.then(()=>{const g=u;return c=null,this.U(f).then(()=>g())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const w=p?this.getExtensionElement(p):void 0;if(p&&!w)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let s=this.Q(p);return s||(s=await this.R(w)),s?s.map(r=>r.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,w){w=w||{select:!0,focus:!1};const s=(0,N.isUndefinedOrNull)(w.select)?!0:w.select,r=(0,N.isUndefinedOrNull)(w.focus)?!1:w.focus,a=(0,N.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(d=>this.P(p,d[d.length-1]).then(c=>this.D.$reveal(this.C,{item:c.item,parentChain:d.map(u=>u.item)},{select:s,focus:r,expand:a})),d=>this.G.error(d)):this.D.$reveal(this.C,void 0,{select:s,focus:r,expand:a})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=m.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,w){const s=this.getExtensionElement(p);s&&(w?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(p){(0,D.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const w=(await Promise.all(p.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);w.forEach(s=>{s.treeItem.checkboxState=s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(s=>[s.extensionItem,s.newState])})}async handleDrag(p,w,s){const r=[];for(const a of p){const d=this.getExtensionElement(a);d&&r.push(d)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,w,s),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,w,s){const r=w?this.getExtensionElement(w):void 0;if(!(!r&&w||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,p,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,w){if(!this.f.resolveTreeItem)return;const s=this.i.get(p);if(s){const r=this.j.get(s);if(r){const a=await this.f.resolveTreeItem(r.extensionItem,s,w)??r.extensionItem;return this.db(a),r.item.tooltip=this.ab(a.tooltip),r.item.command=this.bb(r.disposableStore,a.command),r.item}}}N(p){return this.O(p).then(w=>w?this.N(w).then(s=>this.P(w,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}O(p){const w=this.j.get(p);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(p))}P(p,w){const s=this.j.get(p);return s?Promise.resolve(s):(0,S.asPromise)(()=>this.f.getTreeItem(p)).then(r=>this.gb(p,r,w,!0)).then(r=>this.getChildren(w?w.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const d=this.j.get(a);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(p){if(p){let w;if(typeof p=="string"){const s=this.getExtensionElement(p);w=s?this.j.get(s):void 0}else w=p;return w&&w.children||void 0}return this.h}async R(p){this.nb(p);const w=new v.CancellationTokenSource(this.S.token);try{const s=p?this.j.get(p):void 0,r=await this.f.getChildren(p);if(w.token.isCancellationRequested)return;const a=await Promise.all((0,D.coalesce)(r||[]).map(async d=>{const c=await this.f.getTreeItem(d);return c&&!w.token.isCancellationRequested?this.Z(d,c,s):null}));return w.token.isCancellationRequested?void 0:(0,D.coalesce)(a)}finally{w.dispose()}}U(p){if(p.some(s=>!s))return this.S.dispose(!0),this.S=new v.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(p);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(p){const w=new Set,s=p.map(a=>this.j.get(a));for(const a of s)if(a&&!w.has(a.item.handle)){let d=a;for(;d&&d.parent&&s.findIndex(c=>d&&d.parent&&c&&c.item.handle===d.parent.item.handle)===-1;){const c=this.i.get(d.parent.item.handle);d=c?this.j.get(c):void 0}d&&!d.parent&&w.add(a.item.handle)}const r=[];return w.forEach(a=>{const d=this.i.get(a);if(d){const c=this.j.get(d);c&&(!c.parent||!w.has(c.parent.item.handle))&&r.push(a)}}),r}X(p){const w={};return Promise.all(p.map(s=>this.Y(s).then(r=>{r&&(w[s]=r.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(p){const w=this.getExtensionElement(p);if(w){const s=this.j.get(w);if(s)return this.nb(w),(0,S.asPromise)(()=>this.f.getTreeItem(w)).then(r=>{if(r){const a=this.eb(w,r,s.parent);return this.lb(w,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}Z(p,w,s){const r=this.eb(p,w,s);if(w.id&&this.i.has(r.item.handle))throw new Error((0,i.localize)(10,null,w.id));return this.kb(p,r),this.mb(r,s),r}ab(p){return k.MarkdownString.isMarkdownString(p)?m.MarkdownString.from(p):p}bb(p,w){return w?{...this.F.toInternal(w,p),originalId:w.command}:void 0}cb(p){if(!p.checkboxState)return;let w,s;return typeof p.checkboxState=="number"?w=p.checkboxState:(w=p.checkboxState.state,s=p.checkboxState.tooltip),{isChecked:w===k.TreeItemCheckboxState.Checked,tooltip:s}}db(p){if(!k.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,w,s){this.db(w);const r=new O.DisposableStore,a=this.gb(p,w,s),d=this.hb(w);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:o(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(r,w.command),contextValue:w.contextValue,icon:d,iconDark:this.ib(w)||d,themeIcon:this.fb(w),collapsibleState:(0,N.isUndefinedOrNull)(w.collapsibleState)?k.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(p){return p.iconPath instanceof k.ThemeIcon?p.iconPath:void 0}gb(p,{id:w,label:s,resourceUri:r},a,d){if(w)return`${b.b}/${w}`;const c=o(s,this.H),u=a?a.item.handle:b.a;let n=c?c.label:r?(0,y.basename)(r):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const f=this.j.has(p)?this.j.get(p).item.handle:void 0,g=this.Q(a)||[];let P,M=0;do{if(P=`${u}/${M}:${n}`,d||!this.i.has(P)||f===P)break;M++}while(M<=g.length);return P}hb(p){if(p.iconPath&&!(p.iconPath instanceof k.ThemeIcon))return typeof p.iconPath=="string"||L.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof k.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return L.URI.isUri(p)?p:L.URI.file(p)}kb(p,w){this.i.set(w.item.handle,p),this.j.set(p,w)}lb(p,w,s,r){this.i.delete(w.item.handle),this.j.delete(p),w.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(p,w);const a=this.Q(r)||[],d=a.filter(c=>c.item.handle===s.item.handle)[0];d&&a.splice(a.indexOf(d),1,w)}mb(p,w){w?(w.children||(w.children=[]),w.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const w=this.j.get(p);if(w){if(w.children)for(const s of w.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}w.children=void 0}}else this.pb()}ob(p){const w=this.j.get(p);if(w){if(w.children)for(const s of w.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}this.j.delete(p),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(Ie[245],Ce([1,0,20,11,5,29,2,125,254,114,123,36,4,69,198,197,38,199,32,201,202,203,186,204,55,33,206,207,210,211,213,102,189,218,219,220,75,58,223,244,8,6,91,226,59,101,31,176,209,48,100,104,106,107,12,52,15,27,214,184,65,72,195,224,76,57,229,227,228,196,37,221,225,74,56,70,215,103,216,13,87,188,167,208,7,25,171,73,164,217]),function(ee,e,i,T,y,L,C,O,S,k,N,D,m,v,h,t,o,l,b,E,p,w,s,r,a,d,c,u,n,f,g,P,M,q,J,x,R,A,F,$,z,V,K,ie,ge,ce,re,se,le,_,me,we,Ne,We,Qe,Te,De,ke,oe,ue,Y,I,U,H,j,Z,de,Se,ae,ve,be,$e,He,tt,xe,et,it,dt,Fe,st,Q,X,pe,Me,Be,je,Je,nt,vt,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Tt(lt){const at=lt.get(ke.IExtHostInitDataService),Ut=lt.get(be.IExtHostFileSystemInfo),Ft=lt.get(Z.IExtHostConsumerFileSystem),Nt=lt.get(d.IExtHostExtensionService),ft=lt.get(re.IExtHostWorkspace),Ct=lt.get(et.IExtHostTelemetry),Bt=lt.get(b.IExtHostConfiguration),Mt=lt.get(Te.IURITransformerService),Ge=lt.get(De.IExtHostRpcService),Rt=lt.get(R.IExtHostStorage),Lt=lt.get(j.IExtensionStoragePaths),Ht=lt.get(Qe.ILoggerService),mt=lt.get(Qe.ILogService),At=lt.get(Y.IExtHostTunnelService),ye=lt.get(I.IExtHostApiDeprecationService),Pe=lt.get(ce.IExtHostWindow),fe=lt.get(tt.IExtHostSecretState),G=lt.get(xe.IExtHostEditorTabs);Ge.set(m.ExtHostContext.ExtHostFileSystemInfo,Ut),Ge.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ht),Ge.set(m.ExtHostContext.ExtHostWorkspace,ft),Ge.set(m.ExtHostContext.ExtHostConfiguration,Bt),Ge.set(m.ExtHostContext.ExtHostExtensionService,Nt),Ge.set(m.ExtHostContext.ExtHostStorage,Rt),Ge.set(m.ExtHostContext.ExtHostTunnelService,At),Ge.set(m.ExtHostContext.ExtHostWindow,Pe),Ge.set(m.ExtHostContext.ExtHostSecretState,fe),Ge.set(m.ExtHostContext.ExtHostTelemetry,Ct),Ge.set(m.ExtHostContext.ExtHostEditorTabs,G);const Ae=Ge.set(m.ExtHostContext.ExtHostDecorations,lt.get(me.IExtHostDecorations)),Le=Ge.set(m.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(a.IExtHostDocumentsAndEditors)),Xe=Ge.set(m.ExtHostContext.ExtHostCommands,lt.get(o.IExtHostCommands)),ze=Ge.set(m.ExtHostContext.ExtHostTerminalService,lt.get(A.IExtHostTerminalService)),Ze=Ge.set(m.ExtHostContext.ExtHostDebugService,lt.get(Ne.IExtHostDebugService)),It=Ge.set(m.ExtHostContext.ExtHostSearch,lt.get(We.IExtHostSearch)),bt=Ge.set(m.ExtHostContext.ExtHostTask,lt.get(we.IExtHostTask)),kt=Ge.set(m.ExtHostContext.ExtHostOutputService,lt.get(P.IExtHostOutputService)),gt=Ge.set(m.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),pt=Ge.set(m.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ge)),St=Ge.set(m.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(Ge,Le)),$t=Ge.set(m.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ge,Le,mt)),Xt=Ge.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(mt,St,Ge.getProxy(m.MainContext.MainThreadBulkEdits))),Et=Ge.set(m.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(Ge,Xe,Le,St)),si=Ge.set(m.ExtHostContext.ExtHostNotebookDocuments,new pe.ExtHostNotebookDocuments(Et)),oi=Ge.set(m.ExtHostContext.ExtHostNotebookEditors,new X.ExtHostNotebookEditors(mt,Et)),Zt=Ge.set(m.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,at,Et,Xe,mt)),pi=Ge.set(m.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,Et)),yt=Ge.set(m.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ge,Le)),ai=Ge.set(m.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(Ge.getProxy(m.MainContext.MainThreadTreeViews),Xe,mt)),Oi=Ge.set(m.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(Ge.getProxy(m.MainContext.MainThreadEditorInsets),yt,at.remote)),ei=Ge.set(m.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,mt,Ut,Le)),Vt=Ge.set(m.ExtHostContext.ExtHostLanguages,new f.ExtHostLanguages(Ge,St,Xe.converter,Mt)),ct=Ge.set(m.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Ge,Mt,St,Xe,ei,mt,ye,Ct)),vi=Ge.set(m.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ge,ct)),jt=Ge.set(m.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Ge,mt,Le)),Qt=Ge.set(m.ExtHostContext.ExtHostQuickOpen,(0,q.createExtHostQuickOpen)(Ge,ft,Xe)),ci=Ge.set(m.ExtHostContext.ExtHostSCM,new J.ExtHostSCM(Ge,Xe,mt)),bi=Ge.set(m.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,Xe,St)),ui=Ge.set(m.ExtHostContext.ExtHostProgress,new M.ExtHostProgress(Ge.getProxy(m.MainContext.MainThreadProgress))),Ei=Ge.set(m.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Ge)),Ci=Ge.set(m.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(Ge)),ti=Ge.set(m.ExtHostContext.ExtHostAuthentication,new U.ExtHostAuthentication(Ge)),wi=Ge.set(m.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(Ge,Xe)),ni=Ge.set(m.ExtHostContext.ExtHostWebviews,new ge.ExtHostWebviews(Ge,at.remote,ft,mt,ye)),ri=Ge.set(m.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ni,ft)),Fi=Ge.set(m.ExtHostContext.ExtHostCustomEditors,new Se.ExtHostCustomEditors(Ge,St,Lt,ni,ri)),Si=Ge.set(m.ExtHostContext.ExtHostWebviewViews,new de.ExtHostWebviewViews(Ge,ni)),_t=Ge.set(m.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(Ge,Xe,Le)),Ni=Ge.set(m.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),Mi=Ge.set(m.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(Ge));Ge.set(m.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,Et,Le,Xe,mt));const Li=Object.values(m.ExtHostContext);Ge.assertRegistered(Li);const Ui=new ve.ExtHostBulkEdits(Ge,Le),Bi=new t.ExtHostClipboard(Ge),yi=new g.ExtHostMessageService(Ge,mt),li=new p.ExtHostDialogs(Ge),di=new x.ExtHostStatusBar(Ge,Xe.converter);return h.ExtHostApiCommands.register(Xe),function(Ue,Kt,ki){const ht=function(){let ne=!Ue.isUnderDevelopment;function he(){ne||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(rt){if(Array.isArray(rt))rt.forEach(Oe);else if(typeof rt=="string")he();else{const Dt=rt;typeof Dt.scheme>"u"&&he(),typeof Dt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),$i={getSession(ne,he,Oe){return ti.getSession(Ue,ne,he,Oe)},async hasSession(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"authSession"),!!await ti.getSession(Ue,ne,he,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ne,he,Oe,rt){return ti.registerAuthenticationProvider(ne,he,Oe,rt)}},zi={registerCommand(ne,he,Oe){return Xe.registerCommand(!0,ne,he,Oe,void 0,Ue)},registerTextEditorCommand(ne,he,Oe){return Xe.registerCommand(!0,ne,(...rt)=>{const Dt=yt.getActiveTextEditor();if(!Dt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(Pt=>{he.apply(Oe,[Dt,Pt,...rt])}).then(Pt=>{Pt||mt.warn("Edits from command "+ne+" were not applied.")},Pt=>{mt.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,he,Oe)=>((0,je.checkProposedApiEnabled)(Ue,"diffCommand"),Xe.registerCommand(!0,ne,async(...rt)=>{const Dt=Le.activeEditor(!0);if(!Dt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await yt.getDiffInformation(Dt.id);he.apply(Oe,[Pt,...rt])},void 0,void 0,Ue)),executeCommand(ne,...he){return Xe.executeCommand(ne,...he)},getCommands(ne=!1){return Xe.getCommands(ne)}},Ti={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return Bi.value},get shell(){return ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Ue,"envShellEvent"),ze.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,je.checkProposedApiEnabled)(Ue,"telemetryLogger"),Ct.instantiateLogger(Ue,ne)},openExternal(ne,he){return Pe.openUri(ne,{allowTunneling:!!at.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===at.environment.appUriScheme)return pt.createAppUri(ne);try{return await Pe.asExternalUri(ne,{allowTunneling:!!at.remote.authority})}catch(he){if((0,Q.matchesScheme)(ne,st.Schemas.http)||(0,Q.matchesScheme)(ne,st.Schemas.https))return ne;throw he}},get remoteName(){return(0,_.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return mt.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(Ti);const Wi={createTestController(ne,he,Oe){return _t.createTestController(ne,he,Oe)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.createTestObserver()},runTests(ne){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.runTests(ne)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.results}},ii=at.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,Hi={getExtension(ne,he){(0,je.isProposedApiEnabled)(Ue,"extensionsAny")||(he=!1);const Oe=Kt.mine.getExtensionDescription(ne);if(Oe)return new d.Extension(Nt,Ue.identifier,Oe,ii,!1);if(he){const rt=Kt.all.getExtensionDescription(ne);if(rt)return new d.Extension(Nt,Ue.identifier,rt,ii,!0)}},get all(){const ne=[];for(const he of Kt.mine.getAllExtensionDescriptions())ne.push(new d.Extension(Nt,Ue.identifier,he,ii,!1));return ne},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new je.ExtensionIdentifierSet(Kt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),he=[];for(const Oe of Kt.all.getAllExtensionDescriptions()){const rt=!ne.has(Oe.identifier);he.push(new d.Extension(Nt,Ue.identifier,Oe,ii,rt))}return he},get onDidChange(){return(0,je.isProposedApiEnabled)(Ue,"extensionsAny")?y.Event.any(Kt.mine.onDidChange,Kt.all.onDidChange):Kt.mine.onDidChange}},Gt={createDiagnosticCollection(ne){return ei.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:ne=>ei.getDiagnostics(ne),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(ne,he){return Vt.changeLanguage(ne.uri,he)},match(ne,he){const Oe=St.getDocumentData(he.uri)?.notebook;return(0,N.score)(z.LanguageSelector.from(ne),he.uri,he.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ne,he,Oe){return ct.registerCodeActionProvider(Ue,ht(ne),he,Oe)},registerDocumentPasteEditProvider(ne,he,Oe){return(0,je.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,ht(ne),he,Oe)},registerCodeLensProvider(ne,he){return ct.registerCodeLensProvider(Ue,ht(ne),he)},registerDefinitionProvider(ne,he){return ct.registerDefinitionProvider(Ue,ht(ne),he)},registerDeclarationProvider(ne,he){return ct.registerDeclarationProvider(Ue,ht(ne),he)},registerImplementationProvider(ne,he){return ct.registerImplementationProvider(Ue,ht(ne),he)},registerTypeDefinitionProvider(ne,he){return ct.registerTypeDefinitionProvider(Ue,ht(ne),he)},registerHoverProvider(ne,he){return ct.registerHoverProvider(Ue,ht(ne),he,Ue.identifier)},registerEvaluatableExpressionProvider(ne,he){return ct.registerEvaluatableExpressionProvider(Ue,ht(ne),he,Ue.identifier)},registerInlineValuesProvider(ne,he){return ct.registerInlineValuesProvider(Ue,ht(ne),he,Ue.identifier)},registerDocumentHighlightProvider(ne,he){return ct.registerDocumentHighlightProvider(Ue,ht(ne),he)},registerLinkedEditingRangeProvider(ne,he){return ct.registerLinkedEditingRangeProvider(Ue,ht(ne),he)},registerReferenceProvider(ne,he){return ct.registerReferenceProvider(Ue,ht(ne),he)},registerRenameProvider(ne,he){return ct.registerRenameProvider(Ue,ht(ne),he)},registerDocumentSymbolProvider(ne,he,Oe){return ct.registerDocumentSymbolProvider(Ue,ht(ne),he,Oe)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,he){return ct.registerDocumentFormattingEditProvider(Ue,ht(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return ct.registerDocumentRangeFormattingEditProvider(Ue,ht(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Oe,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,ht(ne),he,[Oe].concat(rt))},registerDocumentSemanticTokensProvider(ne,he,Oe){return ct.registerDocumentSemanticTokensProvider(Ue,ht(ne),he,Oe)},registerDocumentRangeSemanticTokensProvider(ne,he,Oe){return ct.registerDocumentRangeSemanticTokensProvider(Ue,ht(ne),he,Oe)},registerSignatureHelpProvider(ne,he,Oe,...rt){return typeof Oe=="object"?ct.registerSignatureHelpProvider(Ue,ht(ne),he,Oe):ct.registerSignatureHelpProvider(Ue,ht(ne),he,typeof Oe>"u"?[]:[Oe,...rt])},registerCompletionItemProvider(ne,he,...Oe){return ct.registerCompletionItemProvider(Ue,ht(ne),he,Oe)},registerInlineCompletionItemProvider(ne,he){return he.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,ht(ne),he)},registerDocumentLinkProvider(ne,he){return ct.registerDocumentLinkProvider(Ue,ht(ne),he)},registerColorProvider(ne,he){return ct.registerColorProvider(Ue,ht(ne),he)},registerFoldingRangeProvider(ne,he){return ct.registerFoldingRangeProvider(Ue,ht(ne),he)},registerSelectionRangeProvider(ne,he){return ct.registerSelectionRangeProvider(Ue,ne,he)},registerCallHierarchyProvider(ne,he){return ct.registerCallHierarchyProvider(Ue,ne,he)},registerTypeHierarchyProvider(ne,he){return ct.registerTypeHierarchyProvider(Ue,ne,he)},setLanguageConfiguration:(ne,he)=>ct.setLanguageConfiguration(Ue,ne,he),getTokenInformationAtPosition(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"tokenInformation"),Vt.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return ct.registerInlayHintsProvider(Ue,ne,he)},createLanguageStatusItem(ne,he){return Vt.createLanguageStatusItem(Ue,ne,he)},registerDocumentDropEditProvider(ne,he){return ct.registerDocumentOnDropEditProvider(Ue,ne,he)}},hi={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ze.activeTerminal},get terminals(){return ze.terminals},async showTextDocument(ne,he,Oe){const rt=await(C.URI.isUri(ne)?Promise.resolve(Pi.openTextDocument(ne)):Promise.resolve(ne));return yt.showTextDocument(rt,he,Oe)},createTextEditorDecorationType(ne){return yt.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,he,Oe){return yt.onDidChangeActiveTextEditor(ne,he,Oe)},onDidChangeVisibleTextEditors(ne,he,Oe){return yt.onDidChangeVisibleTextEditors(ne,he,Oe)},onDidChangeTextEditorSelection(ne,he,Oe){return yt.onDidChangeTextEditorSelection(ne,he,Oe)},onDidChangeTextEditorOptions(ne,he,Oe){return yt.onDidChangeTextEditorOptions(ne,he,Oe)},onDidChangeTextEditorVisibleRanges(ne,he,Oe){return yt.onDidChangeTextEditorVisibleRanges(ne,he,Oe)},onDidChangeTextEditorViewColumn(ne,he,Oe){return yt.onDidChangeTextEditorViewColumn(ne,he,Oe)},onDidCloseTerminal(ne,he,Oe){return ze.onDidCloseTerminal(ne,he,Oe)},onDidOpenTerminal(ne,he,Oe){return ze.onDidOpenTerminal(ne,he,Oe)},onDidChangeActiveTerminal(ne,he,Oe){return ze.onDidChangeActiveTerminal(ne,he,Oe)},onDidChangeTerminalDimensions(ne,he,Oe){return(0,je.checkProposedApiEnabled)(Ue,"terminalDimensions"),ze.onDidChangeTerminalDimensions(ne,he,Oe)},onDidChangeTerminalState(ne,he,Oe){return ze.onDidChangeTerminalState(ne,he,Oe)},onDidWriteTerminalData(ne,he,Oe){return(0,je.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),ze.onDidWriteTerminalData(ne,he,Oe)},get state(){return Pe.state},onDidChangeWindowState(ne,he,Oe){return Pe.onDidChangeWindowState(ne,he,Oe)},showInformationMessage(ne,...he){return yi.showMessage(Ue,L.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return yi.showMessage(Ue,L.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return yi.showMessage(Ue,L.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Oe){return Qt.showQuickPick(ne,he,Oe)},showWorkspaceFolderPick(ne){return Qt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Qt.showInput(ne,he)},showOpenDialog(ne){return li.showOpenDialog(ne)},showSaveDialog(ne){return li.showSaveDialog(ne)},createStatusBarItem(ne,he,Oe){let rt,Dt,Pt;return typeof ne=="string"?(rt=ne,Dt=he,Pt=Oe):(Dt=ne,Pt=he),di.createStatusBarEntry(Ue,rt,Dt,Pt)},setStatusBarMessage(ne,he){return di.setStatusBarMessage(ne,he)},withScmProgress(ne){return ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ui.withProgress(Ue,{location:V.ProgressLocation.SourceControl},(he,Oe)=>ne({report(rt){}}))},withProgress(ne,he){return ui.withProgress(Ue,ne,he)},createOutputChannel(ne,he){return kt.createOutputChannel(ne,he,Ue)},createWebviewPanel(ne,he,Oe,rt){return ri.createWebviewPanel(Ue,ne,he,Oe,rt)},createWebviewTextEditorInset(ne,he,Oe,rt){return(0,je.checkProposedApiEnabled)(Ue,"editorInsets"),Oi.createWebviewEditorInset(ne,he,Oe,rt,Ue)},createTerminal(ne,he,Oe){return typeof ne=="object"?"pty"in ne?ze.createExtensionTerminal(ne):ze.createTerminalFromOptions(ne):ze.createTerminal(ne,he,Oe)},registerTerminalLinkProvider(ne){return ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return ze.registerProfileProvider(Ue,ne,he)},registerTerminalQuickFixProvider(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),ze.registerTerminalQuickFixProvider(ne,Ue.identifier.value,he)},registerTreeDataProvider(ne,he){return ai.registerTreeDataProvider(ne,he,Ue)},createTreeView(ne,he){return ai.createTreeView(ne,he,Ue)},registerWebviewPanelSerializer:(ne,he)=>ri.registerWebviewPanelSerializer(Ue,ne,he),registerCustomEditorProvider:(ne,he,Oe={})=>Fi.registerCustomEditorProvider(Ue,ne,he,Oe),registerFileDecorationProvider(ne){return Ae.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return pt.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return Ci.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Oe){return Ci.onDidChangeActiveColorTheme(ne,he,Oe)},registerWebviewViewProvider(ne,he,Oe){return Si.registerWebviewViewProvider(Ue,ne,he,Oe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Oe){return Et.onDidChangeActiveNotebookEditor(ne,he,Oe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Oe){return oi.onDidChangeNotebookEditorSelection(ne,he,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,he,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(ne,he,Oe)},showNotebookDocument(ne,he){return Et.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Oe){return(0,je.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ni.registerExternalUriOpener(Ue.identifier,ne,he,Oe)},registerProfileContentHandler(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Mi.registrProfileContentHandler(Ue,ne,he)},get tabGroups(){return G.tabGroups}},Pi={get rootPath(){return ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw T.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw T.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw T.readonly()},updateWorkspaceFolders:(ne,he,...Oe)=>ft.updateWorkspaceFolders(Ue,ne,he||0,...Oe),onDidChangeWorkspaceFolders:function(ne,he,Oe){return ft.onDidChangeWorkspace(ne,he,Oe)},asRelativePath:(ne,he)=>ft.getRelativePath(ne,he),findFiles:(ne,he,Oe,rt)=>ft.findFiles(ne,he,Oe,Ue.identifier,rt),findTextInFiles:(ne,he,Oe,rt)=>{(0,je.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Pt;return typeof he=="object"?(Dt=he,Pt=Oe):(Dt={},Pt=he,rt=Oe),ft.findTextInFiles(ne,Dt||{},Pt,Ue.identifier,rt)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,he){return Ui.applyWorkspaceEdit(ne,Ue,he)},createFileSystemWatcher:(ne,he,Oe,rt)=>jt.createFileSystemWatcher(ft,Ue,ne,he,Oe,rt),get textDocuments(){return St.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw T.readonly()},openTextDocument(ne){let he;const Oe=ne;if(typeof ne=="string")he=Promise.resolve(C.URI.file(ne));else if(C.URI.isUri(ne))he=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")he=St.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(rt=>St.ensureDocumentData(rt).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,he,Oe)=>St.onDidAddDocument(ne,he,Oe),onDidCloseTextDocument:(ne,he,Oe)=>St.onDidRemoveDocument(ne,he,Oe),onDidChangeTextDocument:(ne,he,Oe)=>St.onDidChangeDocument(ne,he,Oe),onDidSaveTextDocument:(ne,he,Oe)=>St.onDidSaveDocument(ne,he,Oe),onWillSaveTextDocument:(ne,he,Oe)=>Xt.getOnWillSaveTextDocumentEvent(Ue)(ne,he,Oe),get notebookDocuments(){return Et.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Oe;if(C.URI.isUri(ne))Oe=ne,await Et.openNotebookDocument(ne);else if(typeof ne=="string")Oe=C.URI.revive(await Et.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,he,Oe){return si.onDidSaveNotebookDocument(ne,he,Oe)},onDidChangeNotebookDocument(ne,he,Oe){return si.onDidChangeNotebookDocument(ne,he,Oe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Oe,rt){return Et.registerNotebookSerializer(Ue,ne,he,Oe,(0,je.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,he,Oe)=>ki.onDidChangeConfiguration(ne,he,Oe),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,ki.getConfiguration(ne,he,Ue)},registerTextDocumentContentProvider(ne,he){return $t.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Ue,ne,he)),registerFileSystemProvider(ne,he,Oe){return(0,Be.combinedDisposable)(vi.registerFileSystemProvider(Ue,ne,he,Oe),Ft.addFileSystemProvider(ne,he))},get fs(){return Ft.value},registerFileSearchProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"fileSearchProvider"),It.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"textSearchProvider"),It.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Nt.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Ei.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Oe)=>jt.onDidCreateFile(ne,he,Oe),onDidDeleteFiles:(ne,he,Oe)=>jt.onDidDeleteFile(ne,he,Oe),onDidRenameFiles:(ne,he,Oe)=>jt.onDidRenameFile(ne,he,Oe),onWillCreateFiles:(ne,he,Oe)=>jt.getOnWillCreateFileEvent(Ue)(ne,he,Oe),onWillDeleteFiles:(ne,he,Oe)=>jt.getOnWillDeleteFileEvent(Ue)(ne,he,Oe),onWillRenameFiles:(ne,he,Oe)=>jt.getOnWillRenameFileEvent(Ue)(ne,he,Oe),openTunnel:ne=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),At.openTunnel(Ue,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,je.checkProposedApiEnabled)(Ue,"tunnels"),At.getTunnels()},onDidChangeTunnels:(ne,he,Oe)=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),At.onDidChangeTunnels(ne,he,Oe)),registerPortAttributesProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"portsAttributes"),At.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"timeline"),wi.registerTimelineProvider(ne,he,Ue.identifier,Xe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,je.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Oe)=>ft.onDidGrantWorkspaceTrust(ne,he,Oe),registerEditSessionIdentityProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,he))},zt={get inputBox(){return ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Ue)},createSourceControl(ne,he,Oe){return ci.createSourceControl(Ue,ne,he,Oe)}},fi={createCommentController(ne,he){return bi.createCommentController(Ue,ne,he)}},Vi={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,he,Oe){return Ze.onDidStartDebugSession(ne,he,Oe)},onDidTerminateDebugSession(ne,he,Oe){return Ze.onDidTerminateDebugSession(ne,he,Oe)},onDidChangeActiveDebugSession(ne,he,Oe){return Ze.onDidChangeActiveDebugSession(ne,he,Oe)},onDidReceiveDebugSessionCustomEvent(ne,he,Oe){return Ze.onDidReceiveDebugSessionCustomEvent(ne,he,Oe)},onDidChangeBreakpoints(ne,he,Oe){return Ze.onDidChangeBreakpoints(ne,he,Oe)},registerDebugConfigurationProvider(ne,he,Oe){return Ze.registerDebugConfigurationProvider(ne,he,Oe||Je.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return Ze.registerDebugAdapterDescriptorFactory(Ue,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return Ze.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Ze.startDebugging(ne,he,{parentSession:Oe}):Ze.startDebugging(ne,he,Oe||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return Ze.asDebugSourceUri(ne,he)}},ji={registerTaskProvider:(ne,he)=>bt.registerTaskProvider(Ue,ne,he),fetchTasks:ne=>bt.fetchTasks(ne),executeTask:ne=>bt.executeTask(Ue,ne),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(ne,he,Oe)=>bt.onDidStartTask(ne,he,Oe),onDidEndTask:(ne,he,Oe)=>bt.onDidEndTask(ne,he,Oe),onDidStartTaskProcess:(ne,he,Oe)=>bt.onDidStartTaskProcess(ne,he,Oe),onDidEndTaskProcess:(ne,he,Oe)=>bt.onDidEndTaskProcess(ne,he,Oe)},qi={createNotebookController(ne,he,Oe,rt,Dt){return Zt.createNotebookController(Ue,ne,he,Oe,rt,(0,je.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ne,he),createRendererMessaging(ne){return pi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,ne,he)},onDidChangeNotebookCellExecutionState(ne,he,Oe){return(0,je.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ne,he,Oe)}},Ki={t(...ne){if(typeof ne[0]=="string"){const he=ne.shift(),Oe=!ne||typeof ne[0]!="object"?ne:ne[0];return gt.getMessage(Ue.identifier.value,{message:he,args:Oe})}return gt.getMessage(Ue.identifier.value,ne[0])},get bundle(){return gt.getBundle(Ue.identifier.value)},get uri(){return gt.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:$i,commands:zi,comments:fi,debug:Vi,env:Ti,extensions:Hi,l10n:Ki,languages:Gt,notebooks:qi,scm:zt,tasks:ji,tests:Wi,window:hi,workspace:Pi,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Je.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:k.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:O.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:v.UIKind,Uri:C.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TrustedTelemetryValue:K.TrustedTelemetryValue,LogLevel:Qe.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Tt}),define(Ie[246],Ce([1,0,245,33,2,239,6,14,230]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends L.RequireInterceptor{j(){}getModule(v,h){for(const t of this.b){const o=t(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(S.ExtHostConsoleForwarder);const v=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,v,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(v){return v.browser}async pb(v,h,t){h=h.with({path:D(h.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const l=y.URI.revive(await this.v.$asBrowserUri(h)),b=await fetch(l.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),b.status!==200)throw new Error(b.statusText);const E=await b.text(),p=`${h.toString(!0)}#vscode-extension`,w=`${E}
//# sourceURL=${p}`;let s;try{s=new Function("module","exports","require",w)}catch(c){throw console.error(o?`Loading code for extension ${o} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${h.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}v&&await this.s.initializeLocalizedMessages(v);const r={},a={exports:r},d=c=>{const u=this.r.getModule(c,h);if(u===void 0)throw new Error(`Cannot load module '${c}'`);return u};try{return t.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),s(a,r,d),a.exports!==r?a.exports:r}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),t.codeLoadingStop()}}async $setRemoteEnvironment(v){}async tb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+v;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,O.timeout)(10)}}e.ExtHostExtensionService=N;function D(m,v){return m.endsWith(v)?m:m+v}}),define(Ie[247],Ce([1,0,62,33,76,246]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(T.IExtHostExtensionService,L.ExtHostExtensionService,0),(0,i.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths,0)}),define(Ie[255],Ce([1,0,24,5,69,240,232,19,77,13,2,242,247]),function(ee,e,i,T,y,L,C,O,S,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(s){return/^(file|vscode-remote):/i.test(s)}const h=fetch.bind(self);function t(s){self.fetch=async function(r,a){return r instanceof Request||v(String(r))&&(r=(await s(N.URI.parse(String(r)))).toString(!0)),h(r,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,a,d,c,u){(async()=>(v(a.toString())&&(a=(await s(N.URI.parse(a.toString()))).toString(!0)),super.open(r,a,d??!0,c,u)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(r,a){if(/^file:/i.test(r.toString()))r=k.FileAccess.uriToBrowserUri(N.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(g){function P(J){return typeof J=="string"||J instanceof URL?String(J).replace(/^file:\/\//i,"vscode-file://vscode-app"):J}const M=fetch.bind(self);self.fetch=function(J,x){return J instanceof Request?M(J,x):M(P(J),x)},self.XMLHttpRequest=class extends XMLHttpRequest{open(J,x,R,A,F){return super.open(J,P(x),R??!0,A,F)}};const q=importScripts.bind(self);self.importScripts=(...J)=>{q(...J.map(P))},q(g)}.toString()}('${r}'))`;a=a||{},a.name=a.name||O.basename(r.toString());const u=new Blob([c],{type:"application/javascript"}),n=URL.createObjectURL(u);return new s(n,a)}}else self.Worker=class extends C.NestedWorker{constructor(s,r){super(m,s,{name:O.basename(s.toString()),...r})}};const o=new class{constructor(){this.pid=void 0}exit(s){D()}async exists(s){return!0}async realpath(s){return s}};class l{constructor(){const r=new MessageChannel,a=new T.Emitter;let d=!1;m(r.port2,[r.port2]),r.port1.onmessage=c=>{const{data:u}=c;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const n=i.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,y.isMessageOfType)(n,2)){d=!0,E("received terminate message from renderer");return}a.fire(n)},this.protocol={onMessage:a.event,send:c=>{if(!d){const u=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);r.port1.postMessage(u,[u])}}}}}function b(s){return new Promise(r=>{const a=s.onMessage(d=>{a.dispose();const c=JSON.parse(d.toString());s.send((0,y.createMessageOfType)(0)),r({protocol:s,initData:c})});s.send((0,y.createMessageOfType)(1))})}let E=s=>D();function p(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function w(){S.mark("code/extHost/willConnectToRenderer");const s=new l;return{onmessage(r){!p(r)||b(s.protocol).then(a=>{S.mark("code/extHost/didWaitForInitData");const d=new L.ExtensionHostMain(a.protocol,a.initData,o,null,r.data);t(c=>d.asBrowserUri(c)),E=c=>d.terminate(c)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b92894493e6f971a3c71912d823e699d3a05d643/core/vs/workbench/api/worker/extensionHostWorker.js.map
